/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/arrays","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/advancedLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ie=function(z){for(var t=[],F=0,_=z.length;F<_;F++)t[F]=ne[z[F]];return t};const je=this,Ve=typeof global=="object"?global:{};var we;(function(z){z.global=je;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof z.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}z.Environment=t})(we||(we={}));var we;(function(z){class t{constructor(o,L,u){this.type=o,this.detail=L,this.timestamp=u}}z.LoaderEvent=t;class F{constructor(o){this._events=[new t(1,"",o)]}record(o,L){this._events.push(new t(o,L,z.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}z.LoaderEventRecorder=F;class _{record(o,L){}getEvents(){return[]}}_.INSTANCE=new _,z.NullLoaderEventRecorder=_})(we||(we={}));var we;(function(z){class t{static fileUriToFilePath(_,i){if(i=decodeURI(i).replace(/%23/g,"#"),_){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(_,i){return _.length>=i.length&&_.substr(0,i.length)===i}static endsWith(_,i){return _.length>=i.length&&_.substr(_.length-i.length)===i}static containsQueryString(_){return/^[^\#]*\?/gi.test(_)}static isAbsolutePath(_){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(_)}static forEachProperty(_,i){if(_){let o;for(o in _)_.hasOwnProperty(o)&&i(o,_[o])}}static isEmpty(_){let i=!0;return t.forEachProperty(_,()=>{i=!1}),i}static recursiveClone(_){if(!_||typeof _!="object"||_ instanceof RegExp||!Array.isArray(_)&&Object.getPrototypeOf(_)!==Object.prototype)return _;let i=Array.isArray(_)?[]:{};return t.forEachProperty(_,(o,L)=>{L&&typeof L=="object"?i[o]=t.recursiveClone(L):i[o]=L}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(_){return t.startsWith(_,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=z.global.performance&&typeof z.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?z.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,z.Utilities=t})(we||(we={}));var we;(function(z){function t(i){if(i instanceof Error)return i;const o=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(o.stack=i.stack),o}z.ensureError=t;class F{static validateConfigurationOptions(o){function L(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory function of "'+u.moduleId+'" has thrown an exception'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=L),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(z.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const u=t(new Error("INVALID cached data configuration, 'path' MUST be set"));u.phase="configuration",o.onError(u),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,L=null){let u=z.Utilities.recursiveClone(L||{});return z.Utilities.forEachProperty(o,(s,l)=>{s==="ignoreDuplicateModules"&&typeof u.ignoreDuplicateModules<"u"?u.ignoreDuplicateModules=u.ignoreDuplicateModules.concat(l):s==="paths"&&typeof u.paths<"u"?z.Utilities.forEachProperty(l,(g,E)=>u.paths[g]=E):s==="config"&&typeof u.config<"u"?z.Utilities.forEachProperty(l,(g,E)=>u.config[g]=E):u[s]=z.Utilities.recursiveClone(l)}),F.validateConfigurationOptions(u)}}z.ConfigurationOptionsUtil=F;class _{constructor(o,L){if(this._env=o,this.options=F.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let u=this.options.nodeRequire.main.filename,s=Math.max(u.lastIndexOf("/"),u.lastIndexOf("\\"));this.options.baseUrl=u.substring(0,s+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],z.Utilities.forEachProperty(this.options.paths,(o,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:o,to:L}):this.sortedPathsRules.push({from:o,to:[L]})}),this.sortedPathsRules.sort((o,L)=>L.from.length-o.from.length)}cloneAndMerge(o){return new _(this._env,F.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let L;for(let u=0,s=this.sortedPathsRules.length;u<s;u++)if(L=this.sortedPathsRules[u],z.Utilities.startsWith(o,L.from)){let l=[];for(let g=0,E=L.to.length;g<E;g++)l.push(L.to[g]+o.substr(L.from.length));return l}return[o]}_addUrlArgsToUrl(o){return z.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let L=0,u=o.length;L<u;L++)o[L]=this._addUrlArgsToUrl(o[L]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let L=o,u;if(!z.Utilities.endsWith(L,".js")&&!z.Utilities.isAbsolutePath(L)){u=this._applyPaths(L);for(let s=0,l=u.length;s<l;s++)this.isBuild()&&u[s]==="empty:"||(z.Utilities.isAbsolutePath(u[s])||(u[s]=this.options.baseUrl+u[s]),!z.Utilities.endsWith(u[s],".js")&&!z.Utilities.containsQueryString(u[s])&&(u[s]=u[s]+".js"))}else!z.Utilities.endsWith(L,".js")&&!z.Utilities.containsQueryString(L)&&(L=L+".js"),u=[L];return this._addUrlArgsIfNecessaryToUrls(u)}requireToUrl(o){let L=o;return z.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],z.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||z.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}z.Configuration=_})(we||(we={}));var we;(function(z){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,g,E,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new F:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new F;let f={callback:E,errorback:d};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(f);return}this._callbackMap[g]=[f],this._scriptLoader.load(l,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(l){let g=this._callbackMap[l];delete this._callbackMap[l];for(let E=0;E<g.length;E++)g[E].callback()}triggerErrorback(l,g){let E=this._callbackMap[l];delete this._callbackMap[l];for(let d=0;d<E.length;d++)E[d].errorback(g)}}class F{attachListeners(l,g,E){let d=()=>{l.removeEventListener("load",f),l.removeEventListener("error",e)},f=N=>{d(),g()},e=N=>{d(),E(N)};l.addEventListener("load",f),l.addEventListener("error",e)}load(l,g,E,d){if(/^node\|/.test(g)){let f=l.getConfig().getOptionsLiteral(),e=L(l.getRecorder(),f.nodeRequire||z.global.nodeRequire),N=g.split("|"),p=null;try{p=e(N[1])}catch(R){d(R);return}l.enqueueDefineAnonymousModule([],()=>p),E()}else{let f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript"),this.attachListeners(f,E,d);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),f.setAttribute("src",g);const{cspNonce:N}=l.getConfig().getOptionsLiteral();N&&f.setAttribute("nonce",N),document.getElementsByTagName("head")[0].appendChild(f)}}}function _(s){const{trustedTypesPolicy:l}=s.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=_(l)),this._cachedCanUseEval}load(l,g,E,d){if(/^node\|/.test(g)){const f=l.getConfig().getOptionsLiteral(),e=L(l.getRecorder(),f.nodeRequire||z.global.nodeRequire),N=g.split("|");let p=null;try{p=e(N[1])}catch(R){d(R);return}l.enqueueDefineAnonymousModule([],function(){return p}),E()}else{const{trustedTypesPolicy:f}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(g).then(N=>{if(N.status!==200)throw new Error(N.statusText);return N.text()}).then(N=>{N=`${N}
//# sourceURL=${g}`,(f?self.eval(f.createScript("",N)):new Function(N)).call(self),E()}).then(void 0,d);return}try{f&&(g=f.createScriptURL(g)),importScripts(g),E()}catch(N){d(N)}}}}class o{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,g){const{nodeCachedData:E}=g.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,f=l("module");function e(N){const p=N.constructor;let R=function(M){try{return N.require(M)}finally{}};return R.resolve=function(M,h){return p._resolveFilename(M,N,!1,h)},R.resolve.paths=function(M){return p._resolveLookupPaths(M,N)},R.main=process.mainModule,R.extensions=p._extensions,R.cache=p._cache,R}f.prototype._compile=function(N,p){const R=f.wrap(N.replace(/^#!.*/,"")),b=g.getRecorder(),M=d._getCachedDataPath(E,p),h={filename:p};let c;try{const v=d._fs.readFileSync(M);c=v.slice(0,16),h.cachedData=v.slice(16),b.record(60,M)}catch{b.record(61,M)}const r=new d._vm.Script(R,h),a=r.runInThisContext(h),A=d._path.dirname(p),m=e(this),$=[this.exports,m,this,p,A,process,Ve,Buffer],w=a.apply(this.exports,$);return d._handleCachedData(r,R,M,!h.cachedData,g),d._verifyCachedData(r,R,M,c,g),w}}load(l,g,E,d){const f=l.getConfig().getOptionsLiteral(),e=L(l.getRecorder(),f.nodeRequire||z.global.nodeRequire),N=f.nodeInstrumenter||function(R){return R};this._init(e),this._initNodeRequire(e,l);let p=l.getRecorder();if(/^node\|/.test(g)){let R=g.split("|"),b=null;try{b=e(R[1])}catch(M){d(M);return}l.enqueueDefineAnonymousModule([],()=>b),E()}else{g=z.Utilities.fileUriToFilePath(this._env.isWindows,g);const R=this._path.normalize(g),b=this._getElectronRendererScriptPathOrUri(R),M=!!f.nodeCachedData,h=M?this._getCachedDataPath(f.nodeCachedData,g):void 0;this._readSourceAndCachedData(R,h,p,(c,r,a,A)=>{if(c){d(c);return}let m;r.charCodeAt(0)===o._BOM?m=o._PREFIX+r.substring(1)+o._SUFFIX:m=o._PREFIX+r+o._SUFFIX,m=N(m,R);const $={filename:b,cachedData:a},w=this._createAndEvalScript(l,m,$,E,d);this._handleCachedData(w,m,h,M&&!a,l),this._verifyCachedData(w,m,h,A,l)})}}_createAndEvalScript(l,g,E,d,f){const e=l.getRecorder();e.record(31,E.filename);const N=new this._vm.Script(g,E),p=N.runInThisContext(E),R=l.getGlobalAMDDefineFunc();let b=!1;const M=function(){return b=!0,R.apply(null,arguments)};return M.amd=R.amd,p.call(z.global,l.getGlobalAMDRequireFunc(),M,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),b?d():f(new Error(`Didn't receive define call in ${E.filename}!`)),N}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let g=l.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,g){const E=this._crypto.createHash("md5").update(g,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(g).replace(/\.js$/,"");return this._path.join(l.path,`${d}-${E}.code`)}_handleCachedData(l,g,E,d,f){l.cachedDataRejected?this._fs.unlink(E,e=>{f.getRecorder().record(62,E),this._createAndWriteCachedData(l,g,E,f),e&&f.getConfig().onError(e)}):d&&this._createAndWriteCachedData(l,g,E,f)}_createAndWriteCachedData(l,g,E,d){let f=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,N=0,p;const R=()=>{setTimeout(()=>{p||(p=this._crypto.createHash("md5").update(g,"utf8").digest());const b=l.createCachedData();if(!(b.length===0||b.length===e||N>=5)){if(b.length<e){R();return}e=b.length,this._fs.writeFile(E,Buffer.concat([p,b]),M=>{M&&d.getConfig().onError(M),d.getRecorder().record(63,E),R()})}},f*Math.pow(4,N++))};R()}_readSourceAndCachedData(l,g,E,d){if(!g)this._fs.readFile(l,{encoding:"utf8"},d);else{let f,e,N,p=2;const R=b=>{b?d(b):--p===0&&d(void 0,f,e,N)};this._fs.readFile(l,{encoding:"utf8"},(b,M)=>{f=M,R(b)}),this._fs.readFile(g,(b,M)=>{!b&&M&&M.length>0?(N=M.slice(0,16),e=M.slice(16),E.record(60,g)):E.record(61,g),R()})}}_verifyCachedData(l,g,E,d,f){d&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();d.equals(e)||(f.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,N=>{N&&f.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function L(s,l){if(l.__$__isRecorded)return l;const g=function(d){s.record(33,d);try{return l(d)}finally{s.record(34,d)}};return g.__$__isRecorded=!0,g}z.ensureRecordedNodeRequire=L;function u(s){return new t(s)}z.createScriptLoader=u})(we||(we={}));var we;(function(z){class t{constructor(s){let l=s.lastIndexOf("/");l!==-1?this.fromModulePath=s.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(s){let l=s,g;for(g=/\/\.\//;g.test(l);)l=l.replace(g,"/");for(l=l.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(l);)l=l.replace(g,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(s){let l=s;return z.Utilities.isAbsolutePath(l)||(z.Utilities.startsWith(l,"./")||z.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),z.ModuleIdResolver=t;class F{constructor(s,l,g,E,d,f){this.id=s,this.strId=l,this.dependencies=g,this._callback=E,this._errorback=d,this.moduleIdResolver=f,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(s,l){try{return{returnedValue:s.apply(z.global,l),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(s,l,g,E){return s.shouldInvokeFactory(l)?s.shouldCatchError()?this._safeInvokeFunction(g,E):{returnedValue:g.apply(z.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(s,l,g,E){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){s.record(21,this.strId);let f=F._invokeFactory(l,this.strId,this._callback,g);d=f.producedError,s.record(22,this.strId),!d&&typeof f.returnedValue<"u"&&(!this.exportsPassedIn||z.Utilities.isEmpty(this.exports))&&(this.exports=f.returnedValue)}else this.exports=this._callback;if(d){let f=z.ensureError(d);f.phase="factory",f.moduleId=this.strId,f.neededBy=E(this.id),this.error=f,l.onError(f)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(s){return this._isComplete=!0,this.error=s,this._errorback?(this._errorback(s),!0):!1}isComplete(){return this._isComplete}}z.Module=F;class _{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(s){let l=this._strModuleIdToIntModuleId.get(s);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(s,l),this._intModuleIdToStrModuleId[l]=s),l}getStrModuleId(s){return this._intModuleIdToStrModuleId[s]}}class i{constructor(s){this.id=s}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),z.RegularDependency=i;class o{constructor(s,l,g){this.id=s,this.pluginId=l,this.pluginParam=g}}z.PluginDependency=o;class L{constructor(s,l,g,E,d=0){this._env=s,this._scriptLoader=l,this._loaderAvailableTimestamp=d,this._defineFunc=g,this._requireFunc=E,this._moduleIdProvider=new _,this._config=new z.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(s,l){let g=f=>f.replace(/\\/g,"/"),E=g(s),d=l.split(/\n/);for(let f=0;f<d.length;f++){let e=d[f].match(/(.*):(\d+):(\d+)\)?$/);if(e){let N=e[1],p=e[2],R=e[3],b=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(b),N=g(N),N===E){let M={line:parseInt(p,10),col:parseInt(R,10)};return M.line===1&&(M.col-=53),M}}}throw new Error("Could not correlate define call site for needle "+s)}getBuildInfo(){if(!this._config.isBuild())return null;let s=[],l=0;for(let g=0,E=this._modules2.length;g<E;g++){let d=this._modules2[g];if(!d)continue;let f=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,N=this._buildInfoDependencies[d.id];s[l++]={id:d.strId,path:f,defineLocation:f&&e?L._findRelevantLocationInStack(f,e):null,dependencies:N,shim:null,exports:d.exports}}return s}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new z.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=z.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(s,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:s,callback:l}}defineModule(s,l,g,E,d,f=new t(s)){let e=this._moduleIdProvider.getModuleId(s);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(s)||console.warn("Duplicate definition of module '"+s+"'");return}let N=new F(e,s,this._normalizeDependencies(l,f),g,E,f);this._modules2[e]=N,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(N.dependencies||[]).map(p=>this._moduleIdProvider.getStrModuleId(p.id))),this._resolve(N)}_normalizeDependency(s,l){if(s==="exports")return i.EXPORTS;if(s==="module")return i.MODULE;if(s==="require")return i.REQUIRE;let g=s.indexOf("!");if(g>=0){let E=l.resolveModule(s.substr(0,g)),d=l.resolveModule(s.substr(g+1)),f=this._moduleIdProvider.getModuleId(E+"!"+d),e=this._moduleIdProvider.getModuleId(E);return new o(f,e,d)}return new i(this._moduleIdProvider.getModuleId(l.resolveModule(s)))}_normalizeDependencies(s,l){let g=[],E=0;for(let d=0,f=s.length;d<f;d++)g[E++]=this._normalizeDependency(s[d],l);return g}_relativeRequire(s,l,g,E){if(typeof l=="string")return this.synchronousRequire(l,s);this.defineModule(z.Utilities.generateAnonymousModule(),l,g,E,null,s)}synchronousRequire(s,l=new t(s)){let g=this._normalizeDependency(s,l),E=this._modules2[g.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(s,l){let g=this._config.shouldRecordStats();l?this._config=new z.Configuration(this._env,s):this._config=this._config.cloneAndMerge(s),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(s){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(s),l.dependencies,l.callback,null,l.stack)}}_createLoadError(s,l){let g=this._moduleIdProvider.getStrModuleId(s),E=(this._inverseDependencies2[s]||[]).map(f=>this._moduleIdProvider.getStrModuleId(f));const d=z.ensureError(l);return d.phase="loading",d.moduleId=g,d.neededBy=E,d}_onLoadError(s,l){const g=this._createLoadError(s,l);this._modules2[s]||(this._modules2[s]=new F(s,this._moduleIdProvider.getStrModuleId(s),[],()=>{},null,null));let E=[];for(let e=0,N=this._moduleIdProvider.getMaxModuleId();e<N;e++)E[e]=!1;let d=!1,f=[];for(f.push(s),E[s]=!0;f.length>0;){let e=f.shift(),N=this._modules2[e];N&&(d=N.onDependencyError(g)||d);let p=this._inverseDependencies2[e];if(p)for(let R=0,b=p.length;R<b;R++){let M=p[R];E[M]||(f.push(M),E[M]=!0)}}d||this._config.onError(g)}_hasDependencyPath(s,l){let g=this._modules2[s];if(!g)return!1;let E=[];for(let f=0,e=this._moduleIdProvider.getMaxModuleId();f<e;f++)E[f]=!1;let d=[];for(d.push(g),E[s]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let N=0,p=e.length;N<p;N++){let R=e[N];if(R.id===l)return!0;let b=this._modules2[R.id];b&&!E[R.id]&&(E[R.id]=!0,d.push(b))}}return!1}_findCyclePath(s,l,g){if(s===l||g===50)return[s];let E=this._modules2[s];if(!E)return null;let d=E.dependencies;if(d)for(let f=0,e=d.length;f<e;f++){let N=this._findCyclePath(d[f].id,l,g+1);if(N!==null)return N.push(s),N}return null}_createRequire(s){let l=(g,E,d)=>this._relativeRequire(s,g,E,d);return l.toUrl=g=>this._config.requireToUrl(s.resolveModule(g)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(g,E=!1)=>{this.configure(g,E)},l.__$__nodeRequire=z.global.nodeRequire,l}_loadModule(s){if(this._modules2[s]||this._knownModules2[s])return;this._knownModules2[s]=!0;let l=this._moduleIdProvider.getStrModuleId(s),g=this._config.moduleIdToPaths(l),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||E.test(l))&&g.push("node|"+l);let d=-1,f=e=>{if(d++,d>=g.length)this._onLoadError(s,e);else{let N=g[d],p=this.getRecorder();if(this._config.isBuild()&&N==="empty:"){this._buildInfoPath[s]=N,this.defineModule(this._moduleIdProvider.getStrModuleId(s),[],null,null,null),this._onLoad(s);return}p.record(10,N),this._scriptLoader.load(this,N,()=>{this._config.isBuild()&&(this._buildInfoPath[s]=N),p.record(11,N),this._onLoad(s)},R=>{p.record(12,N),f(R)})}};f(null)}_loadPluginDependency(s,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let g=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],E,null,null)};g.error=E=>{this._config.onError(this._createLoadError(l.id,E))},s.load(l.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(s){let l=s.dependencies;if(l)for(let g=0,E=l.length;g<E;g++){let d=l[g];if(d===i.EXPORTS){s.exportsPassedIn=!0,s.unresolvedDependenciesCount--;continue}if(d===i.MODULE){s.unresolvedDependenciesCount--;continue}if(d===i.REQUIRE){s.unresolvedDependenciesCount--;continue}let f=this._modules2[d.id];if(f&&f.isComplete()){if(f.error){s.onDependencyError(f.error);return}s.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,s.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(s.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,s.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(N=>this._moduleIdProvider.getStrModuleId(N)).join(` => 
`)),s.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(s.id),d instanceof o){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let N=this._inversePluginDependencies2.get(d.pluginId);N||(N=[],this._inversePluginDependencies2.set(d.pluginId,N)),N.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}_onModuleComplete(s){let l=this.getRecorder();if(s.isComplete())return;let g=s.dependencies,E=[];if(g)for(let N=0,p=g.length;N<p;N++){let R=g[N];if(R===i.EXPORTS){E[N]=s.exports;continue}if(R===i.MODULE){E[N]={id:s.strId,config:()=>this._config.getConfigForModule(s.strId)};continue}if(R===i.REQUIRE){E[N]=this._createRequire(s.moduleIdResolver);continue}let b=this._modules2[R.id];if(b){E[N]=b.exports;continue}E[N]=null}const d=N=>(this._inverseDependencies2[N]||[]).map(p=>this._moduleIdProvider.getStrModuleId(p));s.complete(l,this._config,E,d);let f=this._inverseDependencies2[s.id];if(this._inverseDependencies2[s.id]=null,f)for(let N=0,p=f.length;N<p;N++){let R=f[N],b=this._modules2[R];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}let e=this._inversePluginDependencies2.get(s.id);if(e){this._inversePluginDependencies2.delete(s.id);for(let N=0,p=e.length;N<p;N++)this._loadPluginDependency(s.exports,e[N])}}}z.ModuleManager=L})(we||(we={}));var te,we;(function(z){const t=new z.Environment;let F=null;const _=function(u,s,l){typeof u!="string"&&(l=s,s=u,u=null),(typeof s!="object"||!Array.isArray(s))&&(l=s,s=null),s||(s=["require","exports","module"]),u?F.defineModule(u,s,l,null,null):F.enqueueDefineAnonymousModule(s,l)};_.amd={jQuery:!0};const i=function(u,s=!1){F.configure(u,s)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return F.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){F.defineModule(z.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=i,o.getConfig=function(){return F.getConfig().getOptionsLiteral()},o.reset=function(){F=F.reset()},o.getBuildInfo=function(){return F.getBuildInfo()},o.getStats=function(){return F.getLoaderEvents()},o.define=_;function L(){if(typeof z.global.require<"u"||typeof require<"u"){const u=z.global.require||require;if(typeof u=="function"&&typeof u.resolve=="function"){const s=z.ensureRecordedNodeRequire(F.getRecorder(),u);z.global.nodeRequire=s,o.nodeRequire=s,o.__$__nodeRequire=s}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(z.global.define=_),z.global.require=o)}z.init=L,(typeof z.global.define!="function"||!z.global.define.amd)&&(F=new z.ModuleManager(t,z.createScriptLoader(t),_,o,z.Utilities.getHighPerformanceTimestamp()),typeof z.global.require<"u"&&typeof z.global.require!="function"&&o.config(z.global.require),te=function(){return _.apply(null,arguments)},te.amd=_.amd,typeof doNotInitLoader>"u"&&L())})(we||(we={})),te(ne[63],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function F(u,s,l,g){if(g=g||{},(g["vs/css"]||{}).disabled){l({});return}const d=s.toUrl(u+".css");_(u,d,()=>{l({})},f=>{typeof l.error=="function"&&l.error("Could not find "+d+".")})}t.load=F;function _(u,s,l,g){if(i(u,s)){l();return}o(u,s,l,g)}function i(u,s){const l=document.getElementsByTagName("link");for(let g=0,E=l.length;g<E;g++){const d=l[g].getAttribute("data-name"),f=l[g].getAttribute("href");if(d===u||f===s)return!0}return!1}function o(u,s,l,g){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",u),L(u,E,l,g),E.setAttribute("href",s),(document.head||document.getElementsByTagName("head")[0]).appendChild(E)}function L(u,s,l,g){const E=()=>{s.removeEventListener("load",d),s.removeEventListener("error",f)},d=e=>{E(),l()},f=e=>{E(),g(e)};s.addEventListener("load",d),s.addEventListener("error",f)}}),te("vs/nls",["require","exports"],function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let F=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const _="i-default";function i(e,N){let p;return N.length===0?p=e:p=e.replace(/\{(\d+)\}/g,(R,b)=>{const M=b[0],h=N[M];let c=R;return typeof h=="string"?c=h:(typeof h=="number"||typeof h=="boolean"||h===void 0||h===null)&&(c=String(h)),c}),F&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function o(e,N){let p=e[N];return p||(p=e["*"],p)?p:null}function L(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function u(e,N,p){const R=L(e)+L(N)+"vscode/"+L(p),b=await fetch(R);if(b.ok)return await b.json();throw new Error(`${b.status} - ${b.statusText}`)}function s(e){return function(N,p){const R=Array.prototype.slice.call(arguments,2);return i(e[N],R)}}function l(e,N,...p){return i(N,p)}t.localize=l;function g(e){}t.getConfiguredDefaultLocale=g;function E(e){F=e}t.setPseudoTranslation=E;function d(e,N){return{localize:s(N[e]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??(p=>{})}}t.create=d;function f(e,N,p,R){const b=R["vs/nls"]??{};if(!e||e.length===0)return p({localize:l,getConfiguredDefaultLocale:()=>b.availableLanguages?.["*"]});const M=b.availableLanguages?o(b.availableLanguages,e):null,h=M===null||M===_;let c=".nls";h||(c=c+"."+M);const r=a=>{Array.isArray(a)?a.localize=s(a):a.localize=s(a[e]),a.getConfiguredDefaultLocale=()=>b.availableLanguages?.["*"],p(a)};typeof b.loadBundle=="function"?b.loadBundle(e,M,(a,A)=>{a?N([e+".nls"],r):r(A)}):b.translationServiceUrl&&!h?(async()=>{try{const a=await u(b.translationServiceUrl,M,e);return r(a)}catch(a){if(!M.includes("-"))return console.error(a),N([e+".nls"],r);try{const A=M.split("-")[0],m=await u(b.translationServiceUrl,A,e);return b.availableLanguages??={},b.availableLanguages["*"]=A,r(m)}catch(A){return console.error(A),N([e+".nls"],r)}}})():N([e+c],r,a=>{if(c===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${M}. Falling back to the default language:`,a),N([e+".nls"],r)})}t.load=f}),function(){const z=globalThis.MonacoEnvironment,t=z&&z.baseUrl?z.baseUrl:"../../../";function F(g,E){if(z?.createTrustedTypesPolicy)try{return z.createTrustedTypesPolicy(g,E)}catch(d){console.warn(d);return}try{return self.trustedTypes?.createPolicy(g,E)}catch(d){console.warn(d);return}}const _=F("amdLoader",{createScriptURL:g=>g,createScript:(g,...E)=>{const d=E.slice(0,-1).join(","),f=E.pop().toString();return`(function anonymous(${d}) { ${f}
})`}});function i(){try{return(_?globalThis.eval(_.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((g,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const d=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(d).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${d}`,(_?globalThis.eval(_.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,E);return}_?importScripts(_.createScriptURL(d)):importScripts(d),g()})}function L(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:_,amdModulesPattern:/^vs\//})}function u(g){o().then(()=>{L(),require([g],function(E){setTimeout(function(){const d=E.create((f,e)=>{globalThis.postMessage(f,e)},null);for(globalThis.onmessage=f=>d.onmessage(f.data,f.ports);l.length>0;){const f=l.shift();d.onmessage(f.data,f.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&L();let s=!0;const l=[];globalThis.onmessage=g=>{if(!s){l.push(g);return}s=!1,u(g.data)}}(),te(ne[28],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function F(L,u){const s=Object.create(null);for(const l of L){const g=u(l);let E=s[g];E||(E=s[g]=[]),E.push(l)}return s}t.$I=F;function _(L,u){const s=[],l=[];for(const g of L)u.has(g)||s.push(g);for(const g of u)L.has(g)||l.push(g);return{removed:s,added:l}}t.$J=_;function i(L,u){const s=[],l=[];for(const[g,E]of L)u.has(g)||s.push(E);for(const[g,E]of u)L.has(g)||l.push(E);return{removed:s,added:l}}t.$K=i;class o{constructor(){this.a=new Map}add(u,s){let l=this.a.get(u);l||(l=new Set,this.a.set(u,l)),l.add(s)}delete(u,s){const l=this.a.get(u);l&&(l.delete(s),l.size===0&&this.a.delete(u))}forEach(u,s){const l=this.a.get(u);l&&l.forEach(s)}get(u){const s=this.a.get(u);return s||new Set}}t.$L=o}),te(ne[29],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ds=t.$cs=t.$bs=t.$as=void 0;function F(u,s){const l=Math.pow(10,s);return Math.round(u*l)/l}class _{constructor(s,l,g,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,s))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=F(Math.max(Math.min(1,E),0),3)}static equals(s,l){return s.r===l.r&&s.g===l.g&&s.b===l.b&&s.a===l.a}}t.$as=_;class i{constructor(s,l,g,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=F(Math.max(Math.min(1,l),0),3),this.l=F(Math.max(Math.min(1,g),0),3),this.a=F(Math.max(Math.min(1,E),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.l===l.l&&s.a===l.a}static fromRGBA(s){const l=s.r/255,g=s.g/255,E=s.b/255,d=s.a,f=Math.max(l,g,E),e=Math.min(l,g,E);let N=0,p=0;const R=(e+f)/2,b=f-e;if(b>0){switch(p=Math.min(R<=.5?b/(2*R):b/(2-2*R),1),f){case l:N=(g-E)/b+(g<E?6:0);break;case g:N=(E-l)/b+2;break;case E:N=(l-g)/b+4;break}N*=60,N=Math.round(N)}return new i(N,p,R,d)}static i(s,l,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?s+(l-s)*6*g:g<1/2?l:g<2/3?s+(l-s)*(2/3-g)*6:s}static toRGBA(s){const l=s.h/360,{s:g,l:E,a:d}=s;let f,e,N;if(g===0)f=e=N=E;else{const p=E<.5?E*(1+g):E+g-E*g,R=2*E-p;f=i.i(R,p,l+1/3),e=i.i(R,p,l),N=i.i(R,p,l-1/3)}return new _(Math.round(f*255),Math.round(e*255),Math.round(N*255),d)}}t.$bs=i;class o{constructor(s,l,g,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=F(Math.max(Math.min(1,l),0),3),this.v=F(Math.max(Math.min(1,g),0),3),this.a=F(Math.max(Math.min(1,E),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.v===l.v&&s.a===l.a}static fromRGBA(s){const l=s.r/255,g=s.g/255,E=s.b/255,d=Math.max(l,g,E),f=Math.min(l,g,E),e=d-f,N=d===0?0:e/d;let p;return e===0?p=0:d===l?p=((g-E)/e%6+6)%6:d===g?p=(E-l)/e+2:p=(l-g)/e+4,new o(Math.round(p*60),N,d,s.a)}static toRGBA(s){const{h:l,s:g,v:E,a:d}=s,f=E*g,e=f*(1-Math.abs(l/60%2-1)),N=E-f;let[p,R,b]=[0,0,0];return l<60?(p=f,R=e):l<120?(p=e,R=f):l<180?(R=f,b=e):l<240?(R=e,b=f):l<300?(p=e,b=f):l<=360&&(p=f,b=e),p=Math.round((p+N)*255),R=Math.round((R+N)*255),b=Math.round((b+N)*255),new _(p,R,b,d)}}t.$cs=o;class L{static fromHex(s){return L.Format.CSS.parseHex(s)||L.red}static equals(s,l){return!s&&!l?!0:!s||!l?!1:s.equals(l)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(s){if(s)if(s instanceof _)this.rgba=s;else if(s instanceof i)this.i=s,this.rgba=i.toRGBA(s);else if(s instanceof o)this.j=s,this.rgba=o.toRGBA(s);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(s){return!!s&&_.equals(this.rgba,s.rgba)&&i.equals(this.hsla,s.hsla)&&o.equals(this.hsva,s.hsva)}getRelativeLuminance(){const s=L.k(this.rgba.r),l=L.k(this.rgba.g),g=L.k(this.rgba.b),E=.2126*s+.7152*l+.0722*g;return F(E,4)}static k(s){const l=s/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(s){const l=this.getRelativeLuminance(),g=s.getRelativeLuminance();return l>g?(l+.05)/(g+.05):(g+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(s){const l=this.getRelativeLuminance(),g=s.getRelativeLuminance();return l>g}isDarkerThan(s){const l=this.getRelativeLuminance(),g=s.getRelativeLuminance();return l<g}lighten(s){return new L(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*s,this.hsla.a))}darken(s){return new L(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*s,this.hsla.a))}transparent(s){const{r:l,g,b:E,a:d}=this.rgba;return new L(new _(l,g,E,d*s))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new L(new _(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(s){const l=s.rgba,g=this.rgba.a,E=l.a,d=g+E*(1-g);if(d<1e-6)return L.transparent;const f=this.rgba.r*g/d+l.r*E*(1-g)/d,e=this.rgba.g*g/d+l.g*E*(1-g)/d,N=this.rgba.b*g/d+l.b*E*(1-g)/d;return new L(new _(f,e,N,d))}makeOpaque(s){if(this.isOpaque()||s.rgba.a!==1)return this;const{r:l,g,b:E,a:d}=this.rgba;return new L(new _(s.rgba.r-d*(s.rgba.r-l),s.rgba.g-d*(s.rgba.g-g),s.rgba.b-d*(s.rgba.b-E),1))}flatten(...s){const l=s.reduceRight((g,E)=>L.o(E,g));return L.o(this,l)}static o(s,l){const g=1-s.rgba.a;return new L(new _(g*l.rgba.r+s.rgba.a*s.rgba.r,g*l.rgba.g+s.rgba.a*s.rgba.g,g*l.rgba.b+s.rgba.a*s.rgba.b))}toString(){return this.u||(this.u=L.Format.CSS.format(this)),this.u}static getLighterColor(s,l,g){if(s.isLighterThan(l))return s;g=g||.5;const E=s.getRelativeLuminance(),d=l.getRelativeLuminance();return g=g*(d-E)/d,s.lighten(g)}static getDarkerColor(s,l,g){if(s.isDarkerThan(l))return s;g=g||.5;const E=s.getRelativeLuminance(),d=l.getRelativeLuminance();return g=g*(E-d)/E,s.darken(g)}static{this.white=new L(new _(255,255,255,1))}static{this.black=new L(new _(0,0,0,1))}static{this.red=new L(new _(255,0,0,1))}static{this.blue=new L(new _(0,0,255,1))}static{this.green=new L(new _(0,255,0,1))}static{this.cyan=new L(new _(0,255,255,1))}static{this.lightgrey=new L(new _(211,211,211,1))}static{this.transparent=new L(new _(0,0,0,0))}}t.$ds=L,function(u){let s;(function(l){let g;(function(E){function d(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:u.Format.CSS.formatRGBA(r)}E.formatRGB=d;function f(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}E.formatRGBA=f;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:u.Format.CSS.formatHSLA(r)}E.formatHSL=e;function N(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}E.formatHSLA=N;function p(r){const a=r.toString(16);return a.length!==2?"0"+a:a}function R(r){return`#${p(r.rgba.r)}${p(r.rgba.g)}${p(r.rgba.b)}`}E.formatHex=R;function b(r,a=!1){return a&&r.rgba.a===1?u.Format.CSS.formatHex(r):`#${p(r.rgba.r)}${p(r.rgba.g)}${p(r.rgba.b)}${p(Math.round(r.rgba.a*255))}`}E.formatHexA=b;function M(r){return r.isOpaque()?u.Format.CSS.formatHex(r):u.Format.CSS.formatRGBA(r)}E.format=M;function h(r){const a=r.length;if(a===0||r.charCodeAt(0)!==35)return null;if(a===7){const A=16*c(r.charCodeAt(1))+c(r.charCodeAt(2)),m=16*c(r.charCodeAt(3))+c(r.charCodeAt(4)),$=16*c(r.charCodeAt(5))+c(r.charCodeAt(6));return new u(new _(A,m,$,1))}if(a===9){const A=16*c(r.charCodeAt(1))+c(r.charCodeAt(2)),m=16*c(r.charCodeAt(3))+c(r.charCodeAt(4)),$=16*c(r.charCodeAt(5))+c(r.charCodeAt(6)),w=16*c(r.charCodeAt(7))+c(r.charCodeAt(8));return new u(new _(A,m,$,w/255))}if(a===4){const A=c(r.charCodeAt(1)),m=c(r.charCodeAt(2)),$=c(r.charCodeAt(3));return new u(new _(16*A+A,16*m+m,16*$+$))}if(a===5){const A=c(r.charCodeAt(1)),m=c(r.charCodeAt(2)),$=c(r.charCodeAt(3)),w=c(r.charCodeAt(4));return new u(new _(16*A+A,16*m+m,16*$+$,(16*w+w)/255))}return null}E.parseHex=h;function c(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=l.CSS||(l.CSS={}))})(s=u.Format||(u.Format={}))}(L||(t.$ds=L={}))}),te(ne[30],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ru=void 0;class F{constructor(i,o,L,u){this.originalStart=i,this.originalLength=o,this.modifiedStart=L,this.modifiedLength=u}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ru=F}),te(ne[3],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class F{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?h.isErrorNoTelemetry(a)?new h(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(A=>{A(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}t.$U=F,t.$V=new F;function _(r){t.$V.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=_;function i(r){if(!r||typeof r!="object")return!1;const a=r;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}t.$X=i;function o(r){l(r)||t.$V.onUnexpectedError(r)}t.$Y=o;function L(r){l(r)||t.$V.onUnexpectedExternalError(r)}t.$Z=L;function u(r){if(r instanceof Error){const{name:a,message:A}=r,m=r.stacktrace||r.stack;return{$isError:!0,name:a,message:A,stack:m,noTelemetry:h.isErrorNoTelemetry(r)}}return r}t.$1=u;const s="Canceled";function l(r){return r instanceof g?!0:r instanceof Error&&r.name===s&&r.message===s}t.$2=l;class g extends Error{constructor(){super(s),this.name=this.message}}t.$3=g;function E(){const r=new Error(s);return r.name=r.message,r}t.$4=E;function d(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.$5=d;function f(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.$6=f;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.$7=e;function N(r){const a=new Error(`${r} has been disposed`);return a.name="DISPOSED",a}t.$8=N;function p(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.$9=p;class R extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.$0=R;class b extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.$$=b;class M extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=M;class h extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof h)return a;const A=new h;return A.message=a.message,A.stack=a.stack,A}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.$ab=h;class c extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}t.$bb=c}),te(ne[15],ie([0,1,3]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.CompareResult=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.top=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=void 0;function _(D,S=0){return D[D.length-(1+S)]}t.$9e=_;function i(D){if(D.length===0)throw new Error("Invalid tail call");return[D.slice(0,D.length-1),D[D.length-1]]}t.$0e=i;function o(D,S,U=(V,H)=>V===H){if(D===S)return!0;if(!D||!S||D.length!==S.length)return!1;for(let V=0,H=D.length;V<H;V++)if(!U(D[V],S[V]))return!1;return!0}t.$$e=o;function L(D,S){const U=D.length-1;S<U&&(D[S]=D[U]),D.pop()}t.$_e=L;function u(D,S,U){return s(D.length,V=>U(D[V],S))}t.$af=u;function s(D,S){let U=0,V=D-1;for(;U<=V;){const H=(U+V)/2|0,se=S(H);if(se<0)U=H+1;else if(se>0)V=H-1;else return H}return-(U+1)}t.$bf=s;function l(D,S){let U=0,V=D.length;if(V===0)return 0;for(;U<V;){const H=Math.floor((U+V)/2);S(D[H])?V=H:U=H+1}return U}t.$cf=l;function g(D,S,U){if(D=D|0,D>=S.length)throw new TypeError("invalid index");const V=S[Math.floor(S.length*Math.random())],H=[],se=[],ae=[];for(const ge of S){const be=U(ge,V);be<0?H.push(ge):be>0?se.push(ge):ae.push(ge)}return D<H.length?g(D,H,U):D<H.length+ae.length?ae[0]:g(D-(H.length+ae.length),se,U)}t.$df=g;function E(D,S){const U=[];let V;for(const H of D.slice(0).sort(S))!V||S(V[0],H)!==0?(V=[H],U.push(V)):V.push(H);return U}t.$ef=E;function d(D,S,U){const V=[];function H(ge,be,$e){if(be===0&&$e.length===0)return;const Ae=V[V.length-1];Ae&&Ae.start+Ae.deleteCount===ge?(Ae.deleteCount+=be,Ae.toInsert.push(...$e)):V.push({start:ge,deleteCount:be,toInsert:$e})}let se=0,ae=0;for(;;){if(se===D.length){H(se,0,S.slice(ae));break}if(ae===S.length){H(se,D.length-se,[]);break}const ge=D[se],be=S[ae],$e=U(ge,be);$e===0?(se+=1,ae+=1):$e<0?(H(se,1,[]),se+=1):$e>0&&(H(se,0,[be]),ae+=1)}return V}t.$ff=d;function f(D,S,U){const V=d(D,S,U),H=[],se=[];for(const ae of V)H.push(...D.slice(ae.start,ae.start+ae.deleteCount)),se.push(...ae.toInsert);return{removed:H,added:se}}t.$gf=f;function e(D,S,U){if(U===0)return[];const V=D.slice(0,U).sort(S);return p(D,S,V,U,D.length),V}t.top=e;function N(D,S,U,V,H){return U===0?Promise.resolve([]):new Promise((se,ae)=>{(async()=>{const ge=D.length,be=D.slice(0,U).sort(S);for(let $e=U,Ae=Math.min(U+V,ge);$e<ge;$e=Ae,Ae=Math.min(Ae+V,ge)){if($e>U&&await new Promise(ye=>setTimeout(ye)),H&&H.isCancellationRequested)throw new F.$3;p(D,S,be,$e,Ae)}return be})().then(se,ae)})}t.$if=N;function p(D,S,U,V,H){for(const se=U.length;V<H;V++){const ae=D[V];if(S(ae,U[se-1])<0){U.pop();const ge=l(U,be=>S(ae,be)<0);U.splice(ge,0,ae)}}}function R(D){return D.filter(S=>!!S)}t.$jf=R;function b(D){let S=0;for(let U=0;U<D.length;U++)D[U]&&(D[S]=D[U],S+=1);D.length=S}t.$kf=b;function M(D,S,U){D.splice(U,0,D.splice(S,1)[0])}t.$lf=M;function h(D){return!Array.isArray(D)||D.length===0}t.$mf=h;function c(D){return Array.isArray(D)&&D.length>0}t.$nf=c;function r(D,S=U=>U){const U=new Set;return D.filter(V=>{const H=S(V);return U.has(H)?!1:(U.add(H),!0)})}t.$of=r;function a(D){const S=new Set;return U=>{const V=D(U);return S.has(V)?!1:(S.add(V),!0)}}t.$pf=a;function A(D,S){const U=m(D,S);if(U!==-1)return D[U]}t.$qf=A;function m(D,S){for(let U=D.length-1;U>=0;U--){const V=D[U];if(S(V))return U}return-1}t.$rf=m;function $(D,S){return D.length>0?D[0]:S}t.$sf=$;function w(D,S){return D.length>0?D[D.length-1]:S}t.$tf=w;function v(D,S,U=(V,H)=>V===H){let V=0;for(let H=0,se=Math.min(D.length,S.length);H<se&&U(D[H],S[H]);H++)V++;return V}t.$uf=v;function y(D){return[].concat(...D)}t.$vf=y;function I(D,S){let U=typeof S=="number"?D:0;typeof S=="number"?U=D:(U=0,S=D);const V=[];if(U<=S)for(let H=U;H<S;H++)V.push(H);else for(let H=U;H>S;H--)V.push(H);return V}t.$wf=I;function P(D,S,U){return D.reduce((V,H)=>(V[S(H)]=U?U(H):H,V),Object.create(null))}t.$xf=P;function j(D,S){return D.push(S),()=>x(D,S)}t.$yf=j;function x(D,S){const U=D.indexOf(S);if(U>-1)return D.splice(U,1),S}t.$zf=x;function W(D,S,U){const V=D.slice(0,S),H=D.slice(S);return V.concat(U,H)}t.$Af=W;function G(D,S){let U;if(typeof S=="number"){let V=S;U=()=>{const H=Math.sin(V++)*179426549;return H-Math.floor(H)}}else U=Math.random;for(let V=D.length-1;V>0;V-=1){const H=Math.floor(U()*(V+1)),se=D[V];D[V]=D[H],D[H]=se}}t.$Bf=G;function k(D,S){const U=D.indexOf(S);U>-1&&(D.splice(U,1),D.unshift(S))}t.$Cf=k;function q(D,S){const U=D.indexOf(S);U>-1&&(D.splice(U,1),D.push(S))}t.$Df=q;function O(D,S){for(const U of S)D.push(U)}t.$Ef=O;function B(D,S){return Array.isArray(D)?D.map(S):S(D)}t.$Ff=B;function X(D){return Array.isArray(D)?D:[D]}t.$Gf=X;function n(D){return D[Math.floor(Math.random()*D.length)]}t.$Hf=n;function K(D,S){for(const U of D){const V=S(U);if(V!==void 0)return V}}t.$If=K;function ee(D,S,U){const V=oe(D,S),H=D.length,se=U.length;D.length=H+se;for(let ae=H-1;ae>=V;ae--)D[ae+se]=D[ae];for(let ae=0;ae<se;ae++)D[ae+V]=U[ae]}t.$Jf=ee;function ue(D,S,U,V){const H=oe(D,S),se=D.splice(H,U);return ee(D,H,V),se}t.$Kf=ue;function oe(D,S){return S<0?Math.max(S+D.length,0):Math.min(S,D.length)}var ce;(function(D){function S(H){return H<0}D.isLessThan=S;function U(H){return H>0}D.isGreaterThan=U;function V(H){return H===0}D.isNeitherLessOrGreaterThan=V,D.greaterThan=1,D.lessThan=-1,D.neitherLessOrGreaterThan=0})(ce||(t.CompareResult=ce={}));function he(D,S){return(U,V)=>S(D(U),D(V))}t.$Lf=he;function de(...D){return(S,U)=>{for(const V of D){const H=V(S,U);if(!ce.isNeitherLessOrGreaterThan(H))return H}return ce.neitherLessOrGreaterThan}}t.$Mf=de;const Re=(D,S)=>D-S;t.$Nf=Re;const me=(D,S)=>(0,t.$Nf)(D?1:0,S?1:0);t.$Of=me;function ve(D){return(S,U)=>-D(S,U)}t.$Pf=ve;function Me(D,S){if(D.length===0)return;let U=D[0];for(let V=1;V<D.length;V++){const H=D[V];S(H,U)>0&&(U=H)}return U}t.$Qf=Me;function Ne(D,S){if(D.length===0)return;let U=D[0];for(let V=1;V<D.length;V++){const H=D[V];S(H,U)>=0&&(U=H)}return U}t.$Rf=Ne;function pe(D,S){return Me(D,(U,V)=>-S(U,V))}t.$Sf=pe;function le(D,S){if(D.length===0)return-1;let U=0;for(let V=1;V<D.length;V++){const H=D[V];S(H,D[U])>0&&(U=V)}return U}t.$Tf=le;class Z{constructor(S){this.f=S,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(S){let U=this.c;for(;U<this.f.length&&S(this.f[U]);)U++;const V=U===this.c?null:this.f.slice(this.c,U);return this.c=U,V}takeFromEndWhile(S){let U=this.d;for(;U>=0&&S(this.f[U]);)U--;const V=U===this.d?null:this.f.slice(U+1,this.d+1);return this.d=U,V}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const S=this.f[this.c];return this.c++,S}removeLast(){const S=this.f[this.d];return this.d--,S}takeCount(S){const U=this.f.slice(this.c,this.c+S);return this.c+=S,U}}t.$Uf=Z;class J{static{this.empty=new J(S=>{})}constructor(S){this.iterate=S}forEach(S){this.iterate(U=>(S(U),!0))}toArray(){const S=[];return this.iterate(U=>(S.push(U),!0)),S}filter(S){return new J(U=>this.iterate(V=>S(V)?U(V):!0))}map(S){return new J(U=>this.iterate(V=>U(S(V))))}some(S){let U=!1;return this.iterate(V=>(U=S(V),!U)),U}findFirst(S){let U;return this.iterate(V=>S(V)?(U=V,!1):!0),U}findLast(S){let U;return this.iterate(V=>(S(V)&&(U=V),!0)),U}findLastMaxBy(S){let U,V=!0;return this.iterate(H=>((V||ce.isGreaterThan(S(H,U)))&&(V=!1,U=H),!0)),U}}t.$Vf=J}),te(ne[10],ie([0,1,3]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zb=t.$yb=t.$xb=t.$wb=t.ok=void 0;function _(s,l){if(!s)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=_;function i(s,l="Unreachable"){throw new Error(l)}t.$wb=i;function o(s){if(!s)throw new F.$bb("Assertion Failed")}t.$xb=o;function L(s){if(!s()){debugger;s(),(0,F.$Y)(new F.$bb("Assertion Failed"))}}t.$yb=L;function u(s,l){let g=0;for(;g<s.length-1;){const E=s[g],d=s[g+1];if(!l(E,d))return!1;g++}return!0}t.$zb=u}),te(ne[16],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function F(_){const i=this;let o=!1,L;return function(){return o||(o=!0,L=_.apply(i,arguments)),L}}t.$cb=F}),te(ne[17],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var F;(function(_){function i(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}_.is=i;const o=Object.freeze([]);function L(){return o}_.empty=L;function*u(h){yield h}_.single=u;function s(h){return i(h)?h:u(h)}_.wrap=s;function l(h){return h||o}_.from=l;function g(h){return!h||h[Symbol.iterator]().next().done===!0}_.isEmpty=g;function E(h){return h[Symbol.iterator]().next().value}_.first=E;function d(h,c){for(const r of h)if(c(r))return!0;return!1}_.some=d;function f(h,c){for(const r of h)if(c(r))return r}_.find=f;function*e(h,c){for(const r of h)c(r)&&(yield r)}_.filter=e;function*N(h,c){let r=0;for(const a of h)yield c(a,r++)}_.map=N;function*p(...h){for(const c of h)for(const r of c)yield r}_.concat=p;function R(h,c,r){let a=r;for(const A of h)a=c(a,A);return a}_.reduce=R;function*b(h,c,r=h.length){for(c<0&&(c+=h.length),r<0?r+=h.length:r>h.length&&(r=h.length);c<r;c++)yield h[c]}_.slice=b;function M(h,c=Number.POSITIVE_INFINITY){const r=[];if(c===0)return[r,h];const a=h[Symbol.iterator]();for(let A=0;A<c;A++){const m=a.next();if(m.done)return[r,_.empty()];r.push(m.value)}return[r,{[Symbol.iterator](){return a}}]}_.consume=M})(F||(t.Iterable=F={}))}),te(ne[31],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mq=t.KeyMod=t.KeyCodeUtils=t.$lq=t.$kq=t.$jq=t.$iq=t.$hq=t.ScanCode=t.KeyCode=void 0;var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(F||(t.KeyCode=F={}));var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(_||(t.ScanCode=_={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,p){this._keyCodeToStr[N]=p,this._strToKeyCode[p.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const o=new i,L=new i,u=new i;t.$hq=new Array(230),t.$iq={};const s=[],l=Object.create(null),g=Object.create(null);t.$jq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>l[e]||0,toString:e=>s[e]||"None"},t.$kq=[],t.$lq=[];for(let e=0;e<=193;e++)t.$kq[e]=-1;for(let e=0;e<=132;e++)t.$lq[e]=-1;(function(){const e="",N=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],p=[],R=[];for(const b of N){const[M,h,c,r,a,A,m,$,w]=b;if(R[h]||(R[h]=!0,s[h]=c,l[c]=h,g[c.toLowerCase()]=h,M&&(t.$kq[h]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$lq[r]=h))),!p[r]){if(p[r]=!0,!a)throw new Error(`String representation missing for key code ${r} around scan code ${c}`);o.define(r,a),L.define(r,$||a),u.define(r,w||$||a)}A&&(t.$hq[A]=r),m&&(t.$iq[m]=r)}t.$lq[3]=46})();var E;(function(e){function N(c){return o.keyCodeToStr(c)}e.toString=N;function p(c){return o.strToKeyCode(c)}e.fromString=p;function R(c){return L.keyCodeToStr(c)}e.toUserSettingsUS=R;function b(c){return u.keyCodeToStr(c)}e.toUserSettingsGeneral=b;function M(c){return L.strToKeyCode(c)||u.strToKeyCode(c)}e.fromUserSettings=M;function h(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(c)}e.toElectronAccelerator=h})(E||(t.KeyCodeUtils=E={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(t.KeyMod=d={}));function f(e,N){const p=(N&65535)<<16>>>0;return(e|p)>>>0}t.$mq=f}),te(ne[32],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class F{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=F}),te(ne[7],ie([0,1,16,17]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tb=t.$sb=t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;const i=!1;let o=null;function L(w){o=w}if(t.$db=L,i){const w="__is_disposable_tracked__";L(new class{trackDisposable(v){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[w]||console.log(y)},3e3)}setParent(v,y){if(v&&v!==b.None)try{v[w]=!0}catch{}}markAsDisposed(v){if(v&&v!==b.None)try{v[w]=!0}catch{}}markAsSingleton(v){}})}function u(w){return o?.trackDisposable(w),w}function s(w){o?.markAsDisposed(w)}function l(w,v){o?.setParent(w,v)}function g(w,v){if(o)for(const y of w)o.setParent(y,v)}function E(w){return o?.markAsSingleton(w),w}t.$eb=E;function d(w){return typeof w.dispose=="function"&&w.dispose.length===0}t.$fb=d;function f(w){if(_.Iterable.is(w)){const v=[];for(const y of w)if(y)try{y.dispose()}catch(I){v.push(I)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}t.$gb=f;function e(w){for(const v of w)d(v)&&v.dispose();return[]}t.$hb=e;function N(...w){const v=p(()=>f(w));return g(w,v),v}t.$ib=N;function p(w){const v=u({dispose:(0,F.$cb)(()=>{s(v),w()})});return v}t.$jb=p;class R{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return l(v,this),this.g?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}}t.$kb=R;class b{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new R,u(this),l(this.q,this)}dispose(){s(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}t.$lb=b;class M{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&l(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&l(v,null),v}}t.$mb=M;class h{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$nb=h;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(v){let y=v;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,s(this))},this}}t.$ob=c;class r{constructor(){this.a=new Map}acquire(v,...y){let I=this.a.get(v);I||(I={counter:0,object:this.b(v,...y)},this.a.set(v,I));const{object:P}=I,j=(0,F.$cb)(()=>{--I.counter===0&&(this.c(v,I.object),this.a.delete(v))});return I.counter++,{object:P,dispose:j}}}t.$pb=r;class a{constructor(v){this.a=v}async acquire(v,...y){const I=this.a.acquire(v,...y);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(P){throw I.dispose(),P}}}t.$qb=a;class A{constructor(v){this.object=v}dispose(){}}t.$rb=A;function m(w){const v=new R;try{w(v)}finally{v.dispose()}}t.$sb=m;class ${constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get(v){return this.a.get(v)}set(v,y,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(v)?.dispose(),this.a.set(v,y)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$tb=$}),te(ne[18],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ub=void 0;class F{static{this.Undefined=new F(void 0)}constructor(o){this.element=o,this.next=F.Undefined,this.prev=F.Undefined}}class _{constructor(){this.a=F.Undefined,this.b=F.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===F.Undefined}clear(){let o=this.a;for(;o!==F.Undefined;){const L=o.next;o.prev=F.Undefined,o.next=F.Undefined,o=L}this.a=F.Undefined,this.b=F.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,L){const u=new F(o);if(this.a===F.Undefined)this.a=u,this.b=u;else if(L){const l=this.b;this.b=u,u.prev=l,l.next=u}else{const l=this.a;this.a=u,u.next=l,l.prev=u}this.c+=1;let s=!1;return()=>{s||(s=!0,this.e(u))}}shift(){if(this.a!==F.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==F.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==F.Undefined&&o.next!==F.Undefined){const L=o.prev;L.next=o.next,o.next.prev=L}else o.prev===F.Undefined&&o.next===F.Undefined?(this.a=F.Undefined,this.b=F.Undefined):o.next===F.Undefined?(this.b=this.b.prev,this.b.next=F.Undefined):o.prev===F.Undefined&&(this.a=this.a.next,this.a.prev=F.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==F.Undefined;)yield o.element,o=o.next}}t.$ub=_}),te(ne[19],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=void 0;const F=globalThis.performance&&typeof globalThis.performance.now=="function";class _{static create(o){return new _(o)}constructor(o){this.c=F&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ac=_}),te(ne[8],ie([0,1,3,16,7,18,19]),function(z,t,F,_,i,o,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.Event=void 0;const u=!1,s=!1;var l;(function(I){I.None=()=>i.$lb.None;function P(Z){if(s){const{onDidAddListener:J}=Z,D=e.create();let S=0;Z.onDidAddListener=()=>{++S===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),D.print()),J?.()}}}function j(Z,J){return n(Z,()=>{},0,void 0,!0,void 0,J)}I.defer=j;function x(Z){return(J,D=null,S)=>{let U=!1,V;return V=Z(H=>{if(!U)return V?V.dispose():U=!0,J.call(D,H)},null,S),U&&V.dispose(),V}}I.once=x;function W(Z,J,D){return X((S,U=null,V)=>Z(H=>S.call(U,J(H)),null,V),D)}I.map=W;function G(Z,J,D){return X((S,U=null,V)=>Z(H=>{J(H),S.call(U,H)},null,V),D)}I.forEach=G;function k(Z,J,D){return X((S,U=null,V)=>Z(H=>J(H)&&S.call(U,H),null,V),D)}I.filter=k;function q(Z){return Z}I.signal=q;function O(...Z){return(J,D=null,S)=>(0,i.$ib)(...Z.map(U=>U(V=>J.call(D,V),null,S)))}I.any=O;function B(Z,J,D,S){let U=D;return W(Z,V=>(U=J(U,V),U),S)}I.reduce=B;function X(Z,J){let D;const S={onWillAddFirstListener(){D=Z(U.fire,U)},onDidRemoveLastListener(){D?.dispose()}};J||P(S);const U=new M(S);return J?.add(U),U.event}function n(Z,J,D=100,S=!1,U=!1,V,H){let se,ae,ge,be=0,$e;const Ae={leakWarningThreshold:V,onWillAddFirstListener(){se=Z(qe=>{be++,ae=J(ae,qe),S&&!ge&&(ye.fire(ae),ae=void 0),$e=()=>{const Ue=ae;ae=void 0,ge=void 0,(!S||be>1)&&ye.fire(Ue),be=0},typeof D=="number"?(clearTimeout(ge),ge=setTimeout($e,D)):ge===void 0&&(ge=0,queueMicrotask($e))})},onWillRemoveListener(){U&&be>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,se.dispose()}};H||P(Ae);const ye=new M(Ae);return H?.add(ye),ye.event}I.debounce=n;function K(Z,J=0,D){return I.debounce(Z,(S,U)=>S?(S.push(U),S):[U],J,void 0,!0,void 0,D)}I.accumulate=K;function ee(Z,J=(S,U)=>S===U,D){let S=!0,U;return k(Z,V=>{const H=S||!J(V,U);return S=!1,U=V,H},D)}I.latch=ee;function ue(Z,J,D){return[I.filter(Z,J,D),I.filter(Z,S=>!J(S),D)]}I.split=ue;function oe(Z,J=!1,D=[]){let S=D.slice(),U=Z(se=>{S?S.push(se):H.fire(se)});const V=()=>{S?.forEach(se=>H.fire(se)),S=null},H=new M({onWillAddFirstListener(){U||(U=Z(se=>H.fire(se)))},onDidAddFirstListener(){S&&(J?setTimeout(V):V())},onDidRemoveLastListener(){U&&U.dispose(),U=null}});return H.event}I.buffer=oe;class ce{constructor(J){this.event=J,this.d=new i.$kb}map(J){return new ce(W(this.event,J,this.d))}forEach(J){return new ce(G(this.event,J,this.d))}filter(J){return new ce(k(this.event,J,this.d))}reduce(J,D){return new ce(B(this.event,J,D,this.d))}latch(){return new ce(ee(this.event,void 0,this.d))}debounce(J,D=100,S=!1,U=!1,V){return new ce(n(this.event,J,D,S,U,V,this.d))}on(J,D,S){return this.event(J,D,S)}once(J,D,S){return x(this.event)(J,D,S)}dispose(){this.d.dispose()}}function he(Z){return new ce(Z)}I.chain=he;function de(Z,J,D=S=>S){const S=(...se)=>H.fire(D(...se)),U=()=>Z.on(J,S),V=()=>Z.removeListener(J,S),H=new M({onWillAddFirstListener:U,onDidRemoveLastListener:V});return H.event}I.fromNodeEventEmitter=de;function Re(Z,J,D=S=>S){const S=(...se)=>H.fire(D(...se)),U=()=>Z.addEventListener(J,S),V=()=>Z.removeEventListener(J,S),H=new M({onWillAddFirstListener:U,onDidRemoveLastListener:V});return H.event}I.fromDOMEventEmitter=Re;function me(Z){return new Promise(J=>x(Z)(J))}I.toPromise=me;function ve(Z,J){return J(void 0),Z(D=>J(D))}I.runAndSubscribe=ve;function Me(Z,J){let D=null;function S(V){D?.dispose(),D=new i.$kb,J(V,D)}S(void 0);const U=Z(V=>S(V));return(0,i.$jb)(()=>{U.dispose(),D?.dispose()})}I.runAndSubscribeWithStore=Me;class Ne{constructor(J,D){this._observable=J,this.d=0,this.f=!1;const S={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};D||P(S),this.emitter=new M(S),D&&D.add(this.emitter)}beginUpdate(J){this.d++}handlePossibleChange(J){}handleChange(J,D){this.f=!0}endUpdate(J){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function pe(Z,J){return new Ne(Z,J).emitter.event}I.fromObservable=pe;function le(Z){return J=>{let D=0,S=!1;const U={beginUpdate(){D++},endUpdate(){D--,D===0&&(Z.reportChanges(),S&&(S=!1,J()))},handlePossibleChange(){},handleChange(){S=!0}};return Z.addObserver(U),Z.reportChanges(),{dispose(){Z.removeObserver(U)}}}}I.fromObservableLight=le})(l||(t.Event=l={}));class g{static{this.all=new Set}static{this.d=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${g.d++}`,g.all.add(this)}start(P){this.f=new L.$ac,this.listenerCount=P}stop(){if(this.f){const P=this.f.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.f=void 0}}}t.$cc=g;let E=-1;function d(I){const P=E;return E=I,{dispose(){E=P}}}t.$dc=d;class f{constructor(P,j=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=j,this.f=0}dispose(){this.d?.clear()}check(P,j){const x=this.threshold;if(x<=0||j<x)return;this.d||(this.d=new Map);const W=this.d.get(P.value)||0;if(this.d.set(P.value,W+1),this.f-=1,this.f<=0){this.f=x*.5;let G,k=0;for(const[q,O]of this.d)(!G||k<O)&&(G=q,k=O);console.warn(`[${this.name}] potential listener LEAK detected, having ${j} listeners already. MOST frequent listener (${k}):`),console.warn(G)}return()=>{const G=this.d.get(P.value)||0;this.d.set(P.value,G-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let N=0;class p{constructor(P){this.value=P,this.id=N++}}const R=2,b=(I,P)=>{if(I instanceof p)P(I);else for(let j=0;j<I.length;j++){const x=I[j];x&&P(x)}};class M{constructor(P){this.u=0,this.d=P,this.f=E>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new g(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(u){const P=this.q;queueMicrotask(()=>{b(P,j=>j.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(P,j,x)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$lb.None;if(this.j)return i.$lb.None;j&&(P=P.bind(j));const W=new p(P);let G,k;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(W.stack=e.create(),G=this.f.check(W.stack,this.u+1)),u&&(W.stack=k??e.create()),this.q?this.q instanceof p?(this.t??=new c,this.q=[this.q,W]):this.q.push(W):(this.d?.onWillAddFirstListener?.(this),this.q=W,this.d?.onDidAddFirstListener?.(this)),this.u++;const q=(0,i.$jb)(()=>{G?.(),this.v(W)});return x instanceof i.$kb?x.add(q):Array.isArray(x)&&x.push(q),q},this.m}v(P){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const j=this.q,x=j.indexOf(P);if(x===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,j[x]=void 0;const W=this.t.current===this;if(this.u*R<=j.length){let G=0;for(let k=0;k<j.length;k++)j[k]?j[G++]=j[k]:W&&(this.t.end--,G<this.t.i&&this.t.i--);j.length=G}}w(P,j){if(!P)return;const x=this.d?.onListenerError||F.$Y;if(!x){P.value(j);return}try{P.value(j)}catch(W){x(W)}}x(P){const j=P.current.q;for(;P.i<P.end;)this.w(j[P.i++],P.value);P.reset()}fire(P){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof p)this.w(this.q,P);else{const j=this.t;j.enqueue(this,P,this.q.length),this.x(j)}this.g?.stop()}hasListeners(){return this.u>0}}t.$ec=M;const h=()=>new c;t.$fc=h;class c{constructor(){this.i=-1,this.end=0}enqueue(P,j,x){this.i=0,this.end=x,this.current=P,this.value=j}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends M{async fireAsync(P,j,x){if(this.q)for(this.h||(this.h=new o.$ub),b(this.q,W=>this.h.push([W.value,P]));this.h.size>0&&!j.isCancellationRequested;){const[W,G]=this.h.shift(),k=[],q={...G,token:j,waitUntil:O=>{if(Object.isFrozen(k))throw new Error("waitUntil can NOT be called asynchronous");x&&(O=x(O,W)),k.push(O)}};try{W(q)}catch(O){(0,F.$Y)(O);continue}Object.freeze(k),await Promise.allSettled(k).then(O=>{for(const B of O)B.status==="rejected"&&(0,F.$Y)(B.reason)})}}}t.$gc=r;class a extends M{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new o.$ub,this.y=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.y(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.u&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$hc=a;class A extends a{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$ic=A;class m extends M{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(j=>super.fire(j)),this.h=[]}))}}t.$jc=m;class ${constructor(){this.f=!1,this.g=[],this.d=new M({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(P){const j={event:P,listener:null};this.g.push(j),this.f&&this.k(j);const x=()=>{this.f&&this.m(j);const W=this.g.indexOf(j);this.g.splice(W,1)};return(0,i.$jb)((0,_.$cb)(x))}h(){this.f=!0,this.g.forEach(P=>this.k(P))}j(){this.f=!1,this.g.forEach(P=>this.m(P))}k(P){P.listener=P.event(j=>this.d.fire(j))}m(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.d.dispose()}}t.$kc=$;class w{constructor(P,j,x,W){this.d=new i.$kb;const G=this.d.add(new $),k=this.d.add(new i.$tb);function q(O){k.set(O,G.add(W(O)))}for(const O of P)q(O);this.d.add(j(O=>{q(O)})),this.d.add(x(O=>{k.deleteAndDispose(O)})),this.event=G.event}dispose(){this.d.dispose()}}t.$lc=w;class v{constructor(){this.d=[]}wrapEvent(P){return(j,x,W)=>P(G=>{const k=this.d[this.d.length-1];k?k.push(()=>j.call(x,G)):j.call(x,G)},void 0,W)}bufferEvents(P){const j=[];this.d.push(j);const x=P();return this.d.pop(),j.forEach(W=>W()),x}}t.$mc=v;class y{constructor(){this.d=!1,this.f=l.None,this.g=i.$lb.None,this.h=new M({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(P){this.f=P,this.d&&(this.g.dispose(),this.g=P(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}t.$nc=y}),te(ne[20],ie([0,1,8]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oc=t.CancellationToken=void 0;const _=Object.freeze(function(u,s){const l=setTimeout(u.bind(s),0);return{dispose(){clearTimeout(l)}}});var i;(function(u){function s(l){return l===u.None||l===u.Cancelled||l instanceof o?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}u.isCancellationToken=s,u.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:F.Event.None}),u.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(i||(t.CancellationToken=i={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?_:(this.b||(this.b=new F.$ec),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(s){this.a=void 0,this.b=void 0,this.b=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new o),this.a}cancel(){this.a?this.a instanceof o&&this.a.cancel():this.a=i.Cancelled}dispose(s=!1){s&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof o&&this.a.dispose():this.a=i.None}}t.$oc=L}),te(ne[33],ie([0,1,20]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$id=t.$hd=t.$gd=void 0;class _{constructor(u){this.b=u,this.a=null}get(){if(this.a)return this.a;const u=new F.$oc,s=this.b(u.token);return this.a={promise:s,dispose:()=>{this.a=null,u.cancel(),u.dispose()}},this.a}}t.$gd=_;class i{constructor(u){this.c=u,this.a=void 0,this.b=void 0}get(u){const s=JSON.stringify(u);return this.b!==s&&(this.b=s,this.a=this.c(u)),this.a}}t.$hd=i;class o{get cachedValues(){return this.a}constructor(u){this.b=u,this.a=new Map}get(u){if(this.a.has(u))return this.a.get(u);const s=this.b(u);return this.a.set(u,s),s}}t.$id=o}),te(ne[5],ie([0,1,33,32]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$he=t.$ge=t.$fe=t.$ee=t.GraphemeBreakType=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=t.$Ed=t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=t.$pd=t.$od=t.$nd=t.$md=t.$ld=void 0;function i(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.$ld=i;const o=/{(\d+)}/g;function L(T,...C){return C.length===0?T:T.replace(o,function(Y,Q){const re=parseInt(Q,10);return isNaN(re)||re<0||re>=C.length?Y:C[re]})}t.$md=L;const u=/{([^}]+)}/g;function s(T,C){return T.replace(u,(Y,Q)=>C[Q]??Y)}t.$nd=s;function l(T){return T.replace(/[<>&]/g,function(C){switch(C){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return C}})}t.$od=l;function g(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$pd=g;function E(T,C){let Y=0;const Q=C.charCodeAt(0);for(let re=T.length-1;re>=0;re--)T.charCodeAt(re)===Q&&Y++;return Y}t.$qd=E;function d(T,C,Y="\u2026"){return T.length<=C?T:`${T.substr(0,C)}${Y}`}t.$rd=d;function f(T,C=" "){const Y=e(T,C);return N(Y,C)}t.$sd=f;function e(T,C){if(!T||!C)return T;const Y=C.length;if(Y===0||T.length===0)return T;let Q=0;for(;T.indexOf(C,Q)===Q;)Q=Q+Y;return T.substring(Q)}t.$td=e;function N(T,C){if(!T||!C)return T;const Y=C.length,Q=T.length;if(Y===0||Q===0)return T;let re=Q,fe=-1;for(;fe=T.lastIndexOf(C,re-1),!(fe===-1||fe+Y!==re);){if(fe===0)return"";re=fe}return T.substring(0,re)}t.$ud=N;function p(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$vd=p;function R(T){return T.replace(/\*/g,"")}t.$wd=R;function b(T,C,Y={}){if(!T)throw new Error("Cannot create regex from empty string");C||(T=g(T)),Y.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Q="";return Y.global&&(Q+="g"),Y.matchCase||(Q+="i"),Y.multiline&&(Q+="m"),Y.unicode&&(Q+="u"),new RegExp(T,Q)}t.$xd=b;function M(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.$yd=M;function h(T){return T.split(/\r\n|\r|\n/)}t.$zd=h;function c(T){for(let C=0,Y=T.length;C<Y;C++){const Q=T.charCodeAt(C);if(Q!==32&&Q!==9)return C}return-1}t.$Ad=c;function r(T,C=0,Y=T.length){for(let Q=C;Q<Y;Q++){const re=T.charCodeAt(Q);if(re!==32&&re!==9)return T.substring(C,Q)}return T.substring(C,Y)}t.$Bd=r;function a(T,C=T.length-1){for(let Y=C;Y>=0;Y--){const Q=T.charCodeAt(Y);if(Q!==32&&Q!==9)return Y}return-1}t.$Cd=a;function A(T,C,Y){const Q=[];let re=0;for(const fe of T.matchAll(C)){if(Q.push(T.slice(re,fe.index)),fe.index===void 0)throw new Error("match.index should be defined");re=fe.index+fe[0].length,Q.push(Y(fe[0],...fe.slice(1),fe.index,T,fe.groups))}return Q.push(T.slice(re)),Promise.all(Q).then(fe=>fe.join(""))}t.$Dd=A;function m(T,C){return T<C?-1:T>C?1:0}t.$Ed=m;function $(T,C,Y=0,Q=T.length,re=0,fe=C.length){for(;Y<Q&&re<fe;Y++,re++){const Fe=T.charCodeAt(Y),Pe=C.charCodeAt(re);if(Fe<Pe)return-1;if(Fe>Pe)return 1}const Le=Q-Y,_e=fe-re;return Le<_e?-1:Le>_e?1:0}t.$Fd=$;function w(T,C){return v(T,C,0,T.length,0,C.length)}t.$Gd=w;function v(T,C,Y=0,Q=T.length,re=0,fe=C.length){for(;Y<Q&&re<fe;Y++,re++){let Fe=T.charCodeAt(Y),Pe=C.charCodeAt(re);if(Fe===Pe)continue;if(Fe>=128||Pe>=128)return $(T.toLowerCase(),C.toLowerCase(),Y,Q,re,fe);I(Fe)&&(Fe-=32),I(Pe)&&(Pe-=32);const Ee=Fe-Pe;if(Ee!==0)return Ee}const Le=Q-Y,_e=fe-re;return Le<_e?-1:Le>_e?1:0}t.$Hd=v;function y(T){return T>=48&&T<=57}t.$Id=y;function I(T){return T>=97&&T<=122}t.$Jd=I;function P(T){return T>=65&&T<=90}t.$Kd=P;function j(T,C){return T.length===C.length&&v(T,C)===0}t.$Ld=j;function x(T,C){const Y=C.length;return C.length>T.length?!1:v(T,C,0,Y)===0}t.$Md=x;function W(T,C){const Y=Math.min(T.length,C.length);let Q;for(Q=0;Q<Y;Q++)if(T.charCodeAt(Q)!==C.charCodeAt(Q))return Q;return Y}t.$Nd=W;function G(T,C){const Y=Math.min(T.length,C.length);let Q;const re=T.length-1,fe=C.length-1;for(Q=0;Q<Y;Q++)if(T.charCodeAt(re-Q)!==C.charCodeAt(fe-Q))return Q;return Y}t.$Od=G;function k(T){return 55296<=T&&T<=56319}t.$Pd=k;function q(T){return 56320<=T&&T<=57343}t.$Qd=q;function O(T,C){return(T-55296<<10)+(C-56320)+65536}t.$Rd=O;function B(T,C,Y){const Q=T.charCodeAt(Y);if(k(Q)&&Y+1<C){const re=T.charCodeAt(Y+1);if(q(re))return O(Q,re)}return Q}t.$Sd=B;function X(T,C){const Y=T.charCodeAt(C-1);if(q(Y)&&C>1){const Q=T.charCodeAt(C-2);if(k(Q))return O(Q,Y)}return Y}class n{get offset(){return this.e}constructor(C,Y=0){this.c=C,this.d=C.length,this.e=Y}setOffset(C){this.e=C}prevCodePoint(){const C=X(this.c,this.e);return this.e-=C>=65536?2:1,C}nextCodePoint(){const C=B(this.c,this.d,this.e);return this.e+=C>=65536?2:1,C}eol(){return this.e>=this.d}}t.$Td=n;class K{get offset(){return this.c.offset}constructor(C,Y=0){this.c=new n(C,Y)}nextGraphemeLength(){const C=ye.getInstance(),Y=this.c,Q=Y.offset;let re=C.getGraphemeBreakType(Y.nextCodePoint());for(;!Y.eol();){const fe=Y.offset,Le=C.getGraphemeBreakType(Y.nextCodePoint());if($e(re,Le)){Y.setOffset(fe);break}re=Le}return Y.offset-Q}prevGraphemeLength(){const C=ye.getInstance(),Y=this.c,Q=Y.offset;let re=C.getGraphemeBreakType(Y.prevCodePoint());for(;Y.offset>0;){const fe=Y.offset,Le=C.getGraphemeBreakType(Y.prevCodePoint());if($e(Le,re)){Y.setOffset(fe);break}re=Le}return Q-Y.offset}eol(){return this.c.eol()}}t.$Ud=K;function ee(T,C){return new K(T,C).nextGraphemeLength()}t.$Vd=ee;function ue(T,C){return new K(T,C).prevGraphemeLength()}t.$Wd=ue;function oe(T,C){C>0&&q(T.charCodeAt(C))&&C--;const Y=C+ee(T,C);return[Y-ue(T,Y),Y]}t.$Xd=oe;function ce(T){const C=new K(T);let Y=0;for(;!C.eol();)Y++,C.nextGraphemeLength();return Y}t.$Yd=ce;let he;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Re(T){return he||(he=de()),he.test(T)}t.$Zd=Re;const me=/^[\t\n\r\x20-\x7E]*$/;function ve(T){return me.test(T)}t.$1d=ve,t.$2d=/[\u2028\u2029]/;function Me(T){return t.$2d.test(T)}t.$3d=Me;function Ne(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.$4d=Ne;function pe(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.$5d=pe;function le(T,C){if(T.length<C)return T;const Y=/\b/g;let Q=0;for(;Y.test(T)&&!(T.length-Y.lastIndex<C);)Q=Y.lastIndex,Y.lastIndex+=1;return T.substring(Q).replace(/^\s/,"")}t.$6d=le;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,J=/\x1b\].*?\x07/g;function D(T){return T&&(T=T.replace(Z,"").replace(J,"")),T}t.$7d=D,t.$8d=String.fromCharCode(65279);function S(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.$9d=S;function U(T){return S(T)?T.substr(1):T}t.$0d=U;function V(T,C){if(!T||!C||T.length<C.length)return!1;const Y=C.length,Q=T.toLowerCase();let re=0,fe=-1;for(;re<Y;){const Le=Q.indexOf(C[re],fe+1);if(Le<0)return!1;fe=Le,re++}return!0}t.$$d=V;function H(T,C=!1){return T?(C&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.$_d=H;function se(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.$ae=se;function ae(T,C=1){if(C===0)return"";let Y=-1;do Y=T.indexOf(`
`,Y+1),C--;while(C>0&&Y>=0);return Y===-1?T:(T[Y-1]==="\r"&&Y--,T.substr(0,Y))}t.$be=ae;function ge(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.$ce=ge;function be(T){return ye.getInstance().getGraphemeBreakType(T)}t.$de=be;function $e(T,C){return T===0?C!==5&&C!==7:T===2&&C===3?!1:T===4||T===2||T===3||C===4||C===2||C===3?!0:!(T===8&&(C===8||C===9||C===11||C===12)||(T===11||T===9)&&(C===9||C===10)||(T===12||T===10)&&C===10||C===5||C===13||C===7||T===1||T===13&&C===14||T===6&&C===6)}var Ae;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(t.GraphemeBreakType=Ae={}));class ye{static{this.c=null}static getInstance(){return ye.c||(ye.c=new ye),ye.c}constructor(){this.d=qe()}getGraphemeBreakType(C){if(C<32)return C===10?3:C===13?2:4;if(C<127)return 0;const Y=this.d,Q=Y.length/3;let re=1;for(;re<=Q;)if(C<Y[3*re])re=2*re;else if(C>Y[3*re+1])re=2*re+1;else return Y[3*re+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(T,C){if(T===0)return 0;const Y=We(T,C);if(Y!==void 0)return Y;const Q=new n(C,T);return Q.prevCodePoint(),Q.offset}t.$ee=Ue;function We(T,C){const Y=new n(C,T);let Q=Y.prevCodePoint();for(;Ce(Q)||Q===65039||Q===8419;){if(Y.offset===0)return;Q=Y.prevCodePoint()}if(!pe(Q))return;let re=Y.offset;return re>0&&Y.prevCodePoint()===8205&&(re=Y.offset),re}function Ce(T){return 127995<=T&&T<=127999}var Oe;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),t.$fe="\xA0";class Te{static{this.c=new _.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new F.$hd(C=>{function Y(Ee){const De=new Map;for(let ke=0;ke<Ee.length;ke+=2)De.set(Ee[ke],Ee[ke+1]);return De}function Q(Ee,De){const ke=new Map(Ee);for(const[Se,Be]of De)ke.set(Se,Be);return ke}function re(Ee,De){if(!Ee)return De;const ke=new Map;for(const[Se,Be]of Ee)De.has(Se)&&ke.set(Se,Be);return ke}const fe=this.c.value;let Le=C.filter(Ee=>!Ee.startsWith("_")&&Ee in fe);Le.length===0&&(Le=["_default"]);let _e;for(const Ee of Le){const De=Y(fe[Ee]);_e=re(_e,De)}const Fe=Y(fe._common),Pe=Q(Fe,_e);return new Te(Pe)})}static getInstance(C){return Te.d.get(Array.from(C))}static{this.e=new _.$T(()=>Object.keys(Te.c.value).filter(C=>!C.startsWith("_")))}static getLocales(){return Te.e.value}constructor(C){this.f=C}isAmbiguous(C){return this.f.has(C)}getPrimaryConfusable(C){return this.f.get(C)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$ge=Te;class Ie{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ie.c())),this.d}static isInvisibleCharacter(C){return Ie.e().has(C)}static get codePoints(){return Ie.e()}}t.$he=Ie}),te(ne[34],ie([0,1,5]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.$ii=t.$hi=t.$gi=t.$fi=t.$ei=t.$di=void 0;function _(R){return i(R,0)}t.$di=_;function i(R,b){switch(typeof R){case"object":return R===null?o(349,b):Array.isArray(R)?s(R,b):l(R,b);case"string":return u(R,b);case"boolean":return L(R,b);case"number":return o(R,b);case"undefined":return o(937,b);default:return o(617,b)}}t.$ei=i;function o(R,b){return(b<<5)-b+R|0}t.$fi=o;function L(R,b){return o(R?433:863,b)}function u(R,b){b=o(149417,b);for(let M=0,h=R.length;M<h;M++)b=o(R.charCodeAt(M),b);return b}t.$gi=u;function s(R,b){return b=o(104579,b),R.reduce((M,h)=>i(h,M),b)}function l(R,b){return b=o(181387,b),Object.keys(R).sort().reduce((M,h)=>(M=u(h,M),i(R[h],M)),b)}class g{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=i(b,this.g),this.g}}t.$hi=g;var E;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(R,b,M=32){const h=M-b,c=~((1<<h)-1);return(R<<b|(c&R)>>>h)>>>0}function f(R,b=0,M=R.byteLength,h=0){for(let c=0;c<M;c++)R[b+c]=h}function e(R,b,M="0"){for(;R.length<b;)R=M+R;return R}function N(R,b=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(M=>M.toString(16).padStart(2,"0")).join(""):e((R>>>0).toString(16),b/4)}t.$ii=N;class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const M=b.length;if(M===0)return;const h=this.p;let c=this.r,r=this.u,a,A;for(r!==0?(a=r,A=-1,r=0):(a=b.charCodeAt(0),A=0);;){let m=a;if(F.$Pd(a))if(A+1<M){const $=b.charCodeAt(A+1);F.$Qd($)?(A++,m=F.$Rd(a,$)):m=65533}else{r=a;break}else F.$Qd(a)&&(m=65533);if(c=this.w(h,c,m),A++,A<M)a=b.charCodeAt(A);else break}this.r=c,this.u=r}w(b,M,h){return h<128?b[M++]=h:h<2048?(b[M++]=192|(h&1984)>>>6,b[M++]=128|(h&63)>>>0):h<65536?(b[M++]=224|(h&61440)>>>12,b[M++]=128|(h&4032)>>>6,b[M++]=128|(h&63)>>>0):(b[M++]=240|(h&1835008)>>>18,b[M++]=128|(h&258048)>>>12,b[M++]=128|(h&4032)>>>6,b[M++]=128|(h&63)>>>0),M>=64&&(this.y(),M-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),M}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=p.g,M=this.q;for(let v=0;v<64;v+=4)b.setUint32(v,M.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)b.setUint32(v,d(b.getUint32(v-12,!1)^b.getUint32(v-32,!1)^b.getUint32(v-56,!1)^b.getUint32(v-64,!1),1),!1);let h=this.h,c=this.l,r=this.m,a=this.n,A=this.o,m,$,w;for(let v=0;v<80;v++)v<20?(m=c&r|~c&a,$=1518500249):v<40?(m=c^r^a,$=1859775393):v<60?(m=c&r|c&a|r&a,$=2400959708):(m=c^r^a,$=3395469782),w=d(h,5)+m+A+$+b.getUint32(v*4,!1)&4294967295,A=a,a=r,r=d(c,30),c=h,h=w;this.h=this.h+h&4294967295,this.l=this.l+c&4294967295,this.m=this.m+r&4294967295,this.n=this.n+a&4294967295,this.o=this.o+A&4294967295}}t.$ji=p}),te(ne[21],ie([0,1,30,34]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uu=t.$tu=t.$su=void 0;class i{constructor(d){this.a=d}getElements(){const d=this.a,f=new Int32Array(d.length);for(let e=0,N=d.length;e<N;e++)f[e]=d.charCodeAt(e);return f}}t.$su=i;function o(E,d,f){return new g(new i(E),new i(d)).ComputeDiff(f).changes}t.$tu=o;class L{static Assert(d,f){if(!d)throw new Error(f)}}class u{static Copy(d,f,e,N,p){for(let R=0;R<p;R++)e[N+R]=d[f+R]}static Copy2(d,f,e,N,p){for(let R=0;R<p;R++)e[N+R]=d[f+R]}}var s;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(s||(s={}));class l{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new F.$ru(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(d,f){this.b=Math.min(this.b,d),this.c=Math.min(this.c,f),this.d++}AddModifiedElement(d,f){this.b=Math.min(this.b,d),this.c=Math.min(this.c,f),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(d,f,e=null){this.a=e,this.b=d,this.c=f;const[N,p,R]=g.o(d),[b,M,h]=g.o(f);this.d=R&&h,this.e=N,this.f=p,this.g=b,this.h=M,this.k=[],this.m=[]}static n(d){return d.length>0&&typeof d[0]=="string"}static o(d){const f=d.getElements();if(g.n(f)){const e=new Int32Array(f.length);for(let N=0,p=f.length;N<p;N++)e[N]=(0,_.$gi)(f[N],0);return[f,e,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}p(d,f){return this.f[d]!==this.h[f]?!1:this.d?this.e[d]===this.g[f]:!0}q(d,f){if(!this.p(d,f))return!1;const e=g.r(this.b,d),N=g.r(this.c,f);return e===N}static r(d,f){return typeof d.getStrictElement=="function"?d.getStrictElement(f):null}s(d,f){return this.f[d]!==this.f[f]?!1:this.d?this.e[d]===this.e[f]:!0}u(d,f){return this.h[d]!==this.h[f]?!1:this.d?this.g[d]===this.g[f]:!0}ComputeDiff(d){return this.v(0,this.f.length-1,0,this.h.length-1,d)}v(d,f,e,N,p){const R=[!1];let b=this.w(d,f,e,N,R);return p&&(b=this.z(b)),{quitEarly:R[0],changes:b}}w(d,f,e,N,p){for(p[0]=!1;d<=f&&e<=N&&this.p(d,e);)d++,e++;for(;f>=d&&N>=e&&this.p(f,N);)f--,N--;if(d>f||e>N){let r;return e<=N?(L.Assert(d===f+1,"originalStart should only be one more than originalEnd"),r=[new F.$ru(d,0,e,N-e+1)]):d<=f?(L.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[new F.$ru(d,f-d+1,e,0)]):(L.Assert(d===f+1,"originalStart should only be one more than originalEnd"),L.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const R=[0],b=[0],M=this.y(d,f,e,N,R,b,p),h=R[0],c=b[0];if(M!==null)return M;if(!p[0]){const r=this.w(d,h,e,c,p);let a=[];return p[0]?a=[new F.$ru(h+1,f-(h+1)+1,c+1,N-(c+1)+1)]:a=this.w(h+1,f,c+1,N,p),this.H(r,a)}return[new F.$ru(d,f-d+1,e,N-e+1)]}x(d,f,e,N,p,R,b,M,h,c,r,a,A,m,$,w,v,y){let I=null,P=null,j=new l,x=f,W=e,G=A[0]-w[0]-N,k=-1073741824,q=this.k.length-1;do{const O=G+d;O===x||O<W&&h[O-1]<h[O+1]?(r=h[O+1],m=r-G-N,r<k&&j.MarkNextChange(),k=r,j.AddModifiedElement(r+1,m),G=O+1-d):(r=h[O-1]+1,m=r-G-N,r<k&&j.MarkNextChange(),k=r-1,j.AddOriginalElement(r,m+1),G=O-1-d),q>=0&&(h=this.k[q],d=h[0],x=1,W=h.length-1)}while(--q>=-1);if(I=j.getReverseChanges(),y[0]){let O=A[0]+1,B=w[0]+1;if(I!==null&&I.length>0){const X=I[I.length-1];O=Math.max(O,X.getOriginalEnd()),B=Math.max(B,X.getModifiedEnd())}P=[new F.$ru(O,a-O+1,B,$-B+1)]}else{j=new l,x=R,W=b,G=A[0]-w[0]-M,k=1073741824,q=v?this.m.length-1:this.m.length-2;do{const O=G+p;O===x||O<W&&c[O-1]>=c[O+1]?(r=c[O+1]-1,m=r-G-M,r>k&&j.MarkNextChange(),k=r+1,j.AddOriginalElement(r+1,m+1),G=O+1-p):(r=c[O-1],m=r-G-M,r>k&&j.MarkNextChange(),k=r,j.AddModifiedElement(r+1,m+1),G=O-1-p),q>=0&&(c=this.m[q],p=c[0],x=1,W=c.length-1)}while(--q>=-1);P=j.getChanges()}return this.H(I,P)}y(d,f,e,N,p,R,b){let M=0,h=0,c=0,r=0,a=0,A=0;d--,e--,p[0]=0,R[0]=0,this.k=[],this.m=[];const m=f-d+(N-e),$=m+1,w=new Int32Array($),v=new Int32Array($),y=N-e,I=f-d,P=d-e,j=f-N,W=(I-y)%2===0;w[y]=d,v[I]=f,b[0]=!1;for(let G=1;G<=m/2+1;G++){let k=0,q=0;c=this.J(y-G,G,y,$),r=this.J(y+G,G,y,$);for(let B=c;B<=r;B+=2){B===c||B<r&&w[B-1]<w[B+1]?M=w[B+1]:M=w[B-1]+1,h=M-(B-y)-P;const X=M;for(;M<f&&h<N&&this.p(M+1,h+1);)M++,h++;if(w[B]=M,M+h>k+q&&(k=M,q=h),!W&&Math.abs(B-I)<=G-1&&M>=v[B])return p[0]=M,R[0]=h,X<=v[B]&&1447>0&&G<=1447+1?this.x(y,c,r,P,I,a,A,j,w,v,M,f,p,h,N,R,W,b):null}const O=(k-d+(q-e)-G)/2;if(this.a!==null&&!this.a(k,O))return b[0]=!0,p[0]=k,R[0]=q,O>0&&1447>0&&G<=1447+1?this.x(y,c,r,P,I,a,A,j,w,v,M,f,p,h,N,R,W,b):(d++,e++,[new F.$ru(d,f-d+1,e,N-e+1)]);a=this.J(I-G,G,I,$),A=this.J(I+G,G,I,$);for(let B=a;B<=A;B+=2){B===a||B<A&&v[B-1]>=v[B+1]?M=v[B+1]-1:M=v[B-1],h=M-(B-I)-j;const X=M;for(;M>d&&h>e&&this.p(M,h);)M--,h--;if(v[B]=M,W&&Math.abs(B-y)<=G&&M<=w[B])return p[0]=M,R[0]=h,X>=w[B]&&1447>0&&G<=1447+1?this.x(y,c,r,P,I,a,A,j,w,v,M,f,p,h,N,R,W,b):null}if(G<=1447){let B=new Int32Array(r-c+2);B[0]=y-c+1,u.Copy2(w,c,B,1,r-c+1),this.k.push(B),B=new Int32Array(A-a+2),B[0]=I-a+1,u.Copy2(v,a,B,1,A-a+1),this.m.push(B)}}return this.x(y,c,r,P,I,a,A,j,w,v,M,f,p,h,N,R,W,b)}z(d){for(let f=0;f<d.length;f++){const e=d[f],N=f<d.length-1?d[f+1].originalStart:this.f.length,p=f<d.length-1?d[f+1].modifiedStart:this.h.length,R=e.originalLength>0,b=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<p&&(!R||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!b||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const h=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!h)break;e.originalStart++,e.modifiedStart++}const M=[null];if(f<d.length-1&&this.I(d[f],d[f+1],M)){d[f]=M[0],d.splice(f+1,1),f--;continue}}for(let f=d.length-1;f>=0;f--){const e=d[f];let N=0,p=0;if(f>0){const r=d[f-1];N=r.originalStart+r.originalLength,p=r.modifiedStart+r.modifiedLength}const R=e.originalLength>0,b=e.modifiedLength>0;let M=0,h=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const a=e.originalStart-r,A=e.modifiedStart-r;if(a<N||A<p||R&&!this.s(a,a+e.originalLength)||b&&!this.u(A,A+e.modifiedLength))break;const $=(a===N&&A===p?5:0)+this.G(a,e.originalLength,A,e.modifiedLength);$>h&&(h=$,M=r)}e.originalStart-=M,e.modifiedStart-=M;const c=[null];if(f>0&&this.I(d[f-1],d[f],c)){d[f-1]=c[0],d.splice(f,1),f++;continue}}if(this.d)for(let f=1,e=d.length;f<e;f++){const N=d[f-1],p=d[f],R=p.originalStart-N.originalStart-N.originalLength,b=N.originalStart,M=p.originalStart+p.originalLength,h=M-b,c=N.modifiedStart,r=p.modifiedStart+p.modifiedLength,a=r-c;if(R<5&&h<20&&a<20){const A=this.A(b,h,c,a,R);if(A){const[m,$]=A;(m!==N.originalStart+N.originalLength||$!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=m-N.originalStart,N.modifiedLength=$-N.modifiedStart,p.originalStart=m+R,p.modifiedStart=$+R,p.originalLength=M-p.originalStart,p.modifiedLength=r-p.modifiedStart)}}}return d}A(d,f,e,N,p){if(f<p||N<p)return null;const R=d+f-p+1,b=e+N-p+1;let M=0,h=0,c=0;for(let r=d;r<R;r++)for(let a=e;a<b;a++){const A=this.B(r,a,p);A>0&&A>M&&(M=A,h=r,c=a)}return M>0?[h,c]:null}B(d,f,e){let N=0;for(let p=0;p<e;p++){if(!this.p(d+p,f+p))return 0;N+=this.e[d+p].length}return N}C(d){return d<=0||d>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[d])}D(d,f){if(this.C(d)||this.C(d-1))return!0;if(f>0){const e=d+f;if(this.C(e-1)||this.C(e))return!0}return!1}E(d){return d<=0||d>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[d])}F(d,f){if(this.E(d)||this.E(d-1))return!0;if(f>0){const e=d+f;if(this.E(e-1)||this.E(e))return!0}return!1}G(d,f,e,N){const p=this.D(d,f)?1:0,R=this.F(e,N)?1:0;return p+R}H(d,f){const e=[];if(d.length===0||f.length===0)return f.length>0?f:d;if(this.I(d[d.length-1],f[0],e)){const N=new Array(d.length+f.length-1);return u.Copy(d,0,N,0,d.length-1),N[d.length-1]=e[0],u.Copy(f,1,N,d.length,f.length-1),N}else{const N=new Array(d.length+f.length);return u.Copy(d,0,N,0,d.length),u.Copy(f,0,N,d.length,f.length),N}}I(d,f,e){if(L.Assert(d.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),L.Assert(d.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=f.originalStart||d.modifiedStart+d.modifiedLength>=f.modifiedStart){const N=d.originalStart;let p=d.originalLength;const R=d.modifiedStart;let b=d.modifiedLength;return d.originalStart+d.originalLength>=f.originalStart&&(p=f.originalStart+f.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=f.modifiedStart&&(b=f.modifiedStart+f.modifiedLength-d.modifiedStart),e[0]=new F.$ru(N,p,R,b),!0}else return e[0]=null,!1}J(d,f,e,N){if(d>=0&&d<N)return d;const p=e,R=N-e-1,b=f%2===0;if(d<0){const M=p%2===0;return b===M?0:1}else{const M=R%2===0;return b===M?N-1:N-2}}}t.$uu=g}),te(ne[22],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=void 0;function F(c){return typeof c=="string"}t.$ie=F;function _(c){return Array.isArray(c)&&c.every(r=>F(r))}t.$je=_;function i(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$ke=i;function o(c){const r=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof r}t.$le=o;function L(c){return typeof c=="number"&&!isNaN(c)}t.$me=L;function u(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$ne=u;function s(c){return c===!0||c===!1}t.$oe=s;function l(c){return typeof c>"u"}t.$pe=l;function g(c){return!E(c)}t.$qe=g;function E(c){return l(c)||c===null}t.$re=E;function d(c,r){if(!c)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}t.$se=d;function f(c){if(E(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$te=f;function e(...c){const r=[];for(let a=0;a<c.length;a++){const A=c[a];if(E(A))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);r.push(A)}return r}t.$ue=e;const N=Object.prototype.hasOwnProperty;function p(c){if(!i(c))return!1;for(const r in c)if(N.call(c,r))return!1;return!0}t.$ve=p;function R(c){return typeof c=="function"}t.$we=R;function b(...c){return c.length>0&&c.every(R)}t.$xe=b;function M(c,r){const a=Math.min(c.length,r.length);for(let A=0;A<a;A++)h(c[A],r[A])}t.$ye=M;function h(c,r){if(F(r)){if(typeof c!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(R(r)){try{if(c instanceof r)return}catch{}if(!E(c)&&c.constructor===r||r.length===1&&r.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$ze=h}),te(ne[35],ie([0,1,22]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=t.$Bj=t.$Aj=void 0;const _=Object.create(null);function i(u,s){if((0,F.$ie)(s)){const l=_[s];if(l===void 0)throw new Error(`${u} references an unknown codicon: ${s}`);s=l}return _[u]=s,{id:u}}function o(){return _}t.$Aj=o;function L(){return Object.values(t.$Cj)}t.$Bj=L,t.$Cj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),te(ne[11],ie([0,1,22]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tm=t.$Sm=t.$Rm=t.$Qm=t.$Pm=t.$Om=t.$Nm=t.$Mm=t.$Lm=t.$Km=t.$Jm=t.$Im=void 0;function _(R){if(!R||typeof R!="object"||R instanceof RegExp)return R;const b=Array.isArray(R)?[]:{};return Object.entries(R).forEach(([M,h])=>{b[M]=h&&typeof h=="object"?_(h):h}),b}t.$Im=_;function i(R){if(!R||typeof R!="object")return R;const b=[R];for(;b.length>0;){const M=b.shift();Object.freeze(M);for(const h in M)if(o.call(M,h)){const c=M[h];typeof c=="object"&&!Object.isFrozen(c)&&!(0,F.$le)(c)&&b.push(c)}}return R}t.$Jm=i;const o=Object.prototype.hasOwnProperty;function L(R,b){return u(R,b,new Set)}t.$Km=L;function u(R,b,M){if((0,F.$re)(R))return R;const h=b(R);if(typeof h<"u")return h;if(Array.isArray(R)){const c=[];for(const r of R)c.push(u(r,b,M));return c}if((0,F.$ke)(R)){if(M.has(R))throw new Error("Cannot clone recursive data-structure");M.add(R);const c={};for(const r in R)o.call(R,r)&&(c[r]=u(R[r],b,M));return M.delete(R),c}return R}function s(R,b,M=!0){return(0,F.$ke)(R)?((0,F.$ke)(b)&&Object.keys(b).forEach(h=>{h in R?M&&((0,F.$ke)(R[h])&&(0,F.$ke)(b[h])?s(R[h],b[h],M):R[h]=b[h]):R[h]=b[h]}),R):b}t.$Lm=s;function l(R,b){if(R===b)return!0;if(R==null||b===null||b===void 0||typeof R!=typeof b||typeof R!="object"||Array.isArray(R)!==Array.isArray(b))return!1;let M,h;if(Array.isArray(R)){if(R.length!==b.length)return!1;for(M=0;M<R.length;M++)if(!l(R[M],b[M]))return!1}else{const c=[];for(h in R)c.push(h);c.sort();const r=[];for(h in b)r.push(h);if(r.sort(),!l(c,r))return!1;for(M=0;M<c.length;M++)if(!l(R[c[M]],b[c[M]]))return!1}return!0}t.$Mm=l;function g(R){const b=new Set;return JSON.stringify(R,(M,h)=>{if((0,F.$ke)(h)||Array.isArray(h)){if(b.has(h))return"[Circular]";b.add(h)}return h})}t.$Nm=g;function E(R,b){const M=Object.create(null);return!R||!b||Object.keys(b).forEach(c=>{const r=R[c],a=b[c];l(r,a)||(M[c]=a)}),M}t.$Om=E;function d(R,b){const M=b.toLowerCase(),h=Object.keys(R).find(c=>c.toLowerCase()===M);return h?R[h]:R[b]}t.$Pm=d;function f(R,b){const M=Object.create(null);for(const[h,c]of Object.entries(R))b(h,c)&&(M[h]=c);return M}t.$Qm=f;function e(R){let b=[];for(;Object.prototype!==R;)b=b.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return b}t.$Rm=e;function N(R){const b=[];for(const M of e(R))typeof R[M]=="function"&&b.push(M);return b}t.$Sm=N;function p(R,b){const M=c=>function(){const r=Array.prototype.slice.call(arguments,0);return b(c,r)},h={};for(const c of R)h[c]=M(c);return h}t.$Tm=p}),te(ne[23],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kd=t.$jd=t.Constants=void 0;var F;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(F||(t.Constants=F={}));function _(o){return o<0?0:o>255?255:o|0}t.$jd=_;function i(o){return o<0?0:o>4294967295?4294967295:o|0}t.$kd=i}),te(ne[24],ie([0,1,23]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0r=t.$9r=void 0;class _{constructor(u){const s=(0,F.$jd)(u);this.c=s,this.a=_.d(s),this.b=new Map}static d(u){const s=new Uint8Array(256);return s.fill(u),s}set(u,s){const l=(0,F.$jd)(s);u>=0&&u<256?this.a[u]=l:this.b.set(u,l)}get(u){return u>=0&&u<256?this.a[u]:this.b.get(u)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$9r=_;var i;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(i||(i={}));class o{constructor(){this.a=new _(0)}add(u){this.a.set(u,1)}has(u){return this.a.get(u)===1}clear(){return this.a.clear()}}t.$0r=o}),te(ne[6],ie([0,1,3]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sr=t.$Rr=void 0;class _{static addRange(L,u){let s=0;for(;s<u.length&&u[s].endExclusive<L.start;)s++;let l=s;for(;l<u.length&&u[l].start<=L.endExclusive;)l++;if(s===l)u.splice(s,0,L);else{const g=Math.min(L.start,u[s].start),E=Math.max(L.endExclusive,u[l-1].endExclusive);u.splice(s,l-s,new _(g,E))}}static tryCreate(L,u){if(!(L>u))return new _(L,u)}static ofLength(L){return new _(0,L)}constructor(L,u){if(this.start=L,this.endExclusive=u,L>u)throw new F.$bb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(L){return new _(this.start+L,this.endExclusive+L)}deltaStart(L){return new _(this.start+L,this.endExclusive)}deltaEnd(L){return new _(this.start,this.endExclusive+L)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(L){return this.start===L.start&&this.endExclusive===L.endExclusive}containsRange(L){return this.start<=L.start&&L.endExclusive<=this.endExclusive}contains(L){return this.start<=L&&L<this.endExclusive}join(L){return new _(Math.min(this.start,L.start),Math.max(this.endExclusive,L.endExclusive))}intersect(L){const u=Math.max(this.start,L.start),s=Math.min(this.endExclusive,L.endExclusive);if(u<=s)return new _(u,s)}slice(L){return L.slice(this.start,this.endExclusive)}clip(L){if(this.isEmpty)throw new F.$bb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,L))}clipCyclic(L){if(this.isEmpty)throw new F.$bb(`Invalid clipping range: ${this.toString()}`);return L<this.start?this.endExclusive-(this.start-L)%this.length:L>=this.endExclusive?this.start+(L-this.start)%this.length:L}}t.$Rr=_;class i{constructor(){this.a=[]}addRange(L){let u=0;for(;u<this.a.length&&this.a[u].endExclusive<L.start;)u++;let s=u;for(;s<this.a.length&&this.a[s].start<=L.endExclusive;)s++;if(u===s)this.a.splice(u,0,L);else{const l=Math.min(L.start,this.a[u].start),g=Math.max(L.endExclusive,this.a[s-1].endExclusive);this.a.splice(u,s-u,new _(l,g))}}toString(){return this.a.map(L=>L.toString()).join(", ")}intersectsStrict(L){let u=0;for(;u<this.a.length&&this.a[u].endExclusive<=L.start;)u++;return u<this.a.length&&this.a[u].start<L.endExclusive}intersectWithRange(L){const u=new i;for(const s of this.a){const l=s.intersect(L);l&&u.addRange(l)}return u}intersectWithRangeLength(L){return this.intersectWithRange(L).length}get length(){return this.a.reduce((L,u)=>L+u.length,0)}}t.$Sr=i}),te(ne[4],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tr=void 0;class F{constructor(i,o){this.lineNumber=i,this.column=o}with(i=this.lineNumber,o=this.column){return i===this.lineNumber&&o===this.column?this:new F(i,o)}delta(i=0,o=0){return this.with(this.lineNumber+i,this.column+o)}equals(i){return F.equals(this,i)}static equals(i,o){return!i&&!o?!0:!!i&&!!o&&i.lineNumber===o.lineNumber&&i.column===o.column}isBefore(i){return F.isBefore(this,i)}static isBefore(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<o.column}isBeforeOrEqual(i){return F.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<=o.column}static compare(i,o){const L=i.lineNumber|0,u=o.lineNumber|0;if(L===u){const s=i.column|0,l=o.column|0;return s-l}return L-u}clone(){return new F(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new F(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.$Tr=F}),te(ne[2],ie([0,1,4]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ur=void 0;class _{constructor(o,L,u,s){o>u||o===u&&L>s?(this.startLineNumber=u,this.startColumn=s,this.endLineNumber=o,this.endColumn=L):(this.startLineNumber=o,this.startColumn=L,this.endLineNumber=u,this.endColumn=s)}isEmpty(){return _.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return _.containsPosition(this,o)}static containsPosition(o,L){return!(L.lineNumber<o.startLineNumber||L.lineNumber>o.endLineNumber||L.lineNumber===o.startLineNumber&&L.column<o.startColumn||L.lineNumber===o.endLineNumber&&L.column>o.endColumn)}static strictContainsPosition(o,L){return!(L.lineNumber<o.startLineNumber||L.lineNumber>o.endLineNumber||L.lineNumber===o.startLineNumber&&L.column<=o.startColumn||L.lineNumber===o.endLineNumber&&L.column>=o.endColumn)}containsRange(o){return _.containsRange(this,o)}static containsRange(o,L){return!(L.startLineNumber<o.startLineNumber||L.endLineNumber<o.startLineNumber||L.startLineNumber>o.endLineNumber||L.endLineNumber>o.endLineNumber||L.startLineNumber===o.startLineNumber&&L.startColumn<o.startColumn||L.endLineNumber===o.endLineNumber&&L.endColumn>o.endColumn)}strictContainsRange(o){return _.strictContainsRange(this,o)}static strictContainsRange(o,L){return!(L.startLineNumber<o.startLineNumber||L.endLineNumber<o.startLineNumber||L.startLineNumber>o.endLineNumber||L.endLineNumber>o.endLineNumber||L.startLineNumber===o.startLineNumber&&L.startColumn<=o.startColumn||L.endLineNumber===o.endLineNumber&&L.endColumn>=o.endColumn)}plusRange(o){return _.plusRange(this,o)}static plusRange(o,L){let u,s,l,g;return L.startLineNumber<o.startLineNumber?(u=L.startLineNumber,s=L.startColumn):L.startLineNumber===o.startLineNumber?(u=L.startLineNumber,s=Math.min(L.startColumn,o.startColumn)):(u=o.startLineNumber,s=o.startColumn),L.endLineNumber>o.endLineNumber?(l=L.endLineNumber,g=L.endColumn):L.endLineNumber===o.endLineNumber?(l=L.endLineNumber,g=Math.max(L.endColumn,o.endColumn)):(l=o.endLineNumber,g=o.endColumn),new _(u,s,l,g)}intersectRanges(o){return _.intersectRanges(this,o)}static intersectRanges(o,L){let u=o.startLineNumber,s=o.startColumn,l=o.endLineNumber,g=o.endColumn;const E=L.startLineNumber,d=L.startColumn,f=L.endLineNumber,e=L.endColumn;return u<E?(u=E,s=d):u===E&&(s=Math.max(s,d)),l>f?(l=f,g=e):l===f&&(g=Math.min(g,e)),u>l||u===l&&s>g?null:new _(u,s,l,g)}equalsRange(o){return _.equalsRange(this,o)}static equalsRange(o,L){return!o&&!L?!0:!!o&&!!L&&o.startLineNumber===L.startLineNumber&&o.startColumn===L.startColumn&&o.endLineNumber===L.endLineNumber&&o.endColumn===L.endColumn}getEndPosition(){return _.getEndPosition(this)}static getEndPosition(o){return new F.$Tr(o.endLineNumber,o.endColumn)}getStartPosition(){return _.getStartPosition(this)}static getStartPosition(o){return new F.$Tr(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,L){return new _(this.startLineNumber,this.startColumn,o,L)}setStartPosition(o,L){return new _(o,L,this.endLineNumber,this.endColumn)}collapseToStart(){return _.collapseToStart(this)}static collapseToStart(o){return new _(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return _.collapseToEnd(this)}static collapseToEnd(o){return new _(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new _(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,L=o){return new _(o.lineNumber,o.column,L.lineNumber,L.column)}static lift(o){return o?new _(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,L){return!(o.endLineNumber<L.startLineNumber||o.endLineNumber===L.startLineNumber&&o.endColumn<L.startColumn||L.endLineNumber<o.startLineNumber||L.endLineNumber===o.startLineNumber&&L.endColumn<o.startColumn)}static areIntersecting(o,L){return!(o.endLineNumber<L.startLineNumber||o.endLineNumber===L.startLineNumber&&o.endColumn<=L.startColumn||L.endLineNumber<o.startLineNumber||L.endLineNumber===o.startLineNumber&&L.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,L){if(o&&L){const l=o.startLineNumber|0,g=L.startLineNumber|0;if(l===g){const E=o.startColumn|0,d=L.startColumn|0;if(E===d){const f=o.endLineNumber|0,e=L.endLineNumber|0;if(f===e){const N=o.endColumn|0,p=L.endColumn|0;return N-p}return f-e}return E-d}return l-g}return(o?1:0)-(L?1:0)}static compareRangesUsingEnds(o,L){return o.endLineNumber===L.endLineNumber?o.endColumn===L.endColumn?o.startLineNumber===L.startLineNumber?o.startColumn-L.startColumn:o.startLineNumber-L.startLineNumber:o.endColumn-L.endColumn:o.endLineNumber-L.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$Ur=_}),te(ne[36],ie([0,1,2]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2r=void 0;class _{static insert(o,L){return{range:new F.$Ur(o.lineNumber,o.column,o.lineNumber,o.column),text:L,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,L){return{range:o,text:L}}static replaceMove(o,L){return{range:o,text:L,forceMoveMarkers:!0}}}t.$2r=_}),te(ne[12],ie([0,1,3,6,2]),function(z,t,F,_,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vr=void 0;class o{static fromRange(u){return new o(u.startLineNumber,u.endLineNumber)}static subtract(u,s){return s?u.startLineNumber<s.startLineNumber&&s.endLineNumberExclusive<u.endLineNumberExclusive?[new o(u.startLineNumber,s.startLineNumber),new o(s.endLineNumberExclusive,u.endLineNumberExclusive)]:s.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=s.endLineNumberExclusive?[]:s.endLineNumberExclusive<u.endLineNumberExclusive?[new o(Math.max(s.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new o(u.startLineNumber,Math.min(s.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let s=u[0];for(let l=1;l<u.length;l++)s=this.join(s,u[l]);return s}static join(u,s){if(u.length===0)return s;if(s.length===0)return u;const l=[];let g=0,E=0,d=null;for(;g<u.length||E<s.length;){let f=null;if(g<u.length&&E<s.length){const e=u[g],N=s[E];e.startLineNumber<N.startLineNumber?(f=e,g++):(f=N,E++)}else g<u.length?(f=u[g],g++):(f=s[E],E++);d===null?d=f:d.endLineNumberExclusive>=f.startLineNumber?d=new o(d.startLineNumber,Math.max(d.endLineNumberExclusive,f.endLineNumberExclusive)):(l.push(d),d=f)}return d!==null&&l.push(d),l}static ofLength(u,s){return new o(u,u+s)}static deserialize(u){return new o(u[0],u[1])}constructor(u,s){if(u>s)throw new F.$bb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${s}`);this.startLineNumber=u,this.endLineNumberExclusive=s}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new o(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new o(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new o(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const s=Math.max(this.startLineNumber,u.startLineNumber),l=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(s<=l)return new o(s,l)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.$Ur(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.$Ur(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const s=[];for(let l=this.startLineNumber;l<this.endLineNumberExclusive;l++)s.push(u(l));return s}forEach(u){for(let s=this.startLineNumber;s<this.endLineNumberExclusive;s++)u(s)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new _.$Rr(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Vr=o}),te(ne[37],ie([0,1,4,2]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3r=t.SelectionDirection=void 0;var i;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class o extends _.$Ur{constructor(u,s,l,g){super(u,s,l,g),this.selectionStartLineNumber=u,this.selectionStartColumn=s,this.positionLineNumber=l,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(u){return o.selectionsEqual(this,u)}static selectionsEqual(u,s){return u.selectionStartLineNumber===s.selectionStartLineNumber&&u.selectionStartColumn===s.selectionStartColumn&&u.positionLineNumber===s.positionLineNumber&&u.positionColumn===s.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(u,s){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,u,s):new o(u,s,this.startLineNumber,this.startColumn)}getPosition(){return new F.$Tr(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new F.$Tr(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(u,s){return this.getDirection()===0?new o(u,s,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,u,s)}static fromPositions(u,s=u){return new o(u.lineNumber,u.column,s.lineNumber,s.column)}static fromRange(u,s){return s===0?new o(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):new o(u.endLineNumber,u.endColumn,u.startLineNumber,u.startColumn)}static liftSelection(u){return new o(u.selectionStartLineNumber,u.selectionStartColumn,u.positionLineNumber,u.positionColumn)}static selectionsArrEqual(u,s){if(u&&!s||!u&&s)return!1;if(!u&&!s)return!0;if(u.length!==s.length)return!1;for(let l=0,g=u.length;l<g;l++)if(!this.selectionsEqual(u[l],s[l]))return!1;return!0}static isISelection(u){return u&&typeof u.selectionStartLineNumber=="number"&&typeof u.selectionStartColumn=="number"&&typeof u.positionLineNumber=="number"&&typeof u.positionColumn=="number"}static createWithDirection(u,s,l,g,E){return E===0?new o(u,s,l,g):new o(l,g,u,s)}}t.$3r=o}),te(ne[38],ie([0,1,24]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_r=t.$$r=t.WordCharacterClass=void 0;var _;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(_||(t.WordCharacterClass=_={}));class i extends F.$9r{constructor(u){super(0);for(let s=0,l=u.length;s<l;s++)this.set(u.charCodeAt(s),2);this.set(32,1),this.set(9,1)}}t.$$r=i;function o(L){const u={};return s=>(u.hasOwnProperty(s)||(u[s]=L(s)),u[s])}t.$_r=o(L=>new i(L))}),te(ne[25],ie([0,1,17,7,18]),function(z,t,F,_,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qr=t.$Pr=t.$Or=t.$Nr=t.$Mr=void 0,t.$Mr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(E=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const f of t.$Mr)E.indexOf(f)>=0||(d+="\\"+f);return d+="\\s]+)",new RegExp(d,"g")}t.$Nr=o();function L(E){let d=t.$Nr;if(E&&E instanceof RegExp)if(E.global)d=E;else{let f="g";E.ignoreCase&&(f+="i"),E.multiline&&(f+="m"),E.unicode&&(f+="u"),d=new RegExp(E.source,f)}return d.lastIndex=0,d}t.$Or=L;const u=new i.$ub;u.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function s(E){const d=u.unshift(E);return(0,_.$jb)(d)}t.$Pr=s;function l(E,d,f,e,N){if(N||(N=F.Iterable.first(u)),f.length>N.maxLen){let h=E-N.maxLen/2;return h<0?h=0:e+=h,f=f.substring(h,E+N.maxLen/2),l(E,d,f,e,N)}const p=Date.now(),R=E-1-e;let b=-1,M=null;for(let h=1;!(Date.now()-p>=N.timeBudget);h++){const c=R-N.windowSize*h;d.lastIndex=Math.max(0,c);const r=g(d,f,R,b);if(!r&&M||(M=r,c<=0))break;b=c}if(M){const h={word:M[0],startColumn:e+1+M.index,endColumn:e+1+M.index+M[0].length};return d.lastIndex=0,h}return null}t.$Qr=l;function g(E,d,f,e){let N;for(;N=E.exec(d);){const p=N.index||0;if(p<=f&&E.lastIndex>=f)return N;if(e>0&&p>e)return null}return null}}),te(ne[9],ie([0,1,3,6]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nY=t.$mY=t.$lY=t.$kY=void 0;class i{static trivial(l,g){return new i([new o(new _.$Rr(0,l.length),new _.$Rr(0,g.length))],!1)}static trivialTimedOut(l,g){return new i([new o(new _.$Rr(0,l.length),new _.$Rr(0,g.length))],!0)}constructor(l,g){this.diffs=l,this.hitTimeout=g}}t.$kY=i;class o{constructor(l,g){this.seq1Range=l,this.seq2Range=g}reverse(){return new o(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(l){return new o(this.seq1Range.join(l.seq1Range),this.seq2Range.join(l.seq2Range))}delta(l){return l===0?this:new o(this.seq1Range.delta(l),this.seq2Range.delta(l))}}t.$lY=o;class L{static{this.instance=new L}isValid(){return!0}}t.$mY=L;class u{constructor(l){if(this.c=l,this.a=Date.now(),this.b=!0,l<=0)throw new F.$bb("timeout must be positive")}isValid(){if(!(Date.now()-this.a<this.c)&&this.b){this.b=!1;debugger}return this.b}disable(){this.c=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.b=!0}}t.$nY=u}),te(ne[39],ie([0,1,6,9]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vY=t.$uY=t.$tY=t.$sY=t.$rY=t.$qY=void 0;function i(E,d,f){let e=f;return e=s(E,d,e),e=l(E,d,e),e}t.$qY=i;function o(E,d,f){const e=[];for(const N of f){const p=e[e.length-1];if(!p){e.push(N);continue}N.seq1Range.start-p.seq1Range.endExclusive<=2||N.seq2Range.start-p.seq2Range.endExclusive<=2?e[e.length-1]=new _.$lY(p.seq1Range.join(N.seq1Range),p.seq2Range.join(N.seq2Range)):e.push(N)}return e}t.$rY=o;function L(E,d,f){let e=f;if(e.length===0)return e;let N=0,p;do{p=!1;const R=[e[0]];for(let b=1;b<e.length;b++){let c=function(a,A){const m=new F.$Rr(h.seq1Range.endExclusive,M.seq1Range.start);return E.getText(m).replace(/\s/g,"").length<=4&&(a.seq1Range.length+a.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const M=e[b],h=R[R.length-1];c(h,M)?(p=!0,R[R.length-1]=R[R.length-1].join(M)):R.push(M)}e=R}while(N++<10&&p);return e}t.$sY=L;function u(E,d,f){let e=f;if(e.length===0)return e;let N=0,p;do{p=!1;const R=[e[0]];for(let b=1;b<e.length;b++){let c=function(a,A){const m=new F.$Rr(h.seq1Range.endExclusive,M.seq1Range.start);if(E.countLinesIn(m)>5||m.length>500)return!1;const w=E.getText(m).trim();if(w.length>20||w.split(/\r\n|\r|\n/).length>1)return!1;const v=E.countLinesIn(a.seq1Range),y=a.seq1Range.length,I=d.countLinesIn(a.seq2Range),P=a.seq2Range.length,j=E.countLinesIn(A.seq1Range),x=A.seq1Range.length,W=d.countLinesIn(A.seq2Range),G=A.seq2Range.length,k=2*40+50;function q(O){return Math.min(O,k)}return Math.pow(Math.pow(q(v*40+y),1.5)+Math.pow(q(I*40+P),1.5),1.5)+Math.pow(Math.pow(q(j*40+x),1.5)+Math.pow(q(W*40+G),1.5),1.5)>(k**1.5)**1.5*1.3};const M=e[b],h=R[R.length-1];c(h,M)?(p=!0,R[R.length-1]=R[R.length-1].join(M)):R.push(M)}e=R}while(N++<10&&p);for(let R=0;R<e.length;R++){const b=e[R];let M=b.seq1Range,h=b.seq2Range;const c=E.extendToFullLines(b.seq1Range),r=E.getText(new F.$Rr(c.start,b.seq1Range.start));r.length>0&&r.trim().length<=3&&b.seq1Range.length+b.seq2Range.length>100&&(M=b.seq1Range.deltaStart(-r.length),h=b.seq2Range.deltaStart(-r.length));const a=E.getText(new F.$Rr(b.seq1Range.endExclusive,c.endExclusive));a.length>0&&a.trim().length<=3&&b.seq1Range.length+b.seq2Range.length>150&&(M=M.deltaEnd(a.length),h=h.deltaEnd(a.length)),e[R]=new _.$lY(M,h)}return e}t.$tY=u;function s(E,d,f){if(f.length===0)return f;const e=[];e.push(f[0]);for(let p=1;p<f.length;p++){const R=e[e.length-1];let b=f[p];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const M=b.seq1Range.start-R.seq1Range.endExclusive;let h;for(h=1;h<=M&&!(E.getElement(b.seq1Range.start-h)!==E.getElement(b.seq1Range.endExclusive-h)||d.getElement(b.seq2Range.start-h)!==d.getElement(b.seq2Range.endExclusive-h));h++);if(h--,h===M){e[e.length-1]=new _.$lY(new F.$Rr(R.seq1Range.start,b.seq1Range.endExclusive-M),new F.$Rr(R.seq2Range.start,b.seq2Range.endExclusive-M));continue}b=b.delta(-h)}e.push(b)}const N=[];for(let p=0;p<e.length-1;p++){const R=e[p+1];let b=e[p];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const M=R.seq1Range.start-b.seq1Range.endExclusive;let h;for(h=0;h<M&&!(E.getElement(b.seq1Range.start+h)!==E.getElement(b.seq1Range.endExclusive+h)||d.getElement(b.seq2Range.start+h)!==d.getElement(b.seq2Range.endExclusive+h));h++);if(h===M){e[p+1]=new _.$lY(new F.$Rr(b.seq1Range.start+M,R.seq1Range.endExclusive),new F.$Rr(b.seq2Range.start+M,R.seq2Range.endExclusive));continue}h>0&&(b=b.delta(h))}N.push(b)}return e.length>0&&N.push(e[e.length-1]),N}t.$uY=s;function l(E,d,f){if(!E.getBoundaryScore||!d.getBoundaryScore)return f;for(let e=0;e<f.length;e++){const N=e>0?f[e-1]:void 0,p=f[e],R=e+1<f.length?f[e+1]:void 0,b=new F.$Rr(N?N.seq1Range.start+1:0,R?R.seq1Range.endExclusive-1:E.length),M=new F.$Rr(N?N.seq2Range.start+1:0,R?R.seq2Range.endExclusive-1:d.length);p.seq1Range.isEmpty?f[e]=g(p,E,d,b,M):p.seq2Range.isEmpty&&(f[e]=g(p.reverse(),d,E,M,b).reverse())}return f}t.$vY=l;function g(E,d,f,e,N){let R=1;for(;E.seq1Range.start-R>=e.start&&E.seq2Range.start-R>=N.start&&f.isStronglyEqual(E.seq2Range.start-R,E.seq2Range.endExclusive-R)&&R<100;)R++;R--;let b=0;for(;E.seq1Range.start+b<e.endExclusive&&E.seq2Range.endExclusive+b<N.endExclusive&&f.isStronglyEqual(E.seq2Range.start+b,E.seq2Range.endExclusive+b)&&b<100;)b++;if(R===0&&b===0)return E;let M=0,h=-1;for(let c=-R;c<=b;c++){const r=E.seq2Range.start+c,a=E.seq2Range.endExclusive+c,A=E.seq1Range.start+c,m=d.getBoundaryScore(A)+f.getBoundaryScore(r)+f.getBoundaryScore(a);m>h&&(h=m,M=c)}return E.delta(M)}}),te(ne[40],ie([0,1,6,9]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wY=void 0;class i{compute(l,g,E=_.$mY.instance){if(l.length===0||g.length===0)return _.$kY.trivial(l,g);function d(c,r){for(;c<l.length&&r<g.length&&l.getElement(c)===g.getElement(r);)c++,r++;return c}let f=0;const e=new L;e.set(0,d(0,0));const N=new u;N.set(0,e.get(0)===0?null:new o(null,0,0,e.get(0)));let p=0;e:for(;;){if(f++,!E.isValid())return _.$kY.trivialTimedOut(l,g);const c=-Math.min(f,g.length+f%2),r=Math.min(f,l.length+f%2);for(p=c;p<=r;p+=2){const a=p===r?-1:e.get(p+1),A=p===c?-1:e.get(p-1)+1,m=Math.min(Math.max(a,A),l.length),$=m-p;if(m>l.length||$>g.length)continue;const w=d(m,$);e.set(p,w);const v=m===a?N.get(p+1):N.get(p-1);if(N.set(p,w!==m?new o(v,m,$,w-m):v),e.get(p)===l.length&&e.get(p)-p===g.length)break e}}let R=N.get(p);const b=[];let M=l.length,h=g.length;for(;;){const c=R?R.x+R.length:0,r=R?R.y+R.length:0;if((c!==M||r!==h)&&b.push(new _.$lY(new F.$Rr(c,M),new F.$Rr(r,h))),!R)break;M=R.x,h=R.y,R=R.prev}return b.reverse(),new _.$kY(b,!1)}}t.$wY=i;class o{constructor(l,g,E,d){this.prev=l,this.x=g,this.y=E,this.length=d}}class L{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,g){if(l<0){if(l=-l-1,l>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[l]=g}else{if(l>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[l]=g}}}class u{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,g){l<0?(l=-l-1,this.b[l]=g):this.a[l]=g}}}),te(ne[41],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oY=void 0;class F{constructor(i,o){this.width=i,this.height=o,this.a=[],this.a=new Array(i*o)}get(i,o){return this.a[i+o*this.width]}set(i,o,L){this.a[i+o*this.width]=L}}t.$oY=F}),te(ne[42],ie([0,1,6,9,41]),function(z,t,F,_,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pY=void 0;class o{compute(u,s,l=_.$mY.instance,g){if(u.length===0||s.length===0)return _.$kY.trivial(u,s);const E=new i.$oY(u.length,s.length),d=new i.$oY(u.length,s.length),f=new i.$oY(u.length,s.length);for(let h=0;h<u.length;h++)for(let c=0;c<s.length;c++){if(!l.isValid())return _.$kY.trivialTimedOut(u,s);const r=h===0?0:E.get(h-1,c),a=c===0?0:E.get(h,c-1);let A;u.getElement(h)===s.getElement(c)?(h===0||c===0?A=0:A=E.get(h-1,c-1),h>0&&c>0&&d.get(h-1,c-1)===3&&(A+=f.get(h-1,c-1)),A+=g?g(h,c):1):A=-1;const m=Math.max(r,a,A);if(m===A){const $=h>0&&c>0?f.get(h-1,c-1):0;f.set(h,c,$+1),d.set(h,c,3)}else m===r?(f.set(h,c,0),d.set(h,c,1)):m===a&&(f.set(h,c,0),d.set(h,c,2));E.set(h,c,m)}const e=[];let N=u.length,p=s.length;function R(h,c){(h+1!==N||c+1!==p)&&e.push(new _.$lY(new F.$Rr(h+1,N),new F.$Rr(c+1,p))),N=h,p=c}let b=u.length-1,M=s.length-1;for(;b>=0&&M>=0;)d.get(b,M)===3?(R(b,M),b--,M--):d.get(b,M)===1?b--:M--;return R(-1,-1),e.reverse(),new _.$kY(e,!1)}}t.$pY=o}),te(ne[26],ie([0,1,12]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1r=t.$Zr=t.$Yr=t.$Xr=t.$Wr=void 0;class _{constructor(l,g,E){this.changes=l,this.moves=g,this.hitTimeout=E}}t.$Wr=_;class i{static inverse(l,g,E){const d=[];let f=1,e=1;for(const p of l){const R=new i(new F.$Vr(f,p.originalRange.startLineNumber),new F.$Vr(e,p.modifiedRange.startLineNumber),void 0);R.modifiedRange.isEmpty||d.push(R),f=p.originalRange.endLineNumberExclusive,e=p.modifiedRange.endLineNumberExclusive}const N=new i(new F.$Vr(f,g+1),new F.$Vr(e,E+1),void 0);return N.modifiedRange.isEmpty||d.push(N),d}constructor(l,g,E){this.originalRange=l,this.modifiedRange=g,this.innerChanges=E}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){return new i(this.modifiedRange,this.originalRange,this.innerChanges?.map(l=>l.flip()))}}t.$Xr=i;class o{constructor(l,g){this.originalRange=l,this.modifiedRange=g}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$Yr=o;class L{constructor(l,g){this.original=l,this.modified=g}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new L(this.modified,this.original)}join(l){return new L(this.original.join(l.original),this.modified.join(l.modified))}}t.$Zr=L;class u{constructor(l,g){this.lineRangeMapping=l,this.changes=g}flip(){return new u(this.lineRangeMapping.flip(),this.changes.map(l=>l.flip()))}}t.$1r=u}),te(ne[43],ie([0,1,15,10,28,12,6,4,2,9,42,39,40,26]),function(z,t,F,_,i,o,L,u,s,l,g,E,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BY=t.$AY=t.$zY=t.$yY=t.$xY=void 0;class e{constructor(){this.f=new g.$pY,this.h=new d.$wY}computeDiff(O,B,X){if(O.length<=1&&(0,F.$$e)(O,B,(D,S)=>D===S))return new f.$Wr([],[],!1);if(O.length===1&&O[0].length===0||B.length===1&&B[0].length===0)return new f.$Wr([new f.$Xr(new o.$Vr(1,O.length+1),new o.$Vr(1,B.length+1),[new f.$Yr(new s.$Ur(1,1,O.length,O[0].length+1),new s.$Ur(1,1,B.length,B[0].length+1))])],[],!1);const n=X.maxComputationTimeMs===0?l.$mY.instance:new l.$nY(X.maxComputationTimeMs),K=!X.ignoreTrimWhitespace,ee=new Map;function ue(D){let S=ee.get(D);return S===void 0&&(S=ee.size,ee.set(D,S)),S}const oe=O.map(D=>ue(D.trim())),ce=B.map(D=>ue(D.trim())),he=new a(oe,O),de=new a(ce,B),Re=(()=>he.length+de.length<1700?this.f.compute(he,de,n,(D,S)=>O[D]===B[S]?B[S].length===0?.1:1+Math.log(1+B[S].length):.99):this.h.compute(he,de))();let me=Re.diffs,ve=Re.hitTimeout;me=(0,E.$qY)(he,de,me),me=(0,E.$sY)(he,de,me);const Me=[],Ne=D=>{if(K)for(let S=0;S<D;S++){const U=pe+S,V=le+S;if(O[U]!==B[V]){const H=this.o(O,B,new l.$lY(new L.$Rr(U,U+1),new L.$Rr(V,V+1)),n,K);for(const se of H.mappings)Me.push(se);H.hitTimeout&&(ve=!0)}}};let pe=0,le=0;for(const D of me){(0,_.$yb)(()=>D.seq1Range.start-pe===D.seq2Range.start-le);const S=D.seq1Range.start-pe;Ne(S),pe=D.seq1Range.endExclusive,le=D.seq2Range.endExclusive;const U=this.o(O,B,D,n,K);U.hitTimeout&&(ve=!0);for(const V of U.mappings)Me.push(V)}Ne(O.length-pe);const Z=h(Me,O,B);let J=[];return X.computeMoves&&(J=this.n(Z,O,B,oe,ce,n,K)),(0,_.$yb)(()=>{function D(U,V){if(U.lineNumber<1||U.lineNumber>V.length)return!1;const H=V[U.lineNumber-1];return!(U.column<1||U.column>H.length+1)}function S(U,V){return!(U.startLineNumber<1||U.startLineNumber>V.length+1||U.endLineNumberExclusive<1||U.endLineNumberExclusive>V.length+1)}for(const U of Z){if(!U.innerChanges)return!1;for(const V of U.innerChanges)if(!(D(V.modifiedRange.getStartPosition(),B)&&D(V.modifiedRange.getEndPosition(),B)&&D(V.originalRange.getStartPosition(),O)&&D(V.originalRange.getEndPosition(),O)))return!1;if(!S(U.modifiedRange,B)||!S(U.originalRange,O))return!1}return!0}),new f.$Wr(Z,J,ve)}n(O,B,X,n,K,ee,ue){const oe=[],ce=O.filter(le=>le.modifiedRange.isEmpty&&le.originalRange.length>=3).map(le=>new k(le.originalRange,B,le)),he=new Set(O.filter(le=>le.originalRange.isEmpty&&le.modifiedRange.length>=3).map(le=>new k(le.modifiedRange,X,le))),de=new Set;for(const le of ce){let Z=-1,J;for(const D of he){const S=le.computeSimilarity(D);S>Z&&(Z=S,J=D)}if(Z>.9&&J&&(he.delete(J),oe.push(new f.$Zr(le.range,J.range)),de.add(le.source),de.add(J.source)),!ee.isValid())return[]}const Re=new i.$L;for(const le of O)if(!de.has(le))for(let Z=le.originalRange.startLineNumber;Z<le.originalRange.endLineNumberExclusive-2;Z++){const J=`${n[Z-1]}:${n[Z+1-1]}:${n[Z+2-1]}`;Re.add(J,{range:new o.$Vr(Z,Z+3)})}const me=[];O.sort((0,F.$Lf)(le=>le.modifiedRange.startLineNumber,F.$Nf));for(const le of O){if(de.has(le))continue;let Z=[];for(let J=le.modifiedRange.startLineNumber;J<le.modifiedRange.endLineNumberExclusive-2;J++){const D=`${K[J-1]}:${K[J+1-1]}:${K[J+2-1]}`,S=new o.$Vr(J,J+3),U=[];Re.forEach(D,({range:V})=>{for(const se of Z)if(se.originalLineRange.endLineNumberExclusive+1===V.endLineNumberExclusive&&se.modifiedLineRange.endLineNumberExclusive+1===S.endLineNumberExclusive){se.originalLineRange=new o.$Vr(se.originalLineRange.startLineNumber,V.endLineNumberExclusive),se.modifiedLineRange=new o.$Vr(se.modifiedLineRange.startLineNumber,S.endLineNumberExclusive),U.push(se);return}const H={modifiedLineRange:S,originalLineRange:V};me.push(H),U.push(H)}),Z=U}if(!ee.isValid())return[]}me.sort((0,F.$Pf)((0,F.$Lf)(le=>le.modifiedLineRange.length,F.$Nf)));const ve=new p,Me=new p;for(const le of me){const Z=le.modifiedLineRange.startLineNumber-le.originalLineRange.startLineNumber,J=ve.subtractFrom(le.modifiedLineRange),D=Me.subtractFrom(le.originalLineRange).map(U=>U.delta(Z)),S=N(J,D);for(const U of S){if(U.length<3)continue;const V=U,H=U.delta(-Z);oe.push(new f.$Zr(H,V)),ve.addRange(V),Me.addRange(H)}}if(oe.sort((0,F.$Lf)(le=>le.original.startLineNumber,F.$Nf)),oe.length===0)return[];const Ne=[oe[0]];for(let le=1;le<oe.length;le++){const Z=Ne[Ne.length-1],J=oe[le],D=J.original.startLineNumber-Z.original.endLineNumberExclusive,S=J.modified.startLineNumber-Z.modified.endLineNumberExclusive;if(D>=0&&S>=0&&D+S<=2){Ne[Ne.length-1]=Z.join(J);continue}J.original.toOffsetRange().slice(B).map(H=>H.trim()).join(`
`).length<=10||Ne.push(J)}return Ne.map(le=>{const Z=this.o(B,X,new l.$lY(le.original.toOffsetRange(),le.modified.toOffsetRange()),ee,ue),J=h(Z.mappings,B,X,!0);return new f.$1r(le,J)})}o(O,B,X,n,K){const ee=new m(O,X.seq1Range,K),ue=new m(B,X.seq2Range,K),oe=ee.length+ue.length<500?this.f.compute(ee,ue,n):this.h.compute(ee,ue,n);let ce=oe.diffs;return ce=(0,E.$qY)(ee,ue,ce),ce=b(ee,ue,ce),ce=(0,E.$rY)(ee,ue,ce),ce=(0,E.$tY)(ee,ue,ce),{mappings:ce.map(de=>new f.$Yr(ee.translateRange(de.seq1Range),ue.translateRange(de.seq2Range))),hitTimeout:oe.hitTimeout}}}t.$xY=e;function N(q,O){const B=[];let X=0,n=0;for(;X<q.length&&n<O.length;){const K=q[X],ee=O[n],ue=K.intersect(ee);ue&&!ue.isEmpty&&B.push(ue),K.endLineNumberExclusive<ee.endLineNumberExclusive?X++:n++}return B}class p{constructor(){this.f=[]}addRange(O){const B=R(this.f.findIndex(n=>n.endLineNumberExclusive>=O.startLineNumber),this.f.length),X=(0,F.$rf)(this.f,n=>n.startLineNumber<=O.endLineNumberExclusive)+1;if(B===X)this.f.splice(B,0,O);else if(B===X-1){const n=this.f[B];this.f[B]=n.join(O)}else{const n=this.f[B].join(this.f[X-1]).join(O);this.f.splice(B,X-B,n)}}intersects(O){for(const B of this.f)if(B.intersectsStrict(O))return!0;return!1}subtractFrom(O){const B=R(this.f.findIndex(ee=>ee.endLineNumberExclusive>=O.startLineNumber),this.f.length),X=(0,F.$rf)(this.f,ee=>ee.startLineNumber<=O.endLineNumberExclusive)+1;if(B===X)return[O];const n=[];let K=O.startLineNumber;for(let ee=B;ee<X;ee++){const ue=this.f[ee];ue.startLineNumber>K&&n.push(new o.$Vr(K,ue.startLineNumber)),K=ue.endLineNumberExclusive}return K<O.endLineNumberExclusive&&n.push(new o.$Vr(K,O.endLineNumberExclusive)),n}}function R(q,O){return q===-1?O:q}function b(q,O,B){const X=[];let n;function K(){if(!n)return;const ue=n.s1Range.length-n.deleted,oe=n.s2Range.length-n.added;Math.max(n.deleted,n.added)+(n.count-1)>ue&&X.push(new l.$lY(n.s1Range,n.s2Range)),n=void 0}for(const ue of B){let oe=function(me,ve){if(!n||!n.s1Range.containsRange(me)||!n.s2Range.containsRange(ve))if(n&&!(n.s1Range.endExclusive<me.start&&n.s2Range.endExclusive<ve.start)){const pe=L.$Rr.tryCreate(n.s1Range.endExclusive,me.start),le=L.$Rr.tryCreate(n.s2Range.endExclusive,ve.start);n.deleted+=pe?.length??0,n.added+=le?.length??0,n.s1Range=n.s1Range.join(me),n.s2Range=n.s2Range.join(ve)}else K(),n={added:0,deleted:0,count:0,s1Range:me,s2Range:ve};const Me=me.intersect(ue.seq1Range),Ne=ve.intersect(ue.seq2Range);n.count++,n.deleted+=Me?.length??0,n.added+=Ne?.length??0};const ce=q.findWordContaining(ue.seq1Range.start-1),he=O.findWordContaining(ue.seq2Range.start-1),de=q.findWordContaining(ue.seq1Range.endExclusive),Re=O.findWordContaining(ue.seq2Range.endExclusive);ce&&de&&he&&Re&&ce.equals(de)&&he.equals(Re)?oe(ce,he):(ce&&he&&oe(ce,he),de&&Re&&oe(de,Re))}return K(),M(B,X)}function M(q,O){const B=[];for(;q.length>0||O.length>0;){const X=q[0],n=O[0];let K;X&&(!n||X.seq1Range.start<n.seq1Range.start)?K=q.shift():K=O.shift(),B.length>0&&B[B.length-1].seq1Range.endExclusive>=K.seq1Range.start?B[B.length-1]=B[B.length-1].join(K):B.push(K)}return B}function h(q,O,B,X=!1){const n=[];for(const K of r(q.map(ee=>c(ee,O,B)),(ee,ue)=>ee.originalRange.overlapOrTouch(ue.originalRange)||ee.modifiedRange.overlapOrTouch(ue.modifiedRange))){const ee=K[0],ue=K[K.length-1];n.push(new f.$Xr(ee.originalRange.join(ue.originalRange),ee.modifiedRange.join(ue.modifiedRange),K.map(oe=>oe.innerChanges[0])))}return(0,_.$yb)(()=>!X&&n.length>0&&n[0].originalRange.startLineNumber!==n[0].modifiedRange.startLineNumber?!1:(0,_.$zb)(n,(K,ee)=>ee.originalRange.startLineNumber-K.originalRange.endLineNumberExclusive===ee.modifiedRange.startLineNumber-K.modifiedRange.endLineNumberExclusive&&K.originalRange.endLineNumberExclusive<ee.originalRange.startLineNumber&&K.modifiedRange.endLineNumberExclusive<ee.modifiedRange.startLineNumber)),n}t.$yY=h;function c(q,O,B){let X=0,n=0;q.modifiedRange.endColumn===1&&q.originalRange.endColumn===1&&q.originalRange.startLineNumber+X<=q.originalRange.endLineNumber&&q.modifiedRange.startLineNumber+X<=q.modifiedRange.endLineNumber&&(n=-1),q.modifiedRange.startColumn-1>=B[q.modifiedRange.startLineNumber-1].length&&q.originalRange.startColumn-1>=O[q.originalRange.startLineNumber-1].length&&q.originalRange.startLineNumber<=q.originalRange.endLineNumber+n&&q.modifiedRange.startLineNumber<=q.modifiedRange.endLineNumber+n&&(X=1);const K=new o.$Vr(q.originalRange.startLineNumber+X,q.originalRange.endLineNumber+1+n),ee=new o.$Vr(q.modifiedRange.startLineNumber+X,q.modifiedRange.endLineNumber+1+n);return new f.$Xr(K,ee,[q])}t.$zY=c;function*r(q,O){let B,X;for(const n of q)X!==void 0&&O(X,n)?B.push(n):(B&&(yield B),B=[n]),X=n;B&&(yield B)}class a{constructor(O,B){this.f=O,this.h=B}getElement(O){return this.f[O]}get length(){return this.f.length}getBoundaryScore(O){const B=O===0?0:A(this.h[O-1]),X=O===this.h.length?0:A(this.h[O]);return 1e3-(B+X)}getText(O){return this.h.slice(O.start,O.endExclusive).join(`
`)}isStronglyEqual(O,B){return this.h[O]===this.h[B]}}t.$AY=a;function A(q){let O=0;for(;O<q.length&&(q.charCodeAt(O)===32||q.charCodeAt(O)===9);)O++;return O}class m{constructor(O,B,X){this.lines=O,this.considerWhitespaceChanges=X,this.f=[],this.h=[],this.n=[];let n=!1;B.start>0&&B.endExclusive>=O.length&&(B=new L.$Rr(B.start-1,B.endExclusive),n=!0),this.lineRange=B;for(let K=this.lineRange.start;K<this.lineRange.endExclusive;K++){let ee=O[K],ue=0;if(n)ue=ee.length,ee="",n=!1;else if(!X){const oe=ee.trimStart();ue=ee.length-oe.length,ee=oe.trimEnd()}this.n.push(ue);for(let oe=0;oe<ee.length;oe++)this.f.push(ee.charCodeAt(oe));K<O.length-1&&(this.f.push(`
`.charCodeAt(0)),this.h[K-this.lineRange.start]=this.f.length)}this.n.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new L.$Rr(0,this.length))}getText(O){return this.f.slice(O.start,O.endExclusive).map(B=>String.fromCharCode(B)).join("")}getElement(O){return this.f[O]}get length(){return this.f.length}getBoundaryScore(O){const B=j(O>0?this.f[O-1]:-1),X=j(O<this.f.length?this.f[O]:-1);if(B===6&&X===7)return 0;let n=0;return B!==X&&(n+=10,X===1&&(n+=1)),n+=P(B),n+=P(X),n}translateOffset(O){if(this.lineRange.isEmpty)return new u.$Tr(this.lineRange.start+1,1);let B=0,X=this.h.length;for(;B<X;){const K=Math.floor((B+X)/2);this.h[K]>O?X=K:B=K+1}const n=B===0?0:this.h[B-1];return new u.$Tr(this.lineRange.start+B+1,O-n+1+this.n[B])}translateRange(O){return s.$Ur.fromPositions(this.translateOffset(O.start),this.translateOffset(O.endExclusive))}findWordContaining(O){if(O<0||O>=this.f.length||!v(this.f[O]))return;let B=O;for(;B>0&&v(this.f[B-1]);)B--;let X=O;for(;X<this.f.length&&v(this.f[X]);)X++;return new L.$Rr(B,X)}countLinesIn(O){return this.translateOffset(O.endExclusive).lineNumber-this.translateOffset(O.start).lineNumber}isStronglyEqual(O,B){return this.f[O]===this.f[B]}extendToFullLines(O){const B=$(this.h,ee=>ee<=O.start),X=w(this.h,ee=>O.endExclusive<=ee),n=B===-1?0:this.h[B],K=X===this.h.length?this.f.length:this.h[X];return new L.$Rr(n,K)}}t.$BY=m;function $(q,O){let B=0,X=q.length;for(;B<X;){const n=Math.floor((B+X)/2);O(q[n])?B=n+1:X=n}return B-1}function w(q,O){let B=0,X=q.length;for(;B<X;){const n=Math.floor((B+X)/2);O(q[n])?X=n:B=n+1}return B}function v(q){return q>=97&&q<=122||q>=65&&q<=90||q>=48&&q<=57}var y;(function(q){q[q.WordLower=0]="WordLower",q[q.WordUpper=1]="WordUpper",q[q.WordNumber=2]="WordNumber",q[q.End=3]="End",q[q.Other=4]="Other",q[q.Space=5]="Space",q[q.LineBreakCR=6]="LineBreakCR",q[q.LineBreakLF=7]="LineBreakLF"})(y||(y={}));const I={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function P(q){return I[q]}function j(q){return q===10?7:q===13?6:x(q)?5:q>=97&&q<=122?0:q>=65&&q<=90?1:q>=48&&q<=57?2:q===-1?3:4}function x(q){return q===32||q===9}const W=new Map;function G(q){let O=W.get(q);return O===void 0&&(O=W.size,W.set(q,O)),O}class k{constructor(O,B,X){this.range=O,this.lines=B,this.source=X,this.h=[];let n=0;for(let K=O.startLineNumber-1;K<O.endLineNumberExclusive-1;K++){const ee=B[K];for(let oe=0;oe<ee.length;oe++){n++;const ce=ee[oe],he=G(ce);this.h[he]=(this.h[he]||0)+1}n++;const ue=G(`
`);this.h[ue]=(this.h[ue]||0)+1}this.f=n}computeSimilarity(O){let B=0;const X=Math.max(this.h.length,O.h.length);for(let n=0;n<X;n++)B+=Math.abs((this.h[n]??0)-(O.h[n]??0));return 1-B/(this.f+O.f)}}}),te(ne[27],ie([0,1,21,26,5,2,10,12]),function(z,t,F,_,i,o,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wu=t.$vu=void 0;const s=3;class l{computeDiff(c,r,a){const m=new p(c,r,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),$=[];let w=null;for(const v of m.changes){let y;v.originalEndLineNumber===0?y=new u.$Vr(v.originalStartLineNumber+1,v.originalStartLineNumber+1):y=new u.$Vr(v.originalStartLineNumber,v.originalEndLineNumber+1);let I;v.modifiedEndLineNumber===0?I=new u.$Vr(v.modifiedStartLineNumber+1,v.modifiedStartLineNumber+1):I=new u.$Vr(v.modifiedStartLineNumber,v.modifiedEndLineNumber+1);let P=new _.$Xr(y,I,v.charChanges?.map(j=>new _.$Yr(new o.$Ur(j.originalStartLineNumber,j.originalStartColumn,j.originalEndLineNumber,j.originalEndColumn),new o.$Ur(j.modifiedStartLineNumber,j.modifiedStartColumn,j.modifiedEndLineNumber,j.modifiedEndColumn))));w&&(w.modifiedRange.endLineNumberExclusive===P.modifiedRange.startLineNumber||w.originalRange.endLineNumberExclusive===P.originalRange.startLineNumber)&&(P=new _.$Xr(w.originalRange.join(P.originalRange),w.modifiedRange.join(P.modifiedRange),w.innerChanges&&P.innerChanges?w.innerChanges.concat(P.innerChanges):void 0),$.pop()),$.push(P),w=P}return(0,L.$yb)(()=>(0,L.$zb)($,(v,y)=>y.originalRange.startLineNumber-v.originalRange.endLineNumberExclusive===y.modifiedRange.startLineNumber-v.modifiedRange.endLineNumberExclusive&&v.originalRange.endLineNumberExclusive<y.originalRange.startLineNumber&&v.modifiedRange.endLineNumberExclusive<y.modifiedRange.startLineNumber)),new _.$Wr($,[],m.quitEarly)}}t.$vu=l;function g(h,c,r,a){return new F.$uu(h,c,r).ComputeDiff(a)}class E{constructor(c){const r=[],a=[];for(let A=0,m=c.length;A<m;A++)r[A]=R(c[A],1),a[A]=b(c[A],1);this.lines=c,this.a=r,this.b=a}getElements(){const c=[];for(let r=0,a=this.lines.length;r<a;r++)c[r]=this.lines[r].substring(this.a[r]-1,this.b[r]-1);return c}getStrictElement(c){return this.lines[c]}getStartLineNumber(c){return c+1}getEndLineNumber(c){return c+1}createCharSequence(c,r,a){const A=[],m=[],$=[];let w=0;for(let v=r;v<=a;v++){const y=this.lines[v],I=c?this.a[v]:1,P=c?this.b[v]:y.length+1;for(let j=I;j<P;j++)A[w]=y.charCodeAt(j-1),m[w]=v+1,$[w]=j,w++;!c&&v<a&&(A[w]=10,m[w]=v+1,$[w]=y.length+1,w++)}return new d(A,m,$)}}class d{constructor(c,r,a){this.a=c,this.b=r,this.d=a}toString(){return"["+this.a.map((c,r)=>(c===10?"\\n":String.fromCharCode(c))+`-(${this.b[r]},${this.d[r]})`).join(", ")+"]"}e(c,r){if(c<0||c>=r.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(c){return c>0&&c===this.b.length?this.getEndLineNumber(c-1):(this.e(c,this.b),this.b[c])}getEndLineNumber(c){return c===-1?this.getStartLineNumber(c+1):(this.e(c,this.b),this.a[c]===10?this.b[c]+1:this.b[c])}getStartColumn(c){return c>0&&c===this.d.length?this.getEndColumn(c-1):(this.e(c,this.d),this.d[c])}getEndColumn(c){return c===-1?this.getStartColumn(c+1):(this.e(c,this.d),this.a[c]===10?1:this.d[c]+1)}}class f{constructor(c,r,a,A,m,$,w,v){this.originalStartLineNumber=c,this.originalStartColumn=r,this.originalEndLineNumber=a,this.originalEndColumn=A,this.modifiedStartLineNumber=m,this.modifiedStartColumn=$,this.modifiedEndLineNumber=w,this.modifiedEndColumn=v}static createFromDiffChange(c,r,a){const A=r.getStartLineNumber(c.originalStart),m=r.getStartColumn(c.originalStart),$=r.getEndLineNumber(c.originalStart+c.originalLength-1),w=r.getEndColumn(c.originalStart+c.originalLength-1),v=a.getStartLineNumber(c.modifiedStart),y=a.getStartColumn(c.modifiedStart),I=a.getEndLineNumber(c.modifiedStart+c.modifiedLength-1),P=a.getEndColumn(c.modifiedStart+c.modifiedLength-1);return new f(A,m,$,w,v,y,I,P)}}function e(h){if(h.length<=1)return h;const c=[h[0]];let r=c[0];for(let a=1,A=h.length;a<A;a++){const m=h[a],$=m.originalStart-(r.originalStart+r.originalLength),w=m.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min($,w)<s?(r.originalLength=m.originalStart+m.originalLength-r.originalStart,r.modifiedLength=m.modifiedStart+m.modifiedLength-r.modifiedStart):(c.push(m),r=m)}return c}class N{constructor(c,r,a,A,m){this.originalStartLineNumber=c,this.originalEndLineNumber=r,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=A,this.charChanges=m}static createFromDiffResult(c,r,a,A,m,$,w){let v,y,I,P,j;if(r.originalLength===0?(v=a.getStartLineNumber(r.originalStart)-1,y=0):(v=a.getStartLineNumber(r.originalStart),y=a.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(I=A.getStartLineNumber(r.modifiedStart)-1,P=0):(I=A.getStartLineNumber(r.modifiedStart),P=A.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),$&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&m()){const x=a.createCharSequence(c,r.originalStart,r.originalStart+r.originalLength-1),W=A.createCharSequence(c,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(x.getElements().length>0&&W.getElements().length>0){let G=g(x,W,m,!0).changes;w&&(G=e(G)),j=[];for(let k=0,q=G.length;k<q;k++)j.push(f.createFromDiffChange(G[k],x,W))}}return new N(v,y,I,P,j)}}class p{constructor(c,r,a){this.a=a.shouldComputeCharChanges,this.b=a.shouldPostProcessCharChanges,this.d=a.shouldIgnoreTrimWhitespace,this.e=a.shouldMakePrettyDiff,this.f=c,this.g=r,this.h=new E(c),this.j=new E(r),this.k=M(a.maxComputationTime),this.l=M(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const c=g(this.h,this.j,this.k,this.e),r=c.changes,a=c.quitEarly;if(this.d){const w=[];for(let v=0,y=r.length;v<y;v++)w.push(N.createFromDiffResult(this.d,r[v],this.h,this.j,this.l,this.a,this.b));return{quitEarly:a,changes:w}}const A=[];let m=0,$=0;for(let w=-1,v=r.length;w<v;w++){const y=w+1<v?r[w+1]:null,I=y?y.originalStart:this.f.length,P=y?y.modifiedStart:this.g.length;for(;m<I&&$<P;){const j=this.f[m],x=this.g[$];if(j!==x){{let W=R(j,1),G=R(x,1);for(;W>1&&G>1;){const k=j.charCodeAt(W-2),q=x.charCodeAt(G-2);if(k!==q)break;W--,G--}(W>1||G>1)&&this.m(A,m+1,1,W,$+1,1,G)}{let W=b(j,1),G=b(x,1);const k=j.length+1,q=x.length+1;for(;W<k&&G<q;){const O=j.charCodeAt(W-1),B=j.charCodeAt(G-1);if(O!==B)break;W++,G++}(W<k||G<q)&&this.m(A,m+1,W,k,$+1,G,q)}}m++,$++}y&&(A.push(N.createFromDiffResult(this.d,y,this.h,this.j,this.l,this.a,this.b)),m+=y.originalLength,$+=y.modifiedLength)}return{quitEarly:a,changes:A}}m(c,r,a,A,m,$,w){if(this.n(c,r,a,A,m,$,w))return;let v;this.a&&(v=[new f(r,a,r,A,m,$,m,w)]),c.push(new N(r,r,m,m,v))}n(c,r,a,A,m,$,w){const v=c.length;if(v===0)return!1;const y=c[v-1];return y.originalEndLineNumber===0||y.modifiedEndLineNumber===0?!1:y.originalEndLineNumber===r&&y.modifiedEndLineNumber===m?(this.a&&y.charChanges&&y.charChanges.push(new f(r,a,r,A,m,$,m,w)),!0):y.originalEndLineNumber+1===r&&y.modifiedEndLineNumber+1===m?(y.originalEndLineNumber=r,y.modifiedEndLineNumber=m,this.a&&y.charChanges&&y.charChanges.push(new f(r,a,r,A,m,$,m,w)),!0):!1}}t.$wu=p;function R(h,c){const r=i.$Ad(h);return r===-1?c:r+1}function b(h,c){const r=i.$Cd(h);return r===-1?c:r+2}function M(h){if(h===0)return()=>!0;const c=Date.now();return()=>Date.now()-c<h}}),te(ne[44],ie([0,1,27,43]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CY=void 0,t.$CY={getLegacy:()=>new F.$vu,getAdvanced:()=>new _.$xY}}),te(ne[45],ie([0,1,29]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DY=void 0;function _(d){const f=[];for(const e of d){const N=Number(e);(N||N===0&&e.replace(/\s/g,"")!=="")&&f.push(N)}return f}function i(d,f,e,N){return{red:d/255,blue:e/255,green:f/255,alpha:N}}function o(d,f){const e=f.index,N=f[0].length;if(!e)return;const p=d.positionAt(e);return{startLineNumber:p.lineNumber,startColumn:p.column,endLineNumber:p.lineNumber,endColumn:p.column+N}}function L(d,f){if(!d)return;const e=F.$ds.Format.CSS.parseHex(f);if(e)return{range:d,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function u(d,f,e){if(!d||f.length!==1)return;const p=f[0].values(),R=_(p);return{range:d,color:i(R[0],R[1],R[2],e?R[3]:1)}}function s(d,f,e){if(!d||f.length!==1)return;const p=f[0].values(),R=_(p),b=new F.$ds(new F.$bs(R[0],R[1]/100,R[2]/100,e?R[3]:1));return{range:d,color:i(b.rgba.r,b.rgba.g,b.rgba.b,b.rgba.a)}}function l(d,f){return typeof d=="string"?[...d.matchAll(f)]:d.findMatches(f)}function g(d){const f=[],N=l(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(N.length>0)for(const p of N){const R=p.filter(c=>c!==void 0),b=R[1],M=R[2];if(!M)continue;let h;if(b==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;h=u(o(d,p),l(M,c),!1)}else if(b==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;h=u(o(d,p),l(M,c),!0)}else if(b==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;h=s(o(d,p),l(M,c),!1)}else if(b==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;h=s(o(d,p),l(M,c),!0)}else b==="#"&&(h=L(o(d,p),b+M));h&&f.push(h)}return f}function E(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:g(d)}t.$DY=E}),te(ne[46],ie([0,1,24]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gY=t.$fY=t.$eY=t.State=void 0;var _;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(_||(t.State=_={}));class i{constructor(e,N,p){const R=new Uint8Array(e*N);for(let b=0,M=e*N;b<M;b++)R[b]=p;this.a=R,this.rows=e,this.cols=N}get(e,N){return this.a[e*this.cols+N]}set(e,N,p){this.a[e*this.cols+N]=p}}class o{constructor(e){let N=0,p=0;for(let b=0,M=e.length;b<M;b++){const[h,c,r]=e[b];c>N&&(N=c),h>p&&(p=h),r>p&&(p=r)}N++,p++;const R=new i(p,N,0);for(let b=0,M=e.length;b<M;b++){const[h,c,r]=e[b];R.set(h,c,r)}this.a=R,this.b=N}nextState(e,N){return N<0||N>=this.b?0:this.a.get(e,N)}}t.$eY=o;let L=null;function u(){return L===null&&(L=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var s;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(s||(s={}));let l=null;function g(){if(l===null){l=new F.$9r(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<f.length;N++)l.set(f.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)l.set(e.charCodeAt(N),2)}return l}class E{static a(e,N,p,R,b){let M=b-1;do{const h=N.charCodeAt(M);if(e.get(h)!==2)break;M--}while(M>R);if(R>0){const h=N.charCodeAt(R-1),c=N.charCodeAt(M);(h===40&&c===41||h===91&&c===93||h===123&&c===125)&&M--}return{range:{startLineNumber:p,startColumn:R+1,endLineNumber:p,endColumn:M+2},url:N.substring(R,M+1)}}static computeLinks(e,N=u()){const p=g(),R=[];for(let b=1,M=e.getLineCount();b<=M;b++){const h=e.getLineContent(b),c=h.length;let r=0,a=0,A=0,m=1,$=!1,w=!1,v=!1,y=!1;for(;r<c;){let I=!1;const P=h.charCodeAt(r);if(m===13){let j;switch(P){case 40:$=!0,j=0;break;case 41:j=$?0:1;break;case 91:v=!0,w=!0,j=0;break;case 93:v=!1,j=w?0:1;break;case 123:y=!0,j=0;break;case 125:j=y?0:1;break;case 39:case 34:case 96:A===P?j=1:A===39||A===34||A===96?j=0:j=1;break;case 42:j=A===42?1:0;break;case 124:j=A===124?1:0;break;case 32:j=v?0:1;break;default:j=p.get(P)}j===1&&(R.push(E.a(p,h,b,a,r)),I=!0)}else if(m===12){let j;P===91?(w=!0,j=0):j=p.get(P),j===1?I=!0:m=13}else m=N.nextState(m,P),m===0&&(I=!0);I&&(m=1,$=!1,w=!1,y=!1,a=r+1,A=P),r++}m===13&&R.push(E.a(p,h,b,a,c))}return R}}t.$fY=E;function d(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:E.computeLinks(f)}t.$gY=d}),te(ne[47],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hY=void 0;class F{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new F}navigateValueSet(i,o,L,u,s){if(i&&o){const l=this.a(o,s);if(l)return{range:i,value:l}}if(L&&u){const l=this.a(u,s);if(l)return{range:L,value:l}}return null}a(i,o){const L=this.b(i,o);return L!==null?L:this.d(i,o)}b(i,o){const L=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let u=Number(i);const s=parseFloat(i);return!isNaN(u)&&!isNaN(s)&&u===s?u===0&&!o?null:(u=Math.floor(u*L),u+=o?L:-L,String(u/L)):null}d(i,o){return this.e(this.c,i,o)}e(i,o,L){let u=null;for(let s=0,l=i.length;u===null&&s<l;s++)u=this.f(i[s],o,L);return u}f(i,o,L){let u=i.indexOf(o);return u>=0?(u+=L?1:-1,u<0?u=i.length-1:u%=i.length,i[u]):null}}t.$hY=F}),te(ne[48],ie([0,1,11]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8t=t.$7t=t.$6t=t.$5t=t.ModelConstants=t.PositionAffinity=t.$4t=t.TrackedRangeStickiness=t.$3t=t.$2t=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var _;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(_||(t.OverviewRulerLane=_={}));var i;(function(h){h[h.Left=1]="Left",h[h.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var o;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var L;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(L||(t.InjectedTextCursorStops=L={}));var u;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(u||(t.EndOfLinePreference=u={}));var s;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var l;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,F.$Mm)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.$2t=g;class E{constructor(c,r){this._findMatchBrand=void 0,this.range=c,this.matches=r}}t.$3t=E;var d;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(d||(t.TrackedRangeStickiness=d={}));function f(h){return h&&typeof h.read=="function"}t.$4t=f;var e;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var N;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(t.ModelConstants=N={}));class p{constructor(c,r,a,A,m,$){this.identifier=c,this.range=r,this.text=a,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=m,this._isTracked=$}}t.$5t=p;class R{constructor(c,r,a){this.regex=c,this.wordSeparators=r,this.simpleSearch=a}}t.$6t=R;class b{constructor(c,r,a){this.reverseEdits=c,this.changes=r,this.trimAutoWhitespaceLineNumbers=a}}t.$7t=b;function M(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}t.$8t=M}),te(ne[49],ie([0,1,15,23]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bu=t.$Au=t.$zu=void 0;class i{constructor(s){this.a=s,this.b=new Uint32Array(s.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(s,l){s=(0,_.$kd)(s);const g=this.a,E=this.b,d=l.length;return d===0?!1:(this.a=new Uint32Array(g.length+d),this.a.set(g.subarray(0,s),0),this.a.set(g.subarray(s),s+d),this.a.set(l,s),s-1<this.c[0]&&(this.c[0]=s-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(s,l){return s=(0,_.$kd)(s),l=(0,_.$kd)(l),this.a[s]===l?!1:(this.a[s]=l,s-1<this.c[0]&&(this.c[0]=s-1),!0)}removeValues(s,l){s=(0,_.$kd)(s),l=(0,_.$kd)(l);const g=this.a,E=this.b;if(s>=g.length)return!1;const d=g.length-s;return l>=d&&(l=d),l===0?!1:(this.a=new Uint32Array(g.length-l),this.a.set(g.subarray(0,s),0),this.a.set(g.subarray(s+l),s),this.b=new Uint32Array(this.a.length),s-1<this.c[0]&&(this.c[0]=s-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(s){return s<0?0:(s=(0,_.$kd)(s),this.d(s))}d(s){if(s<=this.c[0])return this.b[s];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),s>=this.a.length&&(s=this.a.length-1);for(let g=l;g<=s;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],s),this.b[s]}getIndexOf(s){s=Math.floor(s),this.getTotalSum();let l=0,g=this.a.length-1,E=0,d=0,f=0;for(;l<=g;)if(E=l+(g-l)/2|0,d=this.b[E],f=d-this.a[E],s<f)g=E-1;else if(s>=d)l=E+1;else break;return new L(E,s-f)}}t.$zu=i;class o{constructor(s){this.a=s,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(s){return this.g(),s===0?0:this.d[s-1]}getIndexOf(s){this.g();const l=this.e[s],g=l>0?this.d[l-1]:0;return new L(l,s-g)}removeValues(s,l){this.a.splice(s,l),this.f(s)}insertValues(s,l){this.a=(0,F.$Af)(this.a,s,l),this.f(s)}f(s){this.b=!1,this.c=Math.min(this.c,s-1)}g(){if(!this.b){for(let s=this.c+1,l=this.a.length;s<l;s++){const g=this.a[s],E=s>0?this.d[s-1]:0;this.d[s]=E+g;for(let d=0;d<g;d++)this.e[E+d]=s}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(s,l){this.a[s]!==l&&(this.a[s]=l,this.f(s))}}t.$Au=o;class L{constructor(s,l){this.index=s,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=s,this.remainder=l}}t.$Bu=L}),te(ne[50],ie([0,1,5,4,49]),function(z,t,F,_,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cu=void 0;class o{constructor(u,s,l,g){this.d=u,this.f=s,this.g=l,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(u){u.eol&&u.eol!==this.g&&(this.g=u.eol,this.j=null);const s=u.changes;for(const l of s)this.o(l.range),this.p(new _.$Tr(l.range.startLineNumber,l.range.startColumn),l.text);this.h=u.versionId,this.k=null}l(){if(!this.j){const u=this.g.length,s=this.f.length,l=new Uint32Array(s);for(let g=0;g<s;g++)l[g]=this.f[g].length+u;this.j=new i.$zu(l)}}n(u,s){this.f[u]=s,this.j&&this.j.setValue(u,this.f[u].length+this.g.length)}o(u){if(u.startLineNumber===u.endLineNumber){if(u.startColumn===u.endColumn)return;this.n(u.startLineNumber-1,this.f[u.startLineNumber-1].substring(0,u.startColumn-1)+this.f[u.startLineNumber-1].substring(u.endColumn-1));return}this.n(u.startLineNumber-1,this.f[u.startLineNumber-1].substring(0,u.startColumn-1)+this.f[u.endLineNumber-1].substring(u.endColumn-1)),this.f.splice(u.startLineNumber,u.endLineNumber-u.startLineNumber),this.j&&this.j.removeValues(u.startLineNumber,u.endLineNumber-u.startLineNumber)}p(u,s){if(s.length===0)return;const l=(0,F.$zd)(s);if(l.length===1){this.n(u.lineNumber-1,this.f[u.lineNumber-1].substring(0,u.column-1)+l[0]+this.f[u.lineNumber-1].substring(u.column-1));return}l[l.length-1]+=this.f[u.lineNumber-1].substring(u.column-1),this.n(u.lineNumber-1,this.f[u.lineNumber-1].substring(0,u.column-1)+l[0]);const g=new Uint32Array(l.length-1);for(let E=1;E<l.length;E++)this.f.splice(u.lineNumber+E-1,0,l[E]),g[E-1]=l[E].length+this.g.length;this.j&&this.j.insertValues(u.lineNumber,g)}}t.$Cu=o}),te(ne[51],ie([0,1,5,38,4,2,48]),function(z,t,F,_,i,o,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bC=t.$aC=t.$_B=t.$$B=t.$0B=t.$9B=void 0;const u=999;class s{constructor(b,M,h,c){this.searchString=b,this.isRegex=M,this.matchCase=h,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=l(this.searchString):b=this.searchString.indexOf(`
`)>=0;let M=null;try{M=F.$xd(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!M)return null;let h=!this.isRegex&&!b;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new L.$6t(M,this.wordSeparators?(0,_.$_r)(this.wordSeparators):null,h?this.searchString:null)}}t.$9B=s;function l(R){if(!R||R.length===0)return!1;for(let b=0,M=R.length;b<M;b++){const h=R.charCodeAt(b);if(h===10)return!0;if(h===92){if(b++,b>=M)break;const c=R.charCodeAt(b);if(c===110||c===114||c===87)return!0}}return!1}t.$0B=l;function g(R,b,M){if(!M)return new L.$3t(R,null);const h=[];for(let c=0,r=b.length;c<r;c++)h[c]=b[c];return new L.$3t(R,h)}t.$$B=g;class E{constructor(b){const M=[];let h=0;for(let c=0,r=b.length;c<r;c++)b.charCodeAt(c)===10&&(M[h++]=c);this.a=M}findLineFeedCountBeforeOffset(b){const M=this.a;let h=0,c=M.length-1;if(c===-1||b<=M[0])return 0;for(;h<c;){const r=h+((c-h)/2>>0);M[r]>=b?c=r-1:M[r+1]>=b?(h=r,c=r):h=r+1}return h+1}}class d{static findMatches(b,M,h,c,r){const a=M.parseSearchRequest();return a?a.regex.multiline?this.b(b,h,new p(a.wordSeparators,a.regex),c,r):this.c(b,h,a,c,r):[]}static a(b,M,h,c,r,a){let A,m=0;c?(m=c.findLineFeedCountBeforeOffset(r),A=M+r+m):A=M+r;let $;if(c){const I=c.findLineFeedCountBeforeOffset(r+a.length)-m;$=A+a.length+I}else $=A+a.length;const w=b.getPositionAt(A),v=b.getPositionAt($);return new o.$Ur(w.lineNumber,w.column,v.lineNumber,v.column)}static b(b,M,h,c,r){const a=b.getOffsetAt(M.getStartPosition()),A=b.getValueInRange(M,1),m=b.getEOL()===`\r
`?new E(A):null,$=[];let w=0,v;for(h.reset(0);v=h.next(A);)if($[w++]=g(this.a(b,a,A,m,v.index,v[0]),v,c),w>=r)return $;return $}static c(b,M,h,c,r){const a=[];let A=0;if(M.startLineNumber===M.endLineNumber){const $=b.getLineContent(M.startLineNumber).substring(M.startColumn-1,M.endColumn-1);return A=this.d(h,$,M.startLineNumber,M.startColumn-1,A,a,c,r),a}const m=b.getLineContent(M.startLineNumber).substring(M.startColumn-1);A=this.d(h,m,M.startLineNumber,M.startColumn-1,A,a,c,r);for(let $=M.startLineNumber+1;$<M.endLineNumber&&A<r;$++)A=this.d(h,b.getLineContent($),$,0,A,a,c,r);if(A<r){const $=b.getLineContent(M.endLineNumber).substring(0,M.endColumn-1);A=this.d(h,$,M.endLineNumber,0,A,a,c,r)}return a}static d(b,M,h,c,r,a,A,m){const $=b.wordSeparators;if(!A&&b.simpleSearch){const y=b.simpleSearch,I=y.length,P=M.length;let j=-I;for(;(j=M.indexOf(y,j+I))!==-1;)if((!$||N($,M,P,j,I))&&(a[r++]=new L.$3t(new o.$Ur(h,j+1+c,h,j+1+I+c),null),r>=m))return r;return r}const w=new p(b.wordSeparators,b.regex);let v;w.reset(0);do if(v=w.next(M),v&&(a[r++]=g(new o.$Ur(h,v.index+1+c,h,v.index+1+v[0].length+c),v,A),r>=m))return r;while(v);return r}static findNextMatch(b,M,h,c){const r=M.parseSearchRequest();if(!r)return null;const a=new p(r.wordSeparators,r.regex);return r.regex.multiline?this.e(b,h,a,c):this.f(b,h,a,c)}static e(b,M,h,c){const r=new i.$Tr(M.lineNumber,1),a=b.getOffsetAt(r),A=b.getLineCount(),m=b.getValueInRange(new o.$Ur(r.lineNumber,r.column,A,b.getLineMaxColumn(A)),1),$=b.getEOL()===`\r
`?new E(m):null;h.reset(M.column-1);const w=h.next(m);return w?g(this.a(b,a,m,$,w.index,w[0]),w,c):M.lineNumber!==1||M.column!==1?this.e(b,new i.$Tr(1,1),h,c):null}static f(b,M,h,c){const r=b.getLineCount(),a=M.lineNumber,A=b.getLineContent(a),m=this.g(h,A,a,M.column,c);if(m)return m;for(let $=1;$<=r;$++){const w=(a+$-1)%r,v=b.getLineContent(w+1),y=this.g(h,v,w+1,1,c);if(y)return y}return null}static g(b,M,h,c,r){b.reset(c-1);const a=b.next(M);return a?g(new o.$Ur(h,a.index+1,h,a.index+1+a[0].length),a,r):null}static findPreviousMatch(b,M,h,c){const r=M.parseSearchRequest();if(!r)return null;const a=new p(r.wordSeparators,r.regex);return r.regex.multiline?this.h(b,h,a,c):this.j(b,h,a,c)}static h(b,M,h,c){const r=this.b(b,new o.$Ur(1,1,M.lineNumber,M.column),h,c,10*u);if(r.length>0)return r[r.length-1];const a=b.getLineCount();return M.lineNumber!==a||M.column!==b.getLineMaxColumn(a)?this.h(b,new i.$Tr(a,b.getLineMaxColumn(a)),h,c):null}static j(b,M,h,c){const r=b.getLineCount(),a=M.lineNumber,A=b.getLineContent(a).substring(0,M.column-1),m=this.k(h,A,a,c);if(m)return m;for(let $=1;$<=r;$++){const w=(r+a-$-1)%r,v=b.getLineContent(w+1),y=this.k(h,v,w+1,c);if(y)return y}return null}static k(b,M,h,c){let r=null,a;for(b.reset(0);a=b.next(M);)r=g(new o.$Ur(h,a.index+1,h,a.index+1+a[0].length),a,c);return r}}t.$_B=d;function f(R,b,M,h,c){if(h===0)return!0;const r=b.charCodeAt(h-1);if(R.get(r)!==0||r===13||r===10)return!0;if(c>0){const a=b.charCodeAt(h);if(R.get(a)!==0)return!0}return!1}function e(R,b,M,h,c){if(h+c===M)return!0;const r=b.charCodeAt(h+c);if(R.get(r)!==0||r===13||r===10)return!0;if(c>0){const a=b.charCodeAt(h+c-1);if(R.get(a)!==0)return!0}return!1}function N(R,b,M,h,c){return f(R,b,M,h,c)&&e(R,b,M,h,c)}t.$aC=N;class p{constructor(b,M){this._wordSeparators=b,this.a=M,this.b=-1,this.c=0}reset(b){this.a.lastIndex=b,this.b=-1,this.c=0}next(b){const M=b.length;let h;do{if(this.b+this.c===M||(h=this.a.exec(b),!h))return null;const c=h.index,r=h[0].length;if(c===this.b&&r===this.c){if(r===0){F.$Sd(b,M,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=r,!this._wordSeparators||N(this._wordSeparators,b,M,c,r))return h}while(h);return null}}t.$bC=p}),te(ne[52],ie([0,1,2,51,5,10,25]),function(z,t,F,_,i,o,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$dY=void 0;class u{static computeUnicodeHighlights(e,N,p){const R=p?p.startLineNumber:1,b=p?p.endLineNumber:e.getLineCount(),M=new g(N),h=M.getCandidateCodePoints();let c;h==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${s(Array.from(h))}`,"g");const r=new _.$bC(null,c),a=[];let A=!1,m,$=0,w=0,v=0;e:for(let y=R,I=b;y<=I;y++){const P=e.getLineContent(y),j=P.length;r.reset(0);do if(m=r.next(P),m){let x=m.index,W=m.index+m[0].length;if(x>0){const O=P.charCodeAt(x-1);i.$Pd(O)&&x--}if(W+1<j){const O=P.charCodeAt(W-1);i.$Pd(O)&&W++}const G=P.substring(x,W);let k=(0,L.$Qr)(x+1,L.$Nr,P,0);k&&k.endColumn<=x+1&&(k=null);const q=M.shouldHighlightNonBasicASCII(G,k?k.word:null);if(q!==0){q===3?$++:q===2?w++:q===1?v++:(0,o.$wb)(q);const O=1e3;if(a.length>=O){A=!0;break e}a.push(new F.$Ur(y,x+1,y,W+1))}}while(m)}return{ranges:a,hasMore:A,ambiguousCharacterCount:$,invisibleCharacterCount:w,nonBasicAsciiCharacterCount:v}}static computeUnicodeHighlightReason(e,N){const p=new g(N);switch(p.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const b=e.codePointAt(0),M=p.ambiguousCharacters.getPrimaryConfusable(b),h=i.$ge.getLocales().filter(c=>!i.$ge.getInstance(new Set([...N.allowedLocales,c])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(M),notAmbiguousInLocales:h}}case 1:return{kind:2}}}}t.$dY=u;function s(f,e){return`[${i.$pd(f.map(p=>String.fromCodePoint(p)).join(""))}]`}var l;(function(f){f[f.Ambiguous=0]="Ambiguous",f[f.Invisible=1]="Invisible",f[f.NonBasicAscii=2]="NonBasicAscii"})(l||(t.UnicodeHighlighterReasonKind=l={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.$ge.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const N of i.$he.codePoints)E(String.fromCodePoint(N))||e.add(N);if(this.b.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.a)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const p=e.codePointAt(0);if(this.a.has(p))return 0;if(this.b.nonBasicASCII)return 1;let R=!1,b=!1;if(N)for(const M of N){const h=M.codePointAt(0),c=i.$1d(M);R=R||c,!c&&!this.ambiguousCharacters.isAmbiguous(h)&&!i.$he.isInvisibleCharacter(h)&&(b=!0)}return!R&&b?0:this.b.invisibleCharacters&&!E(e)&&i.$he.isInvisibleCharacter(p)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(p)?3:0}}function E(f){return f===" "||f===`
`||f==="	"}var d;(function(f){f[f.None=0]="None",f[f.NonBasicASCII=1]="NonBasicASCII",f[f.Invisible=2]="Invisible",f[f.Ambiguous=3]="Ambiguous"})(d||(d={}))}),te(ne[53],ie([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var F;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(F||(t.AccessibilitySupport=F={}));var _;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(_||(t.CodeActionTriggerType=_={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var o;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var L;(function(n){n[n.Deprecated=1]="Deprecated"})(L||(t.CompletionItemTag=L={}));var u;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(t.CompletionTriggerKind=u={}));var s;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(s||(t.ContentWidgetPositionPreference=s={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var E;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var d;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(d||(t.EditorAutoIndentStrategy=d={}));var f;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=8]="autoClosingDelete",n[n.autoClosingOvertype=9]="autoClosingOvertype",n[n.autoClosingQuotes=10]="autoClosingQuotes",n[n.autoIndent=11]="autoIndent",n[n.automaticLayout=12]="automaticLayout",n[n.autoSurround=13]="autoSurround",n[n.bracketPairColorization=14]="bracketPairColorization",n[n.guides=15]="guides",n[n.codeLens=16]="codeLens",n[n.codeLensFontFamily=17]="codeLensFontFamily",n[n.codeLensFontSize=18]="codeLensFontSize",n[n.colorDecorators=19]="colorDecorators",n[n.colorDecoratorsLimit=20]="colorDecoratorsLimit",n[n.columnSelection=21]="columnSelection",n[n.comments=22]="comments",n[n.contextmenu=23]="contextmenu",n[n.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",n[n.cursorBlinking=25]="cursorBlinking",n[n.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",n[n.cursorStyle=27]="cursorStyle",n[n.cursorSurroundingLines=28]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",n[n.cursorWidth=30]="cursorWidth",n[n.disableLayerHinting=31]="disableLayerHinting",n[n.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",n[n.domReadOnly=33]="domReadOnly",n[n.dragAndDrop=34]="dragAndDrop",n[n.dropIntoEditor=35]="dropIntoEditor",n[n.emptySelectionClipboard=36]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",n[n.extraEditorClassName=38]="extraEditorClassName",n[n.fastScrollSensitivity=39]="fastScrollSensitivity",n[n.find=40]="find",n[n.fixedOverflowWidgets=41]="fixedOverflowWidgets",n[n.folding=42]="folding",n[n.foldingStrategy=43]="foldingStrategy",n[n.foldingHighlight=44]="foldingHighlight",n[n.foldingImportsByDefault=45]="foldingImportsByDefault",n[n.foldingMaximumRegions=46]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=48]="fontFamily",n[n.fontInfo=49]="fontInfo",n[n.fontLigatures=50]="fontLigatures",n[n.fontSize=51]="fontSize",n[n.fontWeight=52]="fontWeight",n[n.fontVariations=53]="fontVariations",n[n.formatOnPaste=54]="formatOnPaste",n[n.formatOnType=55]="formatOnType",n[n.glyphMargin=56]="glyphMargin",n[n.gotoLocation=57]="gotoLocation",n[n.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",n[n.hover=59]="hover",n[n.inDiffEditor=60]="inDiffEditor",n[n.inlineSuggest=61]="inlineSuggest",n[n.letterSpacing=62]="letterSpacing",n[n.lightbulb=63]="lightbulb",n[n.lineDecorationsWidth=64]="lineDecorationsWidth",n[n.lineHeight=65]="lineHeight",n[n.lineNumbers=66]="lineNumbers",n[n.lineNumbersMinChars=67]="lineNumbersMinChars",n[n.linkedEditing=68]="linkedEditing",n[n.links=69]="links",n[n.matchBrackets=70]="matchBrackets",n[n.minimap=71]="minimap",n[n.mouseStyle=72]="mouseStyle",n[n.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=74]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",n[n.multiCursorModifier=76]="multiCursorModifier",n[n.multiCursorPaste=77]="multiCursorPaste",n[n.multiCursorLimit=78]="multiCursorLimit",n[n.occurrencesHighlight=79]="occurrencesHighlight",n[n.overviewRulerBorder=80]="overviewRulerBorder",n[n.overviewRulerLanes=81]="overviewRulerLanes",n[n.padding=82]="padding",n[n.pasteAs=83]="pasteAs",n[n.parameterHints=84]="parameterHints",n[n.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",n[n.quickSuggestions=87]="quickSuggestions",n[n.quickSuggestionsDelay=88]="quickSuggestionsDelay",n[n.readOnly=89]="readOnly",n[n.readOnlyMessage=90]="readOnlyMessage",n[n.renameOnType=91]="renameOnType",n[n.renderControlCharacters=92]="renderControlCharacters",n[n.renderFinalNewline=93]="renderFinalNewline",n[n.renderLineHighlight=94]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=96]="renderValidationDecorations",n[n.renderWhitespace=97]="renderWhitespace",n[n.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",n[n.roundedSelection=99]="roundedSelection",n[n.rulers=100]="rulers",n[n.scrollbar=101]="scrollbar",n[n.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=103]="scrollBeyondLastLine",n[n.scrollPredominantAxis=104]="scrollPredominantAxis",n[n.selectionClipboard=105]="selectionClipboard",n[n.selectionHighlight=106]="selectionHighlight",n[n.selectOnLineNumbers=107]="selectOnLineNumbers",n[n.showFoldingControls=108]="showFoldingControls",n[n.showUnused=109]="showUnused",n[n.snippetSuggestions=110]="snippetSuggestions",n[n.smartSelect=111]="smartSelect",n[n.smoothScrolling=112]="smoothScrolling",n[n.stickyScroll=113]="stickyScroll",n[n.stickyTabStops=114]="stickyTabStops",n[n.stopRenderingLineAfter=115]="stopRenderingLineAfter",n[n.suggest=116]="suggest",n[n.suggestFontSize=117]="suggestFontSize",n[n.suggestLineHeight=118]="suggestLineHeight",n[n.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",n[n.suggestSelection=120]="suggestSelection",n[n.tabCompletion=121]="tabCompletion",n[n.tabIndex=122]="tabIndex",n[n.unicodeHighlighting=123]="unicodeHighlighting",n[n.unusualLineTerminators=124]="unusualLineTerminators",n[n.useShadowDOM=125]="useShadowDOM",n[n.useTabStops=126]="useTabStops",n[n.wordBreak=127]="wordBreak",n[n.wordSeparators=128]="wordSeparators",n[n.wordWrap=129]="wordWrap",n[n.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=132]="wordWrapColumn",n[n.wordWrapOverride1=133]="wordWrapOverride1",n[n.wordWrapOverride2=134]="wordWrapOverride2",n[n.wrappingIndent=135]="wrappingIndent",n[n.wrappingStrategy=136]="wrappingStrategy",n[n.showDeprecated=137]="showDeprecated",n[n.inlayHints=138]="inlayHints",n[n.editorClassName=139]="editorClassName",n[n.pixelRatio=140]="pixelRatio",n[n.tabFocusMode=141]="tabFocusMode",n[n.layoutInfo=142]="layoutInfo",n[n.wrappingInfo=143]="wrappingInfo",n[n.defaultColorDecorators=144]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(f||(t.EditorOption=f={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var N;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(N||(t.EndOfLineSequence=N={}));var p;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(p||(t.GlyphMarginLane=p={}));var R;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(R||(t.IndentAction=R={}));var b;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(b||(t.InjectedTextCursorStops=b={}));var M;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(M||(t.InlayHintKind=M={}));var h;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(h||(t.InlineCompletionTriggerKind=h={}));var c;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(c||(t.KeyCode=c={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var A;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(A||(t.MinimapPosition=A={}));var m;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m||(t.MouseTargetType=m={}));var $;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})($||(t.OverlayWidgetPositionPreference=$={}));var w;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(w||(t.OverviewRulerLane=w={}));var v;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(v||(t.PositionAffinity=v={}));var y;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(y||(t.RenderLineNumbersType=y={}));var I;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(I||(t.RenderMinimap=I={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var j;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(j||(t.ScrollbarVisibility=j={}));var x;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(x||(t.SelectionDirection=x={}));var W;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(W||(t.SignatureHelpTriggerKind=W={}));var G;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(G||(t.SymbolKind=G={}));var k;(function(n){n[n.Deprecated=1]="Deprecated"})(k||(t.SymbolTag=k={}));var q;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(q||(t.TextEditorCursorBlinkingStyle=q={}));var O;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(O||(t.TextEditorCursorStyle=O={}));var B;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(B||(t.TrackedRangeStickiness=B={}));var X;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(X||(t.WrappingIndent=X={}))}),te(ne[54],ie([0,1,8,7]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ks=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new F.$ec,this.onDidChange=this.c.event,this.d=null}handleChange(u){this.c.fire({changedLanguages:u,changedColorMap:!1})}register(u,s){return this.a.set(u,s),this.handleChange([u]),(0,_.$jb)(()=>{this.a.get(u)===s&&(this.a.delete(u),this.handleChange([u]))})}get(u){return this.a.get(u)||null}registerFactory(u,s){this.b.get(u)?.dispose();const l=new o(this,u,s);return this.b.set(u,l),(0,_.$jb)(()=>{const g=this.b.get(u);!g||g!==l||(this.b.delete(u),g.dispose())})}async getOrCreate(u){const s=this.get(u);if(s)return s;const l=this.b.get(u);return!l||l.isResolved?null:(await l.resolve(),this.get(u))}isResolved(u){if(this.get(u))return!0;const l=this.b.get(u);return!!(!l||l.isResolved)}setColorMap(u){this.d=u,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$ks=i;class o extends _.$lb{get isResolved(){return this.c}constructor(u,s,l){super(),this.f=u,this.g=s,this.h=l,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const u=await this.h.tokenizationSupport;this.c=!0,u&&!this.a&&this.B(this.f.register(this.g,u))}}}),te(ne[55],ie([56,57]),function(z,t){return z.create("vs/base/common/platform",t)}),te(ne[13],ie([0,1,55]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let _=!1,i=!1,o=!1,L=!1,u=!1,s=!1,l=!1,g=!1,E=!1,d=!1,f,e=t.$f,N=t.$f,p,R;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?b=t.$g.vscode.process:typeof process<"u"&&(b=process);const M=typeof b?.versions?.electron=="string",h=M&&b?.type==="renderer";if(typeof navigator=="object"&&!h)R=navigator.userAgent,_=R.indexOf("Windows")>=0,i=R.indexOf("Macintosh")>=0,g=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=R.indexOf("Linux")>=0,d=R?.indexOf("Mobi")>=0,s=!0,f=F.getConfiguredDefaultLocale(F.localize(0,null))||t.$f,e=f,N=navigator.language;else if(typeof b=="object"){_=b.platform==="win32",i=b.platform==="darwin",o=b.platform==="linux",L=o&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,l=M,E=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t.$f,e=t.$f;const y=b.env.VSCODE_NLS_CONFIG;if(y)try{const I=JSON.parse(y),P=I.availableLanguages["*"];f=I.locale,N=I.osLocale,e=P||t.$f,p=I._translationsConfigFile}catch{}u=!0}else console.error("Unable to resolve platform.");var c;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(c||(t.Platform=c={}));function r(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=r;let a=0;i?a=1:_?a=3:o&&(a=2),t.$i=_,t.$j=i,t.$k=o,t.$l=L,t.$m=u,t.$n=l,t.$o=s,t.$p=s&&typeof t.$g.importScripts=="function",t.$q=g,t.$r=d,t.$s=E,t.$t=a,t.$u=R,t.$v=e;var A;(function(y){function I(){return t.$v}y.value=I;function P(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}y.isDefaultVariant=P;function j(){return t.$v==="en"}y.isDefault=j})(A||(t.Language=A={})),t.$w=f,t.$x=N,t.$y=p,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const y=[];t.$g.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let j=0,x=y.length;j<x;j++){const W=y[j];if(W.id===P.data.vscodeScheduleAsyncWork){y.splice(j,1),W.callback();return}}});let I=0;return P=>{const j=++I;y.push({id:j,callback:P}),t.$g.postMessage({vscodeScheduleAsyncWork:j},"*")}}return y=>setTimeout(y)})();var m;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(m||(t.OperatingSystem=m={})),t.OS=i||g?2:_?1:3;let $=!0,w=!1;function v(){if(!w){w=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,$=new Uint16Array(y.buffer)[0]===(2<<8)+1}return $}t.$C=v,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),te(ne[58],ie([0,1,13]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.env=t.cwd=void 0;let _;if(typeof F.$g.vscode<"u"&&typeof F.$g.vscode.process<"u"){const i=F.$g.vscode.process;_={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:_={get platform(){return F.$i?"win32":F.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=_.cwd,t.env=_.env,t.$2c=_.platform,t.$3c=_.arch}),te(ne[59],ie([0,1,58]),function(z,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fd=t.sep=t.$dd=t.$cd=t.$bd=t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.$5c=t.$4c=void 0;const _=65,i=97,o=90,L=122,u=46,s=47,l=92,g=58,E=63;class d extends Error{constructor(a,A,m){let $;typeof A=="string"&&A.indexOf("not ")===0?($="must not be",A=A.replace(/^not /,"")):$="must be";const w=a.indexOf(".")!==-1?"property":"argument";let v=`The "${a}" ${w} ${$} of type ${A}`;v+=`. Received type ${typeof m}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function f(r,a){if(r===null||typeof r!="object")throw new d(a,"Object",r)}function e(r,a){if(typeof r!="string")throw new d(a,"string",r)}const N=F.$2c==="win32";function p(r){return r===s||r===l}function R(r){return r===s}function b(r){return r>=_&&r<=o||r>=i&&r<=L}function M(r,a,A,m){let $="",w=0,v=-1,y=0,I=0;for(let P=0;P<=r.length;++P){if(P<r.length)I=r.charCodeAt(P);else{if(m(I))break;I=s}if(m(I)){if(!(v===P-1||y===1))if(y===2){if($.length<2||w!==2||$.charCodeAt($.length-1)!==u||$.charCodeAt($.length-2)!==u){if($.length>2){const j=$.lastIndexOf(A);j===-1?($="",w=0):($=$.slice(0,j),w=$.length-1-$.lastIndexOf(A)),v=P,y=0;continue}else if($.length!==0){$="",w=0,v=P,y=0;continue}}a&&($+=$.length>0?`${A}..`:"..",w=2)}else $.length>0?$+=`${A}${r.slice(v+1,P)}`:$=r.slice(v+1,P),w=P-v-1;v=P,y=0}else I===u&&y!==-1?++y:y=-1}return $}function h(r,a){f(a,"pathObject");const A=a.dir||a.root,m=a.base||`${a.name||""}${a.ext||""}`;return A?A===a.root?`${A}${m}`:`${A}${r}${m}`:m}t.$4c={resolve(...r){let a="",A="",m=!1;for(let $=r.length-1;$>=-1;$--){let w;if($>=0){if(w=r[$],e(w,"path"),w.length===0)continue}else a.length===0?w=F.cwd():(w=F.env[`=${a}`]||F.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==a.toLowerCase()&&w.charCodeAt(2)===l)&&(w=`${a}\\`));const v=w.length;let y=0,I="",P=!1;const j=w.charCodeAt(0);if(v===1)p(j)&&(y=1,P=!0);else if(p(j))if(P=!0,p(w.charCodeAt(1))){let x=2,W=x;for(;x<v&&!p(w.charCodeAt(x));)x++;if(x<v&&x!==W){const G=w.slice(W,x);for(W=x;x<v&&p(w.charCodeAt(x));)x++;if(x<v&&x!==W){for(W=x;x<v&&!p(w.charCodeAt(x));)x++;(x===v||x!==W)&&(I=`\\\\${G}\\${w.slice(W,x)}`,y=x)}}}else y=1;else b(j)&&w.charCodeAt(1)===g&&(I=w.slice(0,2),y=2,v>2&&p(w.charCodeAt(2))&&(P=!0,y=3));if(I.length>0)if(a.length>0){if(I.toLowerCase()!==a.toLowerCase())continue}else a=I;if(m){if(a.length>0)break}else if(A=`${w.slice(y)}\\${A}`,m=P,P&&a.length>0)break}return A=M(A,!m,"\\",p),m?`${a}\\${A}`:`${a}${A}`||"."},normalize(r){e(r,"path");const a=r.length;if(a===0)return".";let A=0,m,$=!1;const w=r.charCodeAt(0);if(a===1)return R(w)?"\\":r;if(p(w))if($=!0,p(r.charCodeAt(1))){let y=2,I=y;for(;y<a&&!p(r.charCodeAt(y));)y++;if(y<a&&y!==I){const P=r.slice(I,y);for(I=y;y<a&&p(r.charCodeAt(y));)y++;if(y<a&&y!==I){for(I=y;y<a&&!p(r.charCodeAt(y));)y++;if(y===a)return`\\\\${P}\\${r.slice(I)}\\`;y!==I&&(m=`\\\\${P}\\${r.slice(I,y)}`,A=y)}}}else A=1;else b(w)&&r.charCodeAt(1)===g&&(m=r.slice(0,2),A=2,a>2&&p(r.charCodeAt(2))&&($=!0,A=3));let v=A<a?M(r.slice(A),!$,"\\",p):"";return v.length===0&&!$&&(v="."),v.length>0&&p(r.charCodeAt(a-1))&&(v+="\\"),m===void 0?$?`\\${v}`:v:$?`${m}\\${v}`:`${m}${v}`},isAbsolute(r){e(r,"path");const a=r.length;if(a===0)return!1;const A=r.charCodeAt(0);return p(A)||a>2&&b(A)&&r.charCodeAt(1)===g&&p(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let a,A;for(let w=0;w<r.length;++w){const v=r[w];e(v,"path"),v.length>0&&(a===void 0?a=A=v:a+=`\\${v}`)}if(a===void 0)return".";let m=!0,$=0;if(typeof A=="string"&&p(A.charCodeAt(0))){++$;const w=A.length;w>1&&p(A.charCodeAt(1))&&(++$,w>2&&(p(A.charCodeAt(2))?++$:m=!1))}if(m){for(;$<a.length&&p(a.charCodeAt($));)$++;$>=2&&(a=`\\${a.slice($)}`)}return t.$4c.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a)return"";const A=t.$4c.resolve(r),m=t.$4c.resolve(a);if(A===m||(r=A.toLowerCase(),a=m.toLowerCase(),r===a))return"";let $=0;for(;$<r.length&&r.charCodeAt($)===l;)$++;let w=r.length;for(;w-1>$&&r.charCodeAt(w-1)===l;)w--;const v=w-$;let y=0;for(;y<a.length&&a.charCodeAt(y)===l;)y++;let I=a.length;for(;I-1>y&&a.charCodeAt(I-1)===l;)I--;const P=I-y,j=v<P?v:P;let x=-1,W=0;for(;W<j;W++){const k=r.charCodeAt($+W);if(k!==a.charCodeAt(y+W))break;k===l&&(x=W)}if(W!==j){if(x===-1)return m}else{if(P>j){if(a.charCodeAt(y+W)===l)return m.slice(y+W+1);if(W===2)return m.slice(y+W)}v>j&&(r.charCodeAt($+W)===l?x=W:W===2&&(x=3)),x===-1&&(x=0)}let G="";for(W=$+x+1;W<=w;++W)(W===w||r.charCodeAt(W)===l)&&(G+=G.length===0?"..":"\\..");return y+=x,G.length>0?`${G}${m.slice(y,I)}`:(m.charCodeAt(y)===l&&++y,m.slice(y,I))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const a=t.$4c.resolve(r);if(a.length<=2)return r;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const A=a.charCodeAt(2);if(A!==E&&A!==u)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return r},dirname(r){e(r,"path");const a=r.length;if(a===0)return".";let A=-1,m=0;const $=r.charCodeAt(0);if(a===1)return p($)?r:".";if(p($)){if(A=m=1,p(r.charCodeAt(1))){let y=2,I=y;for(;y<a&&!p(r.charCodeAt(y));)y++;if(y<a&&y!==I){for(I=y;y<a&&p(r.charCodeAt(y));)y++;if(y<a&&y!==I){for(I=y;y<a&&!p(r.charCodeAt(y));)y++;if(y===a)return r;y!==I&&(A=m=y+1)}}}}else b($)&&r.charCodeAt(1)===g&&(A=a>2&&p(r.charCodeAt(2))?3:2,m=A);let w=-1,v=!0;for(let y=a-1;y>=m;--y)if(p(r.charCodeAt(y))){if(!v){w=y;break}}else v=!1;if(w===-1){if(A===-1)return".";w=A}return r.slice(0,w)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let A=0,m=-1,$=!0,w;if(r.length>=2&&b(r.charCodeAt(0))&&r.charCodeAt(1)===g&&(A=2),a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let v=a.length-1,y=-1;for(w=r.length-1;w>=A;--w){const I=r.charCodeAt(w);if(p(I)){if(!$){A=w+1;break}}else y===-1&&($=!1,y=w+1),v>=0&&(I===a.charCodeAt(v)?--v===-1&&(m=w):(v=-1,m=y))}return A===m?m=y:m===-1&&(m=r.length),r.slice(A,m)}for(w=r.length-1;w>=A;--w)if(p(r.charCodeAt(w))){if(!$){A=w+1;break}}else m===-1&&($=!1,m=w+1);return m===-1?"":r.slice(A,m)},extname(r){e(r,"path");let a=0,A=-1,m=0,$=-1,w=!0,v=0;r.length>=2&&r.charCodeAt(1)===g&&b(r.charCodeAt(0))&&(a=m=2);for(let y=r.length-1;y>=a;--y){const I=r.charCodeAt(y);if(p(I)){if(!w){m=y+1;break}continue}$===-1&&(w=!1,$=y+1),I===u?A===-1?A=y:v!==1&&(v=1):A!==-1&&(v=-1)}return A===-1||$===-1||v===0||v===1&&A===$-1&&A===m+1?"":r.slice(A,$)},format:h.bind(null,"\\"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const A=r.length;let m=0,$=r.charCodeAt(0);if(A===1)return p($)?(a.root=a.dir=r,a):(a.base=a.name=r,a);if(p($)){if(m=1,p(r.charCodeAt(1))){let x=2,W=x;for(;x<A&&!p(r.charCodeAt(x));)x++;if(x<A&&x!==W){for(W=x;x<A&&p(r.charCodeAt(x));)x++;if(x<A&&x!==W){for(W=x;x<A&&!p(r.charCodeAt(x));)x++;x===A?m=x:x!==W&&(m=x+1)}}}}else if(b($)&&r.charCodeAt(1)===g){if(A<=2)return a.root=a.dir=r,a;if(m=2,p(r.charCodeAt(2))){if(A===3)return a.root=a.dir=r,a;m=3}}m>0&&(a.root=r.slice(0,m));let w=-1,v=m,y=-1,I=!0,P=r.length-1,j=0;for(;P>=m;--P){if($=r.charCodeAt(P),p($)){if(!I){v=P+1;break}continue}y===-1&&(I=!1,y=P+1),$===u?w===-1?w=P:j!==1&&(j=1):w!==-1&&(j=-1)}return y!==-1&&(w===-1||j===0||j===1&&w===y-1&&w===v+1?a.base=a.name=r.slice(v,y):(a.name=r.slice(v,w),a.base=r.slice(v,y),a.ext=r.slice(w,y))),v>0&&v!==m?a.dir=r.slice(0,v-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(N){const r=/\\/g;return()=>{const a=F.cwd().replace(r,"/");return a.slice(a.indexOf("/"))}}return()=>F.cwd()})();t.$5c={resolve(...r){let a="",A=!1;for(let m=r.length-1;m>=-1&&!A;m--){const $=m>=0?r[m]:c();e($,"path"),$.length!==0&&(a=`${$}/${a}`,A=$.charCodeAt(0)===s)}return a=M(a,!A,"/",R),A?`/${a}`:a.length>0?a:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s,A=r.charCodeAt(r.length-1)===s;return r=M(r,!a,"/",R),r.length===0?a?"/":A?"./":".":(A&&(r+="/"),a?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===s},join(...r){if(r.length===0)return".";let a;for(let A=0;A<r.length;++A){const m=r[A];e(m,"path"),m.length>0&&(a===void 0?a=m:a+=`/${m}`)}return a===void 0?".":t.$5c.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a||(r=t.$5c.resolve(r),a=t.$5c.resolve(a),r===a))return"";const A=1,m=r.length,$=m-A,w=1,v=a.length-w,y=$<v?$:v;let I=-1,P=0;for(;P<y;P++){const x=r.charCodeAt(A+P);if(x!==a.charCodeAt(w+P))break;x===s&&(I=P)}if(P===y)if(v>y){if(a.charCodeAt(w+P)===s)return a.slice(w+P+1);if(P===0)return a.slice(w+P)}else $>y&&(r.charCodeAt(A+P)===s?I=P:P===0&&(I=0));let j="";for(P=A+I+1;P<=m;++P)(P===m||r.charCodeAt(P)===s)&&(j+=j.length===0?"..":"/..");return`${j}${a.slice(w+I)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s;let A=-1,m=!0;for(let $=r.length-1;$>=1;--$)if(r.charCodeAt($)===s){if(!m){A=$;break}}else m=!1;return A===-1?a?"/":".":a&&A===1?"//":r.slice(0,A)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let A=0,m=-1,$=!0,w;if(a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let v=a.length-1,y=-1;for(w=r.length-1;w>=0;--w){const I=r.charCodeAt(w);if(I===s){if(!$){A=w+1;break}}else y===-1&&($=!1,y=w+1),v>=0&&(I===a.charCodeAt(v)?--v===-1&&(m=w):(v=-1,m=y))}return A===m?m=y:m===-1&&(m=r.length),r.slice(A,m)}for(w=r.length-1;w>=0;--w)if(r.charCodeAt(w)===s){if(!$){A=w+1;break}}else m===-1&&($=!1,m=w+1);return m===-1?"":r.slice(A,m)},extname(r){e(r,"path");let a=-1,A=0,m=-1,$=!0,w=0;for(let v=r.length-1;v>=0;--v){const y=r.charCodeAt(v);if(y===s){if(!$){A=v+1;break}continue}m===-1&&($=!1,m=v+1),y===u?a===-1?a=v:w!==1&&(w=1):a!==-1&&(w=-1)}return a===-1||m===-1||w===0||w===1&&a===m-1&&a===A+1?"":r.slice(a,m)},format:h.bind(null,"/"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const A=r.charCodeAt(0)===s;let m;A?(a.root="/",m=1):m=0;let $=-1,w=0,v=-1,y=!0,I=r.length-1,P=0;for(;I>=m;--I){const j=r.charCodeAt(I);if(j===s){if(!y){w=I+1;break}continue}v===-1&&(y=!1,v=I+1),j===u?$===-1?$=I:P!==1&&(P=1):$!==-1&&(P=-1)}if(v!==-1){const j=w===0&&A?1:w;$===-1||P===0||P===1&&$===v-1&&$===w+1?a.base=a.name=r.slice(j,v):(a.name=r.slice(j,$),a.base=r.slice(j,v),a.ext=r.slice($,v))}return w>0?a.dir=r.slice(0,w-1):A&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.$5c.win32=t.$4c.win32=t.$4c,t.$5c.posix=t.$4c.posix=t.$5c,t.$6c=N?t.$4c.normalize:t.$5c.normalize,t.$7c=N?t.$4c.isAbsolute:t.$5c.isAbsolute,t.$8c=N?t.$4c.join:t.$5c.join,t.$9c=N?t.$4c.resolve:t.$5c.resolve,t.$0c=N?t.$4c.relative:t.$5c.relative,t.$$c=N?t.$4c.dirname:t.$5c.dirname,t.$_c=N?t.$4c.basename:t.$5c.basename,t.$ad=N?t.$4c.extname:t.$5c.extname,t.$bd=N?t.$4c.format:t.$5c.format,t.$cd=N?t.$4c.parse:t.$5c.parse,t.$dd=N?t.$4c.toNamespacedPath:t.$5c.toNamespacedPath,t.sep=N?t.$4c.sep:t.$5c.sep,t.$fd=N?t.$4c.delimiter:t.$5c.delimiter}),te(ne[14],ie([0,1,59,13]),function(z,t,F,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Se=t.$Re=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,o=/^\//,L=/^\/\//;function u(m,$){if(!m.scheme&&$)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!i.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!o.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function s(m,$){return!m&&!$?"file":m}function l(m,$){switch(m){case"https":case"http":case"file":$?$[0]!==E&&($=E+$):$=E;break}return $}const g="",E="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri($){return $ instanceof f?!0:$?typeof $.authority=="string"&&typeof $.fragment=="string"&&typeof $.path=="string"&&typeof $.query=="string"&&typeof $.scheme=="string"&&typeof $.fsPath=="string"&&typeof $.with=="function"&&typeof $.toString=="function":!1}constructor($,w,v,y,I,P=!1){typeof $=="object"?(this.scheme=$.scheme||g,this.authority=$.authority||g,this.path=$.path||g,this.query=$.query||g,this.fragment=$.fragment||g):(this.scheme=s($,P),this.authority=w||g,this.path=l(this.scheme,v||g),this.query=y||g,this.fragment=I||g,u(this,P))}get fsPath(){return h(this,!1)}with($){if(!$)return this;let{scheme:w,authority:v,path:y,query:I,fragment:P}=$;return w===void 0?w=this.scheme:w===null&&(w=g),v===void 0?v=this.authority:v===null&&(v=g),y===void 0?y=this.path:y===null&&(y=g),I===void 0?I=this.query:I===null&&(I=g),P===void 0?P=this.fragment:P===null&&(P=g),w===this.scheme&&v===this.authority&&y===this.path&&I===this.query&&P===this.fragment?this:new p(w,v,y,I,P)}static parse($,w=!1){const v=d.exec($);return v?new p(v[2]||g,A(v[4]||g),A(v[5]||g),A(v[7]||g),A(v[9]||g),w):new p(g,g,g,g,g)}static file($){let w=g;if(_.$i&&($=$.replace(/\\/g,E)),$[0]===E&&$[1]===E){const v=$.indexOf(E,2);v===-1?(w=$.substring(2),$=E):(w=$.substring(2,v),$=$.substring(v)||E)}return new p("file",w,$,g,g)}static from($,w){return new p($.scheme,$.authority,$.path,$.query,$.fragment,w)}static joinPath($,...w){if(!$.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return _.$i&&$.scheme==="file"?v=f.file(F.$4c.join(h($,!0),...w)).path:v=F.$5c.join($.path,...w),$.with({path:v})}toString($=!1){return c(this,$)}toJSON(){return this}static revive($){if($){if($ instanceof f)return $;{const w=new p($);return w._formatted=$.external??null,w._fsPath=$._sep===N?$.fsPath??null:null,w}}else return $}}t.URI=f;function e(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}t.$Re=e;const N=_.$i?1:void 0;class p extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString($=!1){return $?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const $={$mid:1};return this._fsPath&&($.fsPath=this._fsPath,$._sep=N),this._formatted&&($.external=this._formatted),this.path&&($.path=this.path),this.scheme&&($.scheme=this.scheme),this.authority&&($.authority=this.authority),this.query&&($.query=this.query),this.fragment&&($.fragment=this.fragment),$}}const R={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(m,$,w){let v,y=-1;for(let I=0;I<m.length;I++){const P=m.charCodeAt(I);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||$&&P===47||w&&P===91||w&&P===93||w&&P===58)y!==-1&&(v+=encodeURIComponent(m.substring(y,I)),y=-1),v!==void 0&&(v+=m.charAt(I));else{v===void 0&&(v=m.substr(0,I));const j=R[P];j!==void 0?(y!==-1&&(v+=encodeURIComponent(m.substring(y,I)),y=-1),v+=j):y===-1&&(y=I)}}return y!==-1&&(v+=encodeURIComponent(m.substring(y))),v!==void 0?v:m}function M(m){let $;for(let w=0;w<m.length;w++){const v=m.charCodeAt(w);v===35||v===63?($===void 0&&($=m.substr(0,w)),$+=R[v]):$!==void 0&&($+=m[w])}return $!==void 0?$:m}function h(m,$){let w;return m.authority&&m.path.length>1&&m.scheme==="file"?w=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?$?w=m.path.substr(1):w=m.path[1].toLowerCase()+m.path.substr(2):w=m.path,_.$i&&(w=w.replace(/\//g,"\\")),w}t.$Se=h;function c(m,$){const w=$?M:b;let v="",{scheme:y,authority:I,path:P,query:j,fragment:x}=m;if(y&&(v+=y,v+=":"),(I||y==="file")&&(v+=E,v+=E),I){let W=I.indexOf("@");if(W!==-1){const G=I.substr(0,W);I=I.substr(W+1),W=G.lastIndexOf(":"),W===-1?v+=w(G,!1,!1):(v+=w(G.substr(0,W),!1,!1),v+=":",v+=w(G.substr(W+1),!1,!0)),v+="@"}I=I.toLowerCase(),W=I.lastIndexOf(":"),W===-1?v+=w(I,!1,!0):(v+=w(I.substr(0,W),!1,!0),v+=I.substr(W))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const W=P.charCodeAt(1);W>=65&&W<=90&&(P=`/${String.fromCharCode(W+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const W=P.charCodeAt(0);W>=65&&W<=90&&(P=`${String.fromCharCode(W+32)}:${P.substr(2)}`)}v+=w(P,!0,!1)}return j&&(v+="?",v+=w(j,!1,!1)),x&&(v+="#",v+=$?x:b(x,!1,!1)),v}function r(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+r(m.substr(3)):m}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(m){return m.match(a)?m.replace(a,$=>r($)):m}}),te(ne[64],ie([0,1,3,8,7,11,13,5]),function(z,t,F,_,i,o,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const s="$initialize";let l=!1;function g(A){L.$o&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(A.message))}t.logOnceWebWorkerWarning=g;var E;(function(A){A[A.Request=0]="Request",A[A.Reply=1]="Reply",A[A.SubscribeEvent=2]="SubscribeEvent",A[A.Event=3]="Event",A[A.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class d{constructor(m,$,w,v){this.vsWorker=m,this.req=$,this.method=w,this.args=v,this.type=0}}class f{constructor(m,$,w,v){this.vsWorker=m,this.seq=$,this.res=w,this.err=v,this.type=1}}class e{constructor(m,$,w,v){this.vsWorker=m,this.req=$,this.eventName=w,this.arg=v,this.type=2}}class N{constructor(m,$,w){this.vsWorker=m,this.req=$,this.event=w,this.type=3}}class p{constructor(m,$){this.vsWorker=m,this.req=$,this.type=4}}class R{constructor(m){this.a=-1,this.g=m,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(m){this.a=m}sendMessage(m,$){const w=String(++this.b);return new Promise((v,y)=>{this.c[w]={resolve:v,reject:y},this.o(new d(this.a,w,m,$))})}listen(m,$){let w=null;const v=new _.$ec({onWillAddFirstListener:()=>{w=String(++this.b),this.d.set(w,v),this.o(new e(this.a,w,m,$))},onDidRemoveLastListener:()=>{this.d.delete(w),this.o(new p(this.a,w)),w=null}});return v.event}handleMessage(m){!m||!m.vsWorker||this.a!==-1&&m.vsWorker!==this.a||this.h(m)}h(m){switch(m.type){case 1:return this.j(m);case 0:return this.k(m);case 2:return this.l(m);case 3:return this.m(m);case 4:return this.n(m)}}j(m){if(!this.c[m.seq]){console.warn("Got reply to unknown seq");return}const $=this.c[m.seq];if(delete this.c[m.seq],m.err){let w=m.err;m.err.$isError&&(w=new Error,w.name=m.err.name,w.message=m.err.message,w.stack=m.err.stack),$.reject(w);return}$.resolve(m.res)}k(m){const $=m.req;this.g.handleMessage(m.method,m.args).then(v=>{this.o(new f(this.a,$,v,void 0))},v=>{v.detail instanceof Error&&(v.detail=(0,F.$1)(v.detail)),this.o(new f(this.a,$,void 0,(0,F.$1)(v)))})}l(m){const $=m.req,w=this.g.handleEvent(m.eventName,m.arg)(v=>{this.o(new N(this.a,$,v))});this.f.set($,w)}m(m){if(!this.d.has(m.req)){console.warn("Got event for unknown req");return}this.d.get(m.req).fire(m.event)}n(m){if(!this.f.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(m.req).dispose(),this.f.delete(m.req)}o(m){const $=[];if(m.type===0)for(let w=0;w<m.args.length;w++)m.args[w]instanceof ArrayBuffer&&$.push(m.args[w]);else m.type===1&&m.res instanceof ArrayBuffer&&$.push(m.res);this.g.sendMessage(m,$)}}class b extends i.$lb{constructor(m,$,w){super();let v=null;this.a=this.B(m.create("vs/base/common/worker/simpleWorker",W=>{this.c.handleMessage(W)},W=>{v?.(W)})),this.c=new R({sendMessage:(W,G)=>{this.a.postMessage(W,G)},handleMessage:(W,G)=>{if(typeof w[W]!="function")return Promise.reject(new Error("Missing method "+W+" on main thread host."));try{return Promise.resolve(w[W].apply(w,G))}catch(k){return Promise.reject(k)}},handleEvent:(W,G)=>{if(h(W)){const k=w[W].call(w,G);if(typeof k!="function")throw new Error(`Missing dynamic event ${W} on main thread host.`);return k}if(M(W)){const k=w[W];if(typeof k!="function")throw new Error(`Missing event ${W} on main thread host.`);return k}throw new Error(`Malformed event name ${W}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const I=globalThis.require;typeof I<"u"&&typeof I.getConfig=="function"?y=I.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const P=(0,o.$Sm)(w);this.b=this.c.sendMessage(s,[this.a.getId(),JSON.parse(JSON.stringify(y)),$,P]);const j=(W,G)=>this.g(W,G),x=(W,G)=>this.c.listen(W,G);this.f=new Promise((W,G)=>{v=G,this.b.then(k=>{W(c(k,j,x))},k=>{G(k),this.h("Worker failed to load "+$,k)})})}getProxyObject(){return this.f}g(m,$){return new Promise((w,v)=>{this.b.then(()=>{this.c.sendMessage(m,$).then(w,v)},v)})}h(m,$){console.error(m),console.info($)}}t.SimpleWorkerClient=b;function M(A){return A[0]==="o"&&A[1]==="n"&&u.$Kd(A.charCodeAt(2))}function h(A){return/^onDynamic/.test(A)&&u.$Kd(A.charCodeAt(9))}function c(A,m,$){const w=I=>function(){const P=Array.prototype.slice.call(arguments,0);return m(I,P)},v=I=>function(P){return $(I,P)},y={};for(const I of A){if(h(I)){y[I]=v(I);continue}if(M(I)){y[I]=$(I,void 0);continue}y[I]=w(I)}return y}class r{constructor(m,$){this.a=$,this.b=null,this.c=new R({sendMessage:(w,v)=>{m(w,v)},handleMessage:(w,v)=>this.d(w,v),handleEvent:(w,v)=>this.f(w,v)})}onmessage(m){this.c.handleMessage(m)}d(m,$){if(m===s)return this.g($[0],$[1],$[2],$[3]);if(!this.b||typeof this.b[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this.b[m].apply(this.b,$))}catch(w){return Promise.reject(w)}}f(m,$){if(!this.b)throw new Error("Missing requestHandler");if(h(m)){const w=this.b[m].call(this.b,$);if(typeof w!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return w}if(M(m)){const w=this.b[m];if(typeof w!="function")throw new Error(`Missing event ${m} on request handler.`);return w}throw new Error(`Malformed event name ${m}`)}g(m,$,w,v){this.c.setWorkerId(m);const P=c(v,(j,x)=>this.c.sendMessage(j,x),(j,x)=>this.c.listen(j,x));return this.a?(this.b=this.a(P),Promise.resolve((0,o.$Sm)(this.b))):($&&(typeof $.baseUrl<"u"&&delete $.baseUrl,typeof $.paths<"u"&&typeof $.paths.vs<"u"&&delete $.paths.vs,typeof $.trustedTypesPolicy!==void 0&&delete $.trustedTypesPolicy,$.catchError=!0,globalThis.require.config($)),new Promise((j,x)=>{(globalThis.require||z)([w],G=>{if(this.b=G.create(P),!this.b){x(new Error("No RequestHandler!"));return}j((0,o.$Sm)(this.b))},x)}))}}t.SimpleWorkerServer=r;function a(A){return new r(A,null)}t.create=a}),te(ne[60],ie([56,57]),function(z,t){return z.create("vs/editor/common/languages",t)}),te(ne[61],ie([0,1,35,14,36,2,54,60]),function(z,t,F,_,i,o,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$Cs=t.$Bs=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$As=t.$zs=t.SymbolKinds=t.SymbolTag=t.$ys=t.$xs=t.SymbolKind=t.$ws=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$vs=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$us=t.$ts=t.$ss=void 0;class s{constructor(q,O,B){this.offset=q,this.type=O,this.language=B,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$ss=s;class l{constructor(q,O){this.tokens=q,this.endState=O,this._tokenizationResultBrand=void 0}}t.$ts=l;class g{constructor(q,O){this.tokens=q,this.endState=O,this._encodedTokenizationResultBrand=void 0}}t.$us=g;var E;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(E||(t.CompletionItemKind=E={}));var d;(function(k){const q=new Map;q.set(0,F.$Cj.symbolMethod),q.set(1,F.$Cj.symbolFunction),q.set(2,F.$Cj.symbolConstructor),q.set(3,F.$Cj.symbolField),q.set(4,F.$Cj.symbolVariable),q.set(5,F.$Cj.symbolClass),q.set(6,F.$Cj.symbolStruct),q.set(7,F.$Cj.symbolInterface),q.set(8,F.$Cj.symbolModule),q.set(9,F.$Cj.symbolProperty),q.set(10,F.$Cj.symbolEvent),q.set(11,F.$Cj.symbolOperator),q.set(12,F.$Cj.symbolUnit),q.set(13,F.$Cj.symbolValue),q.set(15,F.$Cj.symbolEnum),q.set(14,F.$Cj.symbolConstant),q.set(15,F.$Cj.symbolEnum),q.set(16,F.$Cj.symbolEnumMember),q.set(17,F.$Cj.symbolKeyword),q.set(27,F.$Cj.symbolSnippet),q.set(18,F.$Cj.symbolText),q.set(19,F.$Cj.symbolColor),q.set(20,F.$Cj.symbolFile),q.set(21,F.$Cj.symbolReference),q.set(22,F.$Cj.symbolCustomColor),q.set(23,F.$Cj.symbolFolder),q.set(24,F.$Cj.symbolTypeParameter),q.set(25,F.$Cj.account),q.set(26,F.$Cj.issues);function O(n){let K=q.get(n);return K||(console.info("No codicon found for CompletionItemKind "+n),K=F.$Cj.symbolProperty),K}k.toIcon=O;const B=new Map;B.set("method",0),B.set("function",1),B.set("constructor",2),B.set("field",3),B.set("variable",4),B.set("class",5),B.set("struct",6),B.set("interface",7),B.set("module",8),B.set("property",9),B.set("event",10),B.set("operator",11),B.set("unit",12),B.set("value",13),B.set("constant",14),B.set("enum",15),B.set("enum-member",16),B.set("enumMember",16),B.set("keyword",17),B.set("snippet",27),B.set("text",18),B.set("color",19),B.set("file",20),B.set("reference",21),B.set("customcolor",22),B.set("folder",23),B.set("type-parameter",24),B.set("typeParameter",24),B.set("account",25),B.set("issue",26);function X(n,K){let ee=B.get(n);return typeof ee>"u"&&!K&&(ee=9),ee}k.fromString=X})(d||(t.CompletionItemKinds=d={}));var f;(function(k){k[k.Deprecated=1]="Deprecated"})(f||(t.CompletionItemTag=f={}));var e;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var N;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(N||(t.CompletionTriggerKind=N={}));var p;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})(p||(t.InlineCompletionTriggerKind=p={}));class R{constructor(q,O,B,X){this.range=q,this.text=O,this.completionKind=B,this.isSnippetText=X}equals(q){return o.$Ur.lift(this.range).equalsRange(q.range)&&this.text===q.text&&this.completionKind===q.completionKind&&this.isSnippetText===q.isSnippetText}}t.$vs=R;var b;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})(b||(t.CodeActionTriggerType=b={}));var M;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(M||(t.SignatureHelpTriggerKind=M={}));var h;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(h||(t.DocumentHighlightKind=h={}));function c(k){return k&&_.URI.isUri(k.uri)&&o.$Ur.isIRange(k.range)&&(o.$Ur.isIRange(k.originSelectionRange)||o.$Ur.isIRange(k.targetSelectionRange))}t.$ws=c;var r;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(r||(t.SymbolKind=r={})),t.$xs={[17]:(0,u.localize)(0,null),[16]:(0,u.localize)(1,null),[4]:(0,u.localize)(2,null),[13]:(0,u.localize)(3,null),[8]:(0,u.localize)(4,null),[9]:(0,u.localize)(5,null),[21]:(0,u.localize)(6,null),[23]:(0,u.localize)(7,null),[7]:(0,u.localize)(8,null),[0]:(0,u.localize)(9,null),[11]:(0,u.localize)(10,null),[10]:(0,u.localize)(11,null),[19]:(0,u.localize)(12,null),[5]:(0,u.localize)(13,null),[1]:(0,u.localize)(14,null),[2]:(0,u.localize)(15,null),[20]:(0,u.localize)(16,null),[15]:(0,u.localize)(17,null),[18]:(0,u.localize)(18,null),[24]:(0,u.localize)(19,null),[3]:(0,u.localize)(20,null),[6]:(0,u.localize)(21,null),[14]:(0,u.localize)(22,null),[22]:(0,u.localize)(23,null),[25]:(0,u.localize)(24,null),[12]:(0,u.localize)(25,null)};function a(k,q){return(0,u.localize)(26,null,k,t.$xs[q])}t.$ys=a;var A;(function(k){k[k.Deprecated=1]="Deprecated"})(A||(t.SymbolTag=A={}));var m;(function(k){const q=new Map;q.set(0,F.$Cj.symbolFile),q.set(1,F.$Cj.symbolModule),q.set(2,F.$Cj.symbolNamespace),q.set(3,F.$Cj.symbolPackage),q.set(4,F.$Cj.symbolClass),q.set(5,F.$Cj.symbolMethod),q.set(6,F.$Cj.symbolProperty),q.set(7,F.$Cj.symbolField),q.set(8,F.$Cj.symbolConstructor),q.set(9,F.$Cj.symbolEnum),q.set(10,F.$Cj.symbolInterface),q.set(11,F.$Cj.symbolFunction),q.set(12,F.$Cj.symbolVariable),q.set(13,F.$Cj.symbolConstant),q.set(14,F.$Cj.symbolString),q.set(15,F.$Cj.symbolNumber),q.set(16,F.$Cj.symbolBoolean),q.set(17,F.$Cj.symbolArray),q.set(18,F.$Cj.symbolObject),q.set(19,F.$Cj.symbolKey),q.set(20,F.$Cj.symbolNull),q.set(21,F.$Cj.symbolEnumMember),q.set(22,F.$Cj.symbolStruct),q.set(23,F.$Cj.symbolEvent),q.set(24,F.$Cj.symbolOperator),q.set(25,F.$Cj.symbolTypeParameter);function O(B){let X=q.get(B);return X||(console.info("No codicon found for SymbolKind "+B),X=F.$Cj.symbolProperty),X}k.toIcon=O})(m||(t.SymbolKinds=m={}));class ${static asEditOperation(q){return i.$2r.replace(o.$Ur.lift(q.range),q.text)}}t.$zs=$;class w{static{this.Comment=new w("comment")}static{this.Imports=new w("imports")}static{this.Region=new w("region")}static fromValue(q){switch(q){case"comment":return w.Comment;case"imports":return w.Imports;case"region":return w.Region}return new w(q)}constructor(q){this.value=q}}t.$As=w;var v;(function(k){function q(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}k.is=q})(v||(t.Command=v={}));var y;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(y||(t.CommentThreadCollapsibleState=y={}));var I;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(I||(t.CommentThreadState=I={}));var P;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(P||(t.CommentMode=P={}));var j;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(j||(t.CommentState=j={}));var x;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(x||(t.InlayHintKind=x={}));class W{constructor(q){this.b=q,this.a=null}dispose(){this.a&&this.a.then(q=>{q&&q.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Bs=W,t.$Cs=new L.$ks;var G;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(G||(t.ExternalUriOpenerPriority=G={}))}),te(ne[62],ie([0,1,20,8,31,14,4,2,37,61,53]),function(z,t,F,_,i,o,L,u,s,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jY=t.$iY=void 0;class E{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,N){return(0,i.$mq)(e,N)}}t.$iY=E;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:F.$oc,Emitter:_.$ec,KeyCode:g.KeyCode,KeyMod:E,Position:L.$Tr,Range:u.$Ur,Selection:s.$3r,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:o.URI,Token:l.$ss}}t.$jY=d}),te(ne[65],ie([0,1,21,14,4,2,50,25,46,47,62,19,52,27,44,11,3,45]),function(z,t,F,_,i,o,L,u,s,l,g,E,d,f,e,N,p,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends L.$Cu{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const a=[];for(let A=0;A<this.f.length;A++){const m=this.f[A],$=this.offsetAt(new i.$Tr(A+1,1)),w=m.matchAll(r);for(const v of w)(v.index||v.index===0)&&(v.index=v.index+$),a.push(v)}return a}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,a){const A=(0,u.$Qr)(r.column,(0,u.$Or)(a),this.f[r.lineNumber-1],0);return A?new o.$Ur(r.lineNumber,A.startColumn,r.lineNumber,A.endColumn):null}getWordUntilPosition(r,a){const A=this.getWordAtPosition(r,a);return A?{word:this.f[r.lineNumber-1].substring(A.startColumn-1,r.column-1),startColumn:A.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const a=this.f,A=this.q.bind(this);let m=0,$="",w=0,v=[];return{*[Symbol.iterator](){for(;;)if(w<v.length){const y=$.substring(v[w].start,v[w].end);w+=1,yield y}else if(m<a.length)$=a[m],v=A($,r),w=0,m+=1;else break}}}getLineWords(r,a){const A=this.f[r-1],m=this.q(A,a),$=[];for(const w of m)$.push({word:A.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1});return $}q(r,a){const A=[];let m;for(a.lastIndex=0;(m=a.exec(r))&&m[0].length!==0;)A.push({start:m.index,end:m.index+m[0].length});return A}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const a=this.g,A=r.startLineNumber-1,m=r.endLineNumber-1,$=[];$.push(this.f[A].substring(r.startColumn-1));for(let w=A+1;w<m;w++)$.push(this.f[w]);return $.push(this.f[m].substring(0,r.endColumn-1)),$.join(a)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const a=this.j.getIndexOf(r),A=this.f[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,A)}}r(r){const a=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),A=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return a.lineNumber!==r.startLineNumber||a.column!==r.startColumn||A.lineNumber!==r.endLineNumber||A.column!==r.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:A.lineNumber,endColumn:A.column}:r}s(r){if(!i.$Tr.isIPosition(r))throw new Error("bad position");let{lineNumber:a,column:A}=r,m=!1;if(a<1)a=1,A=1,m=!0;else if(a>this.f.length)a=this.f.length,A=this.f[a-1].length+1,m=!0;else{const $=this.f[a-1].length+1;A<1?(A=1,m=!0):A>$&&(A=$,m=!0)}return m?{lineNumber:a,column:A}:r}}class M{constructor(r,a){this.d=r,this.f=Object.create(null),this.g=a,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(a=>r.push(this.f[a])),r}acceptNewModel(r){this.f[r.url]=new b(_.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,a){if(!this.f[r])return;this.f[r].onEvents(a)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,a,A){const m=this.j(r);return m?d.$dY.computeUnicodeHighlights(m,a,A):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,a,A,m){const $=this.j(r),w=this.j(a);return!$||!w?null:M.l($,w,A,m)}static l(r,a,A,m){const $=m==="advanced"?e.$CY.getAdvanced():e.$CY.getLegacy(),w=r.getLinesContent(),v=a.getLinesContent(),y=$.computeDiff(w,v,A),I=y.changes.length>0?!1:this.n(r,a);function P(j){return j.map(x=>[x.originalRange.startLineNumber,x.originalRange.endLineNumberExclusive,x.modifiedRange.startLineNumber,x.modifiedRange.endLineNumberExclusive,x.innerChanges?.map(W=>[W.originalRange.startLineNumber,W.originalRange.startColumn,W.originalRange.endLineNumber,W.originalRange.endColumn,W.modifiedRange.startLineNumber,W.modifiedRange.startColumn,W.modifiedRange.endLineNumber,W.modifiedRange.endColumn])])}return{identical:I,quitEarly:y.hitTimeout,changes:P(y.changes),moves:y.moves.map(j=>[j.lineRangeMapping.original.startLineNumber,j.lineRangeMapping.original.endLineNumberExclusive,j.lineRangeMapping.modified.startLineNumber,j.lineRangeMapping.modified.endLineNumberExclusive,P(j.changes)])}}static n(r,a){const A=r.getLineCount(),m=a.getLineCount();if(A!==m)return!1;for(let $=1;$<=A;$++){const w=r.getLineContent($),v=a.getLineContent($);if(w!==v)return!1}return!0}async computeDirtyDiff(r,a,A){const m=this.j(r),$=this.j(a);if(!m||!$)return null;const w=m.getLinesContent(),v=$.getLinesContent();return new f.$wu(w,v,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:A,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(r,a,A){const m=this.j(r);if(!m)return a;const $=[];let w;a=a.slice(0).sort((v,y)=>{if(v.range&&y.range)return o.$Ur.compareRangesUsingStarts(v.range,y.range);const I=v.range?0:1,P=y.range?0:1;return I-P});for(let{range:v,text:y,eol:I}of a){if(typeof I=="number"&&(w=I),o.$Ur.isEmpty(v)&&!y)continue;const P=m.getValueInRange(v);if(y=y.replace(/\r\n|\n|\r/g,m.eol),P===y)continue;if(Math.max(y.length,P.length)>M.o){$.push({range:v,text:y});continue}const j=(0,F.$tu)(P,y,A),x=m.offsetAt(o.$Ur.lift(v).getStartPosition());for(const W of j){const G=m.positionAt(x+W.originalStart),k=m.positionAt(x+W.originalStart+W.originalLength),q={text:y.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:G.lineNumber,startColumn:G.column,endLineNumber:k.lineNumber,endColumn:k.column}};m.getValueInRange(q.range)!==q.text&&$.push(q)}}return typeof w=="number"&&$.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),$}async computeHumanReadableDiff(r,a,A){const m=this.j(r);if(!m)return a;const $=[];let w;a=a.slice(0).sort((v,y)=>{if(v.range&&y.range)return o.$Ur.compareRangesUsingStarts(v.range,y.range);const I=v.range?0:1,P=y.range?0:1;return I-P});for(let{range:v,text:y,eol:I}of a){let k=function(O,B){return new i.$Tr(O.lineNumber+B.lineNumber-1,B.lineNumber===1?O.column+B.column-1:B.column)},q=function(O,B){const X=[];for(let n=B.startLineNumber;n<=B.endLineNumber;n++){const K=O[n-1];n===B.startLineNumber&&n===B.endLineNumber?X.push(K.substring(B.startColumn-1,B.endColumn-1)):n===B.startLineNumber?X.push(K.substring(B.startColumn-1)):n===B.endLineNumber?X.push(K.substring(0,B.endColumn-1)):X.push(K)}return X};if(typeof I=="number"&&(w=I),o.$Ur.isEmpty(v)&&!y)continue;const P=m.getValueInRange(v);if(y=y.replace(/\r\n|\n|\r/g,m.eol),P===y)continue;if(Math.max(y.length,P.length)>M.o){$.push({range:v,text:y});continue}const j=P.split(/\r\n|\n|\r/),x=y.split(/\r\n|\n|\r/),W=e.$CY.getAdvanced().computeDiff(j,x,A),G=o.$Ur.lift(v).getStartPosition();for(const O of W.changes)if(O.innerChanges)for(const B of O.innerChanges)$.push({range:o.$Ur.fromPositions(k(G,B.originalRange.getStartPosition()),k(G,B.originalRange.getEndPosition())),text:q(x,B.modifiedRange).join(m.eol)});else throw new p.$bb("The experimental diff algorithm always produces inner changes")}return typeof w=="number"&&$.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),$}async computeLinks(r){const a=this.j(r);return a?(0,s.$gY)(a):null}async computeDefaultDocumentColors(r){const a=this.j(r);return a?(0,R.$DY)(a):null}static{this.p=1e4}async textualSuggest(r,a,A,m){const $=new E.$ac,w=new RegExp(A,m),v=new Set;e:for(const y of r){const I=this.j(y);if(I){for(const P of I.words(w))if(!(P===a||!isNaN(Number(P)))&&(v.add(P),v.size>M.p))break e}}return{words:Array.from(v),duration:$.elapsed()}}async computeWordRanges(r,a,A,m){const $=this.j(r);if(!$)return Object.create(null);const w=new RegExp(A,m),v=Object.create(null);for(let y=a.startLineNumber;y<a.endLineNumber;y++){const I=$.getLineWords(y,w);for(const P of I){if(!isNaN(Number(P.word)))continue;let j=v[P.word];j||(j=[],v[P.word]=j),j.push({startLineNumber:y,startColumn:P.startColumn,endLineNumber:y,endColumn:P.endColumn})}}return v}async navigateValueSet(r,a,A,m,$){const w=this.j(r);if(!w)return null;const v=new RegExp(m,$);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const y=w.getValueInRange(a),I=w.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},v);if(!I)return null;const P=w.getValueInRange(I);return l.$hY.INSTANCE.navigateValueSet(a,y,I,P,A)}loadForeignModule(r,a,A){const m=(v,y)=>this.d.fhr(v,y),w={host:(0,N.$Tm)(A,m),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(w,a),Promise.resolve((0,N.$Sm)(this.h))):new Promise((v,y)=>{z([r],I=>{this.h=I.create(w,a),v((0,N.$Sm)(this.h))},y)})}fmr(r,a){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,a))}catch(A){return Promise.reject(A)}}}t.EditorSimpleWorker=M;function h(c){return new M(c,null)}t.create=h,typeof importScripts=="function"&&(globalThis.monaco=(0,g.$jY)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/35be9bf683eace09796e59d54f1f225bbc3a7866/core/vs/base/worker/workerMain.js.map
