/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(H){for(var e=[],k=0,O=H.length;k<O;k++)e[k]=te[H[k]];return e};define(te[134],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=e.$cs=e.$bs=e.$as=void 0;function k(E,f){const h=Math.pow(10,f);return Math.round(E*h)/h}class O{constructor(f,h,$,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=k(Math.max(Math.min(1,g),0),3)}static equals(f,h){return f.r===h.r&&f.g===h.g&&f.b===h.b&&f.a===h.a}}e.$as=O;class s{constructor(f,h,$,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=k(Math.max(Math.min(1,h),0),3),this.l=k(Math.max(Math.min(1,$),0),3),this.a=k(Math.max(Math.min(1,g),0),3)}static equals(f,h){return f.h===h.h&&f.s===h.s&&f.l===h.l&&f.a===h.a}static fromRGBA(f){const h=f.r/255,$=f.g/255,g=f.b/255,p=f.a,u=Math.max(h,$,g),y=Math.min(h,$,g);let v=0,c=0;const d=(y+u)/2,l=u-y;if(l>0){switch(c=Math.min(d<=.5?l/(2*d):l/(2-2*d),1),u){case h:v=($-g)/l+($<g?6:0);break;case $:v=(g-h)/l+2;break;case g:v=(h-$)/l+4;break}v*=60,v=Math.round(v)}return new s(v,c,d,p)}static i(f,h,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?f+(h-f)*6*$:$<1/2?h:$<2/3?f+(h-f)*(2/3-$)*6:f}static toRGBA(f){const h=f.h/360,{s:$,l:g,a:p}=f;let u,y,v;if($===0)u=y=v=g;else{const c=g<.5?g*(1+$):g+$-g*$,d=2*g-c;u=s.i(d,c,h+1/3),y=s.i(d,c,h),v=s.i(d,c,h-1/3)}return new O(Math.round(u*255),Math.round(y*255),Math.round(v*255),p)}}e.$bs=s;class M{constructor(f,h,$,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=k(Math.max(Math.min(1,h),0),3),this.v=k(Math.max(Math.min(1,$),0),3),this.a=k(Math.max(Math.min(1,g),0),3)}static equals(f,h){return f.h===h.h&&f.s===h.s&&f.v===h.v&&f.a===h.a}static fromRGBA(f){const h=f.r/255,$=f.g/255,g=f.b/255,p=Math.max(h,$,g),u=Math.min(h,$,g),y=p-u,v=p===0?0:y/p;let c;return y===0?c=0:p===h?c=(($-g)/y%6+6)%6:p===$?c=(g-h)/y+2:c=(h-$)/y+4,new M(Math.round(c*60),v,p,f.a)}static toRGBA(f){const{h,s:$,v:g,a:p}=f,u=g*$,y=u*(1-Math.abs(h/60%2-1)),v=g-u;let[c,d,l]=[0,0,0];return h<60?(c=u,d=y):h<120?(c=y,d=u):h<180?(d=u,l=y):h<240?(d=y,l=u):h<300?(c=y,l=u):h<=360&&(c=u,l=y),c=Math.round((c+v)*255),d=Math.round((d+v)*255),l=Math.round((l+v)*255),new O(c,d,l,p)}}e.$cs=M;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,h){return!f&&!h?!0:!f||!h?!1:f.equals(h)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof O)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof M)this.j=f,this.rgba=M.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&O.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&M.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),h=D.k(this.rgba.g),$=D.k(this.rgba.b),g=.2126*f+.7152*h+.0722*$;return k(g,4)}static k(f){const h=f/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(f){const h=this.getRelativeLuminance(),$=f.getRelativeLuminance();return h>$?(h+.05)/($+.05):($+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const h=this.getRelativeLuminance(),$=f.getRelativeLuminance();return h>$}isDarkerThan(f){const h=this.getRelativeLuminance(),$=f.getRelativeLuminance();return h<$}lighten(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:h,g:$,b:g,a:p}=this.rgba;return new D(new O(h,$,g,p*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const h=f.rgba,$=this.rgba.a,g=h.a,p=$+g*(1-$);if(p<1e-6)return D.transparent;const u=this.rgba.r*$/p+h.r*g*(1-$)/p,y=this.rgba.g*$/p+h.g*g*(1-$)/p,v=this.rgba.b*$/p+h.b*g*(1-$)/p;return new D(new O(u,y,v,p))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:h,g:$,b:g,a:p}=this.rgba;return new D(new O(f.rgba.r-p*(f.rgba.r-h),f.rgba.g-p*(f.rgba.g-$),f.rgba.b-p*(f.rgba.b-g),1))}flatten(...f){const h=f.reduceRight(($,g)=>D.o(g,$));return D.o(this,h)}static o(f,h){const $=1-f.rgba.a;return new D(new O($*h.rgba.r+f.rgba.a*f.rgba.r,$*h.rgba.g+f.rgba.a*f.rgba.g,$*h.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,h,$){if(f.isLighterThan(h))return f;$=$||.5;const g=f.getRelativeLuminance(),p=h.getRelativeLuminance();return $=$*(p-g)/p,f.lighten($)}static getDarkerColor(f,h,$){if(f.isDarkerThan(h))return f;$=$||.5;const g=f.getRelativeLuminance(),p=h.getRelativeLuminance();return $=$*(g-p)/g,f.darken($)}static{this.white=new D(new O(255,255,255,1))}static{this.black=new D(new O(0,0,0,1))}static{this.red=new D(new O(255,0,0,1))}static{this.blue=new D(new O(0,0,255,1))}static{this.green=new D(new O(0,255,0,1))}static{this.cyan=new D(new O(0,255,255,1))}static{this.lightgrey=new D(new O(211,211,211,1))}static{this.transparent=new D(new O(0,0,0,0))}}e.$ds=D,function(E){let f;(function(h){let $;(function(g){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}g.formatRGB=p;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}g.formatRGBA=u;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}g.formatHSL=y;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}g.formatHSLA=v;function c(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function d(t){return`#${c(t.rgba.r)}${c(t.rgba.g)}${c(t.rgba.b)}`}g.formatHex=d;function l(t,a=!1){return a&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${c(t.rgba.r)}${c(t.rgba.g)}${c(t.rgba.b)}${c(Math.round(t.rgba.a*255))}`}g.formatHexA=l;function w(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}g.format=w;function S(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const r=16*m(t.charCodeAt(1))+m(t.charCodeAt(2)),i=16*m(t.charCodeAt(3))+m(t.charCodeAt(4)),n=16*m(t.charCodeAt(5))+m(t.charCodeAt(6));return new E(new O(r,i,n,1))}if(a===9){const r=16*m(t.charCodeAt(1))+m(t.charCodeAt(2)),i=16*m(t.charCodeAt(3))+m(t.charCodeAt(4)),n=16*m(t.charCodeAt(5))+m(t.charCodeAt(6)),o=16*m(t.charCodeAt(7))+m(t.charCodeAt(8));return new E(new O(r,i,n,o/255))}if(a===4){const r=m(t.charCodeAt(1)),i=m(t.charCodeAt(2)),n=m(t.charCodeAt(3));return new E(new O(16*r+r,16*i+i,16*n+n))}if(a===5){const r=m(t.charCodeAt(1)),i=m(t.charCodeAt(2)),n=m(t.charCodeAt(3)),o=m(t.charCodeAt(4));return new E(new O(16*r+r,16*i+i,16*n+n,(16*o+o)/255))}return null}g.parseHex=S;function m(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=h.CSS||(h.CSS={}))})(f=E.Format||(E.Format={}))}(D||(e.$ds=D={}))}),define(te[55],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function k(D){return(E,f,h)=>{let $=null,g=null;if(typeof h.value=="function"?($="value",g=h.value):typeof h.get=="function"&&($="get",g=h.get),!g)throw new Error("not supported");h[$]=D(g,f)}}function O(D,E,f){let h=null,$=null;if(typeof f.value=="function"?(h="value",$=f.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(h="get",$=f.get),!$)throw new Error("not supported");const g=`$memoize$${E}`;f[h]=function(...p){return this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,p)}),this[g]}}e.$Tg=O;function s(D,E,f){return k((h,$)=>{const g=`$debounce$${$}`,p=`$debounce$result$${$}`;return function(...u){this[p]||(this[p]=f?f():void 0),clearTimeout(this[g]),E&&(this[p]=E(this[p],...u),u=[this[p]]),this[g]=setTimeout(()=>{h.apply(this,u),this[p]=f?f():void 0},D)}})}e.$Ug=s;function M(D,E,f){return k((h,$)=>{const g=`$throttle$timer$${$}`,p=`$throttle$result$${$}`,u=`$throttle$lastRun$${$}`,y=`$throttle$pending$${$}`;return function(...v){if(this[p]||(this[p]=f?f():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),E&&(this[p]=E(this[p],...v)),this[y])return;const c=this[u]+D;c<=Date.now()?(this[u]=Date.now(),h.apply(this,[this[p]]),this[p]=f?f():void 0):(this[y]=!0,this[g]=setTimeout(()=>{this[y]=!1,this[u]=Date.now(),h.apply(this,[this[p]]),this[p]=f?f():void 0},c-Date.now()))}})}e.$Vg=M}),define(te[13],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class k{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?S.isErrorNoTelemetry(a)?new S(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(r=>{r(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.$U=k,e.$V=new k;function O(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=O;function s(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.$X=s;function M(t){h(t)||e.$V.onUnexpectedError(t)}e.$Y=M;function D(t){h(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=D;function E(t){if(t instanceof Error){const{name:a,message:r}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:a,message:r,stack:i,noTelemetry:S.isErrorNoTelemetry(t)}}return t}e.$1=E;const f="Canceled";function h(t){return t instanceof $?!0:t instanceof Error&&t.name===f&&t.message===f}e.$2=h;class $ extends Error{constructor(){super(f),this.name=this.message}}e.$3=$;function g(){const t=new Error(f);return t.name=t.message,t}e.$4=g;function p(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=p;function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=u;function y(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=y;function v(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.$8=v;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=c;class d extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.$0=d;class l extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.$$=l;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=w;class S extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof S)return a;const r=new S;return r.message=a.message,r.stack=a.stack,r}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.$ab=S;class m extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$bb=m}),define(te[24],ie([0,1,13]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function O(K,ee=0){return K[K.length-(1+ee)]}e.$9e=O;function s(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.$0e=s;function M(K,ee,X=(de,me)=>de===me){if(K===ee)return!0;if(!K||!ee||K.length!==ee.length)return!1;for(let de=0,me=K.length;de<me;de++)if(!X(K[de],ee[de]))return!1;return!0}e.$$e=M;function D(K,ee){const X=K.length-1;ee<X&&(K[ee]=K[X]),K.pop()}e.$_e=D;function E(K,ee,X){return f(K.length,de=>X(K[de],ee))}e.$af=E;function f(K,ee){let X=0,de=K-1;for(;X<=de;){const me=(X+de)/2|0,Re=ee(me);if(Re<0)X=me+1;else if(Re>0)de=me-1;else return me}return-(X+1)}e.$bf=f;function h(K,ee){let X=0,de=K.length;if(de===0)return 0;for(;X<de;){const me=Math.floor((X+de)/2);ee(K[me])?de=me:X=me+1}return X}e.$cf=h;function $(K,ee,X){if(K=K|0,K>=ee.length)throw new TypeError("invalid index");const de=ee[Math.floor(ee.length*Math.random())],me=[],Re=[],De=[];for(const je of ee){const ye=X(je,de);ye<0?me.push(je):ye>0?Re.push(je):De.push(je)}return K<me.length?$(K,me,X):K<me.length+De.length?De[0]:$(K-(me.length+De.length),Re,X)}e.$df=$;function g(K,ee){const X=[];let de;for(const me of K.slice(0).sort(ee))!de||ee(de[0],me)!==0?(de=[me],X.push(de)):de.push(me);return X}e.$ef=g;function p(K,ee,X){const de=[];function me(je,ye,be){if(ye===0&&be.length===0)return;const Z=de[de.length-1];Z&&Z.start+Z.deleteCount===je?(Z.deleteCount+=ye,Z.toInsert.push(...be)):de.push({start:je,deleteCount:ye,toInsert:be})}let Re=0,De=0;for(;;){if(Re===K.length){me(Re,0,ee.slice(De));break}if(De===ee.length){me(Re,K.length-Re,[]);break}const je=K[Re],ye=ee[De],be=X(je,ye);be===0?(Re+=1,De+=1):be<0?(me(Re,1,[]),Re+=1):be>0&&(me(Re,0,[ye]),De+=1)}return de}e.$ff=p;function u(K,ee,X){const de=p(K,ee,X),me=[],Re=[];for(const De of de)me.push(...K.slice(De.start,De.start+De.deleteCount)),Re.push(...De.toInsert);return{removed:me,added:Re}}e.$gf=u;function y(K,ee,X){if(X===0)return[];const de=K.slice(0,X).sort(ee);return c(K,ee,de,X,K.length),de}e.top=y;function v(K,ee,X,de,me){return X===0?Promise.resolve([]):new Promise((Re,De)=>{(async()=>{const je=K.length,ye=K.slice(0,X).sort(ee);for(let be=X,Z=Math.min(X+de,je);be<je;be=Z,Z=Math.min(Z+de,je)){if(be>X&&await new Promise(he=>setTimeout(he)),me&&me.isCancellationRequested)throw new k.$3;c(K,ee,ye,be,Z)}return ye})().then(Re,De)})}e.$if=v;function c(K,ee,X,de,me){for(const Re=X.length;de<me;de++){const De=K[de];if(ee(De,X[Re-1])<0){X.pop();const je=h(X,ye=>ee(De,ye)<0);X.splice(je,0,De)}}}function d(K){return K.filter(ee=>!!ee)}e.$jf=d;function l(K){let ee=0;for(let X=0;X<K.length;X++)K[X]&&(K[ee]=K[X],ee+=1);K.length=ee}e.$kf=l;function w(K,ee,X){K.splice(X,0,K.splice(ee,1)[0])}e.$lf=w;function S(K){return!Array.isArray(K)||K.length===0}e.$mf=S;function m(K){return Array.isArray(K)&&K.length>0}e.$nf=m;function t(K,ee=X=>X){const X=new Set;return K.filter(de=>{const me=ee(de);return X.has(me)?!1:(X.add(me),!0)})}e.$of=t;function a(K){const ee=new Set;return X=>{const de=K(X);return ee.has(de)?!1:(ee.add(de),!0)}}e.$pf=a;function r(K,ee){const X=i(K,ee);if(X!==-1)return K[X]}e.$qf=r;function i(K,ee){for(let X=K.length-1;X>=0;X--){const de=K[X];if(ee(de))return X}return-1}e.$rf=i;function n(K,ee){return K.length>0?K[0]:ee}e.$sf=n;function o(K,ee){return K.length>0?K[K.length-1]:ee}e.$tf=o;function b(K,ee,X=(de,me)=>de===me){let de=0;for(let me=0,Re=Math.min(K.length,ee.length);me<Re&&X(K[me],ee[me]);me++)de++;return de}e.$uf=b;function I(K){return[].concat(...K)}e.$vf=I;function A(K,ee){let X=typeof ee=="number"?K:0;typeof ee=="number"?X=K:(X=0,ee=K);const de=[];if(X<=ee)for(let me=X;me<ee;me++)de.push(me);else for(let me=X;me>ee;me--)de.push(me);return de}e.$wf=A;function P(K,ee,X){return K.reduce((de,me)=>(de[ee(me)]=X?X(me):me,de),Object.create(null))}e.$xf=P;function C(K,ee){return K.push(ee),()=>j(K,ee)}e.$yf=C;function j(K,ee){const X=K.indexOf(ee);if(X>-1)return K.splice(X,1),ee}e.$zf=j;function U(K,ee,X){const de=K.slice(0,ee),me=K.slice(ee);return de.concat(X,me)}e.$Af=U;function W(K,ee){let X;if(typeof ee=="number"){let de=ee;X=()=>{const me=Math.sin(de++)*179426549;return me-Math.floor(me)}}else X=Math.random;for(let de=K.length-1;de>0;de-=1){const me=Math.floor(X()*(de+1)),Re=K[de];K[de]=K[me],K[me]=Re}}e.$Bf=W;function re(K,ee){const X=K.indexOf(ee);X>-1&&(K.splice(X,1),K.unshift(ee))}e.$Cf=re;function ne(K,ee){const X=K.indexOf(ee);X>-1&&(K.splice(X,1),K.push(ee))}e.$Df=ne;function fe(K,ee){for(const X of ee)K.push(X)}e.$Ef=fe;function ae(K,ee){return Array.isArray(K)?K.map(ee):ee(K)}e.$Ff=ae;function ue(K){return Array.isArray(K)?K:[K]}e.$Gf=ue;function V(K){return K[Math.floor(Math.random()*K.length)]}e.$Hf=V;function J(K,ee){for(const X of K){const de=ee(X);if(de!==void 0)return de}}e.$If=J;function z(K,ee,X){const de=F(K,ee),me=K.length,Re=X.length;K.length=me+Re;for(let De=me-1;De>=de;De--)K[De+Re]=K[De];for(let De=0;De<Re;De++)K[De+de]=X[De]}e.$Jf=z;function T(K,ee,X,de){const me=F(K,ee),Re=K.splice(me,X);return z(K,me,de),Re}e.$Kf=T;function F(K,ee){return ee<0?Math.max(ee+K.length,0):Math.min(ee,K.length)}var B;(function(K){function ee(me){return me<0}K.isLessThan=ee;function X(me){return me>0}K.isGreaterThan=X;function de(me){return me===0}K.isNeitherLessOrGreaterThan=de,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function x(K,ee){return(X,de)=>ee(K(X),K(de))}e.$Lf=x;function oe(...K){return(ee,X)=>{for(const de of K){const me=de(ee,X);if(!B.isNeitherLessOrGreaterThan(me))return me}return B.neitherLessOrGreaterThan}}e.$Mf=oe;const ce=(K,ee)=>K-ee;e.$Nf=ce;const G=(K,ee)=>(0,e.$Nf)(K?1:0,ee?1:0);e.$Of=G;function R(K){return(ee,X)=>-K(ee,X)}e.$Pf=R;function L(K,ee){if(K.length===0)return;let X=K[0];for(let de=1;de<K.length;de++){const me=K[de];ee(me,X)>0&&(X=me)}return X}e.$Qf=L;function N(K,ee){if(K.length===0)return;let X=K[0];for(let de=1;de<K.length;de++){const me=K[de];ee(me,X)>=0&&(X=me)}return X}e.$Rf=N;function q(K,ee){return L(K,(X,de)=>-ee(X,de))}e.$Sf=q;function se(K,ee){if(K.length===0)return-1;let X=0;for(let de=1;de<K.length;de++){const me=K[de];ee(me,K[X])>0&&(X=de)}return X}e.$Tf=se;class Y{constructor(ee){this.f=ee,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let X=this.c;for(;X<this.f.length&&ee(this.f[X]);)X++;const de=X===this.c?null:this.f.slice(this.c,X);return this.c=X,de}takeFromEndWhile(ee){let X=this.d;for(;X>=0&&ee(this.f[X]);)X--;const de=X===this.d?null:this.f.slice(X+1,this.d+1);return this.d=X,de}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ee=this.f[this.c];return this.c++,ee}removeLast(){const ee=this.f[this.d];return this.d--,ee}takeCount(ee){const X=this.f.slice(this.c,this.c+ee);return this.c+=ee,X}}e.$Uf=Y;class le{static{this.empty=new le(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(X=>(ee(X),!0))}toArray(){const ee=[];return this.iterate(X=>(ee.push(X),!0)),ee}filter(ee){return new le(X=>this.iterate(de=>ee(de)?X(de):!0))}map(ee){return new le(X=>this.iterate(de=>X(ee(de))))}some(ee){let X=!1;return this.iterate(de=>(X=ee(de),!X)),X}findFirst(ee){let X;return this.iterate(de=>ee(de)?(X=de,!1):!0),X}findLast(ee){let X;return this.iterate(de=>(ee(de)&&(X=de),!0)),X}findLastMaxBy(ee){let X,de=!0;return this.iterate(me=>((de||B.isGreaterThan(ee(me,X)))&&(de=!1,X=me),!0)),X}}e.$Vf=le}),define(te[135],ie([0,1,13]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zb=e.$yb=e.$xb=e.$wb=e.ok=void 0;function O(f,h){if(!f)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}e.ok=O;function s(f,h="Unreachable"){throw new Error(h)}e.$wb=s;function M(f){if(!f)throw new k.$bb("Assertion Failed")}e.$xb=M;function D(f){if(!f()){debugger;f(),(0,k.$Y)(new k.$bb("Assertion Failed"))}}e.$yb=D;function E(f,h){let $=0;for(;$<f.length-1;){const g=f[$],p=f[$+1];if(!h(g,p))return!1;$++}return!0}e.$zb=E}),define(te[49],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function k(O){const s=this;let M=!1,D;return function(){return M||(M=!0,D=O.apply(s,arguments)),D}}e.$cb=k}),define(te[68],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(O){function s(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}O.is=s;const M=Object.freeze([]);function D(){return M}O.empty=D;function*E(S){yield S}O.single=E;function f(S){return s(S)?S:E(S)}O.wrap=f;function h(S){return S||M}O.from=h;function $(S){return!S||S[Symbol.iterator]().next().done===!0}O.isEmpty=$;function g(S){return S[Symbol.iterator]().next().value}O.first=g;function p(S,m){for(const t of S)if(m(t))return!0;return!1}O.some=p;function u(S,m){for(const t of S)if(m(t))return t}O.find=u;function*y(S,m){for(const t of S)m(t)&&(yield t)}O.filter=y;function*v(S,m){let t=0;for(const a of S)yield m(a,t++)}O.map=v;function*c(...S){for(const m of S)for(const t of m)yield t}O.concat=c;function d(S,m,t){let a=t;for(const r of S)a=m(a,r);return a}O.reduce=d;function*l(S,m,t=S.length){for(m<0&&(m+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);m<t;m++)yield S[m]}O.slice=l;function w(S,m=Number.POSITIVE_INFINITY){const t=[];if(m===0)return[t,S];const a=S[Symbol.iterator]();for(let r=0;r<m;r++){const i=a.next();if(i.done)return[t,O.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return a}}]}O.consume=w})(k||(e.Iterable=k={}))}),define(te[44],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(t,a=!1){let r=0;const i=t.length;let n="",o=0,b=16,I=0;function A(ne){let fe=0,ae=0;for(;fe<ne;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)ae=ae*16+ue-48;else if(ue>=65&&ue<=70)ae=ae*16+ue-65+10;else if(ue>=97&&ue<=102)ae=ae*16+ue-97+10;else break;r++,fe++}return fe<ne&&(ae=-1),ae}function P(ne){r=ne,n="",o=0,b=16,I=0}function C(){const ne=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&h(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&h(t.charCodeAt(r)))for(r++;r<t.length&&h(t.charCodeAt(r));)r++;else return I=3,t.substring(ne,r);let fe=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&h(t.charCodeAt(r))){for(r++;r<t.length&&h(t.charCodeAt(r));)r++;fe=r}else I=3;return t.substring(ne,fe)}function j(){let ne="",fe=r;for(;;){if(r>=i){ne+=t.substring(fe,r),I=2;break}const ae=t.charCodeAt(r);if(ae===34){ne+=t.substring(fe,r),r++;break}if(ae===92){if(ne+=t.substring(fe,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const V=A(4);V>=0?ne+=String.fromCharCode(V):I=4;break}default:I=5}fe=r;continue}if(ae>=0&&ae<=31)if(f(ae)){ne+=t.substring(fe,r),I=2;break}else I=6;r++}return ne}function U(){if(n="",I=0,o=r,r>=i)return o=i,b=17;let ne=t.charCodeAt(r);if(E(ne)){do r++,n+=String.fromCharCode(ne),ne=t.charCodeAt(r);while(E(ne));return b=15}if(f(ne))return r++,n+=String.fromCharCode(ne),ne===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),b=14;switch(ne){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,n=j(),b=10;case 47:{const fe=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(fe,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const ae=i-1;let ue=!1;for(;r<ae;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,I=1),n=t.substring(fe,r),b=13}return n+=String.fromCharCode(ne),r++,b=16}case 45:if(n+=String.fromCharCode(ne),r++,r===i||!h(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),b=11;default:for(;r<i&&W(ne);)r++,ne=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return n+=String.fromCharCode(ne),r++,b=16}}function W(ne){if(E(ne)||f(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ne;do ne=U();while(ne>=12&&ne<=15);return ne}return{setPosition:P,getPosition:()=>r,scan:a?re:U,getToken:()=>b,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>I}}e.$wm=D;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function h(t){return t>=48&&t<=57}var $;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})($||($={}));function g(t,a){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function I(A,P,C,j){o.value=A,o.offset=P,o.length=C,o.type=j,o.colonOffset=void 0,n=o}try{w(t,{onObjectBegin:(A,P)=>{if(a<=A)throw i;n=void 0,b=a>A,r.push("")},onObjectProperty:(A,P,C)=>{if(a<P||(I(A,P,C,"property"),r[r.length-1]=A,a<=P+C))throw i},onObjectEnd:(A,P)=>{if(a<=A)throw i;n=void 0,r.pop()},onArrayBegin:(A,P)=>{if(a<=A)throw i;n=void 0,r.push(0)},onArrayEnd:(A,P)=>{if(a<=A)throw i;n=void 0,r.pop()},onLiteralValue:(A,P,C)=>{if(a<P||(I(A,P,C,m(A)),a<=P+C))throw i},onSeparator:(A,P,C)=>{if(a<=P)throw i;if(A===":"&&n&&n.type==="property")n.colonOffset=P,b=!1,n=void 0;else if(A===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(b=!0,r[r.length-1]=""),n=void 0}}})}catch(A){if(A!==i)throw A}return{path:r,previousNode:n,isAtPropertyKey:b,matches:A=>{let P=0;for(let C=0;P<A.length&&C<r.length;C++)if(A[P]===r[C]||A[P]==="*")P++;else if(A[P]!=="**")return!1;return P===A.length}}}e.$xm=g;function p(t,a=[],r=M.DEFAULT){let i=null,n=[];const o=[];function b(A){Array.isArray(n)?n.push(A):i!==null&&(n[i]=A)}return w(t,{onObjectBegin:()=>{const A={};b(A),o.push(n),n=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const A=[];b(A),o.push(n),n=A,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:b,onError:(A,P,C)=>{a.push({error:A,offset:P,length:C})}},r),n[0]}e.$ym=p;function u(t,a=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function o(A){return i.children.push(A),A}w(t,{onObjectBegin:A=>{i=o({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,P,C)=>{i=o({type:"property",offset:P,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:P,length:C,parent:i})},onObjectEnd:(A,P)=>{i.length=A+P-i.offset,i=i.parent,n(A+P)},onArrayBegin:(A,P)=>{i=o({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,P)=>{i.length=A+P-i.offset,i=i.parent,n(A+P)},onLiteralValue:(A,P,C)=>{o({type:m(A),offset:P,length:C,parent:i,value:A}),n(P+C)},onSeparator:(A,P,C)=>{i.type==="property"&&(A===":"?i.colonOffset=P:A===","&&n(P))},onError:(A,P,C)=>{a.push({error:A,offset:P,length:C})}},r);const I=i.children[0];return I&&delete I.parent,I}e.$zm=u;function y(t,a){if(!t)return;let r=t;for(const i of a)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Am=y;function v(t){if(!t.parent||!t.parent.children)return[];const a=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;a.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&a.push(r)}return a}e.$Bm=v;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const a=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(a[r.children[0].value]=c(i))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Cm=c;function d(t,a,r=!1){return a>=t.offset&&a<t.offset+t.length||r&&a===t.offset+t.length}e.$Dm=d;function l(t,a,r=!1){if(d(t,a,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=a;n++){const o=l(i[n],a,r);if(o)return o}return t}}e.$Em=l;function w(t,a,r=M.DEFAULT){const i=D(t,!1);function n(x){return x?()=>x(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(x){return x?oe=>x(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=n(a.onObjectBegin),I=o(a.onObjectProperty),A=n(a.onObjectEnd),P=n(a.onArrayBegin),C=n(a.onArrayEnd),j=o(a.onLiteralValue),U=o(a.onSeparator),W=n(a.onComment),re=o(a.onError),ne=r&&r.disallowComments,fe=r&&r.allowTrailingComma;function ae(){for(;;){const x=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:ne||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(x){case 12:case 13:ne?ue(10):W();break;case 16:ue(1);break;case 15:case 14:break;default:return x}}}function ue(x,oe=[],ce=[]){if(re(x),oe.length+ce.length>0){let G=i.getToken();for(;G!==17;){if(oe.indexOf(G)!==-1){ae();break}else if(ce.indexOf(G)!==-1)break;G=ae()}}}function V(x){const oe=i.getTokenValue();return x?j(oe):I(oe),ae(),!0}function J(){switch(i.getToken()){case 11:{let x=0;try{x=JSON.parse(i.getTokenValue()),typeof x!="number"&&(ue(2),x=0)}catch{ue(2)}j(x);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return ae(),!0}function z(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(U(":"),ae(),B()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function T(){b(),ae();let x=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(x||ue(4,[],[]),U(","),ae(),i.getToken()===2&&fe)break}else x&&ue(6,[],[]);z()||ue(4,[],[2,5]),x=!0}return A(),i.getToken()!==2?ue(7,[2],[]):ae(),!0}function F(){P(),ae();let x=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(x||ue(4,[],[]),U(","),ae(),i.getToken()===4&&fe)break}else x&&ue(6,[],[]);B()||ue(4,[],[4,5]),x=!0}return C(),i.getToken()!==4?ue(8,[4],[]):ae(),!0}function B(){switch(i.getToken()){case 3:return F();case 1:return T();case 10:return V(!0);default:return J()}}return ae(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):B()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$Fm=w;function S(t,a){const r=D(t),i=[];let n,o=0,b;do switch(b=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:o!==b&&i.push(t.substring(o,b)),a!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,a)),o=r.getPosition();break}while(n!==17);return i.join("")}e.$Gm=S;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Hm=m}),define(te[136],ie([0,1,44]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eS=e.$dS=e.$cS=e.$bS=void 0;function O(h,$,g){let p,u,y,v,c;if($){for(v=$.offset,c=v+$.length,y=v;y>0&&!f(h,y-1);)y--;let b=c;for(;b<h.length&&!f(h,b);)b++;u=h.substring(y,b),p=D(u,g)}else u=h,p=0,y=0,v=0,c=h.length;const d=E(g,h);let l=!1,w=0,S;g.insertSpaces?S=M(" ",g.tabSize||4):S="	";const m=(0,k.$wm)(u,!1);let t=!1;function a(){return d+M(S,p+w)}function r(){let b=m.scan();for(l=!1;b===15||b===14;)l=l||b===14,b=m.scan();return t=b===16||m.getTokenError()!==0,b}const i=[];function n(b,I,A){!t&&I<c&&A>v&&h.substring(I,A)!==b&&i.push({offset:I,length:A-I,content:b})}let o=r();if(o!==17){const b=m.getTokenOffset()+y,I=M(S,p);n(I,y,b)}for(;o!==17;){let b=m.getTokenOffset()+m.getTokenLength()+y,I=r(),A="";for(;!l&&(I===12||I===13);){const C=m.getTokenOffset()+y;n(" ",b,C),b=m.getTokenOffset()+m.getTokenLength()+y,A=I===12?a():"",I=r()}if(I===2)o!==1&&(w--,A=a());else if(I===4)o!==3&&(w--,A=a());else{switch(o){case 3:case 1:w++,A=a();break;case 5:case 12:A=a();break;case 13:l?A=a():A=" ";break;case 6:A=" ";break;case 10:if(I===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?A=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}l&&(I===12||I===13)&&(A=a())}const P=m.getTokenOffset()+y;n(A,b,P),o=I}return i}e.$bS=O;function s(h,$){const g=JSON.stringify(h,void 0,$.insertSpaces?$.tabSize||4:"	");return $.eol!==void 0?g.replace(/\r\n|\r|\n/g,$.eol):g}e.$cS=s;function M(h,$){let g="";for(let p=0;p<$;p++)g+=h;return g}function D(h,$){let g=0,p=0;const u=$.tabSize||4;for(;g<h.length;){const y=h.charAt(g);if(y===" ")p++;else if(y==="	")p+=u;else break;g++}return Math.floor(p/u)}function E(h,$){for(let g=0;g<$.length;g++){const p=$.charAt(g);if(p==="\r")return g+1<$.length&&$.charAt(g+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return h&&h.eol||`
`}e.$dS=E;function f(h,$){return`\r
`.indexOf(h.charAt($))!==-1}e.$eS=f}),define(te[137],ie([0,1,44,136]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jS=e.$iS=e.$hS=e.$gS=e.$fS=void 0;function s(h,$,g){return M(h,$,void 0,g)}e.$fS=s;function M(h,$,g,p,u){const y=$.slice(),v=[],c=(0,k.$zm)(h,v);let d,l;for(;y.length>0&&(l=y.pop(),d=(0,k.$Am)(c,y),d===void 0&&g!==void 0);)typeof l=="string"?g={[l]:g}:g=[g];if(d)if(d.type==="object"&&typeof l=="string"&&Array.isArray(d.children)){const w=(0,k.$Am)(d,[l]);if(w!==void 0)if(g===void 0){if(!w.parent)throw new Error("Malformed AST");const S=d.children.indexOf(w.parent);let m,t=w.parent.offset+w.parent.length;if(S>0){const a=d.children[S-1];m=a.offset+a.length}else m=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return D(h,{offset:m,length:t-m,content:""},p)}else return D(h,{offset:w.offset,length:w.length,content:JSON.stringify(g)},p);else{if(g===void 0)return[];const S=`${JSON.stringify(l)}: ${JSON.stringify(g)}`,m=u?u(d.children.map(a=>a.children[0].value)):d.children.length;let t;if(m>0){const a=d.children[m-1];t={offset:a.offset+a.length,length:0,content:","+S}}else d.children.length===0?t={offset:d.offset+1,length:0,content:S}:t={offset:d.offset+1,length:0,content:S+","};return D(h,t,p)}}else if(d.type==="array"&&typeof l=="number"&&Array.isArray(d.children))if(g!==void 0){const w=`${JSON.stringify(g)}`;let S;if(d.children.length===0||l===0)S={offset:d.offset+1,length:0,content:d.children.length===0?w:w+","};else{const m=l===-1||l>d.children.length?d.children.length:l,t=d.children[m-1];S={offset:t.offset+t.length,length:0,content:","+w}}return D(h,S,p)}else{const w=l,S=d.children[w];let m;if(d.children.length===1)m={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===w){const t=d.children[w-1],a=t.offset+t.length,r=d.offset+d.length;m={offset:a,length:r-2-a,content:""}}else m={offset:S.offset,length:d.children[w+1].offset-S.offset,content:""};return D(h,m,p)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${d.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return D(h,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(g)},p)}}e.$gS=M;function D(h,$,g){let p=E(h,$),u=$.offset,y=$.offset+$.content.length;if($.length===0||$.content.length===0){for(;u>0&&!(0,O.$eS)(p,u-1);)u--;for(;y<p.length&&!(0,O.$eS)(p,y);)y++}const v=(0,O.$bS)(p,{offset:u,length:y-u},g);for(let d=v.length-1;d>=0;d--){const l=v[d];p=E(p,l),u=Math.min(u,l.offset),y=Math.max(y,l.offset+l.length),y+=l.content.length-l.length}const c=h.length-(p.length-y)-u;return[{offset:u,length:c,content:p.substring(u,y)}]}e.$hS=D;function E(h,$){return h.substring(0,$.offset)+$.content+h.substring($.offset+$.length)}e.$iS=E;function f(h,$){const g=$.slice(0).sort((u,y)=>{const v=u.offset-y.offset;return v===0?u.length-y.length:v});let p=h.length;for(let u=g.length-1;u>=0;u--){const y=g[u];if(y.offset+y.length<=p)h=E(h,y);else throw new Error("Overlapping edit");p=y.offset}return h}e.$jS=f}),define(te[85],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class k{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=k}),define(te[2],ie([0,1,49,68]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const s=!1;let M=null;function D(o){M=o}if(e.$db=D,s){const o="__is_disposable_tracked__";D(new class{trackDisposable(b){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[o]||console.log(I)},3e3)}setParent(b,I){if(b&&b!==l.None)try{b[o]=!0}catch{}}markAsDisposed(b){if(b&&b!==l.None)try{b[o]=!0}catch{}}markAsSingleton(b){}})}function E(o){return M?.trackDisposable(o),o}function f(o){M?.markAsDisposed(o)}function h(o,b){M?.setParent(o,b)}function $(o,b){if(M)for(const I of o)M.setParent(I,b)}function g(o){return M?.markAsSingleton(o),o}e.$eb=g;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.$fb=p;function u(o){if(O.Iterable.is(o)){const b=[];for(const I of o)if(I)try{I.dispose()}catch(A){b.push(A)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.$gb=u;function y(o){for(const b of o)p(b)&&b.dispose();return[]}e.$hb=y;function v(...o){const b=c(()=>u(o));return $(o,b),b}e.$ib=v;function c(o){const b=E({dispose:(0,k.$cb)(()=>{f(b),o()})});return b}e.$jb=c;class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return h(b,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(b),b}}e.$kb=d;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new d,E(this),h(this.q,this)}dispose(){f(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}e.$lb=l;class w{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&h(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&h(b,null),b}}e.$mb=w;class S{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=S;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(b){let I=b;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,f(this))},this}}e.$ob=m;class t{constructor(){this.a=new Map}acquire(b,...I){let A=this.a.get(b);A||(A={counter:0,object:this.b(b,...I)},this.a.set(b,A));const{object:P}=A,C=(0,k.$cb)(()=>{--A.counter===0&&(this.c(b,A.object),this.a.delete(b))});return A.counter++,{object:P,dispose:C}}}e.$pb=t;class a{constructor(b){this.a=b}async acquire(b,...I){const A=this.a.acquire(b,...I);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(P){throw A.dispose(),P}}}e.$qb=a;class r{constructor(b){this.object=b}dispose(){}}e.$rb=r;function i(o){const b=new d;try{o(b)}finally{b.dispose()}}e.$sb=i;class n{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get(b){return this.a.get(b)}set(b,I,A=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this.a.get(b)?.dispose(),this.a.set(b,I)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=n}),define(te[102],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=void 0;class k{static{this.Undefined=new k(void 0)}constructor(M){this.element=M,this.next=k.Undefined,this.prev=k.Undefined}}class O{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let M=this.a;for(;M!==k.Undefined;){const D=M.next;M.prev=k.Undefined,M.next=k.Undefined,M=D}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const E=new k(M);if(this.a===k.Undefined)this.a=E,this.b=E;else if(D){const h=this.b;this.b=E,E.prev=h,h.next=E}else{const h=this.a;this.a=E,E.next=h,h.prev=E}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(E))}}shift(){if(this.a!==k.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==k.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==k.Undefined&&M.next!==k.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===k.Undefined&&M.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):M.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):M.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==k.Undefined;)yield M.element,M=M.next}}e.$ub=O}),define(te[35],ie([0,1]),function(H,e){"use strict";var k,O,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function M(v,c,d){let l=v.get(c);return l===void 0&&(l=d,v.set(c,l)),l}e.$ki=M;function D(v){const c=[];return v.forEach((d,l)=>{c.push(`${l} => ${d}`)}),`Map(${v.size}) {${c.join(", ")}}`}e.$li=D;function E(v){const c=[];return v.forEach(d=>{c.push(d)}),`Set(${v.size}) {${c.join(", ")}}`}e.$mi=E;class f{constructor(c,d){this.uri=c,this.value=d}}class h{static{this.a=c=>c.toString()}constructor(c,d){this[k]="ResourceMap",c instanceof h?(this.b=new Map(c.b),this.c=d??h.a):(this.b=new Map,this.c=c??h.a)}set(c,d){return this.b.set(this.c(c),new f(c,d)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,d){typeof d<"u"&&(c=c.bind(d));for(const[l,w]of this.b)c(w.value,w.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$ni=h;class ${constructor(c,d){this[O]="ResourceSet",!c||typeof c=="function"?this.a=new h(c):(this.a=new h(d),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,d){this.a.forEach((l,w)=>c.call(d,w,w,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=$;var g;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class p{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,d=0){const l=this.a.get(c);if(l)return d!==0&&this.j(l,d),l.value}set(c,d,l=0){let w=this.a.get(c);if(w)w.value=d,l!==0&&this.j(w,l);else{switch(w={key:c,value:d,next:void 0,previous:void 0},l){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(c,w),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const d=this.a.get(c);if(d)return this.a.delete(c),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,d){const l=this.e;let w=this.b;for(;w;){if(d?c.bind(d)(w.value,w.key,this):c(w.value,w.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const c=this,d=this.e;let l=this.b;const w={[Symbol.iterator](){return w},next(){if(c.e!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.key,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return w}values(){const c=this,d=this.e;let l=this.b;const w={[Symbol.iterator](){return w},next(){if(c.e!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.value,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return w}entries(){const c=this,d=this.e;let l=this.b;const w={[Symbol.iterator](){return w},next(){if(c.e!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:[l.key,l.value],done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return w}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let d=this.b,l=this.size;for(;d&&l>c;)this.a.delete(d.key),d=d.next,l--;this.b=d,this.d=l,d&&(d.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const d=c.next,l=c.previous;if(!d||!l)throw new Error("Invalid list");d.previous=l,l.next=d}c.next=void 0,c.previous=void 0,this.e++}j(c,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(c===this.b)return;const l=c.next,w=c.previous;c===this.c?(w.next=void 0,this.c=w):(l.previous=w,w.next=l),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(d===2){if(c===this.c)return;const l=c.next,w=c.previous;c===this.b?(l.previous=void 0,this.b=l):(l.previous=w,w.next=l),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((d,l)=>{c.push([l,d])}),c}fromJSON(c){this.clear();for(const[d,l]of c)this.set(d,l)}}e.$pi=p;class u extends p{constructor(c,d=1){super(),this.k=c,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,d=2){return super.get(c,d)}peek(c){return super.get(c,0)}set(c,d){return super.set(c,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=u;class y{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let d=this.a.get(c)||0;return d===0?!1:(d--,d===0?this.a.delete(c):this.a.set(c,d),!0)}has(c){return this.a.has(c)}}e.$ri=y}),define(te[86],ie([0,1,35]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=void 0;const O=new k.$qi(1e4);function s(h){return f(h,"NFC",O)}e.$7k=s;const M=new k.$qi(1e4);function D(h){return f(h,"NFD",M)}e.$8k=D;const E=/[^\u0000-\u0080]/;function f(h,$,g){if(!h)return h;const p=g.get(h);if(p)return p;let u;return E.test(h)?u=h.normalize($):u=h,g.set(h,u),u}e.$9k=function(){const h=/[\u0300-\u036f]/g;return function($){return D($).replace(h,"")}}()}),define(te[138],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.$wl=e.rot=e.$ul=void 0;function k(E,f,h){return Math.min(Math.max(E,f),h)}e.$ul=k;function O(E,f){return(f+E%f)%f}e.rot=O;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$wl=s;class M{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$xl=M;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const h=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$yl=D}),function(){function H(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(f){M.push(f,Date.now())}function E(){const f=[];for(let h=0;h<M.length;h+=2)f.push({name:M[h],startTime:M[h+1]});return f}return{mark:D,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function k(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=k(O))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var O in k)(typeof exports=="object"?exports:H)[O]=k[O]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function k(O){if(e[O])return e[O].exports;var s=e[O]={i:O,l:!1,exports:{}};return H[O].call(s.exports,s,s.exports,k),s.l=!0,s.exports}return k.m=H,k.c=e,k.d=function(O,s,M){k.o(O,s)||Object.defineProperty(O,s,{enumerable:!0,get:M})},k.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},k.t=function(O,s){if(1&s&&(O=k(O)),8&s||4&s&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(k.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&s&&typeof O!="string")for(var D in O)k.d(M,D,function(E){return O[E]}.bind(null,D));return M},k.n=function(O){var s=O&&O.__esModule?function(){return O.default}:function(){return O};return k.d(s,"a",s),s},k.o=function(O,s){return Object.prototype.hasOwnProperty.call(O,s)},k.p="",k(k.s=0)}([function(H,e,k){(function(O){var s;e=H.exports=ce,s=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],f=e.src=[],h=0,$=h++;f[$]="0|[1-9]\\d*";var g=h++;f[g]="[0-9]+";var p=h++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=h++;f[u]="("+f[$]+")\\.("+f[$]+")\\.("+f[$]+")";var y=h++;f[y]="("+f[g]+")\\.("+f[g]+")\\.("+f[g]+")";var v=h++;f[v]="(?:"+f[$]+"|"+f[p]+")";var c=h++;f[c]="(?:"+f[g]+"|"+f[p]+")";var d=h++;f[d]="(?:-("+f[v]+"(?:\\."+f[v]+")*))";var l=h++;f[l]="(?:-?("+f[c]+"(?:\\."+f[c]+")*))";var w=h++;f[w]="[0-9A-Za-z-]+";var S=h++;f[S]="(?:\\+("+f[w]+"(?:\\."+f[w]+")*))";var m=h++,t="v?"+f[u]+f[d]+"?"+f[S]+"?";f[m]="^"+t+"$";var a="[v=\\s]*"+f[y]+f[l]+"?"+f[S]+"?",r=h++;f[r]="^"+a+"$";var i=h++;f[i]="((?:<|>)?=?)";var n=h++;f[n]=f[g]+"|x|X|\\*";var o=h++;f[o]=f[$]+"|x|X|\\*";var b=h++;f[b]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[d]+")?"+f[S]+"?)?)?";var I=h++;f[I]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[l]+")?"+f[S]+"?)?)?";var A=h++;f[A]="^"+f[i]+"\\s*"+f[b]+"$";var P=h++;f[P]="^"+f[i]+"\\s*"+f[I]+"$";var C=h++;f[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=h++;f[j]="(?:~>?)";var U=h++;f[U]="(\\s*)"+f[j]+"\\s+",E[U]=new RegExp(f[U],"g");var W=h++;f[W]="^"+f[j]+f[b]+"$";var re=h++;f[re]="^"+f[j]+f[I]+"$";var ne=h++;f[ne]="(?:\\^)";var fe=h++;f[fe]="(\\s*)"+f[ne]+"\\s+",E[fe]=new RegExp(f[fe],"g");var ae=h++;f[ae]="^"+f[ne]+f[b]+"$";var ue=h++;f[ue]="^"+f[ne]+f[I]+"$";var V=h++;f[V]="^"+f[i]+"\\s*("+a+")$|^$";var J=h++;f[J]="^"+f[i]+"\\s*("+t+")$|^$";var z=h++;f[z]="(\\s*)"+f[i]+"\\s*("+a+"|"+f[b]+")",E[z]=new RegExp(f[z],"g");var T=h++;f[T]="^\\s*("+f[b]+")\\s+-\\s+("+f[b]+")\\s*$";var F=h++;f[F]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var B=h++;f[B]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)s(x,f[x]),E[x]||(E[x]=new RegExp(f[x]));function oe(Z,he){if(Z instanceof ce)return Z;if(typeof Z!="string"||Z.length>M||!(he?E[r]:E[m]).test(Z))return null;try{return new ce(Z,he)}catch{return null}}function ce(Z,he){if(Z instanceof ce){if(Z.loose===he)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ce))return new ce(Z,he);s("SemVer",Z,he),this.loose=he;var $e=Z.trim().match(he?E[r]:E[m]);if(!$e)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ce=+Ee;if(Ce>=0&&Ce<D)return Ce}return Ee}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=oe,e.valid=function(Z,he){var $e=oe(Z,he);return $e?$e.version:null},e.clean=function(Z,he){var $e=oe(Z.trim().replace(/^[=v]+/,""),he);return $e?$e.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(Z){return s("SemVer.compare",this.version,this.loose,Z),Z instanceof ce||(Z=new ce(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},ce.prototype.compareMain=function(Z){return Z instanceof ce||(Z=new ce(Z,this.loose)),R(this.major,Z.major)||R(this.minor,Z.minor)||R(this.patch,Z.patch)},ce.prototype.comparePre=function(Z){if(Z instanceof ce||(Z=new ce(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var he=0;do{var $e=this.prerelease[he],Ee=Z.prerelease[he];if(s("prerelease compare",he,$e,Ee),$e===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if($e===void 0)return-1;if($e!==Ee)return R($e,Ee)}while(++he)},ce.prototype.inc=function(Z,he){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,he,$e,Ee){typeof $e=="string"&&(Ee=$e,$e=void 0);try{return new ce(Z,$e).inc(he,Ee).version}catch{return null}},e.diff=function(Z,he){if(se(Z,he))return null;var $e=oe(Z),Ee=oe(he);if($e.prerelease.length||Ee.prerelease.length){for(var Ce in $e)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&$e[Ce]!==Ee[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in $e)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&$e[Ce]!==Ee[Ce])return Ce},e.compareIdentifiers=R;var G=/^[0-9]+$/;function R(Z,he){var $e=G.test(Z),Ee=G.test(he);return $e&&Ee&&(Z=+Z,he=+he),$e&&!Ee?-1:Ee&&!$e?1:Z<he?-1:Z>he?1:0}function L(Z,he,$e){return new ce(Z,$e).compare(new ce(he,$e))}function N(Z,he,$e){return L(Z,he,$e)>0}function q(Z,he,$e){return L(Z,he,$e)<0}function se(Z,he,$e){return L(Z,he,$e)===0}function Y(Z,he,$e){return L(Z,he,$e)!==0}function le(Z,he,$e){return L(Z,he,$e)>=0}function K(Z,he,$e){return L(Z,he,$e)<=0}function ee(Z,he,$e,Ee){var Ce;switch(he){case"===":typeof Z=="object"&&(Z=Z.version),typeof $e=="object"&&($e=$e.version),Ce=Z===$e;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof $e=="object"&&($e=$e.version),Ce=Z!==$e;break;case"":case"=":case"==":Ce=se(Z,$e,Ee);break;case"!=":Ce=Y(Z,$e,Ee);break;case">":Ce=N(Z,$e,Ee);break;case">=":Ce=le(Z,$e,Ee);break;case"<":Ce=q(Z,$e,Ee);break;case"<=":Ce=K(Z,$e,Ee);break;default:throw new TypeError("Invalid operator: "+he)}return Ce}function X(Z,he){if(Z instanceof X){if(Z.loose===he)return Z;Z=Z.value}if(!(this instanceof X))return new X(Z,he);s("comparator",Z,he),this.loose=he,this.parse(Z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Z,he){return R(he,Z)},e.major=function(Z,he){return new ce(Z,he).major},e.minor=function(Z,he){return new ce(Z,he).minor},e.patch=function(Z,he){return new ce(Z,he).patch},e.compare=L,e.compareLoose=function(Z,he){return L(Z,he,!0)},e.rcompare=function(Z,he,$e){return L(he,Z,$e)},e.sort=function(Z,he){return Z.sort(function($e,Ee){return e.compare($e,Ee,he)})},e.rsort=function(Z,he){return Z.sort(function($e,Ee){return e.rcompare($e,Ee,he)})},e.gt=N,e.lt=q,e.eq=se,e.neq=Y,e.gte=le,e.lte=K,e.cmp=ee,e.Comparator=X;var de={};function me(Z,he){if(Z instanceof me)return Z.loose===he?Z:new me(Z.raw,he);if(Z instanceof X)return new me(Z.value,he);if(!(this instanceof me))return new me(Z,he);if(this.loose=he,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Re(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function De(Z,he,$e,Ee,Ce,Fe,Oe,ze,We,_,ge,we,ve){return((he=Re($e)?"":Re(Ee)?">="+$e+".0.0":Re(Ce)?">="+$e+"."+Ee+".0":">="+he)+" "+(ze=Re(We)?"":Re(_)?"<"+(+We+1)+".0.0":Re(ge)?"<"+We+"."+(+_+1)+".0":we?"<="+We+"."+_+"."+ge+"-"+we:"<="+ze)).trim()}function je(Z,he){for(var $e=0;$e<Z.length;$e++)if(!Z[$e].test(he))return!1;if(he.prerelease.length){for($e=0;$e<Z.length;$e++)if(s(Z[$e].semver),Z[$e].semver!==de&&Z[$e].semver.prerelease.length>0){var Ee=Z[$e].semver;if(Ee.major===he.major&&Ee.minor===he.minor&&Ee.patch===he.patch)return!0}return!1}return!0}function ye(Z,he,$e){try{he=new me(he,$e)}catch{return!1}return he.test(Z)}function be(Z,he,$e,Ee){var Ce,Fe,Oe,ze,We;switch(Z=new ce(Z,Ee),he=new me(he,Ee),$e){case">":Ce=N,Fe=K,Oe=q,ze=">",We=">=";break;case"<":Ce=q,Fe=le,Oe=N,ze="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(Z,he,Ee))return!1;for(var _=0;_<he.set.length;++_){var ge=he.set[_],we=null,ve=null;if(ge.forEach(function(Ae){Ae.semver===de&&(Ae=new X(">=0.0.0")),we=we||Ae,ve=ve||Ae,Ce(Ae.semver,we.semver,Ee)?we=Ae:Oe(Ae.semver,ve.semver,Ee)&&(ve=Ae)}),we.operator===ze||we.operator===We||(!ve.operator||ve.operator===ze)&&Fe(Z,ve.semver)||ve.operator===We&&Oe(Z,ve.semver))return!1}return!0}X.prototype.parse=function(Z){var he=this.loose?E[V]:E[J],$e=Z.match(he);if(!$e)throw new TypeError("Invalid comparator: "+Z);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new ce($e[2],this.loose):this.semver=de},X.prototype.toString=function(){return this.value},X.prototype.test=function(Z){return s("Comparator.test",Z,this.loose),this.semver===de||(typeof Z=="string"&&(Z=new ce(Z,this.loose)),ee(Z,this.operator,this.semver,this.loose))},X.prototype.intersects=function(Z,he){if(!(Z instanceof X))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(Z.value,he),ye(this.value,$e,he);if(Z.operator==="")return $e=new me(this.value,he),ye(Z.semver,$e,he);var Ee=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Fe=this.semver.version===Z.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),ze=ee(this.semver,"<",Z.semver,he)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),We=ee(this.semver,">",Z.semver,he)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ee||Ce||Fe&&Oe||ze||We},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(Z){var he=this.loose;Z=Z.trim(),s("range",Z,he);var $e=he?E[F]:E[T];Z=Z.replace($e,De),s("hyphen replace",Z),Z=Z.replace(E[z],"$1$2$3"),s("comparator trim",Z,E[z]),Z=(Z=(Z=Z.replace(E[U],"$1~")).replace(E[fe],"$1^")).split(/\s+/).join(" ");var Ee=he?E[V]:E[J],Ce=Z.split(" ").map(function(Fe){return function(Oe,ze){return s("comp",Oe),Oe=function(We,_){return We.trim().split(/\s+/).map(function(ge){return function(we,ve){s("caret",we,ve);var Ae=ve?E[ue]:E[ae];return we.replace(Ae,function(Ue,Me,Te,Be,He){var qe;return s("caret",we,Ue,Me,Te,Be,He),Re(Me)?qe="":Re(Te)?qe=">="+Me+".0.0 <"+(+Me+1)+".0.0":Re(Be)?qe=Me==="0"?">="+Me+"."+Te+".0 <"+Me+"."+(+Te+1)+".0":">="+Me+"."+Te+".0 <"+(+Me+1)+".0.0":He?(s("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),qe=Me==="0"?Te==="0"?">="+Me+"."+Te+"."+Be+He+" <"+Me+"."+Te+"."+(+Be+1):">="+Me+"."+Te+"."+Be+He+" <"+Me+"."+(+Te+1)+".0":">="+Me+"."+Te+"."+Be+He+" <"+(+Me+1)+".0.0"):(s("no pr"),qe=Me==="0"?Te==="0"?">="+Me+"."+Te+"."+Be+" <"+Me+"."+Te+"."+(+Be+1):">="+Me+"."+Te+"."+Be+" <"+Me+"."+(+Te+1)+".0":">="+Me+"."+Te+"."+Be+" <"+(+Me+1)+".0.0"),s("caret return",qe),qe})}(ge,_)}).join(" ")}(Oe,ze),s("caret",Oe),Oe=function(We,_){return We.trim().split(/\s+/).map(function(ge){return function(we,ve){var Ae=ve?E[re]:E[W];return we.replace(Ae,function(Ue,Me,Te,Be,He){var qe;return s("tilde",we,Ue,Me,Te,Be,He),Re(Me)?qe="":Re(Te)?qe=">="+Me+".0.0 <"+(+Me+1)+".0.0":Re(Be)?qe=">="+Me+"."+Te+".0 <"+Me+"."+(+Te+1)+".0":He?(s("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),qe=">="+Me+"."+Te+"."+Be+He+" <"+Me+"."+(+Te+1)+".0"):qe=">="+Me+"."+Te+"."+Be+" <"+Me+"."+(+Te+1)+".0",s("tilde return",qe),qe})}(ge,_)}).join(" ")}(Oe,ze),s("tildes",Oe),Oe=function(We,_){return s("replaceXRanges",We,_),We.split(/\s+/).map(function(ge){return function(we,ve){we=we.trim();var Ae=ve?E[P]:E[A];return we.replace(Ae,function(Ue,Me,Te,Be,He,qe){s("xRange",we,Ue,Me,Te,Be,He,qe);var xe=Re(Te),Xe=xe||Re(Be),tt=Xe||Re(He);return Me==="="&&tt&&(Me=""),xe?Ue=Me===">"||Me==="<"?"<0.0.0":"*":Me&&tt?(Xe&&(Be=0),tt&&(He=0),Me===">"?(Me=">=",Xe?(Te=+Te+1,Be=0,He=0):tt&&(Be=+Be+1,He=0)):Me==="<="&&(Me="<",Xe?Te=+Te+1:Be=+Be+1),Ue=Me+Te+"."+Be+"."+He):Xe?Ue=">="+Te+".0.0 <"+(+Te+1)+".0.0":tt&&(Ue=">="+Te+"."+Be+".0 <"+Te+"."+(+Be+1)+".0"),s("xRange return",Ue),Ue})}(ge,_)}).join(" ")}(Oe,ze),s("xrange",Oe),Oe=function(We,_){return s("replaceStars",We,_),We.trim().replace(E[B],"")}(Oe,ze),s("stars",Oe),Oe}(Fe,he)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(Ee)})),Ce=Ce.map(function(Fe){return new X(Fe,he)})},me.prototype.intersects=function(Z,he){if(!(Z instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Ee){return Z.set.some(function(Ce){return Ce.every(function(Fe){return Ee.intersects(Fe,he)})})})})},e.toComparators=function(Z,he){return new me(Z,he).set.map(function($e){return $e.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},me.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new ce(Z,this.loose));for(var he=0;he<this.set.length;he++)if(je(this.set[he],Z))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(Z,he,$e){var Ee=null,Ce=null;try{var Fe=new me(he,$e)}catch{return null}return Z.forEach(function(Oe){Fe.test(Oe)&&(Ee&&Ce.compare(Oe)!==-1||(Ce=new ce(Ee=Oe,$e)))}),Ee},e.minSatisfying=function(Z,he,$e){var Ee=null,Ce=null;try{var Fe=new me(he,$e)}catch{return null}return Z.forEach(function(Oe){Fe.test(Oe)&&(Ee&&Ce.compare(Oe)!==1||(Ce=new ce(Ee=Oe,$e)))}),Ee},e.validRange=function(Z,he){try{return new me(Z,he).range||"*"}catch{return null}},e.ltr=function(Z,he,$e){return be(Z,he,"<",$e)},e.gtr=function(Z,he,$e){return be(Z,he,">",$e)},e.outside=be,e.prerelease=function(Z,he){var $e=oe(Z,he);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(Z,he,$e){return Z=new me(Z,$e),he=new me(he,$e),Z.intersects(he)},e.coerce=function(Z){if(Z instanceof ce)return Z;if(typeof Z!="string")return null;var he=Z.match(E[C]);return he==null?null:oe((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,k(1))},function(H,e){var k,O,s=H.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function E(c){if(k===setTimeout)return setTimeout(c,0);if((k===M||!k)&&setTimeout)return k=setTimeout,setTimeout(c,0);try{return k(c,0)}catch{try{return k.call(null,c,0)}catch{return k.call(this,c,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:M}catch{k=M}try{O=typeof clearTimeout=="function"?clearTimeout:D}catch{O=D}})();var f,h=[],$=!1,g=-1;function p(){$&&f&&($=!1,f.length?h=f.concat(h):g=-1,h.length&&u())}function u(){if(!$){var c=E(p);$=!0;for(var d=h.length;d;){for(f=h,h=[];++g<d;)f&&f[g].run();g=-1,d=h.length}f=null,$=!1,function(l){if(O===clearTimeout)return clearTimeout(l);if((O===D||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(l);try{O(l)}catch{try{return O.call(null,l)}catch{return O.call(this,l)}}}(c)}}function y(c,d){this.fun=c,this.array=d}function v(){}s.nextTick=function(c){var d=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)d[l-1]=arguments[l];h.push(new y(c,d)),h.length!==1||$||E(u)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=v,s.addListener=v,s.once=v,s.off=v,s.removeListener=v,s.removeAllListeners=v,s.emit=v,s.prependListener=v,s.prependOnceListener=v,s.listeners=function(c){return[]},s.binding=function(c){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(c){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(H,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class O{constructor(E,f,h){this.level=E,this.key=f,this.value=h,this.forward=[]}}const s=void 0;class M{constructor(E,f=2**16){this.comparator=E,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new O(this.c,s,s)}get size(){return this.f}clear(){this.e=new O(this.c,s,s)}has(E){return!!M.g(this,E,this.comparator)}get(E){return M.g(this,E,this.comparator)?.value}set(E,f){return M.h(this,E,f,this.comparator)&&(this.f+=1),this}delete(E){const f=M.k(this,E,this.comparator);return f&&(this.f-=1),f}forEach(E,f){let h=this.e.forward[0];for(;h;)E.call(f,h.value,h.key,this),h=h.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",f=this.e.forward[0];for(;f;)E+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return E}static g(E,f,h){let $=E.e;for(let g=E.d-1;g>=0;g--)for(;$.forward[g]&&h($.forward[g].key,f)<0;)$=$.forward[g];if($=$.forward[0],$&&h($.key,f)===0)return $}static h(E,f,h,$){const g=[];let p=E.e;for(let u=E.d-1;u>=0;u--){for(;p.forward[u]&&$(p.forward[u].key,f)<0;)p=p.forward[u];g[u]=p}if(p=p.forward[0],p&&$(p.key,f)===0)return p.value=h,!1;{const u=M.j(E);if(u>E.d){for(let y=E.d;y<u;y++)g[y]=E.e;E.d=u}p=new O(u,f,h);for(let y=0;y<u;y++)p.forward[y]=g[y].forward[y],g[y].forward[y]=p;return!0}}static j(E,f=.5){let h=1;for(;Math.random()<f&&h<E.c;)h+=1;return h}static k(E,f,h){const $=[];let g=E.e;for(let p=E.d-1;p>=0;p--){for(;g.forward[p]&&h(g.forward[p].key,f)<0;)g=g.forward[p];$[p]=g}if(g=g.forward[0],!g||h(g.key,f)!==0)return!1;for(let p=0;p<E.d&&$[p].forward[p]===g;p++)$[p].forward[p]=g.forward[p];for(;E.d>0&&E.e.forward[E.d-1]===s;)E.d-=1;return!0}}e.$fr=M}),define(te[69],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(M){return new O(M)}constructor(M){this.c=k&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ac=O}),define(te[3],ie([0,1,13,49,2,102,69]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.Event=void 0;const E=!1,f=!1;var h;(function(A){A.None=()=>s.$lb.None;function P(Y){if(f){const{onDidAddListener:le}=Y,K=y.create();let ee=0;Y.onDidAddListener=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),le?.()}}}function C(Y,le){return V(Y,()=>{},0,void 0,!0,void 0,le)}A.defer=C;function j(Y){return(le,K=null,ee)=>{let X=!1,de;return de=Y(me=>{if(!X)return de?de.dispose():X=!0,le.call(K,me)},null,ee),X&&de.dispose(),de}}A.once=j;function U(Y,le,K){return ue((ee,X=null,de)=>Y(me=>ee.call(X,le(me)),null,de),K)}A.map=U;function W(Y,le,K){return ue((ee,X=null,de)=>Y(me=>{le(me),ee.call(X,me)},null,de),K)}A.forEach=W;function re(Y,le,K){return ue((ee,X=null,de)=>Y(me=>le(me)&&ee.call(X,me),null,de),K)}A.filter=re;function ne(Y){return Y}A.signal=ne;function fe(...Y){return(le,K=null,ee)=>(0,s.$ib)(...Y.map(X=>X(de=>le.call(K,de),null,ee)))}A.any=fe;function ae(Y,le,K,ee){let X=K;return U(Y,de=>(X=le(X,de),X),ee)}A.reduce=ae;function ue(Y,le){let K;const ee={onWillAddFirstListener(){K=Y(X.fire,X)},onDidRemoveLastListener(){K?.dispose()}};le||P(ee);const X=new w(ee);return le?.add(X),X.event}function V(Y,le,K=100,ee=!1,X=!1,de,me){let Re,De,je,ye=0,be;const Z={leakWarningThreshold:de,onWillAddFirstListener(){Re=Y($e=>{ye++,De=le(De,$e),ee&&!je&&(he.fire(De),De=void 0),be=()=>{const Ee=De;De=void 0,je=void 0,(!ee||ye>1)&&he.fire(Ee),ye=0},typeof K=="number"?(clearTimeout(je),je=setTimeout(be,K)):je===void 0&&(je=0,queueMicrotask(be))})},onWillRemoveListener(){X&&ye>0&&be?.()},onDidRemoveLastListener(){be=void 0,Re.dispose()}};me||P(Z);const he=new w(Z);return me?.add(he),he.event}A.debounce=V;function J(Y,le=0,K){return A.debounce(Y,(ee,X)=>ee?(ee.push(X),ee):[X],le,void 0,!0,void 0,K)}A.accumulate=J;function z(Y,le=(ee,X)=>ee===X,K){let ee=!0,X;return re(Y,de=>{const me=ee||!le(de,X);return ee=!1,X=de,me},K)}A.latch=z;function T(Y,le,K){return[A.filter(Y,le,K),A.filter(Y,ee=>!le(ee),K)]}A.split=T;function F(Y,le=!1,K=[]){let ee=K.slice(),X=Y(Re=>{ee?ee.push(Re):me.fire(Re)});const de=()=>{ee?.forEach(Re=>me.fire(Re)),ee=null},me=new w({onWillAddFirstListener(){X||(X=Y(Re=>me.fire(Re)))},onDidAddFirstListener(){ee&&(le?setTimeout(de):de())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return me.event}A.buffer=F;class B{constructor(le){this.event=le,this.d=new s.$kb}map(le){return new B(U(this.event,le,this.d))}forEach(le){return new B(W(this.event,le,this.d))}filter(le){return new B(re(this.event,le,this.d))}reduce(le,K){return new B(ae(this.event,le,K,this.d))}latch(){return new B(z(this.event,void 0,this.d))}debounce(le,K=100,ee=!1,X=!1,de){return new B(V(this.event,le,K,ee,X,de,this.d))}on(le,K,ee){return this.event(le,K,ee)}once(le,K,ee){return j(this.event)(le,K,ee)}dispose(){this.d.dispose()}}function x(Y){return new B(Y)}A.chain=x;function oe(Y,le,K=ee=>ee){const ee=(...Re)=>me.fire(K(...Re)),X=()=>Y.on(le,ee),de=()=>Y.removeListener(le,ee),me=new w({onWillAddFirstListener:X,onDidRemoveLastListener:de});return me.event}A.fromNodeEventEmitter=oe;function ce(Y,le,K=ee=>ee){const ee=(...Re)=>me.fire(K(...Re)),X=()=>Y.addEventListener(le,ee),de=()=>Y.removeEventListener(le,ee),me=new w({onWillAddFirstListener:X,onDidRemoveLastListener:de});return me.event}A.fromDOMEventEmitter=ce;function G(Y){return new Promise(le=>j(Y)(le))}A.toPromise=G;function R(Y,le){return le(void 0),Y(K=>le(K))}A.runAndSubscribe=R;function L(Y,le){let K=null;function ee(de){K?.dispose(),K=new s.$kb,le(de,K)}ee(void 0);const X=Y(de=>ee(de));return(0,s.$jb)(()=>{X.dispose(),K?.dispose()})}A.runAndSubscribeWithStore=L;class N{constructor(le,K){this._observable=le,this.d=0,this.f=!1;const ee={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};K||P(ee),this.emitter=new w(ee),K&&K.add(this.emitter)}beginUpdate(le){this.d++}handlePossibleChange(le){}handleChange(le,K){this.f=!0}endUpdate(le){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function q(Y,le){return new N(Y,le).emitter.event}A.fromObservable=q;function se(Y){return le=>{let K=0,ee=!1;const X={beginUpdate(){K++},endUpdate(){K--,K===0&&(Y.reportChanges(),ee&&(ee=!1,le()))},handlePossibleChange(){},handleChange(){ee=!0}};return Y.addObserver(X),Y.reportChanges(),{dispose(){Y.removeObserver(X)}}}}A.fromObservableLight=se})(h||(e.Event=h={}));class ${static{this.all=new Set}static{this.d=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${$.d++}`,$.all.add(this)}start(P){this.f=new D.$ac,this.listenerCount=P}stop(){if(this.f){const P=this.f.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.f=void 0}}}e.$cc=$;let g=-1;function p(A){const P=g;return g=A,{dispose(){g=P}}}e.$dc=p;class u{constructor(P,C=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=C,this.f=0}dispose(){this.d?.clear()}check(P,C){const j=this.threshold;if(j<=0||C<j)return;this.d||(this.d=new Map);const U=this.d.get(P.value)||0;if(this.d.set(P.value,U+1),this.f-=1,this.f<=0){this.f=j*.5;let W,re=0;for(const[ne,fe]of this.d)(!W||re<fe)&&(W=ne,re=fe);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${re}):`),console.warn(W)}return()=>{const W=this.d.get(P.value)||0;this.d.set(P.value,W-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class c{constructor(P){this.value=P,this.id=v++}}const d=2,l=(A,P)=>{if(A instanceof c)P(A);else for(let C=0;C<A.length;C++){const j=A[C];j&&P(j)}};class w{constructor(P){this.u=0,this.d=P,this.f=g>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??g):void 0,this.g=this.d?._profName?new $(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(E){const P=this.q;queueMicrotask(()=>{l(P,C=>C.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(P,C,j)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$lb.None;if(this.j)return s.$lb.None;C&&(P=P.bind(C));const U=new c(P);let W,re;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(U.stack=y.create(),W=this.f.check(U.stack,this.u+1)),E&&(U.stack=re??y.create()),this.q?this.q instanceof c?(this.t??=new m,this.q=[this.q,U]):this.q.push(U):(this.d?.onWillAddFirstListener?.(this),this.q=U,this.d?.onDidAddFirstListener?.(this)),this.u++;const ne=(0,s.$jb)(()=>{W?.(),this.v(U)});return j instanceof s.$kb?j.add(ne):Array.isArray(j)&&j.push(ne),ne},this.m}v(P){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const C=this.q,j=C.indexOf(P);if(j===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,C[j]=void 0;const U=this.t.current===this;if(this.u*d<=C.length){let W=0;for(let re=0;re<C.length;re++)C[re]?C[W++]=C[re]:U&&(this.t.end--,W<this.t.i&&this.t.i--);C.length=W}}w(P,C){if(!P)return;const j=this.d?.onListenerError||k.$Y;if(!j){P.value(C);return}try{P.value(C)}catch(U){j(U)}}x(P){const C=P.current.q;for(;P.i<P.end;)this.w(C[P.i++],P.value);P.reset()}fire(P){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof c)this.w(this.q,P);else{const C=this.t;C.enqueue(this,P,this.q.length),this.x(C)}this.g?.stop()}hasListeners(){return this.u>0}}e.$ec=w;const S=()=>new m;e.$fc=S;class m{constructor(){this.i=-1,this.end=0}enqueue(P,C,j){this.i=0,this.end=j,this.current=P,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends w{async fireAsync(P,C,j){if(this.q)for(this.h||(this.h=new M.$ub),l(this.q,U=>this.h.push([U.value,P]));this.h.size>0&&!C.isCancellationRequested;){const[U,W]=this.h.shift(),re=[],ne={...W,token:C,waitUntil:fe=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");j&&(fe=j(fe,U)),re.push(fe)}};try{U(ne)}catch(fe){(0,k.$Y)(fe);continue}Object.freeze(re),await Promise.allSettled(re).then(fe=>{for(const ae of fe)ae.status==="rejected"&&(0,k.$Y)(ae.reason)})}}}e.$gc=t;class a extends w{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new M.$ub,this.y=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.y(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.u&&(this.h!==0?this.s.push(P):super.fire(P))}}e.$hc=a;class r extends a{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}e.$ic=r;class i extends w{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$jc=i;class n{constructor(){this.f=!1,this.g=[],this.d=new w({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(P){const C={event:P,listener:null};this.g.push(C),this.f&&this.k(C);const j=()=>{this.f&&this.m(C);const U=this.g.indexOf(C);this.g.splice(U,1)};return(0,s.$jb)((0,O.$cb)(j))}h(){this.f=!0,this.g.forEach(P=>this.k(P))}j(){this.f=!1,this.g.forEach(P=>this.m(P))}k(P){P.listener=P.event(C=>this.d.fire(C))}m(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.d.dispose()}}e.$kc=n;class o{constructor(P,C,j,U){this.d=new s.$kb;const W=this.d.add(new n),re=this.d.add(new s.$tb);function ne(fe){re.set(fe,W.add(U(fe)))}for(const fe of P)ne(fe);this.d.add(C(fe=>{ne(fe)})),this.d.add(j(fe=>{re.deleteAndDispose(fe)})),this.event=W.event}dispose(){this.d.dispose()}}e.$lc=o;class b{constructor(){this.d=[]}wrapEvent(P){return(C,j,U)=>P(W=>{const re=this.d[this.d.length-1];re?re.push(()=>C.call(j,W)):C.call(j,W)},void 0,U)}bufferEvents(P){const C=[];this.d.push(C);const j=P();return this.d.pop(),C.forEach(U=>U()),j}}e.$mc=b;class I{constructor(){this.d=!1,this.f=h.None,this.g=s.$lb.None,this.h=new w({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(P){this.f=P,this.d&&(this.g.dispose(),this.g=P(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$nc=I}),define(te[23],ie([0,1,3]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.CancellationToken=void 0;const O=Object.freeze(function(E,f){const h=setTimeout(E.bind(f),0);return{dispose(){clearTimeout(h)}}});var s;(function(E){function f(h){return h===E.None||h===E.Cancelled||h instanceof M?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}E.isCancellationToken=f,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new k.$ec),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new M),this.a}cancel(){this.a?this.a instanceof M&&this.a.cancel():this.a=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof M&&this.a.dispose():this.a=s.None}}e.$oc=D}),define(te[140],ie([0,1,23]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.$hd=e.$gd=void 0;class O{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new k.$oc,f=this.b(E.token);return this.a={promise:f,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$gd=O;class s{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const f=JSON.stringify(E);return this.b!==f&&(this.b=f,this.a=this.c(E)),this.a}}e.$hd=s;class M{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const f=this.b(E);return this.a.set(E,f),f}}e.$id=M}),define(te[56],ie([0,1,13,2]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function s(S){const m=S;return m?typeof m.read=="function":!1}e.$pc=s;function M(S){const m=S;return m?[m.on,m.pause,m.resume,m.destroy].every(t=>typeof t=="function"):!1}e.$qc=M;function D(S){const m=S;return m?M(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.$rc=D;function E(S,m){return new f(S,m)}e.$sc=E;class f{constructor(m,t){this.e=m,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(t=>t(m))}h(m){this.c.error.length===0?(0,k.$Y)(m):this.c.error.slice(0).forEach(t=>t(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,t){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(m,t){if(this.a.destroyed)return;let a;switch(m){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const r=a.indexOf(t);r>=0&&a.splice(r,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(S,m){const t=[];let a;for(;(a=S.read())!==null;)t.push(a);return m(t)}e.$tc=h;function $(S,m,t){const a=[];let r;for(;(r=S.read())!==null&&a.length<t;)a.push(r);return r===null&&a.length>0?m(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return S.read()}}}e.$uc=$;function g(S,m){return new Promise((t,a)=>{const r=[];p(S,{onData:i=>{m&&r.push(i)},onError:i=>{m?a(i):t(void 0)},onEnd:()=>{t(m?m(r):void 0)}})})}e.$vc=g;function p(S,m,t){S.on("error",a=>{t?.isCancellationRequested||m.onError(a)}),S.on("end",()=>{t?.isCancellationRequested||m.onEnd()}),S.on("data",a=>{t?.isCancellationRequested||m.onData(a)})}e.$wc=p;function u(S,m){return new Promise((t,a)=>{const r=new O.$kb,i=[],n=I=>{if(i.push(I),i.length>m)return r.dispose(),S.pause(),t({stream:S,buffer:i,ended:!1})},o=I=>a(I),b=()=>t({stream:S,buffer:i,ended:!0});r.add((0,O.$jb)(()=>S.removeListener("error",o))),S.on("error",o),r.add((0,O.$jb)(()=>S.removeListener("end",b))),S.on("end",b),r.add((0,O.$jb)(()=>S.removeListener("data",n))),S.on("data",n)})}e.$xc=u;function y(S,m){const t=E(m);return t.end(S),t}e.$yc=y;function v(){const S=E(()=>{throw new Error("not supported")});return S.end(),S}e.$zc=v;function c(S){let m=!1;return{read:()=>m?null:(m=!0,S)}}e.$Ac=c;function d(S,m,t){const a=E(t);return p(S,{onData:r=>a.write(m.data(r)),onError:r=>a.error(m.error?m.error(r):r),onEnd:()=>a.end()}),a}e.$Bc=d;function l(S,m,t){let a=!1;return{read:()=>{const r=m.read();return a?r:(a=!0,r!==null?t([S,r]):S)}}}e.$Cc=l;function w(S,m,t){let a=!1;const r=E(t);return p(m,{onData:i=>a?r.write(i):(a=!0,r.write(t([S,i]))),onError:i=>r.error(i),onEnd:()=>{a||(a=!0,r.write(S)),r.end()}}),r}e.$Dc=w}),define(te[17],ie([0,1,85,56]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const s=typeof Buffer<"u",M=new k.$T(()=>new Uint8Array(256));let D,E;class f{static alloc(C){return s?new f(Buffer.allocUnsafe(C)):new f(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new f(C)}static fromString(C,j){return!(j?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(C)):(D||(D=new TextEncoder),new f(D.encode(C)))}static fromByteArray(C){const j=f.alloc(C.length);for(let U=0,W=C.length;U<W;U++)j.buffer[U]=C[U];return j}static concat(C,j){if(typeof j>"u"){j=0;for(let re=0,ne=C.length;re<ne;re++)j+=C[re].byteLength}const U=f.alloc(j);let W=0;for(let re=0,ne=C.length;re<ne;re++){const fe=C[re];U.set(fe,W),W+=fe.byteLength}return U}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=f.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(C,j){return new f(this.buffer.subarray(C,j))}set(C,j){if(C instanceof f)this.buffer.set(C.buffer,j);else if(C instanceof Uint8Array)this.buffer.set(C,j);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),j);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return p(this.buffer,C)}writeUInt32BE(C,j){u(this.buffer,C,j)}readUInt32LE(C){return y(this.buffer,C)}writeUInt32LE(C,j){v(this.buffer,C,j)}readUInt8(C){return c(this.buffer,C)}writeUInt8(C,j){d(this.buffer,C,j)}indexOf(C,j=0){return h(this.buffer,C instanceof f?C.buffer:C,j)}}e.$Ec=f;function h(P,C,j=0){const U=C.byteLength,W=P.byteLength;if(U===0)return 0;if(U===1)return P.indexOf(C[0]);if(U>W-j)return-1;const re=M.value;re.fill(C.length);for(let ue=0;ue<C.length;ue++)re[C[ue]]=C.length-ue-1;let ne=j+C.length-1,fe=ne,ae=-1;for(;ne<W;)if(P[ne]===C[fe]){if(fe===0){ae=ne;break}ne--,fe--}else ne+=Math.max(C.length-fe,re[P[ne]]),fe=C.length-1;return ae}e.$Fc=h;function $(P,C){return P[C+0]<<0>>>0|P[C+1]<<8>>>0}e.$Gc=$;function g(P,C,j){P[j+0]=C&255,C=C>>>8,P[j+1]=C&255}e.$Hc=g;function p(P,C){return P[C]*2**24+P[C+1]*2**16+P[C+2]*2**8+P[C+3]}e.$Ic=p;function u(P,C,j){P[j+3]=C,C=C>>>8,P[j+2]=C,C=C>>>8,P[j+1]=C,C=C>>>8,P[j]=C}e.$Jc=u;function y(P,C){return P[C+0]<<0>>>0|P[C+1]<<8>>>0|P[C+2]<<16>>>0|P[C+3]<<24>>>0}e.$Kc=y;function v(P,C,j){P[j+0]=C&255,C=C>>>8,P[j+1]=C&255,C=C>>>8,P[j+2]=C&255,C=C>>>8,P[j+3]=C&255}e.$Lc=v;function c(P,C){return P[C]}e.$Mc=c;function d(P,C,j){P[j]=C}e.$Nc=d;function l(P){return O.$tc(P,C=>f.concat(C))}e.$Oc=l;function w(P){return O.$Ac(P)}e.$Pc=w;function S(P){return O.$vc(P,C=>f.concat(C))}e.$Qc=S;async function m(P){return P.ended?f.concat(P.buffer):f.concat([...P.buffer,await S(P.stream)])}e.$Rc=m;function t(P){return O.$yc(P,C=>f.concat(C))}e.$Sc=t;function a(P){return O.$Bc(P,{data:C=>typeof C=="string"?f.fromString(C):f.wrap(C)},C=>f.concat(C))}e.$Tc=a;function r(P){return O.$sc(C=>f.concat(C),P)}e.$Uc=r;function i(P,C){return O.$Cc(P,C,j=>f.concat(j))}e.$Vc=i;function n(P,C){return O.$Dc(P,C,j=>f.concat(j))}e.$Wc=n;function o(P){let C=0,j=0,U=0;const W=new Uint8Array(Math.floor(P.length/4*3)),re=fe=>{switch(j){case 3:W[U++]=C|fe,j=0;break;case 2:W[U++]=C|fe>>>2,C=fe<<6,j=3;break;case 1:W[U++]=C|fe>>>4,C=fe<<4,j=2;break;default:C=fe<<2,j=1}};for(let fe=0;fe<P.length;fe++){const ae=P.charCodeAt(fe);if(ae>=65&&ae<=90)re(ae-65);else if(ae>=97&&ae<=122)re(ae-97+26);else if(ae>=48&&ae<=57)re(ae-48+52);else if(ae===43||ae===45)re(62);else if(ae===47||ae===95)re(63);else{if(ae===61)break;throw new SyntaxError(`Unexpected base64 character ${P[fe]}`)}}const ne=U;for(;j>0;)re(0);return f.wrap(W).slice(0,ne)}e.$Xc=o;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:P},C=!0,j=!1){const U=j?I:b;let W="";const re=P.byteLength%3;let ne=0;for(;ne<P.byteLength-re;ne+=3){const fe=P[ne+0],ae=P[ne+1],ue=P[ne+2];W+=U[fe>>>2],W+=U[(fe<<4|ae>>>4)&63],W+=U[(ae<<2|ue>>>6)&63],W+=U[ue&63]}if(re===1){const fe=P[ne+0];W+=U[fe>>>2],W+=U[fe<<4&63],C&&(W+="==")}else if(re===2){const fe=P[ne+0],ae=P[ne+1];W+=U[fe>>>2],W+=U[(fe<<4|ae>>>4)&63],W+=U[ae<<2&63],C&&(W+="=")}return W}e.$Yc=A}),define(te[26],ie([0,1,140,85]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.GraphemeBreakType=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=void 0;function s(_){return!_||typeof _!="string"?!0:_.trim().length===0}e.$ld=s;const M=/{(\d+)}/g;function D(_,...ge){return ge.length===0?_:_.replace(M,function(we,ve){const Ae=parseInt(ve,10);return isNaN(Ae)||Ae<0||Ae>=ge.length?we:ge[Ae]})}e.$md=D;const E=/{([^}]+)}/g;function f(_,ge){return _.replace(E,(we,ve)=>ge[ve]??we)}e.$nd=f;function h(_){return _.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.$od=h;function $(_){return _.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pd=$;function g(_,ge){let we=0;const ve=ge.charCodeAt(0);for(let Ae=_.length-1;Ae>=0;Ae--)_.charCodeAt(Ae)===ve&&we++;return we}e.$qd=g;function p(_,ge,we="\u2026"){return _.length<=ge?_:`${_.substr(0,ge)}${we}`}e.$rd=p;function u(_,ge=" "){const we=y(_,ge);return v(we,ge)}e.$sd=u;function y(_,ge){if(!_||!ge)return _;const we=ge.length;if(we===0||_.length===0)return _;let ve=0;for(;_.indexOf(ge,ve)===ve;)ve=ve+we;return _.substring(ve)}e.$td=y;function v(_,ge){if(!_||!ge)return _;const we=ge.length,ve=_.length;if(we===0||ve===0)return _;let Ae=ve,Ue=-1;for(;Ue=_.lastIndexOf(ge,Ae-1),!(Ue===-1||Ue+we!==Ae);){if(Ue===0)return"";Ae=Ue}return _.substring(0,Ae)}e.$ud=v;function c(_){return _.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$vd=c;function d(_){return _.replace(/\*/g,"")}e.$wd=d;function l(_,ge,we={}){if(!_)throw new Error("Cannot create regex from empty string");ge||(_=$(_)),we.wholeWord&&(/\B/.test(_.charAt(0))||(_="\\b"+_),/\B/.test(_.charAt(_.length-1))||(_=_+"\\b"));let ve="";return we.global&&(ve+="g"),we.matchCase||(ve+="i"),we.multiline&&(ve+="m"),we.unicode&&(ve+="u"),new RegExp(_,ve)}e.$xd=l;function w(_){return _.source==="^"||_.source==="^$"||_.source==="$"||_.source==="^\\s*$"?!1:!!(_.exec("")&&_.lastIndex===0)}e.$yd=w;function S(_){return _.split(/\r\n|\r|\n/)}e.$zd=S;function m(_){for(let ge=0,we=_.length;ge<we;ge++){const ve=_.charCodeAt(ge);if(ve!==32&&ve!==9)return ge}return-1}e.$Ad=m;function t(_,ge=0,we=_.length){for(let ve=ge;ve<we;ve++){const Ae=_.charCodeAt(ve);if(Ae!==32&&Ae!==9)return _.substring(ge,ve)}return _.substring(ge,we)}e.$Bd=t;function a(_,ge=_.length-1){for(let we=ge;we>=0;we--){const ve=_.charCodeAt(we);if(ve!==32&&ve!==9)return we}return-1}e.$Cd=a;function r(_,ge,we){const ve=[];let Ae=0;for(const Ue of _.matchAll(ge)){if(ve.push(_.slice(Ae,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Ae=Ue.index+Ue[0].length,ve.push(we(Ue[0],...Ue.slice(1),Ue.index,_,Ue.groups))}return ve.push(_.slice(Ae)),Promise.all(ve).then(Ue=>Ue.join(""))}e.$Dd=r;function i(_,ge){return _<ge?-1:_>ge?1:0}e.$Ed=i;function n(_,ge,we=0,ve=_.length,Ae=0,Ue=ge.length){for(;we<ve&&Ae<Ue;we++,Ae++){const Be=_.charCodeAt(we),He=ge.charCodeAt(Ae);if(Be<He)return-1;if(Be>He)return 1}const Me=ve-we,Te=Ue-Ae;return Me<Te?-1:Me>Te?1:0}e.$Fd=n;function o(_,ge){return b(_,ge,0,_.length,0,ge.length)}e.$Gd=o;function b(_,ge,we=0,ve=_.length,Ae=0,Ue=ge.length){for(;we<ve&&Ae<Ue;we++,Ae++){let Be=_.charCodeAt(we),He=ge.charCodeAt(Ae);if(Be===He)continue;if(Be>=128||He>=128)return n(_.toLowerCase(),ge.toLowerCase(),we,ve,Ae,Ue);A(Be)&&(Be-=32),A(He)&&(He-=32);const qe=Be-He;if(qe!==0)return qe}const Me=ve-we,Te=Ue-Ae;return Me<Te?-1:Me>Te?1:0}e.$Hd=b;function I(_){return _>=48&&_<=57}e.$Id=I;function A(_){return _>=97&&_<=122}e.$Jd=A;function P(_){return _>=65&&_<=90}e.$Kd=P;function C(_,ge){return _.length===ge.length&&b(_,ge)===0}e.$Ld=C;function j(_,ge){const we=ge.length;return ge.length>_.length?!1:b(_,ge,0,we)===0}e.$Md=j;function U(_,ge){const we=Math.min(_.length,ge.length);let ve;for(ve=0;ve<we;ve++)if(_.charCodeAt(ve)!==ge.charCodeAt(ve))return ve;return we}e.$Nd=U;function W(_,ge){const we=Math.min(_.length,ge.length);let ve;const Ae=_.length-1,Ue=ge.length-1;for(ve=0;ve<we;ve++)if(_.charCodeAt(Ae-ve)!==ge.charCodeAt(Ue-ve))return ve;return we}e.$Od=W;function re(_){return 55296<=_&&_<=56319}e.$Pd=re;function ne(_){return 56320<=_&&_<=57343}e.$Qd=ne;function fe(_,ge){return(_-55296<<10)+(ge-56320)+65536}e.$Rd=fe;function ae(_,ge,we){const ve=_.charCodeAt(we);if(re(ve)&&we+1<ge){const Ae=_.charCodeAt(we+1);if(ne(Ae))return fe(ve,Ae)}return ve}e.$Sd=ae;function ue(_,ge){const we=_.charCodeAt(ge-1);if(ne(we)&&ge>1){const ve=_.charCodeAt(ge-2);if(re(ve))return fe(ve,we)}return we}class V{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=ue(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=ae(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$Td=V;class J{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new V(ge,we)}nextGraphemeLength(){const ge=he.getInstance(),we=this.c,ve=we.offset;let Ae=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Ue=we.offset,Me=ge.getGraphemeBreakType(we.nextCodePoint());if(be(Ae,Me)){we.setOffset(Ue);break}Ae=Me}return we.offset-ve}prevGraphemeLength(){const ge=he.getInstance(),we=this.c,ve=we.offset;let Ae=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Ue=we.offset,Me=ge.getGraphemeBreakType(we.prevCodePoint());if(be(Me,Ae)){we.setOffset(Ue);break}Ae=Me}return ve-we.offset}eol(){return this.c.eol()}}e.$Ud=J;function z(_,ge){return new J(_,ge).nextGraphemeLength()}e.$Vd=z;function T(_,ge){return new J(_,ge).prevGraphemeLength()}e.$Wd=T;function F(_,ge){ge>0&&ne(_.charCodeAt(ge))&&ge--;const we=ge+z(_,ge);return[we-T(_,we),we]}e.$Xd=F;function B(_){const ge=new J(_);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}e.$Yd=B;let x;function oe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ce(_){return x||(x=oe()),x.test(_)}e.$Zd=ce;const G=/^[\t\n\r\x20-\x7E]*$/;function R(_){return G.test(_)}e.$1d=R,e.$2d=/[\u2028\u2029]/;function L(_){return e.$2d.test(_)}e.$3d=L;function N(_){return _>=11904&&_<=55215||_>=63744&&_<=64255||_>=65281&&_<=65374}e.$4d=N;function q(_){return _>=127462&&_<=127487||_===8986||_===8987||_===9200||_===9203||_>=9728&&_<=10175||_===11088||_===11093||_>=127744&&_<=128591||_>=128640&&_<=128764||_>=128992&&_<=129008||_>=129280&&_<=129535||_>=129648&&_<=129782}e.$5d=q;function se(_,ge){if(_.length<ge)return _;const we=/\b/g;let ve=0;for(;we.test(_)&&!(_.length-we.lastIndex<ge);)ve=we.lastIndex,we.lastIndex+=1;return _.substring(ve).replace(/^\s/,"")}e.$6d=se;const Y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,le=/\x1b\].*?\x07/g;function K(_){return _&&(_=_.replace(Y,"").replace(le,"")),_}e.$7d=K,e.$8d=String.fromCharCode(65279);function ee(_){return!!(_&&_.length>0&&_.charCodeAt(0)===65279)}e.$9d=ee;function X(_){return ee(_)?_.substr(1):_}e.$0d=X;function de(_,ge){if(!_||!ge||_.length<ge.length)return!1;const we=ge.length,ve=_.toLowerCase();let Ae=0,Ue=-1;for(;Ae<we;){const Me=ve.indexOf(ge[Ae],Ue+1);if(Me<0)return!1;Ue=Me,Ae++}return!0}e.$$d=de;function me(_,ge=!1){return _?(ge&&(_=_.replace(/\\./g,"")),_.toLowerCase()!==_):!1}e.$_d=me;function Re(_){return _.charAt(0).toUpperCase()+_.slice(1)}e.$ae=Re;function De(_,ge=1){if(ge===0)return"";let we=-1;do we=_.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?_:(_[we-1]==="\r"&&we--,_.substr(0,we))}e.$be=De;function je(_){return _=_%(2*26),_<26?String.fromCharCode(97+_):String.fromCharCode(65+_-26)}e.$ce=je;function ye(_){return he.getInstance().getGraphemeBreakType(_)}e.$de=ye;function be(_,ge){return _===0?ge!==5&&ge!==7:_===2&&ge===3?!1:_===4||_===2||_===3||ge===4||ge===2||ge===3?!0:!(_===8&&(ge===8||ge===9||ge===11||ge===12)||(_===11||_===9)&&(ge===9||ge===10)||(_===12||_===10)&&ge===10||ge===5||ge===13||ge===7||_===1||_===13&&ge===14||_===6&&ge===6)}var Z;(function(_){_[_.Other=0]="Other",_[_.Prepend=1]="Prepend",_[_.CR=2]="CR",_[_.LF=3]="LF",_[_.Control=4]="Control",_[_.Extend=5]="Extend",_[_.Regional_Indicator=6]="Regional_Indicator",_[_.SpacingMark=7]="SpacingMark",_[_.L=8]="L",_[_.V=9]="V",_[_.T=10]="T",_[_.LV=11]="LV",_[_.LVT=12]="LVT",_[_.ZWJ=13]="ZWJ",_[_.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class he{static{this.c=null}static getInstance(){return he.c||(he.c=new he),he.c}constructor(){this.d=$e()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const we=this.d,ve=we.length/3;let Ae=1;for(;Ae<=ve;)if(ge<we[3*Ae])Ae=2*Ae;else if(ge>we[3*Ae+1])Ae=2*Ae+1;else return we[3*Ae+2];return 0}}function $e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(_,ge){if(_===0)return 0;const we=Ce(_,ge);if(we!==void 0)return we;const ve=new V(ge,_);return ve.prevCodePoint(),ve.offset}e.$ee=Ee;function Ce(_,ge){const we=new V(ge,_);let ve=we.prevCodePoint();for(;Fe(ve)||ve===65039||ve===8419;){if(we.offset===0)return;ve=we.prevCodePoint()}if(!q(ve))return;let Ae=we.offset;return Ae>0&&we.prevCodePoint()===8205&&(Ae=we.offset),Ae}function Fe(_){return 127995<=_&&_<=127999}var Oe;(function(_){_[_.zwj=8205]="zwj",_[_.emojiVariantSelector=65039]="emojiVariantSelector",_[_.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$fe="\xA0";class ze{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$hd(ge=>{function we(qe){const xe=new Map;for(let Xe=0;Xe<qe.length;Xe+=2)xe.set(qe[Xe],qe[Xe+1]);return xe}function ve(qe,xe){const Xe=new Map(qe);for(const[tt,nt]of xe)Xe.set(tt,nt);return Xe}function Ae(qe,xe){if(!qe)return xe;const Xe=new Map;for(const[tt,nt]of qe)xe.has(tt)&&Xe.set(tt,nt);return Xe}const Ue=this.c.value;let Me=ge.filter(qe=>!qe.startsWith("_")&&qe in Ue);Me.length===0&&(Me=["_default"]);let Te;for(const qe of Me){const xe=we(Ue[qe]);Te=Ae(Te,xe)}const Be=we(Ue._common),He=ve(Be,Te);return new ze(He)})}static getInstance(ge){return ze.d.get(Array.from(ge))}static{this.e=new O.$T(()=>Object.keys(ze.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return ze.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ge=ze;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(ge){return We.e().has(ge)}static get codePoints(){return We.e()}}e.$he=We}),define(te[57],ie([0,1,26]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function O(d){return s(d,0)}e.$di=O;function s(d,l){switch(typeof d){case"object":return d===null?M(349,l):Array.isArray(d)?f(d,l):h(d,l);case"string":return E(d,l);case"boolean":return D(d,l);case"number":return M(d,l);case"undefined":return M(937,l);default:return M(617,l)}}e.$ei=s;function M(d,l){return(l<<5)-l+d|0}e.$fi=M;function D(d,l){return M(d?433:863,l)}function E(d,l){l=M(149417,l);for(let w=0,S=d.length;w<S;w++)l=M(d.charCodeAt(w),l);return l}e.$gi=E;function f(d,l){return l=M(104579,l),d.reduce((w,S)=>s(S,w),l)}function h(d,l){return l=M(181387,l),Object.keys(d).sort().reduce((w,S)=>(w=E(S,w),s(d[S],w)),l)}class ${constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=s(l,this.g),this.g}}e.$hi=$;var g;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function p(d,l,w=32){const S=w-l,m=~((1<<S)-1);return(d<<l|(m&d)>>>S)>>>0}function u(d,l=0,w=d.byteLength,S=0){for(let m=0;m<w;m++)d[l+m]=S}function y(d,l,w="0"){for(;d.length<l;)d=w+d;return d}function v(d,l=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(w=>w.toString(16).padStart(2,"0")).join(""):y((d>>>0).toString(16),l/4)}e.$ii=v;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const w=l.length;if(w===0)return;const S=this.p;let m=this.r,t=this.u,a,r;for(t!==0?(a=t,r=-1,t=0):(a=l.charCodeAt(0),r=0);;){let i=a;if(k.$Pd(a))if(r+1<w){const n=l.charCodeAt(r+1);k.$Qd(n)?(r++,i=k.$Rd(a,n)):i=65533}else{t=a;break}else k.$Qd(a)&&(i=65533);if(m=this.w(S,m,i),r++,r<w)a=l.charCodeAt(r);else break}this.r=m,this.u=t}w(l,w,S){return S<128?l[w++]=S:S<2048?(l[w++]=192|(S&1984)>>>6,l[w++]=128|(S&63)>>>0):S<65536?(l[w++]=224|(S&61440)>>>12,l[w++]=128|(S&4032)>>>6,l[w++]=128|(S&63)>>>0):(l[w++]=240|(S&1835008)>>>18,l[w++]=128|(S&258048)>>>12,l[w++]=128|(S&4032)>>>6,l[w++]=128|(S&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=c.g,w=this.q;for(let b=0;b<64;b+=4)l.setUint32(b,w.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)l.setUint32(b,p(l.getUint32(b-12,!1)^l.getUint32(b-32,!1)^l.getUint32(b-56,!1)^l.getUint32(b-64,!1),1),!1);let S=this.h,m=this.l,t=this.m,a=this.n,r=this.o,i,n,o;for(let b=0;b<80;b++)b<20?(i=m&t|~m&a,n=1518500249):b<40?(i=m^t^a,n=1859775393):b<60?(i=m&t|m&a|t&a,n=2400959708):(i=m^t^a,n=3395469782),o=p(S,5)+i+r+n+l.getUint32(b*4,!1)&4294967295,r=a,a=t,t=p(m,30),m=S,S=o;this.h=this.h+S&4294967295,this.l=this.l+m&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+r&4294967295}}e.$ji=c}),define(te[70],ie([0,1,26]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(O||(O={})),function(s){const M="error",D="warning",E="warn",f="info",h="ignore";function $(p){return p?k.$Ld(M,p)?s.Error:k.$Ld(D,p)||k.$Ld(E,p)?s.Warning:k.$Ld(f,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=$;function g(p){switch(p){case s.Error:return M;case s.Warning:return D;case s.Info:return f;default:return h}}s.toString=g}(O||(O={})),e.default=O}),define(te[141],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(te[58],ie([0,1,24,26]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class s{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const y=u.charCodeAt(0),v=this.b.charCodeAt(this.c);return y-v}value(){return this.b[this.c]}}e.$rh=s;class M{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,O.$Fd)(u,this.b,0,u.length,this.c,this.d):(0,O.$Hd)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=M;class D{constructor(u=!0,y=!0){this.f=u,this.g=y}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let y=u.length-1;y>=0;y--,this.c--){const v=this.b.charCodeAt(y);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,O.$Fd)(u,this.b,0,u.length,this.d,this.e):(0,O.$Hd)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=D;var E;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(E||(E={}));class f{constructor(u,y){this.f=u,this.g=y,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,O.$Gd)(u,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Gd)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,O.$Ed)(u,this.c.query);if(this.d[this.e]===5)return(0,O.$Ed)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=f;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})($||($={}));class g{static forUris(u=()=>!1,y=()=>!1){return new g(new f(u,y))}static forPaths(u=!1){return new g(new D(void 0,!u))}static forStrings(){return new g(new s)}static forConfigKeys(){return new g(new M)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,y){if(y){const v=y.slice(0);(0,k.$Bf)(v);for(const c of v)this.set(c,u)}else{const v=u.slice(0);(0,k.$Bf)(v);for(const c of v)this.set(c[0],c[1])}}set(u,y){const v=this.b.reset(u);let c;this.c||(this.c=new h,this.c.segment=v.value());const d=[];for(c=this.c;;){const w=v.cmp(c.segment);if(w>0)c.left||(c.left=new h,c.left.segment=v.value()),d.push([-1,c]),c=c.left;else if(w<0)c.right||(c.right=new h,c.right.segment=v.value()),d.push([1,c]),c=c.right;else if(v.hasNext())v.next(),c.mid||(c.mid=new h,c.mid.segment=v.value()),d.push([0,c]),c=c.mid;else break}const l=c.value;c.value=y,c.key=u;for(let w=d.length-1;w>=0;w--){const S=d[w][1];S.updateHeight();const m=S.balanceFactor();if(m<-1||m>1){const t=d[w][0],a=d[w+1][0];if(t===1&&a===1)d[w][1]=S.rotateLeft();else if(t===-1&&a===-1)d[w][1]=S.rotateRight();else if(t===1&&a===-1)S.right=d[w+1][1]=d[w+1][1].rotateRight(),d[w][1]=S.rotateLeft();else if(t===-1&&a===1)S.left=d[w+1][1]=d[w+1][1].rotateLeft(),d[w][1]=S.rotateRight();else throw new Error;if(w>0)switch(d[w-1][0]){case-1:d[w-1][1].left=d[w][1];break;case 1:d[w-1][1].right=d[w][1];break;case 0:d[w-1][1].mid=d[w][1];break}else this.c=d[0][1]}}return l}get(u){return this.d(u)?.value}d(u){const y=this.b.reset(u);let v=this.c;for(;v;){const c=y.cmp(v.segment);if(c>0)v=v.left;else if(c<0)v=v.right;else if(y.hasNext())y.next(),v=v.mid;else break}return v}has(u){const y=this.d(u);return!(y?.value===void 0&&y?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,y){const v=this.b.reset(u),c=[];let d=this.c;for(;d;){const l=v.cmp(d.segment);if(l>0)c.push([-1,d]),d=d.left;else if(l<0)c.push([1,d]),d=d.right;else if(v.hasNext())v.next(),c.push([0,d]),d=d.mid;else break}if(d){if(y?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const l=this.f(d.right);if(l.key){const{key:w,value:S,segment:m}=l;this.e(l.key,!1),d.key=w,d.value=S,d.segment=m}}else{const l=d.left??d.right;if(c.length>0){const[w,S]=c[c.length-1];switch(w){case-1:S.left=l;break;case 0:S.mid=l;break;case 1:S.right=l;break}}else this.c=l}for(let l=c.length-1;l>=0;l--){const w=c[l][1];w.updateHeight();const S=w.balanceFactor();if(S>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),c[l][1]=w.rotateLeft()):S<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),c[l][1]=w.rotateRight()),l>0)switch(c[l-1][0]){case-1:c[l-1][1].left=c[l][1];break;case 1:c[l-1][1].right=c[l][1];break;case 0:c[l-1][1].mid=c[l][1];break}else this.c=c[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const y=this.b.reset(u);let v=this.c,c;for(;v;){const d=y.cmp(v.segment);if(d>0)v=v.left;else if(d<0)v=v.right;else if(y.hasNext())y.next(),c=v.value||c,v=v.mid;else break}return v&&v.value||c}findSuperstr(u){return this.g(u,!1)}g(u,y){const v=this.b.reset(u);let c=this.c;for(;c;){const d=v.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if(v.hasNext())v.next(),c=c.mid;else return c.mid?this.h(c.mid):y?c.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[y,v]of this)u(v,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const y=[];return this.j(u,y),y[Symbol.iterator]()}j(u,y){u&&(u.left&&this.j(u.left,y),u.value&&y.push([u.key,u.value]),u.mid&&this.j(u.mid,y),u.right&&this.j(u.right,y))}_isBalanced(){const u=y=>{if(!y)return!0;const v=y.balanceFactor();return v<-1||v>1?!1:u(y.left)&&u(y.right)};return u(this.c)}}e.$vh=g}),define(te[12],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;function k(m){return typeof m=="string"}e.$ie=k;function O(m){return Array.isArray(m)&&m.every(t=>k(t))}e.$je=O;function s(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.$ke=s;function M(m){const t=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof t}e.$le=M;function D(m){return typeof m=="number"&&!isNaN(m)}e.$me=D;function E(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.$ne=E;function f(m){return m===!0||m===!1}e.$oe=f;function h(m){return typeof m>"u"}e.$pe=h;function $(m){return!g(m)}e.$qe=$;function g(m){return h(m)||m===null}e.$re=g;function p(m,t){if(!m)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$se=p;function u(m){if(g(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.$te=u;function y(...m){const t=[];for(let a=0;a<m.length;a++){const r=m[a];if(g(r))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(r)}return t}e.$ue=y;const v=Object.prototype.hasOwnProperty;function c(m){if(!s(m))return!1;for(const t in m)if(v.call(m,t))return!1;return!0}e.$ve=c;function d(m){return typeof m=="function"}e.$we=d;function l(...m){return m.length>0&&m.every(d)}e.$xe=l;function w(m,t){const a=Math.min(m.length,t.length);for(let r=0;r<a;r++)S(m[r],t[r])}e.$ye=w;function S(m,t){if(k(t)){if(typeof m!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(d(t)){try{if(m instanceof t)return}catch{}if(!g(m)&&m.constructor===t||t.length===1&&t.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$ze=S}),define(te[71],ie([0,1,12]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=void 0;const O=Object.create(null);function s(E,f){if((0,k.$ie)(f)){const h=O[f];if(h===void 0)throw new Error(`${E} references an unknown codicon: ${f}`);f=h}return O[E]=f,{id:E}}function M(){return O}e.$Aj=M;function D(){return Object.values(e.$Cj)}e.$Bj=D,e.$Cj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function O(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const l=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([w,S])=>{l[w]=S&&typeof S=="object"?O(S):S}),l}e.$Im=O;function s(d){if(!d||typeof d!="object")return d;const l=[d];for(;l.length>0;){const w=l.shift();Object.freeze(w);for(const S in w)if(M.call(w,S)){const m=w[S];typeof m=="object"&&!Object.isFrozen(m)&&!(0,k.$le)(m)&&l.push(m)}}return d}e.$Jm=s;const M=Object.prototype.hasOwnProperty;function D(d,l){return E(d,l,new Set)}e.$Km=D;function E(d,l,w){if((0,k.$re)(d))return d;const S=l(d);if(typeof S<"u")return S;if(Array.isArray(d)){const m=[];for(const t of d)m.push(E(t,l,w));return m}if((0,k.$ke)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const m={};for(const t in d)M.call(d,t)&&(m[t]=E(d[t],l,w));return w.delete(d),m}return d}function f(d,l,w=!0){return(0,k.$ke)(d)?((0,k.$ke)(l)&&Object.keys(l).forEach(S=>{S in d?w&&((0,k.$ke)(d[S])&&(0,k.$ke)(l[S])?f(d[S],l[S],w):d[S]=l[S]):d[S]=l[S]}),d):l}e.$Lm=f;function h(d,l){if(d===l)return!0;if(d==null||l===null||l===void 0||typeof d!=typeof l||typeof d!="object"||Array.isArray(d)!==Array.isArray(l))return!1;let w,S;if(Array.isArray(d)){if(d.length!==l.length)return!1;for(w=0;w<d.length;w++)if(!h(d[w],l[w]))return!1}else{const m=[];for(S in d)m.push(S);m.sort();const t=[];for(S in l)t.push(S);if(t.sort(),!h(m,t))return!1;for(w=0;w<m.length;w++)if(!h(d[m[w]],l[m[w]]))return!1}return!0}e.$Mm=h;function $(d){const l=new Set;return JSON.stringify(d,(w,S)=>{if((0,k.$ke)(S)||Array.isArray(S)){if(l.has(S))return"[Circular]";l.add(S)}return S})}e.$Nm=$;function g(d,l){const w=Object.create(null);return!d||!l||Object.keys(l).forEach(m=>{const t=d[m],a=l[m];h(t,a)||(w[m]=a)}),w}e.$Om=g;function p(d,l){const w=l.toLowerCase(),S=Object.keys(d).find(m=>m.toLowerCase()===w);return S?d[S]:d[l]}e.$Pm=p;function u(d,l){const w=Object.create(null);for(const[S,m]of Object.entries(d))l(S,m)&&(w[S]=m);return w}e.$Qm=u;function y(d){let l=[];for(;Object.prototype!==d;)l=l.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return l}e.$Rm=y;function v(d){const l=[];for(const w of y(d))typeof d[w]=="function"&&l.push(w);return l}e.$Sm=v;function c(d,l){const w=m=>function(){const t=Array.prototype.slice.call(arguments,0);return l(m,t)},S={};for(const m of d)S[m]=w(m);return S}e.$Tm=c}),define(te[103],ie([0,1,71]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var O;(function(D){function E(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=E})(O||(e.ThemeColor=O={}));function s(D){return{id:D}}e.$Dj=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(l){const w=E.exec(l.id);if(!w)return f(k.$Cj.error);const[,S,m]=w,t=["codicon","codicon-"+S];return m&&t.push("codicon-modifier-"+m.substring(1)),t}D.asClassNameArray=f;function h(l){return f(l).join(" ")}D.asClassName=h;function $(l){return"."+f(l).join(".")}D.asCSSSelector=$;function g(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||O.isThemeColor(l.color))}D.isThemeIcon=g;const p=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function u(l){const w=p.exec(l);if(!w)return;const[,S]=w;return{id:S}}D.fromString=u;function y(l){return{id:l}}D.fromId=y;function v(l,w){let S=l.id;const m=S.lastIndexOf("~");return m!==-1&&(S=S.substring(0,m)),w&&(S=`${S}~${w}`),{id:S}}D.modify=v;function c(l){const w=l.id.lastIndexOf("~");if(w!==-1)return l.id.substring(w+1)}D.getModifier=c;function d(l,w){return l.id===w.id&&l.color?.id===w.color?.id}D.isEqual=d})(M||(e.ThemeIcon=M={}))}),define(te[31],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(s){return k.test(s)}e.$2e=O,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(E){for(let f=0;f<E.length;f++)E[f]=Math.floor(Math.random()*256);return E};const M=new Uint8Array(16),D=[];for(let E=0;E<256;E++)D.push(E.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,h="";return h+=D[M[f++]],h+=D[M[f++]],h+=D[M[f++]],h+=D[M[f++]],h+="-",h+=D[M[f++]],h+=D[M[f++]],h+="-",h+=D[M[f++]],h+=D[M[f++]],h+="-",h+=D[M[f++]],h+=D[M[f++]],h+="-",h+=D[M[f++]],h+=D[M[f++]],h+=D[M[f++]],h+=D[M[f++]],h+=D[M[f++]],h+=D[M[f++]],h}}()}),define(te[142],ie([0,1,72,45,49]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rS=void 0;async function M(D,E){if(await new Promise(($,g)=>{const p=O.createReadStream(D),u=k.createHash("sha1");p.pipe(u);const y=(0,s.$cb)((v,c)=>{p.removeAllListeners(),u.removeAllListeners(),v?g(v):$(c)});p.once("error",y),p.once("end",y),u.once("error",y),u.once("data",v=>y(void 0,v.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.$rS=M}),define(te[143],ie([0,1,27]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const E=D.replace(/\-/g,":").toLowerCase();return!O.has(E)}function M(){const D=(0,k.networkInterfaces)();for(const E in D){const f=D[E];if(f){for(const{mac:h}of f)if(s(h))return h}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$tm=M}),define(te[87],ie([0,1,27,58,31,143]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0,e.$um=new class{c(h){return this.a||(this.a=O.$vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(h)}value(){if(this.b===void 0){let h=0,$=0;const g=(0,k.networkInterfaces)();for(const p in g){const u=g[p];if(u)for(const{mac:y,internal:v}of u)v||($+=1,this.c(y.toUpperCase())&&(h+=1))}this.b=$>0?h/$:0}return this.b}};let D;async function E(h){return D||(D=(async()=>await f(h)||s.$3e())()),D}e.$vm=E;async function f(h){try{const $=await new Promise((p,u)=>{H(["crypto"],p,u)}),g=(0,M.$tm)();return $.createHash("sha256").update(g,"utf8").digest("hex")}catch($){h($);return}}}),define(te[104],ie([0,1,88]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7e=e.$6e=e.$5e=void 0;function O(E,f,h,$=1){let g=!1;return new Promise(p=>{const u=setTimeout(()=>{if(!g)return g=!0,p(0)},h);s(E,f,$,y=>{if(!g)return g=!0,clearTimeout(u),p(y)})})}e.$5e=O;function s(E,f,h,$){if(f===0)return $(0);const g=new k.Socket;g.once("connect",()=>(D(g),s(E+h,f-1,h,$))),g.once("data",()=>{}),g.once("error",p=>(D(g),p.code!=="ECONNREFUSED"?s(E+h,f-1,h,$):$(E))),g.connect(E,"127.0.0.1")}e.$6e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(E,f,h,$="127.0.0.1"){let g=!1,p,u=1;const y=k.createServer({pauseOnConnect:!0});function v(c,d){g||(g=!0,y.removeAllListeners(),y.close(),p&&clearTimeout(p),d(c))}return new Promise(c=>{p=setTimeout(()=>{v(0,c)},h),y.on("listening",()=>{v(E,c)}),y.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&u<f?(E++,u++,y.listen(E,$)):v(0,c)}),y.on("close",()=>{v(0,c)}),y.listen(E,$)})}e.$7e=M;function D(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(f){console.error(f)}}}),function(){function H(){function e(){return process.uncHostAllowlist}function k(f){const h=new Set;if(Array.isArray(f))for(const $ of f)typeof $=="string"&&h.add($);return Array.from(h)}function O(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const h=e();if(h)if(typeof f=="string")h.add(f.toLowerCase());else for(const $ of k(f))s($)}function M(f){if(typeof f!="string")return;const h=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let $;for(const g of h){if(f.indexOf(g)!==0)continue;const u=f.indexOf("\\",g.length);if(u===-1)continue;const y=f.substring(g.length,u);if(y){$=y;break}}return $}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return H()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=H():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vS=e.$uS=void 0,e.$uS="vscode:contextmenu",e.$vS="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CS=void 0;class k{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$CS=k}),define(te[38],ie([0,1,14,13]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wS=void 0;class s{constructor(){this.a=new WeakMap}on(D,E){const f=(h,...$)=>{this.b(D,h)&&E(h,...$)};return this.a.set(E,f),k.ipcMain.on(D,f),this}once(D,E){return k.ipcMain.once(D,(f,...h)=>{this.b(D,f)&&E(f,...h)}),this}handle(D,E){return k.ipcMain.handle(D,(f,...h)=>this.b(D,f)?E(f,...h):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return k.ipcMain.removeHandler(D),this}removeListener(D,E){const f=this.a.get(E);return f&&(k.ipcMain.removeListener(D,f),this.a.delete(E)),this}b(D,E){if(!D||!D.startsWith("vscode:"))return(0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const f=E.senderFrame,h=f.url;if(!h||h==="about:blank")return!0;let $="unknown";try{$=new URL(h).host}catch{return(0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${h}'.`),!1}return $!=="vscode-app"?((0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${$}'.`),!1):f.parent!==null?((0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${$}' is not a main frame.`),!1):!0}}e.$wS=new s}),define(te[146],ie([0,1,14,38,144]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xS=void 0;function M(){O.$wS.on(s.$uS,(E,f,h,$,g)=>{const p=D(E,$,h);p.popup({window:k.BrowserWindow.fromWebContents(E.sender)??void 0,x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{p&&E.sender.send(s.$vS,f)}})})}e.$xS=M;function D(E,f,h){const $=new k.Menu;return h.forEach(g=>{let p;g.type==="separator"?p=new k.MenuItem({type:g.type}):Array.isArray(g.submenu)?p=new k.MenuItem({submenu:D(E,f,g.submenu),label:g.label}):p=new k.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(u,y,v)=>E.sender.send(f,g.id,v)}),$.append(p)}),$}}),define(te[147],ie([11,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(te[148],ie([0,1,147]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0;const O=60,s=O*60,M=s*24,D=M*7,E=M*30,f=M*365;function h(g,p,u,y){typeof g!="number"&&(g=g.getTime());const v=Math.round((new Date().getTime()-g)/1e3);if(v<-30)return(0,k.localize)(0,null,h(new Date().getTime()+v*1e3,!1));if(!y&&v<30)return(0,k.localize)(1,null);let c;return v<O?(c=v,p?c===1?u?(0,k.localize)(2,null,c):(0,k.localize)(3,null,c):u?(0,k.localize)(4,null,c):(0,k.localize)(5,null,c):c===1?u?(0,k.localize)(6,null,c):(0,k.localize)(7,null,c):u?(0,k.localize)(8,null,c):(0,k.localize)(9,null,c)):v<s?(c=Math.floor(v/O),p?c===1?u?(0,k.localize)(10,null,c):(0,k.localize)(11,null,c):u?(0,k.localize)(12,null,c):(0,k.localize)(13,null,c):c===1?u?(0,k.localize)(14,null,c):(0,k.localize)(15,null,c):u?(0,k.localize)(16,null,c):(0,k.localize)(17,null,c)):v<M?(c=Math.floor(v/s),p?c===1?u?(0,k.localize)(18,null,c):(0,k.localize)(19,null,c):u?(0,k.localize)(20,null,c):(0,k.localize)(21,null,c):c===1?u?(0,k.localize)(22,null,c):(0,k.localize)(23,null,c):u?(0,k.localize)(24,null,c):(0,k.localize)(25,null,c)):v<D?(c=Math.floor(v/M),p?c===1?(0,k.localize)(26,null,c):(0,k.localize)(27,null,c):c===1?(0,k.localize)(28,null,c):(0,k.localize)(29,null,c)):v<E?(c=Math.floor(v/D),p?c===1?u?(0,k.localize)(30,null,c):(0,k.localize)(31,null,c):u?(0,k.localize)(32,null,c):(0,k.localize)(33,null,c):c===1?u?(0,k.localize)(34,null,c):(0,k.localize)(35,null,c):u?(0,k.localize)(36,null,c):(0,k.localize)(37,null,c)):v<f?(c=Math.floor(v/E),p?c===1?u?(0,k.localize)(38,null,c):(0,k.localize)(39,null,c):u?(0,k.localize)(40,null,c):(0,k.localize)(41,null,c):c===1?u?(0,k.localize)(42,null,c):(0,k.localize)(43,null,c):u?(0,k.localize)(44,null,c):(0,k.localize)(45,null,c)):(c=Math.floor(v/f),p?c===1?u?(0,k.localize)(46,null,c):(0,k.localize)(47,null,c):u?(0,k.localize)(48,null,c):(0,k.localize)(49,null,c):c===1?u?(0,k.localize)(50,null,c):(0,k.localize)(51,null,c):u?(0,k.localize)(52,null,c):(0,k.localize)(53,null,c))}e.$Sl=h;function $(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Tl=$}),define(te[149],ie([11,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,24,12,149]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function M(g,p){return p&&(g.stack||g.stacktrace)?s.localize(0,null,E(g),D(g.stack)||D(g.stacktrace)):E(g)}function D(g){return Array.isArray(g)?g.join(`
`):g}function E(g){return g.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${g.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?s.localize(1,null,g.message):g.message||s.localize(2,null)}function f(g=null,p=!1){if(!g)return s.localize(3,null);if(Array.isArray(g)){const u=k.$jf(g),y=f(u[0],p);return u.length>1?s.localize(4,null,y,u.length):y}if(O.$ie(g))return g;if(g.detail){const u=g.detail;if(u.error)return M(u.error,p);if(u.exception)return M(u.exception,p)}return g.stack?M(g,p):g.message?g.message:s.localize(5,null)}e.$ai=f;function h(g){const p=g;return p instanceof Error&&Array.isArray(p.actions)}e.$bi=h;function $(g,p){let u;return typeof g=="string"?u=new Error(g):u=g,u.actions=p,u}e.$ci=$}),define(te[150],ie([11,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(te[151],ie([0,1,150]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;function O(s){switch(s){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.$dp=O}),define(te[152],ie([11,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,152]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let O=!1,s=!1,M=!1,D=!1,E=!1,f=!1,h=!1,$=!1,g=!1,p=!1,u,y=e.$f,v=e.$f,c,d;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?l=e.$g.vscode.process:typeof process<"u"&&(l=process);const w=typeof l?.versions?.electron=="string",S=w&&l?.type==="renderer";if(typeof navigator=="object"&&!S)d=navigator.userAgent,O=d.indexOf("Windows")>=0,s=d.indexOf("Macintosh")>=0,$=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=d.indexOf("Linux")>=0,p=d?.indexOf("Mobi")>=0,f=!0,u=k.getConfiguredDefaultLocale(k.localize(0,null))||e.$f,y=u,v=navigator.language;else if(typeof l=="object"){O=l.platform==="win32",s=l.platform==="darwin",M=l.platform==="linux",D=M&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,h=w,g=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$f,y=e.$f;const I=l.env.VSCODE_NLS_CONFIG;if(I)try{const A=JSON.parse(I),P=A.availableLanguages["*"];u=A.locale,v=A.osLocale,y=P||e.$f,c=A._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var m;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(m||(e.Platform=m={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let a=0;s?a=1:O?a=3:M&&(a=2),e.$i=O,e.$j=s,e.$k=M,e.$l=D,e.$m=E,e.$n=h,e.$o=f,e.$p=f&&typeof e.$g.importScripts=="function",e.$q=$,e.$r=p,e.$s=g,e.$t=a,e.$u=d,e.$v=y;var r;(function(I){function A(){return e.$v}I.value=A;function P(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}I.isDefaultVariant=P;function C(){return e.$v==="en"}I.isDefault=C})(r||(e.Language=r={})),e.$w=u,e.$x=v,e.$y=c,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const I=[];e.$g.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let C=0,j=I.length;C<j;C++){const U=I[C];if(U.id===P.data.vscodeScheduleAsyncWork){I.splice(C,1),U.callback();return}}});let A=0;return P=>{const C=++A;I.push({id:C,callback:P}),e.$g.postMessage({vscodeScheduleAsyncWork:C},"*")}}return I=>setTimeout(I)})();var i;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||$?2:O?1:3;let n=!0,o=!1;function b(){if(!o){o=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,n=new Uint16Array(I.buffer)[0]===(2<<8)+1}return n}e.$C=b,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[36],ie([0,1,4]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.env=e.cwd=void 0;let O;if(typeof k.$g.vscode<"u"&&typeof k.$g.vscode.process<"u"){const s=k.$g.vscode.process;O={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$2c=O.platform,e.$3c=O.arch}),define(te[9],ie([0,1,36]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=e.sep=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=void 0;const O=65,s=97,M=90,D=122,E=46,f=47,h=92,$=58,g=63;class p extends Error{constructor(a,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=a.indexOf(".")!==-1?"property":"argument";let b=`The "${a}" ${o} ${n} of type ${r}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,a){if(t===null||typeof t!="object")throw new p(a,"Object",t)}function y(t,a){if(typeof t!="string")throw new p(a,"string",t)}const v=k.$2c==="win32";function c(t){return t===f||t===h}function d(t){return t===f}function l(t){return t>=O&&t<=M||t>=s&&t<=D}function w(t,a,r,i){let n="",o=0,b=-1,I=0,A=0;for(let P=0;P<=t.length;++P){if(P<t.length)A=t.charCodeAt(P);else{if(i(A))break;A=f}if(i(A)){if(!(b===P-1||I===1))if(I===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==E||n.charCodeAt(n.length-2)!==E){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",o=0):(n=n.slice(0,C),o=n.length-1-n.lastIndexOf(r)),b=P,I=0;continue}else if(n.length!==0){n="",o=0,b=P,I=0;continue}}a&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(b+1,P)}`:n=t.slice(b+1,P),o=P-b-1;b=P,I=0}else A===E&&I!==-1?++I:I=-1}return n}function S(t,a){u(a,"pathObject");const r=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return r?r===a.root?`${r}${i}`:`${r}${t}${i}`:i}e.$4c={resolve(...t){let a="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else a.length===0?o=k.cwd():(o=k.env[`=${a}`]||k.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===h)&&(o=`${a}\\`));const b=o.length;let I=0,A="",P=!1;const C=o.charCodeAt(0);if(b===1)c(C)&&(I=1,P=!0);else if(c(C))if(P=!0,c(o.charCodeAt(1))){let j=2,U=j;for(;j<b&&!c(o.charCodeAt(j));)j++;if(j<b&&j!==U){const W=o.slice(U,j);for(U=j;j<b&&c(o.charCodeAt(j));)j++;if(j<b&&j!==U){for(U=j;j<b&&!c(o.charCodeAt(j));)j++;(j===b||j!==U)&&(A=`\\\\${W}\\${o.slice(U,j)}`,I=j)}}}else I=1;else l(C)&&o.charCodeAt(1)===$&&(A=o.slice(0,2),I=2,b>2&&c(o.charCodeAt(2))&&(P=!0,I=3));if(A.length>0)if(a.length>0){if(A.toLowerCase()!==a.toLowerCase())continue}else a=A;if(i){if(a.length>0)break}else if(r=`${o.slice(I)}\\${r}`,i=P,P&&a.length>0)break}return r=w(r,!i,"\\",c),i?`${a}\\${r}`:`${a}${r}`||"."},normalize(t){y(t,"path");const a=t.length;if(a===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(a===1)return d(o)?"\\":t;if(c(o))if(n=!0,c(t.charCodeAt(1))){let I=2,A=I;for(;I<a&&!c(t.charCodeAt(I));)I++;if(I<a&&I!==A){const P=t.slice(A,I);for(A=I;I<a&&c(t.charCodeAt(I));)I++;if(I<a&&I!==A){for(A=I;I<a&&!c(t.charCodeAt(I));)I++;if(I===a)return`\\\\${P}\\${t.slice(A)}\\`;I!==A&&(i=`\\\\${P}\\${t.slice(A,I)}`,r=I)}}}else r=1;else l(o)&&t.charCodeAt(1)===$&&(i=t.slice(0,2),r=2,a>2&&c(t.charCodeAt(2))&&(n=!0,r=3));let b=r<a?w(t.slice(r),!n,"\\",c):"";return b.length===0&&!n&&(b="."),b.length>0&&c(t.charCodeAt(a-1))&&(b+="\\"),i===void 0?n?`\\${b}`:b:n?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){y(t,"path");const a=t.length;if(a===0)return!1;const r=t.charCodeAt(0);return c(r)||a>2&&l(r)&&t.charCodeAt(1)===$&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,r;for(let o=0;o<t.length;++o){const b=t[o];y(b,"path"),b.length>0&&(a===void 0?a=r=b:a+=`\\${b}`)}if(a===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&c(r.charCodeAt(0))){++n;const o=r.length;o>1&&c(r.charCodeAt(1))&&(++n,o>2&&(c(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<a.length&&c(a.charCodeAt(n));)n++;n>=2&&(a=`\\${a.slice(n)}`)}return e.$4c.normalize(a)},relative(t,a){if(y(t,"from"),y(a,"to"),t===a)return"";const r=e.$4c.resolve(t),i=e.$4c.resolve(a);if(r===i||(t=r.toLowerCase(),a=i.toLowerCase(),t===a))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===h;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===h;)o--;const b=o-n;let I=0;for(;I<a.length&&a.charCodeAt(I)===h;)I++;let A=a.length;for(;A-1>I&&a.charCodeAt(A-1)===h;)A--;const P=A-I,C=b<P?b:P;let j=-1,U=0;for(;U<C;U++){const re=t.charCodeAt(n+U);if(re!==a.charCodeAt(I+U))break;re===h&&(j=U)}if(U!==C){if(j===-1)return i}else{if(P>C){if(a.charCodeAt(I+U)===h)return i.slice(I+U+1);if(U===2)return i.slice(I+U)}b>C&&(t.charCodeAt(n+U)===h?j=U:U===2&&(j=3)),j===-1&&(j=0)}let W="";for(U=n+j+1;U<=o;++U)(U===o||t.charCodeAt(U)===h)&&(W+=W.length===0?"..":"\\..");return I+=j,W.length>0?`${W}${i.slice(I,A)}`:(i.charCodeAt(I)===h&&++I,i.slice(I,A))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.$4c.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===h){if(a.charCodeAt(1)===h){const r=a.charCodeAt(2);if(r!==g&&r!==E)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(l(a.charCodeAt(0))&&a.charCodeAt(1)===$&&a.charCodeAt(2)===h)return`\\\\?\\${a}`;return t},dirname(t){y(t,"path");const a=t.length;if(a===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(a===1)return c(n)?t:".";if(c(n)){if(r=i=1,c(t.charCodeAt(1))){let I=2,A=I;for(;I<a&&!c(t.charCodeAt(I));)I++;if(I<a&&I!==A){for(A=I;I<a&&c(t.charCodeAt(I));)I++;if(I<a&&I!==A){for(A=I;I<a&&!c(t.charCodeAt(I));)I++;if(I===a)return t;I!==A&&(r=i=I+1)}}}}else l(n)&&t.charCodeAt(1)===$&&(r=a>2&&c(t.charCodeAt(2))?3:2,i=r);let o=-1,b=!0;for(let I=a-1;I>=i;--I)if(c(t.charCodeAt(I))){if(!b){o=I;break}}else b=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,a){a!==void 0&&y(a,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===$&&(r=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let b=a.length-1,I=-1;for(o=t.length-1;o>=r;--o){const A=t.charCodeAt(o);if(c(A)){if(!n){r=o+1;break}}else I===-1&&(n=!1,I=o+1),b>=0&&(A===a.charCodeAt(b)?--b===-1&&(i=o):(b=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if(c(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let a=0,r=-1,i=0,n=-1,o=!0,b=0;t.length>=2&&t.charCodeAt(1)===$&&l(t.charCodeAt(0))&&(a=i=2);for(let I=t.length-1;I>=a;--I){const A=t.charCodeAt(I);if(c(A)){if(!o){i=I+1;break}continue}n===-1&&(o=!1,n=I+1),A===E?r===-1?r=I:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||n===-1||b===0||b===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:S.bind(null,"\\"),parse(t){y(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return c(n)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(c(n)){if(i=1,c(t.charCodeAt(1))){let j=2,U=j;for(;j<r&&!c(t.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&c(t.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&!c(t.charCodeAt(j));)j++;j===r?i=j:j!==U&&(i=j+1)}}}}else if(l(n)&&t.charCodeAt(1)===$){if(r<=2)return a.root=a.dir=t,a;if(i=2,c(t.charCodeAt(2))){if(r===3)return a.root=a.dir=t,a;i=3}}i>0&&(a.root=t.slice(0,i));let o=-1,b=i,I=-1,A=!0,P=t.length-1,C=0;for(;P>=i;--P){if(n=t.charCodeAt(P),c(n)){if(!A){b=P+1;break}continue}I===-1&&(A=!1,I=P+1),n===E?o===-1?o=P:C!==1&&(C=1):o!==-1&&(C=-1)}return I!==-1&&(o===-1||C===0||C===1&&o===I-1&&o===b+1?a.base=a.name=t.slice(b,I):(a.name=t.slice(b,o),a.base=t.slice(b,I),a.ext=t.slice(o,I))),b>0&&b!==i?a.dir=t.slice(0,b-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(v){const t=/\\/g;return()=>{const a=k.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>k.cwd()})();e.$5c={resolve(...t){let a="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:m();y(n,"path"),n.length!==0&&(a=`${n}/${a}`,r=n.charCodeAt(0)===f)}return a=w(a,!r,"/",d),r?`/${a}`:a.length>0?a:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=w(t,!a,"/",d),t.length===0?a?"/":r?"./":".":(r&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let a;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.$5c.normalize(a)},relative(t,a){if(y(t,"from"),y(a,"to"),t===a||(t=e.$5c.resolve(t),a=e.$5c.resolve(a),t===a))return"";const r=1,i=t.length,n=i-r,o=1,b=a.length-o,I=n<b?n:b;let A=-1,P=0;for(;P<I;P++){const j=t.charCodeAt(r+P);if(j!==a.charCodeAt(o+P))break;j===f&&(A=P)}if(P===I)if(b>I){if(a.charCodeAt(o+P)===f)return a.slice(o+P+1);if(P===0)return a.slice(o+P)}else n>I&&(t.charCodeAt(r+P)===f?A=P:P===0&&(A=0));let C="";for(P=r+A+1;P<=i;++P)(P===i||t.charCodeAt(P)===f)&&(C+=C.length===0?"..":"/..");return`${C}${a.slice(o+A)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?a?"/":".":a&&r===1?"//":t.slice(0,r)},basename(t,a){a!==void 0&&y(a,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let b=a.length-1,I=-1;for(o=t.length-1;o>=0;--o){const A=t.charCodeAt(o);if(A===f){if(!n){r=o+1;break}}else I===-1&&(n=!1,I=o+1),b>=0&&(A===a.charCodeAt(b)?--b===-1&&(i=o):(b=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===f){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let a=-1,r=0,i=-1,n=!0,o=0;for(let b=t.length-1;b>=0;--b){const I=t.charCodeAt(b);if(I===f){if(!n){r=b+1;break}continue}i===-1&&(n=!1,i=b+1),I===E?a===-1?a=b:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||i===-1||o===0||o===1&&a===i-1&&a===r+1?"":t.slice(a,i)},format:S.bind(null,"/"),parse(t){y(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const r=t.charCodeAt(0)===f;let i;r?(a.root="/",i=1):i=0;let n=-1,o=0,b=-1,I=!0,A=t.length-1,P=0;for(;A>=i;--A){const C=t.charCodeAt(A);if(C===f){if(!I){o=A+1;break}continue}b===-1&&(I=!1,b=A+1),C===E?n===-1?n=A:P!==1&&(P=1):n!==-1&&(P=-1)}if(b!==-1){const C=o===0&&r?1:o;n===-1||P===0||P===1&&n===b-1&&n===o+1?a.base=a.name=t.slice(C,b):(a.name=t.slice(C,n),a.base=t.slice(C,b),a.ext=t.slice(n,b))}return o>0?a.dir=t.slice(0,o-1):r&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$5c.win32=e.$4c.win32=e.$4c,e.$5c.posix=e.$4c.posix=e.$5c,e.$6c=v?e.$4c.normalize:e.$5c.normalize,e.$7c=v?e.$4c.isAbsolute:e.$5c.isAbsolute,e.$8c=v?e.$4c.join:e.$5c.join,e.$9c=v?e.$4c.resolve:e.$5c.resolve,e.$0c=v?e.$4c.relative:e.$5c.relative,e.$$c=v?e.$4c.dirname:e.$5c.dirname,e.$_c=v?e.$4c.basename:e.$5c.basename,e.$ad=v?e.$4c.extname:e.$5c.extname,e.$bd=v?e.$4c.format:e.$5c.format,e.$cd=v?e.$4c.parse:e.$5c.parse,e.$dd=v?e.$4c.toNamespacedPath:e.$5c.toNamespacedPath,e.sep=v?e.$4c.sep:e.$5c.sep,e.$fd=v?e.$4c.delimiter:e.$5c.delimiter}),define(te[32],ie([0,1,9,4,26,12]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function D(o){return o===47||o===92}e.$Ae=D;function E(o){return o.replace(/[\\/]/g,k.$5c.sep)}e.$Be=E;function f(o){return o.indexOf("/")===-1&&(o=E(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Ce=f;function h(o,b=k.$5c.sep){if(!o)return"";const I=o.length,A=o.charCodeAt(0);if(D(A)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let C=3;const j=C;for(;C<I&&!D(o.charCodeAt(C));C++);if(j!==C&&!D(o.charCodeAt(C+1))){for(C+=1;C<I;C++)if(D(o.charCodeAt(C)))return o.slice(0,C+1).replace(/[\\/]/g,b)}}return b}else if(d(A)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+b:o.slice(0,2);let P=o.indexOf("://");if(P!==-1){for(P+=3;P<I;P++)if(D(o.charCodeAt(P)))return o.slice(0,P+1)}return""}e.$De=h;function $(o){if(!O.$i||!o||o.length<5)return!1;let b=o.charCodeAt(0);if(b!==92||(b=o.charCodeAt(1),b!==92))return!1;let I=2;const A=I;for(;I<o.length&&(b=o.charCodeAt(I),b!==92);I++);return!(A===I||(b=o.charCodeAt(I+1),isNaN(b)||b===92))}e.$Ee=$;const g=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,b=O.$i){const I=b?g:p;return!(!o||o.length===0||/^\s+$/.test(o)||(I.lastIndex=0,I.test(o))||b&&u.test(o)||o==="."||o===".."||b&&o[o.length-1]==="."||b&&o.length!==o.trim().length||o.length>255)}e.$Fe=y;function v(o,b,I){const A=o===b;return!I||A?A:!o||!b?!1:(0,s.$Ld)(o,b)}e.$Ge=v;function c(o,b,I,A=k.sep){if(o===b)return!0;if(!o||!b||b.length>o.length)return!1;if(I){if(!(0,s.$Md)(o,b))return!1;if(b.length===o.length)return!0;let C=b.length;return b.charAt(b.length-1)===A&&C--,o.charAt(C)===A}return b.charAt(b.length-1)!==A&&(b+=A),o.indexOf(b)===0}e.$He=c;function d(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Ie=d;function l(o,b){return O.$i&&o.endsWith(":")&&(o+=k.sep),(0,k.$7c)(o)||(o=(0,k.$8c)(b,o)),o=(0,k.$6c)(o),O.$i?(o=(0,s.$ud)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,s.$ud)(o,k.sep),o||(o=k.sep)),o}e.$Je=l;function w(o){const b=(0,k.$6c)(o);return O.$i?o.length>3?!1:S(b)&&(o.length===2||b.charCodeAt(2)===92):b===k.$5c.sep}e.$Ke=w;function S(o,b=O.$i){return b?d(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Le=S;function m(o,b=O.$i){return S(o,b)?o[0]:void 0}e.$Me=m;function t(o,b,I){return b.length>o.length?-1:o===b?0:(I&&(o=o.toLowerCase(),b=b.toLowerCase()),o.indexOf(b))}e.$Ne=t;function a(o){const b=o.split(":");let I,A,P;for(const C of b){const j=Number(C);(0,M.$me)(j)?A===void 0?A=j:P===void 0&&(P=j):I=I?[I,C].join(":"):C}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:A!==void 0?A:void 0,column:P!==void 0?P:A!==void 0?1:void 0}}e.$Oe=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,b,I=8){let A="";for(let C=0;C<I;C++){let j;C===0&&O.$i&&!b&&(I===3||I===4)?j=i:j=r,A+=j.charAt(Math.floor(Math.random()*j.length))}let P;return b?P=`${b}-${A}`:P=A,o?(0,k.$8c)(o,P):P}e.$Pe=n}),define(te[73],ie([0,1,4]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var O;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(O||(e.Source=O={}));var s;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(E,...f){const h=f.reduce((p,u)=>(p[u]=!0,p),{}),$=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(p=>!h[p]).forEach(p=>{for(let u=0;u<$.length;u++)if(p.search($[u])!==-1){delete E[p];break}})}e.$fl=M;function D(E){E&&(delete E.DEBUG,k.$j&&delete E.DYLD_LIBRARY_PATH,k.$k&&delete E.LD_PRELOAD)}e.$gl=D}),define(te[7],ie([0,1,9,4]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function E(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function h(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==g&&(n=g+n):n=g;break}return n}const $="",g="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(n){return n instanceof u?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,b,I,A,P=!1){typeof n=="object"?(this.scheme=n.scheme||$,this.authority=n.authority||$,this.path=n.path||$,this.query=n.query||$,this.fragment=n.fragment||$):(this.scheme=f(n,P),this.authority=o||$,this.path=h(this.scheme,b||$),this.query=I||$,this.fragment=A||$,E(this,P))}get fsPath(){return S(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:b,path:I,query:A,fragment:P}=n;return o===void 0?o=this.scheme:o===null&&(o=$),b===void 0?b=this.authority:b===null&&(b=$),I===void 0?I=this.path:I===null&&(I=$),A===void 0?A=this.query:A===null&&(A=$),P===void 0?P=this.fragment:P===null&&(P=$),o===this.scheme&&b===this.authority&&I===this.path&&A===this.query&&P===this.fragment?this:new c(o,b,I,A,P)}static parse(n,o=!1){const b=p.exec(n);return b?new c(b[2]||$,r(b[4]||$),r(b[5]||$),r(b[7]||$),r(b[9]||$),o):new c($,$,$,$,$)}static file(n){let o=$;if(O.$i&&(n=n.replace(/\\/g,g)),n[0]===g&&n[1]===g){const b=n.indexOf(g,2);b===-1?(o=n.substring(2),n=g):(o=n.substring(2,b),n=n.substring(b)||g)}return new c("file",o,n,$,$)}static from(n,o){return new c(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return O.$i&&n.scheme==="file"?b=u.file(k.$4c.join(S(n,!0),...o)).path:b=k.$5c.join(n.path,...o),n.with({path:b})}toString(n=!1){return m(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof u)return n;{const o=new c(n);return o._formatted=n.external??null,o._fsPath=n._sep===v?n.fsPath??null:null,o}}else return n}}e.URI=u;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Re=y;const v=O.$i?1:void 0;class c extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(n=!1){return n?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=v),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(i,n,o){let b,I=-1;for(let A=0;A<i.length;A++){const P=i.charCodeAt(A);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47||o&&P===91||o&&P===93||o&&P===58)I!==-1&&(b+=encodeURIComponent(i.substring(I,A)),I=-1),b!==void 0&&(b+=i.charAt(A));else{b===void 0&&(b=i.substr(0,A));const C=d[P];C!==void 0?(I!==-1&&(b+=encodeURIComponent(i.substring(I,A)),I=-1),b+=C):I===-1&&(I=A)}}return I!==-1&&(b+=encodeURIComponent(i.substring(I))),b!==void 0?b:i}function w(i){let n;for(let o=0;o<i.length;o++){const b=i.charCodeAt(o);b===35||b===63?(n===void 0&&(n=i.substr(0,o)),n+=d[b]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function S(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,O.$i&&(o=o.replace(/\//g,"\\")),o}e.$Se=S;function m(i,n){const o=n?w:l;let b="",{scheme:I,authority:A,path:P,query:C,fragment:j}=i;if(I&&(b+=I,b+=":"),(A||I==="file")&&(b+=g,b+=g),A){let U=A.indexOf("@");if(U!==-1){const W=A.substr(0,U);A=A.substr(U+1),U=W.lastIndexOf(":"),U===-1?b+=o(W,!1,!1):(b+=o(W.substr(0,U),!1,!1),b+=":",b+=o(W.substr(U+1),!1,!0)),b+="@"}A=A.toLowerCase(),U=A.lastIndexOf(":"),U===-1?b+=o(A,!1,!0):(b+=o(A.substr(0,U),!1,!0),b+=A.substr(U))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const U=P.charCodeAt(1);U>=65&&U<=90&&(P=`/${String.fromCharCode(U+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const U=P.charCodeAt(0);U>=65&&U<=90&&(P=`${String.fromCharCode(U+32)}:${P.substr(2)}`)}b+=o(P,!0,!1)}return C&&(b+="?",b+=o(C,!1,!1)),j&&(b+="#",b+=n?j:l(j,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(a)?i.replace(a,n=>t(n)):i}}),define(te[153],ie([0,1,7]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Gp=e.$Fp=e.$Ep=void 0;function O(h){const $=h;return $&&typeof $.type=="string"&&typeof $.severity=="string"}e.$Ep=O;function s(h){const $=[];let g;try{const p=JSON.parse(h.arguments),u=p[p.length-1];u&&u.__$stack&&(p.pop(),g=u.__$stack),$.push(...p)}catch{$.push("Unable to log remote console arguments",h.arguments)}return{args:$,stack:g}}e.$Fp=s;function M(h){if(typeof h!="string")return M(s(h).stack);const $=h;if($){const g=D($),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(p&&p.length===4)return{uri:k.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Gp=M;function D(h){if(!h)return h;const $=h.indexOf(`
`);return $===-1?h:h.substring(0,$)}function E(h,$){const{args:g,stack:p}=s(h),u=typeof g[0]=="string"&&g.length===1;let y=D(p);y&&(y=`(${y.trim()})`);let v=[];if(typeof g[0]=="string"?y&&u?v=[`%c[${$}] %c${g[0]} %c${y}`,f("blue"),f(""),f("grey")]:v=[`%c[${$}] %c${g[0]}`,f("blue"),f(""),...g.slice(1)]:v=[`%c[${$}]%`,f("blue"),...g],y&&!u&&v.push(y),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,v)}e.log=E;function f(h){return`color: ${h}`}}),define(te[74],ie([0,1,17,7]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function s(f){return JSON.stringify(f,D)}e.$Wg=s;function M(f){let h=JSON.parse(f);return h=E(h),h}e.$Xg=M;function D(f,h){return h instanceof RegExp?{$mid:2,source:h.source,flags:h.flags}:h}function E(f,h=0){if(!f||h>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return O.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 16:return new Date(f.source)}if(f instanceof k.$Ec||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let $=0;$<f.length;++$)f[$]=E(f[$],h+1);else for(const $ in f)Object.hasOwnProperty.call(f,$)&&(f[$]=E(f[$],h+1))}return f}e.$Yg=E}),define(te[15],ie([0,1,13,4,7]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var M;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$Te="vscode-tkn",e.$Ue="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${M.vscodeRemoteResource}`}set($,g,p){this.a[$]=g,this.b[$]=p}setConnectionToken($,g){this.c[$]=g}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(c){return k.$Y(c),$}const g=$.authority;let p=this.a[g];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const u=this.b[g],y=this.c[g];let v=`path=${encodeURIComponent($.path)}`;return typeof y=="string"&&(v+=`&${e.$Ue}=${encodeURIComponent(y)}`),s.URI.from({scheme:O.$o?this.d:M.vscodeRemoteResource,authority:`${p}:${u}`,path:this.f,query:v})}}e.$Ve=new D,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class E{static{this.a="vscode-app"}asBrowserUri($){const g=this.b($,H);return this.uriToBrowserUri(g)}uriToBrowserUri($){return $.scheme===M.vscodeRemote?e.$Ve.rewrite($):$.scheme===M.file&&(O.$m||O.$p&&O.$g.origin===`${M.vscodeFileResource}://${E.a}`)?$.with({scheme:M.vscodeFileResource,authority:$.authority||E.a,query:null,fragment:null}):$}asFileUri($){const g=this.b($,H);return this.uriToFileUri(g)}uriToFileUri($){return $.scheme===M.vscodeFileResource?$.with({scheme:M.file,authority:$.authority!==E.a?$.authority:null,query:null,fragment:null}):$}b($,g){return s.URI.isUri($)?$:s.URI.parse(g.toUrl($))}}e.$1e=new E;var f;(function(h){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze($.get("3"));const g="vscode-coi";function p(y){let v;typeof y=="string"?v=new URL(y).searchParams:y instanceof URL?v=y.searchParams:s.URI.isUri(y)&&(v=new URL(y.toString(!0)).searchParams);const c=v?.get(g);if(c)return $.get(c)}h.getHeadersFromQuery=p;function u(y,v,c){if(!globalThis.crossOriginIsolated)return;const d=v&&c?"3":c?"2":"1";y instanceof URLSearchParams?y.set(g,d):y[g]=d}h.addSearchParam=u})(f||(e.COI=f={}))}),define(te[19],ie([0,1,32,15,9,4,26,7]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function f(u){return(0,E.$Se)(u,!0)}e.$Wf=f;class h{constructor(y){this.a=y}compare(y,v,c=!1){return y===v?0:(0,D.$Ed)(this.getComparisonKey(y,c),this.getComparisonKey(v,c))}isEqual(y,v,c=!1){return y===v?!0:!y||!v?!1:this.getComparisonKey(y,c)===this.getComparisonKey(v,c)}getComparisonKey(y,v=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,v,c=!1){if(y.scheme===v.scheme){if(y.scheme===O.Schemas.file)return k.$He(f(y),f(v),this.a(y))&&y.query===v.query&&(c||y.fragment===v.fragment);if((0,e.$bg)(y.authority,v.authority))return k.$He(y.path,v.path,this.a(y),"/")&&y.query===v.query&&(c||y.fragment===v.fragment)}return!1}joinPath(y,...v){return E.URI.joinPath(y,...v)}basenameOrAuthority(y){return(0,e.$6f)(y)||y.authority}basename(y){return s.$5c.basename(y.path)}extname(y){return s.$5c.extname(y.path)}dirname(y){if(y.path.length===0)return y;let v;return y.scheme===O.Schemas.file?v=E.URI.file(s.$$c(f(y))).path:(v=s.$5c.dirname(y.path),y.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),v="/")),y.with({path:v})}normalizePath(y){if(!y.path.length)return y;let v;return y.scheme===O.Schemas.file?v=E.URI.file(s.$6c(f(y))).path:v=s.$5c.normalize(y.path),y.with({path:v})}relativePath(y,v){if(y.scheme!==v.scheme||!(0,e.$bg)(y.authority,v.authority))return;if(y.scheme===O.Schemas.file){const l=s.$0c(f(y),f(v));return M.$i?k.$Be(l):l}let c=y.path||"/";const d=v.path||"/";if(this.a(y)){let l=0;for(const w=Math.min(c.length,d.length);l<w&&!(c.charCodeAt(l)!==d.charCodeAt(l)&&c.charAt(l).toLowerCase()!==d.charAt(l).toLowerCase());l++);c=d.substr(0,l)+c.substr(l)}return s.$5c.relative(c,d)}resolvePath(y,v){if(y.scheme===O.Schemas.file){const c=E.URI.file(s.$9c(f(y),v));return y.with({authority:c.authority,path:c.path})}return v=k.$Ce(v),y.with({path:s.$5c.resolve(y.path,v)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,v){return y===v||y!==void 0&&v!==void 0&&(0,D.$Ld)(y,v)}hasTrailingPathSeparator(y,v=s.sep){if(y.scheme===O.Schemas.file){const c=f(y);return c.length>k.$De(c).length&&c[c.length-1]===v}else{const c=y.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,v=s.sep){return(0,e.$cg)(y,v)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,v=s.sep){let c=!1;if(y.scheme===O.Schemas.file){const d=f(y);c=d!==void 0&&d.length===k.$De(d).length&&d[d.length-1]===v}else{v="/";const d=y.path;c=d.length===1&&d.charCodeAt(d.length-1)===47}return!c&&!(0,e.$cg)(y,v)?y.with({path:y.path+"/"}):y}}e.$Xf=h,e.$Yf=new h(()=>!1),e.$Zf=new h(u=>u.scheme===O.Schemas.file?!M.$k:!0),e.$1f=new h(u=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function $(u,y){const v=[];for(let c=0;c<u.length;c++){const d=y(u[c]);u.some((l,w)=>w===c?!1:(0,e.$3f)(d,y(l)))||v.push(u[c])}return v}e.$fg=$;var g;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function y(v){const c=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(w=>{const[S,m]=w.split(":");S&&m&&c.set(S,m)});const l=v.path.substring(0,v.path.indexOf(";"));return l&&c.set(u.META_DATA_MIME,l),c}u.parseMetaData=y})(g||(e.DataUri=g={}));function p(u,y,v){if(y){let c=u.path;return c&&c[0]!==s.$5c.sep&&(c=s.$5c.sep+c),u.with({scheme:v,authority:y,path:c})}return u.with({scheme:v})}e.$gg=p}),define(te[8],ie([0,1,23,13,3,2,19,4,141]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function h(R){return!!R&&typeof R.then=="function"}e.$hg=h;function $(R){const L=new k.$oc,N=R(L.token),q=new Promise((se,Y)=>{const le=L.token.onCancellationRequested(()=>{le.dispose(),L.dispose(),Y(new O.$3)});Promise.resolve(N).then(K=>{le.dispose(),L.dispose(),se(K)},K=>{le.dispose(),L.dispose(),Y(K)})});return new class{cancel(){L.cancel()}then(se,Y){return q.then(se,Y)}catch(se){return this.then(void 0,se)}finally(se){return q.finally(se)}}}e.$ig=$;function g(R,L,N){return new Promise((q,se)=>{const Y=L.onCancellationRequested(()=>{Y.dispose(),q(N)});R.then(q,se).finally(()=>Y.dispose())})}e.$jg=g;function p(R,L){return new Promise((N,q)=>{const se=L.onCancellationRequested(()=>{se.dispose(),q(new O.$3)});R.then(N,q).finally(()=>se.dispose())})}e.$kg=p;async function u(R){let L=-1;const N=R.map((q,se)=>q.then(Y=>(L=se,Y)));try{return await Promise.race(N)}finally{R.forEach((q,se)=>{se!==L&&q.cancel()})}}e.$lg=u;function y(R,L,N){let q;const se=setTimeout(()=>{q?.(void 0),N?.()},L);return Promise.race([R.finally(()=>clearTimeout(se)),new Promise(Y=>q=Y)])}e.$mg=y;function v(R){return new Promise((L,N)=>{const q=R();h(q)?q.then(L,N):L(q)})}e.$ng=v;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=L,!this.b){const N=()=>{if(this.b=null,this.f)return;const q=this.queue(this.d);return this.d=null,q};this.b=new Promise(q=>{this.a.then(N,N).then(q)})}return new Promise((N,q)=>{this.b.then(N,q)})}return this.a=L(),new Promise((N,q)=>{this.a.then(se=>{this.a=null,N(se)},se=>{this.a=null,q(se)})})}dispose(){this.f=!0}}e.$og=c;class d{constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$pg=d;class l{constructor(){this.a=new Map}queue(L,N){const se=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(L)===se&&this.a.delete(L)});return this.a.set(L,se),se}}e.$qg=l;const w=(R,L)=>{let N=!0;const q=setTimeout(()=>{N=!1,L()},R);return{isTriggered:()=>N,dispose:()=>{clearTimeout(q),N=!1}}},S=R=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,R())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class m{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,N=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((se,Y)=>{this.d=se,this.f=Y}).then(()=>{if(this.b=null,this.d=null,this.g){const se=this.g;return this.g=null,se()}}));const q=()=>{this.a=null,this.d?.(null)};return this.a=N===f.$bc?S(q):w(N,q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=m;class t{constructor(L){this.a=new m(L),this.b=new c}trigger(L,N){return this.a.trigger(()=>this.b.queue(L),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=t;class a{constructor(){this.a=!1,this.b=new Promise((L,N)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=a;class r extends a{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$ug=r;function i(R,L){return L?new Promise((N,q)=>{const se=setTimeout(()=>{Y.dispose(),N()},R),Y=L.onCancellationRequested(()=>{clearTimeout(se),Y.dispose(),q(new O.$3)})}):$(N=>i(R,N))}e.$vg=i;function n(R,L=0){const N=setTimeout(R,L);return(0,M.$jb)(()=>clearTimeout(N))}e.$wg=n;function o(R){const L=[];let N=0;const q=R.length;function se(){return N<q?R[N++]():null}function Y(le){le!=null&&L.push(le);const K=se();return K?K.then(Y):Promise.resolve(L)}return Promise.resolve(null).then(Y)}e.$xg=o;function b(R,L=q=>!!q,N=null){let q=0;const se=R.length,Y=()=>{if(q>=se)return Promise.resolve(N);const le=R[q++];return Promise.resolve(le()).then(ee=>L(ee)?Promise.resolve(ee):Y())};return Y()}e.$yg=b;function I(R,L=q=>!!q,N=null){if(R.length===0)return Promise.resolve(N);let q=R.length;const se=()=>{q=-1;for(const Y of R)Y.cancel?.()};return new Promise((Y,le)=>{for(const K of R)K.then(ee=>{--q>=0&&L(ee)?(se(),Y(ee)):q===0&&Y(N)}).catch(ee=>{--q>=0&&(se(),le(ee))})})}e.$zg=I;class A{constructor(L){this.a=0,this.d=L,this.f=[],this.b=0,this.g=new s.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(L){return this.a++,new Promise((N,q)=>{this.f.push({factory:L,c:N,e:q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const L=this.f.shift();this.b++;const N=L.factory();N.then(L.c,L.e),N.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=A;class P extends A{constructor(){super(1)}}e.$Bg=P;class C{constructor(){this.a=new J,this.b=0}queue(L){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,L())):this.a.run(this.b++,L())}}e.$Cg=C;class j{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const L=new F;return this.b.add(L),L.p}d(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueFor(L,N=D.$Yf){const q=N.getComparisonKey(L);let se=this.a.get(q);return se||(se=new P,s.Event.once(se.onDrained)(()=>{se?.dispose(),this.a.delete(q),this.f()}),this.a.set(q,se)),se}f(){this.d()&&this.g()}g(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.g()}}e.$Dg=j;class U{constructor(L,N){this.a=-1,typeof L=="function"&&typeof N=="number"&&this.setIfNotSet(L,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},N)}setIfNotSet(L,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},N))}}e.$Eg=U;class W{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(L,N){this.cancel(),this.a=setInterval(()=>{L()},N)}}e.$Fg=W;class re{constructor(L,N){this.b=-1,this.a=L,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=re;class ne{constructor(L,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=L,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=ne;class fe extends re{constructor(L,N){super(L,N),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$Ig=fe;class ae extends M.$lb{constructor(L,N){super(),this.g=L,this.h=N,this.a=[],this.b=this.B(new M.$mb),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const N of L)this.a.push(N);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=R=>{(0,E.$A)(()=>{if(L)return;const N=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.$Kg=(R,L)=>{const N=requestIdleCallback(R,typeof L=="number"?{timeout:L}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(N))}}}}();class ue{constructor(L){this.d=!1,this.a=()=>{try{this.f=L()}catch(N){this.g=N}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=ue;async function V(R,L,N){let q;for(let se=0;se<N;se++)try{return await R()}catch(Y){q=Y,await i(L)}throw q}e.$Mg=V;class J{isRunning(L){return typeof L=="number"?this.a?.taskId===L:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(L,N,q){return this.a={taskId:L,cancel:()=>q?.(),promise:N},N.then(()=>this.d(L),()=>this.d(L)),N}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this.b)this.b.run=L;else{let N,q;const se=new Promise((Y,le)=>{N=Y,q=le});this.b={run:L,promise:se,promiseResolve:N,promiseReject:q}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=J;class z{constructor(L,N=()=>Date.now()){this.d=L,this.f=N,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$Og=z;var T;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(T||(T={}));class F{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,N)=>{this.a=L,this.b=N})}complete(L){return new Promise(N=>{this.a(L),this.d={outcome:0,value:L},N()})}error(L){return new Promise(N=>{this.b(L),this.d={outcome:1,value:L},N()})}cancel(){return this.error(new O.$3)}}e.$Pg=F;var B;(function(R){async function L(q){let se;const Y=await Promise.all(q.map(le=>le.then(K=>K,K=>{se||(se=K)})));if(typeof se<"u")throw se;return Y}R.settled=L;function N(q){return new Promise(async(se,Y)=>{try{await q(se,Y)}catch(le){Y(le)}})}R.withAsyncBody=N})(B||(e.Promises=B={}));var x;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(x||(x={}));class oe{static fromArray(L){return new oe(N=>{N.emitMany(L)})}static fromPromise(L){return new oe(async N=>{N.emitMany(await L)})}static fromPromises(L){return new oe(async N=>{await Promise.all(L.map(async q=>N.emitOne(await q)))})}static merge(L){return new oe(async N=>{await Promise.all(L.map(async q=>{for await(const se of q)N.emitOne(se)}))})}static{this.EMPTY=oe.fromArray([])}constructor(L){this.a=0,this.b=[],this.d=null,this.f=new s.$ec,queueMicrotask(async()=>{const N={emitOne:q=>this.g(q),emitMany:q=>this.h(q),reject:q=>this.k(q)};try{await Promise.resolve(L(N)),this.j()}catch(q){this.k(q)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(L,N){return new oe(async q=>{for await(const se of L)q.emitOne(N(se))})}map(L){return oe.map(this,L)}static filter(L,N){return new oe(async q=>{for await(const se of L)N(se)&&q.emitOne(se)})}filter(L){return oe.filter(this,L)}static coalesce(L){return oe.filter(L,N=>!!N)}coalesce(){return oe.coalesce(this)}static async toPromise(L){const N=[];for await(const q of L)N.push(q);return N}toPromise(){return oe.toPromise(this)}g(L){this.a===0&&(this.b.push(L),this.f.fire())}h(L){this.a===0&&(this.b=this.b.concat(L),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(L){this.a===0&&(this.a=2,this.d=L,this.f.fire())}}e.$Qg=oe;class ce extends oe{constructor(L,N){super(N),this.l=L}cancel(){this.l.cancel()}}e.$Rg=ce;function G(R){const L=new k.$oc,N=R(L.token);return new ce(L,async q=>{const se=L.token.onCancellationRequested(()=>{se.dispose(),L.dispose(),q.reject(new O.$3)});try{for await(const Y of N){if(L.token.isCancellationRequested)return;q.emitOne(Y)}se.dispose(),L.dispose()}catch(Y){se.dispose(),L.dispose(),q.reject(Y)}})}e.$Sg=G}),define(te[105],ie([0,1,24,8,32,35,9,4,26]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function h(){return Object.create(null)}e.$_i=h,e.$aj="**",e.$bj="/";const $="[/\\\\]",g="[^/\\\\]",p=/\//g;function u(J,z){switch(J){case 0:return"";case 1:return`${g}*?`;default:return`(?:${$}|${g}+${$}${z?`|${$}${g}+`:""})*?`}}function y(J,z){if(!J)return[];const T=[];let F=!1,B=!1,x="";for(const oe of J){switch(oe){case z:if(!F&&!B){T.push(x),x="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":B=!0;break;case"]":B=!1;break}x+=oe}return x&&T.push(x),T}e.$cj=y;function v(J){if(!J)return"";let z="";const T=y(J,e.$bj);if(T.every(F=>F===e.$aj))z=".*";else{let F=!1;T.forEach((B,x)=>{if(B===e.$aj){if(F)return;z+=u(2,x===T.length-1)}else{let oe=!1,ce="",G=!1,R="";for(const L of B){if(L!=="}"&&oe){ce+=L;continue}if(G&&(L!=="]"||!R)){let N;L==="-"?N=L:(L==="^"||L==="!")&&!R?N="^":L===e.$bj?N="":N=(0,f.$pd)(L),R+=N;continue}switch(L){case"{":oe=!0;continue;case"[":G=!0;continue;case"}":{const q=`(?:${y(ce,",").map(se=>v(se)).join("|")})`;z+=q,oe=!1,ce="";break}case"]":{z+="["+R+"]",G=!1,R="";break}case"?":z+=g;continue;case"*":z+=u(1);continue;default:z+=(0,f.$pd)(L)}}x<T.length-1&&(T[x+1]!==e.$aj||x+2<T.length)&&(z+=$)}F=B===e.$aj})}return z}const c=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$qi(1e4),a=function(){return!1},r=function(){return null};function i(J,z){if(!J)return r;let T;typeof J!="string"?T=J.pattern:T=J,T=T.trim();const F=`${T}_${!!z.trimForExclusions}`;let B=t.get(F);if(B)return n(B,J);let x;return c.test(T)?B=b(T.substr(4),T):(x=d.exec(o(T,z)))?B=I(x[1],T):(z.trimForExclusions?w:l).test(T)?B=A(T,z):(x=S.exec(o(T,z)))?B=P(x[1].substr(1),T,!0):(x=m.exec(o(T,z)))?B=P(x[1],T,!1):B=C(T),t.set(F,B),n(B,J)}function n(J,z){if(typeof z=="string")return J;const T=function(F,B){return(0,s.$He)(F,z.base,!E.$k)?J((0,f.$td)(F.substr(z.base.length),D.sep),B):null};return T.allBasenames=J.allBasenames,T.allPaths=J.allPaths,T.basenames=J.basenames,T.patterns=J.patterns,T}function o(J,z){return z.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function b(J,z){return function(T,F){return typeof T=="string"&&T.endsWith(J)?z:null}}function I(J,z){const T=`/${J}`,F=`\\${J}`,B=function(oe,ce){return typeof oe!="string"?null:ce?ce===J?z:null:oe===J||oe.endsWith(T)||oe.endsWith(F)?z:null},x=[J];return B.basenames=x,B.patterns=[z],B.allBasenames=x,B}function A(J,z){const T=ue(J.slice(1,-1).split(",").map(ce=>i(ce,z)).filter(ce=>ce!==r),J),F=T.length;if(!F)return r;if(F===1)return T[0];const B=function(ce,G){for(let R=0,L=T.length;R<L;R++)if(T[R](ce,G))return J;return null},x=T.find(ce=>!!ce.allBasenames);x&&(B.allBasenames=x.allBasenames);const oe=T.reduce((ce,G)=>G.allPaths?ce.concat(G.allPaths):ce,[]);return oe.length&&(B.allPaths=oe),B}function P(J,z,T){const F=D.sep===D.$5c.sep,B=F?J:J.replace(p,D.sep),x=D.sep+B,oe=D.$5c.sep+J;let ce;return T?ce=function(G,R){return typeof G=="string"&&(G===B||G.endsWith(x)||!F&&(G===J||G.endsWith(oe)))?z:null}:ce=function(G,R){return typeof G=="string"&&(G===B||!F&&G===J)?z:null},ce.allPaths=[(T?"*/":"./")+J],ce}function C(J){try{const z=new RegExp(`^${v(J)}$`);return function(T){return z.lastIndex=0,typeof T=="string"&&z.test(T)?J:null}}catch{return r}}function j(J,z,T){return!J||typeof z!="string"?!1:U(J)(z,void 0,T)}e.$dj=j;function U(J,z={}){if(!J)return a;if(typeof J=="string"||W(J)){const T=i(J,z);if(T===r)return a;const F=function(B,x){return!!T(B,x)};return T.allBasenames&&(F.allBasenames=T.allBasenames),T.allPaths&&(F.allPaths=T.allPaths),F}return fe(J,z)}e.$ej=U;function W(J){const z=J;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.$fj=W;function re(J){return J.allBasenames||[]}e.$gj=re;function ne(J){return J.allPaths||[]}e.$hj=ne;function fe(J,z){const T=ue(Object.getOwnPropertyNames(J).map(ce=>ae(ce,J[ce],z)).filter(ce=>ce!==r)),F=T.length;if(!F)return r;if(!T.some(ce=>!!ce.requiresSiblings)){if(F===1)return T[0];const ce=function(L,N){let q;for(let se=0,Y=T.length;se<Y;se++){const le=T[se](L,N);if(typeof le=="string")return le;(0,O.$hg)(le)&&(q||(q=[]),q.push(le))}return q?(async()=>{for(const se of q){const Y=await se;if(typeof Y=="string")return Y}return null})():null},G=T.find(L=>!!L.allBasenames);G&&(ce.allBasenames=G.allBasenames);const R=T.reduce((L,N)=>N.allPaths?L.concat(N.allPaths):L,[]);return R.length&&(ce.allPaths=R),ce}const B=function(ce,G,R){let L,N;for(let q=0,se=T.length;q<se;q++){const Y=T[q];Y.requiresSiblings&&R&&(G||(G=(0,D.$_c)(ce)),L||(L=G.substr(0,G.length-(0,D.$ad)(ce).length)));const le=Y(ce,G,L,R);if(typeof le=="string")return le;(0,O.$hg)(le)&&(N||(N=[]),N.push(le))}return N?(async()=>{for(const q of N){const se=await q;if(typeof se=="string")return se}return null})():null},x=T.find(ce=>!!ce.allBasenames);x&&(B.allBasenames=x.allBasenames);const oe=T.reduce((ce,G)=>G.allPaths?ce.concat(G.allPaths):ce,[]);return oe.length&&(B.allPaths=oe),B}function ae(J,z,T){if(z===!1)return r;const F=i(J,T);if(F===r)return r;if(typeof z=="boolean")return F;if(z){const B=z.when;if(typeof B=="string"){const x=(oe,ce,G,R)=>{if(!R||!F(oe,ce))return null;const L=B.replace("$(basename)",()=>G),N=R(L);return(0,O.$hg)(N)?N.then(q=>q?J:null):N?J:null};return x.requiresSiblings=!0,x}}return F}function ue(J,z){const T=J.filter(ce=>!!ce.basenames);if(T.length<2)return J;const F=T.reduce((ce,G)=>{const R=G.basenames;return R?ce.concat(R):ce},[]);let B;if(z){B=[];for(let ce=0,G=F.length;ce<G;ce++)B.push(z)}else B=T.reduce((ce,G)=>{const R=G.patterns;return R?ce.concat(R):ce},[]);const x=function(ce,G){if(typeof ce!="string")return null;if(!G){let L;for(L=ce.length;L>0;L--){const N=ce.charCodeAt(L-1);if(N===47||N===92)break}G=ce.substr(L)}const R=F.indexOf(G);return R!==-1?B[R]:null};x.basenames=F,x.patterns=B,x.allBasenames=F;const oe=J.filter(ce=>!ce.basenames);return oe.push(x),oe}function V(J,z){return(0,k.$$e)(J,z,(T,F)=>typeof T=="string"&&typeof F=="string"?T===F:typeof T!="string"&&typeof F!="string"?T.base===F.base&&T.pattern===F.pattern:!1)}e.$ij=V}),define(te[46],ie([0,1,24,32,9,4,19,26]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cA=e.$bA=e.$aA=e.$_z=e.$$z=e.$0z=e.$9z=e.$8z=e.$7z=e.$6z=void 0;function f(i,n){const{os:o,tildify:b,relative:I}=n;if(I){const C=h(i,I,o);if(typeof C=="string")return C}let A=i.fsPath;if(o===1&&!M.$i?A=A.replace(/\//g,"\\"):o!==1&&M.$i&&(A=A.replace(/\\/g,"/")),o!==1&&b?.userHome){const C=b.userHome.fsPath;let j;i.scheme!==b.userHome.scheme&&i.path.startsWith(s.$5c.sep)?j=b.userHome.with({path:i.path}).fsPath:j=i.fsPath,A=p(j,C,o)}return(o===1?s.$4c:s.$5c).normalize($(A,o===1))}e.$6z=f;function h(i,n,o){const b=o===1?s.$4c:s.$5c,I=o===3?D.$Yf:D.$1f,A=n.getWorkspace(),P=(0,k.$sf)(A.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path.startsWith(s.$5c.sep)&&(i=P.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let j;if(I.isEqual(C.uri,i)?j="":j=I.relativePath(C.uri,i)??"",j&&(j=b.normalize(j)),A.folders.length>1&&!n.noPrefix){const U=C.name?C.name:I.basenameOrAuthority(C.uri);j=j?`${U} \u2022 ${j}`:U}return j}function $(i,n=M.$i){return(0,O.$Le)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$7z=$;let g=Object.create(null);function p(i,n,o=M.OS){if(o===1||!i||!n)return i;let b=g.original===n?g.normalized:void 0;b||(b=n,M.$i&&(b=(0,O.$Be)(b)),b=`${(0,E.$ud)(b,s.$5c.sep)}${s.$5c.sep}`,g={original:n,normalized:b});let I=i;return M.$i&&(I=(0,O.$Be)(I)),(o===3?I.startsWith(b):(0,E.$Md)(I,b))?`~/${I.substr(b.length)}`:i}e.$8z=p;function u(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$9z=u;const y="\u2026",v="\\\\",c="~";function d(i,n=s.sep){const o=new Array(i.length);let b=!1;for(let I=0;I<i.length;I++){const A=i[I];if(A===""){o[I]=`.${n}`;continue}if(!A){o[I]=A;continue}b=!0;let P="",C=A;C.indexOf(v)===0?(P=C.substr(0,C.indexOf(v)+v.length),C=C.substr(C.indexOf(v)+v.length)):C.indexOf(n)===0?(P=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf(c)===0&&(P=C.substr(0,C.indexOf(c)+c.length),C=C.substr(C.indexOf(c)+c.length));const j=C.split(n);for(let U=1;b&&U<=j.length;U++)for(let W=j.length-U;b&&W>=0;W--){b=!1;let re=j.slice(W,W+U).join(n);for(let ne=0;!b&&ne<i.length;ne++)if(ne!==I&&i[ne]&&i[ne].indexOf(re)>-1){const fe=W+U===j.length,ae=W>0&&i[ne].indexOf(n)>-1?n+re:re,ue=i[ne].endsWith(ae);b=!fe||ue}if(!b){let ne="";(j[0].endsWith(":")||P!=="")&&(W===1&&(W=0,U++,re=j[0]+n+re),W>0&&(ne=j[0]+n),ne=P+ne),W>0&&(ne=ne+y+n),ne=ne+re,W+U<j.length&&(ne=ne+n+y),o[I]=ne}}b&&(o[I]=A)}return o}e.$0z=d;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function w(i,n=Object.create(null)){const o=[];let b=!1,I="";for(const A of i)if(A==="$"||b&&A==="{")I&&o.push({value:I,type:l.TEXT}),I="",b=!0;else if(A==="}"&&b){const P=n[I];if(typeof P=="string")P.length&&o.push({value:P,type:l.VARIABLE});else if(P){const C=o[o.length-1];(!C||C.type!==l.SEPARATOR)&&o.push({value:P.label,type:l.SEPARATOR})}I="",b=!1}else I+=A;return I&&!b&&o.push({value:I,type:l.TEXT}),o.filter((A,P)=>{if(A.type===l.SEPARATOR){const C=o[P-1],j=o[P+1];return[C,j].every(U=>U&&(U.type===l.VARIABLE||U.type===l.TEXT)&&U.value.length>0)}return!0}).map(A=>A.value).join("")}e.$$z=w;function S(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$_z=S;function m(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$aA=m;function t(i){return i.replace(/&/g,"&&")}e.$bA=t;function a(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=r(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return r(i)}e.$cA=a;function r(i){const n=i.indexOf("/")!==-1?s.$5c:s.$4c,o=n.basename(i),b=n.dirname(i);return o.length?{name:o,parentPath:b}:{name:b,parentPath:""}}}),define(te[154],ie([0,1,17,7]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=void 0;function s(g){return g.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const u=this.a.transformIncoming(p);return u===p?p:s(O.URI.from(u))}transformOutgoing(p){const u=this.a.transformOutgoing(p);return u===p?p:s(O.URI.from(u))}transformOutgoingURI(p){const u=this.a.transformOutgoing(p);return u===p?p:O.URI.from(u)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$om=M,e.$pm=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function D(g,p,u){if(!g||u>200)return null;if(typeof g=="object"){if(g instanceof O.URI)return p.transformOutgoing(g);for(const y in g)if(Object.hasOwnProperty.call(g,y)){const v=D(g[y],p,u+1);v!==null&&(g[y]=v)}}return null}function E(g,p){const u=D(g,p,0);return u===null?g:u}e.$qm=E;function f(g,p,u,y){if(!g||y>200)return null;if(typeof g=="object"){if(g.$mid===1)return u?O.URI.revive(p.transformIncoming(g)):p.transformIncoming(g);if(g instanceof k.$Ec)return null;for(const v in g)if(Object.hasOwnProperty.call(g,v)){const c=f(g[v],p,u,y+1);c!==null&&(g[v]=c)}}return null}function h(g,p){const u=f(g,p,!1,0);return u===null?g:u}e.$rm=h;function $(g,p){const u=f(g,p,!0,0);return u===null?g:u}e.$sm=$}),define(te[21],ie([0,1,45,27,155,8,32,86,9,4,19,7]),function(H,e,k,O,s,M,D,E,f,h,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(ae){ae[ae.UNLINK=0]="UNLINK",ae[ae.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function u(ae,ue=p.UNLINK,V){if((0,D.$Ke)(ae))throw new Error("rimraf - will refuse to recursively delete root");return ue===p.UNLINK?v(ae):y(ae,V)}async function y(ae,ue=(0,D.$Pe)((0,O.tmpdir)())){try{try{await k.promises.rename(ae,ue)}catch(V){return V.code==="ENOENT"?void 0:v(ae)}v(ue).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function v(ae){return(0,s.promisify)(k.rm)(ae,{recursive:!0,force:!0,maxRetries:3})}function c(ae){if((0,D.$Ke)(ae))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(ae,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function d(ae,ue){return S(await(ue?l(ae):(0,s.promisify)(k.readdir)(ae)))}async function l(ae){try{return await(0,s.promisify)(k.readdir)(ae,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const ue=[],V=await d(ae);for(const J of V){let z=!1,T=!1,F=!1;try{const B=await e.Promises.lstat((0,f.$8c)(ae,J));z=B.isFile(),T=B.isDirectory(),F=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}ue.push({name:J,isFile:()=>z,isDirectory:()=>T,isSymbolicLink:()=>F})}return ue}function w(ae){return S(k.readdirSync(ae))}e.readdirSync=w;function S(ae){return ae.map(ue=>typeof ue=="string"?h.$j?(0,E.$7k)(ue):ue:(ue.name=h.$j?(0,E.$7k)(ue.name):ue.name,ue))}async function m(ae){const ue=await d(ae),V=[];for(const J of ue)await a.existsDirectory((0,f.$8c)(ae,J))&&V.push(J);return V}function t(ae,ue=1e3){return new Promise(V=>{let J=!1;const z=setInterval(()=>{J||(J=!0,k.access(ae,T=>{J=!1,T&&(clearInterval(z),V(void 0))}))},ue)})}e.whenDeleted=t;var a;(function(ae){async function ue(z){let T;try{if(T=await e.Promises.lstat(z),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(h.$i&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw B}throw F}}ae.stat=ue;async function V(z){try{const{stat:T,symbolicLink:F}=await ae.stat(z);return T.isFile()&&F?.dangling!==!0}catch{}return!1}ae.existsFile=V;async function J(z){try{const{stat:T,symbolicLink:F}=await ae.stat(z);return T.isDirectory()&&F?.dangling!==!0}catch{}return!1}ae.existsDirectory=J})(a||(e.SymlinkSupport=a={}));const r=new M.$Dg;function i(ae,ue,V){return r.queueFor(g.URI.file(ae),$.$Zf).queue(()=>{const J=A(V);return new Promise((z,T)=>b(ae,ue,J,F=>F?T(F):z()))})}let n=!0;function o(ae){n=ae}e.configureFlushOnWrite=o;function b(ae,ue,V,J){if(!n)return k.writeFile(ae,ue,{mode:V.mode,flag:V.flag},J);k.open(ae,V.flag,V.mode,(z,T)=>{if(z)return J(z);k.writeFile(T,ue,F=>{if(F)return k.close(T,()=>J(F));k.fdatasync(T,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),o(!1)),k.close(T,x=>J(x))))})})}function I(ae,ue,V){const J=A(V);if(!n)return k.writeFileSync(ae,ue,{mode:J.mode,flag:J.flag});const z=k.openSync(ae,J.flag,J.mode);try{k.writeFileSync(z,ue);try{k.fdatasyncSync(z)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),o(!1)}}finally{k.closeSync(z)}}e.writeFileSync=I;function A(ae){return ae?{mode:typeof ae.mode=="number"?ae.mode:438,flag:typeof ae.flag=="string"?ae.flag:"w"}:{mode:438,flag:"w"}}async function P(ae,ue,V=6e4){if(ae!==ue)try{h.$i&&typeof V=="number"?await C(ae,ue,Date.now(),V):await(0,s.promisify)(k.rename)(ae,ue)}catch(J){if(ae.toLowerCase()!==ue.toLowerCase()&&J.code==="EXDEV"||ae.endsWith("."))await j(ae,ue,{preserveSymlinks:!1}),await u(ae,p.MOVE);else throw J}}async function C(ae,ue,V,J,z=0){try{return await(0,s.promisify)(k.rename)(ae,ue)}catch(T){if(T.code!=="EACCES"&&T.code!=="EPERM"&&T.code!=="EBUSY")throw T;if(Date.now()-V>=J)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${T}`),T;if(z===0){let F=!1;try{const{stat:B}=await a.stat(ue);B.isFile()||(F=!0)}catch{}if(F)throw T}return await(0,M.$vg)(Math.min(100,z*10)),C(ae,ue,V,J,z+1)}}async function j(ae,ue,V){return W(ae,ue,{root:{source:ae,target:ue},options:V,handledSourcePaths:new Set})}const U=511;async function W(ae,ue,V){if(V.handledSourcePaths.has(ae))return;V.handledSourcePaths.add(ae);const{stat:J,symbolicLink:z}=await a.stat(ae);if(z){if(V.options.preserveSymlinks)try{return await fe(ae,ue,V)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(z.dangling)return}return J.isDirectory()?re(ae,ue,J.mode&U,V):ne(ae,ue,J.mode&U)}async function re(ae,ue,V,J){await e.Promises.mkdir(ue,{recursive:!0,mode:V});const z=await d(ae);for(const T of z)await W((0,f.$8c)(ae,T),(0,f.$8c)(ue,T),J)}async function ne(ae,ue,V){await e.Promises.copyFile(ae,ue),await e.Promises.chmod(ue,V)}async function fe(ae,ue,V){let J=await e.Promises.readlink(ae);(0,D.$He)(J,V.root.source,!h.$k)&&(J=(0,f.$8c)(V.root.target,J.substr(V.root.source.length+1))),await e.Promises.symlink(J,ue)}e.Promises=new class{get access(){return(0,s.promisify)(k.access)}get stat(){return(0,s.promisify)(k.stat)}get lstat(){return(0,s.promisify)(k.lstat)}get utimes(){return(0,s.promisify)(k.utimes)}get read(){return(ae,ue,V,J,z)=>new Promise((T,F)=>{k.read(ae,ue,V,J,z,(B,x,oe)=>B?F(B):T({bytesRead:x,buffer:oe}))})}get readFile(){return(0,s.promisify)(k.readFile)}get write(){return(ae,ue,V,J,z)=>new Promise((T,F)=>{k.write(ae,ue,V,J,z,(B,x,oe)=>B?F(B):T({bytesWritten:x,buffer:oe}))})}get appendFile(){return(0,s.promisify)(k.appendFile)}get fdatasync(){return(0,s.promisify)(k.fdatasync)}get truncate(){return(0,s.promisify)(k.truncate)}get copyFile(){return(0,s.promisify)(k.copyFile)}get open(){return(0,s.promisify)(k.open)}get close(){return(0,s.promisify)(k.close)}get symlink(){return(0,s.promisify)(k.symlink)}get readlink(){return(0,s.promisify)(k.readlink)}get chmod(){return(0,s.promisify)(k.chmod)}get mkdir(){return(0,s.promisify)(k.mkdir)}get unlink(){return(0,s.promisify)(k.unlink)}get rmdir(){return(0,s.promisify)(k.rmdir)}get realpath(){return(0,s.promisify)(k.realpath)}async exists(ae){try{return await e.Promises.access(ae),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return m}get writeFile(){return i}get rm(){return u}get rename(){return P}get copy(){return j}}}),define(te[106],ie([0,1,45,9,4,26,21]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=void 0;function E(p){if(s.$k)return p;const u=(0,O.$$c)(p);if(p===u)return p;const y=((0,O.$_c)(p)||p).toLowerCase();try{const c=(0,D.readdirSync)(u).filter(d=>d.toLowerCase()===y);if(c.length===1){const d=E(u);if(d)return(0,O.$8c)(d,c[0])}else if(c.length>1){const d=c.indexOf(y);if(d>=0){const l=E(u);if(l)return(0,O.$8c)(l,c[d])}}}catch{}return null}e.$Lp=E;async function f(p){if(s.$k)return p;const u=(0,O.$$c)(p);if(p===u)return p;const y=((0,O.$_c)(p)||p).toLowerCase();try{const c=(await D.Promises.readdir(u)).filter(d=>d.toLowerCase()===y);if(c.length===1){const d=await f(u);if(d)return(0,O.$8c)(d,c[0])}else if(c.length>1){const d=c.indexOf(y);if(d>=0){const l=await f(u);if(l)return(0,O.$8c)(l,c[d])}}}catch{}return null}e.$Mp=f;async function h(p){try{return await D.Promises.realpath(p)}catch{const y=g(p);return await D.Promises.access(y,k.constants.R_OK),y}}e.$Np=h;function $(p){try{return k.realpathSync(p)}catch{const y=g(p);return k.accessSync(y,k.constants.R_OK),y}}e.$Op=$;function g(p){return(0,M.$ud)((0,O.$6c)(p),O.sep)}}),define(te[107],ie([0,1,27,9,21]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var f;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(f||(f={}));let h;switch(process.arch){case"ia32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let $;process.env.PROCESSOR_ARCHITEW6432?$=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?$=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?$=1:$=0;class g{constructor(m,t,a){this.exePath=m,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:S=!1}={}){return S?h===0?process.env["ProgramFiles(x86)"]||null:$===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:S=!1,findPreview:m=!1}={}){const t=p({useAlternateBitness:S});if(!t)return null;const a=O.$8c(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(a))return null;let r=-1,i=null;for(const b of await s.Promises.readdir(a)){let I=-1;if(m){const P=b.indexOf("-");if(P<0)continue;const C=b.substring(0,P);if(!M.test(C)||b.substring(P+1)!=="preview")continue;I=parseInt(C,10)}else{if(!M.test(b))continue;I=parseInt(b,10)}if(I<=r)continue;const A=O.$8c(a,b,"pwsh.exe");await s.SymlinkSupport.existsFile(A)&&(i=A,r=I)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=m?" Preview":"";return new g(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const m=O.$8c(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=S?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(m))if(t.test(r)){const i=O.$8c(m,r,"pwsh.exe");return new g(i,a)}return null}function v(){const S=O.$8c(k.homedir(),".dotnet","tools","pwsh.exe");return new g(S,".NET Core PowerShell Global Tool")}function c(){const S=O.$8c(process.env.windir,h===1&&$!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(S,"Windows PowerShell",!0)}async function*d(){let S=await u();S&&(yield S),S=await u({useAlternateBitness:!0}),S&&(yield S),S=await y(),S&&(yield S),S=v(),S&&(yield S),S=await u({findPreview:!0}),S&&(yield S),S=await y({findPreview:!0}),S&&(yield S),S=await u({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=c(),S&&(yield S)}async function*l(){for await(const S of d())await S.exists()&&(yield S)}e.$dl=l;async function w(){for await(const S of l())return S;return null}e.$el=w}),define(te[89],ie([0,1,9,4,36,73,12,21]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f(g=s.env){return g.comspec||"cmd.exe"}e.$hl=f;function h(g){let p=[],u=!1;const y=function(v){if(u){p.push(v);return}(!g.send(v,d=>{if(d&&console.error(d),u=!1,p.length>0){const l=p.slice(0);p=[],l.forEach(w=>y(w))}})||O.$i)&&(u=!0)};return{send:y}}e.$il=h;var $;(function(g){async function p(u,y,v){if(k.$7c(u))return u;if(y===void 0&&(y=s.cwd()),k.$$c(u)!=="."||(v===void 0&&D.$ie(s.env.PATH)&&(v=s.env.PATH.split(k.$fd)),v===void 0||v.length===0))return k.$8c(y,u);async function d(l){if(await E.Promises.exists(l)){let w;try{w=await E.Promises.stat(l)}catch(S){S.message.startsWith("EACCES")&&(w=await E.Promises.lstat(l))}return w?!w.isDirectory():!1}return!1}for(const l of v){let w;if(k.$7c(l)?w=k.$8c(l,u):w=k.$8c(y,l,u),await d(w))return w;let S=w+".com";if(await d(S)||(S=w+".exe",await d(S)))return S}return k.$8c(y,u)}g.findExecutable=p})($||(e.win32=$={}))}),define(te[108],ie([0,1,47,15]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;function s(D){return new Promise((E,f)=>{let h;const $=new Map;function g(u,y,v,c,d){const l=$.get(y);if(u===D||l){const w={name:p(v),cmd:v,pid:u,ppid:y,load:c,mem:d};$.set(u,w),u===D&&(h=w),l&&(l.children||(l.children=[]),l.children.push(w),l.children.length>1&&(l.children=l.children.sort((S,m)=>S.pid-m.pid)))}}function p(u){const y=/--utility-sub-type=network/i,v=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(c.exec(u))return"electron-crash-reporter";if(d.exec(u))return"winpty-agent";if(l.exec(u))return"conpty-agent";let S=w.exec(u);if(S&&S.length===2)return S[1]==="renderer"?"window":S[1]==="utility"?y.exec(u)?"utility-network-service":"utility-process":S[1]==="extensionHost"?"extension-host":S[1];const m=/[a-zA-Z-]+\.js/g;let t="";do S=m.exec(u),S&&(t+=S+" ");while(S);return t&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${t})`:v.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,v)=>{H(["@vscode/windows-process-tree"],y,v)}).then(y=>{y.getProcessList(D,v=>{if(!v){f(new Error(`Root process ${D} not found`));return}y.getProcessCpuUsage(v,c=>{const d=new Map;c.forEach(l=>{const w=u(l.commandLine||"");d.set(l.pid,{name:p(w),cmd:w,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),h=d.get(D),h?(d.forEach(l=>{const w=d.get(l.ppid);w&&(w.children||(w.children=[]),w.children.push(l))}),d.forEach(l=>{l.children&&(l.children=l.children.sort((w,S)=>w.pid-S.pid))}),E(h)):f(new Error(`Root process ${D} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let u=function(){let y=[h];const v=[];for(;y.length;){const d=y.shift();d&&(v.push(d.pid),d.children&&(y=y.concat(d.children)))}let c=JSON.stringify(O.$1e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+v.join(" "),(0,k.exec)(c,{},(d,l,w)=>{if(d||w)f(d||new Error(w.toString()));else{const S=l.toString().split(`
`);for(let m=0;m<v.length;m++){const t=$.get(v[m]);t.load=parseFloat(S[m])}if(!h){f(new Error(`Root process ${D} not found`));return}E(h)}})};(0,k.exec)("which ps",{},(y,v,c)=>{if(y||c)if(process.platform!=="linux")f(y||new Error(c.toString()));else{const d=JSON.stringify(O.$1e.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(d,{},(l,w,S)=>{l||S?f(l||new Error(S.toString())):(M(w,g),u())})}else{const d=v.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${d} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,S,m)=>{w||m&&!m.includes("screen size is bogus")?f(w||new Error(m.toString())):(M(S,g),process.platform==="linux"?u():h?E(h):f(new Error(`Root process ${D} not found`)))})}})}})}e.$jr=s;function M(D,E){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,h=D.toString().split(`
`);for(const $ of h){const g=f.exec($.trim());g&&g.length===6&&E(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(te[109],ie([0,1,27,4,107,89]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=void 0;async function D(g,p){return g===1?O.$i?$():M.$hl(p):f(g,p)}e.$jl=D;let E=null;function f(g,p){if(O.$k&&g===2||O.$j&&g===3)return"/bin/bash";if(!E){let u;if(O.$i)u="/bin/bash";else{if(u=p.SHELL,!u)try{u=(0,k.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}E=u}return E}let h=null;async function $(){return h||(h=(await(0,s.$el)()).exePath),h}});var ke=this&&this.__decorate||function(H,e,k,O){var s=arguments.length,M=s<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,k):O,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(H,e,k,O);else for(var E=H.length-1;E>=0;E--)(D=H[E])&&(M=(s<3?D(M):s>3?D(e,k,M):D(e,k))||M);return s>3&&M&&Object.defineProperty(e,k,M),M};define(te[42],ie([0,1,24,8,17,23,55,13,3,2,74,26,12]),function(H,e,k,O,s,M,D,E,f,h,$,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var u;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(u||(u={}));function y(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(v||(v={}));function c(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(d||(d={}));function l(z){let T=0;for(let F=0;;F+=7){const B=z.read(1);if(T|=(B.buffer[0]&127)<<F,!(B.buffer[0]&128))return T}}const w=r(0);function S(z,T){if(T===0){z.write(w);return}let F=0;for(let x=T;x!==0;x=x>>>7)F++;const B=s.$Ec.alloc(F);for(let x=0;T!==0;x++)B.buffer[x]=T&127,T=T>>>7,T>0&&(B.buffer[x]|=128);z.write(B)}class m{constructor(T){this.b=T,this.a=0}read(T){const F=this.b.slice(this.a,this.a+T);return this.a+=F.byteLength,F}}e.$Zg=m;class t{constructor(){this.a=[]}get buffer(){return s.$Ec.concat(this.a)}write(T){this.a.push(T)}}e.$1g=t;var a;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(a||(a={}));function r(z){const T=s.$Ec.alloc(1);return T.writeUInt8(z,0),T}const i={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object),Uint:r(a.Int)},n=typeof Buffer<"u";function o(z,T){if(typeof T>"u")z.write(i.Undefined);else if(typeof T=="string"){const F=s.$Ec.fromString(T);z.write(i.String),S(z,F.byteLength),z.write(F)}else if(n&&Buffer.isBuffer(T)){const F=s.$Ec.wrap(T);z.write(i.Buffer),S(z,F.byteLength),z.write(F)}else if(T instanceof s.$Ec)z.write(i.VSBuffer),S(z,T.byteLength),z.write(T);else if(Array.isArray(T)){z.write(i.Array),S(z,T.length);for(const F of T)o(z,F)}else if(typeof T=="number"&&(T|0)===T)z.write(i.Uint),S(z,T);else{const F=s.$Ec.fromString(JSON.stringify(T));z.write(i.Object),S(z,F.byteLength),z.write(F)}}e.$2g=o;function b(z){switch(z.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return z.read(l(z)).toString();case a.Buffer:return z.read(l(z)).buffer;case a.VSBuffer:return z.read(l(z));case a.Array:{const F=l(z),B=[];for(let x=0;x<F;x++)B.push(b(z));return B}case a.Object:return JSON.parse(z.read(l(z)).toString());case a.Int:return l(z)}}e.$3g=b;class I{constructor(T,F,B=null,x=1e3){this.h=T,this.j=F,this.k=B,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(T,F){this.b.set(T,F),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const F=this.o([T.type]);this.k?.logOutgoing(F,0,1,c(T.type));return}case 201:case 202:case 204:case 203:{const F=this.o([T.type,T.id],T.data);this.k?.logOutgoing(F,T.id,1,c(T.type),T.data);return}}}o(T,F=void 0){const B=new t;return o(B,T),o(B,F),this.p(B.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const F=new m(T),B=b(F),x=b(F),oe=B[0];switch(oe){case 100:return this.k?.logIncoming(T.byteLength,B[1],1,`${y(oe)}: ${B[2]}.${B[3]}`,x),this.s({type:oe,id:B[1],channelName:B[2],name:B[3],arg:x});case 102:return this.k?.logIncoming(T.byteLength,B[1],1,`${y(oe)}: ${B[2]}.${B[3]}`,x),this.t({type:oe,id:B[1],channelName:B[2],name:B[3],arg:x});case 101:return this.k?.logIncoming(T.byteLength,B[1],1,`${y(oe)}`),this.u({type:oe,id:B[1]});case 103:return this.k?.logIncoming(T.byteLength,B[1],1,`${y(oe)}`),this.u({type:oe,id:B[1]})}}s(T){const F=this.b.get(T.channelName);if(!F){this.v(T);return}const B=new M.$oc;let x;try{x=F.call(this.j,T.name,T.arg,B.token)}catch(G){x=Promise.reject(G)}const oe=T.id;x.then(G=>{this.m({id:oe,data:G,type:201}),this.d.delete(T.id)},G=>{G instanceof Error?this.m({id:oe,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:oe,data:G,type:203}),this.d.delete(T.id)});const ce=(0,h.$jb)(()=>B.cancel());this.d.set(T.id,ce)}t(T){const F=this.b.get(T.channelName);if(!F){this.v(T);return}const B=T.id,oe=F.listen(this.j,T.name,T.arg)(ce=>this.m({id:B,data:ce,type:204}));this.d.set(T.id,oe)}u(T){const F=this.d.get(T.id);F&&(F.dispose(),this.d.delete(T.id))}v(T){let F=this.g.get(T.channelName);F||(F=[],this.g.set(T.channelName,F));const B=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);F.push({request:T,timeoutTimer:B})}w(T){const F=this.g.get(T);if(F){for(const B of F)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.s(B.request);break;case 102:this.t(B.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,h.$gb)(this.d.values()),this.d.clear()}}e.$4g=I;var A;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class P{constructor(T,F=null){this.l=T,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$ec,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(B=>this.s(B)),this.j=F}getChannel(T){const F=this;return{call(B,x,oe){return F.a?Promise.reject(new E.$3):F.m(T,B,x,oe)},listen(B,x){return F.a?f.Event.None:F.o(T,B,x)}}}m(T,F,B,x=M.CancellationToken.None){const oe=this.g++,G={id:oe,type:100,channelName:T,name:F,arg:B};if(x.isCancellationRequested)return Promise.reject(new E.$3);let R;return new Promise((N,q)=>{if(x.isCancellationRequested)return q(new E.$3);const se=()=>{const ee=X=>{switch(X.type){case 201:this.f.delete(oe),N(X.data);break;case 202:{this.f.delete(oe);const de=new Error(X.data.message);de.stack=Array.isArray(X.data.stack)?X.data.stack.join(`
`):X.data.stack,de.name=X.data.name,q(de);break}case 203:this.f.delete(oe),q(X.data);break}};this.f.set(oe,ee),this.p(G)};let Y=null;this.b===d.Idle?se():(Y=(0,O.$ig)(ee=>this.u()),Y.then(()=>{Y=null,se()}));const le=()=>{Y?(Y.cancel(),Y=null):this.p({id:oe,type:101}),q(new E.$3)},K=x.onCancellationRequested(le);R=(0,h.$ib)((0,h.$jb)(le),K),this.d.add(R)}).finally(()=>{this.d.delete(R)})}o(T,F,B){const x=this.g++,ce={id:x,type:102,channelName:T,name:F,arg:B};let G=null;const R=new f.$ec({onWillAddFirstListener:()=>{G=(0,O.$ig)(N=>this.u()),G.then(()=>{G=null,this.d.add(R),this.p(ce)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(R),this.p({id:x,type:103}))}}),L=N=>R.fire(N.data);return this.f.set(x,L),R.event}p(T){switch(T.type){case 100:case 102:{const F=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(F,T.id,0,`${y(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const F=this.q([T.type,T.id]);this.j?.logOutgoing(F,T.id,0,y(T.type));return}}}q(T,F=void 0){const B=new t;return o(B,T),o(B,F),this.r(B.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const F=new m(T),B=b(F),x=b(F),oe=B[0];switch(oe){case 200:return this.j?.logIncoming(T.byteLength,0,0,c(oe)),this.t({type:B[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,B[1],0,c(oe),x),this.t({type:B[0],id:B[1],data:x})}}t(T){if(T.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,h.$gb)(this.d.values()),this.d.clear()}}e.$5g=P,ke([D.$Tg],P.prototype,"onDidInitializePromise",null);class C{get connections(){const T=[];return this.f.forEach(F=>T.push(F)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new f.$ec,this.onDidAddConnection=this.g.event,this.h=new f.$ec,this.onDidRemoveConnection=this.h.event,T(({protocol:F,onDidClientDisconnect:B})=>{f.Event.once(F.onMessage)(oe=>{const ce=new m(oe),G=b(ce),R=new I(F,G),L=new P(F);this.a.forEach((q,se)=>R.registerChannel(se,q));const N={channelServer:R,channelClient:L,ctx:G};this.f.add(N),this.g.fire(N),B(()=>{R.dispose(),L.dispose(),this.f.delete(N),this.h.fire(N)})})})}getChannel(T,F){const B=this;return{call(x,oe,ce){let G;if((0,p.$we)(F)){const L=(0,k.$Hf)(B.connections.filter(F));G=L?Promise.resolve(L):f.Event.toPromise(f.Event.filter(B.onDidAddConnection,F))}else G=F.routeCall(B,x,oe);const R=G.then(L=>L.channelClient.getChannel(T));return U(R).call(x,oe,ce)},listen(x,oe){if((0,p.$we)(F))return B.j(T,F,x,oe);const ce=F.routeEvent(B,x,oe).then(G=>G.channelClient.getChannel(T));return U(ce).listen(x,oe)}}}j(T,F,B,x){const oe=this;let ce=new h.$kb;const G=new f.$ec({onWillAddFirstListener:()=>{ce=new h.$kb;const R=new f.$kc,L=new Map,N=se=>{const le=se.channelClient.getChannel(T).listen(B,x),K=R.add(le);L.set(se,K)},q=se=>{const Y=L.get(se);Y&&(Y.dispose(),L.delete(se))};oe.connections.filter(F).forEach(N),f.Event.filter(oe.onDidAddConnection,F)(N,void 0,ce),oe.onDidRemoveConnection(q,void 0,ce),R.event(G.fire,G,ce),ce.add(R)},onDidRemoveLastListener:()=>{ce.dispose()}});return G.event}registerChannel(T,F){this.a.set(T,F),this.f.forEach(B=>{B.channelServer.registerChannel(T,F)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=C;class j{constructor(T,F,B=null){const x=new t;o(x,F),T.send(x.buffer),this.a=new P(T,B),this.d=new I(T,F,B)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,F){this.d.registerChannel(T,F)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=j;function U(z){return{call(T,F,B){return z.then(x=>x.call(T,F,B))},listen(T,F){const B=new f.$nc;return z.then(x=>B.input=x.listen(T,F)),B.event}}}e.$8g=U;function W(z){let T=!1;return{call(F,B,x){return T?z.call(F,B,x):(0,O.$vg)(0).then(()=>T=!0).then(()=>z.call(F,B,x))},listen(F,B){if(T)return z.listen(F,B);const x=new f.$nc;return(0,O.$vg)(0).then(()=>T=!0).then(()=>x.input=z.listen(F,B)),x.event}}}e.$9g=W;class re{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const F of T.connections)if(await Promise.resolve(this.a(F.ctx)))return Promise.resolve(F);return await f.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$0g=re;var ne;(function(z){function T(oe,ce){const G=oe,R=ce&&ce.disableMarshalling,L=new Map;for(const N in G)B(N)&&L.set(N,f.Event.buffer(G[N],!0));return new class{listen(N,q,se){const Y=L.get(q);if(Y)return Y;if(x(q)){const le=G[q];if(typeof le=="function")return le.call(G,se)}throw new E.$ab(`Event not found: ${q}`)}call(N,q,se){const Y=G[q];if(typeof Y=="function"){if(!R&&Array.isArray(se))for(let le=0;le<se.length;le++)se[le]=(0,$.$Yg)(se[le]);return Y.apply(G,se)}throw new E.$ab(`Method not found: ${q}`)}}}z.fromService=T;function F(oe,ce){const G=ce&&ce.disableMarshalling;return new Proxy({},{get(R,L){if(typeof L=="string")return ce?.properties?.has(L)?ce.properties.get(L):x(L)?function(N){return oe.listen(L,N)}:B(L)?oe.listen(L):async function(...N){let q;ce&&!(0,p.$re)(ce.context)?q=[ce.context,...N]:q=N;const se=await oe.call(L,q);return G?se:(0,$.$Yg)(se)};throw new E.$ab(`Property not found: ${String(L)}`)}})}z.toService=F;function B(oe){return oe[0]==="o"&&oe[1]==="n"&&g.$Kd(oe.charCodeAt(2))}function x(oe){return/^onDynamic/.test(oe)&&g.$Kd(oe.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const T=z.toString();if(T!=="[object Object]")return T}return z}function ue(z){return Array.isArray(z)?z.map(ae):ae(z)}function V(z,T,F,B,x,oe,ce){ce=ue(ce);const G=fe[x],R=G[B%G.length];let L=[`%c[${z}]%c[${String(T).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(oe)?(L=L.concat(ce),L.push(")")):L.push(ce),console.log.apply(console,L)}class J{constructor(T,F){this.d=T,this.f=F,this.a=0,this.b=0}logOutgoing(T,F,B,x,oe){this.b+=T,V(this.d,this.b,T,F,B,x,oe)}logIncoming(T,F,B,x,oe){this.a+=T,V(this.f,this.a,T,F,B,x,oe)}}e.$$g=J}),define(te[156],ie([0,1,17,3,42]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AS=e.$zS=void 0;class M{constructor(f){this.a=f,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",h=>k.$Ec.wrap(h.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$zS=M;class D extends s.$7g{constructor(f,h){const $=new M(f);super($,h),this.b=$}dispose(){this.b.disconnect()}}e.$AS=D}),define(te[110],ie([0,1,17,3,2,42]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.$ah=e.ProtocolConstants=e.$_g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function b(A,P){if(!n.has(A)){const C=String(++o);n.set(A,C)}return n.get(A)}function I(A,P,C,j){if(!i.enableDiagnostics)return;const U=b(A,P);if(j instanceof k.$Ec||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const W=k.$Ec.alloc(j.byteLength);W.set(j),i.records.push({timestamp:Date.now(),id:U,label:P,type:C,buff:W})}else i.records.push({timestamp:Date.now(),id:U,label:P,type:C,data:j})}i.traceSocketEvent=I})(E||(e.SocketDiagnostics=E={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let h=null;function $(){return h||(h=k.$Ec.alloc(0)),h}class g{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return $();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const P=this.a[0];return o&&(this.a.shift(),this.b-=n),P}if(this.a[0].byteLength>n){const P=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),P}const b=k.$Ec.alloc(n);let I=0,A=0;for(;n>0;){const P=this.a[A];if(P.byteLength>n){const C=P.slice(0,n);b.set(C,I),I+=n,o&&(this.a[A]=P.slice(n),this.b-=n),n-=n}else b.set(P,I),I+=P.byteLength,o?(this.a.shift(),this.b-=P.byteLength):A++,n-=P.byteLength}return b}}e.$_g=g;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function u(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class v{constructor(n,o,b,I){this.type=n,this.id=o,this.ack=b,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends s.$lb{constructor(n){super(),this.f=this.B(new O.$ec),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new g,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,I=this.g.id,A=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new v(b,I,A,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=k.$Ec.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const b=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,b}h(){const n=k.$Ec.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class l extends s.$lb{constructor(n){super(),this.f=new O.$ec,this.onMessage=this.f.event,this.g=new O.$ec,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new d(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new v(1,0,0,n))}}e.$ah=l;class w extends M.$7g{static fromSocket(n,o){return new w(new l(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,b=null){super(n,o,b),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$bh=w;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$ec({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$ch=S;class m{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,b=this.a;for(;b;)n[o++]=b.data,b=b.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new m(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<a.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=a.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+a.a)*1e3;let b=0;for(let I=0;I<a.a;I++)n-this.c[I]<=o&&b++;return 1-b/a.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new S,this.onControlMessage=this.u.event,this.v=new S,this.onMessage=this.v.event,this.w=new S,this.onDidDispose=this.w.event,this.x=new S,this.onSocketClose=this.x.event,this.y=new S,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??a.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$kb,this.o=n.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new v(5,0,0,$());this.p.write(n),this.p.flush()}sendPause(){const n=new v(7,0,0,$());this.p.write(n)}sendResume(){const n=new v(8,0,0,$());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new s.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new v(3,0,this.h,$());this.p.write(n);const o=this.b.toArray();for(let b=0,I=o.length;b<I;b++)this.p.write(o[b]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new v(6,0,0,$())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let b=0,I=o.length;b<I;b++)this.p.write(o[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const b=new v(1,o,this.h,n);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(n){const o=new v(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,b=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(o>=2e4&&b>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:b});return}const A=Math.max(2e4-o,2e4-b,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},A)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new v(3,0,this.h,$());this.p.write(n)}D(){this.h=this.g;const n=new v(9,0,this.h,$());this.p.write(n)}}e.$dh=r}),define(te[157],ie([0,1,38,17,3,2,42,145]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DS=void 0;function f($,g){const p=s.Event.fromNodeEventEmitter(k.$wS,g,(y,v)=>({event:y,message:v})),u=s.Event.filter(p,({event:y})=>y.sender.id===$);return s.Event.map(u,({message:y})=>y&&O.$Ec.wrap(y))}class h extends D.$6g{static{this.b=new Map}static d(){const g=s.Event.fromNodeEventEmitter(k.$wS,"vscode:hello",({sender:p})=>p);return s.Event.map(g,p=>{const u=p.id;h.b.get(u)?.dispose();const v=new s.$ec;h.b.set(u,(0,M.$jb)(()=>v.fire()));const c=f(u,"vscode:message"),d=s.Event.any(s.Event.signal(f(u,"vscode:disconnect")),v.event);return{protocol:new E.$CS(p,c),onDidClientDisconnect:d}})}constructor(){super(h.d())}}e.$DS=h}),define(te[111],ie([0,1,38,3,31,156]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FS=e.$ES=void 0;class D extends M.$AS{constructor(h,$){super({addEventListener:(g,p)=>h.addListener(g,p),removeEventListener:(g,p)=>h.removeListener(g,p),postMessage:g=>h.postMessage(g),start:()=>h.start(),close:()=>h.close()},$)}}e.$ES=D;async function E(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const h=(0,s.$3e)();f.webContents.send("vscode:createMessageChannel",h);const $=O.Event.fromNodeEventEmitter(k.$wS,"vscode:createMessageChannelResult",(p,u)=>({nonce:u,port:p.ports[0]})),{port:g}=await O.Event.toPromise(O.Event.once(O.Event.filter($,p=>p.nonce===h)));return g}e.$FS=E}),define(te[158],ie([0,1,47,8,17,23,153,13,3,2,37,89,73,42]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=void 0;class y extends u.$4g{constructor(d){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",l=>s.$Ec.wrap(Buffer.from(l,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$Ip=y;class v{constructor(d,l){this.i=d,this.j=l,this.c=new Set,this.g=new Map,this.h=new f.$ec,this.onDidProcessExit=this.h.event;const w=l&&l.timeout?l.timeout:6e4;this.b=new O.$rg(w),this.d=null,this.f=null}getChannel(d){const l=this;return{call(w,S,m){return l.k(d,w,S,m)},listen(w,S){return l.l(d,w,S)}}}k(d,l,w,S=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(E.$4());this.b.cancel();const m=this.n(d),t=(0,O.$ig)(i=>m.call(l,w,i)),a=S.onCancellationRequested(()=>t.cancel()),r=(0,h.$jb)(()=>t.cancel());return this.c.add(r),t.finally(()=>{a.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,l,w){if(!this.b)return f.Event.None;this.b.cancel();let S;const m=new f.$ec({onWillAddFirstListener:()=>{S=this.n(d).listen(l,w)(m.fire,m),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,$.$Im)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$gl)(l.env),this.d=(0,k.fork)(this.i,d,l);const w=new f.$ec;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Ep)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}w.fire(s.$Ec.wrap(Buffer.from(n,"base64")))});const m=this.j.useQueue?(0,g.$il)(this.d):this.d,t=n=>this.d&&this.d.connected&&m.send(n.buffer.toString("base64")),a=w.event,r={send:t,onMessage:a};this.f=new u.$5g(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(b=>(0,h.$gb)(b)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(d){let l=this.g.get(d);return l||(l=this.m.getChannel(d),this.g.set(d,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Jp=v}),define(te[112],ie([0,1,8,3,2,74,12]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.StorageState=e.$Ho=e.StorageHint=void 0;var E;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function f(p){const u=p;return u?.changed instanceof Map||u?.deleted instanceof Set}e.$Ho=f;var h;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(h||(e.StorageState=h={}));class $ extends s.$lb{static{this.a=100}constructor(u,y=Object.create(null)){super(),this.m=u,this.n=y,this.b=this.B(new O.$hc),this.onDidChangeStorage=this.b.event,this.c=h.None,this.f=new Map,this.g=new k.$sg($.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(u=>this.r(u)))}r(u){this.b.pause();try{u.changed?.forEach((y,v)=>this.s(v,y)),u.deleted?.forEach(y=>this.s(y,void 0))}finally{this.b.resume()}}s(u,y){if(this.c===h.Closed)return;let v=!1;(0,D.$re)(y)?v=this.f.delete(u):this.f.get(u)!==y&&(this.f.set(u,y),v=!0),v&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===h.None&&(this.c=h.Initialized,this.n.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(u,y){const v=this.f.get(u);return(0,D.$re)(v)?y:v}getBoolean(u,y){const v=this.get(u);return(0,D.$re)(v)?y:v==="true"}getNumber(u,y){const v=this.get(u);return(0,D.$re)(v)?y:parseInt(v,10)}getObject(u,y){const v=this.get(u);return(0,D.$re)(v)?y:(0,M.$Xg)(v)}async set(u,y,v=!1){if(this.c===h.Closed)return;if((0,D.$re)(y))return this.delete(u,v);const c=(0,D.$ke)(y)||Array.isArray(y)?(0,M.$Wg)(y):String(y);if(this.f.get(u)!==c)return this.f.set(u,c),this.j.set(u,c),this.h.delete(u),this.b.fire({key:u,external:v}),this.w()}async delete(u,y=!1){if(!(this.c===h.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:y}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=h.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(u).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(u){if(this.u)return this.w(u)}async w(u){return this.g.trigger(()=>this.v(),u)}async whenFlushed(){if(this.u)return new Promise(u=>this.l.push(u))}isInMemory(){return this.n.hint===E.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Io=$;class g{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((y,v)=>this.a.set(v,y)),u.delete?.forEach(y=>this.a.delete(y))}async close(){}}e.$Jo=g}),define(te[159],ie([0,1,8,3,35,9,21]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3S=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return O.Event.None}static{this.a=2e3}static{this.b=256}constructor($,g=Object.create(null)){this.g=$,this.h=g,this.c=(0,M.$_c)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const $=await this.f,g=new Map;return(await this.s($,"SELECT * FROM ItemTable")).forEach(u=>g.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${g.size} rows`),g}async updateItems($){const g=await this.f;return this.j(g,$)}j($,g){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${g.insert?(0,s.$li)(g.insert):"0"}), delete(${g.delete?(0,s.$mi)(g.delete):"0"})`),this.t($,()=>{const p=g.insert,u=g.delete;if(p&&p.size>0){const y=[];y.push([]);let v=0;p.forEach((c,d)=>{let l=y[v];l.length>E.b&&(v++,l=[],y.push(l)),l.push(d,c)}),y.forEach(c=>{this.u($,`INSERT INTO ItemTable VALUES ${new Array(c.length/2).fill("(?,?)").join(",")}`,d=>d.run(c),()=>{const d=[];let l=0;return p.forEach((w,S)=>{d.push(S),l+=w.length}),`Keys: ${d.join(", ")} Length: ${l}`})})}if(u&&u.size){const y=[];y.push([]);let v=0;u.forEach(c=>{let d=y[v];d.length>E.b&&(v++,d=[],y.push(d)),d.push(c)}),y.forEach(c=>{this.u($,`DELETE FROM ItemTable WHERE key IN (${new Array(c.length).fill("?").join(",")})`,d=>d.run(c),()=>{const d=[];return u.forEach(l=>{d.push(l)}),`Keys: ${d.join(", ")}`})})}})}async close($){this.d.trace(`[storage ${this.c}] close()`);const g=await this.f;return this.k(g,$)}k($,g){return new Promise((p,u)=>{$.db.close(y=>(y&&this.o($,`[storage ${this.c}] close(): ${y}`),this.g===E.IN_MEMORY_PATH?p():!$.isErroneous&&!$.isInMemory?this.l().then(p,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),p())):typeof g=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const c=()=>this.k(v,void 0);return this.j(v,{insert:g()}).then(()=>c(),d=>(c(),Promise.reject(d)))})).then(p,u):u(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const $=this.m(this.g);return D.Promises.copy(this.g,$,{preserveSymlinks:!1})}m($){return`${$}.backup`}async checkIntegrity($){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${$})`);const g=await this.f,p=await this.r(g,$?"PRAGMA integrity_check":"PRAGMA quick_check"),u=$?p.integrity_check:p.quick_check;return g.isErroneous?`${u} (last error: ${g.lastError})`:g.isInMemory?`${u} (in-memory!)`:u}async n($,g=!0){this.d.trace(`[storage ${this.c}] open(${$}, retryOnBusy: ${g})`);try{return await this.p($)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&g)return await(0,k.$vg)(E.a),this.n($,!1);try{await D.Promises.unlink($);try{await D.Promises.rename(this.m($),$,!1)}catch{}return await this.p($)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(E.IN_MEMORY_PATH)}}}o($,g){$.isErroneous=!0,$.lastError=g,this.d.error(g)}p($){return new Promise((g,p)=>{new Promise((u,y)=>{H(["@vscode/sqlite3"],u,y)}).then(u=>{const y={db:new(this.d.isTracing?u.verbose().Database:u.Database)($,v=>v?y.db&&v.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(v)):p(v):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>g(y),c=>y.db.close(()=>p(c)))),isInMemory:$===E.IN_MEMORY_PATH};y.db.on("error",v=>this.o(y,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&y.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},p)})}q($,g){return new Promise((p,u)=>{$.db.exec(g,y=>y?(this.o($,`[storage ${this.c}] exec(): ${y}`),u(y)):p())})}r($,g){return new Promise((p,u)=>{$.db.get(g,(y,v)=>y?(this.o($,`[storage ${this.c}] get(): ${y}`),u(y)):p(v))})}s($,g){return new Promise((p,u)=>{$.db.all(g,(y,v)=>y?(this.o($,`[storage ${this.c}] all(): ${y}`),u(y)):p(v))})}t($,g){return new Promise((p,u)=>{$.db.serialize(()=>{$.db.run("BEGIN TRANSACTION"),g(),$.db.run("END TRANSACTION",y=>y?(this.o($,`[storage ${this.c}] transaction(): ${y}`),u(y)):p())})})}u($,g,p,u){const y=$.db.prepare(g),v=c=>{this.o($,`[storage ${this.c}] prepare(): ${c} (${g}). Details: ${u()}`)};y.on("error",v),p(y),y.finalize(c=>{c&&v(c),y.removeListener("error",v)})}}e.$3S=E;class f{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor($){$&&typeof $.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=$.logTrace),$&&typeof $.logError=="function"&&(this.b=$.logError)}get isTracing(){return!!this.a}trace($){this.a?.($)}error($){this.b?.($)}}}),define(te[160],ie([11,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(te[161],ie([11,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([11,10]),function(H,e){return H.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([11,10]),function(H,e){return H.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([11,10]),function(H,e){return H.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([11,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([11,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([11,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([11,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([11,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([11,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([11,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(te[175],ie([11,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(te[176],ie([11,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([11,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([11,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([11,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([11,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([11,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(te[182],ie([11,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([11,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([11,10]),function(H,e){return H.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([11,10]),function(H,e){return H.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([11,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([11,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([11,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TT=e.$ST=void 0;function k(s){return s&&s.hasOwnProperty("folderUri")}e.$ST=k;function O(s){return s&&s.hasOwnProperty("workspace")}e.$TT=O}),define(te[194],ie([0,1,7]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T4b=e.$S4b=e.$R4b=void 0;function O(D){return typeof D?.backupFolder=="string"}e.$R4b=O;function s(D){let E=[];try{Array.isArray(D.workspaces)&&(E=D.workspaces.map(f=>({workspace:{id:f.id,configPath:k.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return E}e.$S4b=s;function M(D){let E=[];try{Array.isArray(D.folders)&&(E=D.folders.map(f=>({folderUri:k.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return E}e.$T4b=M}),define(te[195],ie([0,1,13,163]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var s;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...h){switch(h.length){case 1:return(0,O.localize)(0,null,h[0]);case 2:return(0,O.localize)(1,null,h[0],h[1]);case 3:return(0,O.localize)(2,null,h[0],h[1],h[2]);default:return}}const D=(0,O.localize)(3,null),E=(0,O.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return $.isTripleEq?"===":"==";case 4:return $.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return $.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return $.lexeme;case 18:return $.lexeme;case 19:return $.lexeme;case 20:return"EOF";default:throw(0,k.$6)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const g=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:g})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const g=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:g})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const g=this.d,p=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:p};this.g.push({offset:g,lexeme:p,additionalInfo:$}),this.f.push(u)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const g=this.c.substring(this.d,this.e),p=f.b.get(g);p?this.k(p):this.f.push({type:17,lexeme:g,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,g=!1,p=!1;for(;;){if($>=this.c.length){this.e=$,this.l(E);return}const y=this.c.charCodeAt($);if(g)g=!1;else if(y===47&&!p){$++;break}else y===91?p=!0:y===92?g=!0:y===93&&(p=!1);$++}for(;$<this.c.length&&f.a.has(this.c.charCodeAt($));)$++;this.e=$;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=f}),define(te[196],ie([0,1,3,2]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=void 0;class s{constructor(){this.a=new k.$ec,this.b=new k.$ec,this.c=new k.$ec,this.d=new k.$ec}static{this.ChannelName="extensionhostdebugservice"}call(E,f,h){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:h[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:h[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:h[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:h[0],port:h[1],subId:h[2]}))}throw new Error("Method not implemented.")}listen(E,f,h){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$tn=s;class M extends O.$lb{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,f,h){this.b.call("attach",[E,f,h])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,f){this.b.call("terminate",[E,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,f){return this.b.call("openExtensionDevelopmentHostWindow",[E,f])}}e.$un=M}),define(te[197],ie([0,1,148,55,15,9,36,19,7]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.$Ul=void 0,e.$Ul=/^([^.]+\..+):(.+)$/;class h{get appRoot(){return(0,M.$$c)(s.$1e.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$8c)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,E.$9f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$9f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,k.$Tl)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$8c)(this.userDataPath,"logs",u)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$9f)(f.URI.file((0,M.$8c)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$9f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$9f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$9f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=D.env.VSCODE_PORTABLE;return u?f.URI.file((0,M.$8c)(u,"argv.json")):(0,E.$9f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$8c)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,M.$9c)(u):(0,M.$6c)((0,M.$8c)(s.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?f.URI.file((0,M.$9c)(u)):f.URI.file((0,M.$8c)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,M.$9c)(u);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const v=D.env.VSCODE_PORTABLE;return v?(0,M.$8c)(v,"extensions"):(0,E.$9f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,M.$6c)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?f.URI.parse(u):f.URI.file((0,M.$6c)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return $(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$Ul.test(u))}get extensionLogLevel(){const u=[];for(const y of this.args.log||[]){const v=e.$Ul.exec(y);v&&v[1]&&v[2]&&u.push([v[1],v[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,E.$9f)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=D.env.VSCODE_PORTABLE;return u?f.URI.file((0,M.$8c)(u,"policy.json")):(0,E.$9f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,y,v){this.a=u,this.b=y,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Vl=h,ke([O.$Tg],h.prototype,"appRoot",null),ke([O.$Tg],h.prototype,"userHome",null),ke([O.$Tg],h.prototype,"userDataPath",null),ke([O.$Tg],h.prototype,"appSettingsHome",null),ke([O.$Tg],h.prototype,"tmpDir",null),ke([O.$Tg],h.prototype,"cacheHome",null),ke([O.$Tg],h.prototype,"stateResource",null),ke([O.$Tg],h.prototype,"userRoamingDataHome",null),ke([O.$Tg],h.prototype,"userDataSyncHome",null),ke([O.$Tg],h.prototype,"sync",null),ke([O.$Tg],h.prototype,"machineSettingsResource",null),ke([O.$Tg],h.prototype,"workspaceStorageHome",null),ke([O.$Tg],h.prototype,"localHistoryHome",null),ke([O.$Tg],h.prototype,"keyboardLayoutResource",null),ke([O.$Tg],h.prototype,"argvResource",null),ke([O.$Tg],h.prototype,"isExtensionDevelopment",null),ke([O.$Tg],h.prototype,"untitledWorkspacesHome",null),ke([O.$Tg],h.prototype,"builtinExtensionsPath",null),ke([O.$Tg],h.prototype,"extensionsPath",null),ke([O.$Tg],h.prototype,"extensionDevelopmentLocationURI",null),ke([O.$Tg],h.prototype,"extensionDevelopmentKind",null),ke([O.$Tg],h.prototype,"extensionTestsLocationURI",null),ke([O.$Tg],h.prototype,"debugExtensionHost",null),ke([O.$Tg],h.prototype,"logLevel",null),ke([O.$Tg],h.prototype,"extensionLogLevel",null),ke([O.$Tg],h.prototype,"serviceMachineIdResource",null),ke([O.$Tg],h.prototype,"disableTelemetry",null),ke([O.$Tg],h.prototype,"disableWorkspaceTrust",null),ke([O.$Tg],h.prototype,"disableKeytar",null),ke([O.$Tg],h.prototype,"policyFile",null);function $(p,u){return g(p["inspect-extensions"],p["inspect-brk-extensions"],5870,u,p.debugId,p.extensionEnvironment)}e.$Wl=$;function g(p,u,y,v,c,d){const w=Number(u||p)||(v?null:y),S=w?!!u:!1;let m;if(d)try{m=JSON.parse(d)}catch{}return{port:w,break:S,debugId:c,env:m}}e.$Xl=g}),define(te[113],ie([0,1,308,4,166]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$kl=["tunnel","serve-web"],e.$ll={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(v,c,d=D){const l=v.find(o=>o.length>0&&o[0]!=="-"),w={},S=["_"],m=[],t={};let a;for(const o in c){const b=c[o];b.type==="subcommand"?o===l&&(a=b):(b.alias&&(w[o]=b.alias),b.type==="string"||b.type==="string[]"?(S.push(o),b.deprecates&&S.push(...b.deprecates)):b.type==="boolean"&&(m.push(o),b.deprecates&&m.push(...b.deprecates)),b.global&&(t[o]=b))}if(a&&l){const o=t;for(const P in a.options)o[P]=a.options[P];const b=v.filter(P=>P!==l),I=d.getSubcommandReporter?d.getSubcommandReporter(l):void 0,A=E(b,o,I);return{[l]:A,_:[]}}const r=k(v,{string:S,boolean:m,alias:w}),i={},n=r;i._=r._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in c){const b=c[o];if(b.type==="subcommand")continue;b.alias&&delete n[b.alias];let I=n[o];if(b.deprecates)for(const A of b.deprecates)n.hasOwnProperty(A)&&(I||(I=n[A],I&&d.onDeprecatedOption(A,b.deprecationMessage||(0,s.localize)(37,null,o))),delete n[A]);if(typeof I<"u"){if(b.type==="string[]"){if(Array.isArray(I)||(I=[I]),!b.allowEmptyValue){const A=I.filter(P=>P.length>0);A.length!==I.length&&(d.onEmptyValue(o),I=A.length>0?A:void 0)}}else b.type==="string"&&(Array.isArray(I)?(I=I.pop(),d.onMultipleValues(o,I)):!I&&!b.allowEmptyValue&&(d.onEmptyValue(o),I=void 0));i[o]=I,b.deprecationMessage&&d.onDeprecatedOption(o,b.deprecationMessage)}delete n[o]}for(const o in n)d.onUnknownOption(o);return i}e.$ml=E;function f(v,c){let d="";return c.args&&(Array.isArray(c.args)?d=` <${c.args.join("> <")}>`:d=` <${c.args}>`),c.alias?`-${c.alias} --${v}${d}`:`--${v}${d}`}function h(v,c){const d=[];for(const l in v){const w=v[l],S=f(l,w);d.push([S,w.description])}return $(d,c)}e.$nl=h;function $(v,c){const l=v.reduce((m,t)=>Math.max(m,t[0].length),12)+2+1;if(c-l<25)return v.reduce((m,t)=>m.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const w=c-l-1,S=[];for(const m of v){const t=m[0],a=p(m[1],w),r=g(l-t.length-2);S.push("  "+t+r+a[0]);for(let i=1;i<a.length;i++)S.push(g(l)+a[i])}return S}function g(v){return" ".repeat(v)}function p(v,c){const d=[];for(;v.length;){const l=v.length<c?v.length:v.lastIndexOf(" ",c),w=v.slice(0,l).trim();v=v.slice(l),d.push(w)}return d}function u(v,c,d,l,w){const S=process.stdout.isTTY&&process.stdout.columns||80,m=w?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${v} ${d}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${c} [${(0,s.localize)(40,null)}]${m}`),t.push(""),w?.noPipe!==!0&&(O.$i?t.push((0,s.localize)(41,null,c)):t.push((0,s.localize)(42,null,c)),t.push(""));const a={},r=[];for(const i in l){const n=l[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let o=a[n.cat];o||(a[n.cat]=o={}),o[i]=n}}for(const i in a){const n=i,o=a[n];o&&(t.push(M[n]),t.push(...h(o,S)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...$(r.map(i=>[i.command,i.description]),S)),t.push("")),t.join(`
`)}e.$ol=u;function y(v,c){return`${v||(0,s.localize)(44,null)}
${c||(0,s.localize)(45,null)}
${process.arch}`}e.$pl=y}),define(te[198],ie([0,1,88,196,113]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$14b=void 0;class M extends O.$tn{constructor(E){super(),this.f=E}call(E,f,h){return f==="openExtensionDevelopmentHostWindow"?this.g(h[0],h[1]):super.call(E,f,h)}async g(E,f){const h=(0,s.$ml)(E,s.$ll);h.debugRenderer=f;const $=h.extensionDevelopmentPath;if(!$)return{success:!1};const[g]=await this.f.openExtensionDevelopmentHostWindow($,{context:5,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!f)return{success:!0};const p=g.win;if(!p)return{success:!0};const u=p.webContents.debugger;let y=u.isAttached()?1/0:0;const v=(0,k.createServer)(c=>{y++===0&&u.attach();let d=!1;const l=m=>{d||c.write(JSON.stringify(m)+"\0")},w=(m,t,a,r)=>l({method:t,params:a,sessionId:r});p.on("close",()=>{u.removeListener("message",w),c.end(),d=!0}),u.addListener("message",w);let S=Buffer.alloc(0);c.on("data",m=>{S=Buffer.concat([S,m]);for(let t=S.indexOf(0);t!==-1;t=S.indexOf(0)){let a;try{const r=S.slice(0,t).toString("utf8");S=S.slice(t+1),a=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}u.sendCommand(a.method,a.params,a.sessionId).then(r=>l({id:a.id,sessionId:a.sessionId,result:r})).catch(r=>l({id:a.id,sessionId:a.sessionId,error:{code:0,message:r.message}}))}}),c.on("error",m=>{console.error("error on cdp pipe:",m)}),c.on("close",()=>{d=!0,--y===0&&u.detach()})});return await new Promise(c=>v.listen(0,c)),p.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$14b=M}),define(te[63],ie([0,1,309,167,113]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.$ql=void 0;function M(g,p){const u=(w,S)=>{console.warn((0,O.localize)(0,null,w,S))},y=w=>{console.warn((0,O.localize)(1,null,w))},v=(w,S)=>{console.warn((0,O.localize)(2,null,w,S))},c=w=>({onUnknownOption:S=>{s.$kl.includes(w)||console.warn((0,O.localize)(3,null,S,w))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:s.$kl.includes(w)?c:void 0}),d={onUnknownOption:w=>{console.warn((0,O.localize)(4,null,w))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:c},l=(0,s.$ml)(g,s.$ll,p?d:void 0);return l.goto&&l._.forEach(w=>k(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(w),(0,O.localize)(5,null))),l}function D(g){const p=g.findIndex(u=>!/^-/.test(u));if(p>-1)return[...g.slice(0,p),...g.slice(p+1)]}function E(g){let[,...p]=g;process.env.VSCODE_DEV&&(p=D(p)||[]);const u=!$(process.env);return M(p,u)}e.$ql=E;function f(g){let[,,...p]=g;return process.env.VSCODE_DEV&&(p=D(p)||[]),M(p,!0)}e.$rl=f;function h(g,...p){const u=g.indexOf("--");return u===-1?g.push(...p):g.splice(u,0,...p),g}e.$sl=h;function $(g){return g.VSCODE_CLI==="1"}e.$tl=$}),function(){"use strict";function H(e,k,O){function s(D,E){const f=M(D,E),h=[f];return e.isAbsolute(f)||h.unshift(O),e.resolve(...h)}function M(D,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return e.join(h,E);const $=D["user-data-dir"];if($)return $;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=e.join(g,"AppData","Roaming")}break;case"darwin":h=e.join(k.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(h,E)}return{getUserDataPath:s}}if(typeof define=="function")define(te[199],ie([114,27,36]),function(e,k,O){return H(e,k,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=H(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[90],ie([0,1,27,197,199]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=void 0;class M extends O.$Vl{constructor(h,$){super(h,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,s.getUserDataPath)(h,$.nameShort)},$)}}e.$Yl=M;function D(f,h){return(0,O.$Xl)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,h,f.extensionEnvironment)}e.$Zl=D;function E(f,h){return(0,O.$Xl)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,h,f.extensionEnvironment)}e.$1l=E}),define(te[200],ie([0,1,45,27,32]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;function M(D){const E=(0,s.$Pe)((0,O.tmpdir)());try{return(0,k.writeFileSync)(E,""),D&&console.log(`Marker file for --wait created: ${E}`),E}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$r6b=M}),define(te[201],ie([0,1,12,169]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;function s(D,E,f){try{M(D,E,f)}catch(h){console.error(h?.message??h)}return D}e.$ep=s;function M(D,E,f){const h=($,g,p)=>{const u=$[g];if((0,k.$ie)(u)){const y=u,v=y.length;if(v>1&&y[0]==="%"&&y[v-1]==="%"){const c=y.substr(1,v-2);let d=E[c];d===void 0&&f&&(d=f[c]);const l=typeof d=="string"?d:d?.message,w=f?.[c],S=typeof w=="string"?w:w?.message;if(!l){S||console.warn(`[${D.name}]: ${(0,O.localize)(0,null,c)}`);return}if(p&&(g==="title"||g==="category")&&S&&S!==l){const m={value:l,original:S};$[g]=m}else $[g]=l}}else if((0,k.$ke)(u))for(const y in u)u.hasOwnProperty(y)&&(y==="commands"?h(u,y,!0):h(u,y,p));else if(Array.isArray(u))for(let y=0;y<u.length;y++)h(u,y,p)};for(const $ in D)D.hasOwnProperty($)&&h(D,$)}}),define(te[202],ie([0,1,19,70,171,203]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function f(d){return d=d.trim(),d==="*"||D.test(d)}e.$to=f;function h(d){if(!f(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=d.match(D);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$uo=h;function $(d){if(!d)return null;const l=d.majorBase,w=d.majorMustEqual,S=d.minorBase;let m=d.minorMustEqual;const t=d.patchBase;let a=d.patchMustEqual;d.hasCaret&&(l===0||(m=!1),a=!1);let r=0;if(d.preRelease){const i=E.exec(d.preRelease);if(i){const[,n,o,b]=i;r=Date.UTC(Number(n),Number(o)-1,Number(b))}}return{majorBase:l,majorMustEqual:w,minorBase:S,minorMustEqual:m,patchBase:t,patchMustEqual:a,isMinimum:d.hasGreaterEquals,notBefore:r}}e.$vo=$;function g(d,l,w){let S;typeof d=="string"?S=$(h(d)):S=d;let m;l instanceof Date?m=l.getTime():typeof l=="string"&&(m=new Date(l).getTime());let t;if(typeof w=="string"?t=$(h(w)):t=w,!S||!t)return!1;const a=S.majorBase,r=S.minorBase,i=S.patchBase;let n=t.majorBase,o=t.minorBase,b=t.patchBase;const I=t.notBefore;let A=t.majorMustEqual,P=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?a>n?!0:a<n?!1:r>o?!0:r<o||m&&m<I?!1:i>=b:(a===1&&n===0&&(!A||!P||!C)&&(n=1,o=0,b=0,A=!0,P=!1,C=!1),a<n?!1:a>n?!A:r<o?!1:r>o?!P:i<b?!1:i>b?!C:!(m&&m<I))}e.$wo=g;function p(d,l,w,S,m){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([O.default.Error,s.localize(0,null)]),t;if(typeof S.name!="string")return t.push([O.default.Error,s.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([O.default.Error,s.localize(2,null,"version")]),t;if(!S.engines)return t.push([O.default.Error,s.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([O.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!c(S.extensionDependencies))return t.push([O.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!c(S.activationEvents))return t.push([O.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([O.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([O.default.Warning,s.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([O.default.Error,s.localize(9,null,"main")]),t;{const i=(0,k.$9f)(w,S.main);(0,k.$3f)(i,w)||t.push([O.default.Warning,s.localize(10,null,i.path,w.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([O.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,k.$9f)(w,S.browser);(0,k.$3f)(i,w)||t.push([O.default.Warning,s.localize(12,null,i.path,w.path)])}}if(!M.valid(S.version))return t.push([O.default.Error,s.localize(13,null)]),t;const a=[];if(!u(d,l,S,m,a))for(const i of a)t.push([O.default.Error,i]);return t}e.$xo=p;function u(d,l,w,S,m){return S||typeof w.main>"u"&&typeof w.browser>"u"?!0:v(d,l,w.engines.vscode,m)}e.$yo=u;function y(d,l,w){return d==="*"||v(l,w,d)}e.$zo=y;function v(d,l,w,S=[]){const m=$(h(w));if(!m)return S.push(s.localize(14,null,w)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return S.push(s.localize(15,null,w)),!1}else if(!m.majorMustEqual)return S.push(s.localize(16,null,w)),!1;return g(d,l,m)?!0:(S.push(s.localize(17,null,d,w)),!1)}function c(d){if(!Array.isArray(d))return!1;for(let l=0,w=d.length;l<w;l++)if(typeof d[l]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0;async function s(M,D,E){let f=E&&E.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const $=(await D.readFile(M.serviceMachineIdResource)).value.toString();f=(0,O.$2e)($)?$:null}catch{f=null}if(!f){f=(0,O.$3e)();try{await D.writeFile(M.serviceMachineIdResource,k.$Ec.fromString(f))}catch{}}return E?.store("storage.serviceMachineId",f,-1,1),f}e.$So=s}),define(te[75],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class k{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$mh=k}),define(te[205],ie([0,1,75]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.InstantiationType=void 0;const O=[];var s;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(E,f,h){f instanceof k.$mh||(f=new k.$mh(f,[],!!h)),O.push([E,f])}e.$dr=M;function D(){return O}e.$er=D}),define(te[206],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;class k{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Up=k;class O{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const E=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(D);E.outgoing.set(f.key,f),f.incoming.set(E.key,E)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const E of this.a.values())E.outgoing.delete(D),E.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let E=this.a.get(D);return E||(E=new k(D,M),this.a.set(D,E)),E}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,E]of this.a)M.push(`${D}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const E=new Set([M]),f=this.c(D,E);if(f)return f}}c(M,D){for(const[E,f]of M.outgoing){if(D.has(E))return[...D,E].join(" -> ");D.add(E);const h=this.c(f,D);if(h)return h;D.delete(E)}}}e.$Vp=O}),define(te[6],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var k;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function E(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=E})(k||(e._util=k={})),e.$oh=s("instantiationService");function O(D,E,f){E[k.DI_TARGET]===E?E[k.DI_DEPENDENCIES].push({id:D,index:f}):(E[k.DI_DEPENDENCIES]=[{id:D,index:f}],E[k.DI_TARGET]=E)}function s(D){if(k.serviceIds.has(D))return k.serviceIds.get(D);const E=function(f,h,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(E,f,$)};return E.toString=()=>D,k.serviceIds.set(D,E),E}e.$ph=s;function M(D){return D}e.$qh=M}),define(te[64],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U4b=void 0,e.$U4b=(0,k.$ph)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,s.$ph)("configurationService");function M(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof O.URI)}e.$Wh=M;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof O.URI)}e.$Xh=D;var E;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function f(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=f;function h(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.$Zh=h;function $(d,l){const w=Object.create(null);for(const S in d)g(w,S,d[S],l);return w}e.$1h=$;function g(d,l,w,S){const m=l.split("."),t=m.pop();let a=d;for(let r=0;r<m.length;r++){const i=m[r];let n=a[i];switch(typeof n){case"undefined":n=a[i]=Object.create(null);break;case"object":break;default:S(`Ignoring ${l} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[t]=w}catch{S(`Ignoring ${l} as ${m.join(".")} is ${JSON.stringify(a)}`)}else S(`Ignoring ${l} as ${m.join(".")} is ${JSON.stringify(a)}`)}e.$2h=g;function p(d,l){const w=l.split(".");u(d,w)}e.$3h=p;function u(d,l){const w=l.shift();if(l.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const S=d[w];typeof S=="object"&&!Array.isArray(S)&&(u(S,l),Object.keys(S).length===0&&delete d[w])}}function y(d,l,w){function S(a,r){let i=a;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const m=l.split("."),t=S(d,m);return typeof t>"u"?w:t}e.$4h=y;function v(d,l,w){Object.keys(l).forEach(S=>{S!=="__proto__"&&(S in d?k.$ke(d[S])&&k.$ke(l[S])?v(d[S],l[S],w):w&&(d[S]=l[S]):d[S]=l[S])})}e.$5h=v;function c(d){return d.replace(/[\[\]]/g,"")}e.$6h=c}),define(te[115],ie([0,1,4,26,195,6,162,13]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",k.$j),f.set("isLinux",k.$k),f.set("isWindows",k.$i),f.set("isWeb",k.$o),f.set("isMacNative",k.$j&&!k.$o),f.set("isEdge",k.$G),f.set("isFirefox",k.$E),f.set("isChrome",k.$D),f.set("isSafari",k.$F);function h(G,R){if(f.get(G)!==void 0)throw(0,E.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(G,R)}e.$ti=h;const $=Object.prototype.hasOwnProperty;var g;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const p={regexParsingWithErrorRecovery:!0},u=(0,D.localize)(0,null),y=(0,D.localize)(1,null),v=(0,D.localize)(2,null),c=(0,D.localize)(3,null),d=(0,D.localize)(4,null),l=(0,D.localize)(5,null),w=(0,D.localize)(6,null),S=(0,D.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=p){this.k=R,this.d=new s.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const N=this.D(),q=N.type===17?l:void 0;throw this.h.push({message:d,offset:N.offset,lexeme:s.$si.getLexeme(N),additionalInfo:q}),m.c}return L}catch(L){if(L!==m.c)throw L;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const L=this.o();R.push(L)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const L=this.s();R.push(L)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const L=this.l();return this.A(1,c),L?.negate()}case 17:return this.z(),j.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const L=this.l();return this.A(1,c),L}case 17:{const L=R.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const se=q.lexeme,Y=se.lastIndexOf("/"),le=Y===se.length-1?void 0:this.w(se.substring(Y+1));let K;try{K=new RegExp(se.substring(1,Y),le)}catch{throw this.B("REGEX",q)}return ae.create(L,K)}switch(q.type){case 10:case 19:{const se=[q.lexeme];this.z();let Y=this.D(),le=0;for(let me=0;me<q.lexeme.length;me++)q.lexeme.charCodeAt(me)===40?le++:q.lexeme.charCodeAt(me)===41&&le--;for(;!this.E()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let me=0;me<Y.lexeme.length;me++)Y.lexeme.charCodeAt(me)===40?le++:q.lexeme.charCodeAt(me)===41&&le--}if(le<0)break;se.push(s.$si.getLexeme(Y)),this.z(),Y=this.D()}const K=se.join(""),ee=K.lastIndexOf("/"),X=ee===K.length-1?void 0:this.w(K.substring(ee+1));let de;try{de=new RegExp(K.substring(1,ee),X)}catch{throw this.B("REGEX",q)}return t.regex(L,de)}case 18:{const se=q.lexeme;this.z();let Y=null;if(!(0,O.$ld)(se)){const le=se.indexOf("/"),K=se.lastIndexOf("/");if(le!==K&&le>=0){const ee=se.slice(le+1,K),X=se[K+1]==="i"?"i":"";try{Y=new RegExp(ee,X)}catch{throw this.B("REGEX",q)}}}if(Y===null)throw this.B("REGEX",q);return ae.create(L,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const q=this.u();return t.notIn(L,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return t.equals(L,q);switch(q){case"true":return t.has(L);case"false":return t.not(L);default:return t.equals(L,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return t.notEquals(L,q);switch(q){case"true":return t.not(L);case"false":return t.has(L);default:return t.notEquals(L,q)}}case 5:return this.z(),ne.create(L,this.u());case 6:return this.z(),fe.create(L,this.u());case 7:return this.z(),W.create(L,this.u());case 8:return this.z(),re.create(L,this.u());case 13:return this.z(),t.in(L,this.u());default:return t.has(L)}}case 20:throw this.h.push({message:w,offset:R.offset,lexeme:"",additionalInfo:S}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,L){if(this.C(R))return this.z();throw this.B(L,this.D())}B(R,L,N){const q=(0,D.localize)(8,null,R,s.$si.getLexeme(L)),se=L.offset,Y=s.$si.getLexeme(L);return this.h.push({message:q,offset:se,lexeme:Y,additionalInfo:N}),m.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=m;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(R){return b.create(R)}static equals(R,L){return I.create(R,L)}static notEquals(R,L){return C.create(R,L)}static regex(R,L){return ae.create(R,L)}static in(R,L){return A.create(R,L)}static notIn(R,L){return P.create(R,L)}static not(R){return j.create(R)}static and(...R){return J.create(R,null,!0)}static or(...R){return z.create(R,null,!0)}static greater(R,L){return W.create(R,L)}static greaterEquals(R,L){return re.create(R,L)}static smaller(R,L){return ne.create(R,L)}static smallerEquals(R,L){return fe.create(R,L)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$vi=t;function a(G){const R=new m({regexParsingWithErrorRecovery:!1});return G.map(L=>(R.parse(L),R.lexingErrors.length>0?R.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,D.localize)(9,null,N.additionalInfo):(0,D.localize)(10,null),offset:N.offset,length:N.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}e.$wi=a;function r(G,R){const L=G?G.substituteConstants():void 0,N=R?R.substituteConstants():void 0;return!L&&!N?!0:!L||!N?!1:L.equals(N)}e.$xi=r;function i(G,R){return G.cmp(R)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return o.INSTANCE}}e.$yi=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return n.INSTANCE}}e.$zi=o;class b{static create(R,L=null){const N=f.get(R);return typeof N=="boolean"?N?o.INSTANCE:n.INSTANCE:new b(R,L)}constructor(R,L){this.key=R,this.c=L,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:F(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=f.get(this.key);return typeof R=="boolean"?R?o.INSTANCE:n.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Ai=b;class I{static create(R,L,N=null){if(typeof L=="boolean")return L?b.create(R,N):j.create(R,N);const q=f.get(R);return typeof q=="boolean"?L===(q?"true":"false")?o.INSTANCE:n.INSTANCE:new I(R,L,N)}constructor(R,L,N){this.c=R,this.d=L,this.f=N,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:B(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=f.get(this.c);if(typeof R=="boolean"){const L=R?"true":"false";return this.d===L?o.INSTANCE:n.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Bi=I;class A{static create(R,L){return new A(R,L)}constructor(R,L){this.d=R,this.f=L,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:B(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const L=R.getValue(this.f),N=R.getValue(this.d);return Array.isArray(L)?L.includes(N):typeof N=="string"&&typeof L=="object"&&L!==null?$.call(L,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=P.create(this.d,this.f)),this.c}}e.$Ci=A;class P{static create(R,L){return new P(R,L)}constructor(R,L){this.d=R,this.f=L,this.type=11,this.c=A.create(R,L)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=P;class C{static create(R,L,N=null){if(typeof L=="boolean")return L?j.create(R,N):b.create(R,N);const q=f.get(R);return typeof q=="boolean"?L===(q?"true":"false")?n.INSTANCE:o.INSTANCE:new C(R,L,N)}constructor(R,L,N){this.c=R,this.d=L,this.f=N,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:B(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=f.get(this.c);if(typeof R=="boolean"){const L=R?"true":"false";return this.d===L?n.INSTANCE:o.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ei=C;class j{static create(R,L=null){const N=f.get(R);return typeof N=="boolean"?N?n.INSTANCE:o.INSTANCE:new j(R,L)}constructor(R,L){this.c=R,this.d=L,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:F(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=f.get(this.c);return typeof R=="boolean"?R?n.INSTANCE:o.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Fi=j;function U(G,R){if(typeof G=="string"){const L=parseFloat(G);isNaN(L)||(G=L)}return typeof G=="string"||typeof G=="number"?R(G):n.INSTANCE}class W{static create(R,L,N=null){return U(L,q=>new W(R,q,N))}constructor(R,L,N){this.c=R,this.d=L,this.f=N,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:B(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=fe.create(this.c,this.d,this)),this.f}}e.$Gi=W;class re{static create(R,L,N=null){return U(L,q=>new re(R,q,N))}constructor(R,L,N){this.c=R,this.d=L,this.f=N,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:B(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Hi=re;class ne{static create(R,L,N=null){return U(L,q=>new ne(R,q,N))}constructor(R,L,N){this.c=R,this.d=L,this.f=N,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:B(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Ii=ne;class fe{static create(R,L,N=null){return U(L,q=>new fe(R,q,N))}constructor(R,L,N){this.c=R,this.d=L,this.f=N,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:B(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ji=fe;class ae{static create(R,L){return new ae(R,L)}constructor(R,L){this.d=R,this.f=L,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const L=this.f?this.f.source:"",N=R.f?R.f.source:"";return L<N?-1:L>N?1:0}equals(R){if(R.type===this.type){const L=this.f?this.f.source:"",N=R.f?R.f.source:"";return this.d===R.d&&L===N}return!1}substituteConstants(){return this}evaluate(R){const L=R.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$Ki=ae;class ue{static create(R){return new ue(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new ue(this.c.map(R))}negate(){return this.c}}e.$Li=ue;function V(G){let R=null;for(let L=0,N=G.length;L<N;L++){const q=G[L].substituteConstants();if(G[L]!==q&&R===null){R=[];for(let se=0;se<L;se++)R[se]=G[se]}R!==null&&(R[L]=q)}return R===null?G:R}class J{static create(R,L,N){return J.d(R,L,N)}constructor(R,L){this.expr=R,this.c=L,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let L=0,N=this.expr.length;L<N;L++){const q=i(this.expr[L],R.expr[L]);if(q!==0)return q}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let L=0,N=this.expr.length;L<N;L++)if(!this.expr[L].equals(R.expr[L]))return!1;return!0}return!1}substituteConstants(){const R=V(this.expr);return R===this.expr?this:J.create(R,this.c,!1)}evaluate(R){for(let L=0,N=this.expr.length;L<N;L++)if(!this.expr[L].evaluate(R))return!1;return!0}static d(R,L,N){const q=[];let se=!1;for(const Y of R)if(Y){if(Y.type===1){se=!0;continue}if(Y.type===0)return n.INSTANCE;if(Y.type===6){q.push(...Y.expr);continue}q.push(Y)}if(q.length===0&&se)return o.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(i);for(let Y=1;Y<q.length;Y++)q[Y-1].equals(q[Y])&&(q.splice(Y,1),Y--);if(q.length===1)return q[0];for(;q.length>1;){const Y=q[q.length-1];if(Y.type!==9)break;q.pop();const le=q.pop(),K=q.length===0,ee=z.create(Y.expr.map(X=>J.create([X,le],null,N)),null,K);ee&&(q.push(ee),q.sort(i))}if(q.length===1)return q[0];if(N){for(let Y=0;Y<q.length;Y++)for(let le=Y+1;le<q.length;le++)if(q[Y].negate().equals(q[le]))return n.INSTANCE;if(q.length===1)return q[0]}return new J(q,L)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const L of this.expr)R.push(...L.keys());return R}map(R){return new J(this.expr.map(L=>L.map(R)),null)}negate(){if(!this.c){const R=[];for(const L of this.expr)R.push(L.negate());this.c=z.create(R,this,!0)}return this.c}}e.$Mi=J;class z{static create(R,L,N){return z.d(R,L,N)}constructor(R,L){this.expr=R,this.c=L,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let L=0,N=this.expr.length;L<N;L++){const q=i(this.expr[L],R.expr[L]);if(q!==0)return q}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let L=0,N=this.expr.length;L<N;L++)if(!this.expr[L].equals(R.expr[L]))return!1;return!0}return!1}substituteConstants(){const R=V(this.expr);return R===this.expr?this:z.create(R,this.c,!1)}evaluate(R){for(let L=0,N=this.expr.length;L<N;L++)if(this.expr[L].evaluate(R))return!0;return!1}static d(R,L,N){let q=[],se=!1;if(R){for(let Y=0,le=R.length;Y<le;Y++){const K=R[Y];if(K){if(K.type===0){se=!0;continue}if(K.type===1)return o.INSTANCE;if(K.type===9){q=q.concat(K.expr);continue}q.push(K)}}if(q.length===0&&se)return n.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let Y=1;Y<q.length;Y++)q[Y-1].equals(q[Y])&&(q.splice(Y,1),Y--);if(q.length===1)return q[0];if(N){for(let Y=0;Y<q.length;Y++)for(let le=Y+1;le<q.length;le++)if(q[Y].negate().equals(q[le]))return o.INSTANCE;if(q.length===1)return q[0]}return new z(q,L)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const L of this.expr)R.push(...L.keys());return R}map(R){return new z(this.expr.map(L=>L.map(R)),null)}negate(){if(!this.c){const R=[];for(const L of this.expr)R.push(L.negate());for(;R.length>1;){const L=R.shift(),N=R.shift(),q=[];for(const se of ce(L))for(const Y of ce(N))q.push(J.create([se,Y],null,!1));R.unshift(z.create(q,null,!1))}this.c=z.create(R,this,!0)}return this.c}}e.$Ni=z;class T extends b{static{this.d=[]}static all(){return T.d.values()}constructor(R,L,N){super(R,null),this.f=L,typeof N=="object"?T.d.push({...N,key:R}):N!==!0&&T.d.push({key:R,description:N,type:L!=null?typeof L:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return I.create(this.key,R)}notEqualsTo(R){return C.create(this.key,R)}}e.$Oi=T,e.$Pi=(0,M.$ph)("contextKeyService");function F(G,R){return G<R?-1:G>R?1:0}function B(G,R,L,N){return G<L?-1:G>L?1:R<N?-1:R>N?1:0}function x(G,R){if(G.type===0||R.type===1)return!0;if(G.type===9)return R.type===9?oe(G.expr,R.expr):!1;if(R.type===9){for(const L of R.expr)if(x(G,L))return!0;return!1}if(G.type===6){if(R.type===6)return oe(R.expr,G.expr);for(const L of G.expr)if(x(L,R))return!0;return!1}return G.equals(R)}e.$Qi=x;function oe(G,R){let L=0,N=0;for(;L<G.length&&N<R.length;){const q=G[L].cmp(R[N]);if(q<0)return!1;q===0&&L++,N++}return L===G.length}function ce(G){return G.type===9?G.expr:[G]}}),define(te[76],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=void 0,e.$nn=(0,k.$ph)("credentialsService"),e.$on=(0,k.$ph)("credentialsMainService");class O{constructor(){this.a={}}async getPassword(M,D){return this.a[M]?.[D]??null}async setPassword(M,D,E){this.a[M]=this.a[M]??{},this.a[M][D]=E}async deletePassword(M,D){return this.a[M]?.[D]?(delete this.a[M][D],Object.keys(this.a[M]).length===0&&delete this.a[M],!0):!1}async findPassword(M){return JSON.stringify(this.a[M])??null}async findCredentials(M){const D=[];for(const E of Object.keys(this.a[M]||{}))D.push({account:E,password:this.a[M][E]});return D}async clear(){this.a={}}}e.$pn=O}),define(te[91],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.ID=void 0,e.ID="diagnosticsService",e.$6l=(0,k.$ph)(e.ID);function O(M){return!!M.hostName&&!!M.errorMessage}e.$7l=O;class s{async getPerformanceInfo(D,E){return{}}async getSystemInfo(D,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,E){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$8l=s}),define(te[92],ie([0,1,19,70,164,6,46,4,37]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hA=e.$gA=e.ConfirmResult=e.$fA=e.$eA=e.$dA=void 0,e.$dA=(0,M.$ph)("dialogService");var h;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(h||(h={}));class ${a(c){return this.d(c,h.Confirmation)}b(c){return this.d(c,h.Prompt)}c(c){return this.d(c,h.Input)}d(c,d){const l=[];switch(d){case h.Confirmation:{const w=c;w.primaryButton?l.push(w.primaryButton):l.push((0,s.localize)(0,null)),w.cancelButton?l.push(w.cancelButton):l.push((0,s.localize)(1,null));break}case h.Prompt:{const w=c;Array.isArray(w.buttons)&&w.buttons.length>0&&l.push(...w.buttons.map(S=>S.label)),w.cancelButton&&(w.cancelButton===!0?l.push((0,s.localize)(2,null)):typeof w.cancelButton=="string"?l.push(w.cancelButton):w.cancelButton.label?l.push(w.cancelButton.label):l.push((0,s.localize)(3,null))),l.length===0&&l.push((0,s.localize)(4,null));break}case h.Input:{const w=c;w.primaryButton?l.push(w.primaryButton):l.push((0,s.localize)(5,null)),w.cancelButton?l.push(w.cancelButton):l.push((0,s.localize)(6,null));break}}return l}e(c){if(typeof c=="string")return c;if(typeof c=="number")return c===O.default.Info?"info":c===O.default.Error?"error":c===O.default.Warning?"warning":"none"}async f(c,d,l){const w=[...c.buttons??[]];return c.cancelButton&&typeof c.cancelButton!="string"&&typeof c.cancelButton!="boolean"&&w.push(c.cancelButton),{result:await w[d]?.run({checkboxChecked:l}),checkboxChecked:l}}}e.$eA=$,e.$fA=(0,M.$ph)("fileDialogService");var g;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(g||(e.ConfirmResult=g={}));const p=10;function u(v){const c=[];return c.push(...v.slice(0,p).map(d=>typeof d=="string"?d:(0,k.$6f)(d))),v.length>p&&(v.length-p===1?c.push((0,s.localize)(7,null)):c.push((0,s.localize)(8,null,v.length-p))),c.push(""),c.join(`
`)}e.$gA=u;function y(v,c){const d=(0,f.$Im)(v);let l=(d.buttons??[]).map(t=>(0,D.$aA)(t)),w=(v.buttons||[]).map((t,a)=>a),S=0,m=d.cancelId??l.length-1;if(l.length>1){const t=typeof m=="number"?l[m]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&l.length>1&&m!==1){l.splice(m,1),l.splice(1,0,t);const a=w[m];w.splice(m,1),w.splice(1,0,a),m=1}E.$k&&l.length>1&&(l=l.reverse(),w=w.reverse(),S=l.length-1,typeof t=="string"&&(m=S-1))}else if(E.$i&&typeof t=="string"&&l.length>1&&m!==l.length-1){l.splice(m,1),l.push(t);const a=w[m];w.splice(m,1),w.push(a),m=l.length-1}}return d.buttons=l,d.defaultId=S,d.cancelId=m,d.noLink=!0,d.title=d.title||c.nameLong,{options:d,buttonIndeces:w}}e.$hA=y}),define(te[116],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hT=e.$gT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$fT=e.$eT=void 0,e.$eT=(0,k.$ph)("encryptionService"),e.$fT=(0,k.$ph)("encryptionMainService");var O;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnome="gnome",E.gnomeKeyring="gnome-keyring",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(O||(e.PasswordStoreCLIOption=O={}));var s;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}e.$gT=M;function D(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}e.$hT=D}),define(te[33],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,k.$ph)("environmentService"),e.$xh=(0,k.$qh)(e.$wh)}),define(te[117],ie([0,1,168,6]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Rn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0,e.$En="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fn=new RegExp(e.$En),e.$Gn="__web_extension",e.$Hn="skipWalkthrough",e.$In="extensionsSync",e.$Jn="dependecyOrPackExtensionInstall";function s(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Kn=s;function M(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Ln=M;function D(l,w){switch(l){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Mn=D;function E(l,w){return w==="web"&&!l.includes("web")}e.$Nn=E;function f(l,w,S){return E(w,S)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===S?!0:h(S).includes(l)}e.$On=f;function h(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Pn=h;function $(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$Qn=$;var g;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var p;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var u;(function(l){l.Install="install",l.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var y;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$Rn=(0,O.$ph)("extensionGalleryService");var v;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var c;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class d extends Error{constructor(w,S){super(w),this.code=S,this.name=S}}e.$Sn=d,e.$Tn=(0,O.$ph)("extensionManagementService"),e.$Un="extensionsIdentifiers/disabled",e.$Vn="extensionsIdentifiers/enabled",e.$Wn=(0,O.$ph)("IGlobalExtensionEnablementService"),e.$Xn=(0,O.$ph)("IExtensionTipsService"),e.$Yn=(0,k.localize)(0,null),e.$Zn={value:e.$Yn,original:"Extensions"},e.$1n={value:(0,k.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkb=void 0,e.$kkb=(0,k.$ph)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e5b=e.$d5b=void 0,e.$d5b=(0,k.$ph)("extensionHostStarter"),e.$e5b="extensionHostStarter"}),define(te[118],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sWb=e.$rWb=e.$qWb=void 0,e.$qWb=(0,k.$ph)("externalTerminal"),e.$rWb="Terminal.app",e.$sWb=(0,k.$ph)("externalTerminal")}),define(te[209],ie([0,1,47,15,9,4,73,21,89,172,118]),function(H,e,k,O,s,M,D,E,f,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i5b=e.$h5b=e.$g5b=void 0;const g=h.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends p{static{this.b="cmd.exe"}openTerminal(S,m){return this.spawnTerminal(k,S,f.$hl(),m)}spawnTerminal(S,m,t,a){const r=m.windowsExec||u.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const i=s.$_c(r,".exe").toLowerCase();if(i==="cmder")return S.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((o,b)=>{const I=c(process),A=S.spawn(t,n,{cwd:a,env:I});A.on("error",b),A.on("exit",()=>o())})}runInTerminal(S,m,t,a,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:u.getDefaultTerminalWindows();return new Promise((n,o)=>{const b=`"${m} - ${g}"`,I=`""${t.join('" "')}" & pause"`,A=Object.assign({},c(process),a);Object.keys(A).filter(W=>A[W]===null).forEach(W=>delete A[W]);const P={cwd:m,env:A,windowsVerbatimArguments:!0};let C,j;s.$_c(i,".exe")==="wt"?(C=i,j=["-d",".",u.b,"/c",I]):(C=u.b,j=["/c","start",b,"/wait",i,"/c",I]),k.spawn(C,j,P).on("error",W=>{o(d(W))}),n(void 0)})}static getDefaultTerminalWindows(){if(!u.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return u.d}}e.$g5b=u;class y extends p{static{this.b="/usr/bin/osascript"}openTerminal(S,m){return this.spawnTerminal(k,S,m)}runInTerminal(S,m,t,a,r){const i=r.osxExec||$.$rWb;return new Promise((n,o)=>{if(i===$.$rWb||i==="iTerm.app"){const b=i===$.$rWb?"TerminalHelper":"iTermHelper",A=[O.$1e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${b}.scpt`).fsPath,"-t",S||g,"-w",m];for(const j of t)A.push("-a"),A.push(j);if(a){const j=Object.assign({},c(process),a);for(const U in j){const W=j[U];W===null?(A.push("-u"),A.push(U)):(A.push("-e"),A.push(`${U}=${W}`))}}let P="";const C=k.spawn(y.b,A);C.on("error",j=>{o(d(j))}),C.stderr.on("data",j=>{P+=j.toString()}),C.on("exit",j=>{if(j===0)n(void 0);else if(P){const U=P.split(`
`,1);o(new Error(U[0]))}else o(new Error(h.localize(1,null,b,j)))})}else o(new Error(h.localize(2,null,i)))})}spawnTerminal(S,m,t){const a=m.osxExec||$.$rWb;return new Promise((r,i)=>{const n=["-a",a];t&&n.push(t);const o=c(process),b=S.spawn("/usr/bin/open",n,{cwd:t,env:o});b.on("error",i),b.on("exit",()=>r())})}}e.$h5b=y;class v extends p{static{this.b=h.localize(3,null)}openTerminal(S,m){return this.spawnTerminal(k,S,m)}runInTerminal(S,m,t,a,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const b=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?b.push("-x"):b.push("-e"),b.push("bash"),b.push("-c");const A=`${l(t)}; echo; read -p "${v.b}" -n1;`;b.push(`''${A}''`);const P=Object.assign({},c(process),a);Object.keys(P).filter(W=>P[W]===null).forEach(W=>delete P[W]);const C={cwd:m,env:P};let j="";const U=k.spawn(I,b,C);U.on("error",W=>{o(d(W))}),U.stderr.on("data",W=>{j+=W.toString()}),U.on("exit",W=>{if(W===0)n(void 0);else if(j){const re=j.split(`
`,1);o(new Error(re[0]))}else o(new Error(h.localize(4,null,I,W)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!M.$k)v.d=Promise.resolve("xterm");else{const S=await E.Promises.exists("/etc/debian_version");v.d=new Promise(m=>{S?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return v.d}spawnTerminal(S,m,t){const a=m.linuxExec?Promise.resolve(m.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{a.then(n=>{const o=c(process),b=S.spawn(n,[],{cwd:t,env:o});b.on("error",i),b.on("exit",()=>r())})})}}e.$i5b=v;function c(w){const S={...w.env};return(0,D.$fl)(S),S}function d(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(h.localize(5,null,w.path)):w}function l(w){let S="";for(const m of w)m.indexOf(" ")>=0?S+='"'+m+'"':S+=m,S+=" ";return S}}),define(te[16],ie([0,1,58,9,26,12,7,174,6,4,15]),function(H,e,k,O,s,M,D,E,f,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,f.$ph)("fileService");function g(F){return F.create===!0}e.$Tj=g;var p;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var u;(function(F){F[F.Readonly=1]="Readonly",F[F.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var y;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileAtomicWrite=32768]="FileAtomicWrite",F[F.FileAtomicDelete=65536]="FileAtomicDelete",F[F.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function v(F){return!!(F.capabilities&2)}e.$Uj=v;function c(F){return!!(F.capabilities&8)}e.$Vj=c;function d(F){return!!(F.capabilities&131072)}e.$Wj=d;function l(F){return!!(F.capabilities&4)}e.$Xj=l;function w(F){return!!(F.capabilities&16)}e.$Yj=w;function S(F){return v(F)?!!(F.capabilities&16384):!1}e.$Zj=S;function m(F){return v(F)?!!(F.capabilities&32768):!1}e.$1j=m;function t(F){return!!(F.capabilities&65536)}e.$2j=t;function a(F){return!!(F.capabilities&2048)}e.$3j=a;var r;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsStorageQuota="EntryExceedsStorageQuota",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(B,x){const oe=new i(B.toString(),x);return b(oe,x),oe}constructor(B,x){super(B),this.code=x}}e.$4j=i;function n(F,B){return i.create(F,B)}e.$5j=n;function o(F){return F||n((0,E.localize)(0,null),r.Unknown)}e.$6j=o;function b(F,B){return F.name=B?`${B} (FileSystemError)`:"FileSystemError",F}e.$7j=b;function I(F){if(!F)return r.Unknown;if(F instanceof i)return F.code;const B=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!B)return r.Unknown;switch(B[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$8j=I;function A(F){if(F instanceof re)return F.fileOperationResult;switch(I(F)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$9j=A;var P;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class C{constructor(B,x,oe){this.resource=B,this.operation=x,this.target=oe}isOperation(B){return this.operation===B}}e.$0j=C;var j;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class U{constructor(B,x){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const oe=new Map;for(const ce of B){const G=oe.get(ce.type);switch(G?G.push([ce.resource,ce]):oe.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,G]of oe)switch(ce){case 1:this.a=k.$vh.forUris(()=>x),this.a.fill(G);break;case 0:this.b=k.$vh.forUris(()=>x),this.b.fill(G);break;case 2:this.c=k.$vh.forUris(()=>x),this.c.fill(G);break}}contains(B,...x){return this.d(B,{includeChildren:!1},...x)}affects(B,...x){return this.d(B,{includeChildren:!0},...x)}d(B,x,...oe){if(!B)return!1;const ce=oe.length>0;return!!((!ce||oe.includes(1))&&(this.a?.get(B)||x.includeChildren&&this.a?.findSuperstr(B))||(!ce||oe.includes(0))&&(this.b?.get(B)||x.includeChildren&&this.b?.findSuperstr(B))||(!ce||oe.includes(2))&&(this.c?.findSubstr(B)||x.includeChildren&&this.c?.findSuperstr(B)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=U;function W(F,B,x){return!F||!B||F===B||B.length>F.length?!1:(B.charAt(B.length-1)!==O.sep&&(B+=O.sep),x?(0,s.$Md)(F,B):F.indexOf(B)===0)}e.$_j=W;class re extends Error{constructor(B,x,oe){super(B),this.fileOperationResult=x,this.options=oe}}e.$ak=re;class ne extends re{constructor(B,x,oe,ce){super(B,x,ce),this.fileOperationResult=x,this.size=oe}}e.$bk=ne;class fe extends re{constructor(B,x,oe){super(B,2,oe),this.stat=x}}e.$ck=fe;var ae;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var ue;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$kk="";function V(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.$lk=V;async function J(F,B){if(!B.hasProvider(D.URI.from({scheme:F.scheme})))return new Promise(x=>{const oe=B.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===F.scheme&&ce.added&&(oe.dispose(),x())})})}e.$mk=J;class z{static{this.KB=1024}static{this.MB=z.KB*z.KB}static{this.GB=z.MB*z.KB}static{this.TB=z.GB*z.KB}static formatSize(B){return(0,M.$me)(B)||(B=0),B<z.KB?(0,E.localize)(1,null,B.toFixed(0)):B<z.MB?(0,E.localize)(2,null,(B/z.KB).toFixed(2)):B<z.GB?(0,E.localize)(3,null,(B/z.MB).toFixed(2)):B<z.TB?(0,E.localize)(4,null,(B/z.GB).toFixed(2)):(0,E.localize)(5,null,(B/z.TB).toFixed(2))}}e.$nk=z;function T(F){const B=typeof F=="string"||F?.scheme===$.Schemas.vscodeRemote;return typeof F!="string"&&F?.scheme===$.Schemas.file?1024*z.MB:B?10*z.MB:h.$o?50*z.MB:1024*z.MB}e.$ok=T}),define(te[210],ie([0,1,17,50,13,3,2,56,7,31,16]),function(H,e,k,O,s,M,D,E,f,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=void 0,e.$QM="localFilesystem";class g extends D.$lb{constructor(u,y){super(),this.a=u,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$ec),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$ec),this.onDidWatchError=this.g.event,this.h=(0,h.$3e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,y){const{buffer:v}=await this.a.call("readFile",[u,y]);return v}readFileStream(u,y,v){const c=(0,E.$sc)(l=>k.$Ec.concat(l.map(w=>k.$Ec.wrap(w))).buffer),d=this.a.listen("readFileStream",[u,y])(l=>{if(l instanceof k.$Ec)c.write(l.buffer);else{if(l==="end")c.end();else{let w;if(l instanceof Error)w=l;else{const S=l;w=(0,$.$5j)(S.message??(0,O.$ai)(S),S.code??$.FileSystemProviderErrorCode.Unknown)}c.error(w),c.end()}d.dispose()}});return v.onCancellationRequested(()=>{c.error((0,s.$4)()),c.end(),d.dispose()}),c}writeFile(u,y,v){return this.a.call("writeFile",[u,k.$Ec.wrap(y),v])}open(u,y){return this.a.call("open",[u,y])}close(u){return this.a.call("close",[u])}async read(u,y,v,c,d){const[l,w]=await this.a.call("read",[u,y,d]);return v.set(l.buffer.slice(0,w),c),w}write(u,y,v,c,d){return this.a.call("write",[u,y,k.$Ec.wrap(v),c,d])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,y){return this.a.call("delete",[u,y])}rename(u,y,v){return this.a.call("rename",[u,y,v])}copy(u,y,v){return this.a.call("copy",[u,y,v])}cloneFile(u,y){return this.a.call("cloneFile",[u,y])}i(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const y=u;this.f.fire(y.map(v=>({resource:f.URI.revive(v.resource),type:v.type})))}else{const y=u;this.g.fire(y)}}))}watch(u,y){const v=(0,h.$3e)();return this.a.call("watch",[this.h,v,u,y]),(0,D.$jb)(()=>this.a.call("unwatch",[this.h,v]))}}e.$RM=g}),define(te[119],ie([0,1,17,13,175,16]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;async function D($,g,p,u,y,v){let c;try{await E($,g,p,u,y,v)}catch(d){c=d}finally{c&&y.errorTransformer&&(c=y.errorTransformer(c)),typeof c<"u"&&p.error(c),p.end()}}e.$tp=D;async function E($,g,p,u,y,v){f(v);const c=await $.open(g,{create:!1});try{f(v);let d=0,l=0,w=y&&typeof y.length=="number"?y.length:void 0,S=k.$Ec.alloc(Math.min(y.bufferSize,typeof w=="number"?w:y.bufferSize)),m=y&&typeof y.position=="number"?y.position:0,t=0;do l=await $.read(c,m,S.buffer,t,S.byteLength-t),m+=l,t+=l,d+=l,typeof w=="number"&&(w-=l),t===S.byteLength&&(await p.write(u(S)),S=k.$Ec.alloc(Math.min(y.bufferSize,typeof w=="number"?w:y.bufferSize)),t=0);while(l>0&&(typeof w!="number"||w>0)&&f(v)&&h(d,y));if(t>0){let a=t;typeof w=="number"&&(a=Math.min(t,w)),p.write(u(S.slice(0,a)))}}catch(d){throw(0,M.$6j)(d)}finally{await $.close(c)}}function f($){if($.isCancellationRequested)throw(0,O.$4)();return!0}function h($,g){if(typeof g?.limits?.size=="number"&&$>g.limits.size)throw(0,M.$5j)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[77],ie([0,1,105,2,9,4,7,16]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0;function f(d){return d.recursive===!0}e.$vp=f;class h extends O.$lb{static{this.a=5}constructor(l,w,S,m){super(),this.h=l,this.i=w,this.j=S,this.k=m,this.c=this.B(new O.$mb),this.f=void 0,this.g=0}m(){const l=new O.$kb;this.c.value=l,this.b=this.l(l),this.b.setVerboseLogging(this.j),l.add(this.b.onDidChangeFile(w=>this.h(w))),l.add(this.b.onDidLogMessage(w=>this.i(w))),l.add(this.b.onDidError(w=>this.n(w)))}n(l){this.k.restartOnError?this.g<h.a&&this.f?(this.r(`restarting watcher after error: ${l}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${l}`):this.r(l)}p(l){this.g++,this.m(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.j=l,await this.b?.setVerboseLogging(l)}r(l){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${l}`})}s(l){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$wp=h;class $ extends h{constructor(l,w,S){super(l,w,S,{type:"node.js",restartOnError:!1})}}e.$xp=$;class g extends h{constructor(l,w,S){super(l,w,S,{type:"universal",restartOnError:!0})}}e.$yp=g;function p(d){return d.map(l=>({type:l.type,resource:D.URI.file(l.path)}))}e.$zp=p;function u(d){const l=new c;for(const w of d)l.processEvent(w);return l.coalesce()}e.$Ap=u;function y(d,l){return typeof l=="string"&&!l.startsWith(k.$aj)&&!(0,s.$7c)(l)?{base:d,pattern:l}:l}e.$Bp=y;function v(d,l){const w=[];for(const S of l)w.push((0,k.$ej)(y(d,S)));return w}e.$Cp=v;class c{constructor(){this.a=new Set,this.b=new Map}c(l){return M.$k?l.path:l.path.toLowerCase()}processEvent(l){const w=this.b.get(this.c(l));let S=!1;if(w){const m=w.type,t=l.type;w.path!==l.path&&(l.type===2||l.type===1)?S=!0:m===1&&t===2?(this.b.delete(this.c(l)),this.a.delete(w)):m===2&&t===1?w.type=0:m===1&&t===0||(w.type=t)}else S=!0;S&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],w=[];return Array.from(this.a).filter(S=>S.type!==2?(l.push(S),!1):!0).sort((S,m)=>S.path.length-m.path.length).filter(S=>w.some(m=>(0,E.$_j)(S.path,m,!M.$k))?!1:(w.push(S.path),!0)).concat(l)}}}),define(te[211],ie([0,1,45,8,23,32,2,86,9,4,106,21,77]),function(H,e,k,O,s,M,D,E,f,h,$,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class u extends D.$lb{static{this.a=100}static{this.b=75}constructor(c,d,l,w){super(),this.j=c,this.k=d,this.l=l,this.m=w,this.c=this.B(new O.$Jg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new O.$Ig(S=>this.u(S),u.b)),this.g=(0,p.$Cp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.$Cp)(this.j.path,this.j.includes):void 0,this.i=new s.$oc,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const d=await g.Promises.stat(c);this.B(await this.s(c,d.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let d=c.path;try{d=await g.Promises.realpath(c.path),c.path===d&&(d=await(0,$.$Mp)(c.path)??c.path),c.path!==d&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${d})`)}catch{}return d}async s(c,d){if(h.$j&&(0,M.$He)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$lb.None;const l=new s.$oc(this.i.token),w=new D.$kb;try{const S=(0,f.$_c)(c),m=(0,k.watch)(c);w.add((0,D.$jb)(()=>{m.removeAllListeners(),m.close()})),this.z(`Started watching: '${c}'`);const t=new Set;if(d)try{for(const r of await g.Promises.readdir(c))t.add(r)}catch(r){this.w(r)}const a=new Map;w.add((0,D.$jb)(()=>{for(const[,r]of a)r.dispose();a.clear()})),m.on("error",(r,i)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),m.on("change",(r,i)=>{if(l.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${i}`);let n="";if(i&&(n=i.toString(),h.$j&&(n=(0,E.$7k)(n))),!(!n||r!=="change"&&r!=="rename"))if(d)if(r==="rename"){a.get(n)?.dispose();const o=setTimeout(async()=>{if(a.delete(n),n===S&&!await g.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.v((0,f.$8c)(c,n));if(l.token.isCancellationRequested)return;let I;b?t.has(n)?I=0:(I=1,t.add(n)):(t.delete(n),I=2),this.t({path:(0,f.$8c)(this.j.path,n),type:I})},u.a);a.set(n,(0,D.$jb)(()=>clearTimeout(o)))}else{let o;t.has(n)?o=0:(o=1,t.add(n)),this.t({path:(0,f.$8c)(this.j.path,n),type:o})}else if(r==="rename"||n!==S){const o=setTimeout(async()=>{const b=await g.Promises.exists(c);l.token.isCancellationRequested||(b?(this.t({path:this.j.path,type:0},!0),w.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},u.a);w.clear(),w.add((0,D.$jb)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await g.Promises.exists(c)&&!l.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${S.toString()})`)}return(0,D.$jb)(()=>{l.dispose(!0),w.dispose()})}t(c,d=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!d&&this.g.some(l=>l(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!d&&this.h&&this.h.length>0&&!this.h.some(l=>l(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const d=(0,p.$Ap)(c);if(d.length>0){if(this.m)for(const w of d)this.z(`>> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`);this.c.work(d)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if(h.$k)return g.Promises.exists(c);try{const d=(0,f.$_c)(c);return(await g.Promises.readdir((0,f.$$c)(c))).some(w=>w===d)}catch(d){return this.z(d),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Pp=u;async function y(v,c,d,l,w=512){const S=await g.Promises.open(v,"r"),m=Buffer.allocUnsafe(w),t=new s.$oc(l);let a,r=!1;const i={path:v,excludes:[],recursive:!1},n=new u(i,o=>{(async()=>{for(const{type:b}of o)if(b===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await g.Promises.read(S,m,0,w,null);if(!I||t.token.isCancellationRequested)break;c(m.slice(0,I))}}catch(I){a=new Error(I),t.dispose(!0)}finally{r=!1}}})()});return await n.ready,d(),new Promise((o,b)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await g.Promises.close(S)}catch(I){a=new Error(I)}a?b(a):o()})})}e.$Qp=y}),define(te[212],ie([0,1,3,105,2,4,211]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class E extends s.$lb{constructor(){super(...arguments),this.a=this.B(new k.$ec),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$ec),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(h){const $=this.i(h),g=$.filter(u=>{const y=this.c.get(u.path);return y?!(0,O.$ij)(y.request.excludes,u.excludes)||!(0,O.$ij)(y.request.includes,u.includes):!0}),p=Array.from(this.c.values()).filter(({request:u})=>!$.find(y=>y.path===u.path&&(0,O.$ij)(y.excludes,u.excludes)&&(0,O.$ij)(y.includes,u.includes))).map(({request:u})=>u.path);g.length&&this.j(`Request to start watching: ${g.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const u of p)this.h(u);for(const u of g)this.g(u)}g(h){const $=new D.$Pp(h,p=>this.a.fire(p),p=>this.b.fire(p),this.f),g={request:h,instance:$};this.c.set(h.path,g)}async stop(){for(const[h]of this.c)this.h(h);this.c.clear()}h(h){const $=this.c.get(h);$&&(this.c.delete(h),$.instance.dispose())}i(h){const $=new Map;for(const g of h){const p=M.$k?g.path:g.path.toLowerCase();$.set(p,g)}return Array.from($.values())}async setVerboseLogging(h){this.f=h;for(const[,$]of this.c)$.instance.setVerboseLogging(h)}j(h){this.f&&this.b.fire({type:"trace",message:this.k(h)})}k(h,$){return $?`[File Watcher (node.js)] ${h} (path: ${$.request.path})`:`[File Watcher (node.js)] ${h}`}}e.$Rp=E}),define(te[213],ie([0,1,77,212]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class s extends k.$xp{constructor(D,E,f){super(D,E,f),this.m()}l(){return new O.$Rp}}e.$Sp=s}),define(te[214],ie([0,1,15,42,158,77]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class D extends M.$yp{constructor(f,h,$){super(f,h,$),this.m()}l(f){const h=f.add(new s.$Jp(k.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(h.onDidProcessExit(({code:$,signal:g})=>this.n(`terminated by itself with code ${$}, signal: ${g}`))),O.ProxyChannel.toService((0,O.$9g)(h.getChannel("watcher")))}}e.$Kp=D}),define(te[93],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class k{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$nh=k}),define(te[215],ie([0,1,8,13,2,75,206,6,93,102]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;const $=!1;class g extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class p{constructor(c=new f.$nh,d=!1,l,w=$){this.f=c,this.g=d,this.h=l,this.i=w,this.o=new Set,this.f.set(E.$oh,this),this._globalGraph=w?l?._globalGraph??new D.$Vp(S=>S):void 0}createChild(c){return new p(c,this.g,this,this.i)}invokeFunction(c,...d){const l=y.traceInvocation(this.i,c);let w=!1;try{return c({get:m=>{if(w)throw(0,O.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(m,l);if(!t)throw new Error(`[invokeFunction] unknown service '${m}'`);return t}},...d)}finally{w=!0,l.stop()}}createInstance(c,...d){let l,w;return c instanceof M.$mh?(l=y.traceCreation(this.i,c.ctor),w=this.j(c.ctor,c.staticArguments.concat(d),l)):(l=y.traceCreation(this.i,c),w=this.j(c,d,l)),l.stop(),w}j(c,d=[],l){const w=E._util.getServiceDependencies(c).sort((t,a)=>t.index-a.index),S=[];for(const t of w){const a=this.m(t.id,l);a||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(a)}const m=w.length>0?w[0].index:d.length;if(d.length!==m){console.trace(`[createInstance] First service dependency of ${c.name} at position ${m+1} conflicts with ${d.length} static arguments`);const t=m-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,m)}return Reflect.construct(c,d.concat(S))}k(c,d){if(this.f.get(c)instanceof M.$mh)this.f.set(c,d);else if(this.h)this.h.k(c,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const d=this.f.get(c);return!d&&this.h?this.h.l(c):d}m(c,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const l=this.l(c);return l instanceof M.$mh?this.q(c,l,d.branch(c,!0)):(d.branch(c,!1),l)}q(c,d,l){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,d,l)}finally{this.o.delete(c)}}r(c,d,l){const w=new D.$Vp(t=>t.id.toString());let S=0;const m=[{id:c,desc:d,_trace:l}];for(;m.length;){const t=m.pop();if(w.lookupOrInsertNode(t),S++>1e3)throw new g(w);for(const a of E._util.getServiceDependencies(t.desc.ctor)){const r=this.l(a.id);if(r||this.u(`[createInstance] ${c} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),r instanceof M.$mh){const i={id:a.id,desc:r,_trace:t._trace.branch(a.id,!0)};w.insertEdge(t,i),m.push(i)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new g(w);break}for(const{data:a}of t){if(this.l(a.id)instanceof M.$mh){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}w.removeNode(a)}}return this.l(c)}s(c,d,l=[],w,S){if(this.f.get(c)instanceof M.$mh)return this.t(c,d,l,w,S);if(this.h)return this.h.s(c,d,l,w,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(c,d,l=[],w,S){if(w){const m=new p(void 0,this.g,this,this.i);m.c=String(c);const t=new Map,a=new k.$Lg(()=>{const r=m.j(d,l,S);for(const[i,n]of t){const o=r[i];if(typeof o=="function")for(const b of n)o.apply(r,b)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new h.$ub,t.set(i,b)),(A,P,C)=>{const j=b.push([A,P,C]);return(0,s.$jb)(j)}}if(i in r)return r[i];const n=a.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),r[i]=o),o},set(r,i,n){return a.value[i]=n,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,l,S)}u(c,d){if(d&&console.warn(c),this.g)throw new Error(c)}}e.$Wp=p;var u;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(u||(u={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,d){return c?new y(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(c,d){return c?new y(1,d.name):y.c}static{this.f=0}constructor(c,d){this.type=c,this.name=d,this.g=Date.now(),this.h=[]}branch(c,d){const l=new y(3,c.toString());return this.h.push([c,d,l]),l}stop(){const c=Date.now()-this.g;y.f+=c;let d=!1;function l(S,m){const t=[],a=new Array(S+1).join("	");for(const[r,i,n]of m.h)if(i&&n){d=!0,t.push(`${a}CREATES -> ${r}`);const o=l(S+1,n);o&&t.push(o)}else t.push(`${a}uses -> ${r}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(c>2||d)&&y.all.add(w.join(`
`))}}e.$Xp=y}),define(te[216],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isb=e.IssueType=void 0;var O;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(O||(e.IssueType=O={})),e.$Isb=(0,k.$ph)("issueService")}),define(te[5],ie([0,1,50,3,57,2,35,4,19,12,7,115,6]),function(H,e,k,O,s,M,D,E,f,h,$,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,p.$ph)("logService"),e.$Si=(0,p.$ph)("loggerService");function u(){return new Date().toISOString()}function y(A){return(0,h.$me)(A)}e.$Ti=y;var v;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$Ui=v.Info;function c(A,P,C){switch(P){case v.Trace:A.trace(C);break;case v.Debug:A.debug(C);break;case v.Info:A.info(C);break;case v.Warning:A.warn(C);break;case v.Error:A.error(C);break;case v.Off:break;default:throw new Error(`Invalid log level ${P}`)}}e.log=c;function d(A,P=!1){let C="";for(let j=0;j<A.length;j++){let U=A[j];if(U instanceof Error&&(U=(0,k.$ai)(U,P)),typeof U=="object")try{U=JSON.stringify(U)}catch{}C+=(j>0?" ":"")+U}return C}class l extends M.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new O.$ec),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==v.Off&&this.b<=P}}e.$Wi=l;class w extends l{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...C){this.f(v.Trace)&&this.g(v.Trace,d([P,...C],!0))}debug(P,...C){this.f(v.Debug)&&this.g(v.Debug,d([P,...C]))}info(P,...C){this.f(v.Info)&&this.g(v.Info,d([P,...C]))}warn(P,...C){this.f(v.Warning)&&this.g(v.Warning,d([P,...C]))}error(P,...C){if(this.f(v.Error))if(P instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=P.stack,this.g(v.Error,d(j))}else this.g(v.Error,d([P,...C]))}flush(){}}e.$Xi=w;class S extends l{constructor(P=e.$Ui){super(),this.setLevel(P),this.g=!E.$i}trace(P,...C){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,P,...C):console.log(`[main ${u()}]`,P,...C))}debug(P,...C){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,P,...C):console.log(`[main ${u()}]`,P,...C))}info(P,...C){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,P,...C):console.log(`[main ${u()}]`,P,...C))}warn(P,...C){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,P,...C):console.warn(`[main ${u()}]`,P,...C))}error(P,...C){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,P,...C):console.error(`[main ${u()}]`,P,...C))}dispose(){}flush(){}}e.$Yi=S;class m extends l{constructor(P=e.$Ui,C=!0){super(),this.g=C,this.setLevel(P)}trace(P,...C){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...C):console.log(P,...C))}debug(P,...C){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...C):console.log(P,...C))}info(P,...C){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...C):console.log(P,...C))}warn(P,...C){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...C):console.log(P,...C))}error(P,...C){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...C):console.error(P,...C))}dispose(){}flush(){}}e.$Zi=m;class t extends l{constructor(P,C=e.$Ui){super(),this.g=P,this.setLevel(C)}trace(P,...C){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(P),...C])}debug(P,...C){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(P),...C])}info(P,...C){this.f(v.Info)&&this.g.log(v.Info,[this.h(P),...C])}warn(P,...C){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(P),...C])}error(P,...C){this.f(v.Error)&&this.g.log(v.Error,[this.h(P),...C])}h(P){return typeof P=="string"?P:(0,k.$ai)(P,this.f(v.Trace))}dispose(){}flush(){}}e.$1i=t;class a extends l{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const C of this.g)C.setLevel(P);super.setLevel(P)}trace(P,...C){for(const j of this.g)j.trace(P,...C)}debug(P,...C){for(const j of this.g)j.debug(P,...C)}info(P,...C){for(const j of this.g)j.info(P,...C)}warn(P,...C){for(const j of this.g)j.warn(P,...C)}error(P,...C){for(const j of this.g)j.error(P,...C)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose()}}e.$2i=a;class r extends M.$lb{constructor(P,C,j){if(super(),this.h=P,this.j=C,this.b=new D.$ni,this.c=this.B(new O.$ec),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$ec),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$ec),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}k(P){return(0,h.$ie)(P)?[...this.b.values()].find(C=>C.info.id===P):this.b.get(P)}getLogger(P){return this.k(P)?.logger}createLogger(P,C){const j=this.l(P),U=(0,h.$ie)(P)?P:C?.id??(0,s.$di)(j.toString()).toString(16);let W=this.b.get(j)?.logger;const re=C?.logLevel==="always"?v.Trace:C?.logLevel;W||(W=this.m(j,re??this.getLogLevel(j)??this.h,{...C,id:U}));const ne={logger:W,info:{resource:j,id:U,logLevel:re,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(ne.info),this.b.set(j,ne),W}l(P){return(0,h.$ie)(P)?(0,f.$9f)(this.j,`${P}.log`):P}setLogLevel(P,C){if($.URI.isUri(P)){const j=P,U=C,W=this.b.get(j);W&&U!==W.info.logLevel&&(W.info.logLevel=U===this.h?void 0:U,W.logger?.setLevel(U),this.b.set(W.info.resource,W),this.f.fire([j,U]))}else{this.h=P;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,C){const j=this.k(P);j&&C!==!j.info.hidden&&(j.info.hidden=!C,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,C]))}getLogLevel(P){let C;return P&&(C=this.b.get(P)?.info.logLevel),C??this.h}registerLogger(P){const C=this.b.get(P.resource);C?C.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const C=this.b.get(P);C&&(C.logger&&C.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=r;class i{constructor(){this.onDidChangeLogLevel=new O.$ec().event}setLevel(P){}getLevel(){return v.Info}trace(P,...C){}debug(P,...C){}info(P,...C){}warn(P,...C){}error(P,...C){}critical(P,...C){}dispose(){}flush(){}}e.$4i=i;class n extends i{}e.$5i=n;function o(A){if(A.verbose)return v.Trace;if(typeof A.logLevel=="string"){const P=I(A.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Ui}e.$6i=o;function b(A){switch(A){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$7i=b;function I(A){switch(A){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$8i=I,e.$9i=new g.$Oi("logLevel",b(v.Info))});var Q=this&&this.__param||function(H,e){return function(k,O){e(k,O,H)}};define(te[217],ie([0,1,76,3,2,5,4,8]),function(H,e,k,O,s,M,D,E){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0;let h=class extends s.$lb{static{f=this}static{this.a=2500}static{this.b=f.a-100}constructor(g){super(),this.h=g,this.c=this.B(new O.$ec),this.onDidChangePassword=this.c.event,this.g=new E.$qg}async getPassword(g,p){this.h.trace("Going to get password from keytar:",g,p);let u;try{u=await this.i()}catch{return null}return await this.g.queue(g+p,()=>this.k(u,g,p))}async k(g,p,u){this.h.trace("Doing get password from keytar:",p,u);const y=await(0,E.$Mg)(()=>g.getPassword(p,u),50,3);if(!y)return this.h.trace("Did not get a password from keytar for account:",u),y;let v,c;try{const d=JSON.parse(y);v=d.content,c=d.hasNextChunk}catch{}if(!v||!c)return this.h.trace("Got password from keytar for account:",u),y;try{let d=1;for(;c;){const l=await(0,E.$Mg)(()=>g.getPassword(p,`${u}-${d}`),50,3),w=JSON.parse(l);v+=w.content,c=w.hasNextChunk,d++}return this.h.trace(`Got ${d}-chunked password from keytar for account:`,u),v}catch(d){return this.h.error(d),y}}async setPassword(g,p,u){this.h.trace("Going to set password using keytar:",g,p);let y;try{y=await this.i()}catch(v){throw this.j?.(v),v}await this.g.queue(g+p,()=>this.l(y,g,p,u)),this.c.fire({service:g,account:p})}async l(g,p,u,y){if(this.h.trace("Doing set password from keytar:",p,u),!D.$i){await(0,E.$Mg)(()=>g.setPassword(p,u,y),50,3),this.h.trace("Set password from keytar for account:",u);return}if(await this.m(g,p,u),y.length<=f.b){await(0,E.$Mg)(()=>g.setPassword(p,u,y),50,3),this.h.trace("Set password from keytar for account:",u);return}let v=0,c=0,d=!0;for(;d;){const l=y.substring(v,v+f.b);v+=f.b,d=y.length-v>0;const w={content:l,hasNextChunk:d};await(0,E.$Mg)(()=>g.setPassword(p,c?`${u}-${c}`:u,JSON.stringify(w)),50,3),c++}this.h.trace(`Set${c?` ${c}-chunked`:""} password from keytar for account:`,u)}async deletePassword(g,p){this.h.trace("Going to delete password using keytar:",g,p);let u;try{u=await this.i()}catch(v){throw this.j?.(v),v}const y=await this.g.queue(g+p,()=>this.m(u,g,p));return y&&this.c.fire({service:g,account:p}),y}async m(g,p,u){this.h.trace("Doing delete password from keytar:",p,u);const y=await g.getPassword(p,u);if(!y)return this.h.trace("Did not get a password to delete from keytar for account:",u),!1;let v,c;try{const l=JSON.parse(y);v=l.content,c=l.hasNextChunk}catch{}let d=0;if(v&&c)try{for(d++;c;){const l=`${u}-${d}`,w=await g.getPassword(p,l);await g.deletePassword(p,l),c=JSON.parse(w).hasNextChunk,d++}}catch(l){this.h.error(l)}return await g.deletePassword(p,u)?(this.h.trace(`Deleted${d?` ${d}-chunked`:""} password from keytar for account:`,u),!0):(this.h.trace(`Keytar failed to delete${d?` ${d}-chunked`:""} password for account:`,u),!1)}async findPassword(g){let p;try{p=await this.i()}catch{return null}return await p.findPassword(g)}async findCredentials(g){let p;try{p=await this.i()}catch{return[]}return await p.findCredentials(g)}clear(){return this.f instanceof k.$pn?this.f.clear():Promise.resolve()}};e.$qn=h,e.$qn=h=f=ke([Q(0,M.$Ri)],h)}),define(te[218],ie([0,1,14,4,5]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b5b=void 0;const M=k.safeStorage;let D=class{constructor(f){this.a=f,k.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const h=JSON.stringify(M.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),h}catch(h){throw this.a.error(h),h}}async decrypt(f){let h;try{if(h=JSON.parse(f),!h.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const $=Buffer.from(h.data);this.a.trace("[EncryptionMainService] Decrypting value.");const g=M.decryptString($);return this.a.trace("[EncryptionMainService] Decrypted value."),g}catch($){throw this.a.error($),$}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(O.$i)return Promise.resolve("dpapi");if(O.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const f=M.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(O.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(O.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$b5b=D,e.$b5b=D=ke([Q(0,s.$Ri)],D)}),define(te[219],ie([0,1,24,8,13,3,2,9,77,5]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class $ extends D.$lb{constructor(p,u){super(),this.a=p,this.b=u,this.c=this.B(new M.$ec),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$ec),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.$sg(0)),this.s=[],this.t=this.B(new O.$sg(0))}watch(p,u){return u.recursive||this.b?.watcher?.forceUniversal?this.l(p,u):this.u(p,u)}l(p,u){const y={path:this.C(p),excludes:u.excludes,includes:u.includes,recursive:u.recursive},v=(0,k.$yf)(this.j,y);return this.m(),(0,D.$jb)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,s.$Y)(p))}n(){this.h||(this.h=this.B(this.p(u=>this.c.fire((0,f.$zp)(u)),u=>this.z(u),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const u of this.j)(0,f.$vp)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const u of this.j)(0,f.$vp)(u)&&p.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,u){const y={path:this.C(p),excludes:u.excludes,includes:u.includes,recursive:!1},v=(0,k.$yf)(this.s,y);return this.v(),(0,D.$jb)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,s.$Y)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,f.$zp)(p)),p=>this.z(p),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,E.$6c)(p.fsPath)}}e.$Dp=$}),define(te[220],ie([0,1,24,8,17,23,3,57,68,2,58,15,65,19,56,173,16,119,5,13]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let S=class extends h.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.$ec),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$ec),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$ec),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.$ec),this.onDidRunOperation=this.m.event,this.R=this.B(new D.$ec),this.onDidFilesChange=this.R.event,this.S=this.B(new D.$ec),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.$Dg)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const r=new h.$kb;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),r.add(a.onDidChangeFile(i=>this.R.fire(new c.$$j(i,!this.O(a))))),typeof a.onDidWatchError=="function"&&r.add(a.onDidWatchError(i=>this.S.fire(new Error(i)))),r.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,h.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,h.$gb)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(r){a.push(r)}}),!this.h.has(t)&&await O.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&a)}listCapabilities(){return f.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,u.$ag)(t))throw new c.$ak((0,v.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const r=new w.$ab;throw r.message=(0,v.localize)(1,null,t.toString()),r}return a}async k(t){const a=await this.j(t);if((0,c.$Xj)(a)||(0,c.$Uj)(a)||(0,c.$Yj)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,c.$Xj)(a)||(0,c.$Uj)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(r){throw(0,c.$8j)(r)===c.FileSystemProviderErrorCode.FileNotFound?new c.$ak((0,v.localize)(2,null,this.nb(t)),1):(0,c.$6j)(r)}}async n(t,a){const r=await this.j(t),i=this.O(r),n=a?.resolveTo,o=a?.resolveSingleChildDescendants,b=a?.resolveMetadata,I=await r.stat(t);let A;return this.p(r,t,I,void 0,!!b,(P,C)=>(A||(A=$.$vh.forUris(()=>!i),A.set(t,!0),n&&A.fill(!0,n)),A.get(P.resource)||A.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&o?C===1:!1))}async p(t,a,r,i,n,o){const{providerExtUri:b}=this.N(t),I={resource:a,name:b.basename(a),isFile:(r.type&c.FileType.File)!==0,isDirectory:(r.type&c.FileType.Directory)!==0,isSymbolicLink:(r.type&c.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&c.FilePermission.Locked),etag:(0,c.$lk)({mtime:r.mtime,size:r.size}),children:void 0};if(I.isDirectory&&o(I,i)){try{const A=await t.readdir(a),P=await O.Promises.settled(A.map(async([C,j])=>{try{const U=b.joinPath(a,C),W=n?await t.stat(U):{type:j};return await this.p(t,U,W,A.length,n,o)}catch(U){return this.b.trace(U),null}}));I.children=(0,k.$jf)(P)}catch(A){this.b.trace(A),I.children=[]}return I}return I}async resolveAll(t){return O.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),r=await a.stat(t);return this.p(a,t,r,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(r){return r}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new c.$ak((0,v.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=s.$Ec.fromString(""),r){await this.r(t,r);const i=await this.writeFile(t,a);return this.m.fire(new c.$0j(t,0,i)),i}async writeFile(t,a,r){const i=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(i);try{await this.s(i,t,r)||await this.P(i,n.dirname(t));let b;if((0,c.$Uj)(i)&&!(a instanceof s.$Ec))if((0,y.$qc)(a)){const I=await(0,y.$xc)(a,3);I.ended?b=s.$Ec.concat(I.buffer):b=I}else b=(0,y.$uc)(a,I=>s.$Ec.concat(I),3);else b=a;if(!(0,c.$Xj)(i)||(0,c.$Uj)(i)&&b instanceof s.$Ec)await this.cb(i,t,r,b);else{const I=b instanceof s.$Ec?(0,s.$Pc)(b):b;r?.atomic!==!1&&r?.atomic?.postfix?await this.Y(i,t,(0,u.$9f)((0,u.$8f)(t),`${(0,u.$6f)(t)}${r.atomic.postfix}`),r,I):await this.Z(i,t,r,I)}this.m.fire(new c.$0j(t,4))}catch(o){throw new c.$ak((0,v.localize)(4,null,this.nb(t),(0,c.$6j)(o).toString()),(0,c.$9j)(o),r)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(a)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,v.localize)(6,null,this.nb(a)));if(i)throw new Error((0,v.localize)(7,null,this.nb(a)))}let o;try{o=await t.stat(a)}catch{return}if(o.type&c.FileType.Directory)throw new c.$ak((0,v.localize)(8,null,this.nb(a)),0,r);if(this.mb(a,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==c.$kk&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,c.$lk)({mtime:r.mtime,size:o.size}))throw new c.$ak((0,v.localize)(9,null),3,r);return o}async readFile(t,a,r){const i=await this.k(t);return a?.atomic?this.t(i,t,a,r):this.u(i,t,a,r)}async t(t,a,r,i){return new Promise((n,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const b=await this.u(t,a,r,i);n(b)}catch(b){o(b)}})})}async u(t,a,r,i){const n=await this.v(t,a,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$Qc)(n.value)}}async readFileStream(t,a,r){const i=await this.k(t);return this.v(i,t,a,r)}async v(t,a,r,i){const n=new M.$oc(i),o=this.F(a,r).then(I=>I,I=>{throw n.cancel(),I});let b;try{return typeof r?.etag=="string"&&r.etag!==c.$kk&&await o,r?.atomic&&(0,c.$Zj)(t)||!((0,c.$Xj)(t)||(0,c.$Yj)(t))||(0,c.$Uj)(t)&&r?.preferUnbuffered?b=this.D(t,a,r):(0,c.$Yj)(t)?b=this.z(t,a,n.token,r):b=this.C(t,a,n.token,r),{...await o,value:b}}catch(I){throw b&&await(0,y.$vc)(b),this.w(I,a,r)}}w(t,a,r){const i=(0,v.localize)(10,null,this.nb(a),(0,c.$6j)(t).toString());return t instanceof c.$ck?new c.$ck(i,t.stat,r):t instanceof c.$bk?new c.$bk(i,t.fileOperationResult,t.size,t.options):new c.$ak(i,(0,c.$9j)(t),r)}z(t,a,r,i=Object.create(null)){const n=t.readFileStream(a,i,r);return(0,y.$Bc)(n,{data:o=>o instanceof s.$Ec?o:s.$Ec.wrap(o),error:o=>this.w(o,a,i)},o=>s.$Ec.concat(o))}C(t,a,r,i=Object.create(null)){const n=(0,s.$Uc)();return(0,d.$tp)(t,a,n,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.w(o,a,i)},r),n}D(t,a,r){const i=(0,y.$sc)(n=>s.$Ec.concat(n));return(async()=>{try{let n;r?.atomic&&(0,c.$Zj)(t)?n=await t.readFile(a,{atomic:!0}):n=await t.readFile(a),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.G(a,n.byteLength,r),i.end(s.$Ec.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async F(t,a){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new c.$ak((0,v.localize)(11,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==c.$kk&&a.etag===r.etag)throw new c.$ck((0,v.localize)(12,null),r,a);return this.G(t,r.size,a),r}G(t,a,r){if(typeof r?.limits?.size=="number"&&a>r.limits.size)throw new c.$bk((0,v.localize)(13,null,this.nb(t)),7,a,r)}async canMove(t,a,r){return this.H(t,a,"move",r)}async canCopy(t,a,r){return this.H(t,a,"copy",r)}async H(t,a,r,i){if(t.toString()!==a.toString())try{const n=r==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(n,t,o,a,r,i)}catch(n){return n}return!0}async move(t,a,r){const i=this.lb(await this.l(t),t),n=this.lb(await this.l(a),a),o=await this.I(i,t,n,a,"move",!!r),b=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,o==="move"?2:3,b)),b}async copy(t,a,r){const i=await this.k(t),n=this.lb(await this.l(a),a),o=await this.I(i,t,n,a,"copy",!!r),b=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,o==="copy"?3:2,b)),b}async I(t,a,r,i,n,o){if(a.toString()===i.toString())return n;const{exists:b,isSameResourceWithDifferentPathCase:I}=await this.M(t,a,r,i,n,o);if(b&&!I&&o&&await this.del(i,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,c.$Vj)(t))await t.copy(a,i,{overwrite:o});else{const A=await this.resolve(a);A.isDirectory?await this.L(t,A,r,i):await this.J(t,a,r,i)}return n}else return t===r?(await t.rename(a,i,{overwrite:o}),n):(await this.I(t,a,r,i,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,r,i){if((0,c.$Xj)(t)&&(0,c.$Xj)(r))return this.eb(t,a,r,i);if((0,c.$Xj)(t)&&(0,c.$Uj)(r))return this.kb(t,a,r,i);if((0,c.$Uj)(t)&&(0,c.$Xj)(r))return this.ib(t,a,r,i);if((0,c.$Uj)(t)&&(0,c.$Uj)(r))return this.gb(t,a,r,i)}async L(t,a,r,i){await r.mkdir(i),Array.isArray(a.children)&&await O.Promises.settled(a.children.map(async n=>{const o=this.N(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),r,o):this.J(t,n.resource,r,o)}))}async M(t,a,r,i,n,o){let b=!1;if(t===r){const{providerExtUri:A,isPathCaseSensitive:P}=this.N(t);if(P||(b=A.isEqual(a,i)),b&&n==="copy")throw new Error((0,v.localize)(14,null,this.nb(a),this.nb(i)));if(!b&&A.isEqualOrParent(i,a))throw new Error((0,v.localize)(15,null,this.nb(a),this.nb(i)))}const I=await this.exists(i);if(I&&!b){if(!o)throw new c.$ak((0,v.localize)(16,null,this.nb(a),this.nb(i)),4);if(t===r){const{providerExtUri:A}=this.N(t);if(A.isEqualOrParent(a,i))throw new Error((0,v.localize)(17,null,this.nb(a),this.nb(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:b}}N(t){const a=this.O(t);return{providerExtUri:a?u.$Yf:u.$1f,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,0,r)),r}async P(t,a){const r=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(a,i.dirname(a));)try{if(!((await t.stat(a)).type&c.FileType.Directory))throw new Error((0,v.localize)(18,null,this.nb(a)));break}catch(n){if((0,c.$8j)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(a)),a=i.dirname(a)}for(let n=r.length-1;n>=0;n--){a=i.joinPath(a,r[n]);try{await t.mkdir(a)}catch(o){if((0,c.$8j)(o)!==c.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(r){return r}return!0}async Q(t,a){const r=this.lb(await this.j(t),t),i=!!a?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,v.localize)(19,null,this.nb(t)));const n=a?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,v.localize)(20,null,this.nb(t)));if(i&&n)throw new Error((0,v.localize)(21,null,this.nb(t)));let o;try{o=await r.stat(t)}catch{}if(o)this.mb(t,o);else throw new c.$ak((0,v.localize)(22,null,this.nb(t)),1);if(!!!a?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,v.localize)(23,null,this.nb(t)))}return r}async del(t,a){const r=await this.Q(t,a),i=!!a?.useTrash,n=!!a?.recursive,o=a?.atomic??!1;await r.delete(t,{recursive:n,useTrash:i,atomic:o}),this.m.fire(new c.$0j(t,1))}async cloneFile(t,a){const r=await this.j(t),i=this.lb(await this.l(a),a);if(r===i&&this.N(r).providerExtUri.isEqual(t,a))return;if(r===i&&(0,c.$Wj)(r))return r.cloneFile(t,a);await this.P(i,this.N(i).providerExtUri.dirname(a));const n=this.X.queueFor(t,this.N(r).providerExtUri);return r===i&&(0,c.$Vj)(r)?n.queue(()=>r.copy(t,a,{overwrite:!0})):n.queue(()=>this.J(r,t,i,a))}watch(t,a={recursive:!1,excludes:[]}){const r=new h.$kb;let i=!1,n=()=>{i=!0};return r.add((0,h.$jb)(()=>n())),(async()=>{try{const o=await this.W(t,a);i?(0,h.$gb)(o):n=()=>(0,h.$gb)(o)}catch(o){this.b.error(o)}})(),r}async W(t,a){const r=await this.j(t),i=(0,E.$di)([this.N(r).providerExtUri.getComparisonKey(t),a]);let n=this.U.get(i);return n||(n={count:0,disposable:r.watch(t,a)},this.U.set(i,n)),n.count+=1,(0,h.$jb)(()=>{n&&(n.count--,n.count===0&&((0,h.$gb)(n.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,h.$gb)(t.disposable);this.U.clear()}async Y(t,a,r,i,n){await this.Z(t,r,i,n);try{await t.rename(r,a,{overwrite:!0})}catch(o){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(t,a,r,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(a,{create:!0,unlock:r?.unlock??!1});try{(0,y.$qc)(i)||(0,y.$rc)(i)?await this.$(t,n,i):await this.ab(t,n,i)}catch(o){throw(0,c.$6j)(o)}finally{await t.close(n)}})}async $(t,a,r){let i=0,n;if((0,y.$rc)(r)){if(r.buffer.length>0){const o=s.$Ec.concat(r.buffer);await this.bb(t,a,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,b)=>{(0,y.$wc)(n,{onData:async I=>{n.pause();try{await this.bb(t,a,I,I.byteLength,i,0)}catch(A){return b(A)}i+=I.byteLength,setTimeout(()=>n.resume())},onError:I=>b(I),onEnd:()=>o()})})}async ab(t,a,r){let i=0,n;for(;(n=r.read())!==null;)await this.bb(t,a,n,n.byteLength,i,0),i+=n.byteLength}async bb(t,a,r,i,n,o){let b=0;for(;b<i;){const I=await t.write(a,n+b,r.buffer,o+b,i-b);b+=I}}async cb(t,a,r,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,r,i))}async db(t,a,r,i){let n;i instanceof s.$Ec?n=i:(0,y.$qc)(i)?n=await(0,s.$Qc)(i):(0,y.$rc)(i)?n=await(0,s.$Rc)(i):n=(0,s.$Oc)(i),await t.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async eb(t,a,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.fb(t,a,r,i))}async fb(t,a,r,i){let n,o;try{n=await t.open(a,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const b=s.$Ec.alloc(this.a);let I=0,A=0,P=0;do P=await t.read(n,I,b.buffer,A,b.byteLength-A),await this.bb(r,o,b,P,I,A),I+=P,A+=P,A===b.byteLength&&(A=0);while(P>0)}catch(b){throw(0,c.$6j)(b)}finally{await O.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async gb(t,a,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.hb(t,a,r,i))}async hb(t,a,r,i){return r.writeFile(i,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,a,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.jb(t,a,r,i))}async jb(t,a,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(r,n,s.$Ec.wrap(o),o.byteLength,0,0)}catch(o){throw(0,c.$6j)(o)}finally{await r.close(n)}}async kb(t,a,r,i){const n=await(0,s.$Qc)(this.C(t,a,M.CancellationToken.None));await this.cb(r,i,void 0,n)}lb(t,a){if(t.capabilities&2048)throw new c.$ak((0,v.localize)(24,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&c.FilePermission.Readonly)throw new c.$ak((0,v.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===g.Schemas.file?t.fsPath:t.toString(!0)}};e.$up=S,e.$up=S=ke([Q(0,l.$Ri)],S)}),define(te[94],ie([0,1,45,310,8,35,17,3,32,2,9,4,19,56,21,177,16,119,219,50,214,213]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0,(()=>{try{(0,O.gracefulify)(k)}catch(a){console.error(`Error enabling graceful-fs: ${(0,w.$ai)(a)}`)}})();class t extends l.$Dp{static{this.D=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=E.Event.None,this.I=new M.$ni(n=>p.$Zf.getComparisonKey(n)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,g.$k&&(this.F|=1024)),this.F}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.C(r));return{type:this.H(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:c.FilePermission.Locked}}catch(i){throw this.ab(i)}}async G(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.C(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let b;o.isSymbolicLink()?b=(await this.stat((0,p.$9f)(r,o.name))).type:b=this.H(o),n.push([o.name,b])}catch(b){this.a.trace(b)}})),n}catch(i){throw this.ab(i)}}H(r,i){let n;return i?.dangling?n=c.FileType.Unknown:r.isFile()?n=c.FileType.File:r.isDirectory()?n=c.FileType.Directory:n=c.FileType.Unknown,i&&(n|=c.FileType.SymbolicLink),n}async J(r){const i=this.C(r);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.I.get(r);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new s.$tg;return this.I.set(r,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,h.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(r)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(r)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),n=await this.J(r));const o=this.C(r);return await y.Promises.readFile(o)}catch(o){throw this.ab(o)}finally{n?.dispose()}}L(r){t.D&&this.a.trace(r)}readFileStream(r,i,n){const o=(0,u.$sc)(b=>D.$Ec.concat(b.map(I=>D.$Ec.wrap(I))).buffer);return(0,d.$tp)(this,r,o,b=>b.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.M(r,(0,p.$9f)((0,p.$8f)(r),`${(0,p.$6f)(r)}${n.atomic.postfix}`),i,n):this.N(r,i,n)}async M(r,i,n,o){await this.N(i,n,o);try{await this.rename(i,r,{overwrite:!0})}catch(b){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}async N(r,i,n){let o;try{const b=this.C(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(b)){if(!n.overwrite)throw(0,c.$5j)((0,v.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,c.$5j)((0,v.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(b){throw await this.bb(r,b)}finally{typeof o=="number"&&await this.close(o)}}static{this.R=!0}static configureFlushOnWrite(r){t.R=r}async open(r,i){const n=this.C(r);let o;(0,c.$Tj)(i)&&(o=await this.J(r));let b;try{if((0,c.$Tj)(i)&&i.unlock)try{const{stat:A}=await y.SymlinkSupport.stat(n);A.mode&128||await y.Promises.chmod(n,A.mode|128)}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}let I;if((0,c.$Tj)(i)){if(g.$i)try{await y.Promises.truncate(n,0),I="r+"}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}I||(I="w")}else I="r";b=await y.Promises.open(n,I)}catch(I){throw o?.dispose(),(0,c.$Tj)(i)?await this.bb(r,I):this.ab(I)}if(this.O.set(b,0),(0,c.$Tj)(i)&&this.Q.set(b,r),o){const I=this.P.get(b);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${n})`),this.P.set(b,o),I&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${n})`),I.dispose())}return b}async close(r){const i=this.P.get(r);try{if(this.O.delete(r),this.Q.delete(r)&&t.R)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.ab(n)}finally{i&&(this.P.get(r)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.P.delete(r)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,o,b){const I=this.S(r,i);let A=null;try{A=(await y.Promises.read(r,n,o,b,I)).bytesRead}catch(P){throw this.ab(P)}finally{this.U(r,I,A)}return A}S(r,i){return i===this.O.get(r)?null:i}U(r,i,n){const o=this.O.get(r);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.O.set(r,o+n):this.O.delete(r)))}async write(r,i,n,o,b){return(0,s.$Mg)(()=>this.W(r,i,n,o,b),100,3)}async W(r,i,n,o,b){const I=this.S(r,i);let A=null;try{A=(await y.Promises.write(r,n,o,b,I)).bytesWritten}catch(P){throw await this.bb(this.Q.get(r),P)}finally{this.U(r,I,A)}return A}async mkdir(r){try{await y.Promises.mkdir(this.C(r))}catch(i){throw this.ab(i)}}async delete(r,i){try{const n=this.C(r);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,$.$8c)((0,$.$$c)(n),`${(0,$.$_c)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let b=!1;try{const{stat:I,symbolicLink:A}=await y.SymlinkSupport.stat(n);b=I.isDirectory()&&!A}catch{}if(b)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.ab(n)}}async rename(r,i,n){const o=this.C(r),b=this.C(i);if(o!==b)try{await this.X(r,i,"move",n.overwrite),await y.Promises.rename(o,b)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(2,null,(0,$.$_c)(o),(0,$.$_c)((0,$.$$c)(b)),I.toString()))),this.ab(I)}}async copy(r,i,n){const o=this.C(r),b=this.C(i);if(o!==b)try{await this.X(r,i,"copy",n.overwrite),await y.Promises.copy(o,b,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,v.localize)(3,null,(0,$.$_c)(o),(0,$.$_c)((0,$.$$c)(b)),I.toString()))),this.ab(I)}}async X(r,i,n,o){const b=this.C(r),I=this.C(i);let A=!1;if(!!(this.capabilities&1024)||(A=(0,f.$Ge)(b,I,!0)),A){if(n==="copy")throw(0,c.$5j)((0,v.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.G(r);if(!C)throw(0,c.$5j)((0,v.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const j=await this.G(i);if(j){if(!o)throw(0,c.$5j)((0,v.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);C.type&c.FileType.File&&j.type&c.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.Y(r,i,!1)}async Y(r,i,n){const o=this.C(r),b=this.C(i),I=!!(this.capabilities&1024);if((0,f.$Ge)(o,b,!I))return;const A=new h.$kb;try{const[P,C]=await Promise.all([this.J(r),this.J(i)]);A.add(P),A.add(C),n&&await y.Promises.mkdir((0,$.$$c)(b),{recursive:!0}),await y.Promises.copyFile(o,b)}catch(P){if(P.code==="ENOENT"&&!n)return this.Y(r,i,!0);throw this.ab(P)}finally{A.dispose()}}p(r,i,n){return new S.$Kp(o=>r(o),o=>i(o),n)}y(r,i,n){return new m.$Sp(o=>r(o),o=>i(o),n)}ab(r){if(r instanceof c.$4j)return r;let i=r,n;switch(r.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=c.FileSystemProviderErrorCode.Unknown;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.$5j)(i,n)}async bb(r,i){let n=this.ab(i);if(r&&n.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.C(r));o.mode&128||(n=(0,c.$5j)(i,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$Tp=t}),define(te[221],ie([0,1,3,94,2,17,56,23]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;class f extends s.$lb{constructor(g,p){super(),this.a=g,this.b=p,this.w=new Map,this.y=new Map}call(g,p,u){const y=this.c(g);switch(p){case"stat":return this.g(y,u[0]);case"readdir":return this.h(y,u[0]);case"open":return this.l(y,u[0],u[1]);case"close":return this.m(u[0]);case"read":return this.n(u[0],u[1],u[2]);case"readFile":return this.i(y,u[0],u[1]);case"write":return this.p(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.k(y,u[0],u[1],u[2]);case"rename":return this.t(y,u[0],u[1],u[2]);case"copy":return this.u(y,u[0],u[1],u[2]);case"cloneFile":return this.v(y,u[0],u[1]);case"mkdir":return this.r(y,u[0]);case"delete":return this.s(y,u[0],u[1]);case"watch":return this.C(y,u[0],u[1],u[2],u[3]);case"unwatch":return this.D(u[0],u[1])}throw new Error(`IPC Command ${p} not found`)}listen(g,p,u){const y=this.c(g);switch(p){case"fileChange":return this.z(y,u[0]);case"readFileStream":return this.j(y,u[0],u[1])}throw new Error(`Unknown event ${p}`)}g(g,p){const u=this.f(g,p,!0);return this.a.stat(u)}h(g,p){const u=this.f(g,p);return this.a.readdir(u)}async i(g,p,u){const y=this.f(g,p,!0),v=await this.a.readFile(y,u);return M.$Ec.wrap(v)}j(g,p,u){const y=this.f(g,p,!0),v=new E.$oc,c=new k.$ec({onDidRemoveLastListener:()=>{v.cancel()}}),d=this.a.readFileStream(y,u,v.token);return(0,D.$wc)(d,{onData:l=>c.fire(M.$Ec.wrap(l)),onError:l=>c.fire(l),onEnd:()=>{c.fire("end"),c.dispose(),v.dispose()}}),c.event}k(g,p,u,y){const v=this.f(g,p);return this.a.writeFile(v,u.buffer,y)}l(g,p,u){const y=this.f(g,p,!0);return this.a.open(y,u)}m(g){return this.a.close(g)}async n(g,p,u){const y=M.$Ec.alloc(u),v=0,c=await this.a.read(g,p,y.buffer,v,u);return[y,c]}p(g,p,u,y,v){return this.a.write(g,p,u.buffer,y,v)}r(g,p){const u=this.f(g,p);return this.a.mkdir(u)}s(g,p,u){const y=this.f(g,p);return this.a.delete(y,u)}t(g,p,u,y){const v=this.f(g,p),c=this.f(g,u);return this.a.rename(v,c,y)}u(g,p,u,y){const v=this.f(g,p),c=this.f(g,u);return this.a.copy(v,c,y)}v(g,p,u){const y=this.f(g,p),v=this.f(g,u);return this.a.cloneFile(y,v)}z(g,p){const u=new k.$ec({onWillAddFirstListener:()=>{this.w.set(p,this.F(g,u))},onDidRemoveLastListener:()=>{(0,s.$gb)(this.w.get(p)),this.w.delete(p)}});return u.event}async C(g,p,u,y,v){const c=this.w.get(p);if(c){const d=this.f(g,y),l=c.watch(u,d,v);this.y.set(p+u,l)}}async D(g,p){const u=g+p,y=this.y.get(u);y&&((0,s.$gb)(y),this.y.delete(u))}dispose(){super.dispose();for(const[,g]of this.y)g.dispose();this.y.clear();for(const[,g]of this.w)g.dispose();this.w.clear()}}e.$pr=f;class h extends s.$lb{constructor(g,p,u,y){super(),this.c=g,this.f=u,this.g=y,this.a=new Map,this.b=this.B(new O.$Tp(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(p)}h(g){const p=this.B(new k.$ec);this.B(p.event(u=>{g.fire(u.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(u=>p.fire(u))),this.B(this.b.onDidWatchError(u=>g.fire(u)))}i(g){}j(g){}watch(g,p,u){const y=this.j(this.g);return Array.isArray(y)&&(u.excludes=[...u.excludes,...y]),this.a.set(g,this.b.watch(p,u)),(0,s.$jb)(()=>{(0,s.$gb)(this.a.get(g)),this.a.delete(g)})}dispose(){super.dispose();for(const[,g]of this.a)g.dispose();this.a.clear()}}e.$qr=h}),define(te[222],ie([0,1,14,176,4,7,16,9,221,154]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=void 0;class $ extends f.$pr{constructor(u,y,v){super(u,y),this.G=v}c(u){return h.$pm}f(u,y){return M.URI.revive(y)}async s(u,y,v){if(!v.useTrash)return super.s(u,y,v);const c=this.f(u,y),d=(0,E.$6c)(c.fsPath);try{await k.shell.trashItem(d)}catch{throw(0,D.$5j)(s.$i?(0,O.localize)(0,null,(0,E.$_c)(d)):(0,O.localize)(1,null,(0,E.$_c)(d)),D.FileSystemProviderErrorCode.Unknown)}}F(u,y){return new g(u,y,this.b,this.G)}}e.$j5b=$;class g extends f.$qr{watch(u,y,v){if(v.recursive)throw(0,D.$5j)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(u,y,v)}}}),define(te[223],ie([0,1,5]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k2b=void 0;class O extends k.$Xi{constructor(M=k.$Ui){super(),this.k=[],this.l=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.l?.setLevel(D)}))}set logger(M){this.l=M;for(const{level:D,message:E}of this.k)(0,k.log)(M,D,E);this.k=[]}g(M,D){this.l?(0,k.log)(this.l,M,D):this.getLevel()<=M&&this.k.push({level:M,message:D})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.$k2b=O}),define(te[224],ie([0,1,7,3,5,2]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0;class D extends s.$3i{constructor(g,p,u,y,v){super(p,u,y),this.n=g,this.p=v,this.B(v.listen("onDidChangeLogLevel",g)(c=>{(0,s.$Ti)(c)?super.setLogLevel(c):super.setLogLevel(k.URI.revive(c[0]),c[1])})),this.B(v.listen("onDidChangeVisibility",g)(([c,d])=>super.setVisibility(k.URI.revive(c),d))),this.B(v.listen("onDidChangeLoggers",g)(({added:c,removed:d})=>{for(const l of c)super.registerLogger({...l,resource:k.URI.revive(l.resource)});for(const l of d)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new s.$1i({log:(g,p)=>{this.p.call("consoleLog",[g,p])}})}registerLogger(g){super.registerLogger(g),this.p.call("registerLogger",[g,this.n])}deregisterLogger(g){super.deregisterLogger(g),this.p.call("deregisterLogger",[g,this.n])}setLogLevel(g,p){super.setLogLevel(g,p),this.p.call("setLogLevel",[g,p])}setVisibility(g,p){super.setVisibility(g,p),this.p.call("setVisibility",[this.l(g),p])}m(g,p,u){return new E(this.p,g,p,u,this.n)}static setLogLevel(g,p,u){return g.call("setLogLevel",[p,u])}}e.$Rq=D;class E extends s.$Xi{constructor(g,p,u,y,v){super(y?.logLevel==="always"),this.m=g,this.n=p,this.k=!1,this.l=[],this.setLevel(u),this.m.call("createLogger",[p,y,v]).then(()=>{this.r(this.l),this.k=!0})}g(g,p){const u=[[g,p]];this.k?this.r(u):this.l.push(...u)}r(g){this.m.call("log",[this.n,g])}}class f{constructor(g,p){this.a=g,this.b=p}listen(g,p){const u=this.b(g);switch(p){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(v=>this.c(v,u)),removed:[...y.removed].map(v=>this.c(v,u))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,y=>[u.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$Ti)(y)?y:[u.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${p}`)}async call(g,p,u){const y=this.b(g);switch(p){case"setLogLevel":return(0,s.$Ti)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(k.URI.revive(y.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,y)))}throw new Error(`Call not found: ${p}`)}c(g,p){return{...g,resource:p.transformOutgoingURI(g.resource)}}}e.$Sq=f;class h extends M.$lb{constructor(g,p){super(),p.call("setLogLevel",[g.getLogLevel()]),this.B(g.onDidChangeLogLevel(u=>p.call("setLogLevel",[u]))),p.call("getRegisteredLoggers").then(u=>{for(const y of u)g.registerLogger({...y,resource:k.URI.revive(y.resource)})}),this.B(p.listen("onDidChangeVisibility")(([u,y])=>g.setVisibility(k.URI.revive(u),y))),this.B(p.listen("onDidChangeLoggers")(({added:u,removed:y})=>{for(const v of u)g.registerLogger({...v,resource:k.URI.revive(v.resource)});for(const v of y)g.deregisterLogger(v.resource)}))}}e.$Tq=h}),define(te[225],ie([0,1,2,5]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class s extends k.$lb{constructor(D,E=[]){super(),this.a=new O.$2i([D,...E]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...E){this.a.trace(D,...E)}debug(D,...E){this.a.debug(D,...E)}info(D,...E){this.a.info(D,...E)}warn(D,...E){this.a.warn(D,...E)}error(D,...E){this.a.error(D,...E)}flush(){this.a.flush()}}e.$9M=s}),define(te[226],ie([0,1,35,7,5]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i6b=void 0;class M{constructor(E){this.b=E,this.a=new k.$ni}listen(E,f,h){switch(f){case"onDidChangeLoggers":return h?this.b.getOnDidChangeLoggersEvent(h):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return h?this.b.getOnDidChangeLogLevelEvent(h):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return h?this.b.getOnDidChangeVisibilityEvent(h):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(E,f,h){switch(f){case"createLogger":this.c(O.URI.revive(h[0]),h[1],h[2]);return;case"log":return this.e(O.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1]);case"setLogLevel":return(0,s.$Ti)(h[0])?this.b.setLogLevel(h[0]):this.b.setLogLevel(O.URI.revive(h[0]),h[1]);case"setVisibility":return this.b.setVisibility(O.URI.revive(h[0]),h[1]);case"registerLogger":return this.b.registerLogger({...h[0],resource:O.URI.revive(h[0].resource)},h[1]);case"deregisterLogger":return this.b.deregisterLogger(O.URI.revive(h[0]))}throw new Error(`Call not found: ${f}`)}c(E,f,h){this.a.set(E,this.b.createLogger(E,f,h))}d(E,f){let h=console.log;switch(E){case s.LogLevel.Error:h=console.error;break;case s.LogLevel.Warning:h=console.warn;break;case s.LogLevel.Info:h=console.info;break}h.call(console,...f)}e(E,f){const h=this.a.get(E);if(!h)throw new Error("Create the logger before logging");for(const[$,g]of f)(0,s.log)(h,$,g)}}e.$i6b=M}),define(te[227],ie([0,1,16,5]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0;var s;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(s||(s={}));async function M(h,$,g,p,u){try{const y=await new Promise((c,d)=>{H(["@vscode/spdlog"],c,d)});y.setFlushOn(s.Trace);const v=await y.createAsyncRotatingLogger(h,$,g,p);return u?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(y){console.error(y)}return null}function D(h,$,g){switch($){case O.LogLevel.Trace:h.trace(g);break;case O.LogLevel.Debug:h.debug(g);break;case O.LogLevel.Info:h.info(g);break;case O.LogLevel.Warning:h.warn(g);break;case O.LogLevel.Error:h.error(g);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${$}`)}}function E(h,$){switch($){case O.LogLevel.Trace:h.setLevel(s.Trace);break;case O.LogLevel.Debug:h.setLevel(s.Debug);break;case O.LogLevel.Info:h.setLevel(s.Info);break;case O.LogLevel.Warning:h.setLevel(s.Warning);break;case O.LogLevel.Error:h.setLevel(s.Error);break;case O.LogLevel.Off:h.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${$}`)}}class f extends O.$Xi{constructor($,g,p,u,y){super(),this.k=[],this.setLevel(y),this.l=this.n($,g,p,u),this.B(this.onDidChangeLogLevel(v=>{this.m&&E(this.m,v)}))}async n($,g,p,u){const y=p?6:1,v=30/y*k.$nk.MB,c=await M($,g,v,y,u);if(c){this.m=c,E(this.m,this.getLevel());for(const{level:d,message:l}of this.k)D(this.m,d,l);this.k=[]}}g($,g){this.m?D(this.m,$,g):this.getLevel()<=$&&this.k.push({level:$,message:g})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$XM=f}),define(te[228],ie([0,1,31,5,227]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=void 0;class M extends O.$3i{m(E,f,h){return new s.$XM((0,k.$3e)(),E.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,f)}}e.$YM=M}),define(te[66],ie([0,1,35,3,6,5,228]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I5b=e.$H5b=void 0,e.$H5b=(0,s.$qh)(M.$Si);class E extends D.$YM{constructor(){super(...arguments),this.p=new k.$ni}createLogger(h,$,g){g!==void 0&&this.p.set(this.l(h),g);try{return super.createLogger(h,$)}catch(p){throw this.p.delete(this.l(h)),p}}registerLogger(h,$){$!==void 0&&this.p.set(h.resource,$),super.registerLogger(h)}deregisterLogger(h){this.p.delete(h),super.deregisterLogger(h)}getRegisteredLoggers(h){const $=[];for(const g of super.getRegisteredLoggers())h===this.p.get(g.resource)&&$.push(g);return $}getOnDidChangeLogLevelEvent(h){return O.Event.filter(this.onDidChangeLogLevel,$=>(0,M.$Ti)($)||this.s($[0],h))}getOnDidChangeVisibilityEvent(h){return O.Event.filter(this.onDidChangeVisibility,([$])=>this.s($,h))}getOnDidChangeLoggersEvent(h){return O.Event.filter(O.Event.map(this.onDidChangeLoggers,$=>({added:[...$.added].filter(p=>this.s(p.resource,h)),removed:[...$.removed].filter(p=>this.s(p.resource,h))})),$=>$.added.length>0||$.removed.length>0)}deregisterLoggers(h){for(const[$,g]of this.p)g===h&&this.deregisterLogger($)}s(h,$){const g=this.p.get(h);return g===void 0||g===$}dispose(){super.dispose(),this.p.clear()}}e.$I5b=E}),define(te[229],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B5b=e.$A5b=e.$z5b=e.$y5b=void 0;function k(D){return D.submenu!==void 0}e.$y5b=k;function O(D){return D.id==="vscode.menubar.separator"}e.$z5b=O;function s(D){return D.uri!==void 0}e.$A5b=s;function M(D){return!k(D)&&!O(D)&&!s(D)}e.$B5b=M}),define(te[39],ie([0,1,3,68,2,6]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=e.$Wm=void 0,e.$Wm=(0,M.$ph)("policy");class D extends s.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.$ec),this.onDidChange=this.h.event}async updatePolicyDefinitions(h){const $=Object.keys(this.f).length;return this.f={...h,...this.f},$!==Object.keys(this.f).length&&await this.i(h),O.Iterable.reduce(this.g.entries(),(g,[p,u])=>({...g,[p]:u}),{})}getPolicyValue(h){return this.g.get(h)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(h,[$,g])=>({...h,[$]:{definition:g,value:this.g.get($)}}),{})}}e.$Xm=D;class E{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Ym=E}),define(te[230],ie([0,1,8,3,68,12,16,5,39]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;function h(g,p){const u=[];for(const y of new Set(s.Iterable.concat(g.keys(),p.keys())))g.get(y)!==p.get(y)&&u.push(y);return u}let $=class extends f.$Xm{constructor(p,u,y){super(),this.j=p,this.k=u,this.l=y,this.c=this.B(new k.$sg(500));const v=O.Event.filter(u.onDidFilesChange,c=>c.affects(p));this.B(u.watch(p)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const u=await this.k.readFile(this.j),y=JSON.parse(u.value.toString());if(!(0,M.$ke)(y))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(y))this.f[v]&&p.set(v,y[v])}catch(u){u.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",u)}return p}async p(){const p=await this.n(),u=h(this.g,p);this.g=p,u.length>0&&this.h.fire(u)}};e.$A6b=$,e.$A6b=$=ke([Q(1,D.$Sj),Q(2,E.$Ri)],$)}),define(te[231],ie([0,1,3,2,39]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.$b6b=void 0;class M{constructor(f){this.b=f,this.a=new O.$kb}listen(f,h){switch(h){case"onDidChange":return k.Event.map(this.b.onDidChange,$=>$.reduce((g,p)=>({...g,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${h}`)}call(f,h,$){switch(h){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions($)}throw new Error(`Call not found: ${h}`)}dispose(){this.a.dispose()}}e.$b6b=M;class D extends s.$Xm{constructor(f,h){super(),this.a=h;for(const $ in f){const{definition:g,value:p}=f[$];this.f[$]=g,p!==void 0&&this.g.set($,p)}this.a.listen("onDidChange")($=>{for(const g in $){const p=$[g];p===null?this.g.delete(g):this.g.set(g,p)}this.h.fire(Object.keys($))})}async i(f){const h=await this.a.call("updatePolicyDefinitions",f);for(const $ in h)this.g.set($,h[$])}}e.$c6b=D}),define(te[232],ie([0,1,39,8,311,2,5]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=void 0;let E=class extends k.$Xm{constructor(h,$){super(),this.j=h,this.k=$,this.a=new O.$og,this.b=this.B(new M.$mb)}async i(h){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`),await this.a.queue(()=>new Promise(($,g)=>{try{this.b.value=(0,s.createWatcher)(this.k,h,p=>{this.m(p),$()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),g(p)}}))}m(h){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const $ in h){const g=h[$];g===void 0?this.g.delete($):this.g.set($,g)}this.h.fire(Object.keys(h))}};e.$z6b=E,e.$z6b=E=ke([Q(0,D.$Ri)],E)}),define(te[78],ie([0,1,4,36]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof k.$g.vscode<"u"&&typeof k.$g.vscode.context<"u"){const M=k.$g.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[22],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,k.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,72,5,22]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c5b=void 0;let M=class{constructor(E,f){this.b=E,this.c=f,this.a=new Map}async isExtensionUrlTrusted(E,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const h=/^(.*)#([^#]+)$/.exec(f);if(!h)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,$,g]=h;let p=this.a.get(E);if(!p){if(p=this.b.trustedExtensionUrlPublicKeys[E],!p||p.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.a.set(E,[...p])}const u=Buffer.from(decodeURIComponent(g),"base64");if(u.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const y=u.slice(0,6),v=u.readUIntBE(0,6),c=Date.now()-v;if(c<0||c>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const d=u.slice(6),l=k.createVerify("SHA256");l.write(y),l.write(Buffer.from($)),l.end();for(let w=0;w<p.length;w++){let S=p[w];if(S!==null){if(typeof S=="string")try{S=k.createPublicKey({key:Buffer.from(S,"base64"),format:"der",type:"spki"}),p[w]=S}catch(m){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${w+1} for ${E}:`,m),p[w]=null;continue}if(l.verify(S,d))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};e.$c5b=M,e.$c5b=M=ke([Q(0,s.$0i),Q(1,O.$Ri)],M)}),define(te[234],ie([0,1,8,5]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o5b=void 0;let s=class{constructor(D,E,f){this.a=D,this.b=E,this.c=f}async inspect(D){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,k.$vg)(D);const f=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$o5b=s,e.$o5b=s=ke([Q(2,O.$Ri)],s)}),define(te[79],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r5b=void 0,e.$r5b=(0,k.$ph)("protocolMainService")}),define(te[43],ie([0,1,135,12]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0;class s{constructor(){this.a=new Map}add(D,E){k.ok(O.$ie(D)),k.ok(O.$ke(E)),k.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,E)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Um=new s}),define(te[235],ie([0,1,3,43]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0,e.$Vm={JSONContribution:"base.contributions.json"};function s(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class M{constructor(){this.b=new k.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,h){this.a[s(f)]=h,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;O.$Um.add(e.$Vm.JSONContribution,D)}),define(te[59],ie([0,1,24,3,12,161,18,235,43]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ConfigurationScope=e.$Zm=e.EditPresentationTypes=void 0;var h;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(h||(e.EditPresentationTypes=h={})),e.$Zm={Configuration:"base.contributions.configuration"};var $;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})($||(e.ConfigurationScope=$={})),e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m={properties:{},patternProperties:{}},e.$7m="vscode://schemas/settings/resourceLanguage",e.$8m="vscode://schemas/settings/configurationDefaults";const g=f.$Um.as(E.$Vm.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$ec,this.onDidSchemaChange=this.i.event,this.j=new O.$ec,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},g.registerSchema(e.$7m,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const r=new Set;this.n(t,a,r),g.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const a=new Set;this.o(t,a),g.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const r=new Set;this.o(a,r),this.n(t,!1,r),g.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(a.add(o),e.$0m.test(o)){const b=this.a.get(o),I=b?.valuesSources??new Map;if(n)for(const j of Object.keys(i[o]))I.set(j,n);const A={...b?.value||{},...i[o]};this.a.set(o,{source:n,value:A,valuesSources:I});const P=(0,D.$6h)(o),C={type:"object",default:A,description:M.localize(1,null,P),$ref:e.$7m,defaultDefaultValue:A,source:s.$ie(n)?void 0:n,defaultValueSource:n};r.push(...v(o)),this.d[o]=C,this.b.properties[o]=C}else{this.a.set(o,{value:i[o],source:n});const b=this.d[o];b&&(this.w(o,b),this.r(o,b))}this.m(r)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),b=s.$ie(i)?i:i?.id,I=s.$ie(o?.source)?o?.source:o?.source?.id;if(b===I)if(a.add(n),this.a.delete(n),e.$0m.test(n))delete this.d[n],delete this.b.properties[n];else{const A=this.d[n];A&&(this.w(n,A),this.r(n,A))}}this.u()}deltaConfiguration(t){let a=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,r){t.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,a){const r=i=>{if(i.properties)for(const n in i.properties){a.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,a=!0,r,i,n=3,o){n=s.$re(t.scope)?n:t.scope;const b=t.properties;if(b)for(const A in b){const P=b[A];if(a&&w(A,P)){delete b[A];continue}if(P.source=r,P.defaultDefaultValue=b[A].default,this.w(A,P),e.$0m.test(A)?P.scope=void 0:(P.scope=s.$re(P.scope)?n:P.scope,P.restricted=s.$re(P.restricted)?!!i?.includes(A):P.restricted),b[A].hasOwnProperty("included")&&!b[A].included){this.f[A]=b[A],delete b[A];continue}else this.d[A]=b[A],b[A].policy?.name&&this.e.set(b[A].policy.name,A);!b[A].deprecationMessage&&b[A].markdownDeprecationMessage&&(b[A].deprecationMessage=b[A].markdownDeprecationMessage),o.add(A)}const I=t.allOf;if(I)for(const A of I)this.p(A,a,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$1m.properties[t]=a,a.scope){case 1:e.$2m.properties[t]=a;break;case 2:e.$3m.properties[t]=a;break;case 6:e.$4m.properties[t]=a;break;case 3:e.$5m.properties[t]=a;break;case 4:e.$6m.properties[t]=a;break;case 5:e.$6m.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$1m.properties[t],a.scope){case 1:delete e.$2m.properties[t];break;case 2:delete e.$3m.properties[t];break;case 6:delete e.$4m.properties[t];break;case 3:delete e.$5m.properties[t];break;case 4:case 5:delete e.$6m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$7m};this.w(a,r),e.$1m.properties[a]=r,e.$2m.properties[a]=r,e.$3m.properties[a]=r,e.$4m.properties[a]=r,e.$5m.properties[a]=r,e.$6m.properties[a]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$7m};e.$1m.patternProperties[e.$9m]=t,e.$2m.patternProperties[e.$9m]=t,e.$3m.patternProperties[e.$9m]=t,e.$4m.patternProperties[e.$9m]=t,e.$5m.patternProperties[e.$9m]=t,e.$6m.patternProperties[e.$9m]=t,this.i.fire()}w(t,a){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$pe(i)&&(i=a.defaultDefaultValue,n=void 0),s.$pe(i)&&(i=d(a.type)),a.default=i,a.defaultValueSource=n}}const u="\\[([^\\]]+)\\]",y=new RegExp(u,"g");e.$9m=`^(${u})+$`,e.$0m=new RegExp(e.$9m);function v(m){const t=[];if(e.$0m.test(m)){let a=y.exec(m);for(;a?.length;){const r=a[1].trim();r&&t.push(r),a=y.exec(m)}}return(0,k.$of)(t)}e.$$m=v;function c(m){return m.reduce((t,a)=>`${t}[${a}]`,"")}e.$_m=c;function d(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$an=d;const l=new p;f.$Um.add(e.$Zm.Configuration,l);function w(m,t){return m.trim()?e.$0m.test(m)?M.localize(7,null,m):l.getConfigurationProperties()[m]!==void 0?M.localize(8,null,m):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,m,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$bn=w;function S(){const m=[],t=l.getConfigurationProperties();for(const a of Object.keys(t))m.push([a,t[a].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.$cn=S}),define(te[120],ie([0,1,24,3,44,2,35,37,12,7,18,59,43]),function(H,e,k,O,s,M,D,E,f,h,$,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function u(a){return Object.isFrozen(a)?a:E.$Jm(a)}class y{constructor(r={},i=[],n=[],o){this.b=r,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,$.$4h)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),o=i?this.rawConfiguration.getOverrideValue(r,i):void 0,b=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:o,merged:b}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,$.$4h)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return k.$of(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return k.$of(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=E.$Im(this.contents),n=E.$Im(this.overrides),o=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const I of r)if(b.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const A of I.overrides){const[P]=n.filter(C=>k.$$e(C.identifiers,A.identifiers));P?(this.h(P.contents,A.contents),P.keys.push(...A.keys),P.keys=k.$of(P.keys)):n.push(E.$Im(A))}for(const A of I.keys)o.indexOf(A)===-1&&o.push(A)}return new y(i,o,n,b.every(I=>I instanceof y)?void 0:b)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of k.$of([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[o];const I=i[o];I&&(typeof b=="object"&&typeof I=="object"?(b=E.$Im(b),this.h(b,I)):b=I),n[o]=b}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$ke(r[n])&&f.$ke(i[n])){this.h(r[n],i[n]);continue}r[n]=E.$Im(i[n])}}i(r){let i=null,n=null;const o=b=>{b&&(n?this.h(n,b):n=E.$Im(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===r?i=b.contents:b.identifiers.includes(r)&&o(b.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,$.$3h)(this.contents,r),g.$0m.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>k.$$e(n.identifiers,(0,g.$$m)(r))),1))}j(r,i,n){(0,$.$2h)(this.contents,r,i,o=>console.error(o)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),g.$0m.test(r)&&this.overrides.push({identifiers:(0,g.$$m)(r),keys:Object.keys(this.contents[r]),contents:(0,$.$1h)(this.contents[r],o=>console.error(o))})}}e.$dn=y;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$re(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:o,overrides:b,restricted:I,hasExcludedProperties:A}=this.h(r,i);this.b=new y(n,o,b,A?[r]:void 0),this.c=I||[]}g(r){let i={},n=null,o=[];const b=[],I=[];function A(C){Array.isArray(o)?o.push(C):n!==null&&(o[n]=C)}const P={onObjectBegin:()=>{const C={};A(C),b.push(o),o=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{o=b.pop()},onArrayBegin:()=>{const C=[];A(C),b.push(o),o=C,n=null},onArrayEnd:()=>{o=b.pop()},onLiteralValue:A,onError:(C,j,U)=>{I.push({error:C,offset:j,length:U})}};if(r)try{s.$Fm(r,P),i=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=p.$Um.as(g.$Zm.Configuration).getConfigurationProperties(),o=this.i(r,n,!0,i);r=o.raw;const b=(0,$.$1h)(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`)),I=Object.keys(r),A=this.j(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:b,keys:I,overrides:A,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(r,i,n,o){let b=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:b};const I={},A=[];for(const P in r)if(g.$0m.test(P)&&n){const C=this.i(r[P],i,!1,o);I[P]=C.raw,b=b||C.hasExcludedProperties,A.push(...C.restricted)}else{const C=i[P],j=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&A.push(P),!o.exclude?.includes(P)&&(o.include?.includes(P)||(j===void 0||o.scopes===void 0||o.scopes.includes(j))&&!(o.skipRestricted&&C?.restricted))?I[P]=r[P]:b=!0}return{raw:I,restricted:A,hasExcludedProperties:b}}j(r,i){const n=[];for(const o of Object.keys(r))if(g.$0m.test(o)){const b={};for(const I in r[o])b[I]=r[o][I];n.push({identifiers:(0,g.$$m)(o),keys:Object.keys(b),contents:(0,$.$1h)(b,i)})}return n}}e.$en=v;class c extends M.$lb{constructor(r,i,n,o){super(),this.c=r,this.f=i,this.g=o,this.b=this.B(new O.$ec),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&n.isEqual(b.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fn=c;class d{constructor(r,i,n,o,b,I,A,P,C,j,U,W,re){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=b,this.f=I,this.g=A,this.h=P,this.i=C,this.j=j,this.k=U,this.l=W,this.m=re}get value(){return u(this.c)}n(r,i,n){const o=r.inspect(i,n);return{get value(){return u(o.value)},get override(){return u(o.override)},get merged(){return u(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(r,i,n,o,b=new y,I=new y,A=new D.$ni,P=new y,C=new D.$ni){this.c=r,this.d=i,this.f=n,this.g=o,this.h=b,this.i=I,this.j=A,this.l=P,this.m=C,this.a=null,this.b=new D.$ni,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new y,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const o=this.q(r,i,n),b=this.u(i.resource,n),I=i.resource?this.m.get(i.resource)||this.l:this.l,A=new Set;for(const P of o.overrides)for(const C of P.identifiers)o.getOverrideValue(r,C)!==void 0&&A.add(C);return new d(r,i,o.getValue(r),A.size?[...A]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,b||void 0,I)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:b,removed:I}=m(this.c,r);i=[...o,...b,...I]}for(const o of i)for(const b of(0,g.$$m)(o)){const I=this.c.getKeysForOverrideIdentifier(b),A=r.getKeysForOverrideIdentifier(b),P=[...A.filter(C=>I.indexOf(C)===-1),...I.filter(C=>A.indexOf(C)===-1),...I.filter(C=>!E.$Mm(this.c.override(b).getValue(C),r.override(b).getValue(C)))];n.push([b,P])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=m(this.d,r),b=[...i,...n,...o];return b.length&&this.updatePolicyConfiguration(r),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:b}=m(this.applicationConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:b}=m(this.localUserConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:b}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:b}=m(this.remoteUserConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:b}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:b}=m(this.workspaceConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:b}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:o,updated:b,removed:I,overrides:A}=m(n,i),P=[...o,...b,...I];return(P.length||!n)&&this.updateFolderConfiguration(r,i),{keys:P,overrides:A}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:b,overrides:I}=m(i,void 0);return{keys:[...n,...o,...b],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}r({resource:r},i){let n=this.s();if(i&&r){const o=i.getFolder(r);o&&(n=this.t(o.uri)||n);const b=this.m.get(r);b&&(n=n.merge(b))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),o=this.j.get(r);o?(i=n.merge(o),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:b}=this.j.get(i);return r.push([i,{contents:n,overrides:o,keys:b}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),o=this.x(r.application),b=this.x(r.user),I=this.x(r.workspace),A=r.folders.reduce((P,C)=>(P.set(h.URI.revive(C[0]),this.x(C[1])),P),new D.$ni);return new l(i,n,o,b,new y,I,A,new y,new D.$ni)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$gn=l;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,i=new Map;for(const o of a)o.keys.forEach(b=>r.add(b)),o.overrides.forEach(([b,I])=>{const A=(0,D.$ki)(i,b,new Set);I.forEach(P=>A.add(P))});const n=[];return i.forEach((o,b)=>n.push([b,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.$hn=w;class S{constructor(r,i,n,o){this.change=r,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const b of r.keys)this.affectedKeys.add(b);for(const[,b]of r.overrides)for(const I of b)this.affectedKeys.add(I);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,o=this.d.indexOf(n);if(o<0)return!1;const b=o+n.length;if(b>=this.d.length)return!1;const I=this.d.charCodeAt(b);if(I!==this.b&&I!==this.c)return!1;if(i){const A=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,P=this.g.getValue(r,i,this.h);return!E.$Mm(A,P)}return!0}}e.$in=S;function m(a,r){const{added:i,removed:n,updated:o}=t(r?.rawConfiguration,a?.rawConfiguration),b=[],I=a?.getAllOverrideIdentifiers()||[],A=r?.getAllOverrideIdentifiers()||[];if(r){const P=A.filter(C=>!I.includes(C));for(const C of P)b.push([C,r.getKeysForOverrideIdentifier(C)])}if(a){const P=I.filter(C=>!A.includes(C));for(const C of P)b.push([C,a.getKeysForOverrideIdentifier(C)])}if(r&&a){for(const P of I)if(A.includes(P)){const C=t({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)});b.push([P,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:o,overrides:b}}function t(a,r){const i=a?r?a.keys.filter(b=>r.keys.indexOf(b)===-1):[...a.keys]:[],n=r?a?r.keys.filter(b=>a.keys.indexOf(b)===-1):[...r.keys]:[],o=[];if(a&&r){for(const b of r.keys)if(a.keys.indexOf(b)!==-1){const I=(0,$.$4h)(r.contents,b),A=(0,$.$4h)(a.contents,b);E.$Mm(I,A)||o.push(b)}}return{added:i,removed:n,updated:o}}}),define(te[236],ie([0,1,24,3,2,37,12,120,59,5,39,43]),function(H,e,k,O,s,M,D,E,f,h,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0;class p extends s.$lb{constructor(){super(...arguments),this.a=this.B(new O.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new E.$dn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(g.$Um.as(f.$Zm.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:d})=>this.c(Array.from(c),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,d){this.h(c,g.$Um.as(f.$Zm.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new E.$dn;const c=g.$Um.as(f.$Zm.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,d){const l=this.f();for(const w of c){const S=l[w],m=d[w];S!==void 0?this.b.addValue(w,S):m?this.b.addValue(w,m.default):this.b.removeValue(w)}}}e.$jn=p;class u{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new E.$dn}async initialize(){return this.configurationModel}}e.$kn=u;let y=class extends s.$lb{get configurationModel(){return this.b}constructor(c,d,l){super(),this.c=c,this.f=d,this.g=l,this.a=this.B(new O.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new E.$dn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const d={},l=[],w=g.$Um.as(f.$Zm.Configuration).getConfigurationProperties();for(const S of c){const m=w[S];if(!m){l.push(S);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}l.push(S),d[m.policy.name]={type:m.type}}}return(0,D.$ve)(d)||await this.f.updatePolicyDefinitions(d),l}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const d=g.$Um.as(f.$Zm.Configuration).getPolicyConfigurations(),l=(0,k.$jf)(c.map(w=>d.get(w)));this.j(l,!0)}j(c,d){this.g.trace("PolicyConfiguration#update",c);const l=g.$Um.as(f.$Zm.Configuration).getConfigurationProperties(),w=[],S=this.b.isEmpty();for(const m of c){const t=l[m]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(S?a!==void 0:!(0,M.$Mm)(this.b.getValue(m),a))&&w.push([m,a])}else this.b.getValue(m)!==void 0&&w.push([m,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const m=this.b;this.b=new E.$dn;for(const t of m.keys)this.b.setValue(t,m.getValue(t));for(const[t,a]of w)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);d&&this.a.fire(this.b)}}};e.$ln=y,e.$ln=y=ke([Q(1,$.$Wm),Q(2,h.$Ri)],y)}),define(te[237],ie([0,1,8,3,2,19,18,120,236,39]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class $ extends s.$lb{constructor(p,u,y,v){super(),this.i=p,this.h=this.B(new O.$ec),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$jn),this.c=y instanceof h.$Ym?new f.$kn:this.B(new f.$ln(this.b,y,v)),this.f=this.B(new E.$fn(this.i,{},M.$Zf,u)),this.a=new E.$gn(this.b.configurationModel,this.c.configurationModel,new E.$dn,new E.$dn),this.g=this.B(new k.$Gg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:d})=>this.k(c,d))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,u,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new E.$gn(p,u,new E.$dn,y)}getConfigurationData(){return this.a.toData()}getValue(p,u){const y=typeof p=="string"?p:void 0,v=(0,D.$Wh)(p)?p:(0,D.$Wh)(u)?u:{};return this.a.getValue(y,v,void 0)}updateValue(p,u,y,v){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const u=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(y,u,2)}k(p,u){const y=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(p,u);this.m(v,y,7)}l(p){const u=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.m(y,u,7)}m(p,u,y){const v=new E.$in(p,{data:u},this.a);v.source=y,v.sourceConfig=this.n(y),this.h.fire(v)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$mn=$}),define(te[238],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=e.$o6b=e.$n6b=void 0,e.$n6b="request",e.$o6b="remoteResourceHandler";class k{async routeCall(s,M,D){if(M!==e.$n6b)throw new Error(`Call not found: ${M}`);const E=D[0];if(E?.authority){const f=s.connections.find(h=>h.ctx===E.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$p6b=k}),define(te[239],ie([0,1,13,6]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,O.$ph)("remoteAuthorityResolverService");var s;(function($){$[$.WebSocket=0]="WebSocket",$[$.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(g){this.id=g,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=M;class D{constructor(g,p){this.host=g,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=D;var E;(function($){$.Unknown="Unknown",$.NotAvailable="NotAvailable",$.TemporarilyNotAvailable="TemporarilyNotAvailable",$.NoResolverFound="NoResolverFound",$.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class f extends k.$ab{static isNotAvailable(g){return g instanceof f&&g._code===E.NotAvailable}static isTemporarilyNotAvailable(g){return g instanceof f&&g._code===E.TemporarilyNotAvailable}static isNoResolverFound(g){return g instanceof f&&g._code===E.NoResolverFound}static isInvalidAuthority(g){return g instanceof f&&g._code===E.InvalidAuthority}static isHandled(g){return g instanceof f&&g.isHandled}constructor(g,p=E.Unknown,u){super(g),this._message=g,this._code=p,this._detail=u,this.isHandled=p===E.NotAvailable&&u===!0,Object.setPrototypeOf(this,f.prototype)}}e.$zk=f;function h($){const g=$.indexOf("+");return g===-1?$:$.substring(0,g)}e.$Ak=h}),define(te[60],ie([0,1,15]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function O(h){return h.scheme===k.Schemas.vscodeRemote?h.authority:void 0}e.$Bk=O;function s(h){if(!h)return;const $=h.indexOf("+");return $<0?h:h.substr(0,$)}e.$Ck=s;function M(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.$Dk=M;function D(h){const{host:$,port:g}=f(h);if(typeof g>"u")throw new Error("Remote authority doesn't contain a port!");return{host:$,port:g}}e.$Ek=D;function E(h,$){let{host:g,port:p}=f(h);return typeof p>"u"&&(p=$),{host:g,port:p}}e.$Fk=E;function f(h){const $=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const g=h.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const p=h.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:h,port:void 0}}}),define(te[121],ie([0,1,26,6,60]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.TargetPlatform=e.ExtensionType=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=void 0,e.$Cl="extensions.user.cache",e.$Dl="extensions.builtin.cache",e.$El="undefined_publisher",e.$Fl=["ui","workspace","web"];function M(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Gl=M,e.$Hl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(D||(e.ExtensionType=D={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class f{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,d){if(typeof c>"u"||c===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof c=="string"||typeof d=="string"){const l=typeof c=="string"?c:c.value,w=typeof d=="string"?d:d.value;return k.$Ld(l,w)}return c._lower===d._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$Il=f;class h{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const d of c)this.add(d)}add(c){this.c.add(f.toKey(c))}delete(c){return this.c.delete(f.toKey(c))}has(c){return this.c.has(f.toKey(c))}}e.$Jl=h;class ${constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(f.toKey(c))}get(c){return this.c.get(f.toKey(c))}has(c){return this.c.has(f.toKey(c))}set(c,d){this.c.set(f.toKey(c),d)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Kl=$;function g(v){return p(v)}e.$Ll=g;function p(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Ml=p;function u(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$Nl=u;function y(v,c){if(c){const d=`onResolveRemoteAuthority:${(0,s.$Ck)(c)}`;return!!v.activationEvents?.includes(d)}return!1}e.$Ol=y,e.$Pl=(0,O.$ph)("IBuiltinExtensionsScannerService")}),define(te[240],ie([0,1,8,17,23,13,3,2,65,69,31,110,239,60]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.PersistentConnectionEventType=e.$Mk=e.$Lk=e.$Kk=e.ConnectionType=void 0;const y=30*1e3;var v;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function c(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(G){const R=new s.$oc;return setTimeout(()=>R.cancel(),G),R.token}function l(G,R){if(G.isCancellationRequested||R.isCancellationRequested)return s.CancellationToken.Cancelled;const L=new s.$oc;return G.onCancellationRequested(()=>L.cancel()),R.onCancellationRequested(()=>L.cancel()),L.token}class w{get didTimeout(){return this.c==="timedout"}constructor(R){this.c="pending",this.d=new E.$kb,this.promise=new Promise((L,N)=>{this.f=L,this.g=N}),R.isCancellationRequested?this.h():this.d.add(R.onCancellationRequested(()=>this.h()))}registerDisposable(R){this.c==="pending"?this.d.add(R):R.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(R))}reject(R){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(R))}}function S(G,R){const L=new w(R);return L.registerDisposable(G.onControlMessage(N=>{const q=JSON.parse(N.toString()),se=T(q);se?L.reject(se):L.resolve(q)})),L.promise}function m(G,R,L,N,q,se,Y,le){const K=new w(le),ee=h.$ac.create(!1);return G.info(`Creating a socket (${Y})...`),f.mark(`code/willCreateSocket/${se}`),R.connect(L,N,q,Y).then(X=>{K.didTimeout?(f.mark(`code/didCreateSocketError/${se}`),G.info(`Creating a socket (${Y}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),X?.dispose()):(f.mark(`code/didCreateSocketOK/${se}`),G.info(`Creating a socket (${Y}) was successful after ${ee.elapsed()} ms.`),K.resolve(X))},X=>{f.mark(`code/didCreateSocketError/${se}`),G.info(`Creating a socket (${Y}) returned an error after ${ee.elapsed()} ms.`),G.error(X),K.reject(X)}),K.promise}function t(G,R){const L=new w(R);return G.then(N=>{L.didTimeout||L.resolve(N)},N=>{L.didTimeout||L.reject(N)}),L.promise}async function a(G,R,L,N){const q=oe(G,R);G.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let se;try{se=await m(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,u.$Dk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,c(R),`renderer-${c(R)}-${G.reconnectionToken}`,N)}catch(X){throw G.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),G.logService.error(X),X}G.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let Y,le;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(se,null),Y=G.reconnectionProtocol,le=!1):(Y=new g.$dh({socket:se}),le=!0),G.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const K=await t(G.signService.createNewMessage((0,$.$3e)()),N),ee={type:"auth",auth:G.connectionToken||"00000000000000000000",data:K.data};Y.sendControl(O.$Ec.fromString(JSON.stringify(ee)));try{const X=await S(Y,l(N,d(1e4)));if(X.type!=="sign"||typeof X.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(G.logService.trace(`${q} 4/6. received SignRequest control message.`),!await t(G.signService.validate(K,X.signedData),N)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const me=await t(G.signService.sign(X.data),N),Re={type:"connectionType",commit:G.commit,signedData:me,desiredConnectionType:R};return L&&(Re.args=L),G.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(O.$Ec.fromString(JSON.stringify(Re))),{protocol:Y,ownsProtocol:le}}catch(X){throw X&&X.code==="ETIMEDOUT"&&(G.logService.error(`${q} the handshake timed out. Error:`),G.logService.error(X)),X&&X.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${q} received error control message when negotiating connection. Error:`),G.logService.error(X)),le&&z(Y),X}}async function r(G,R,L,N){const q=Date.now(),se=oe(G,R),{protocol:Y,ownsProtocol:le}=await a(G,R,L,N),K=new w(N);return K.registerDisposable(Y.onControlMessage(ee=>{const X=JSON.parse(ee.toString()),de=T(X);de?(G.logService.error(`${se} received error control message when negotiating connection. Error:`),G.logService.error(de),le&&z(Y),K.reject(de)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${ce(q)}!`),K.resolve({protocol:Y,firstMessage:X}))})),K.promise}async function i(G,R){const{protocol:L}=await r(G,1,void 0,R);return{protocol:L}}async function n(G,R,L){const{protocol:N,firstMessage:q}=await r(G,2,R,L),se=q&&q.debugPort;return{protocol:N,debugPort:se}}async function o(G,R,L){const N=Date.now(),q=oe(G,3),{protocol:se}=await a(G,3,R,L);return G.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ce(N)}!`),se}async function b(G,R,L){const{connectTo:N,connectionToken:q}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:N,connectionToken:q,reconnectionToken:R,reconnectionProtocol:L,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function I(G,R,L){return P(G,async N=>{const{protocol:q}=await i(N,s.CancellationToken.None);return new V(G,R,L,N.reconnectionToken,q)})}e.$Kk=I;async function A(G,R){return P(G,async L=>{const{protocol:N,debugPort:q}=await n(L,R,s.CancellationToken.None);return new J(G,R,L.reconnectionToken,N,q)})}e.$Lk=A;async function P(G,R){for(let N=1;;N++)try{const q=(0,$.$3e)(),se=await b(G,q,null);return await R(se)}catch(q){if(N<5)G.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(q);else throw G.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(q),ue.triggerPermanentFailure(0,0,p.$zk.isHandled(q)),q}}async function C(G,R,L){const N=await b(G,(0,$.$3e)(),null);return await o(N,{host:R,port:L},s.CancellationToken.None)}e.$Mk=C;function j(G){return(0,k.$ig)(R=>new Promise((L,N)=>{const q=setTimeout(L,G*1e3);R.onCancellationRequested(()=>{clearTimeout(q),L()})}))}var U;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class W{constructor(R,L){this.reconnectionToken=R,this.millisSinceLastIncomingData=L,this.type=0}}e.$Nk=W;class re{constructor(R,L,N,q){this.reconnectionToken=R,this.millisSinceLastIncomingData=L,this.durationSeconds=N,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.$Ok=re;class ne{constructor(R,L,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=L,this.attempt=N,this.type=2}}e.$Pk=ne;class fe{constructor(R,L,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=L,this.attempt=N,this.type=4}}e.$Qk=fe;class ae{constructor(R,L,N,q){this.reconnectionToken=R,this.millisSinceLastIncomingData=L,this.attempt=N,this.handled=q,this.type=3}}e.$Rk=ae;class ue extends E.$lb{static triggerPermanentFailure(R,L,N){this._permanentFailure=!0,this.f=R,this.g=L,this.h=N,this.i.forEach(q=>q.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(R=>R.s())}static debugPauseSocketWriting(){this.i.forEach(R=>R.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||ue._permanentFailure}constructor(R,L,N,q,se){super(),this.n=R,this.p=L,this.reconnectionToken=N,this.protocol=q,this.r=se,this.j=this.B(new D.$ec),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new fe(this.reconnectionToken,0,0)),this.B(q.onSocketClose(Y=>{const le=x(this.n,this.reconnectionToken,!0);Y?Y.type===0?(this.p.logService.info(`${le} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.p.logService.error(Y.error)):(this.p.logService.info(`${le} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.p.logService.error(Y.event)):this.p.logService.info(`${le} received socket close event.`),this.s()})),this.B(q.onSocketTimeout(Y=>{const le=x(this.n,this.reconnectionToken,!0);this.p.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.s()})),ue.i.push(this),this.B((0,E.$jb)(()=>{const Y=ue.i.indexOf(this);Y>=0&&ue.i.splice(Y,1)})),this.k&&this.v(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const R=x(this.n,this.reconnectionToken,!0);this.p.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const q=N<L.length?L[N]:L[L.length-1];try{if(q>0){const Y=j(q);this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,Y)),this.p.logService.info(`${R} waiting for ${q} seconds before reconnecting...`);try{await Y}catch{}}if(this.k){this.p.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.p.logService.info(`${R} resolving connection...`);const se=await b(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${R} connecting to ${se.connectTo}...`),await this.y(se,d(y)),this.p.logService.info(`${R} reconnected!`),this.j.fire(new fe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(se){if(se.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(se),this.u(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.p.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(se),this.u(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(p.$zk.isTemporarilyNotAvailable(se)){this.p.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(se);continue}if((se.code==="ETIMEDOUT"||se.code==="ENETUNREACH"||se.code==="ECONNREFUSED"||se.code==="ECONNRESET")&&se.syscall==="connect"){this.p.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(se);continue}if((0,M.$2)(se)){this.p.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(se);continue}if(se instanceof p.$zk){this.p.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(se),this.u(this.protocol.getMillisSinceLastIncomingData(),N+1,p.$zk.isHandled(se));break}this.p.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(se),this.u(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.k&&!this.m)}u(R,L,N){this.r?ue.triggerPermanentFailure(R,L,N):this.v(R,L,N)}v(R,L,N){this.j.fire(new ae(this.reconnectionToken,R,L,N)),z(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Sk=ue;class V extends ue{constructor(R,L,N,q,se){super(1,R,q,se,!0),this.client=this.B(new g.$bh(se,{remoteAuthority:L,clientId:N},R.ipcLogger))}async y(R,L){await i(R,L)}}e.$Tk=V;class J extends ue{constructor(R,L,N,q,se){super(2,R,N,q,!1),this.z=L,this.debugPort=se}async y(R,L){await n(R,this.z,L)}}e.$Uk=J;function z(G){try{G.acceptDisconnect();const R=G.getSocket();G.dispose(),R.dispose()}catch(R){(0,M.$Y)(R)}}function T(G){if(G&&G.type==="error"){const R=new Error(`Connection error: ${G.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function F(G,R){for(;G.length<R;)G+=" ";return G}function B(G,R){return`[remote-connection][${F(c(G),13)}][${R.substr(0,5)}\u2026]`}function x(G,R,L){return`${B(G,R)}[${L?"reconnect":"initial"}]`}function oe(G,R){return`${x(R,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function ce(G){return`${Date.now()-G} ms`}}),define(te[241],ie([0,1,2,6]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=void 0,e.$Gk=(0,O.$ph)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,E){return this.a[D]??=[],this.a[D].push(E),(0,k.$jb)(()=>{const f=this.a[D]?.indexOf(E);typeof f=="number"&&f>=0&&this.a[D]?.splice(f,1)})}b(D){return(this.a[D.type]||[]).find(f=>f.supports(D))}connect(D,E,f,h){const $=this.b(D);if(!$)throw new Error(`No socket factory found for ${D}`);return $.connect(D,E,f,h)}}e.$Hk=s}),define(te[242],ie([0,1,27,47,21,114]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n5b=void 0;let D;async function E(u=!1){return(D===void 0||u)&&(D=f()),D}e.$n5b=E;async function f(){const u=h();if(u===void 0)return!1;if(u>=22e3){const y=g();if(y)return new Promise(v=>{O.execFile(y,["--status"],c=>v(!c))})}else{const y=p();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function h(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());if(u)return parseInt(u[3])}function $(u){const y=process.env.SystemRoot;if(y){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,v?"Sysnative":"System32",u)}}function g(){return $("wsl.exe")}function p(){return $("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,13,2,181,59,6,5,43]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Ao=(0,E.$ph)("requestService");class ${constructor(m){this.b=m}toJSON(){if(!this.a){const m=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?m[t]="*****":m[t]=this.b[t];this.a=m}return this.a}}class g extends s.$lb{constructor(m){super(),this.b=0,this.a=m.createLogger("network",{name:(0,M.localize)(0,null),when:f.$9i.isEqualTo((0,f.$7i)(f.LogLevel.Trace)).serialize()})}async c(m,t,a){const r=`${m} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new $(t.headers??{}));try{const i=await a();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,O.$9)(i)),i}}}e.$Bo=g;function p(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.$Co=p;function u(S){return S.res.statusCode===204}async function y(S){return u(S)?null:(await(0,k.$Qc)(S.stream)).toString()}e.$Do=y;async function v(S){if(!p(S))throw new Error("Server returned "+S.res.statusCode);return y(S)}e.$Eo=v;async function c(S){if(!p(S))throw new Error("Server returned "+S.res.statusCode);if(u(S))return null;const t=(await(0,k.$Qc)(S.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Fo=c;function d(S){w(S)}e.$Go=d;let l;function w(S){const m=h.$Um.as(D.$Zm.Configuration),t=l;l={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0}}},m.updateConfigurations({add:[l],remove:t?[t]:[]})}w(1)}),define(te[243],ie([0,1,17,23]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class s{constructor(E){this.a=E}listen(E,f){throw new Error("Invalid listen")}call(E,f,h,$=O.CancellationToken.None){switch(f){case"request":return this.a.request(h[0],$).then(async({res:g,stream:p})=>{const u=await(0,k.$Qc)(p);return[{statusCode:g.statusCode,headers:g.headers},u]});case"resolveProxy":return this.a.resolveProxy(h[0])}throw new Error("Invalid call")}}e.$Cq=s;class M{constructor(E){this.a=E}async request(E,f){const[h,$]=await this.a.call("request",[E],f);return{res:h,stream:(0,k.$Sc)($)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}}e.$Dq=M}),define(te[244],ie([0,1,245,12]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;function s(D,E){return D.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:D.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function M(D,E,f={}){const h=(0,k.parse)(D),$=f.proxyUrl||s(h,E);if(!$)return null;const g=(0,k.parse)($);if(!/^https?:$/.test(g.protocol||""))return null;const p={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,O.$oe)(f.strictSSL)?f.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((u,y)=>{H(["http-proxy-agent"],u,y)}))(p):new(await new Promise((u,y)=>{H(["https-proxy-agent"],u,y)}))(p)}e.$Eq=M}),define(te[246],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L5b=e.$K5b=e.$J5b=void 0,e.$J5b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$K5b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$L5b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[95],ie([0,1,47,9,182,23,50,13,4,31,109,63,8,138]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0;let y;async function v(d,l,w,S){return w["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,g.$tl)(S)&&!w["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,g.$tl)(S)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(m,t)=>{const a=new M.$oc;let r=1e4;const i=d.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,u.$ul)(i,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{m(await c(l,a.token))}catch(o){!(0,E.$2)(o)&&!a.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$ai)(o)))):m({})}finally{clearTimeout(n),a.dispose()}})),y)}e.$zl=v;async function c(d,l){const w=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",w);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",S);const m=(0,h.$3e)().replace(/-/g,"").substr(0,12),t=new RegExp(m+"({.*})"+m),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",a);const r=await(0,$.$jl)(f.OS,a);return d.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(l.isCancellationRequested)return n(new E.$3);const o=(0,O.$_c)(r);let b,I;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(b=`& '${process.execPath}' ${A} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,I=["-Login","-Command"]):o==="nu"?(b=`^'${process.execPath}' ${A} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,I=["-i","-l","-c"]):(b=`'${process.execPath}' ${A} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,o==="tcsh"||o==="csh"?I=["-ic"]:I=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),b);const P=(0,k.spawn)(r,[...I,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});l.onCancellationRequested(()=>(P.kill(),n(new E.$3))),P.on("error",U=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.$ai)(U)),n(U)});const C=[];P.stdout.on("data",U=>C.push(U));const j=[];P.stderr.on("data",U=>j.push(U)),P.on("close",(U,W)=>{const re=Buffer.concat(C).toString("utf8");d.trace("getUnixShellEnvironment#raw",re);const ne=Buffer.concat(j).toString("utf8");if(ne.trim()&&d.trace("getUnixShellEnvironment#stderr",ne),U||W)return n(new Error((0,s.localize)(2,null,U,W)));const fe=t.exec(re),ae=fe?fe[1]:"{}";try{const ue=JSON.parse(ae);w?ue.ELECTRON_RUN_AS_NODE=w:delete ue.ELECTRON_RUN_AS_NODE,S?ue.ELECTRON_NO_ATTACH_CONSOLE=S:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){d.error("getUnixShellEnvironment#errorCaught",(0,D.$ai)(ue)),n(ue)}})})}}),define(te[247],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K1b=void 0;class k{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(k.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$K1b=k}),define(te[96],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=void 0,e.$Ik="signService",e.$Jk=(0,k.$ph)(e.$Ik)}),define(te[248],ie([0,1,247]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=void 0;class O extends k.$K1b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>H(["vsda"],M,D))}}e.$y6b=O}),define(te[34],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=void 0,e.$ZM=(0,k.$ph)("stateReadService"),e.$1M=(0,k.$ph)("stateService")}),define(te[122],ie([0,1,8,17,12,33,16,5]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.SaveStrategy=void 0;var f;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(f||(e.SaveStrategy=f={}));class h{constructor(u,y,v,c){this.f=u,this.g=v,this.h=c,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=y===0?void 0:new k.$sg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(u){u.fileOperationResult!==1&&this.g.error(u)}}getItem(u,y){const v=this.a[u];return(0,s.$re)(v)?y:v}setItem(u,y){this.setItems([{key:u,data:y}])}setItems(u){let y=!1;for(const{key:v,data:c}of u)this.a[v]!==c&&((0,s.$re)(c)?(0,s.$pe)(this.a[v])||(this.a[v]=void 0,y=!0):(this.a[v]=c,y=!0));y&&this.j()}removeItem(u){(0,s.$pe)(this.a[u])||(this.a[u]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const u=JSON.stringify(this.a,null,4);if(u!==this.b)try{await this.h.writeFile(this.f,O.$Ec.fromString(u),{atomic:{postfix:".vsctmp"}}),this.b=u}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$2M=h;let $=class{constructor(u,y,v,c){this.a=new h(y.stateResource,u,v,c)}async init(){await this.a.init()}getItem(u,y){return this.a.getItem(u,y)}};e.$3M=$,e.$3M=$=ke([Q(1,M.$wh),Q(2,E.$Ri),Q(3,D.$Sj)],$);class g extends ${setItem(u,y){this.a.setItem(u,y)}setItems(u){this.a.setItems(u)}removeItem(u){this.a.removeItem(u)}close(){return this.a.close()}}e.$4M=g}),define(te[123],ie([0,1,4,36,31]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=void 0;function M(f){if(k.$t===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,h,$,g,p,u,y,v){const c=Object.create(null);c["common.machineId"]=u,c.sessionID=(0,s.$3e)()+Date.now(),c.commitHash=g,c.version=p,c["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,k.$h)(k.$t),c["common.nodePlatform"]=O.$2c,c["common.nodeArch"]=$,c["common.product"]=v||"desktop",y&&(c["common.msftInternal"]=y);let d=0;const l=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),k.$l&&(c["common.snap"]="true");const w=M(h);return w&&(c["common.platformDetail"]=w),c}e.$2n=D;function E(f){const h=O.env.USERDNSDOMAIN;if(!h)return!1;const $=h.toLowerCase();return f.some(g=>$===g)}e.$3n=E}),define(te[25],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,k.$ph)("telemetryService"),e.$Wk=(0,k.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[249],ie([0,1,27,8,44,15,9,4,7,87,21,108,91,16,22,25]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=void 0;const c=new Map;async function d(t,a){const r=`${t}::${a.join(":")}`,i=c.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,b=new Map,I=2e4;function A(C,j,U,W){const re=j.substring(C.length+1);return O.Promises.withAsyncBody(async ne=>{let fe;try{fe=await $.Promises.readdir(j,{withFileTypes:!0})}catch{ne();return}if(W.count>=I){W.count+=fe.length,W.maxReached=!0,ne();return}let ae=fe.length;if(ae===0){ne();return}let ue=fe;W.count+fe.length>I&&(W.maxReached=!0,ae=I-W.count,ue=fe.slice(0,ae)),W.count+=fe.length;for(const V of ue)if(V.isDirectory()){if(U.includes(V.name)||await A(C,(0,D.$8c)(j,V.name),U,W),--ae===0){ne();return}}else{const J=V.name.lastIndexOf(".");if(J>=0){const z=V.name.substring(J+1);z&&o.set(z,(o.get(z)??0)+1)}for(const z of n)z.relativePathPattern?.test(re)!==!1&&z.filePattern.test(V.name)&&b.set(z.tag,(b.get(z.tag)??0)+1);if(--ae===0){ne();return}}})}const P=O.Promises.withAsyncBody(async C=>{const j={count:0,maxReached:!1};await A(t,t,a,j);const U=await S(t);C({configFiles:l(b),fileTypes:l(o),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:U})});return c.set(r,P),P}e.$kr=d;function l(t){return Array.from(t.entries(),([a,r])=>({name:a,count:r})).sort((a,r)=>r.count-a.count)}function w(){const t={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/u.$nk.GB).toFixed(2)}GB (${(k.freemem()/u.$nk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$um.value()*100)}%`},a=k.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.$lr=w;async function S(t){try{const a=new Map,r=(0,D.$8c)(t,".vscode","launch.json"),i=await $.Promises.readFile(r),n=[],o=(0,s.$ym)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$Hm)(o)==="object"&&o.configurations)for(const b of o.configurations){const I=b.type;I&&(a.has(I)?a.set(I,a.get(I)+1):a.set(I,1))}return l(a)}catch{return[]}}e.$mr=S;let m=class{constructor(a,r){this.c=a,this.d=r}f(a){const r=[];return r.push(`OS Version:       ${a.os}`),r.push(`CPUs:             ${a.cpus}`),r.push(`Memory (System):  ${a.memory}`),r.push(`VM:               ${a.vmHint}`),r.join(`
`)}g(a){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const i=k.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(k.totalmem()/u.$nk.GB).toFixed(2)}GB (${(k.freemem()/u.$nk.GB).toFixed(2)}GB free)`),E.$i||r.push(`Load (avg):       ${k.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(h.$um.value()*100)}%`),r.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${a.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(a,r){return Promise.all([(0,g.$jr)(a.mainPID),this.k(a)]).then(async i=>{let[n,o]=i,b=this.m(a,n);return r.forEach(I=>{if((0,p.$7l)(I))b+=`
${I.errorMessage}`,o+=`
${I.errorMessage}`;else if(b+=`

Remote: ${I.hostName}`,I.processes&&(b+=`
${this.m(a,I.processes)}`),I.workspaceMetadata){o+=`
|  Remote: ${I.hostName}`;for(const A of Object.keys(I.workspaceMetadata)){const P=I.workspaceMetadata[A];let C=`${P.fileCount} files`;P.maxFilesReached&&(C=`more than ${C}`),o+=`|    Folder (${A}): ${C}`,o+=this.h(P)}}}),{processInfo:b,workspaceInfo:o}})}async getSystemInfo(a,r){const{memory:i,vmHint:n,os:o,cpus:b}=w(),I={os:o,memory:i,cpus:b,vmHint:n,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:r};return E.$i||(I.load=`${k.loadavg().map(A=>Math.round(A)).join(", ")}`),E.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(a,r){const i=[];return(0,g.$jr)(a.mainPID).then(async n=>(i.push(""),i.push(this.g(a)),i.push(""),i.push(this.m(a,n)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(a))),r.forEach(o=>{if((0,p.$7l)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(a,o.processes)),o.workspaceMetadata)for(const b of Object.keys(o.workspaceMetadata)){const I=o.workspaceMetadata[b];let A=`${I.fileCount} files`;I.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${b}): ${A}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(a){const r=[];let n=0;const o=(P,C)=>{const j=` ${P}(${C})`;n+j.length>60?(r.push(b),b="|                 ",n=b.length):n+=j.length,b+=j};let b="|      File types:";const I=10,A=a.fileTypes.length>I?I:a.fileTypes.length;for(let P=0;P<A;P++){const C=a.fileTypes[P];o(C.name,C.count)}if(r.push(b),a.configFiles.length>=0&&(b="|      Conf files:",n=0,a.configFiles.forEach(P=>{o(P.name,P.count)}),r.push(b)),a.launchConfigFiles.length>0){let P="|      Launch Configs:";a.launchConfigFiles.forEach(C=>{const j=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;P+=j}),r.push(P)}return r.join(`
`)}j(a){const r=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${a[i]}`).join(`
                  `)}k(a){const r=[],i=[];return a.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const b=f.URI.revive(o);if(b.scheme===M.Schemas.file){const I=b.fsPath;i.push(d(I,["node_modules",".git"]).then(A=>{let P=`${A.fileCount} files`;A.maxFilesReached&&(P=`more than ${P}`),r.push(`|    Folder (${(0,D.$_c)(I)}): ${P}`),r.push(this.h(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${I} (${A.toString()})`)}))}else r.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(a,r){const i=new Map;a.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),a.pidToNames.forEach(({pid:o,name:b})=>i.set(o,b));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(a.mainPID,i,n,r,0),n.join(`
`)}n(a,r,i,n,o){const b=o===0;let I;b?I=n.pid===a?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?I=r.get(n.pid):I=`${"  ".repeat(o)} ${n.name}`;const A=process.platform==="win32"?n.mem:k.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(A/u.$nk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(n.children)&&n.children.forEach(P=>this.n(a,r,i,P,o+1))}async getWorkspaceFileExtensions(a){const r=new Set;for(const{uri:i}of a.folders){const n=f.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const o=n.fsPath;try{(await d(o,["node_modules",".git"])).fileTypes.forEach(I=>r.add(I.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(a){for(const{uri:r}of a.folders){const i=f.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const o=await d(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:b.name,count:b.count})}),o.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:b.name,count:b.count})}),o.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$nr=m,e.$nr=m=ke([Q(0,v.$Vk),Q(1,y.$0i)],m)}),define(te[250],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P5b=e.$O5b=void 0;class k{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:E,data:f}){return this.b.forEach(h=>h.log(E,f)),Promise.resolve(null)}}e.$O5b=k;class O{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$P5b=O}),define(te[52],ie([0,1,37,12,3,18,60,123,25]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0;class h{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$4n=h;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5n=$,e.$6n=new $;class g{async publicLog(n,o,b){}async publicLogError(n,o,b){}}e.$7n=g,e.$8n="telemetry",e.$9n="extensionTelemetryLog",e.$0n={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(b,I)=>{const A=b?new Set([...b.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:A}},1e3,!0)(b=>{b.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$Yh)(b.source),configurationKeys:Array.from(b.affectedKeys)})})}e.$$n=p;function u(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$_n=u;function y(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$ao=y;function v(i){const n=i.getValue(f.$3k),o=i.getValue(f.$4k);if(i.getValue(f.$5k)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$bo=v;function c(i){const n={},o={},b={};w(i,b);for(let I in b){I=I.length>150?I.substr(I.length-149):I;const A=b[I];typeof A=="number"?o[I]=A:typeof A=="boolean"?o[I]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${A.length}`),n[I]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(n[I]=A)}return{properties:n,measurements:o}}e.$co=c;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(i){if(!i)return"none";const n=(0,D.$Ck)(i);return d.has(n)?n:"other"}e.$do=l;function w(i,n,o=0,b){if(i)for(const I of Object.getOwnPropertyNames(i)){const A=i[I],P=b?b+I:I;Array.isArray(A)?n[P]=(0,k.$Nm)(A):A instanceof Date?n[P]=A.toISOString():(0,O.$ke)(A)?o<2?w(A,n,o+1,P+"."):n[P]=(0,k.$Nm)(A):n[P]=A}}function S(i,n){const o=i.msftInternalDomains||[],b=n.getValue("telemetry.internalTesting");return(0,E.$3n)(o)||b}e.$eo=S;function m(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$fo=m;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const b=[];for(const C of n)for(;;){const j=C.exec(i);if(!j)break;b.push([j.index,C.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(o="";;){const C=A.exec(i);if(!C)break;const j=b.some(([U,W])=>C.index<W&&U<A.lastIndex);!I.test(C[0])&&!j&&(o+=i.substring(P,C.index)+"<REDACTED: user-file-path>",P=A.lastIndex)}return P<i.length&&(o+=i.substr(P)),o}function a(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function r(i,n){return(0,k.$Km)(i,o=>{if(o instanceof h||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let b=o.replaceAll("%20"," ");b=t(b,n);for(const I of n)b=b.replace(I,"");return b=a(b),b}})}e.$go=r}),define(te[124],ie([0,1,26,117,121,4,7,13,36,52]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;function $(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,k.$Gd)(r.id,i.id)===0}e.$ho=$;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,o)}static parse(i){const n=g.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?$(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$io=p;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=u.exec(r);return i&&i[1]?[c(i[1]),i[2]]:[c(r),void 0]}e.$jo=y;function v(r,i){return`${r}.${i}`}e.$ko=v;function c(r){return r.toLowerCase()}e.$lo=c;function d(r,i){return c(v(r??s.$El,i))}e.$mo=d;function l(r,i){const n=[],o=b=>{for(const I of n)if(I.some(A=>$(i(A),i(b))))return I;return null};for(const b of r){const I=o(b);I?I.push(b):n.push([b])}return n}e.$no=l;function w(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$oo=w;function S(r){return{id:new h.$4n(r.identifier.id),name:new h.$4n(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$po=S,e.$qo=new s.$Il("pprice.better-merge");function m(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const b=o.shift();if(b&&n.every(I=>!$(I.identifier,{id:b}))){const I=r.filter(A=>$(A.identifier,{id:b}));I.length===1&&(n.push(I[0]),o.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$ro=m;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,E.$9)(b))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,i){const n=await t(r,i),o=(0,O.$Mn)(n?"alpine":M.$t,f.$3c);return i.debug("ComputeTargetPlatform:",o),o}e.$so=a}),define(te[251],ie([0,1,204,52]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;async function s(M,D,E,f,h,$,g){const p={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,O.$_n)(D,E)&&(0,O.$bo)(f)===3){const u=await(0,k.$So)(E,h,$);p["X-Market-User-Id"]=u,p["VSCode-SessionId"]=g.machineId||u}return p}e.$To=s}),define(te[252],ie([0,1,2,37,4,26,183,18,59,78,22,43,25,52]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,l,w){this.k=l,this.l=w,this.d={},this.i=new k.$kb,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,M.$pd)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$pd)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(p.$3k)||S.affectsConfiguration(p.$5k)||S.affectsConfiguration(p.$4k))&&this.m()}))}setExperimentProperty(d,l){this.d[d]=l}m(){let d=(0,u.$bo)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const w=l.usage?3:l.error?2:0;d=Math.min(d,w)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,l,w){this.g<l||(w=(0,O.$Lm)(w,this.d),w=(0,u.$go)(w,this.j),w=(0,O.$Lm)(w,this.c),this.b.forEach(S=>S.log(d,w)))}publicLog(d,l){this.n(d,3,l)}publicLog2(d,l){this.publicLog(d,l)}publicLogError(d,l){this.h&&this.n(d,2,l)}publicLogError2(d,l){this.publicLogError(d,l)}};e.$Hq=y,e.$Hq=y=ke([Q(1,E.$Vh),Q(2,$.$0i)],y);function v(){const c=(0,D.localize)(0,null,h.default.nameLong),d=h.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",h.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=s.$o?"":(0,D.localize)(3,null),w=(0,D.localize)(4,null),S=(0,D.localize)(5,null),m=(0,D.localize)(6,null),t=(0,D.localize)(7,null),a=`
|       | ${w} | ${S} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${c} ${d} ${l}

&nbsp;

${t}
${a}

&nbsp;

${r}
`}g.$Um.as(f.$Zm.Configuration).registerConfiguration({id:p.$2k,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[p.$3k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.$Um.as(f.$Zm.Configuration).registerConfiguration({id:p.$2k,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[p.$5k]:{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,D.localize)(16,null,h.default.nameLong,h.default.privacyStatementUrl):(0,D.localize)(15,null,h.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${p.$3k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[253],ie([0,1,4,87,25]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=void 0;async function M(D,E){let f=D.getItem(s.$1k);return(typeof f!="string"||k.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,O.$vm)(E.error.bind(E))),f}e.$g6b=M}),define(te[254],ie([0,1,25,253]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=void 0;async function s(M,D){const E=await(0,O.$g6b)(M,D);return M.setItem(k.$1k,E),E}e.$h6b=s}),define(te[125],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var k;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(k||(e.EnvironmentVariableMutatorType=k={}))}),define(te[255],ie([0,1,4,125]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;const s=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor($){this.collections=$,this.a=new Map,this.b=new Map,$.forEach((g,p)=>{this.d(g,p);const u=g.map.entries();let y=u.next();for(;!y.done;){const v=y.value[1],c=y.value[0];let d=this.a.get(c);if(d||(d=[],this.a.set(c,d)),d.length>0&&d[0].type===O.EnvironmentVariableMutatorType.Replace){y=u.next();continue}const l={extensionIdentifier:p,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};l.scope||delete l.scope,d.unshift(l),y=u.next()}})}async applyToProcessEnvironment($,g,p){let u;k.$i&&(u={},Object.keys($).forEach(y=>u[y.toLowerCase()]=y));for(const[y,v]of this.getVariableMap(g)){const c=k.$i&&u[y.toLowerCase()]||y;for(const d of v){const l=p?await p(d.value):d.value;if(d.options?.applyAtProcessCreation??!0)switch(d.type){case O.EnvironmentVariableMutatorType.Append:$[c]=($[c]||"")+l;break;case O.EnvironmentVariableMutatorType.Prepend:$[c]=l+($[c]||"");break;case O.EnvironmentVariableMutatorType.Replace:$[c]=l;break}if(d.options?.applyAtShellIntegration??!1){const w=`VSCODE_ENV_${s.get(d.type)}`;$[w]=($[w]?$[w]+":":"")+y+"="+this.c(l)}}}}c($){return $.replaceAll(":","\\x3a")}diff($,g){const p=new Map,u=new Map,y=new Map;if($.getVariableMap(g).forEach((v,c)=>{const d=this.getVariableMap(g).get(c),l=E(v,d);l&&p.set(c,l)}),this.getVariableMap(g).forEach((v,c)=>{const d=$.getVariableMap(g).get(c),l=E(v,d);l&&y.set(c,l)}),this.getVariableMap(g).forEach((v,c)=>{const d=$.getVariableMap(g).get(c),l=f(v,d);l&&u.set(c,l)}),!(p.size===0&&u.size===0&&y.size===0))return{added:p,changed:u,removed:y}}getVariableMap($){const g=new Map;for(const p of this.a.values()){const u=p.filter(y=>D(y,$));u.length>0&&g.set(u[0].variable,u)}return g}getDescriptionMap($){const g=new Map;for(const p of this.b.values()){const u=p.filter(y=>D(y,$,!0));for(const y of u)g.set(y.extensionIdentifier,y.description)}return g}d($,g){if(!$.descriptionMap)return;const p=$.descriptionMap.entries();let u=p.next();for(;!u.done;){const y=u.value[1],v=u.value[0];let c=this.b.get(v);c||(c=[],this.b.set(v,c));const d={extensionIdentifier:g,scope:y.scope,description:y.description};d.scope||delete d.scope,c.push(d),u=p.next()}}}e.$0q=M;function D(h,$,g=!1){return h.scope?!!(h.scope.workspaceFolder&&$?.workspaceFolder&&h.scope.workspaceFolder.index===$.workspaceFolder.index):g?$===h.scope:!0}function E(h,$){if(!$)return h;const g=new Set;$.forEach(u=>g.add(u.extensionIdentifier));const p=[];return h.forEach(u=>{g.has(u.extensionIdentifier)||p.push(u)}),p.length===0?void 0:p}function f(h,$){if(!$)return;const g=new Map;$.forEach(u=>g.set(u.extensionIdentifier,u));const p=[];return h.forEach(u=>{const y=g.get(u.extensionIdentifier);y&&(u.type!==y.type||u.value!==y.value||u.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&p.push(y)}),p.length===0?void 0:p}}),define(te[256],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=void 0;function k(f){return[...f.entries()]}e.$4q=k;function O(f){return f?[...f.entries()]:[]}e.$5q=O;function s(f){return new Map(f)}e.$6q=s;function M(f){return new Map(f??[])}e.$7q=M;function D(f){return Array.from(f.entries()).map(h=>[h[0],k(h[1].map),O(h[1].descriptionMap)])}e.$8q=D;function E(f){return new Map(f.map(h=>[h[0],{map:s(h[1]),descriptionMap:M(h[2])}]))}e.$9q=E}),define(te[257],ie([0,1,8,23,3,2,5]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;let E=class extends M.$lb{constructor(h,$){super(),this.h=$,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$ec),this.onCreateRequest=this.g.event,this.b=h===void 0?15e3:h}createRequest(h){return new Promise(($,g)=>{const p=++this.a;this.c.set(p,$),this.g.fire({requestId:p,...h});const u=new O.$oc;(0,k.$vg)(this.b,u.token).then(()=>g(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,M.$jb)(()=>u.cancel())])})}acceptReply(h,$){const g=this.c.get(h);g?(this.c.delete(h),(0,M.$gb)(this.f.get(h)||[]),this.f.delete(h),g($)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${h}`)}};e.$Uq=E,e.$Uq=E=ke([Q(1,D.$Ri)],E)}),define(te[126],ie([0,1,6,115,43]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Nq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Mq=void 0,e.$Mq=new O.$Oi("terminalTabFocusMode",!1,!0);var M;(function(m){m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(m){m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationProfileLinux="terminal.integrated.automationProfile.linux",m.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",m.AutomationProfileWindows="terminal.integrated.automationProfile.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsDefaultColor="terminal.integrated.tabs.defaultColor",m.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.TabStopWidth="terminal.integrated.tabStopWidth",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorStyleInactive="terminal.integrated.cursorStyleInactive",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.TerminalTitleSeparator="terminal.integrated.tabs.separator",m.TerminalTitle="terminal.integrated.tabs.title",m.TerminalDescription="terminal.integrated.tabs.description",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.ConfirmOnKill="terminal.integrated.confirmOnKill",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.TabFocusMode="terminal.integrated.tabFocusMode",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoEnabled="terminal.integrated.localEchoEnabled",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",m.HideOnStartup="terminal.integrated.hideOnStartup",m.CustomGlyphs="terminal.integrated.customGlyphs",m.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover",m.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",m.AutoReplies="terminal.integrated.autoReplies",m.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",m.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",m.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",m.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",m.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",m.EnableImages="terminal.integrated.enableImages",m.SmoothScrolling="terminal.integrated.smoothScrolling",m.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",m.FocusAfterRun="terminal.integrated.focusAfterRun",m.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",m.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",m.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var E;(function(m){m.PowerShell="pwsh",m.Bash="bash",m.Fish="fish",m.Sh="sh",m.Csh="csh",m.Ksh="ksh",m.Zsh="zsh"})(E||(e.PosixShellType=E={}));var f;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var h;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence",m[m.Config=3]="Config"})(h||(e.TitleEventSource=h={}));var $;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.PtyHostWindow="ptyHostWindow",m.Logger="logger",m.Heartbeat="heartbeat"})($||(e.TerminalIpcChannels=$={}));var g;(function(m){m.Cwd="cwd",m.InitialCwd="initialCwd",m.FixedDimensions="fixedDimensions",m.Title="title",m.ShellType="shellType",m.HasChildProcesses="hasChildProcesses",m.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",m.OverrideDimensions="overrideDimensions",m.FailedShellIntegrationActivation="failedShellIntegrationActivation",m.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(g||(e.ProcessPropertyType=g={})),e.$Nq=(0,k.$ph)("ptyService");var p;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var u;(function(m){m[m.Panel=1]="Panel",m[m.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var y;(function(m){m.TerminalView="view",m.Editor="editor"})(y||(e.TerminalLocationString=y={}));var v;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var c;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(c||(e.FlowControlConstants=c={}));var d;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var l;(function(m){m[m.Off=0]="Off",m[m.FinalTerm=1]="FinalTerm",m[m.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var w;(function(m){m[m.Unknown=0]="Unknown",m[m.Shutdown=1]="Shutdown",m[m.Process=2]="Process",m[m.User=3]="User",m[m.Extension=4]="Extension"})(w||(e.TerminalExitReason=w={})),e.$Oq={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const a=this.b(t.remoteAuthority);if(this.a.has(a))throw new Error(`A terminal backend with remote authority '${a}' was already registered.`);this.a.set(a,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$Um.add(e.$Oq.Backend,new S),e.$Pq=(0,k.$ph)("localPtyService"),e.$Qq=(0,k.$ph)("terminalLogService")}),define(te[258],ie([0,1,71,7,185,103]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0;function D(p,u){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...p.map(v=>({name:v.profileName,description:E(v)}))),u&&y.push(...u.map(v=>({name:v.title,description:f(v)}))),{values:y.map(v=>v.name),markdownDescriptions:y.map(v=>v.description)}}e.$Vq=D;function E(p){let u=`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:k.$Cj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?u+=`
- args: "${p.args}"`:u+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(u+=`
- overrideName: ${p.overrideName}`),p.color&&(u+=`
- color: ${p.color}`),p.env&&(u+=`
- env: ${JSON.stringify(p.env)}`),u}function f(p){return`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:k.$Cj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function h(p,u){if(!p&&!u)return!0;if(typeof p=="string"&&typeof u=="string")return p===u;if(Array.isArray(p)&&Array.isArray(u)){if(p.length!==u.length)return!1;for(let y=0;y<p.length;y++)if(p[y]!==u[y])return!1;return!0}return!1}e.$Wq=h;function $(p,u){if(!p&&!u)return!0;if(!p||!u)return!1;if(M.ThemeIcon.isThemeIcon(p)&&M.ThemeIcon.isThemeIcon(u))return p.id===u.id&&p.color===u.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof u=="object"&&"light"in u&&"dark"in u){const y=p,v=u;if((O.URI.isUri(y.light)||g(y.light))&&(O.URI.isUri(y.dark)||g(y.dark))&&(O.URI.isUri(v.light)||g(v.light))&&(O.URI.isUri(v.dark)||g(v.dark)))return y.light.path===v.light.path&&y.dark.path===v.dark.path}if(O.URI.isUri(p)&&O.URI.isUri(u)||g(p)||g(u)){const y=p,v=u;return y.path===v.path&&y.scheme===v.scheme}return!1}e.$Xq=$;function g(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$Yq=g}),define(te[259],ie([0,1,71,4,184,59,43,258]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=e.$Zq=void 0,e.$Zq={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$1q={type:"string",enum:Array.from((0,k.$Bj)(),c=>c.id),markdownEnumDescriptions:Array.from((0,k.$Bj)(),c=>`$(${c.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$1q},color:{description:(0,s.localize)(3,null),...e.$Zq},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},h={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},$={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function g(c){const d=c===2?"linux":c===1?"osx":"windows";return(0,s.localize)(7,null,(0,O.$h)(c),'```json\n"terminal.integrated.profile.'+d+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:g(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},h]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:g(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},h]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:g(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},h]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,s.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){D.$Um.as(M.$Zm.Configuration).registerConfiguration(p),v()}e.$2q=u;let y;function v(c,d){const l=D.$Um.as(M.$Zm.Configuration);let w;c&&(w=(0,E.$Vq)(c?.profiles,d));const S=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:c?.os===3?w?.values:void 0,markdownEnumDescriptions:c?.os===3?w?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:c?.os===2?w?.values:void 0,markdownEnumDescriptions:c?.os===2?w?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:c?.os===1?w?.values:void 0,markdownEnumDescriptions:c?.os===1?w?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[y],remove:S?[S]:[]})}e.$3q=v}),define(te[260],ie([0,1,27,15,37,9,4,36,26,12,21,125,256,255]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$$q=y;async function v(i,n,o,b=E.env,I=$.Promises.exists){if(M.$7c(i))return await I(i)?i:void 0;if(n===void 0&&(n=E.cwd()),M.$$c(i)!=="."){const j=M.$8c(n,i);return await I(j)?j:void 0}const P=(0,s.$Pm)(b,"PATH");if(o===void 0&&(0,h.$ie)(P)&&(o=P.split(M.$fd)),o===void 0||o.length===0){const j=M.$8c(n,i);return await I(j)?j:void 0}for(const j of o){let U;if(M.$7c(j)?U=M.$8c(j,i):U=M.$8c(n,j,i),await I(U))return U;if(D.$i){let W=U+".com";if(await I(W)||(W=U+".exe",await I(W)))return W}}const C=M.$8c(n,i);return await I(C)?C:void 0}e.$_q=v;function c(i,n,o,b,I){const A=D.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||A)return;const P=i.args,C=E.$2c==="win32"?M.$_c(i.executable).toLowerCase():M.$_c(i.executable),j=M.$$c(O.$1e.asFileUri("").fsPath);let U;const W={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(W.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!P||a(P)?U=w.get(l.WindowsPwsh):t(P)&&(U=w.get(l.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$md)(U[U.length-1],j,""),{newArgs:U,envMixin:W}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!P||P.length===0?U=w.get(l.Bash):r(P)&&(W.VSCODE_SHELL_LOGIN="1",d(n,W),U=w.get(l.Bash)),U?(U=[...U],U[U.length-1]=(0,f.$md)(U[U.length-1],j),{newArgs:U,envMixin:W}):void 0;case"fish":{const re=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ne=M.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return W.XDG_DATA_DIRS=`${re}:${ne}`,d(n,W),{newArgs:void 0,envMixin:W}}case"pwsh":return!P||a(P)?U=w.get(l.Pwsh):t(P)&&(U=w.get(l.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$md)(U[U.length-1],j,""),{newArgs:U,envMixin:W}):void 0;case"zsh":{if(!P||P.length===0?U=w.get(l.Zsh):r(P)?(U=w.get(l.ZshLogin),d(n,W)):(P===w.get(l.Zsh)||P===w.get(l.ZshLogin))&&(U=P),!U)return;U=[...U],U[U.length-1]=(0,f.$md)(U[U.length-1],j);let re;try{re=k.userInfo().username}catch{re="unknown"}const ne=M.$8c(k.tmpdir(),`${re}-${I.applicationName}-zsh`);W.ZDOTDIR=ne;const fe=o?.ZDOTDIR??k.homedir()??"~";W.USER_ZDOTDIR=fe;const ae=[];return ae.push({source:M.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$8c(ne,".zshrc")}),ae.push({source:M.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$8c(ne,".zprofile")}),ae.push({source:M.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$8c(ne,".zshenv")}),ae.push({source:M.$8c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$8c(ne,".zlogin")}),{newArgs:U,envMixin:W,filesToCopy:ae}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$ar=c;function d(i,n){if(D.$j&&i.environmentVariableCollections){const o=(0,p.$9q)(i.environmentVariableCollections),I=new u.$0q(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),A=[];if(I)for(const P of I)P.type===g.EnvironmentVariableMutatorType.Prepend&&A.push(P.value);A.length>0&&(n.VSCODE_PATH_PREFIX=A.join(""))}}var l;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(l||(l={}));const w=new Map;w.set(l.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(l.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(l.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),w.set(l.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),w.set(l.Zsh,["-i"]),w.set(l.ZshLogin,["-il"]),w.set(l.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],m=["-nol","-nologo"];function t(i){return typeof i=="string"?S.includes(i.toLowerCase()):i.length===1&&S.includes(i[0].toLowerCase())||i.length===2&&(S.includes(i[0].toLowerCase())||S.includes(i[1].toLowerCase()))&&(m.includes(i[0].toLowerCase())||m.includes(i[1].toLowerCase()))}function a(i){return typeof i=="string"?m.includes(i.toLowerCase()):i.length===0||i?.length===1&&m.includes(i[0].toLowerCase())}function r(i){return i==="string"&&S.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&S.includes(i[0].toLowerCase())}}),define(te[261],ie([0,1,47,71,9,4,12,21,107,260,114]),function(H,e,k,O,s,M,D,E,f,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;let g,p=!0;function u(n,o,b,I,A=process.env,P,C,j,U){return P=P||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},M.$i?y(b,P,A,C,I.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:I.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:I.getValue("terminal.integrated.defaultProfile.windows"),U,j):a(P,C,b,n&&typeof n=="object"?{...n}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,j,A)}e.$br=u;async function y(n,o,b,I,A,P,C,j,U){const W=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${W?"Sysnative":"System32"}`;let ne=!1;(0,h.$$q)()>=16299&&(ne=!0),await l(j);const fe=new Map;if(n){fe.set("PowerShell",{source:"PowerShell",icon:O.$Cj.terminalPowershell,isAutoDetected:!0}),fe.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$Cj.terminalPowershell,isAutoDetected:!0}),fe.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),fe.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:O.$Cj.terminalCmd,isAutoDetected:!0}),fe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),fe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$Cj.terminalBash,isAutoDetected:!0});const ue=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;fe.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",ue],requiresPath:process.env.CMDER_ROOT?ue:{path:ue,isUnsafe:!0},isAutoDetected:!0})}r(P,fe);const ae=await v(fe.entries(),C,o,b,I,U);if(n&&A)try{const ue=await m(`${re}\\${ne?"wsl":"bash"}.exe`,C);for(const V of ue)(!P||!(V.profileName in P))&&ae.push(V)}catch{p&&(I?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return ae}async function v(n,o,b,I=process.env,A,P){const C=[];for(const[j,U]of n)C.push(c(j,U,o,b,I,A,P));return(await Promise.all(C)).filter(j=>!!j)}async function c(n,o,b,I,A=process.env,P,C){if(o===null)return;let j,U,W;if("source"in o&&!("path"in o)){const ae=g?.get(o.source);if(!ae)return;j=ae.paths,U=o.args||ae.args,o.icon?W=d(o.icon):ae.icon&&(W=ae.icon)}else j=Array.isArray(o.path)?o.path:[o.path],U=M.$i||Array.isArray(o.args)?o.args:void 0,W=d(o.icon);let re;if(C){const ae=j.map(V=>typeof V=="string"?V:V.path),ue=await C(ae);re=new Array(j.length);for(let V=0;V<j.length;V++)typeof j[V]=="string"?re[V]=ue[V]:re[V]={path:ue[V],isUnsafe:!0}}else re=j.slice();let ne;if(o.requiresPath){let ae;if((0,D.$ie)(o.requiresPath)?ae=o.requiresPath:(ae=o.requiresPath.path,o.requiresPath.isUnsafe&&(ne=ae)),!await I.existsFile(ae))return}const fe=await i(n,b,re,I,A,U,o.env,o.overrideName,o.isAutoDetected,ne);if(!fe){P?.debug("Terminal profile not validated",n,j);return}return fe.isAutoDetected=o.isAutoDetected,fe.icon=W,fe.color=o.color,fe}function d(n){return typeof n=="string"?{id:n}:n}async function l(n){if(g&&!n)return;const[o,b]=await Promise.all([w(),n||S()]);g=new Map,g.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),g.set("PowerShell",{profileName:"PowerShell",paths:b,icon:O.$Cj.terminalPowershell})}async function w(){const n=new Set,o=await(0,h.$_q)("git.exe");if(o){const A=(0,$.dirname)(o);n.add((0,$.resolve)(A,"../.."))}function b(A,P){P&&A.add(P)}b(n,process.env.ProgramW6432),b(n,process.env.ProgramFiles),b(n,process.env["ProgramFiles(X86)"]),b(n,`${process.env.LocalAppData}\\Program`);const I=[];for(const A of n)I.push(`${A}\\Git\\bin\\bash.exe`,`${A}\\Git\\usr\\bin\\bash.exe`,`${A}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function S(){const n=[];for await(const o of(0,f.$dl)())n.push(o.exePath);return n}async function m(n,o){const b=[],I=await new Promise((C,j)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,W)=>{if(U)return j("Problem occurred when getting wsl distros");C(W)})});if(!I)return[];const A=new RegExp(/[\r?\n]/),P=I.split(A).filter(C=>C.trim().length>0&&C!=="");for(const C of P){if(C===""||C.startsWith("docker-desktop"))continue;const j=`${C} (WSL)`,U={profileName:j,path:n,args:["-d",`${C}`],isDefault:j===o,icon:t(C),isAutoDetected:!1};b.push(U)}return b}function t(n){return n.includes("Ubuntu")?O.$Cj.terminalUbuntu:n.includes("Debian")?O.$Cj.terminalDebian:O.$Cj.terminalLinux}async function a(n,o,b,I,A,P,C,j){const U=new Map;if(b){const W=(await n.readFile("/etc/shells")).toString(),re=(P||W.split(`
`)).map(fe=>{const ae=fe.indexOf("#");return ae===-1?fe:fe.substring(0,ae)}).filter(fe=>fe.trim().length>0),ne=new Map;for(const fe of re){let ae=(0,s.$_c)(fe),ue=ne.get(ae)||0;ue++,ue>1&&(ae=`${ae} (${ue})`),ne.set(ae,ue),U.set(ae,{path:fe,isAutoDetected:!0})}}return r(I,U),await v(U.entries(),A,n,j,o,C)}function r(n,o){if(n)for(const[b,I]of Object.entries(n))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?o.delete(b):(I.icon=I.icon||o.get(b)?.icon,o.set(b,I))}async function i(n,o,b,I,A,P,C,j,U,W){if(b.length===0)return Promise.resolve(void 0);const re=b.shift();if(re==="")return i(n,o,b,I,A,P,C,j,U);const ne=typeof re!="string"&&re.isUnsafe,fe=typeof re=="string"?re:re.path,ae={profileName:n,path:fe,args:P,env:C,overrideName:j,isAutoDetected:U,isDefault:n===o,isUnsafePath:ne,requiresUnsafePath:W};if((0,s.$_c)(fe)===fe){const V=A.PATH?A.PATH.split(s.$fd):void 0,J=await(0,h.$_q)(fe,void 0,V,void 0,I.existsFile);return J?(ae.path=J,ae.isFromPath=!0,ae):i(n,o,b,I,A,P)}return await I.existsFile((0,s.$6c)(fe))?ae:i(n,o,b,I,A,P,C,j,U)}}),define(te[262],ie([0,1,3,2,4,42,18,5,224,95,257,126,259,261,109,69]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;var c;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(c||(c={}));let d=class extends O.$lb{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.P()}constructor(w,S,m,t){super(),this.H=w,this.I=S,this.J=m,this.L=t,this.j=!1,this.k=0,this.l=!0,this.m=!1,this.r=this.B(new k.$ec),this.onPtyHostExit=this.r.event,this.s=this.B(new k.$ec),this.onPtyHostStart=this.s.event,this.t=this.B(new k.$ec),this.onPtyHostUnresponsive=this.t.event,this.u=this.B(new k.$ec),this.onPtyHostResponsive=this.u.event,this.v=this.B(new k.$ec),this.onPtyHostRequestResolveVariables=this.v.event,this.w=this.B(new k.$ec),this.onProcessData=this.w.event,this.y=this.B(new k.$ec),this.onProcessReady=this.y.event,this.z=this.B(new k.$ec),this.onProcessReplay=this.z.event,this.C=this.B(new k.$ec),this.onProcessOrphanQuestion=this.C.event,this.D=this.B(new k.$ec),this.onDidRequestDetach=this.D.event,this.F=this.B(new k.$ec),this.onDidChangeProperty=this.F.event,this.G=this.B(new k.$ec),this.onProcessExit=this.G.event,(0,p.$2q)(),this.B(this.H),this.B((0,O.$jb)(()=>this.Q())),this.i=this.B(new $.$Uq(void 0,this.J)),this.i.onCreateRequest(this.v.fire,this.v),this.H.onRequestConnection&&k.Event.once(this.H.onRequestConnection)(()=>this.h()),this.H.onWillShutdown?.(()=>this.j=!0)}get M(){return this.I.getValue("terminal.integrated.ignoreProcessNames")}async N(){return this.g?.refreshIgnoreProcessNames?.(this.M)}async O(){if(s.$i)return process.env;try{return await(0,h.$zl)(this.I,this.J,{_:[]},process.env)}catch(w){return this.J.error("ptyHost was unable to resolve shell environment",w),{}}}P(){const w=this.H.start(),S=w.client;this.J.getLevel()===E.LogLevel.Trace&&this.J.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(S.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.R()),this.R(!0),this.B(w.onDidProcessExit(a=>{this.r.fire(a.code),!this.j&&!this.m&&(this.k<=c.MaxRestarts?(this.J.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.k++,this.restartPtyHost()):this.J.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const t=M.ProxyChannel.toService(S.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(a=>this.w.fire(a))),this.B(t.onProcessReady(a=>this.y.fire(a))),this.B(t.onProcessExit(a=>this.G.fire(a))),this.B(t.onDidChangeProperty(a=>this.F.fire(a))),this.B(t.onProcessReplay(a=>this.z.fire(a))),this.B(t.onProcessOrphanQuestion(a=>this.C.fire(a))),this.B(t.onDidRequestDetach(a=>this.D.fire(a))),this.B(new f.$Tq(this.L,S.getChannel(g.TerminalIpcChannels.Logger))),this.a=w,this.b=t,this.s.fire(),this.B(this.I.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.N()})),this.N(),[w,t]}dispose(){this.m=!0,super.dispose()}async createProcess(w,S,m,t,a,r,i,n,o,b,I){const A=setTimeout(()=>this.W(),g.HeartbeatConstants.CreateProcessTimeout),P=await this.f.createProcess(w,S,m,t,a,r,i,n,o,b,I);return clearTimeout(A),P}updateTitle(w,S,m){return this.f.updateTitle(w,S,m)}updateIcon(w,S,m,t){return this.f.updateIcon(w,S,m,t)}attachToProcess(w){return this.f.attachToProcess(w)}detachFromProcess(w,S){return this.f.detachFromProcess(w,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(w){return this.f.start(w)}shutdown(w,S){return this.f.shutdown(w,S)}input(w,S){return this.f.input(w,S)}processBinary(w,S){return this.f.processBinary(w,S)}resize(w,S,m){return this.f.resize(w,S,m)}clearBuffer(w){return this.f.clearBuffer(w)}acknowledgeDataEvent(w,S){return this.f.acknowledgeDataEvent(w,S)}setUnicodeVersion(w,S){return this.f.setUnicodeVersion(w,S)}getInitialCwd(w){return this.f.getInitialCwd(w)}getCwd(w){return this.f.getCwd(w)}async getLatency(){const w=new v.$ac,S=await this.f.getLatency();return w.stop(),[{label:"ptyhostservice<->ptyhost",latency:w.elapsed()},...S]}orphanQuestionReply(w){return this.f.orphanQuestionReply(w)}installAutoReply(w,S){return this.f.installAutoReply(w,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(w){return this.f.uninstallAutoReply(w)}getDefaultSystemShell(w){return this.g?.getDefaultSystemShell(w)??(0,y.$jl)(w??s.OS,process.env)}async getProfiles(w,S,m,t=!1){const a=await this.O();return(0,u.$br)(S,m,t,this.I,a,void 0,this.J,this.Y.bind(this,w))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(w,S){return this.f.getWslPath(w,S)}getRevivedPtyNewId(w,S){return this.f.getRevivedPtyNewId(w,S)}setTerminalLayoutInfo(w){return this.f.setTerminalLayoutInfo(w)}async getTerminalLayoutInfo(w){return this.g?.getTerminalLayoutInfo(w)}async requestDetachInstance(w,S){return this.f.requestDetachInstance(w,S)}async acceptDetachInstanceReply(w,S){return this.f.acceptDetachInstanceReply(w,S)}async freePortKillProcess(w){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(w)}async serializeTerminalState(w){return this.f.serializeTerminalState(w)}async reviveTerminalProcesses(w,S,m){return this.f.reviveTerminalProcesses(w,S,m)}async refreshProperty(w,S){return this.f.refreshProperty(w,S)}async updateProperty(w,S,m){return this.f.updateProperty(w,S,m)}async restartPtyHost(){this.Q(),this.l=!0,this.P()}Q(){this.f.shutdownAll(),this.c.store.dispose()}R(w){this.X(),this.n=setTimeout(()=>this.S(),w?g.HeartbeatConstants.ConnectingBeatInterval:g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.l||(this.l=!0,this.u.fire())}S(){this.J.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.n=void 0,this.p=setTimeout(()=>this.U(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}U(){this.J.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.p=void 0,this.l&&(this.l=!1,this.t.fire())}W(){this.X(),this.J.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.l&&(this.l=!1,this.t.fire())}X(){this.n&&(clearTimeout(this.n),this.n=void 0),this.p&&(clearTimeout(this.p),this.p=void 0)}Y(w,S){return this.i.createRequest({workspaceId:w,originalText:S})}async acceptPtyHostResolvedVariables(w,S){this.i.acceptReply(w,S)}};e.$cr=d,e.$cr=d=ke([Q(1,D.$Vh),Q(2,E.$Ri),Q(3,E.$Si)],d)}),define(te[80],ie([0,1,14,3,2,4,18,6,34]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m5b=e.$l5b=void 0;const h="#FFFFFF",$="#1E1E1E",g="#000000",p="#FFFFFF",u="theme",y="themeBackground",v="windowSplash";e.$l5b=(0,E.$ph)("themeMainService");let c=class extends s.$lb{constructor(l,w){super(),this.b=l,this.c=w,this.a=this.B(new O.$ec),this.onDidChangeColorScheme=this.a.event,k.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(k.nativeTheme.shouldUseHighContrastColors)return{dark:k.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(k.nativeTheme.shouldUseInvertedColorScheme||k.nativeTheme.shouldUseHighContrastColors)return{dark:k.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&k.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:k.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const l=this.getColorScheme();if(l.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return l.dark?g:p;let w=this.b.getItem(y,null);if(!w)switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":w=h;break;case"hc-black":w=g;break;case"hc-light":w=p;break;default:w=$}return M.$j&&w.toUpperCase()===$&&(w="#171717"),w}saveWindowSplash(l,w){this.b.setItems([{key:u,data:w.baseTheme},{key:y,data:w.colorInfo.background},{key:v,data:w}]),typeof l=="number"&&this.f(l,w)}f(l,w){for(const S of k.BrowserWindow.getAllWindows())if(S.id===l){S.setBackgroundColor(w.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};e.$m5b=c,e.$m5b=c=ke([Q(0,f.$1M),Q(1,D.$Vh)],c)}),define(te[127],ie([0,1,3,18,6,5]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.$Oz=e.ProvidedOnAutoForward=e.$Nz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Mz=e.$Lz=void 0,e.$Lz=(0,s.$ph)("tunnelService"),e.$Mz=(0,s.$ph)("sharedTunnelsService");var D;(function(c){c.Http="http",c.Https="https"})(D||(e.TunnelProtocol=D={}));var E;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(E||(e.TunnelPrivacyId=E={}));function f(c){return!!c.forwardPort}e.$Nz=f;var h;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function $(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(d)return{address:d[1],port:+d[2]}}e.$Oz=$,e.$Pz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(c){return e.$Pz.indexOf(c)>=0}e.$Qz=g,e.$Rz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(c){return e.$Rz.indexOf(c)>=0}e.$Sz=p;function u(c,d,l,w){if(l===1)return!1;if(l===2&&p(d)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(S?.length===4&&parseInt(S[1])>=18)return!1}return c<1024}e.$Tz=u;class y{constructor(d,l,w){this.remoteAddress=d,this.localAddress=l,this.b=w,this.a=new k.$ec,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Uz=y;let v=class{constructor(d,l){this.j=d,this.k=l,this.a=new k.$ec,this.onTunnelOpened=this.a.event,this.b=new k.$ec,this.onTunnelClosed=this.b.event,this.c=new k.$ec,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const d=this.k.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.f=d,d?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.g=d.elevation,this.h=d.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const d=[],l=Array.from(this.e.values());for(const w of l){const S=Array.from(w.values());for(const m of S){const t=await m.value;t&&typeof t!="string"&&d.push(t)}}return d}async dispose(){for(const d of this.e.values()){for(const{value:l}of d.values())await l.then(w=>typeof w!="string"?w?.dispose():void 0);d.clear()}this.e.clear()}setEnvironmentTunnel(d,l,w,S,m){this.p(d,l,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:l,localAddress:w,privacy:S,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,l){(p(d)||g(d))&&(d=e.$Pz[0]);const w=this.r(d,l);if(w)return++w.refcount,w.value}openTunnel(d,l,w,S,m,t=!1,a,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${w} on local port ${m}.`);const i=this.f??d;if(!i)return;if(l||(l="localhost"),S||(S=this.l),this.f&&this.i.has(w)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,l,w,S,m,t,a,r);return n?n.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(l,w),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(l,w);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.n(o);return(o.tunnelRemoteHost!==l||o.tunnelRemotePort!==w)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&o.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const l=this.e.get(d.tunnelRemoteHost);if(l){const w=l.get(d.tunnelRemotePort);w&&(w.refcount--,await this.o(d.tunnelRemoteHost,d.tunnelRemotePort,w))}}}}async o(d,l,w){if(w.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${l}.`);const S=w.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.e.has(d)&&this.e.get(d).delete(l),S}}async closeTunnel(d,l){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${l} `);const w=this.e.get(d);if(w&&w.has(l)){const S=w.get(l);S.refcount=0,await this.o(d,l,S)}}p(d,l,w){this.e.has(d)||this.e.set(d,new Map),this.e.get(d).set(l,{refcount:1,value:w})}async q(d,l){const w=this.e.get(d);if(w){const S=w.get(l),m=S?await S.value:void 0;(!m||typeof m=="string")&&w.delete(l),w.size===0&&this.e.delete(d)}}r(d,l){const w=[d];g(d)?(w.push(...e.$Pz),w.push(...e.$Rz)):p(d)&&w.push(...e.$Rz);const S=w.map(m=>this.e.get(m));for(const m of S){const t=m?.get(l);if(t)return t}}canTunnel(d){return!!$(d)}t(d,l,w,S,m,t,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${w} on local port ${S}.`);const r=w;this.i.add(r);const i=S===void 0?w:S,n={elevationRequired:m?this.isPortPrivileged(i):!1},o={remoteAddress:{host:l,port:w},localAddressPort:S,privacy:t,public:t?t!==E.Private:void 0,protocol:a},b=d.forwardPort(o,n);return b?(this.p(l,w,b),b.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),b}};e.$Vz=v,e.$Vz=v=ke([Q(0,M.$Ri),Q(1,O.$Vh)],v)}),define(te[48],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xT=e.$wT=e.DisablementReason=e.UpdateType=e.StateType=void 0;var O;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(O||(e.StateType=O={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$wT={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,E)=>({type:"idle",updateType:D,error:E}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$xT=(0,k.$ph)("updateService")}),define(te[263],ie([0,1,4,186,59,43]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$Um.as(s.$Zm.Configuration).registerConfiguration({id:"update",order:15,title:(0,O.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,O.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,O.localize)(2,null),(0,O.localize)(3,null),(0,O.localize)(4,null),(0,O.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,O.localize)(6,null),deprecationMessage:(0,O.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,O.localize)(8,null),description:(0,O.localize)(9,null),included:k.$i&&!k.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,O.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[264],ie([0,1,3,48]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R5b=e.$Q5b=void 0;class s{constructor(E){this.a=E}listen(E,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(E,f,h){switch(f){case"checkForUpdates":return this.a.checkForUpdates(h);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(h)}throw new Error(`Call not found: ${f}`)}}e.$Q5b=s;class M{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new k.$ec,this.onStateChange=this.a.event,this.b=O.$wT.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$R5b=M}),define(te[40],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=void 0,e.$pk=(0,k.$ph)("IUriIdentityService")}),define(te[265],ie([0,1,40,205,16,19,139,3,2]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class h{static{this._clock=0}constructor(p){this.uri=p,this.time=h._clock++}touch(){return this.time=h._clock++,this}}let $=class{constructor(p){this.g=p,this.c=new f.$kb,this.f=2**16;const u=new Map,y=v=>{let c=u.get(v.scheme);return c===void 0&&(c=p.hasProvider(v)&&!this.g.hasCapability(v,1024),u.set(v.scheme,c)),c};this.c.add(E.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(v=>{u.delete(v.scheme)})),this.extUri=new M.$Xf(y),this.d=new D.$fr((v,c)=>this.extUri.compare(v,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,M.$0f)(p));const u=this.d.get(p);return u?u.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new h(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,v)=>y[1].time<v[1].time?1:y[1].time>v[1].time?-1:0);h._clock=0,this.d.clear();const u=this.f*.5;for(let y=0;y<u;y++)this.d.set(p[y][0],p[y][1].touch())}};e.$gr=$,e.$gr=$=ke([Q(0,s.$Sj)],$),(0,O.$dr)(k.$pk,$,1)}),define(te[128],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lT=void 0,e.$lT=(0,k.$ph)("urlService")}),define(te[266],ie([0,1,7]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.$Z5b=e.$Y5b=void 0;class O{constructor(E){this.a=E}listen(E,f){throw new Error(`Event not found: ${f}`)}call(E,f,h){switch(f){case"handleURL":return this.a.handleURL(k.URI.revive(h[0]),h[1])}throw new Error(`Call not found: ${f}`)}}e.$Y5b=O;class s{constructor(E){this.a=E}handleURL(E,f){return this.a.call("handleURL",[E.toJSON(),f])}}e.$Z5b=s;class M{constructor(E,f){this.a=E,this.b=f}async routeCall(E,f,h,$){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(h)&&h.length>0){const g=k.URI.revive(h[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",g.toString(!0)),g.query){const p=/\bwindowId=(\d+)/.exec(g.query);if(p){const u=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,g.toString(!0));const y=new RegExp(`window:${u}`),v=E.connections.find(c=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",c.ctx),y.test(c.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",g.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",g.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",g.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,f,h,$)}routeEvent(E,f){throw new Error(`Event not found: ${f}`)}}e.$15b=M}),define(te[267],ie([0,1,8,2,7,22]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nT=e.$mT=void 0;class D extends O.$lb{constructor(){super(...arguments),this.a=new Set}open(h,$){const g=[...this.a.values()];return(0,k.$yg)(g.map(p=>()=>p.handleURL(h,$)),void 0,!1).then(p=>p||!1)}registerHandler(h){return this.a.add(h),(0,O.$jb)(()=>this.a.delete(h))}}e.$mT=D;let E=class extends D{constructor(h){super(),this.b=h}create(h){let{authority:$,path:g,query:p,fragment:u}=h||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return $&&g&&g.indexOf("/")!==0&&(g=`/${g}`),s.URI.from({scheme:this.b.urlProtocol,authority:$,path:g,query:p,fragment:u})}};e.$nT=E,e.$nT=E=ke([Q(0,M.$0i)],E)}),define(te[268],ie([0,1,14,8,3,2,4,7]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=void 0;class f{constructor($,g,p,u,y,v){if(this.f=g,this.g=v,this.a=[],this.b=0,this.c=M.$lb.None,this.d=new M.$kb,$&&(v.trace("ElectronURLListener initialUrisToHandle:",$.map(l=>l.originalUrl)),this.a=$),D.$i){const l=u.isBuilt?[]:[`"${u.appRoot}"`];l.push("--open-url","--"),k.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,l)}const c=s.Event.map(s.Event.fromNodeEventEmitter(k.app,"open-url",(l,w)=>({event:l,url:w})),({event:l,url:w})=>(l.preventDefault(),w));this.d.add(c(l=>{const w=this.h(l);w&&this.f.open(w,{originalUrl:l})})),p.getWindows().filter(l=>l.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(p.onDidSignalReadyWindow)(this.i,this,this.d))}h($){try{return E.URI.parse($)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const $=[];for(const g of this.a)await this.f.open(g.uri,{originalUrl:g.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",g.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",g.originalUrl),$.push(g));$.length!==0&&(this.a=$,this.c=(0,O.$wg)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$25b=f}),define(te[269],ie([0,1,3,2,16,56,58,17]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=void 0;class f extends O.$lb{get capabilities(){return this.f.capabilities&-5}constructor($,g,p,u){super(),this.c=$,this.f=g,this.g=p,this.h=u,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.$ec),this.onDidChangeFile=this.a.event,this.b=D.$vh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(y=>this.i(y)))}watch($,g){this.b.set($,$);const p=this.f.watch(this.j($),g);return(0,O.$jb)(()=>{this.b.delete($),p.dispose()})}stat($){return this.f.stat(this.j($))}mkdir($){return this.f.mkdir(this.j($))}rename($,g,p){return this.f.rename(this.j($),this.j(g),p)}readFile($){return this.f.readFile(this.j($),{atomic:!0})}readFileStream($,g,p){const u=(0,M.$sc)(y=>E.$Ec.concat(y.map(v=>E.$Ec.wrap(v))).buffer);return(async()=>{try{const y=await this.readFile($);u.end(y)}catch(y){u.error(y),u.end()}})(),u}readdir($){return this.f.readdir(this.j($))}writeFile($,g,p){return this.f.writeFile(this.j($),g,p)}delete($,g){return this.f.delete(this.j($),g)}copy($,g,p){if((0,s.$Vj)(this.f))return this.f.copy(this.j($),this.j(g),p);throw new Error("copy not supported")}i($){const g=[];for(const p of $){if(p.resource.scheme!==this.c)continue;const u=this.k(p.resource);this.b.findSubstr(u)&&g.push({resource:u,type:p.type})}g.length&&(this.h.debug("User data changed"),this.a.fire(g))}j($){return $.with({scheme:this.c})}k($){return $.with({scheme:this.g})}}e.$B6b=f}),define(te[270],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=void 0,e.$j6b="utilityProcessWorker"}),define(te[271],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=void 0,e.$35b=(0,k.$ph)("webviewManagerService")}),define(te[272],ie([0,1,14,2,15,7]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$45b=void 0;class D extends O.$lb{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);k.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,h){try{const $=M.URI.parse(f.url),g=D.a.get($.path);if(typeof g=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${g}`,u=s.$1e.asFileUri(p);return h({path:u.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return h({error:-10})}catch{}return h({error:-2})}}e.$45b=D}),define(te[81],ie([0,1,4]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LD=e.$KD=e.$JD=e.$ID=e.$HD=e.$GD=e.$FD=e.$ED=void 0,e.$ED={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O($){return!!$.workspaceUri}e.$FD=O;function s($){return!!$.folderUri}e.$GD=s;function M($){return!!$.fileUri}e.$HD=M;function D($){const g=E($),p=$.getValue("window.menuBarVisibility");return p==="default"||g==="native"&&p==="compact"||k.$j&&k.$m?"classic":p}e.$ID=D;function E($){if(k.$o)return"custom";const g=$.getValue("window");if(g){if(k.$j&&g.nativeTabs===!0||k.$j&&g.nativeFullScreen===!1)return"native";const y=g.titleBarStyle;if(y==="native"||y==="custom")return y}return k.$k?"native":"custom"}e.$JD=E;function f($){return!(!k.$i||k.$o||E($)==="native")}e.$KD=f;function h($=0){return Math.pow(1.2,$)}e.$LD=h}),define(te[129],ie([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$A4b=e.UnloadReason=e.LoadReason=void 0;var k;(function(E){E[E.INITIAL=1]="INITIAL",E[E.LOAD=2]="LOAD",E[E.RELOAD=3]="RELOAD"})(k||(e.LoadReason=k={}));var O;(function(E){E[E.CLOSE=1]="CLOSE",E[E.QUIT=2]="QUIT",E[E.RELOAD=3]="RELOAD",E[E.LOAD=4]="LOAD"})(O||(e.UnloadReason=O={}));const s=function(E=1){return{width:1024,height:768,mode:E}};e.$A4b=s;var M;(function(E){E[E.Maximized=0]="Maximized",E[E.Normal=1]="Normal",E[E.Minimized=2]="Minimized",E[E.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(E){E[E.UNRESPONSIVE=1]="UNRESPONSIVE",E[E.PROCESS_GONE=2]="PROCESS_GONE",E[E.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(te[29],ie([0,1,6]),function(H,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$P4b=void 0,e.$P4b=(0,k.$ph)("windowsMainService");var O;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(O||(e.OpenContext=O={}))}),define(te[273],ie([0,1,76,5,33,22,29,217]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=void 0;let f=class extends E.$qn{constructor($,g,p,u){super($),this.n=g,this.p=p,this.r=u,this.j=y=>{this.r.sendToFocused("vscode:showCredentialsError",y.message??y)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new k.$pn,this.f;const $=await new Promise((g,p)=>{H(["keytar"],g,p)});return await $.findCredentials("test-keytar-loads"),this.f=$,this.f}};e.$a6b=f,e.$a6b=f=ke([Q(0,O.$Ri),Q(1,s.$xh),Q(2,M.$0i),Q(3,D.$P4b)],f)}),define(te[274],ie([0,1,14,24,4,7,21,18,63,6,5,128,29]),function(H,e,k,O,s,M,D,E,f,h,$,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=e.$w5b=e.ID=void 0,e.ID="launchMainService",e.$w5b=(0,h.$ph)(e.ID);let u=class{constructor(v,c,d,l){this.a=v,this.b=c,this.c=d,this.d=l}async start(v,c){this.a.trace("Received data from other instance: ",v,c),s.$j&&k.app.focus({steal:!0});const d=this.e(v);if(d.length){let l=Promise.resolve();if(this.b.getWindowCount()===0){const w=(0,O.$sf)(await this.b.openEmptyWindow({context:4}));w&&(l=w.ready())}l.then(()=>{for(const{uri:w,originalUrl:S}of d)this.c.open(w,{originalUrl:S})})}else return this.f(v,c)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,O.$jf)(v._urls.map(c=>{try{return{uri:M.URI.parse(c),originalUrl:c}}catch{return null}})):[]}async f(v,c){const d=(0,f.$tl)(c)?0:4;let l=[];const w=v.wait&&v.waitMarkerFilePath?M.URI.file(v.waitMarkerFilePath):void 0,S=v.remote||void 0,m={context:d,cli:v,userEnv:c,waitMarkerFileURI:w,remoteAuthority:S,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,m);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||m.forceProfile||m.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)l=await this.b.open({...m,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,m),l=[a]):l=await this.b.open({...m,forceEmpty:!0})}}else l=await this.b.open({...m,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(w&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,D.whenDeleted)(w.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$x5b=u,e.$x5b=u=ke([Q(0,$.$Ri),Q(1,p.$P4b),Q(2,g.$lT),Q(3,E.$Vh)],u)}),define(te[275],ie([0,1,14,3,2,272,29]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=void 0;let E=class extends s.$lb{constructor(h){super(),this.b=h,this.a=this.B(new O.$ec),this.onFoundInFrame=this.a.event,this.B(new M.$45b)}async setIgnoreMenuShortcuts(h,$){let g;if(typeof h.windowId=="number"){const{windowId:p}=h,u=this.b.getWindowById(p);if(!u?.win)throw new Error(`Invalid windowId: ${p}`);g=u.win.webContents}else{const{webContentsId:p}=h;if(g=k.webContents.fromId(p),!g)throw new Error(`Invalid webContentsId: ${p}`)}g.isDestroyed()||g.setIgnoreMenuShortcuts($)}async findInFrame(h,$,g,p){const y=this.c(h,$);if(typeof y.findInFrame=="function"){y.findInFrame(g,{findNext:p.findNext,forward:p.forward});const v=(c,d)=>{d.finalUpdate&&(this.a.fire(d),y.removeListener("found-in-frame",v))};y.on("found-in-frame",v)}}async stopFindInFrame(h,$,g){const u=this.c(h,$);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(g.keepSelection?"keepSelection":"clearSelection")}c(h,$){const g=this.b.getWindowById(h.windowId);if(!g?.win)throw new Error(`Invalid windowId: ${h}`);const p=g.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===$);if(!p)throw new Error(`Unknown frame: ${$}`);return p}};e.$55b=E,e.$55b=E=ke([Q(0,D.$P4b)],E)}),define(te[276],ie([0,1,8,3,2]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$5b=void 0;class M extends s.$lb{constructor({onDidOpenWindow:E,onDidFocusWindow:f,getActiveWindowId:h}){super(),this.a=this.B(new s.$kb),O.Event.latch(O.Event.any(E,f))(this.f,this,this.a),this.b=(0,k.$ig)(()=>h()),(async()=>{try{const g=await this.b;this.c=typeof this.c=="number"?this.c:g}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$$5b=M}),define(te[30],ie([0,1,190,9,58,19,7,6,15]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,E.$ph)("contextService");function h(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$zh=h;function $(i){return typeof i?.id=="string"&&!h(i)&&!p(i)}e.$Ah=$,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function g(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$_c)(i)}:n?e.$Bh:e.$Ch;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Dh=g;function p(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$Eh=p;function u(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$Fh=u;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Gh=v;function c(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Hh=c;class d{constructor(n,o,b,I,A){this.h=n,this.j=b,this.k=I,this.l=A,this.c=s.$vh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=d;class l{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$9f)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=l;function w(i){return new l({uri:i,index:0,name:(0,M.$5f)(i)},{uri:i.toString()})}e.$Kh=w,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,k.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function S(i,n){return M.$Zf.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$Ph=S;function m(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$Qh=m,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Rh}e.$Sh=t;function a(i,n){return!S(i,n)&&!m(i)}e.$Th=a;function r(i){return(typeof i=="string"?(0,O.$ad)(i):(0,M.$7f)(i))===e.$Mh}e.$Uh=r}),define(te[61],ie([0,1,14,8,57,46,2,86,4,21,165,92,6,5,22,30]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$34b=e.$24b=void 0,e.$24b=(0,p.$ph)("dialogMainService");let c=class{constructor(l,w){this.d=l,this.e=w,this.a=new Map,this.b=new Map,this.c=new O.$Bg}pickFileFolder(l,w){return this.f({...l,pickFolders:!0,pickFiles:!0,title:(0,$.localize)(0,null)},w)}pickFolder(l,w){return this.f({...l,pickFolders:!0,title:(0,$.localize)(1,null)},w)}pickFile(l,w){return this.f({...l,pickFiles:!0,title:(0,$.localize)(2,null)},w)}pickWorkspace(l,w){const S=(0,$.localize)(3,null),m=(0,M.$aA)((0,$.localize)(4,null)),t=v.$Nh;return this.f({...l,pickFiles:!0,title:S,filters:t,buttonLabel:m},w)}async f(l,w){const S={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters,defaultPath:l.defaultPath};(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(S.properties=void 0,l.pickFiles&&l.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&S.properties.push("treatPackageAsDirectory");const m=await this.showOpenDialog(S,(w||k.BrowserWindow.getFocusedWindow())??void 0);if(m&&m.filePaths&&m.filePaths.length>0)return m.filePaths}g(l){if(l){let w=this.b.get(l.id);return w||(w=new O.$Bg,this.b.set(l.id,w)),w}else return this.c}showMessageBox(l,w){return this.g(w).queue(async()=>{const{options:S,buttonIndeces:m}=(0,g.$hA)(l,this.e);let t;return w?t=await k.dialog.showMessageBox(w,S):t=await k.dialog.showMessageBox(S),{response:m[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(l,w){const S=this.j(l,w);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(w).queue(async()=>{let m;return w?m=await k.dialog.showSaveDialog(w,l):m=await k.dialog.showSaveDialog(l),m.filePath=this.h(m.filePath),m})}finally{(0,D.$gb)(S)}}h(l){return l&&f.$j&&(l=(0,E.$7k)(l)),l}i(l){return l.map(w=>this.h(w))}async showOpenDialog(l,w){l.defaultPath&&(await h.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const S=this.j(l,w);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(w).queue(async()=>{let m;return w?m=await k.dialog.showOpenDialog(w,l):m=await k.dialog.showOpenDialog(l),m.filePaths=this.i(m.filePaths),m})}finally{(0,D.$gb)(S)}}j(l,w){if(!w)return D.$lb.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",l);let S=this.a.get(w.id);S||(S=new Set,this.a.set(w.id,S));const m=(0,s.$di)(l);if(!S.has(m))return this.d.trace("[DialogMainService]: new file dialog lock created",l),S.add(m),(0,D.$jb)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",l),S?.delete(m),S?.size===0&&this.a.delete(w.id)})}};e.$34b=c,e.$34b=c=ke([Q(0,u.$Ri),Q(1,y.$0i)],c)}),define(te[277],ie([0,1,3,2,74,30]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N5b=void 0;class D extends O.$lb{static{this.a=100}constructor(f,h){super(),this.f=f,this.g=h,this.b=this.B(new k.$ec),this.c=new Map,this.h(h.applicationStorage,this.b)}h(f,h){this.B(k.Event.debounce(f.onDidChangeStorage,($,g)=>($?$.push(g):$=[g],$),D.a)($=>{$.length&&h.fire(this.i($,f))}))}i(f,h){const $=new Map,g=new Set;return f.forEach(p=>{const u=h.get(p.key);typeof u=="string"?$.set(p.key,u):g.add(p.key)}),{changed:Array.from($.entries()),deleted:Array.from(g.values())}}listen(f,h,$){switch(h){case"onDidChangeStorage":{const g=$.profile?(0,s.$Yg)($.profile):void 0;if(!g)return this.b.event;let p=this.c.get(g.id);return p||(p=this.B(new k.$ec),this.h(this.g.profileStorage(g),p),this.c.set(g.id,p)),p.event}}throw new Error(`Event not found: ${h}`)}async call(f,h,$){const g=$.profile?(0,s.$Yg)($.profile):void 0,p=(0,M.$Fh)($.workspace),u=await this.j(g,p);switch(h){case"getItems":return Array.from(u.items.entries());case"updateItems":{const y=$;if(y.insert)for(const[v,c]of y.insert)u.set(v,c);y.delete?.forEach(v=>u.delete(v));break}case"isUsed":{const y=$.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${h}`)}}async j(f,h){let $;h?$=this.g.workspaceStorage(h):f?$=this.g.profileStorage(f):$=this.g.applicationStorage;try{await $.init()}catch(g){this.f.error(`StorageIPC#init: Unable to init ${h?"workspace":f?"profile":"application"} storage due to ${g}`)}return $}}e.$N5b=D}),define(te[41],ie([0,1,57,3,2,19,7,187,33,16,6,5,30,35,40,8,31,26,12]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.ProfileResourceType=void 0;var w;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(w||(e.ProfileResourceType=w={}));function S(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$qk=S,e.$rk=(0,$.$ph)("IUserDataProfilesService");function m(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$sk=m;function t(i,n,o,b,I,A){return{id:i,name:n,location:o,isDefault:!1,shortName:I?.shortName,globalStorageHome:A&&I?.useDefaultFlags?.globalState?A.globalStorageHome:(0,M.$9f)(o,"globalStorage"),settingsResource:A&&I?.useDefaultFlags?.settings?A.settingsResource:(0,M.$9f)(o,"settings.json"),keybindingsResource:A&&I?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,M.$9f)(o,"keybindings.json"),tasksResource:A&&I?.useDefaultFlags?.tasks?A.tasksResource:(0,M.$9f)(o,"tasks.json"),snippetsHome:A&&I?.useDefaultFlags?.snippets?A.snippetsHome:(0,M.$9f)(o,"snippets"),extensionsResource:A&&I?.useDefaultFlags?.extensions?A.extensionsResource:(0,M.$9f)(o,"extensions.json"),cacheHome:(0,M.$9f)(b,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$tk=t;let a=class extends s.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,o,b,I){super(),this.n=n,this.r=o,this.s=b,this.t=I,this.f=!0,this.h=this.B(new O.$ec),this.onDidChangeProfiles=this.h.event,this.i=this.B(new O.$ec),this.onWillCreateProfile=this.i.event,this.j=this.B(new O.$ec),this.onWillRemoveProfile=this.j.event,this.k=this.B(new O.$ec),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new u.$ni,emptyWindows:new Map},this.profilesHome=(0,M.$9f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,M.$9f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=this.w(),o=[n];if(this.f)try{for(const A of this.J()){if(!A.name||!(0,l.$ie)(A.name)||!A.location){this.t.warn("Skipping the invalid stored profile",A.location||A.name);continue}o.push(t((0,M.$6f)(A.location),A.name,A.location,this.g,{shortName:A.shortName,useDefaultFlags:A.useDefaultFlags},n))}}catch(A){this.t.error(A)}const b=new u.$ni,I=new Map;if(o.length)try{const A=this.M();if(A.workspaces)for(const[P,C]of Object.entries(A.workspaces)){const j=D.URI.parse(P),U=o.find(W=>W.id===C);U&&b.set(j,U)}if(A.emptyWindows)for(const[P,C]of Object.entries(A.emptyWindows)){const j=o.find(U=>U.id===C);j&&I.set(P,j)}}catch(A){this.t.error(A)}this.u={profiles:o,workspaces:b,emptyWindows:I}}return this.u}w(){const n=t("__default__profile__",(0,E.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...n,extensionsResource:this.O()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",b=new RegExp(`${(0,d.$pd)(o)}\\s(\\d+)`);let I=0;for(const P of this.profiles){const C=b.exec(P.name),j=C?parseInt(C[1]):0;I=j>I?j:I}const A=`${o} ${I+1}`;return this.createProfile((0,k.$di)((0,c.$3e)()).toString(16),A,{transient:!0},n)}async createNamedProfile(n,o,b){return this.createProfile((0,k.$di)((0,c.$3e)()).toString(16),n,o,b)}async createProfile(n,o,b,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.y(n,o,b);return I&&await this.setProfileForWorkspace(I,A),A}async y(n,o,b){if(!(0,l.$ie)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.l.get(o);return I||(I=(async()=>{try{const A=this.profiles.find(j=>j.name===o||j.id===n);if(A)return A;const P=t(n,o,(0,M.$9f)(this.profilesHome,n),this.g,b,this.defaultProfile);await this.r.createFolder(P.location);const C=[];return this.i.fire({profile:P,join(j){C.push(j)}}),await v.Promises.settled(C),this.D([P],[],[]),P}finally{this.l.delete(o)}})(),this.l.set(o,I)),I}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(I=>I.id===n.id);if(!b)throw new Error(`Profile '${n.name}' does not exist`);return b=t(b.id,o.name??b.name,b.location,this.g,{shortName:o.shortName??b.shortName,transient:o.transient??b.isTransient,useDefaultFlags:o.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.D([],[],[b]),b}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(I=>I.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const b=[];this.j.fire({profile:o,join(I){b.push(I)}});try{await Promise.allSettled(b)}catch(I){this.t.error(I)}for(const I of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(I)?.id&&this.v.emptyWindows.delete(I);for(const I of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(I)?.id&&this.v.workspaces.delete(I);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(I){(0,h.$9j)(I)!==1&&this.t.error(I)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(I=>I.id===o.id);if(!b)throw new Error(`Profile '${o.name}' does not exist`);this.G(n,b)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(b=>!this.s.extUri.isEqual(b.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.z(n);return D.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(n){return(0,p.$zh)(n)?n.uri:(0,p.$Eh)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location)))}D(n,o,b){const I=[...this.profiles,...n],A=[];this.m.profiles=[];for(let P of I)P.isDefault||o.some(C=>P.id===C.id)||(P=b.find(C=>P.id===C.id)??P,P.isTransient?this.m.profiles.push(P):A.push({location:P.location,name:P.name,shortName:P.shortName,useDefaultFlags:P.useDefaultFlags}));this.L(A),this.u=void 0,this.F(n,o,b)}F(n,o,b){this.h.fire({added:n,removed:o,updated:b,all:this.profiles})}G(n,o,b){b=o?.isTransient?!0:b,b||this.G(n,void 0,!0);const I=this.z(n),A=b?this.m:this.v;D.URI.isUri(I)?(A.workspaces.delete(I),o&&A.workspaces.set(I,o)):(A.emptyWindows.delete(I),o&&A.emptyWindows.set(I,o)),b||this.H()}H(){const n={};for(const[b,I]of this.v.workspaces.entries())n[b.toString()]=I.id;const o={};for(const[b,I]of this.v.emptyWindows.entries())o[b.toString()]=I.id;this.N({workspaces:n,emptyWindows:o}),this.u=void 0}I(n){const o={},b=this.w();if(n.workspaces)for(const[A,P]of Object.entries(n.workspaces)){const C=D.URI.parse(P);o[A]=this.s.extUri.isEqual(C,b.location)?b.id:this.s.extUri.basename(C)}const I={};if(n.emptyWindows)for(const[A,P]of Object.entries(n.emptyWindows)){const C=D.URI.parse(P);I[A]=this.s.extUri.isEqual(C,b.location)?b.id:this.s.extUri.basename(C)}return{workspaces:o,emptyWindows:I}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};e.$uk=a,e.$uk=a=ke([Q(0,f.$wh),Q(1,h.$Sj),Q(2,y.$pk),Q(3,g.$Ri)],a);class r extends a{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.$vk=r}),define(te[82],ie([0,1,8,17,2,3,35,7,117,124,16,6,5,41,40,12,13,25]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class w extends Error{constructor(r,i){super(r),this.code=i}}e.$ap=w,e.$bp=(0,g.$ph)("IExtensionsProfileScannerService");let S=class extends s.$lb{constructor(r,i,n,o,b,I){super(),this.i=r,this.j=i,this.k=n,this.l=o,this.m=b,this.n=I,this.b=this.B(new M.$ec),this.onAddExtensions=this.b.event,this.c=this.B(new M.$ec),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$ec),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$ec),this.onDidRemoveExtensions=this.g.event,this.h=new D.$ni}scanProfileExtensions(r,i){return this.p(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],o=[];try{return await this.p(i,b=>{const I=[];for(const A of b)r.some(([P])=>(0,h.$ho)(P.identifier,A.identifier)&&P.manifest.version!==A.version)?n.push(A):I.push(A);for(const[A,P]of r){const C=I.findIndex(U=>(0,h.$ho)(U.identifier,A.identifier)&&U.version===A.manifest.version),j={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:P};C===-1?(o.push(j),I.push(j)):I.splice(C,1,j)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),I}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(b){throw o.length&&this.c.fire({extensions:o,error:b,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:b,profileLocation:i}),b}}async updateMetadata(r,i){const n=[];return await this.p(i,o=>{const b=[];for(const I of o){const A=r.find(([P])=>(0,h.$ho)(P.identifier,I.identifier)&&P.manifest.version===I.version);A&&(I.metadata={...I.metadata,...A[1]},n.push(I)),b.push(I)}return b}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.p(i,o=>{const b=[];for(const I of o)(0,h.$ho)(I.identifier,r.identifier)?n.push(I):b.push(I);return n.length&&this.f.fire({extensions:n,profileLocation:i}),b}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async p(r,i,n){return this.w(r).queue(async()=>{let o=[],b;try{const I=await this.j.readFile(r);b=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,$.$9j)(I)!==1)throw I;if(this.l.extUri.isEqual(r,this.k.defaultProfile.extensionsResource)&&(b=await this.v()),!b&&n?.bailOutWhenFileNotFound)throw new w((0,c.$9)(I),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.r(r);let I=!1;for(const A of b){m(A)||this.r(r);let P;if((0,v.$ie)(A.relativeLocation)&&A.relativeLocation)P=this.t(A.relativeLocation);else if((0,v.$ie)(A.location))P=this.t(A.location),I=!0,A.relativeLocation=A.location,A.location=P.toJSON();else{P=E.URI.revive(A.location);const C=this.s(P);C&&(I=!0,A.relativeLocation=C)}o.push({identifier:A.identifier,location:P,version:A.version,metadata:A.metadata})}I&&await this.j.writeFile(r,O.$Ec.fromString(JSON.stringify(b)))}if(i){o=i(o);const I=o.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.s(A.location),metadata:A.metadata}));await this.j.writeFile(r,O.$Ec.fromString(JSON.stringify(I)))}return o})}r(r){const i=new w(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(r){return this.l.extUri.isEqual(this.l.extUri.dirname(r),this.i)?this.l.extUri.basename(r):void 0}t(r){return this.l.extUri.joinPath(this.i,r)}async v(){return this.u||(this.u=(async()=>{const r=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(r)).value.toString()}catch(b){if((0,$.$9j)(b)===1)return;throw b}this.n.info("Migrating extensions from old default profile location",r.toString());let o;try{const b=JSON.parse(n);Array.isArray(b)&&b.every(I=>m(I))?o=b:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.n.error(b)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,O.$Ec.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",r.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(b){if((0,$.$9j)(b)===3)this.n.info("Migration from old default profile location to new location is done by another window",r.toString(),this.k.defaultProfile.extensionsResource.toString());else throw b}try{await this.j.del(r)}catch(b){(0,$.$9j)(b)!==1&&this.n.error(b)}try{await this.j.del(i)}catch(b){(0,$.$9j)(b)!==1&&this.n.error(b)}return o})()),this.u}w(r){let i=this.h.get(r);return i||(i=new k.$Bg,this.h.set(r,i)),i}};e.$cp=S,e.$cp=S=ke([Q(1,$.$Sj),Q(2,u.$rk),Q(3,y.$pk),Q(4,d.$Vk),Q(5,p.$Ri)],S);function m(a){return(0,v.$ke)(a)&&(0,f.$Qn)(a.identifier)&&(t(a.location)||(0,v.$ie)(a.location)&&a.location)&&((0,v.$pe)(a.relativeLocation)||(0,v.$ie)(a.relativeLocation))&&a.version&&(0,v.$ie)(a.version)}function t(a){return a?(0,v.$ie)(a.path)&&(0,v.$ie)(a.scheme):!1}}),define(te[130],ie([0,1,24,8,37,17,13,44,151,2,15,9,4,19,203,70,12,7,170,33,124,121,202,16,6,5,22,3,74,82,41,40,201]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m,t,a,r,i,n,o,b,I,A,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.Translations=void 0;var j;(function(ue){function V(J,z){if(J===z)return!0;const T=Object.keys(J),F=new Set;for(const B of Object.keys(z))F.add(B);if(T.length!==F.size)return!1;for(const B of T){if(J[B]!==z[B])return!1;F.delete(B)}return F.size===0}ue.equals=V})(j||(e.Translations=j={})),e.$fp=(0,r.$ph)("IExtensionsScannerService");let U=class extends h.$lb{constructor(V,J,z,T,F,B,x,oe,ce,G,R,L){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=J,this.l=z,this.m=T,this.n=F,this.r=B,this.s=x,this.t=oe,this.u=ce,this.v=G,this.w=R,this.y=L,this.g=this.B(new o.$ec),this.onDidChangeCache=this.g.event,this.h=(0,u.$9f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ne,this.m,this.h)),this.j=this.B(this.y.createInstance(ne,this.m,this.h)),this.k=this.B(this.y.createInstance(re,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,S.$so)(this.s,this.t)),this.z}async scanAllExtensions(V,J,z){const[T,F]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(J)]),B=z?await this.scanExtensionsUnderDevelopment(V,[...T,...F]):[];return this.G(T,F,B,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const J=[];J.push(this.H(!!V.useCache,V.language)),J.push(this.I(V.language,!!V.checkControlFile));const[z,T]=await Promise.all(J);return this.F([...z,...T],0,V,!1)}async scanUserExtensions(V){const J=V.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",J);const z=this.w.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.L(J,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,z),F=V.useCache&&!T.devMode&&T.excludeObsolete?this.j:this.k;let B;try{B=await F.scanExtensions(T)}catch(x){if(x instanceof I.$ap&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),B=await F.scanExtensions(T);else throw x}return B=await this.F(B,1,V,!0),this.t.trace("Scanned user extensions:",B.length),B}async scanExtensionsUnderDevelopment(V,J){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const z=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(T=>T.scheme===$.Schemas.file).map(async T=>{const F=await this.L(T,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(F)).map(x=>(x.type=J.find(oe=>(0,S.$ho)(oe.identifier,x.identifier))?.type??x.type,this.k.validate(x,F)))}))).flat();return this.F(z,"development",V,!0)}return[]}async scanExistingExtension(V,J,z){const T=await this.L(V,!1,J,!0,z.language,!0,void 0),F=await this.k.scanExtension(T);return!F||!z.includeInvalid&&!F.isValid?null:F}async scanOneOrMultipleExtensions(V,J,z){const T=await this.L(V,!1,J,!0,z.language,!0,void 0),F=await this.k.scanOneOrMultipleExtensions(T);return this.F(F,J,z,!0)}async scanMetadata(V){const J=(0,u.$9f)(V,"package.json"),z=(await this.s.readFile(J)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(V,J){const z=(0,u.$9f)(V,"package.json"),T=(await this.s.readFile(z)).value.toString(),F=JSON.parse(T);J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,F.__metadata={...F.__metadata,...J},await this.s.writeFile((0,u.$9f)(V,"package.json"),M.$Ec.fromString(JSON.stringify(F,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof I.$ap&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw V}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.r.addExtensionsToProfile(V.map(J=>[J,J.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,M.$Ec.fromString(JSON.stringify([])))}catch(J){(0,a.$9j)(J)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$9)(J))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.t.error(V)}finally{this.C=void 0}})()),this.C}async F(V,J,z,T){return z.includeAllVersions||(V=this.G(J===0?V:void 0,J===1?V:void 0,J==="development"?V:void 0,await this.getTargetPlatform(),T)),z.includeInvalid||(V=V.filter(F=>F.isValid)),V.sort((F,B)=>{const x=g.$_c(F.location.fsPath),oe=g.$_c(B.location.fsPath);return x<oe?-1:x>oe?1:0})}G(V,J,z,T,F){const B=(oe,ce,G)=>{if(oe.isValid&&!ce.isValid)return!1;if(oe.isValid===ce.isValid){if(F&&y.gt(oe.manifest.version,ce.manifest.version))return this.t.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(y.eq(oe.manifest.version,ce.manifest.version)){if(oe.type===0)return this.t.debug(`Skipping extension ${ce.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===T)return this.t.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return G?this.t.warn(`Overwriting user extension ${oe.location.path} with ${ce.location.path}.`):this.t.debug(`Overwriting user extension ${oe.location.path} with ${ce.location.path}.`),!0},x=new m.$Kl;return V?.forEach(oe=>{const ce=x.get(oe.identifier.id);(!ce||B(ce,oe,!1))&&x.set(oe.identifier.id,oe)}),J?.forEach(oe=>{const ce=x.get(oe.identifier.id);if(!ce&&V&&oe.type===0){this.t.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!ce||B(ce,oe,!1))&&x.set(oe.identifier.id,oe)}),z?.forEach(oe=>{const ce=x.get(oe.identifier.id);(!ce||B(ce,oe,!0))&&x.set(oe.identifier.id,oe),x.set(oe.identifier.id,oe)}),[...x.values()]}async H(V,J){this.t.trace("Started scanning system extensions");const z=await this.L(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),F=await(V&&!z.devMode?this.i:this.k).scanExtensions(z);return this.t.trace("Scanned system extensions:",F.length),F}async I(V,J){const z=this.u.isBuilt?[]:this.v.builtInExtensions;if(!z?.length)return[];this.t.trace("Started scanning dev system extensions");const T=J?await this.J():{},F=[],B=d.URI.file(g.$6c(g.$8c($.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of z){const ce=T[oe.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":F.push((0,u.$9f)(B,oe.name));break;default:F.push(d.URI.file(ce));break}}const x=await Promise.all(F.map(async oe=>this.k.scanExtension(await this.L(oe,!1,0,!0,V,!0,void 0))));return this.t.trace("Scanned dev system extensions:",x.length),(0,k.$jf)(x)}async J(){try{const V=await this.s.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async L(V,J,z,T,F,B,x){const oe=await this.f(F??p.$v),ce=await this.M(V),G=J&&!this.w.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,R=G?await this.M(G):void 0;return new W(V,ce,G,R,J,x,z,T,B,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,F,oe)}async M(V){try{const J=await this.s.stat(V);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.$gp=U,e.$gp=U=ke([Q(4,A.$rk),Q(5,I.$bp),Q(6,a.$Sj),Q(7,i.$Ri),Q(8,w.$wh),Q(9,n.$0i),Q(10,P.$pk),Q(11,r.$oh)],U);class W{constructor(V,J,z,T,F,B,x,oe,ce,G,R,L,N,q,se){this.location=V,this.mtime=J,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=T,this.profile=F,this.profileScanOptions=B,this.type=x,this.excludeObsolete=oe,this.validate=ce,this.productVersion=G,this.productDate=R,this.productCommit=L,this.devMode=N,this.language=q,this.translations=se}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,J){return(0,u.$2f)(V.location,J.location)&&V.mtime===J.mtime&&(0,u.$2f)(V.applicationExtensionslocation,J.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&V.profile===J.profile&&s.$Mm(V.profileScanOptions,J.profileScanOptions)&&V.type===J.type&&V.excludeObsolete===J.excludeObsolete&&V.validate===J.validate&&V.productVersion===J.productVersion&&V.productDate===J.productDate&&V.productCommit===J.productCommit&&V.devMode===J.devMode&&V.language===J.language&&j.equals(V.translations,J.translations)}}e.$hp=W;let re=class extends h.$lb{constructor(V,J,z,T,F){super(),this.f=V,this.g=J,this.h=z,this.i=T,this.j=F}async scanExtensions(V){const J=V.profile?await this.l(V):await this.k(V);let z={};if(V.excludeObsolete&&V.type===1)try{const T=(await this.i.readFile(this.f)).value.toString();z=JSON.parse(T)}catch{}return(0,c.$ve)(z)?J:J.filter(T=>!z[S.$io.create(T).toString()])}async k(V){const J=await this.i.resolve(V.location);if(!J.children?.length)return[];const z=await Promise.all(J.children.map(async T=>{if(!T.isDirectory||V.type===1&&(0,u.$6f)(T.resource).indexOf(".")===0)return null;const F=new W(T.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(F)}));return(0,k.$jf)(z).sort((T,F)=>T.location.path<F.location.path?-1:1)}async l(V){let J=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){J=J.filter(T=>!T.metadata?.isApplicationScoped);const z=await this.m(V.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,V);J.push(...z)}return J}async m(V,J,z){const T=await this.g.scanProfileExtensions(V,z.profileScanOptions);if(!T.length)return[];const F=await Promise.all(T.map(async B=>{if(J(B)){const x=new W(B.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(x,B.metadata)}return null}));return(0,k.$jf)(F)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,u.$9f)(V.location,"package.json"))){const J=await this.scanExtension(V);return J?[J]:[]}else return await this.scanExtensions(V)}catch(J){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,D.$9)(J)),[]}}async scanExtension(V,J){try{let z=await this.scanExtensionManifest(V.location);if(z){z.publisher||(z.publisher=m.$El),J=J??z.__metadata,delete z.__metadata;const T=(0,S.$mo)(z.publisher,z.name),F=J?.id?{id:T,uuid:J.id}:{id:T},B=J?.isSystem?0:V.type,x=B===0||!!J?.isBuiltin;z=await this.n(V.location,z,W.createNlsConfiguration(V));const oe={type:B,identifier:F,manifest:z,location:V.location,isBuiltin:x,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return V.validate?this.validate(oe,V):oe}}catch(z){V.type!==0&&this.j.error(z)}return null}validate(V,J){let z=!0;const T=(0,t.$xo)(J.productVersion,J.productDate,J.location,V.manifest,V.isBuiltin);for(const[F,B]of T)F===v.default.Error&&(z=!1,this.j.error(this.u(J.location,B)));return V.isValid=z,V.validations=T,V}async scanExtensionManifest(V){const J=(0,u.$9f)(V,"package.json");let z;try{z=(await this.i.readFile(J)).value.toString()}catch(F){return(0,a.$9j)(F)!==1&&this.j.error(this.u(V,(0,l.localize)(0,null,J.path,F.message))),null}let T;try{T=JSON.parse(z)}catch{const B=[];(0,E.$ym)(z,B);for(const x of B)this.j.error(this.u(V,(0,l.localize)(1,null,J.path,x.offset,x.length,(0,f.$dp)(x.error))));return null}return(0,E.$Hm)(T)!=="object"?(this.j.error(this.u(V,(0,l.localize)(2,null,J.path))),null):T}async n(V,J,z){const T=await this.r(V,J,z);if(T)try{const F=[],B=await this.s(T.default,F);if(F.length>0)return F.forEach(oe=>{this.j.error(this.u(V,(0,l.localize)(3,null,T.default?.path,(0,f.$dp)(oe.error))))}),J;if((0,E.$Hm)(T)!=="object")return this.j.error(this.u(V,(0,l.localize)(4,null,T.default?.path))),J;const x=T.values||Object.create(null);return(0,C.$ep)(J,x,B)}catch{}return J}async r(V,J,z){const T=(0,u.$9f)(V,"package.nls.json"),F=(ce,G)=>{G.forEach(R=>{this.j.error(this.u(V,(0,l.localize)(5,null,ce?.path,(0,f.$dp)(R.error))))})},B=ce=>{this.j.error(this.u(V,(0,l.localize)(6,null,ce?.path)))},x=`${J.publisher}.${J.name}`,oe=z.translations[x];if(oe)try{const ce=d.URI.file(oe),G=(await this.i.readFile(ce)).value.toString(),R=[],L=(0,E.$ym)(G,R);return R.length>0?(F(ce,R),{values:void 0,default:T}):(0,E.$Hm)(L)!=="object"?(B(ce),{values:void 0,default:T}):{values:L.contents?L.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.i.exists(T))return;let G;try{G=await this.t(V,z)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const R=(await this.i.readFile(G.localized)).value.toString(),L=[],N=(0,E.$ym)(R,L);return L.length>0?(F(G.localized,L),{values:void 0,default:G.original}):(0,E.$Hm)(N)!=="object"?(B(G.localized),{values:void 0,default:G.original}):{values:N,default:G.original}}catch{return{values:void 0,default:G.original}}}}async s(V,J){if(V)try{const z=(await this.i.readFile(V)).value.toString();return(0,E.$ym)(z,J)}catch{}}t(V,J){return new Promise((z,T)=>{const F=B=>{const x=(0,u.$9f)(V,`package.nls.${B}.json`);this.i.exists(x).then(oe=>{oe&&z({localized:x,original:(0,u.$9f)(V,"package.nls.json")});const ce=B.lastIndexOf("-");ce===-1?z({localized:(0,u.$9f)(V,"package.nls.json"),original:null}):(B=B.substring(0,ce),F(B))})};if(J.devMode||J.pseudo||!J.language)return z({localized:(0,u.$9f)(V,"package.nls.json"),original:null});F(J.language)})}u(V,J){return`[${V.path}]: ${J}`}};re=ke([Q(1,I.$bp),Q(2,P.$pk),Q(3,a.$Sj),Q(4,i.$Ri)],re);let ne=class extends re{constructor(V,J,z,T,F,B,x){super(J,T,F,B,x),this.z=V,this.C=z,this.w=this.B(new O.$sg(3e3)),this.y=this.B(new o.$ec),this.onDidChangeCache=this.y.event}async scanExtensions(V){const J=this.H(V),z=await this.D(J);if(this.v=V,z&&z.input&&W.equals(z.input,this.v))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.w.trigger(()=>this.G()),z.result.map(F=>(F.location=d.URI.revive(F.location),F));const T=await super.scanExtensions(V);return await this.F(J,{input:V,result:T}),T}async D(V){try{const J=await this.i.readFile(V),z=JSON.parse(J.value.toString());return{result:z.result,input:(0,b.$Yg)(z.input)}}catch(J){this.j.debug("Error while reading the extension cache file:",V.path,(0,D.$9)(J))}return null}async F(V,J){try{await this.i.writeFile(V,M.$Ec.fromString(JSON.stringify(J)))}catch(z){this.j.debug("Error while writing the extension cache file:",V.path,(0,D.$9)(z))}}async G(){if(!this.v)return;const V=this.H(this.v),J=await this.D(V);if(!J)return;const z=J.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!s.$Mm(T,z))try{this.j.info("Invalidating Cache",z,T),await this.i.del(V),this.y.fire()}catch(F){this.j.error(F)}}H(V){const J=this.I(V);return this.h.extUri.joinPath(J.cacheHome,V.type===0?m.$Dl:m.$Cl)}I(V){return V.type===0?this.C.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.z.extensionsResource)?this.z:this.C.profiles.find(J=>this.h.extUri.isEqual(V.location,J.extensionsResource))??this.z:this.C.defaultProfile}};ne=ke([Q(2,A.$rk),Q(3,I.$bp),Q(4,P.$pk),Q(5,a.$Sj),Q(6,i.$Ri)],ne);function fe(ue,V){const J=(0,S.$ko)(ue.manifest.publisher,ue.manifest.name);return{id:J,identifier:new m.$Il(J),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:V,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$ip=fe;class ae extends U{constructor(V,J,z,T,F,B,x,oe,ce,G,R,L){super(V,J,(0,u.$9f)(z,".vscode-oss-dev","extensions","control.json"),T,F,B,x,oe,ce,G,R,L),this.N=(async()=>{if(p.$y)try{const N=await this.s.readFile(d.URI.file(p.$y));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(V){return this.N}}e.$jp=ae}),define(te[278],ie([0,1,5,41,40,25,82,16,33,7]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;let $=class extends D.$cp{constructor(p,u,y,v,c,d){super(h.URI.file(p.extensionsPath),u,y,v,c,d)}};e.$8M=$,e.$8M=$=ke([Q(0,f.$xh),Q(1,E.$Sj),Q(2,O.$rk),Q(3,s.$pk),Q(4,M.$Vk),Q(5,k.$Ri)],$)}),define(te[279],ie([0,1,7,33,82,130,16,6,5,22,40,41]),function(H,e,k,O,s,M,D,E,f,h,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d6b=void 0;let p=class extends M.$jp{constructor(y,v,c,d,l,w,S,m){super(k.URI.file(l.builtinExtensionsPath),k.URI.file(l.extensionsPath),l.userHome,y.defaultProfile,y,v,c,d,l,w,S,m)}};e.$d6b=p,e.$d6b=p=ke([Q(0,g.$rk),Q(1,s.$bp),Q(2,D.$Sj),Q(3,f.$Ri),Q(4,O.$xh),Q(5,h.$0i),Q(6,$.$pk),Q(7,E.$oh)],p)}),define(te[280],ie([0,1,14,2,15,9,4,58,7,31,38,33,5,41]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s6b=void 0;let y=class extends O.$lb{constructor(c,d,l){super(),this.c=c,this.f=l,this.a=E.$vh.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(c.appRoot),this.addValidFileRoot(c.extensionsPath),this.addValidFileRoot(d.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(c.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:c}=k.session;c.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(d,l)=>this.i(d,l)),c.protocol.interceptFileProtocol(s.Schemas.file,(d,l)=>this.h(d,l)),this.B((0,O.$jb)(()=>{c.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),c.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(c){const d=(0,M.$6c)(c);return this.a.get(d)?O.$lb.None:(this.a.set(d,!0),(0,O.$jb)(()=>this.a.delete(d)))}h(c,d){const l=f.URI.parse(c.url);return this.f.error(`Refused to load resource ${l.fsPath} from ${s.Schemas.file}: protocol (original URL: ${c.url})`),d({error:-3})}i(c,d){const l=this.j(c);let w;return this.c.crossOriginIsolated&&((0,M.$_c)(l)==="workbench.html"||(0,M.$_c)(l)==="workbench-dev.html"?w=s.COI.CoopAndCoep:w=s.COI.getHeadersFromQuery(c.url)),this.a.findSubstr(l)?d({path:l,headers:w}):this.b.has((0,M.$ad)(l).toLowerCase())?d({path:l}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${l} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${c.url})`),d({error:-3}))}j(c){const d=f.URI.parse(c.url),l=s.$1e.uriToFileUri(d);return(0,M.$6c)(l.fsPath)}createIPCObjectUrl(){let c;const d=f.URI.from({scheme:"vscode",path:(0,h.$3e)()}),l=d.toString(),w=async()=>c;return $.$wS.handle(l,w),this.f.trace(`IPC Object URL: Registered new channel ${l}.`),{resource:d,update:S=>c=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${l}.`),$.$wS.removeHandler(l)}}}};e.$s6b=y,e.$s6b=y=ke([Q(0,g.$xh),Q(1,u.$rk),Q(2,p.$Ri)],y)}),define(te[97],ie([0,1,8,3,2,65,12,112,6,41]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Ko="__$__isNewStorageMarker",e.$Lo="__$__targetStorageMarker",e.$Mo=(0,f.$ph)("storageService");var $;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})($||(e.WillSaveStateReason=$={}));var g;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(g||(e.StorageScope=g={}));var p;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function u(l){const w=l.get(e.$Lo);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.$No=u;class y extends s.$lb{static{this.a=60*1e3}constructor(w={flushInterval:y.a}){super(),this.j=w,this.b=this.B(new O.$hc),this.c=this.B(new O.$hc),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$ec),this.onWillSaveState=this.f.event,this.h=this.B(new k.$Gg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new s.$mb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(w,S,m){return O.Event.filter(this.b.event,t=>t.scope===w&&(S===void 0||t.key===S),m)}k(){this.i.value=(0,k.$Kg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,s.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.J()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(w,S){const{key:m,external:t}=S;if(m===e.$Lo){switch(w){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:m,target:this.F(w)[m],external:t})}r(w){this.f.fire({reason:w})}get(w,S,m){return this.L(S)?.get(w,m)}getBoolean(w,S,m){return this.L(S)?.getBoolean(w,m)}getNumber(w,S,m){return this.L(S)?.getNumber(w,m)}getObject(w,S,m){return this.L(S)?.getObject(w,m)}storeAll(w,S){this.t(()=>{for(const m of w)this.store(m.key,m.value,m.scope,m.target,S)})}store(w,S,m,t,a=!1){if((0,D.$re)(S)){this.remove(w,m,a);return}this.t(()=>{this.u(w,m,t),this.L(m)?.set(w,S,a)})}remove(w,S,m=!1){this.t(()=>{this.u(w,S,void 0),this.L(S)?.delete(w,m)})}t(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,S){const m=[],t=this.F(w);for(const a of Object.keys(t))t[a]===S&&m.push(a);return m}u(w,S,m,t=!1){const a=this.F(S);typeof m=="number"?a[w]!==m&&(a[w]=m,this.L(S)?.set(e.$Lo,JSON.stringify(a),t)):typeof a[w]=="number"&&(delete a[w],this.L(S)?.set(e.$Lo,JSON.stringify(a),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(w){switch(w){case-1:return this.D;case 0:return this.z;default:return this.w}}G(w){const S=this.L(w);return S?u(S):Object.create(null)}isNew(w){return this.getBoolean(e.$Ko,w)===!0}async flush(w=$.NONE){this.f.fire({reason:w});const S=this.L(-1),m=this.L(0),t=this.L(1);switch(w){case $.NONE:await k.Promises.settled([S?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case $.SHUTDOWN:await k.Promises.settled([S?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,m=this.L(1)?.items??new Map;return d(w,S,m,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(w,S){return this.r($.NONE),(0,h.$qk)(w)?this.N(w,S):this.O(w,S)}H(w,S){return!(w.id===S.id||v(S)&&v(w))}I(w,S,m){this.t(()=>{const t=new Set;for(const[a,r]of w)t.add(a),S.get(a)!==r&&this.n(m,{key:a,external:!0});for(const[a]of S.items)t.has(a)||this.n(m,{key:a,external:!0})})}}e.$Oo=y;function v(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.$Po=v;class c extends y{constructor(){super(),this.p=this.B(new E.$Io(new E.$Jo,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new E.$Io(new E.$Jo,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new E.$Io(new E.$Jo,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(w=>this.n(1,w))),this.B(this.P.onDidChangeStorage(w=>this.n(0,w))),this.B(this.p.onDidChangeStorage(w=>this.n(-1,w)))}L(w){switch(w){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(w){return!1}}e.$Qo=c;async function d(l,w,S,m,t,a){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;l.forEach((j,U)=>{i.set(U,j),n.set(U,r(j))});const o=new Map,b=new Map;w.forEach((j,U)=>{o.set(U,j),b.set(U,r(j))});const I=new Map,A=new Map;S.forEach((j,U)=>{I.set(U,j),A.set(U,r(j))}),console.group(m!==t?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const P=[];if(i.forEach((j,U)=>{P.push({key:U,value:j})}),console.table(P),console.groupEnd(),console.log(n),m!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];o.forEach((U,W)=>{j.push({key:W,value:U})}),console.table(j),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${a})`);const C=[];I.forEach((j,U)=>{C.push({key:U,value:j})}),console.table(C),console.groupEnd(),console.log(A)}e.$Ro=d}),define(te[281],ie([0,1,24,8,3,2,9,69,7,21,112,159,5,97,25,30]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I4b=e.$H4b=e.$G4b=e.$F4b=void 0;class c extends M.$lb{static{this.a=2e3}get storage(){return this.f}constructor(a,r){super(),this.j=a,this.k=r,this.b=this.B(new s.$ec),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$ec),this.onDidCloseStorage=this.c.event,this.f=new $.$Io(new $.$Jo,{hint:$.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new O.$Pg,this.whenInit=this.h.p,this.i=$.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===$.StorageState.None)try{const a=await this.n();this.f.dispose(),this.f=a,this.B(a.onDidChangeStorage(i=>this.b.fire(i))),await this.m(a);const r=a.getBoolean(u.$Ko);r===void 0?a.set(u.$Ko,!0):r&&a.set(u.$Ko,!1)}catch(a){this.j.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.i=$.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===p.LogLevel.Trace?a=>this.j.trace(a):void 0,logError:a=>this.j.error(a)}}m(a){return a.init()}get items(){return this.f.items}get(a,r){return this.f.get(a,r)}set(a,r){return this.f.set(a,r)}delete(a){return this.f.delete(a)}async close(){const a=new E.$ac(!1);await this.s(),a.stop(),a.elapsed()>c.a&&await this.r(a),this.c.fire()}async r(a){if(this.path)try{const r=(0,k.top)(Array.from(this.f.items.entries()).map(([n,o])=>({key:n,length:o.length})),(n,o)=>o.length-n.length,5).map(n=>`${n.key}:${n.length}`).join(", "),i=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${i}b, Large Keys: ${r}`)}catch(r){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",r)}}async s(){this.g&&await this.g,this.i=$.StorageState.Closed,await this.f.close()}}class d extends c{static{this.t="state.vscdb"}get path(){if(!this.v.useInMemoryStorage)return(0,D.$8c)(this.u.globalStorageHome.fsPath,d.t)}constructor(a,r,i,n){super(i,n),this.u=a,this.v=r}async n(){return new $.$Io(new g.$3S(this.path??g.$3S.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:$.StorageHint.STORAGE_IN_MEMORY})}}class l extends d{constructor(a,r,i,n){super(a,r,i,n)}}e.$F4b=l;class w extends d{constructor(a,r,i,n){super(r.defaultProfile,a,i,n)}async m(a){await super.m(a),this.z(a)}z(a){a.get(y.$Yk,void 0)===void 0&&a.set(y.$Yk,new Date().toUTCString());const i=a.get(y.$Xk,void 0),n=new Date().toUTCString();a.set(y.$Zk,typeof i>"u"?null:i),a.set(y.$Xk,n)}}e.$G4b=w;class S extends c{static{this.t="state.vscdb"}static{this.u="workspace.json"}get path(){if(!this.w.useInMemoryStorage)return(0,D.$8c)(this.y.workspaceStorageHome.fsPath,this.v.id,S.t)}constructor(a,r,i,n,o){super(i,o),this.v=a,this.w=r,this.y=n}async n(){const{storageFilePath:a,wasCreated:r}=await this.C();return new $.$Io(new g.$3S(a,{logging:this.l()}),{hint:this.w.useInMemoryStorage?$.StorageHint.STORAGE_IN_MEMORY:r?$.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:g.$3S.IN_MEMORY_PATH,wasCreated:!0};const a=(0,D.$8c)(this.y.workspaceStorageHome.fsPath,this.v.id),r=(0,D.$8c)(a,S.t);return await h.Promises.exists(a)?{storageFilePath:r,wasCreated:!1}:(await h.Promises.mkdir(a,{recursive:!0}),this.D(a),{storageFilePath:r,wasCreated:!0})}async D(a){let r;if((0,v.$zh)(this.v)?r={folder:this.v.uri.toString()}:(0,v.$Eh)(this.v)&&(r={workspace:this.v.configPath.toString()}),r)try{const i=(0,D.$8c)(a,S.u);await h.Promises.exists(i)||await h.Promises.writeFile(i,JSON.stringify(r,void 0,2))}catch(i){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${i}`)}}}e.$H4b=S;class m extends c{get path(){}async n(){return new $.$Io(new $.$Jo,{hint:$.StorageHint.STORAGE_IN_MEMORY})}}e.$I4b=m}),define(te[282],ie([0,1,3,2,97]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=void 0;class M extends O.$lb{constructor(E,f,h){super(),this.b=E,this.c=f,this.f=h;const $=this.B(new O.$mb);this.a=this.B(new k.$ec({onWillAddFirstListener:()=>$.value=this.g(),onDidRemoveLastListener:()=>$.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new O.$kb;return E.add(k.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,h)=>(f?f.push(h.key):f=[h.key],f),100)(f=>this.h(f))),E.add(k.Event.debounce(this.b.onDidChangeProfileStorage,(f,h)=>{f||(f=new Map);let $=f.get(h.profile.id);return $||f.set(h.profile.id,$={profile:h.profile,keys:[],storage:h.storage}),$.keys.push(h.key),f},100)(f=>this.i(f))),E}h(E){const f=E.includes(s.$Lo)?[this.c.defaultProfile]:[],h=[];if(E=E.filter($=>$!==s.$Lo),E.length){const $=(0,s.$No)(this.b.applicationStorage.storage);h.push({profile:this.c.defaultProfile,changes:E.map(g=>({key:g,scope:0,target:$[g]}))})}this.j(f,h)}i(E){const f=[],h=new Map;for(const[$,g]of E.entries()){g.keys.includes(s.$Lo)&&f.push(g.profile);const p=g.keys.filter(u=>u!==s.$Lo);if(p.length){const u=(0,s.$No)(g.storage.storage);h.set($,{profile:g.profile,changes:p.map(y=>({key:y,scope:0,target:u[y]}))})}}this.j(f,[...h.values()])}j(E,f){(E.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:E})}listen(E,f,h){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(E,f){throw new Error(`Call not found: ${f}`)}}e.$f6b=M}),define(te[283],ie([0,1,7,33,16,5,34,40,41,12,122]),function(H,e,k,O,s,M,D,E,f,h,$){"use strict";var g,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.$5M=void 0;let u=class extends f.$uk{static{g=this}static{this.a="profileAssociationsMigration"}constructor(d,l,w,S,m){super(w,S,l,m),this.P=d,this.Q=w}J(){return this.P.getItem(g.b,[]).map(l=>({...l,location:(0,h.$ie)(l.location)?this.s.extUri.joinPath(this.profilesHome,l.location):k.URI.revive(l.location)}))}M(){const d=this.P.getItem(g.c,{});return this.P.getItem(g.a,!1)?d:this.I(d)}O(){return this.s.extUri.joinPath(k.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$5M=u,e.$5M=u=g=ke([Q(0,D.$ZM),Q(1,E.$pk),Q(2,O.$xh),Q(3,s.$Sj),Q(4,M.$Ri)],u);let y=p=class extends u{constructor(d,l,w,S,m){super(d,l,w,S,m),this.W=d}L(d){d.length?this.W.setItem(p.b,d.map(l=>({...l,location:this.s.extUri.basename(l.location)}))):this.W.removeItem(p.b)}J(){const d=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(d),this.W.setItem("userDataProfilesMigration",!0)),d}N(d){d.emptyWindows||d.workspaces?this.W.setItem(p.c,d):this.W.removeItem(p.c)}M(){const d="workspaceAndProfileInfo",l=this.W.getItem(d,void 0);if(l){this.W.removeItem(d);const S=l.reduce((m,{workspace:t,profile:a})=>(m[k.URI.revive(t).toString()]=k.URI.revive(a).toString(),m),{});this.W.setItem(p.c,{workspaces:S})}const w=super.M();return this.W.getItem(p.a,!1)||(this.N(w),this.W.setItem(p.a,!0)),w}};e.$6M=y,e.$6M=y=p=ke([Q(0,D.$1M),Q(1,E.$pk),Q(2,O.$xh),Q(3,s.$Sj),Q(4,M.$Ri)],y);let v=class extends y{constructor(d,l,w,S){super(new $.$4M(0,l,S,w),d,l,w,S)}async init(){return await this.W.init(),super.init()}};e.$7M=v,e.$7M=v=ke([Q(0,E.$pk),Q(1,O.$xh),Q(2,s.$Sj),Q(3,M.$Ri)],v)}),define(te[53],ie([0,1,33,16,6,5,40,41,283,34]),function(H,e,k,O,s,M,D,E,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K4b=e.$J4b=void 0,e.$J4b=(0,s.$qh)(E.$rk);let $=class extends f.$6M{constructor(p,u,y,v,c){super(p,u,y,v,c)}getAssociatedEmptyWindows(){const p=[];for(const u of this.v.emptyWindows.keys())p.push({id:u});return p}};e.$K4b=$,e.$K4b=$=ke([Q(0,h.$1M),Q(1,D.$pk),Q(2,k.$xh),Q(3,O.$Sj),Q(4,M.$Ri)],$)}),define(te[131],ie([0,1,19,7,30]),function(H,e,k,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$64b=e.$54b=e.$44b=void 0;async function M(f,h,$){for(const p of f){const u=p.openedWorkspace;if((0,s.$Eh)(u)){const y=await $(u);if(y){if(y.folders.some(v=>k.$Zf.isEqualOrParent(h,v.uri)))return p}else if(k.$Zf.isEqualOrParent(h,u.configPath))return p}}const g=f.filter(p=>(0,s.$zh)(p.openedWorkspace)&&k.$Zf.isEqualOrParent(h,p.openedWorkspace.uri));if(g.length)return g.sort((p,u)=>-(p.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.$44b=M;function D(f,h){for(const $ of f)if((0,s.$Eh)($.openedWorkspace)&&k.$Zf.isEqual($.openedWorkspace.configPath,h)||(0,s.$zh)($.openedWorkspace)&&k.$Zf.isEqual($.openedWorkspace.uri,h))return $}e.$54b=D;function E(f,h){const $=g=>h.some(p=>k.$Zf.isEqual(O.URI.file(p),O.URI.file(g)));for(const g of f)if(g.config?.extensionDevelopmentPath?.some(p=>$(p)))return g}e.$64b=E}),define(te[98],ie([0,1,32,44,137,46,15,9,4,19,7,6,60,30]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4T=e.$3T=e.$2T=e.$1T=e.$ZT=e.$YT=e.$XT=e.$WT=e.$VT=e.$UT=void 0,e.$UT=(0,g.$ph)("workspacesService");function y(A){return A.hasOwnProperty("workspace")}e.$VT=y;function v(A){return A.hasOwnProperty("folderUri")}e.$WT=v;function c(A){return A.hasOwnProperty("fileUri")}e.$XT=c;function d(A){return l(A)||w(A)}e.$YT=d;function l(A){const P=A;return typeof P?.path=="string"&&(!P.name||typeof P.name=="string")}function w(A){const P=A;return typeof P?.uri=="string"&&(!P.name||typeof P.name=="string")}function S(A,P,C,j,U){if(A.scheme!==j.scheme)return{name:C,uri:A.toString(!0)};let W=P?void 0:U.relativePath(j,A);if(W!==void 0)W.length===0?W=".":f.$i&&(W=m(W));else if(A.scheme===D.Schemas.file)W=A.fsPath,f.$i&&(W=m(W));else if(U.isEqualAuthority(A.authority,j.authority))W=A.path;else return{name:C,uri:A.toString(!0)};return{name:C,path:W}}e.$ZT=S;function m(A){return A=(0,M.$7z)(A),(0,k.$Ee)(A)||(A=(0,k.$Be)(A)),A}function t(A,P,C){const j=[],U=new Set,W=C.dirname(P);for(const re of A){let ne;if(l(re))re.path&&(ne=C.resolvePath(W,re.path));else if(w(re))try{ne=$.URI.parse(re.uri),ne.path[0]!==E.$5c.sep&&(ne=ne.with({path:E.$5c.sep+ne.path}))}catch(fe){console.warn(fe)}if(ne){const fe=C.getComparisonKey(ne);if(!U.has(fe)){U.add(fe);const ae=re.name||C.basenameOrAuthority(ne);j.push(new u.$Jh({uri:ne,name:ae,index:j.length},re))}}}return j}e.$1T=t;function a(A,P,C,j,U){const W=r(P,A),re=U.dirname(P),ne=U.dirname(j),fe=[];for(const J of W.folders){const z=l(J)?U.resolvePath(re,J.path):$.URI.parse(J.uri);let T;C?T=!1:T=!l(J)||(0,E.$7c)(J.path),fe.push(S(z,T,J.name,ne,U))}const ae={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},ue=s.$gS(A,["folders"],fe,ae);let V=s.$jS(A,ue);return(0,h.$bg)(W.remoteAuthority,(0,p.$Bk)(j))&&(V=s.$jS(V,s.$fS(V,["remoteAuthority"],ae))),V}e.$2T=a;function r(A,P){const C=O.$ym(P);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(j=>d(j));else throw new Error(`${A} looks like an invalid workspace file.`);return C}function i(A){return A.workspace&&typeof A.workspace=="object"&&typeof A.workspace.id=="string"&&typeof A.workspace.configPath=="string"}function n(A){return typeof A.folderUri=="string"}function o(A){return typeof A.fileUri=="string"}function b(A,P){const C={workspaces:[],files:[]};if(A){const j=function(W,re){for(let ne=0;ne<W.length;ne++)try{re(W[ne],ne)}catch(fe){P.warn(`Error restoring recent entry ${JSON.stringify(W[ne])}: ${fe.toString()}. Skip entry.`)}},U=A;Array.isArray(U.entries)&&j(U.entries,W=>{const re=W.label,ne=W.remoteAuthority;i(W)?C.workspaces.push({label:re,remoteAuthority:ne,workspace:{id:W.workspace.id,configPath:$.URI.parse(W.workspace.configPath)}}):n(W)?C.workspaces.push({label:re,remoteAuthority:ne,folderUri:$.URI.parse(W.folderUri)}):o(W)&&C.files.push({label:re,remoteAuthority:ne,fileUri:$.URI.parse(W.fileUri)})})}return C}e.$3T=b;function I(A){const P={entries:[]};for(const C of A.workspaces)v(C)?P.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):P.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of A.files)P.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return P}e.$4T=I}),define(te[99],ie([0,1,72,15,4,19]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y4b=e.$X4b=e.$W4b=e.$V4b=void 0,e.$V4b=128/4;function D(h){function $(){let g=h.scheme===O.Schemas.file?(0,M.$Wf)(h):h.toString();return s.$k||(g=g.toLowerCase()),(0,k.createHash)("md5").update(g).digest("hex")}return{id:$(),configPath:h}}e.$W4b=D;function E(h,$){function g(){if(h.scheme!==O.Schemas.file)return(0,k.createHash)("md5").update(h.toString()).digest("hex");if(!$)return;let u;return s.$k?u=$.ino:s.$j?u=$.birthtime.getTime():s.$i&&(typeof $.birthtimeMs=="number"?u=Math.floor($.birthtimeMs):u=$.birthtime.getTime()),(0,k.createHash)("md5").update(h.fsPath).update(u?String(u):"").digest("hex")}const p=g();if(typeof p=="string")return{id:p,uri:h}}e.$X4b=E;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$Y4b=f}),define(te[100],ie([0,1,72,88,27,284,17,13,3,2,9,4,31,42,110]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=void 0;class v{traceSocketEvent(P,C){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,C)}constructor(P,C=""){this.f=!0,this.debugLabel=C,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,E.$Y)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(P){const C=j=>{this.traceSocketEvent("read",j),P(D.$Ec.wrap(j))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(P){const C=j=>{P({type:0,hadError:j,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(P){const C=()=>{P()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(P){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,E.$Y)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,E.$Y)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$eh=v;var c;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var d;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(d||(d={}));class l extends h.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(P,C){this.socket.traceSocketEvent(P,C)}constructor(P,C,j,U){super(),this.f=this.B(new f.$ec),this.g=this.B(new f.$ec),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:j?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new w(this,C,j,U,this.f,(W,re)=>this.k(W,re))),this.B(this.a.onError(W=>{console.error(W),(0,E.$Y)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new y.$_g,this.B(this.socket.onData(W=>this.l(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this.f.event(P)}onClose(P){return this.g.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let C=0;for(;C<P.byteLength;)this.a.writeMessage(P.slice(C,Math.min(C+262144,P.byteLength))),C+=262144}k(P,C){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let j=2;P.byteLength<126?j+=0:P.byteLength<2**16?j+=2:j+=8;const U=D.$Ec.alloc(j);if(C?U.writeUInt8(194,0):U.writeUInt8(130,0),P.byteLength<126)U.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){U.writeUInt8(126,1);let W=1;U.writeUInt8(P.byteLength>>>8&255,++W),U.writeUInt8(P.byteLength>>>0&255,++W)}else{U.writeUInt8(127,1);let W=1;U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(P.byteLength>>>24&255,++W),U.writeUInt8(P.byteLength>>>16&255,++W),U.writeUInt8(P.byteLength>>>8&255,++W),U.writeUInt8(P.byteLength>>>0&255,++W)}this.socket.write(D.$Ec.concat([U,P]))}end(){this.h=!0,this.socket.end()}l(P){if(P.byteLength!==0){for(this.b.acceptChunk(P);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),j=C.readUInt8(0),U=(j&128)>>>7,W=(j&64)>>>6,re=C.readUInt8(1),ne=(re&128)>>>7,fe=re&127;this.j.state=2,this.j.readLen=2+(ne?4:0)+(fe===126?2:0)+(fe===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),j=C.readUInt8(1),U=(j&128)>>>7;let W=j&127,re=1;W===126?W=C.readUInt8(++re)*2**8+C.readUInt8(++re):W===127&&(W=C.readUInt8(++re)*0+C.readUInt8(++re)*0+C.readUInt8(++re)*0+C.readUInt8(++re)*0+C.readUInt8(++re)*2**24+C.readUInt8(++re)*2**16+C.readUInt8(++re)*2**8+C.readUInt8(++re));let ne=0;U&&(ne=C.readUInt8(++re)*2**24+C.readUInt8(++re)*2**16+C.readUInt8(++re)*2**8+C.readUInt8(++re)),this.j.state=3,this.j.readLen=W,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(C,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$fh=l;class w extends h.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Ec.alloc(0)}constructor(P,C,j,U,W,re){super(),this.l=P,this.m=W,this.n=re,this.a=this.B(new f.$ec),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$ec),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new f.$ec),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,C?(this.b=this.B(new S(this.l,U,j,{windowBits:15})),this.f=this.B(new m(this.l,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(P){this.g.push(P),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const P=this.g.shift();if(this.f){const C=await this.s(this.f,P);this.n(C,!0)}else this.n(P,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(P,C){return new Promise((j,U)=>{P.write(C),P.flush(W=>j(W))})}acceptFrame(P,C,j){this.h.push({data:P,isCompressed:C,isLastFrameOfMessage:j}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const P=this.h.shift();if(this.b&&P.isCompressed){const C=await this.w(this.b,P.data,P.isLastFrameOfMessage);this.m.fire(C)}else this.m.fire(P.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(P,C,j){return new Promise((U,W)=>{P.write(C),j&&P.write(D.$Ec.fromByteArray([0,0,255,255])),P.flush(re=>U(re))})}}class S extends h.$lb{get recordedInflateBytes(){return this.j?D.$Ec.concat(this.f):D.$Ec.alloc(0)}constructor(P,C,j,U){super(),this.h=P,this.j=C,this.a=this.B(new f.$ec),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(D.$Ec.wrap(W))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(P){this.j&&this.f.push(P.clone()),this.h.traceSocketEvent("zlibInflateWrite",P),this.b.write(P.buffer)}flush(P){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=D.$Ec.concat(this.g);this.g.length=0,P(C)})}}class m extends h.$lb{constructor(P,C){super(),this.g=P,this.a=this.B(new f.$ec),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$Ec.wrap(j))})}write(P){this.g.traceSocketEvent("zlibDeflateWrite",P.buffer),this.b.write(P.buffer)}flush(P){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=D.$Ec.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),P(C)})}}function t(A,P){if(P===0)return;const C=A.byteLength>>>2;for(let fe=0;fe<C;fe++){const ae=A.readUInt32BE(fe*4);A.writeUInt32BE(ae^P,fe*4)}const j=C*4,U=A.byteLength-j,W=P>>>24&255,re=P>>>16&255,ne=P>>>8&255;U>=1&&A.writeUInt8(A.readUInt8(j)^W,j),U>=2&&A.writeUInt8(A.readUInt8(j+1)^re,j+1),U>=3&&A.writeUInt8(A.readUInt8(j+2)^ne,j+2)}e.$gh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function r(){const A=(0,p.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const P=process.platform!=="darwin"&&e.$gh?e.$gh:(0,s.tmpdir)(),C=(0,$.$8c)(P,`vscode-ipc-${A}.sock`);return n(C),C}e.$hh=r;function i(A,P,C){const j=(0,k.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${C}-${P}-sock`;const U=C.substr(0,4),W=P.substr(0,6),re=j.substr(0,8);let ne;return process.platform!=="darwin"&&e.$gh&&!process.env.VSCODE_PORTABLE?ne=(0,$.$8c)(e.$gh,`vscode-${re}-${U}-${W}.sock`):ne=(0,$.$8c)(A,`${U}-${W}.sock`),n(ne),ne}e.$ih=i;function n(A){const P=a[g.$t];typeof P=="number"&&A.length>=P&&console.warn(`WARNING: IPC handle "${A}" is longer than ${P} chars, try a shorter --user-data-dir`)}class o extends u.$6g{static b(P){const C=f.Event.fromNodeEventEmitter(P,"connection");return f.Event.map(C,j=>({protocol:new y.$ah(new v(j,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(j,"close"))}))}constructor(P){super(o.b(P)),this.d=P}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$jh=o;function b(A){return new Promise((P,C)=>{const j=(0,O.createServer)();j.on("error",C),j.listen(A,()=>{j.removeListener("error",C),P(new o(j))})})}e.$kh=b;function I(A,P){return new Promise((C,j)=>{const U=(0,O.createConnection)(A,()=>{U.removeListener("error",j),C(y.$bh.fromSocket(new v(U,`ipc-client${P}`),P))});U.once("error",j)})}e.$lh=I}),define(te[28],ie([0,1,55,9,4,100,33,90,6]),function(H,e,k,O,s,M,D,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C4b=e.$B4b=void 0,e.$B4b=(0,f.$qh)(D.$wh);class h extends E.$Yl{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,O.$8c)(this.userDataPath,"clp")}get backupHome(){return(0,O.$8c)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$ih)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,O.$8c)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const g in process.env)if(g.endsWith("_VSCODE_SNAP_ORIG")){const p=g.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[g]?process.env[p]=process.env[g]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$k)for(const g in this.d)process.env[g]=this.d[g],delete this.d[g]}}e.$C4b=h,ke([k.$Tg],h.prototype,"cachedLanguagesPath",null),ke([k.$Tg],h.prototype,"backupHome",null),ke([k.$Tg],h.prototype,"mainIPCHandle",null),ke([k.$Tg],h.prototype,"mainLockfile",null),ke([k.$Tg],h.prototype,"disableUpdates",null),ke([k.$Tg],h.prototype,"crossOriginIsolated",null),ke([k.$Tg],h.prototype,"codeCachePath",null),ke([k.$Tg],h.prototype,"useCodeCache",null)}),define(te[285],ie([0,1,72,32,15,9,4,19,21,194,18,28,34,16,5,193,30,99]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Z4b=void 0;let w=class{static{l=this}static{this.a="backupWorkspaces"}constructor(m,t,a,r){this.j=m,this.k=t,this.l=a,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$Zf,this.i={isEqual:(i,n)=>(0,O.$Ge)(i,n,!D.$k)}}async initialize(){const m=this.m.getItem(l.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(m.emptyWindows),this.d=await this.u((0,h.$S4b)(m)),this.e=await this.v((0,h.$T4b)(m)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.$ek.OFF}q(){return this.s()===u.$ek.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.$ek.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(m,t){this.d.some(r=>m.workspace.id===r.workspace.id)||(this.d.push(m),this.C());const a=(0,M.$8c)(this.c,m.workspace.id);return t?this.t(a,t).then(()=>a):a}async t(m,t){if(await f.Promises.exists(m)&&await this.z(m),await f.Promises.exists(t))try{await f.Promises.rename(t,m,!1)}catch(a){this.l.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}registerFolderBackup(m){return this.e.some(t=>this.h.isEqual(m.folderUri,t.folderUri))||(this.e.push(m),this.C()),(0,M.$8c)(this.c,this.D(m))}registerEmptyWindowBackup(m){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,m.backupFolder))||(this.g.push(m),this.C()),(0,M.$8c)(this.c,m.backupFolder)}async u(m){if(!Array.isArray(m))return[];const t=new Set,a=[];for(const r of m){const i=r.workspace;if(!(0,c.$Eh)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$8c)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?a.push(r):await this.z(n):await this.x(n)}}return a}async v(m){if(!Array.isArray(m))return[];const t=[],a=new Set;for(const r of m){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!a.has(n)){a.add(n);const o=(0,M.$8c)(this.c,this.D(r));await this.B(o)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(o):await this.x(o)}}return t}async w(m){if(!Array.isArray(m))return[];const t=[],a=new Set;for(const r of m){const i=r.backupFolder;if(typeof i!="string")return[];if(!a.has(i)){a.add(i);const n=(0,M.$8c)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(m){try{await f.Promises.rm(m,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let m=(0,d.$Y4b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,m.id));)m=(0,d.$Y4b)();return{backupFolder:m.id}}async z(m){const t=this.y(),a=(0,M.$8c)(this.c,t.backupFolder);try{await f.Promises.rename(m,a,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const m=[];for(const t of this.d)await this.A(t)&&m.push(t);for(const t of this.e)await this.A(t)&&m.push(t);return m}A(m){let t;return(0,h.$R4b)(m)?t=(0,M.$8c)(this.c,m.backupFolder):(0,v.$ST)(m)?t=(0,M.$8c)(this.c,this.D(m)):t=(0,M.$8c)(this.c,m.workspace.id),this.B(t)}async B(m){try{const t=await f.Promises.readdir(m);for(const a of t)try{if((await f.Promises.readdir((0,M.$8c)(m,a))).length>0)return!0}catch{}}catch{}return!1}C(){const m={workspaces:this.d.map(({workspace:t,remoteAuthority:a})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return a&&(r.remoteAuthority=a),r}),folders:this.e.map(({folderUri:t,remoteAuthority:a})=>{const r={folderUri:t.toString()};return a&&(r.remoteAuthority=a),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:a})=>{const r={backupFolder:t};return a&&(r.remoteAuthority=a),r})};this.m.setItem(l.a,m)}D(m){const t=m.folderUri;let a;return t.scheme===s.Schemas.file?a=D.$k?t.fsPath:t.fsPath.toLowerCase():a=t.toString().toLowerCase(),(0,k.createHash)("md5").update(a).digest("hex")}};e.$Z4b=w,e.$Z4b=w=l=ke([Q(0,g.$B4b),Q(1,$.$Vh),Q(2,y.$Ri),Q(3,p.$1M)],w)}),define(te[20],ie([0,1,14,38,8,3,2,4,36,12,6,5,34,28]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$E4b=e.LifecycleMainPhase=e.ShutdownReason=e.$D4b=void 0,e.$D4b=(0,$.$ph)("lifecycleMainService");var v;(function(l){l[l.QUIT=1]="QUIT",l[l.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var c;(function(l){l[l.Starting=1]="Starting",l[l.Ready=2]="Ready",l[l.AfterWindowOpen=3]="AfterWindowOpen",l[l.Eventually=4]="Eventually"})(c||(e.LifecycleMainPhase=c={}));let d=class extends D.$lb{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(w,S,m){super(),this.w=w,this.y=S,this.z=m,this.c=this.B(new M.$ec),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$ec),this.onWillShutdown=this.f.event,this.g=this.B(new M.$ec),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$ec),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.v=void 0,this.C(),this.when(2).then(()=>this.D())}C(){this.j=!!this.y.getItem(y.b),this.j&&this.y.removeItem(y.b)}D(){const w=()=>{this.i||(this.N("Lifecycle#app.on(before-quit)"),this.i=!0,this.N("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.n===0&&this.F(1))};k.app.addListener("before-quit",w);const S=()=>{this.N("Lifecycle#app.on(window-all-closed)"),(this.i||!E.$j)&&k.app.quit()};k.app.addListener("window-all-closed",S),k.app.once("will-quit",m=>{this.N("Lifecycle#app.on(will-quit) - begin"),m.preventDefault(),this.F(1).finally(()=>{this.N("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.I(!1),k.app.removeListener("before-quit",w),k.app.removeListener("window-all-closed",S),this.N("Lifecycle#app.on(will-quit) - calling app.quit()"),k.app.quit()})})}F(w){if(this.s)return this.s;const S=this.w;this.N("Lifecycle#onWillShutdown.fire()");const m=[];return this.f.fire({reason:w,join(t,a){S.trace(`Lifecycle#onWillShutdown - begin '${t}'`),m.push(a.finally(()=>{S.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.s=(async()=>{try{await s.Promises.settled(m)}catch(t){this.w.error(t)}try{await this.y.close()}catch(t){this.w.error(t)}})(),this.s}set phase(w){if(w<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===w)return;this.N(`lifecycle (main): phase changed (value: ${w})`),this.k=w;const S=this.u.get(this.k);S&&(S.open(),this.u.delete(this.k))}async when(w){if(w<=this.k)return;let S=this.u.get(w);S||(S=new s.$tg,this.u.set(w,S)),await S.wait()}registerWindow(w){const S=new D.$kb;this.n++,S.add(w.onWillLoad(t=>this.g.fire({window:w,workspace:t.workspace,reason:t.reason})));const m=(0,h.$te)(w.win);m.on("close",t=>{const a=w.id;if(this.l.has(a)){this.l.delete(a);return}this.N(`Lifecycle#window.on('close') - window ID ${w.id}`),t.preventDefault(),this.unload(w,1).then(r=>{if(r){this.l.delete(a);return}this.l.add(a),this.N(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this.h.fire(w),w.close()})}),m.on("closed",()=>{this.N(`Lifecycle#window.on('closed') - window ID ${w.id}`),this.n--,S.dispose(),this.n===0&&(!E.$j||this.i)&&this.F(1)})}async reload(w,S){await this.unload(w,3)||w.reload(S)}unload(w,S){const m=this.t.get(w.id);if(m)return m;const t=this.G(w,S).finally(()=>{this.t.delete(w.id)});return this.t.set(w.id,t),t}async G(w,S){if(!w.isReady)return!1;this.N(`Lifecycle#unload() - window ID ${w.id}`);const m=this.i?2:S,t=await this.J(w,m);return t?(this.N(`Lifecycle#unload() - veto in renderer (window ID ${w.id})`),this.H(t)):(await this.L(w,m),!1)}H(w){return w?(this.I(!0),this.i=!1,!0):!1}I(w){this.r&&(this.r(w),this.r=void 0,this.p=void 0)}J(w,S){return new Promise(m=>{const t=this.m++,a=`vscode:ok${t}`,r=`vscode:cancel${t}`;O.$wS.once(a,()=>{m(!1)}),O.$wS.once(r,()=>{m(!0)}),w.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:r,reason:S})})}L(w,S){return new Promise(m=>{const a=`vscode:reply${this.m++}`;O.$wS.once(a,()=>m()),w.send("vscode:onWillUnload",{replyChannel:a,reason:S})})}quit(w){return this.M(w).then(S=>{if(!S&&w)try{if(E.$i){const m=(0,f.cwd)();m!==process.cwd()&&process.chdir(m)}}catch(m){this.w.error(m)}return S})}M(w){return this.N(`Lifecycle#quit() - begin (willRestart: ${w})`),this.p?(this.N("Lifecycle#quit() - returning pending quit promise"),this.p):(w&&this.y.setItem(y.b,!0),this.p=new Promise(S=>{this.r=S,this.N("Lifecycle#quit() - calling app.quit()"),k.app.quit()}),this.p)}N(w){this.z.args["enable-smoke-test-driver"]?this.w.info(w):this.w.trace(w)}setRelaunchHandler(w){this.v=w}async relaunch(w){this.N("Lifecycle#relaunch()");const S=process.argv.slice(1);if(w?.addArgs&&S.push(...w.addArgs),w?.removeArgs)for(const a of w.removeArgs){const r=S.indexOf(a);r>=0&&S.splice(r,1)}const m=()=>{this.v?.handleRelaunch(w)||(this.N("Lifecycle#relaunch() - calling app.relaunch()"),k.app.relaunch({args:S}))};k.app.once("quit",m),await this.quit(!0)&&k.app.removeListener("quit",m)}async kill(w){this.N("Lifecycle#kill()"),await this.F(2),await Promise.race([(0,s.$vg)(1e3),(async()=>{for(const S of k.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let m;S.webContents&&!S.webContents.isDestroyed()?m=new Promise(t=>S.once("closed",t)):m=Promise.resolve(),S.destroy(),await m}})()]),k.app.exit(w)}};e.$E4b=d,e.$E4b=d=y=ke([Q(0,g.$Ri),Q(1,p.$1M),Q(2,u.$B4b)],d)}),define(te[286],ie([0,1,4,3,2,6,20]),function(H,e,k,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u5b=e.$t5b=void 0,e.$t5b=(0,M.$ph)("keyboardLayoutMainService");let E=class extends s.$lb{constructor($){super(),this.a=this.B(new O.$ec),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,$.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const $=await new Promise((g,p)=>{H(["native-keymap"],g,p)});this.c=f($),k.$s||$.onDidChangeKeyboardLayout(()=>{this.c=f($),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$u5b=E,e.$u5b=E=ke([Q(0,D.$D4b)],E);function f(h){const $=h.getKeyMap(),g=h.getCurrentKeyboardLayout();return{keyboardMapping:$,keyboardLayoutInfo:g}}}),define(te[287],ie([0,1,245,8,17,13,12,18,33,95,5,51,244,284]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;let y=class extends g.$Bo{constructor(l,w,S,m){super(m),this.j=l,this.k=w,this.l=S,this.m(),this.B(l.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const l=this.j.getValue("http");this.f=l?.proxy,this.g=!!l?.proxyStrictSSL,this.h=l?.proxyAuthorization}async request(l,w){const{f:S,g:m}=this;let t;try{t=await(0,h.$zl)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,M.$9)(i)))}const a={...process.env,...t},r=l.agent?l.agent:await(0,p.$Eq)(l.url||"",a,{proxyUrl:S,strictSSL:m});return l.agent=r,l.strictSSL=m,this.h&&(l.headers={...l.headers||{},"Proxy-Authorization":this.h}),this.c(l.isChromiumNetwork?"electron":"node",l,()=>c(l,w))}async resolveProxy(l){}};e.$Fq=y,e.$Fq=y=ke([Q(0,E.$Vh),Q(1,f.$xh),Q(2,$.$Ri),Q(3,$.$Si)],y);async function v(d){return((0,k.parse)(d.url).protocol==="https:"?await new Promise((S,m)=>{H(["https"],S,m)}):await new Promise((S,m)=>{H(["http"],S,m)})).request}async function c(d,l){return O.Promises.withAsyncBody(async(w,S)=>{const m=(0,k.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await v(d),a={hostname:m.hostname,port:m.port?parseInt(m.port):m.protocol==="https:"?443:80,protocol:m.protocol,path:m.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,D.$oe)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(a.auth=d.user+":"+d.password);const r=t(a,i=>{const n=(0,D.$me)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)c({...d,url:i.headers.location,followRedirects:n-1},l).then(w,S);else{let o=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,u.createGunzip)())),w({res:i,stream:(0,s.$Tc)(o)})}});r.on("error",S),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),l.onCancellationRequested(()=>{r.abort(),S(new M.$3)})})}e.$Gq=c}),define(te[288],ie([0,1,14,287]),function(H,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=void 0;function s(D){return k.net.request}class M extends O.$Fq{request(E,f){return super.request({...E||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$x6b=M}),define(te[83],ie([0,1,7,49,3,2,33,16,6,20,5,97,281,41,53,40]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O4b=e.$N4b=e.$M4b=e.$L4b=void 0,e.$L4b=(0,f.$ph)("storageMainService");let c=class extends M.$lb{constructor(w,S,m,t,a,r){super(),this.c=w,this.f=S,this.g=m,this.h=t,this.i=a,this.j=r,this.a=void 0,this.b=this.B(new s.$ec),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(w=>{w.window.profile&&this.profileStorage(w.window.profile).init(),w.workspace&&this.workspaceStorage(w.workspace).init()})),this.B(this.h.onWillShutdown(w=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=w.reason,w.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.n)w.join("profileStorage",S.close());for(const[,S]of this.r)w.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(w=>{w.join((async()=>{await this.i.exists(w.profile.globalStorageHome)||await this.i.createFolder(w.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(w=>{const S=this.n.get(w.profile.id);S&&w.join(S.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const w=new p.$G4b(this.k(),this.g,this.c,this.i);return(0,O.$cb)(w.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),w}profileStorage(w){if((0,g.$Po)(w))return this.applicationStorage;let S=this.n.get(w.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${w.name})`),S=this.p(w),this.n.set(w.id,S);const m=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:w})));(0,O.$cb)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${w.name})`),this.n.delete(w.id),m.dispose()})}return S}p(w){return this.a===2?new p.$I4b(this.c,this.i):new p.$F4b(w,this.k(),this.c,this.i)}workspaceStorage(w){let S=this.r.get(w.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${w.id})`),S=this.s(w),this.r.set(w.id,S),(0,O.$cb)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${w.id})`),this.r.delete(w.id)})),S}s(w){return this.a===2?new p.$I4b(this.c,this.i):new p.$H4b(w,this.k(),this.c,this.f,this.i)}isUsed(w){const S=k.URI.file(w);for(const m of[this.applicationStorage,...this.n.values(),...this.r.values()])if(m.path&&this.j.extUri.isEqualOrParent(k.URI.file(m.path),S))return!0;return!1}};e.$M4b=c,e.$M4b=c=ke([Q(0,$.$Ri),Q(1,D.$wh),Q(2,y.$J4b),Q(3,h.$D4b),Q(4,E.$Sj),Q(5,v.$pk)],c),e.$N4b=(0,f.$ph)("applicationStorageMainService");let d=class extends g.$Oo{constructor(w,S){super(),this.p=w,this.s=S,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(w){if(w===-1)return this.s.applicationStorage.storage}M(w){if(w===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$O4b=d,e.$O4b=d=ke([Q(0,u.$rk),Q(1,e.$L4b)],d)}),define(te[289],ie([0,1,14,23,3,57,2,31,76,116,5,22,83,29]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q4b=void 0;var y;(function(c){c[c.Initial=1]="Initial",c[c.StoredCredentialsUsed=2]="StoredCredentialsUsed",c[c.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let v=class extends D.$lb{constructor(d,l,w,S,m,t){super(),this.h=d,this.i=l,this.j=w,this.k=S,this.l=m,this.m=t,this.a=`${this.m.urlProtocol}.proxy-credentials`,this.b="proxy-credentials://",this.c=void 0,this.f=y.Initial,this.g=void 0,this.n()}n(){const d=s.Event.fromNodeEventEmitter(k.app,"login",(l,w,S,m,t)=>({event:l,webContents:w,req:S,authInfo:m,callback:t}));this.B(d(this.p,this))}async p({event:d,authInfo:l,req:w,callback:S}){if(!l.isProxy)return;if(!this.c&&this.f===y.LoginDialogShown&&w.firstAuthAttempt){this.h.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}d.preventDefault();let m;if(this.c)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),m=await this.c;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.c=this.r(l);try{m=await this.c}finally{this.c=void 0}}S(m?.username,m?.password)}async r(d){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const l=await this.t(d);if(l)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),l;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async s(d){try{let l=this.l.get(this.b+d,-1),w;if(l||(l=await this.j.getPassword(this.a,d)??void 0,l&&(w=await this.k.decrypt(l),l=await this.k.encrypt(w),this.l.store(this.b+d,l,-1,1),await this.j.deletePassword(this.a,d))),l){const S=JSON.parse(w??await this.k.decrypt(l));return{storedUsername:S.username,storedPassword:S.password}}}catch(l){this.h.error(l)}return{storedUsername:void 0,storedPassword:void 0}}async t(d){this.h.trace("auth#doResolveProxyCredentials - enter",d);const l=String((0,M.$di)({scheme:d.scheme,host:d.host,port:d.port})),{storedUsername:w,storedPassword:S}=await this.s(l);if(this.f!==y.StoredCredentialsUsed&&typeof w=="string"&&typeof S=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.f=y.StoredCredentialsUsed,{username:w,password:S};const m=this.i.getFocusedWindow()||this.i.getLastActiveWindow();if(!m){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${m.id} to handle proxy login`);const t={authInfo:d,username:this.g?.username??w,password:this.g?.password??S,replyChannel:`vscode:proxyAuthResponse:${(0,E.$3e)()}`};m.sendWhenReady("vscode:openProxyAuthenticationDialog",O.CancellationToken.None,t),this.f=y.LoginDialogShown;const a=await new Promise(r=>{const i=async(n,o,b)=>{if(o===t.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${m.id}`),m.win?.webContents.off("ipc-message",i),b){const I={username:b.username,password:b.password};try{if(b.remember){const A=await this.k.encrypt(JSON.stringify(I));this.l.store(this.b+l,A,-1,1)}else this.l.remove(this.b+l,-1)}catch(A){this.h.error(A)}r({username:I.username,password:I.password})}else r(void 0)};m.win?.webContents.on("ipc-message",i)});return this.g=a,a}};e.$Q4b=v,e.$Q4b=v=ke([Q(0,$.$Ri),Q(1,u.$P4b),Q(2,f.$on),Q(3,h.$fT),Q(4,p.$N4b),Q(5,g.$0i)],v)}),define(te[290],ie([0,1,88,27,104,100,8,2,4,18,5,22,240,241,96,127,17]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=e.$u6b=e.$t6b=void 0;async function d(t,a,r,i,n){let o;for(let b=3;b&&(o?.dispose(),o=await new l(t,a,r,i,n).waitForReady(),!(n&&s.$6e[n]||!s.$6e[o.tunnelLocalPort]));b--);return o}class l extends E.$lb{constructor(a,r,i,n,o){super(),this.j=r,this.k=o,this.privacy=v.TunnelPrivacyId.Private,this.i=new Map,this.a=a,this.b=k.createServer(),this.c=new D.$tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.l(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(r=>{r()})}async waitForReady(){const a=this.k??this.tunnelRemotePort,r=(0,v.$Sz)(this.j)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$7e)(a,2,1e3,r),n=null;return this.b.listen(i,this.j),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(a){a.pause();const r=(0,v.$Qz)(this.tunnelRemoteHost)||(0,v.$Sz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$Mk)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&a.write(o.buffer),a.on("end",()=>{a.localAddress&&this.i.delete(a.localAddress),n.end()}),a.on("close",()=>n.end()),a.on("error",()=>{a.localAddress&&this.i.delete(a.localAddress),n instanceof M.$eh?n.socket.destroy():n.end()}),n instanceof M.$eh?this.n(a,n):this.m(a,n),a.localAddress&&this.i.set(a.localAddress,()=>{a.end(),n.end()})}m(a,r){r.onClose(()=>a.destroy()),r.onEnd(()=>a.end()),r.onData(i=>a.write(i.buffer)),a.on("data",i=>r.write(c.$Ec.wrap(i))),a.resume()}n(a,r){const i=r.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.$t6b=l;let w=class extends v.$Vz{constructor(a,r,i,n,o){super(r,o),this.u=a,this.v=i,this.w=n}isPortPrivileged(a){return(0,v.$Tz)(a,this.l,f.OS,O.release())}s(a,r,i,n,o,b,I,A){const P=this.r(r,i);if(P)return++P.refcount,P.value;if((0,v.$Nz)(a))return this.t(a,r,i,o,b,I,A);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const C={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=d(C,n,r,i,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,j),j}}};e.$u6b=w,e.$u6b=w=ke([Q(0,u.$Gk),Q(1,$.$Ri),Q(2,y.$Jk),Q(3,g.$0i),Q(4,h.$Vh)],w);let S=class extends w{constructor(a,r,i,n,o){super(a,r,i,n,o)}};e.$v6b=S,e.$v6b=S=ke([Q(0,u.$Gk),Q(1,$.$Ri),Q(2,y.$Jk),Q(3,g.$0i),Q(4,h.$Vh)],S);let m=class extends E.$lb{constructor(a,r,i,n,o){super(),this.b=a,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(a,r,i,n,o,b,I,A,P){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${b}.`),!this.a.has(a)){const C=new S(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(a,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(r,i,n,o,b,I,A,P)}};e.$w6b=m,e.$w6b=m=ke([Q(0,u.$Gk),Q(1,$.$Ri),Q(2,g.$0i),Q(3,y.$Jk),Q(4,h.$Vh)],m)}),define(te[101],ie([0,1,8,23,3,18,28,20,5,22,51,48]),function(H,e,k,O,s,M,D,E,f,h,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T5b=e.$S5b=void 0;function p(y,v,c){return`${c.updateUrl}/api/update/${y}/${v}/${c.commit}`}e.$S5b=p;let u=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,c,d,l,w,S){this.f=v,this.g=c,this.h=d,this.i=l,this.j=w,this.k=S,this.b=g.$wT.Uninitialized,this.c=new s.$ec,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(g.$wT.Disabled(0));return}if(this.h.disableUpdates){this.d(g.$wT.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(g.$wT.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),c=this.m(v);if(!c){this.d(g.$wT.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(c),!this.a){this.d(g.$wT.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(g.$wT.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,d=>this.j.error(d))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,k.$vg)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},O.CancellationToken.None)).res.statusCode===204}catch(c){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(c);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};e.$T5b=u,e.$T5b=u=ke([Q(0,E.$D4b),Q(1,M.$Vh),Q(2,D.$B4b),Q(3,$.$Ao),Q(4,f.$Ri),Q(5,h.$0i)],u)}),define(te[291],ie([0,1,14,55,3,2,18,28,20,5,22,51,25,48,101]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=void 0;let v=class extends y.$T5b{get v(){return s.Event.fromNodeEventEmitter(k.autoUpdater,"error",(d,l)=>l)}get w(){return s.Event.fromNodeEventEmitter(k.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(k.autoUpdater,"update-available",(d,l,w)=>({url:l,version:w,productVersion:w}))}get y(){return s.Event.fromNodeEventEmitter(k.autoUpdater,"update-downloaded",(d,l,w,S)=>({releaseNotes:l,version:w,productVersion:w,date:S}))}constructor(d,l,w,S,m,t,a){super(d,l,S,m,t,a),this.z=w,this.u=new M.$kb,d.setRelaunchHandler(this)}handleRelaunch(d){return d?.addArgs||d?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(d){this.j.error("UpdateService error:",d);const l=this.state.type==="checking for updates"&&this.state.explicit?d:void 0;this.d(u.$wT.Idle(1,l))}s(d){let l;this.k.darwinUniversalAssetId?l=this.k.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const w=(0,y.$S5b)(l,d,this.k);try{k.autoUpdater.setFeedURL({url:w})}catch(S){this.j.error("Failed to set update feed URL",S);return}return w}t(d){this.d(u.$wT.CheckingForUpdates(d)),k.autoUpdater.checkForUpdates()}E(d){this.state.type==="checking for updates"&&this.d(u.$wT.Downloading(d))}F(d){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:d.version}),this.d(u.$wT.Ready(d)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(u.$wT.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),k.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$U5b=v,ke([O.$Tg],v.prototype,"v",null),ke([O.$Tg],v.prototype,"w",null),ke([O.$Tg],v.prototype,"x",null),ke([O.$Tg],v.prototype,"y",null),e.$U5b=v=ke([Q(0,f.$D4b),Q(1,D.$Vh),Q(2,p.$Vk),Q(3,E.$B4b),Q(4,g.$Ao),Q(5,h.$Ri),Q(6,$.$0i)],v)}),define(te[292],ie([0,1,47,45,8,3,9,28,20,5,25,48]),function(H,e,k,O,s,M,D,E,f,h,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=void 0;let p=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,c,d){if(this.f=v,this.g=d,this.a=g.$wT.Uninitialized,this.b=new M.$ec,this.onStateChange=this.b.event,c.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(g.$wT.Idle(this.k())),this.h(30*1e3).then(void 0,l=>this.g.error(l))}h(v=60*60*1e3){return(0,s.$vg)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};p=ke([Q(0,f.$D4b),Q(1,E.$B4b),Q(2,h.$Ri)],p);let u=class extends p{constructor(v,c,d,l,w,S){super(d,l,w),this.o=v,this.p=c,this.q=S;const m=(0,O.watch)(D.$$c(this.o)),t=M.Event.fromNodeEventEmitter(m,"change",(n,o)=>o),a=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(a,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));d.onWillShutdown(()=>{i.dispose(),m.close()})}m(){this.d(g.$wT.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(g.$wT.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(g.$wT.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(g.$wT.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,k.spawn)("sleep 3 && "+D.$_c(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((d,l)=>(0,O.realpath)(`${D.$$c(this.o)}/current`,(w,S)=>w?l(w):d(S))),c=D.$_c(v);return this.p!==c}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$W5b=u,e.$W5b=u=ke([Q(2,f.$D4b),Q(3,E.$B4b),Q(4,h.$Ri),Q(5,$.$Vk)],u)}),define(te[293],ie([0,1,2,20,53,30,8,29]),function(H,e,k,O,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=void 0;let f=class extends k.$lb{constructor($,g,p){super(),this.a=g,this.b=p,this.B($.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B($.onBeforeCloseWindow(u=>this.c(u))),this.B(new D.$Gg(()=>this.g(),30*1e3)).schedule()}async c($){const g=this.f($),p=this.a.getProfileForWorkspace(g);p?.isTransient&&(this.a.unsetWorkspace(g,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f($){return $.openedWorkspace??(0,M.$Dh)($.backupPath,$.isExtensionDevelopmentHost)}g(){const $=this.a.getAssociatedEmptyWindows();if($.length===0)return;const g=this.b.getWindows().map(p=>this.f(p));for(const p of $)g.some(u=>u.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$e6b=f,e.$e6b=f=ke([Q(0,O.$D4b),Q(1,s.$J4b),Q(2,E.$P4b)],f)}),define(te[62],ie([0,1,14,2,3,5,312,8,15,29,70,25,20,73,37,4,132]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$04b=e.$94b=void 0;function l(m){return typeof m.responseWindowId=="number"}let w=class extends O.$lb{static{d=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(d.b.values())}constructor(t,a,r){super(),this.n=t,this.p=a,this.r=r,this.c=String(++d.a),this.f=this.B(new s.$ec),this.onStdout=this.f.event,this.g=this.B(new s.$ec),this.onStderr=this.g.event,this.h=this.B(new s.$ec),this.onMessage=this.h.event,this.i=this.B(new s.$ec),this.onExit=this.i.event,this.j=this.B(new s.$ec),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(t,a){let r;switch(this.m?.correlationId?r=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${t}`,a){case $.default.Error:this.n.error(r);break;case $.default.Warning:this.n.warn(r);break;case $.default.Info:this.n.trace(r);break}}t(){return this.k?(this.s("Cannot start utility process because it is already running...",$.default.Error),!1):!0}start(t){const a=this.u(t);return a&&t.payload&&this.postMessage(t.payload),a}u(t){if(!this.t())return!1;this.m=t;const a=`${this.m.type}-${this.c}`,r=f.$1e.asFileUri("bootstrap-fork.js").fsPath,i=this.m.args??[],n=this.m.execArgv??[],o=this.m.allowLoadingUnsignedLibraries,b=this.m.forceAllocationsToV8Sandbox,I="pipe",A=this.v(t);return this.s("creating new...",$.default.Info),this.k=k.utilityProcess.fork(r,i,{serviceName:a,env:A,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:b,stdio:I}),this.w(this.k,this.m,a),!0}v(t){const a=t.env?{...t.env}:{...(0,y.$Im)(process.env)};a.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(a.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),a.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.$i&&((0,c.isUNCAccessRestrictionsDisabled)()?a.NODE_DISABLE_UNC_ACCESS_CHECKS="1":a.NODE_UNC_HOST_ALLOWLIST=(0,c.getUNCHostAllowlist)().join("\\")),(0,u.$gl)(a);for(const r of Object.keys(a))a[r]=String(a[r]);return a}w(t,a,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.l=t.pid,typeof t.pid=="number"&&d.b.set(t.pid,{pid:t.pid,name:l(a)?`${a.type} [${a.responseWindowId}]`:a.type}),this.s("successfully created",$.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.s(`received exit event with code ${i}`,$.default.Info),this.i.fire({pid:this.l,code:i,signal:"unknown"}),this.y()})),this.B(s.Event.fromNodeEventEmitter(k.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.s(`crashed with code ${i.exitCode} and reason '${i.reason}'`,$.default.Error),this.p.publicLog2("utilityprocesscrash",{type:a.type,reason:i.reason,code:i.exitCode}),this.j.fire({pid:this.l,code:i.exitCode,reason:i.reason}),this.y())}))}once(t,a){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),a())}))}postMessage(t,a){this.k&&this.k.postMessage(t,a)}connect(t){const{port1:a,port2:r}=new k.MessageChannelMain;return this.postMessage(t,[r]),a}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",$.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",$.default.Info),this.k.kill()?(this.s("successfully killed the process",$.default.Info),this.y()):this.s("unable to kill the process",$.default.Warning)}y(){typeof this.l=="number"&&d.b.delete(this.l),this.k=void 0}async waitForExit(t){this.k&&(this.s("waiting to exit...",$.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,E.$vg)(t)]),this.k&&(this.s(`did not exit within ${t}ms, will kill it now...`,$.default.Info),this.kill()))}};e.$94b=w,e.$94b=w=d=ke([Q(0,M.$Ri),Q(1,g.$Vk),Q(2,p.$D4b)],w);let S=class extends w{constructor(t,a,r,i){super(t,r,i),this.z=a}start(t){const a=this.z.getWindowById(t.responseWindowId);if(!a?.win||a.win.isDestroyed()||a.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",$.default.Error),!0;if(!super.u(t))return!1;this.C(a.win,t);const i=this.connect(t.payload);return a.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}C(t,a){a.windowLifecycleBound&&(this.B(s.Event.filter(this.r.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$04b=S,e.$04b=S=ke([Q(0,M.$Ri),Q(1,h.$P4b),Q(2,g.$Vk),Q(3,p.$D4b)],S)}),define(te[294],ie([0,1,13,5,20,8,62,29,25]),function(H,e,k,O,s,M,D,E,f){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$f5b=void 0;let $=class{static{h=this}static{this.a=0}constructor(p,u,y,v){this.d=p,this.f=u,this.g=y,this.h=v,this.b=new Map,this.c=!1,this.f.onWillShutdown(c=>{this.c=!0,c.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(p){const u=this.b.get(p);if(!u)throw new Error("Unknown extension host!");return u}onDynamicStdout(p){return this.i(p).onStdout}onDynamicStderr(p){return this.i(p).onStderr}onDynamicMessage(p){return this.i(p).onMessage}onDynamicExit(p){return this.i(p).onExit}async createExtensionHost(){if(this.c)throw(0,k.$4)();const p=String(++h.a),u=new D.$04b(this.d,this.g,this.h,this.f);return this.b.set(p,u),u.onExit(({pid:y,code:v,signal:c})=>{this.d.info(`Extension host with pid ${y} exited with code: ${v}, signal: ${c}.`),setTimeout(()=>{u.dispose(),this.b.delete(p)})}),{id:p}}async start(p,u){if(this.c)throw(0,k.$4)();this.i(p).start({...u,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:u.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:p})}async enableInspectPort(p){if(this.c)throw(0,k.$4)();const u=this.b.get(p);return u?u.enableInspectPort():!1}async kill(p){if(this.c)throw(0,k.$4)();const u=this.b.get(p);u&&u.kill()}async _killAllNow(){for(const[,p]of this.b)p.kill()}async _waitForAllExit(p){const u=[];for(const[,y]of this.b)u.push(y.waitForExit(p));return M.Promises.settled(u).then(()=>{})}};e.$f5b=$,e.$f5b=$=h=ke([Q(0,O.$Ri),Q(1,s.$D4b),Q(2,E.$P4b),Q(3,f.$Vk)],$)}),define(te[295],ie([0,1,38,8,2,28,20,5,41,39,66,62,52,90,12,246,22]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M5b=void 0;let d=class extends s.$lb{constructor(w,S,m,t,a,r,i,n){super(),this.c=w,this.f=S,this.g=m,this.h=t,this.i=a,this.j=r,this.k=i,this.l=n,this.a=new O.$tg,this.b=void 0,this.s=void 0,this.t=void 0,this.m()}m(){k.$wS.on(v.$K5b.request,(w,S)=>this.n(w,S,v.$K5b.response)),k.$wS.on(v.$L5b.request,(w,S)=>this.n(w,S,v.$L5b.response)),this.B(this.h.onWillShutdown(()=>this.r()))}async n(w,S,m){this.i.trace(`[SharedProcess] onWindowConnection for: ${m}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(m);if(w.sender.isDestroyed())return t.close();w.sender.postMessage(m,S,[t])}r(){this.i.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(v.$J5b.exit),this.b=void 0}whenReady(){return this.s||(this.s=(async()=>{await this.u;const w=new O.$Pg;this.b?this.b.once(v.$J5b.initDone,()=>w.complete()):k.$wS.once(v.$J5b.initDone,()=>w.complete()),await w.p,this.i.trace("[SharedProcess] Overall ready")})()),this.s}get u(){return this.t||(this.t=(async()=>{await this.a.wait(),this.v();const w=new O.$Pg;this.b?this.b.once(v.$J5b.ipcReady,()=>w.complete()):k.$wS.once(v.$J5b.ipcReady,()=>w.complete()),await w.p,this.i.trace("[SharedProcess] IPC ready")})()),this.t}v(){this.b=this.B(new g.$94b(this.i,p.$6n,this.h));const w=(0,u.$1l)(this.f.args,this.f.isBuilt);let S;w.port&&(S=["--nolazy"],w.break?S.push(`--inspect-brk=${w.port}`):S.push(`--inspect=${w.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.w(),execArgv:S,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.l.quality!=="stable"})}w(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.j.getLogLevel(),loggers:this.j.getRegisteredLoggers(),policiesData:this.k.serialize()}}async connect(w){return await this.u,(0,y.$te)(this.b).connect(w)}};e.$M5b=d,e.$M5b=d=ke([Q(1,M.$B4b),Q(2,f.$rk),Q(3,D.$D4b),Q(4,E.$Ri),Q(5,$.$H5b),Q(6,h.$Wm),Q(7,c.$0i)],d)}),define(te[296],ie([0,1,28,90,20,5,52,62,111,38,2,3,37,18]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=void 0;let y=class extends $.$lb{constructor(c,d,l,w,S){super(),this.f=c,this.g=d,this.h=l,this.i=w,this.j=S,this.a=void 0,this.b=new g.$ec,this.onRequestConnection=this.b.event,this.c=new g.$ec,this.onWillShutdown=this.c.event,this.i.onWillShutdown(()=>this.c.fire()),h.$wS.on("vscode:createPtyHostMessageChannel",(m,t)=>this.l(m,t)),this.B((0,$.$jb)(()=>{h.$wS.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$94b(this.j,D.$6n,this.i);const c=(0,O.$Zl)(this.h.args,this.h.isBuilt),d=c.port?["--nolazy",`--inspect${c.break?"-brk":""}=${c.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this.h.logsHome.fsPath],env:this.k()});const l=this.a.connect(),w=new f.$ES(l,"ptyHost"),S=new $.$kb;return S.add(w),S.add((0,$.$jb)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:w,store:S,onDidProcessExit:this.a.onExit}}k(){this.h.unsetSnapExportedVariables();const c={...(0,p.$Im)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},d=this.g.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&(c.VSCODE_LATENCY=String(d));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&(c.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),c}l(c,d){this.b.fire();const l=this.a.connect();if(c.sender.isDestroyed()){l.close();return}c.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[l])}};e.$m6b=y,e.$m6b=y=ke([Q(1,u.$Vh),Q(2,k.$B4b),Q(3,s.$D4b),Q(4,M.$Ri)],y)}),define(te[297],ie([0,1,2,6,5,29,62,25,57,3,8,20]),function(H,e,k,O,s,M,D,E,f,h,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=e.$k6b=void 0,e.$k6b=(0,O.$ph)("utilityProcessWorker");let p=class extends k.$lb{constructor(v,c,d,l){super(),this.b=v,this.c=c,this.f=d,this.g=l,this.a=new Map}async createWorker(v){const c=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${c})`);const d=this.h(v);this.a.has(d)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${c})`),this.disposeWorker(v));const l=new u(this.b,this.c,this.f,this.g,v);if(!l.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(d,l);const w=new $.$Pg;return h.Event.once(l.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(d),w.complete({reason:S})}),w.p}h(v){return(0,f.$di)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const c=this.h(v),d=this.a.get(c);d&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),d.kill(),this.a.delete(c))}};e.$l6b=p,e.$l6b=p=ke([Q(0,s.$Ri),Q(1,M.$P4b),Q(2,E.$Vk),Q(3,g.$D4b)],p);let u=class extends k.$lb{constructor(v,c,d,l,w){super(),this.c=v,this.f=c,this.g=d,this.h=l,this.i=w,this.a=this.B(new h.$ec),this.onDidTerminate=this.a.event,this.b=new D.$04b(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const c=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:c,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};u=ke([Q(0,s.$Ri),Q(1,M.$P4b),Q(2,E.$Vk),Q(3,g.$D4b)],u)}),define(te[298],ie([0,1,14,2,4,19,7,18,20,5,34,29,129,30]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=e.$85b=e.$75b=void 0;let v=class extends O.$lb{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(m,t,a,r,i){super(),this.g=m,this.h=t,this.i=a,this.j=r,this.k=i,this.b=c(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.l()}l(){k.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(m=>this.p(m)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(m=>{m.newCount-m.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(m=>this.p(m))}m(){this.f=!0,this.n()}n(){const m=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.r(i),t.lastActiveWindow.uiState.mode===3&&m.add(t.lastActiveWindow.uiState.display))}const a=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);a&&(t.lastPluginDevelopmentHostWindow=this.r(a),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(m.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!a.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):m.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.r(i);return n.uiState.mode===3&&(m.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):m.add(n.uiState.display)),n}));const r=l(t);this.h.setItem(y.a,r),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",r)}p(m){if(this.i.quitRequested)return;const t=this.r(m);m.isExtensionDevelopmentHost&&!m.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!m.isExtensionDevelopmentHost&&m.openedWorkspace&&this.b.openedWindows.forEach(a=>{const r=(0,u.$Eh)(m.openedWorkspace)&&a.workspace?.id===m.openedWorkspace.id,i=(0,u.$zh)(m.openedWorkspace)&&a.folderUri&&M.$Zf.isEqual(a.folderUri,m.openedWorkspace.uri);(r||i)&&(a.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}r(m){return{windowId:m.id,workspace:(0,u.$Eh)(m.openedWorkspace)?m.openedWorkspace:void 0,folderUri:(0,u.$zh)(m.openedWorkspace)?m.openedWorkspace.uri:void 0,backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.serializeWindowState()}}getNewWindowState(m){const t=this.s(m),a=this.k.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):r=!!(this.i.wasRestarted||a?.restoreFullscreen),r||(t.mode=1)}return t}s(m){const t=this.g.getLastActiveWindow();if(!m.extensionTestsPath){if(m.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=m.workspace;if((0,u.$Eh)(b)){const A=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===b.id).map(P=>P.uiState);if(A.length)return A[0]}if((0,u.$zh)(b)){const A=this.state.openedWindows.filter(P=>P.folderUri&&M.$Zf.isEqual(P.folderUri,b.uri)).map(P=>P.uiState);if(A.length)return A[0]}else if(m.backupPath){const A=this.state.openedWindows.filter(P=>P.backupPath===m.backupPath).map(P=>P.uiState);if(A.length)return A[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let a;const r=k.screen.getAllDisplays();if(r.length===1)a=r[0];else{if(s.$j){const b=k.screen.getCursorScreenPoint();a=k.screen.getDisplayNearestPoint(b)}!a&&t&&(a=k.screen.getDisplayMatching(t.getBounds())),a||(a=k.screen.getPrimaryDisplay()||r[0])}let i=(0,p.$A4b)();i.x=Math.round(a.bounds.x+a.bounds.width/2-i.width/2),i.y=Math.round(a.bounds.y+a.bounds.height/2-i.height/2);const n=this.k.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i=b,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.t(i)),i.hasDefaultState=!0,i}t(m){if(this.g.getWindows().length===0)return m;m.x=typeof m.x=="number"?m.x:0,m.y=typeof m.y=="number"?m.y:0;const t=this.g.getWindows().map(a=>a.getBounds());for(;t.some(a=>a.x===m.x||a.y===m.y);)m.x+=30,m.y+=30;return m}};e.$75b=v,e.$75b=v=y=ke([Q(0,g.$P4b),Q(1,$.$1M),Q(2,f.$D4b),Q(3,h.$Ri),Q(4,E.$Vh)],v);function c(S){const m={openedWindows:[]},t=S||{openedWindows:[]};return t.lastActiveWindow&&(m.lastActiveWindow=d(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(m.lastPluginDevelopmentHostWindow=d(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(m.openedWindows=t.openedWindows.map(a=>d(a))),m}e.$85b=c;function d(S){const m={uiState:S.uiState};return S.backupPath&&(m.backupPath=S.backupPath),S.remoteAuthority&&(m.remoteAuthority=S.remoteAuthority),S.folder&&(m.folderUri=D.URI.parse(S.folder)),S.workspaceIdentifier&&(m.workspace={id:S.workspaceIdentifier.id,configPath:D.URI.parse(S.workspaceIdentifier.configURIPath)}),m}function l(S){return{lastActiveWindow:S.lastActiveWindow&&w(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&w(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(m=>w(m))}}e.$95b=l;function w(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(te[54],ie([0,1,14,3,44,2,15,9,19,21,192,64,61,28,6,5,53,131,30,98,99]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$84b=e.$74b=void 0,e.$74b=(0,y.$ph)("workspacesManagementMainService");let m=class extends M.$lb{constructor(a,r,i,n,o){super(),this.g=a,this.h=r,this.i=i,this.j=n,this.k=o,this.a=this.B(new O.$ec),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new O.$ec),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const a=(await h.Promises.readdir(this.c.fsPath)).map(r=>(0,f.$9f)(this.c,r,l.$Oh));for(const r of a){const i=(0,S.$W4b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(a){a.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${a}).`)}}resolveLocalWorkspace(a){return this.l(a,r=>h.Promises.readFile(r,"utf8"))}l(a,r){if(this.m(a)&&a.scheme===D.Schemas.file)try{const i=r(a.fsPath);return i instanceof Promise?i.then(n=>this.n(a,n),n=>{}):this.n(a,i)}catch{return}}m(a){return(0,l.$Ph)(a,this.g)||(0,l.$Uh)(a)}n(a,r){try{const i=this.p(a,r),n=(0,S.$W4b)(a);return{id:n.id,configPath:n.configPath,folders:(0,w.$1T)(i.folders,n.configPath,f.$Zf),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}p(a,r){const i=(0,s.$ym)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,w.$YT)(n));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(a,r){const{workspace:i,storedWorkspace:n}=this.r(a,r),o=i.configPath.fsPath;return await h.Promises.mkdir((0,E.$$c)(o),{recursive:!0}),await h.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}r(a=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$9f)(this.c,i),o=(0,f.$9f)(n,l.$Oh),b=[];for(const I of a)b.push((0,w.$ZT)(I.uri,!0,I.name,n,f.$Zf));return{workspace:(0,S.$W4b)(o),storedWorkspace:{folders:b,remoteAuthority:r}}}async getWorkspaceIdentifier(a){return(0,S.$W4b)(a)}isUntitledWorkspace(a){return(0,l.$Ph)(a.configPath,this.g)}async deleteUntitledWorkspace(a){this.isUntitledWorkspace(a)&&(await this.s(a),this.i.isEnabled()&&this.i.unsetWorkspace(a),this.a.fire(a))}async s(a){const r=(0,f.$Wf)(a.configPath);try{await h.Promises.rm((0,E.$$c)(r));const i=(0,E.$8c)(this.g.workspaceStorageHome.fsPath,a.id);await h.Promises.exists(i)&&await h.Promises.writeFile((0,E.$8c)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==a.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(a,r,i){if(!a||!a.win||!a.isReady||!await this.t(a,r,i))return;const o=await this.u(a,(0,S.$W4b)(i));if(o)return this.b.fire({window:a,workspace:o.workspace}),o}async t(a,r,i){return i?(0,l.$Eh)(a.openedWorkspace)&&f.$Zf.isEqual(a.openedWorkspace.configPath,i)?!1:(0,d.$54b)(r,i)?(await this.k.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:(0,$.localize)(1,null,(0,f.$6f)(i)),detail:(0,$.localize)(2,null)},k.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async u(a,r){if(!a.config)return;a.focus();let i;return a.config.extensionDevelopmentPath||(a.config.backupPath?i=await this.j.registerWorkspaceBackup({workspace:r,remoteAuthority:a.remoteAuthority},a.config.backupPath):i=this.j.registerWorkspaceBackup({workspace:r,remoteAuthority:a.remoteAuthority})),(0,l.$Eh)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&await this.deleteUntitledWorkspace(a.openedWorkspace),a.config.workspace=r,a.config.backupPath=i,{workspace:r,backupPath:i}}};e.$84b=m,e.$84b=m=ke([Q(0,u.$B4b),Q(1,v.$Ri),Q(2,c.$J4b),Q(3,g.$U4b),Q(4,p.$24b)],m)}),define(te[133],ie([0,1,14,38,23,6,29,30,54,12,5,62]),function(H,e,k,O,s,M,D,E,f,h,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a5b=e.$_4b=e.ID=void 0,e.ID="diagnosticsMainService",e.$_4b=(0,M.$ph)(e.ID);let p=class{constructor(y,v,c){this.a=y,this.b=v,this.c=c}async getRemoteDiagnostics(y){const v=this.a.getWindows();return(await Promise.all(v.map(async d=>{const l=d.remoteAuthority;if(!l)return;const w=`vscode:getDiagnosticInfoResponse${d.id}`,S={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(d):void 0};return new Promise(m=>{d.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:w,args:S}),O.$wS.once(w,(t,a)=>{a||m({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),m(a)}),setTimeout(()=>{m({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(d=>!!d)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const c of k.BrowserWindow.getAllWindows()){const d=this.a.getWindowById(c.id);d?y.push(await this.d(d)):y.push(this.e(c))}const v=[];for(const{pid:c,name:d}of g.$94b.getAll())v.push({pid:c,name:d});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:v,screenReader:!!k.app.accessibilitySupportEnabled,gpuFeatureStatus:k.app.getGPUFeatureStatus()}}async d(y){const v=await this.f(y),c=(0,h.$te)(y.win);return this.e(c,v,y.remoteAuthority)}e(y,v=[],c){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:v,remoteAuthority:c}}async f(y){const v=[],c=y.openedWorkspace;if((0,E.$zh)(c))v.push(c.uri);else if((0,E.$Eh)(c)){const d=await this.b.resolveLocalWorkspace(c.configPath);d&&d.folders.forEach(w=>{v.push(w.uri)})}return v}};e.$a5b=p,e.$a5b=p=ke([Q(0,D.$P4b),Q(1,f.$74b),Q(2,$.$Ri)],p)}),define(te[67],ie([0,1,47,14,27,155,55,3,2,15,9,4,7,106,87,21,104,180,61,28,6,20,5,22,80,29,30,54,17,242,234]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m,t,a,r,i,n,o,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q5b=e.$p5b=void 0,e.$p5b=(0,S.$ph)("nativeHostMainService");let P=class extends f.$lb{constructor(j,U,W,re,ne,fe,ae,ue){super(),this.a=j,this.b=U,this.c=W,this.f=re,this.g=ne,this.h=fe,this.i=ae,this.j=ue,this.onDidOpenWindow=E.Event.map(this.a.onDidOpenWindow,V=>V.id),this.onDidTriggerSystemContextMenu=E.Event.filter(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:V,x:J,y:z})=>({windowId:V.id,x:J,y:z})),({windowId:V})=>!!this.a.getWindowById(V)),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(O.app,"browser-window-maximize",(V,J)=>J.id),V=>!!this.a.getWindowById(V)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(O.app,"browser-window-unmaximize",(V,J)=>J.id),V=>!!this.a.getWindowById(V)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(O.app,"browser-window-blur",(V,J)=>J.id),V=>!!this.a.getWindowById(V)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),V=>!!V),V=>V.id),E.Event.filter(E.Event.fromNodeEventEmitter(O.app,"browser-window-focus",(V,J)=>J.id),V=>!!this.a.getWindowById(V))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(O.powerMonitor,"resume"),this.onDidChangeColorScheme=this.i.onDidChangeColorScheme,this.k=this.B(new E.$ec),this.onDidChangePassword=this.k.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(O.screen,"display-metrics-changed",(V,J,z)=>z),V=>!(Array.isArray(V)&&V.length===1&&V[0]==="workArea")),E.Event.fromNodeEventEmitter(O.screen,"display-added"),E.Event.fromNodeEventEmitter(O.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,n.$Dh)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(j){return this.a.getWindowCount()}async getActiveWindowId(j){const U=O.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(j,U,W){return Array.isArray(U)?this.l(j,U,W):this.m(j,U)}async l(j,U,W=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:j,urisToOpen:U,cli:this.f.args,forceNewWindow:W.forceNewWindow,forceReuseWindow:W.forceReuseWindow,preferNewWindow:W.preferNewWindow,diffMode:W.diffMode,mergeMode:W.mergeMode,addMode:W.addMode,gotoLineMode:W.gotoLineMode,noRecentEntry:W.noRecentEntry,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:W.remoteAuthority||void 0,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile})}async m(j,U){await this.a.openEmptyWindow({context:5,contextWindowId:j},U)}async toggleFullScreen(j){this.t(j)?.toggleFullScreen()}async handleTitleDoubleClick(j){this.t(j)?.handleTitleDoubleClick()}async isMaximized(j){const U=this.t(j);return U?.win?U.win.isMaximized():!1}async maximizeWindow(j){const U=this.t(j);U?.win&&U.win.maximize()}async unmaximizeWindow(j){const U=this.t(j);U?.win&&U.win.unmaximize()}async minimizeWindow(j){const U=this.t(j);U?.win&&U.win.minimize()}async updateWindowControls(j,U){const W=this.t(j);W&&W.updateWindowControls(U)}async focusWindow(j,U){U&&typeof U.windowId=="number"&&(j=U.windowId),this.t(j)?.focus({force:U?.force??!1})}async setMinimumSize(j,U,W){const re=this.t(j);if(re?.win){const[ne,fe]=re.win.getSize(),[ae,ue]=re.win.getMinimumSize(),[V,J]=[U??ae,W??ue],[z,T]=[Math.max(ne,V),Math.max(fe,J)];(ae!==V||ue!==J)&&re.win.setMinimumSize(V,J),(ne!==z||fe!==T)&&re.win.setSize(z,T)}}async saveWindowSplash(j,U){this.i.saveWindowSplash(j,U)}async installShellCommand(j){const{source:U,target:W}=await this.n();try{const{symbolicLink:re}=await v.SymlinkSupport.stat(U);if(re&&!re.dangling){const ne=await(0,u.$Np)(U);if(W===ne)return}await v.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await v.Promises.symlink(W,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ne}=await this.showMessageBox(j,{type:"info",message:(0,d.localize)(0,null,this.h.nameShort),buttons:[(0,d.localize)(1,null),(0,d.localize)(2,null)]});if(ne===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${W}' '${U}'\\" with administrator privileges"`;await(0,M.promisify)(k.exec)(fe)}catch{throw new Error((0,d.localize)(3,null,U))}}}async uninstallShellCommand(j){const{source:U}=await this.n();try{await v.Promises.unlink(U)}catch(W){switch(W.code){case"EACCES":{const{response:re}=await this.showMessageBox(j,{type:"info",message:(0,d.localize)(4,null,this.h.nameShort),buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]});if(re===0)try{const ne=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,M.promisify)(k.exec)(ne)}catch{throw new Error((0,d.localize)(7,null,U))}break}case"ENOENT":break;default:throw W}}}async n(){const j=(0,$.$9c)(this.f.appRoot,"bin","code"),U=`/usr/local/bin/${this.h.applicationName}`;if(!await v.Promises.exists(j))throw new Error((0,d.localize)(8,null,j));return{source:U,target:j}}async showMessageBox(j,U){return this.b.showMessageBox(U,this.p(j))}async showSaveDialog(j,U){return this.b.showSaveDialog(U,this.p(j))}async showOpenDialog(j,U){return this.b.showOpenDialog(U,this.p(j))}p(j){const U=this.t(j);if(U?.win)return U.win}async pickFileFolderAndOpen(j,U){const W=await this.b.pickFileFolder(U);W&&await this.r(await Promise.all(W.map(async re=>await v.SymlinkSupport.existsDirectory(re)?{folderUri:p.URI.file(re)}:{fileUri:p.URI.file(re)})),U,j)}async pickFolderAndOpen(j,U){const W=await this.b.pickFolder(U);W&&await this.r(W.map(re=>({folderUri:p.URI.file(re)})),U,j)}async pickFileAndOpen(j,U){const W=await this.b.pickFile(U);W&&await this.r(W.map(re=>({fileUri:p.URI.file(re)})),U,j)}async pickWorkspaceAndOpen(j,U){const W=await this.b.pickWorkspace(U);W&&await this.r(W.map(re=>({workspaceUri:p.URI.file(re)})),U,j)}async r(j,U,W){await this.a.open({context:3,contextWindowId:W,cli:this.f.args,urisToOpen:j,forceNewWindow:U.forceNewWindow})}async showItemInFolder(j,U){O.shell.showItemInFolder(U)}async setRepresentedFilename(j,U){this.t(j)?.setRepresentedFilename(U)}async setDocumentEdited(j,U){this.t(j)?.setDocumentEdited(U)}async openExternal(j,U){return this.f.unsetSnapExportedVariables(),O.shell.openExternal(U),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(j,U){return O.shell.trashItem(U)}async isAdmin(){let j;return g.$i?j=(await new Promise((U,W)=>{H(["native-is-elevated"],U,W)}))():j=process.getuid?.()===0,j}async writeElevated(j,U,W,re){const ne=await new Promise((fe,ae)=>{H(["@vscode/sudo-prompt"],fe,ae)});return new Promise((fe,ae)=>{const ue=[`"${this.s}"`];re?.unlock&&ue.push("--file-chmod"),ue.push("--file-write",`"${U.fsPath}"`,`"${W.fsPath}"`);const V={name:this.h.nameLong.replace("-",""),icns:g.$j&&this.f.isBuilt?(0,$.$8c)((0,$.$$c)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ne.exec(ue.join(" "),V,(J,z,T)=>{z&&this.g.trace(`[sudo-prompt] received stdout: ${z}`),T&&this.g.trace(`[sudo-prompt] received stderr: ${T}`),J?ae(J):fe(void 0)})})}async isRunningUnderARM64Translation(){return g.$k||g.$i?!1:O.app.runningUnderARM64Translation}get s(){return g.$i?this.f.isBuilt?(0,$.$8c)((0,$.$$c)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,$.$8c)(this.f.appRoot,"scripts","code-cli.bat"):g.$k?this.f.isBuilt?(0,$.$8c)((0,$.$$c)(process.execPath),"bin",`${this.h.applicationName}`):(0,$.$8c)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,$.$8c)(this.f.appRoot,"bin","code"):(0,$.$8c)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$um.value()}async getOSColorScheme(){return this.i.getColorScheme()}async hasWSLFeatureInstalled(){return g.$i&&(0,I.$n5b)()}async killProcess(j,U,W){process.kill(U,W)}async readClipboardText(j,U){return O.clipboard.readText(U)}async writeClipboardText(j,U,W){return O.clipboard.writeText(U,W)}async readClipboardFindText(j){return O.clipboard.readFindText()}async writeClipboardFindText(j,U){return O.clipboard.writeFindText(U)}async writeClipboardBuffer(j,U,W,re){return O.clipboard.writeBuffer(U,Buffer.from(W.buffer),re)}async readClipboardBuffer(j,U){return b.$Ec.wrap(O.clipboard.readBuffer(U))}async hasClipboard(j,U,W){return O.clipboard.has(U,W)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){O.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){O.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){O.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){O.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){O.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(j,U){this.t(j)?.updateTouchBar(U)}async notifyReady(j){this.t(j)?.setReady()}async relaunch(j,U){return this.c.relaunch(U)}async reload(j,U){const W=this.t(j);if(W){if((0,n.$Eh)(W.openedWorkspace)){const re=W.openedWorkspace.configPath;if(re.scheme===h.Schemas.file&&(await this.j.resolveLocalWorkspace(re))?.transient)return this.openWindow(W.id,{forceReuseWindow:!0})}return this.c.reload(W,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(j){this.closeWindowById(j,j)}async closeWindowById(j,U){const W=this.t(U);if(W?.win)return W.win.close()}async quit(j){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.c.quit()}async exit(j,U){await this.c.kill(U)}async resolveProxy(j,U){return this.t(j)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(j,U,W,re,ne=1){return(0,c.$5e)(U,W,re,ne)}async openDevTools(j,U){const W=this.t(j);W?.win&&W.win.webContents.openDevTools(U)}async toggleDevTools(j){const U=this.t(j);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(j,U){const W=this.t(j);W?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&W.win.webContents.sendInputEvent(U)}async profileRenderer(j,U,W){const re=this.t(j);if(!re||!re.win)throw new Error;return await new A.$o5b(re.win,U,this.g).inspect(W)}async windowsGetStringRegKey(j,U,W,re){if(!g.$i)return;const ne=await new Promise((fe,ae)=>{H(["@vscode/windows-registry"],fe,ae)});try{return ne.GetStringRegKey(U,W,re)}catch{return}}t(j){if(typeof j=="number")return this.a.getWindowById(j)}};e.$q5b=P,ke([D.$Tg],P.prototype,"s",null),e.$q5b=P=ke([Q(0,i.$P4b),Q(1,l.$24b),Q(2,m.$D4b),Q(3,w.$B4b),Q(4,t.$Ri),Q(5,a.$0i),Q(6,r.$l5b),Q(7,o.$74b)],P)}),define(te[299],ie([0,1,14,38,27,2,15,4,108,178,91,133,61,28,5,67,78,22,79,81,32,34,62,23,7,29,8]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m,t,a,r,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$s5b=void 0;const b="issue.processExplorerWindowState";let I=class{static{o=this}static{this.a="#1E1E1E"}constructor(C,j,U,W,re,ne,fe,ae,ue,V,J){this.g=C,this.h=j,this.i=U,this.j=W,this.k=re,this.l=ne,this.m=fe,this.n=ae,this.o=ue,this.p=V,this.q=J,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){O.$wS.on("vscode:listProcesses",async C=>{const j=[];try{j.push({name:(0,h.localize)(0,null),rootProcess:await(0,f.$jr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,$.$7l)(W)?j.push({name:W.hostName,rootProcess:W}):W.processes&&j.push({name:W.hostName,rootProcess:W.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(C,"vscode:listProcessesResponse",j)}),O.$wS.on("vscode:workbenchCommand",(C,j)=>{const{id:U,from:W,args:re}=j;let ne;switch(W){case"processExplorer":ne=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}ne?.webContents.send("vscode:runAction",{id:U,from:W,args:re})}),O.$wS.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),O.$wS.on("vscode:pidToNameRequest",async C=>{const j=await this.k.getMainDiagnostics(),U=[];for(const W of j.windows)U.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:re}of t.$94b.getAll())U.push([W,re]);this.t(C,"vscode:pidToNameResponse",U)})}async openReporter(C){if(!this.b&&(this.c=k.BrowserWindow.getFocusedWindow(),this.c)){const j=new M.$kb,U=j.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,U,{backgroundColor:C.styles.backgroundColor,title:(0,h.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:c.default}),this.b.loadURL(D.$1e.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=k.BrowserWindow.getFocusedWindow(),this.f)){const j=new M.$kb,U=j.add(this.n.createIPCObjectUrl()),W=this.p.getItem(b,void 0),re=A(W)?W:this.v(this.f,800,500);this.d=this.u(re,U,{backgroundColor:C.styles.backgroundColor,title:(0,h.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:c.default}),this.d.loadURL(D.$1e.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const ne=()=>{if(!this.d)return;const fe=this.d.getSize(),ae=this.d.getPosition();if(!fe||!ae)return;const ue={width:fe[0],height:fe[1],x:ae[0],y:ae[1]};this.p.setItem(b,ue)};this.d.on("moved",ne),this.d.on("resized",ne)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await k.contentTracing.stopRecording(`${(0,S.$Pe)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null,C),buttons:[(0,h.localize)(5,null)]},k.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,j)}async $getSystemInfo(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,j)}async $getPerformanceInfo(){try{const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,j)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,h.localize)(6,null),buttons:[(0,h.localize)(7,null),(0,h.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,h.localize)(9,null),buttons:[(0,h.localize)(10,null),(0,h.localize)(11,null)]},this.b);return C===0}return!1}async $getIssueReporterUri(C){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return n.Promises.withAsyncBody(async(W,re)=>{const ne=new a.$oc;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",ne.token,{replyChannel:U,extensionId:C}),O.$wS.once(U,(fe,ae)=>{W(r.URI.parse(ae))});try{await(0,n.$vg)(5e3),ne.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{O.$wS.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,j,...U){C.sender.isDestroyed()||C.sender.send(j,...U)}u(C,j,U,W){const re=new k.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:U.title,backgroundColor:U.backgroundColor||o.a,webPreferences:{preload:D.$1e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,w.$LD)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}v(C,j,U){let W;const re=k.screen.getAllDisplays();if(re.length===1)W=re[0];else{if(E.$j){const ae=k.screen.getCursorScreenPoint();W=k.screen.getDisplayNearestPoint(ae)}!W&&C&&(W=k.screen.getDisplayMatching(C.getBounds())),W||(W=k.screen.getPrimaryDisplay()||re[0])}const ne=W.bounds,fe={width:j,height:U,x:ne.x+ne.width/2-j/2,y:ne.y+ne.height/2-U/2};return ne.width>0&&ne.height>0&&(fe.x<ne.x&&(fe.x=ne.x),fe.y<ne.y&&(fe.y=ne.y),fe.x>ne.x+ne.width&&(fe.x=ne.x),fe.y>ne.y+ne.height&&(fe.y=ne.y),fe.width>ne.width&&(fe.width=ne.width),fe.height>ne.height&&(fe.height=ne.height)),fe}};e.$s5b=I,e.$s5b=I=o=ke([Q(1,u.$B4b),Q(2,y.$Ri),Q(3,$.$6l),Q(4,g.$_4b),Q(5,p.$24b),Q(6,v.$p5b),Q(7,l.$r5b),Q(8,d.$0i),Q(9,m.$1M),Q(10,i.$P4b)],I);function A(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(te[300],ie([0,1,23,18,28,20,5,67,22,51,25,48,101]),function(H,e,k,O,s,M,D,E,f,h,$,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=void 0;let u=class extends p.$T5b{constructor(v,c,d,l,w,S,m,t){super(v,c,l,w,S,t),this.e=d,this.u=m}s(v){return(0,p.$S5b)(`linux-${process.arch}`,v,this.k)}t(v){this.a&&(this.d(g.$wT.CheckingForUpdates(v)),this.i.request({url:this.a},k.CancellationToken.None).then(h.$Fo).then(c=>{!c||!c.url||!c.version||!c.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(g.$wT.Idle(1))):this.d(g.$wT.AvailableForDownload(c))}).then(void 0,c=>{this.j.error(c),this.e.publicLog2("update:notAvailable",{explicit:!!v});const d=v?c.message||c:void 0;this.d(g.$wT.Idle(1,d))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(g.$wT.Idle(1))}};e.$V5b=u,e.$V5b=u=ke([Q(0,M.$D4b),Q(1,O.$Vh),Q(2,$.$Vk),Q(3,s.$B4b),Q(4,h.$Ao),Q(5,D.$Ri),Q(6,E.$p5b),Q(7,f.$0i)],u)}),define(te[301],ie([0,1,47,45,27,8,23,55,9,7,142,21,18,28,16,20,5,67,22,51,25,48,101]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X5b=void 0;async function a(o,b=1e3){for(;!o();)await(0,M.$vg)(b)}let r;function i(){return typeof r>"u"&&(r=O.existsSync(f.$8c(f.$$c(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$T5b{get cachePath(){const b=f.$8c((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return g.Promises.mkdir(b,{recursive:!0}).then(()=>b)}constructor(b,I,A,P,C,j,U,W,re){super(b,I,P,C,j,re),this.u=A,this.v=U,this.w=W,b.setRelaunchHandler(this)}handleRelaunch(b){return b?.addArgs||b?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(m.$wT.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(b){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,t.$S5b)(I,b,this.k)}t(b){this.a&&(this.d(m.$wT.CheckingForUpdates(b)),this.i.request({url:this.a},D.CancellationToken.None).then(w.$Fo).then(I=>{const A=i();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!b}),this.d(m.$wT.Idle(A)),Promise.resolve(null)):A===1?(this.d(m.$wT.AvailableForDownload(I)),Promise.resolve(null)):(this.d(m.$wT.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(P=>g.Promises.exists(P).then(C=>{if(C)return Promise.resolve(P);const j=I.url,U=I.hash,W=`${P}.tmp`;return this.i.request({url:j},D.CancellationToken.None).then(re=>this.v.writeFile(h.URI.file(W),re.stream)).then(U?()=>(0,$.$rS)(W,I.hash):()=>{}).then(()=>g.Promises.rename(W,P,!1)).then(()=>P)})).then(P=>{const C=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:P},C?this.k.target==="user"?this.p():this.d(m.$wT.Downloaded(I)):this.d(m.$wT.Ready(I))})))}).then(void 0,I=>{this.j.error(I),this.u.publicLog2("update:notAvailable",{explicit:!!b});const A=b?I.message||I:void 0;this.d(m.$wT.Idle(i(),A))}))}async o(b){b.update.url&&this.w.openExternal(void 0,b.update.url),this.d(m.$wT.Idle(i()))}async B(b){const I=await this.cachePath;return f.$8c(I,`CodeSetup-${this.k.quality}-${b}.exe`)}async C(b=null){const I=b?j=>!new RegExp(`${this.k.quality}-${b}\\.exe$`).test(j):()=>!0,A=await this.cachePath,C=(await g.Promises.readdir(A)).filter(I).map(async j=>{try{await g.Promises.unlink(f.$8c(A,j))}catch{}});await Promise.all(C)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const b=this.state.update;this.d(m.$wT.Updating(b));const I=await this.cachePath;this.e.updateFilePath=f.$8c(I,`CodeSetup-${this.k.quality}-${b.version}.flag`),await g.Promises.writeFile(this.e.updateFilePath,"flag"),(0,k.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(m.$wT.Idle(i()))});const P=`${this.k.win32MutexName}-ready`,C=await new Promise((j,U)=>{H(["@vscode/windows-mutex"],j,U)});a(()=>C.isActive(P)).then(()=>this.d(m.$wT.Ready(b)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?O.unlinkSync(this.e.updateFilePath):(0,k.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(b){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),A={version:"unknown",productVersion:"unknown"};this.d(m.$wT.Downloading(A)),this.e={packagePath:b},I?this.k.target==="user"?this.p():this.d(m.$wT.Downloaded(A)):this.d(m.$wT.Ready(A))}};e.$X5b=n,ke([E.$Tg],n.prototype,"cachePath",null),e.$X5b=n=ke([Q(0,v.$D4b),Q(1,p.$Vh),Q(2,S.$Vk),Q(3,u.$B4b),Q(4,w.$Ao),Q(5,c.$Ri),Q(6,y.$Sj),Q(7,d.$p5b),Q(8,l.$0i)],n)}),define(te[302],ie([0,1,14,8,23,50,3,2,15,9,65,4,7,188,64,18,61,28,63,16,20,5,22,79,251,83,25,103,80,81,29,30,54,129,134,39,34,53,66,24]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m,t,a,r,i,n,o,b,I,A,P,C,j,U,W,re,ne,fe,ae){"use strict";var ue;Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=void 0;var V;(function(z){z[z.NONE=0]="NONE",z[z.NAVIGATING=1]="NAVIGATING",z[z.READY=2]="READY"})(V||(V={}));let J=class extends E.$lb{static{ue=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.k}get lastFocusTime(){return this.l}get backupPath(){return this.m?.backupPath}get openedWorkspace(){return this.m?.workspace}get profile(){if(!this.config)return;const T=this.O.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&T?T:this.O.getProfileForWorkspace(this.config.workspace??(0,P.$Dh)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.m?.remoteAuthority}get config(){return this.m}get isExtensionDevelopmentHost(){return!!this.m?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.m?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.m?.debugId}constructor(T,F,B,x,oe,ce,G,R,L,N,q,se,Y,le,K,ee,X,de,me,Re){super(),this.J=F,this.L=B,this.M=x,this.N=oe,this.O=ce,this.P=G,this.Q=R,this.R=L,this.S=N,this.U=q,this.W=se,this.X=Y,this.Y=le,this.Z=K,this.$=ee,this.ab=X,this.bb=de,this.db=me,this.eb=Re,this.b=this.B(new D.$ec),this.onWillLoad=this.b.event,this.c=this.B(new D.$ec),this.onDidSignalReady=this.c.event,this.f=this.B(new D.$ec),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$ec),this.onDidClose=this.g.event,this.h=this.B(new D.$ec),this.onDidDestroy=this.h.event,this.l=-1,this.s=void 0,this.t=void 0,this.w=!1,this.z=[],this.C=[],this.D=void 0,this.F=void 0,this.G=this.B(this.bb.createIPCObjectUrl()),this.I=!1,this.fb=0;{const[De,je]=this.pb(T.state);this.n=De,this.J.trace("window#ctor: using window state",De);const ye=this.n.mode===0||this.n.mode===3,be=this.S.getValue("window"),Z={width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y,backgroundColor:this.U.getBackgroundColor(),minWidth:I.$ED.WIDTH,minHeight:I.$ED.HEIGHT,show:!ye,title:this.ab.nameLong,webPreferences:{preload:f.$1e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.G.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.$LD)(be?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};g.$k?Z.icon=(0,h.$8c)(this.M.appRoot,"resources/linux/code.png"):g.$i&&!this.M.isBuilt&&(Z.icon=(0,h.$8c)(this.M.appRoot,"resources/win32/code_150x150.png")),g.$j&&!this.wb()&&(Z.fullscreenable=!1),g.$j&&(Z.acceptFirstMouse=!0,be?.clickThroughInactive===!1&&(Z.acceptFirstMouse=!1));const he=g.$j&&be?.nativeTabs===!0;he&&(Z.tabbingIdentifier=this.ab.nameShort);const $e=(0,I.$JD)(this.S)==="custom";if($e&&(Z.titleBarStyle="hidden",g.$j||(Z.frame=!1),(0,I.$KD)(this.S))){const Ee=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Ce=U.$ds.fromHex(Ee).isDarker()?"#FFFFFF":"#000000";Z.titleBarOverlay={height:29,color:Ee,symbolColor:Ce},this.w=!0}if((0,$.mark)("code/willCreateCodeBrowserWindow"),this.k=new k.BrowserWindow(Z),(0,$.mark)("code/didCreateCodeBrowserWindow"),this.j=this.k.id,g.$j&&$e&&this.k.setSheetOffset(22),$e&&(g.$i&&(0,I.$KD)(this.S)||g.$j)){const Ee=this.eb.getItem(ue.a);Ee&&this.updateWindowControls({height:Ee})}g.$i&&$e&&this.k.hookWindowMessage(278,()=>{const[Ce,Fe]=this.k.getPosition(),Oe=k.screen.getCursorScreenPoint(),ze=Oe.x-Ce,We=Oe.y-Fe;return(()=>!(ze>30&&We>=0&&We<=Math.max(this.k.getBounds().height*.15,35)))()||(this.k.setEnabled(!1),this.k.setEnabled(!0),this.f.fire({x:ze,y:We})),0}),(g.$j||g.$i)&&je&&(!he||k.BrowserWindow.getAllWindows().length===1)&&[this.n.width,this.n.height,this.n.x,this.n.y].every(Ee=>typeof Ee=="number")&&this.k.setBounds({width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y}),ye&&((0,$.mark)("code/willMaximizeCodeWindow"),this.k.maximize(),this.n.mode===3&&this.sb(!0),this.k.show(),(0,$.mark)("code/didMaximizeCodeWindow")),this.l=Date.now()}this.M.args["open-devtools"]===!0&&this.k.webContents.openDevTools(),this.mb(),this.Ab(),this.gb()}setRepresentedFilename(T){g.$j?this.k.setRepresentedFilename(T):this.u=T}getRepresentedFilename(){return g.$j?this.k.getRepresentedFilename():this.u}setDocumentEdited(T){g.$j&&this.k.setDocumentEdited(T),this.v=T}isDocumentEdited(){return g.$j?this.k.isDocumentEdited():!!this.v}focus(T){g.$j&&T?.force&&k.app.focus({steal:!0}),this.k&&(this.k.isMinimized()&&this.k.restore(),this.k.focus())}setReady(){for(this.J.trace(`window#load: window reported ready (id: ${this.j})`),this.fb=2;this.z.length;)this.z.pop()(this);this.c.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.z.push(T)})}get isReady(){return this.fb===2}get whenClosedOrLoaded(){return new Promise(T=>{function F(){B.dispose(),x.dispose(),T()}const B=this.onDidClose(()=>F()),x=this.onWillLoad(()=>F())})}gb(){this.k.on("unresponsive",()=>this.jb(1)),this.k.webContents.on("render-process-gone",(F,B)=>this.jb(2,{...B})),this.k.webContents.on("did-fail-load",(F,B,x)=>this.jb(3,{reason:x,exitCode:B})),this.k.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this.k.on("closed",()=>{this.g.fire(),this.dispose()}),this.k.webContents.on("did-finish-load",()=>{this.H&&(this.m=this.H,this.H=void 0)}),this.k.on("focus",()=>{this.l=Date.now()}),this.k.on("maximize",F=>{this.m&&(this.m.maximized=!0),k.app.emit("browser-window-maximize",F,this.k)}),this.k.on("unmaximize",F=>{this.m&&(this.m.maximized=!1),k.app.emit("browser-window-unmaximize",F,this.k)}),this.k.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.k.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.B(this.S.onDidChangeConfiguration(F=>this.mb(F))),this.B(this.W.onDidDeleteUntitledWorkspace(F=>this.lb(F)));const T=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.k.webContents.session.webRequest.onBeforeSendHeaders({urls:T},async(F,B)=>{const x=await this.ib();B({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,x)})})}ib(){return this.hb||(this.hb=(0,r.$To)(this.ab.version,this.ab,this.M,this.S,this.P,this.Q,this.Y)),this.hb}async jb(T,F){switch(T){case 2:this.J.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.J.error("CodeWindow: detected unresponsive");break;case 3:this.J.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:T,reason:F?.reason,code:F?.exitCode}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.$.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.kb(!1,!1),this.$.quit();return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.k&&this.k.webContents&&this.k.webContents.isDevToolsOpened())return;const{response:B,checkboxChecked:x}=await this.Z.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null),(0,u.localize)(2,null)],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),checkboxLabel:this.m?.workspace?(0,u.localize)(5,null):void 0},this.k);if(B!==2){const oe=B===0;await this.kb(oe,x)}}else if(T===2){let B;F?B=(0,u.localize)(7,null,F.reason,F.exitCode??"<unknown>"):B=(0,u.localize)(6,null);const{response:x,checkboxChecked:oe}=await this.Z.showMessageBox({type:"warning",buttons:[this.m?.workspace?(0,u.localize)(8,null):(0,u.localize)(9,null),(0,u.localize)(10,null)],message:B,detail:this.m?.workspace?(0,u.localize)(11,null):(0,u.localize)(12,null),checkboxLabel:this.m?.workspace?(0,u.localize)(13,null):void 0},this.k),ce=x===0;await this.kb(ce,oe)}break}}async kb(T,F){const B=this.m?.workspace;if(F&&B)try{const x=this.R.workspaceStorage(B);await x.init(),x.delete("memento/workbench.parts.editor"),await x.close()}catch(x){this.J.error(x)}if(this.h.fire(),this.k?.destroy(),T&&this.m){let x,oe;(0,P.$zh)(B)?x={folderUri:B.uri}:(0,P.$Eh)(B)?x={workspaceUri:B.configPath}:oe=!0,(0,ae.$sf)(await this.db.open({context:5,userEnv:this.m.userEnv,cli:{...this.M.args,_:[]},urisToOpen:x?[x]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}lb(T){this.m?.workspace?.id===T.id&&(this.m.workspace=void 0)}mb(T){if(!T||T.affectsConfiguration("window.menuBarVisibility")){const F=this.xb();F!==this.r&&(this.r=F,this.yb(F))}if(!T||T.affectsConfiguration("http.proxy")){let F=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.D||B!==this.F)){this.D=F,this.F=B;const x=F||"",oe=B?`${B},<local>`:"<local>";this.J.trace(`Setting proxy to '${x}', bypassing '${oe}'`),this.k.webContents.session.setProxy({proxyRules:x,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(T){g.$j&&T.win&&this.k.addTabbedWindow(T.win)}load(T,F=Object.create(null)){this.J.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!F.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.k.setTitle(this.ab.nameLong)),this.nb(T,F),this.fb===0?this.m=T:this.H=T,this.fb=1,this.k.loadURL(f.$1e.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const B=this.I;this.I=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new O.$Gg(()=>{this.k&&!this.k.isVisible()&&!this.k.isMinimized()&&(this.k.show(),this.focus({force:!0}),this.k.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:T.workspace,reason:F.isReload?3:B?2:1})}nb(T,F){const B=(this.m??this.H)?.userEnv;if(B){const x=(0,l.$tl)(B)&&!(0,l.$tl)(T.userEnv),oe=this.isExtensionDevelopmentHost;(x||oe)&&(T.userEnv={...B,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(T["disable-extensions"]=F.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this.k.isMaximized(),T.partsSplash=this.U.getWindowSplash(),(0,$.mark)("code/willOpenNewWindow"),T.perfMarks=(0,$.getMarks)(),this.G.update(T)}async reload(T){const F=Object.assign({},this.m);F.workspace=await this.ob(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&T&&(F.verbose=T.verbose,F.debugId=T.debugId,F.extensionEnvironment=T.extensionEnvironment,F["inspect-extensions"]=T["inspect-extensions"],F["inspect-brk-extensions"]=T["inspect-brk-extensions"],F["extensions-dir"]=T["extensions-dir"]),F.accessibilitySupport=k.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.N.serialize(),F.continueOn=this.M.continueOn,F.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile,home:this.O.profilesHome},F.logLevel=this.L.getLogLevel(),F.loggers={window:this.L.getRegisteredLoggers(this.id),global:this.L.getRegisteredLoggers()},this.load(F,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async ob(T){if((0,P.$Eh)(T.workspace)){const F=T.workspace.configPath;if(F.scheme===f.Schemas.file&&!await this.P.exists(F))return}else if((0,P.$zh)(T.workspace)){const F=T.workspace.uri;if(F.scheme===f.Schemas.file&&!await this.P.exists(F))return}return T.workspace}serializeWindowState(){if(!this.k)return(0,j.$A4b)();if(this.isFullScreen){let B;try{B=k.screen.getDisplayMatching(this.getBounds())}catch{}const x=(0,j.$A4b)();return{mode:3,display:B?B.id:void 0,width:this.n.width||x.width,height:this.n.height||x.height,x:this.n.x||0,y:this.n.y||0}}const T=Object.create(null);let F;if(!g.$j&&this.k.isMaximized()?F=0:F=1,F===0?T.mode=0:T.mode=1,F===1||F===0){let B;F===1?B=this.getBounds():B=this.k.getNormalBounds(),T.x=B.x,T.y=B.y,T.width=B.width,T.height=B.height}return T}updateWindowControls(T){if(T.height&&this.eb.setItem(ue.a,T.height),g.$i&&this.w)this.k.setTitleBarOverlay({color:T.backgroundColor?.trim()===""?void 0:T.backgroundColor,symbolColor:T.foregroundColor?.trim()===""?void 0:T.foregroundColor,height:T.height?T.height-1:void 0});else if(g.$j&&T.height!==void 0){const F=(T.height-15)/2;F?this.k.setWindowButtonPosition({x:F,y:F}):this.k.setWindowButtonPosition(null)}}pb(T){(0,$.mark)("code/willRestoreCodeWindowState");let F=!1;if(T)try{const B=k.screen.getAllDisplays();F=B.length>1,T=this.qb(T,B)}catch(B){this.J.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,$.mark)("code/didRestoreCodeWindowState"),[T||(0,j.$A4b)(),F]}qb(T,F){if(this.J.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,T),typeof T.x!="number"||typeof T.y!="number"||typeof T.width!="number"||typeof T.height!="number"){this.J.trace("window#validateWindowState: unexpected type of state values");return}if(T.width<=0||T.height<=0){this.J.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const oe=this.rb(F[0]);if(oe){let ce=function(){!T||typeof T.x!="number"||typeof T.y!="number"||!oe||(T.x<oe.x&&(T.x=oe.x),T.y<oe.y&&(T.y=oe.y))};this.J.trace("window#validateWindowState: 1 monitor working area",oe),ce(),T.width>oe.width&&(T.width=oe.width),T.height>oe.height&&(T.height=oe.height),T.x>oe.x+oe.width-128&&(T.x=oe.x+oe.width-T.width),T.y>oe.y+oe.height-128&&(T.y=oe.y+oe.height-T.height),ce()}return T}if(T.display&&T.mode===3){const oe=F.find(ce=>ce.id===T.display);if(oe&&typeof oe.bounds?.x=="number"&&typeof oe.bounds?.y=="number"){this.J.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,j.$A4b)(3);return ce.x=oe.bounds.x,ce.y=oe.bounds.y,ce}}let B,x;try{B=k.screen.getDisplayMatching({x:T.x,y:T.y,width:T.width,height:T.height}),x=this.rb(B)}catch{}if(B&&x&&T.x+T.width>x.x&&T.y+T.height>x.y&&T.x<x.x+x.width&&T.y<x.y+x.height)return this.J.trace("window#validateWindowState: multi-monitor working area",x),T}rb(T){if(T.workArea.width>0&&T.workArea.height>0)return T.workArea;if(T.bounds.width>0&&T.bounds.height>0)return T.bounds}getBounds(){const[T,F]=this.k.getPosition(),[B,x]=this.k.getSize();return{x:T,y:F,width:B,height:x}}toggleFullScreen(){this.sb(!this.isFullScreen)}sb(T){this.wb()?this.tb(T):this.vb(T),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.r&&this.yb(this.r,!1)}get isFullScreen(){return g.$j&&typeof this.s=="boolean"?this.s:this.k.isFullScreen()||this.k.isSimpleFullScreen()}tb(T){this.k.isSimpleFullScreen()&&this.k.setSimpleFullScreen(!1),this.ub(T)}ub(T){g.$j&&(this.s=T,this.t=new O.$Pg,Promise.race([this.t.p,(0,O.$vg)(1e3)]).finally(()=>this.s=void 0)),this.k.setFullScreen(T)}vb(T){this.k.isFullScreen()&&this.ub(!1),this.k.setSimpleFullScreen(T),this.k.webContents.focus()}wb(){const T=this.S.getValue("window");return!T||typeof T.nativeFullScreen!="boolean"||T.nativeTabs?!0:T.nativeFullScreen!==!1}isMinimized(){return this.k.isMinimized()}xb(){let T=(0,I.$ID)(this.S);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}yb(T,F=!0){g.$j||(T==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,u.localize)(14,null)),T==="hidden"?setTimeout(()=>{this.zb(T)}):this.zb(T))}zb(T){const F=this.isFullScreen;switch(T){case"classic":this.k.setMenuBarVisibility(!F),this.k.autoHideMenuBar=F;break;case"visible":this.k.setMenuBarVisibility(!0),this.k.autoHideMenuBar=!1;break;case"toggle":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!0;break;case"hidden":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.$j)switch(k.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.k.minimize();break;case"None":break;case"Maximize":default:this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}else this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}close(){this.k?.close()}sendWhenReady(T,F,...B){this.isReady?this.send(T,...B):this.ready().then(()=>{F.isCancellationRequested||this.send(T,...B)})}send(T,...F){if(this.k){if(this.k.isDestroyed()||this.k.webContents.isDestroyed()){this.J.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this.k.webContents.send(T,...F)}catch(B){this.J.warn(`Error sending IPC message to channel '${T}' of window ${this.j}: ${(0,M.$ai)(B)}`)}}}updateTouchBar(T){g.$j&&this.C.forEach((F,B)=>{const x=T[B];F.segments=this.Cb(x)})}Ab(){if(g.$j){for(let T=0;T<10;T++){const F=this.Bb();this.C.push(F)}this.k.setTouchBar(new k.TouchBar({items:this.C}))}}Bb(T=[]){const F=this.Cb(T),B=new k.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:x=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:B.segments[x].id,from:"touchbar"})}});return B}Cb(T=[]){return T.map(B=>{let x;B.icon&&!o.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===f.Schemas.file&&(x=k.nativeImage.createFromPath(p.URI.revive(B.icon.dark).fsPath),x.isEmpty()&&(x=void 0));let oe;return typeof B.title=="string"?oe=B.title:oe=B.title.value,{id:B.id,label:x?void 0:oe,icon:x}})}dispose(){super.dispose(),this.L.deregisterLoggers(this.id),this.k=null}};e.$65b=J,e.$65b=J=ue=ke([Q(1,m.$Ri),Q(2,fe.$H5b),Q(3,d.$B4b),Q(4,W.$Wm),Q(5,ne.$J4b),Q(6,w.$Sj),Q(7,i.$N4b),Q(8,i.$L4b),Q(9,v.$Vh),Q(10,b.$l5b),Q(11,C.$74b),Q(12,y.$U4b),Q(13,n.$Vk),Q(14,c.$24b),Q(15,S.$D4b),Q(16,t.$0i),Q(17,a.$r5b),Q(18,A.$P4b),Q(19,re.$1M)],J)}),define(te[84],ie([0,1,14,24,8,3,46,2,15,4,19,7,21,191,6,20,5,83,98,30,54,35]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$D5b=e.$C5b=void 0,e.$C5b=(0,y.$ph)("workspacesHistoryMainService");let a=class extends E.$lb{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,o,b){super(),this.f=i,this.g=n,this.h=o,this.j=b,this.c=this.B(new M.$ec),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new s.$sg(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const I of i)if((0,l.$VT)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.r(n,I.workspace)&&n.push(I);else if((0,l.$WT)(I))this.s(n,I.folderUri)||n.push(I);else{const A=this.t(o,I.fileUri),P=I.fileUri.scheme===f.Schemas.file&&t.y.indexOf((0,$.$6f)(I.fileUri))>=0;!A&&!P&&(o.push(I),h.$i&&I.fileUri.scheme===f.Schemas.file&&k.app.addRecentDocument(I.fileUri.fsPath))}const b=await this.l({workspaces:n,files:o});n=b.workspaces,o=b.files,n.length>t.a&&(n.length=t.a),o.length>t.a&&(o.length=t.a),await this.n({workspaces:n,files:o}),this.c.fire(),h.$j&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const n=A=>{const P=this.p(A);for(const C of i)if($.$Zf.isEqual(C,P))return!1;return!0},o=await this.getRecentlyOpened(),b=o.workspaces.filter(n),I=o.files.filter(n);(b.length!==o.workspaces.length||I.length!==o.files.length)&&(await this.n({files:I,workspaces:b}),this.c.fire(),h.$j&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),k.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const n=new m.$ni(I=>$.$Zf.getComparisonKey(I));if(i?.workspaces)for(const I of i.workspaces)n.set(this.p(I),I);const o=new m.$ni(I=>$.$Zf.getComparisonKey(I));if(i?.files)for(const I of i.files)o.set(this.p(I),I);const b=await this.m();for(const I of b.workspaces){const A=n.get(this.p(I));A?A.label=A.label??I.label:n.set(this.p(I),I)}for(const I of b.files){const A=o.get(this.p(I));A?A.label=A.label??I.label:o.set(this.p(I),I)}return{workspaces:[...n.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,l.$3T)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,l.$4T)(i)),-1,1)}p(i){return(0,l.$WT)(i)?i.folderUri:(0,l.$XT)(i)?i.fileUri:i.workspace.configPath}r(i,n){return!!i.find(o=>(0,l.$VT)(o)&&o.workspace.id===n.id)}s(i,n){return!!i.find(o=>(0,l.$WT)(o)&&$.$Zf.isEqual(o.folderUri,n))}t(i,n){return!!i.find(o=>$.$Zf.isEqual(o.fileUri,n))}static{this.u=7}static{this.v=10}static{this.w=7}static{this.y=["COMMIT_EDITMSG","MERGE_MSG"]}async C(){h.$i&&(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!h.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const I of k.app.getJumpListSettings().removedItems){const A=I.args;if(A){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);P&&n.push(g.URI.parse(P[2]))}}await this.removeRecentlyOpened(n);let o=!1;const b=(0,O.$jf)((await this.getRecentlyOpened()).workspaces.slice(0,t.w).map(I=>{const A=(0,l.$VT)(I)?I.workspace:I.folderUri,{title:P,description:C}=this.F(A,I.label);let j;return g.URI.isUri(A)?j=`--folder-uri "${A.toString()}"`:(o=!0,j=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:C.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));b.length>0&&i.push({type:"custom",name:o?(0,u.localize)(2,null):(0,u.localize)(3,null),items:b})}i.push({type:"recent"});try{const n=k.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}F(i,n){if(n)return{title:(0,D.$cA)(n).name,description:n};if(g.URI.isUri(i))return{title:(0,$.$6f)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,u.localize)(4,null),description:""};let o=(0,$.$6f)(i.configPath);return o.endsWith(w.$Lh)&&(o=o.substr(0,o.length-w.$Lh.length-1)),{title:(0,u.localize)(5,null,o),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,D.$7z)(i.fsPath):i.toString()}async H(){if(!h.$j)return;k.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let I=0;I<i.workspaces.length&&o<t.u;I++){const A=this.p(i.workspaces[I]);if(A.scheme===f.Schemas.file){const P=(0,$.$Wf)(A);await p.Promises.exists(P)&&(n.push(P),o++)}}const b=[];for(let I=0;I<i.files.length&&o<t.v;I++){const A=this.p(i.files[I]);if(A.scheme===f.Schemas.file){const P=(0,$.$Wf)(A);if(t.y.includes((0,$.$6f)(A))||n.includes(P))continue;await p.Promises.exists(P)&&(b.push(P),o++)}}b.reverse().forEach(I=>k.app.addRecentDocument(I)),n.reverse().forEach(I=>k.app.addRecentDocument(I))}};e.$D5b=a,e.$D5b=a=t=ke([Q(0,c.$Ri),Q(1,S.$74b),Q(2,v.$D4b),Q(3,d.$N4b)],a)}),define(te[303],ie([0,1,14,8,23,46,4,7,179,18,28,20,5,229,67,22,34,25,48,81,29,84]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$E5b=void 0;const a="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(o,b,I,A,P,C,j,U,W,re,ne){this.n=o,this.o=b,this.p=I,this.q=A,this.r=P,this.s=C,this.t=j,this.u=U,this.v=W,this.w=re,this.x=ne,this.m=Object.create(null),this.g=new O.$Gg(()=>this.E(),0),this.h=new O.$Gg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,w.$JD)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(t.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(C,j,U)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.newWindow"]=(C,j,U)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.files.openFileFolder"]=(C,j,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.files.openFolder"]=(C,j,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.openWorkspace"]=(C,j,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.youTubeUrl;o&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(o,"openYouTubeUrl"));const b=this.x.requestFeatureUrl;b&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(b,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(I,"openReportIssues"));const A=this.x.licenseUrl;A&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$v){const C=A.indexOf("?")>0?"&":"?";this.Z(`${A}${C}lang=${D.$v}`,"openLicenseUrl")}else this.Z(A,"openLicenseUrl")});const P=this.x.privacyStatementUrl;P&&A&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(P,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!D.$j)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,b){this.k=o.menus,this.l=o.keybindings,this.t.setItem(t.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){D.$j&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){D.$j&&(this.f=!k.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=k.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){k.Menu.setApplicationMenu(D.$j?new k.Menu:null);return}const b=new k.Menu;let I;if(D.$j){const P=new k.Menu;I=new k.MenuItem({label:this.x.nameShort,submenu:P}),this.I(P),b.append(I)}if(D.$j&&!this.c){this.c=!0;const P=new k.Menu;P.append(new k.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),k.app.dock.setMenu(P)}if(this.K("File")){const P=new k.Menu,C=new k.MenuItem({label:this.ab(f.localize(1,null)),submenu:P});this.M(P,"File"),b.append(C)}if(this.K("Edit")){const P=new k.Menu,C=new k.MenuItem({label:this.ab(f.localize(2,null)),submenu:P});this.M(P,"Edit"),b.append(C)}if(this.K("Selection")){const P=new k.Menu,C=new k.MenuItem({label:this.ab(f.localize(3,null)),submenu:P});this.M(P,"Selection"),b.append(C)}if(this.K("View")){const P=new k.Menu,C=new k.MenuItem({label:this.ab(f.localize(4,null)),submenu:P});this.M(P,"View"),b.append(C)}if(this.K("Go")){const P=new k.Menu,C=new k.MenuItem({label:this.ab(f.localize(5,null)),submenu:P});this.M(P,"Go"),b.append(C)}if(this.K("Run")){const P=new k.Menu,C=new k.MenuItem({label:this.ab(f.localize(6,null)),submenu:P});this.M(P,"Run"),b.append(C)}if(this.K("Terminal")){const P=new k.Menu,C=new k.MenuItem({label:this.ab(f.localize(7,null)),submenu:P});this.M(P,"Terminal"),b.append(C)}let A;if(this.K("Window")){const P=new k.Menu;A=new k.MenuItem({label:this.ab(f.localize(8,null)),submenu:P,role:"window"}),this.S(P)}if(A&&b.append(A),this.K("Help")){const P=new k.Menu,C=new k.MenuItem({label:this.ab(f.localize(9,null)),submenu:P,role:"help"});this.M(P,"Help"),b.append(C)}b.items&&b.items.length>0?k.Menu.setApplicationMenu(b):k.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const b=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.T();let A;if(this.K("Preferences")){const fe=new k.Menu;this.M(fe,"Preferences"),A=new k.MenuItem({label:this.ab(f.localize(11,null)),submenu:fe})}const P=new k.Menu,C=new k.MenuItem({label:f.localize(12,null),role:"services",submenu:P}),j=new k.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new k.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),W=new k.MenuItem({label:f.localize(15,null),role:"unhide"}),re=new k.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(fe,ae,ue)=>{const V=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||k.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&await this.J(ue)&&this.w.quit(void 0)}})),ne=[b];ne.push(...I),A&&ne.push(i(),A),ne.push(i(),C,i(),j,U,W,i(),re),ne.forEach(fe=>o.append(fe))}async J(o){if(this.p.getWindowCount()===0)return!0;const b=this.o.getValue("window.confirmBeforeClose");if(b==="always"||b==="keyboardOnly"&&this.Q(o)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return I===0}return!0}K(o){if(!D.$j&&(0,w.$JD)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,b){b.forEach(I=>{if((0,u.$z5b)(I))o.append(i());else if((0,u.$y5b)(I)){const A=new k.Menu,P=new k.MenuItem({label:this.ab(I.label),submenu:A});this.L(A,I.submenu.items),o.append(P)}else(0,u.$A5b)(I)?o.append(this.O(I)):(0,u.$B5b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.N(o),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?o.append(new k.MenuItem(this.Y(I.id,{label:this.ab(I.label),click:this.m[I.id]}))):o.append(this.U(I.label,I.id,!1,I.checked)):o.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)):o.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)))})}M(o,b){this.k&&this.k[b]&&this.L(o,this.k[b].items)}N(o){const b=this.T();b.length&&(b.forEach(I=>o.append(I)),o.append(i()))}O(o){const b=E.URI.revive(o.uri),I=o.id,A=I==="openRecentFile"?{fileUri:b}:I==="openRecentWorkspace"?{workspaceUri:b}:{folderUri:b};return new k.MenuItem(this.Y(I,{label:o.label,click:async(P,C,j)=>{const U=this.P(j);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[A],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([b])}},!1))}P(o){return!!(o&&(!D.$j&&(o.ctrlKey||o.shiftKey)||D.$j&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,b,I){const A={label:this.ab(o),role:I,enabled:!0};return new k.MenuItem(this.X(b,A))}S(o){const b=new k.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new k.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),A=new k.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),P=this.U(f.localize(23,null),"workbench.action.switchWindow"),C=[];this.C&&(C.push(i()),C.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),C.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[b,I,i(),P,...C,i(),A].forEach(j=>o.append(j))}T(){switch(this.n.state.type){case"idle":return[new k.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new k.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new k.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new k.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new k.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new k.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new k.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(o,b,I,A){const P=this.ab(o),C=typeof b=="function"?b:(ne,fe,ae)=>{const ue=ne?ne.userSettingsLabel:null;let V=b;Array.isArray(b)&&(V=this.P(ae)?b[1]:b[0]),ue&&ae.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ue}):this.W({type:"commandId",commandId:V})},j=typeof I=="boolean"?I:this.p.getWindowCount()>0,U=typeof A=="boolean"?A:!1,W={label:P,click:C,enabled:j};U&&(W.type="checkbox",W.checked=U);let re;return typeof b=="string"?re=b:Array.isArray(b)&&(re=b[0]),D.$j&&(re==="editor.action.clipboardCutAction"?W.role="cut":re==="editor.action.clipboardCopyAction"?W.role="copy":re==="editor.action.clipboardPasteAction"&&(W.role="paste"),re==="undo"?W.click=this.V(C,{inDevTools:ne=>ne.undo(),inNoWindow:()=>k.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?W.click=this.V(C,{inDevTools:ne=>ne.redo(),inNoWindow:()=>k.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(W.click=this.V(C,{inDevTools:ne=>ne.selectAll(),inNoWindow:()=>k.Menu.sendActionToFirstResponder("selectAll:")}))),new k.MenuItem(this.X(re,W))}V(o,b){return(I,A,P)=>{const C=k.BrowserWindow.getFocusedWindow();if(!C)return b.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return b.inDevTools(C.webContents.devToolsWebContents);o(I,A||C,P)}}W(o){let b=k.BrowserWindow.getFocusedWindow();if(!b){const A=this.p.getLastActiveWindow();A?.isMinimized()&&(b=A.win)}const I=b?this.p.getWindowById(b.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",o),D.$j&&!this.q.isBuilt&&!I.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const A={id:o.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:o.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,b){const I=typeof o=="string"?this.l[o]:void 0;if(I?.label){if(I.isNative!==!1)b.accelerator=I.label,b.userSettingsLabel=I.userSettingsLabel;else if(typeof b.label=="string"){const A=b.label.indexOf("[");A>=0?b.label=`${b.label.substr(0,A)} [${I.label}]`:b.label=`${b.label} [${I.label}]`}}else b.accelerator=void 0;return b}Y(o,b,I=!b.accelerator){I&&(b=this.X(o,b));const A=b.click;return b.click=(P,C,j)=>{this.$(o),A?.(P,C,j)},b}Z(o,b){this.w.openExternal(void 0,o),this.$(b)}$(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:a})}ab(o){return(0,M.$_z)(o,!this.B)}};e.$E5b=r,e.$E5b=r=t=ke([Q(0,l.$xT),Q(1,h.$Vh),Q(2,S.$P4b),Q(3,$.$B4b),Q(4,d.$Vk),Q(5,m.$C5b),Q(6,c.$1M),Q(7,g.$D4b),Q(8,p.$Ri),Q(9,y.$p5b),Q(10,v.$0i)],r);function i(){return new k.MenuItem({type:"separator"})}}),define(te[304],ie([0,1,6,20,5,303]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G5b=e.$F5b=void 0,e.$F5b=(0,k.$ph)("menubarMainService");let D=class{constructor(f,h,$){this.b=f,this.c=h,this.d=$,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$E5b)}async updateMenubar(f,h){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(h,f)}};e.$G5b=D,e.$G5b=D=ke([Q(0,k.$oh),Q(1,O.$D4b),Q(2,s.$Ri)],D)}),define(te[305],ie([0,1,14,21,132,27,24,23,3,32,49,46,2,15,9,65,4,36,19,12,7,189,64,18,61,28,16,6,20,5,78,79,60,34,81,302,131,298,30,99,84,54,80,39,53,66]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m,t,a,r,i,n,o,b,I,A,P,C,j,U,W,re,ne,fe,ae,ue,V,J,z,T,F){"use strict";var B;Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=void 0;function x(G){return(0,fe.$Eh)(G?.workspace)}function oe(G){return(0,fe.$zh)(G?.workspace)}let ce=class extends p.$lb{static{B=this}static{this.a=[]}constructor(R,L,N,q,se,Y,le,K,ee,X,de,me,Re,De,je,ye,be,Z){super(),this.k=R,this.l=L,this.m=N,this.n=q,this.r=se,this.s=Y,this.t=le,this.u=K,this.v=ee,this.w=X,this.z=de,this.C=me,this.D=Re,this.F=De,this.G=je,this.H=ye,this.I=be,this.J=Z,this.b=this.B(new f.$ec),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$ec),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$ec),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$ec),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$ec),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ne.$75b(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(R=>this.c.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const L=new p.$kb;if(L.add(f.Event.any(R.onDidClose,R.onDidDestroy)(()=>L.dispose())),R.config.extensionDevelopmentPath)for(const N of R.config.extensionDevelopmentPath)L.add(this.I.addValidFileRoot(N));R.config.extensionTestsPath&&L.add(this.I.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,L){const N=this.t.args,q=L?.remoteAuthority||void 0,se=!0,Y=L?.forceReuseWindow,le=!Y;return this.open({...R,cli:N,forceEmpty:se,forceNewWindow:le,forceReuseWindow:Y,remoteAuthority:q})}openExistingWindow(R,L){R.focus(),this.M(L,[R])}async open(R){this.m.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const L=[],N=[],q=[],se=[],Y=[];let le,K=0;const ee=await this.S(R);this.m.trace("windowsManager#open pathsToOpen",ee);for(const De of ee)oe(De)?R.addMode?L.push(De):N.push(De):x(De)?q.push(De):De.fileUri?(le||(le={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),le.filesToOpenOrCreate.push(De)):De.backupPath?Y.push({backupFolder:(0,y.$_c)(De.backupPath),remoteAuthority:De.remoteAuthority}):K++;R.diffMode&&le&&le.filesToOpenOrCreate.length>=2&&(le.filesToDiff=le.filesToOpenOrCreate.slice(0,2),le.filesToOpenOrCreate=[]),R.mergeMode&&le&&le.filesToOpenOrCreate.length===4&&(le.filesToMerge=le.filesToOpenOrCreate.slice(0,4),le.filesToOpenOrCreate=[],le.filesToDiff=[]),le&&R.waitMarkerFileURI&&(le.filesToWait={paths:(0,D.$jf)([...le.filesToDiff,le.filesToMerge[3],...le.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(se.push(...this.D.getUntitledWorkspaces()),q.push(...se),Y.push(...this.w.getEmptyWindowBackups())):Y.length=0;const{windows:X,filesOpenedInWindow:de}=await this.N(R,q,N,Y,K,le,L);if(this.m.trace(`windowsManager#open used window count ${X.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${N.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${K})`),X.length>1)if(de)de.focus();else{const De=this.j.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let je=!0,ye=!0;if(De){const be=X.filter(Z=>this.j.state.lastActiveWindow&&Z.backupPath===this.j.state.lastActiveWindow.backupPath);be.length&&(be[0].focus(),je=!1,ye=!1)}if(je)for(let be=X.length-1;be>=0;be--){const Z=X[be];if(!(Z.openedWorkspace&&se.some(he=>Z.openedWorkspace&&he.workspace.id===Z.openedWorkspace.id)||Z.backupPath&&Y.some(he=>Z.backupPath&&he.backupFolder===(0,y.$_c)(Z.backupPath)))){Z.focus(),ye=!1;break}}ye&&X[X.length-1].focus()}const me=le&&le.filesToDiff.length>0,Re=le&&le.filesToMerge.length>0;if(!X.some(De=>De.isExtensionDevelopmentHost)&&!me&&!Re&&!R.noRecentEntry){const De=[];for(const je of ee)x(je)&&!je.transient?De.push({label:je.label,workspace:je.workspace,remoteAuthority:je.remoteAuthority}):oe(je)?De.push({label:je.label,folderUri:je.workspace.uri,remoteAuthority:je.remoteAuthority}):je.fileUri&&De.push({label:je.label,fileUri:je.fileUri,remoteAuthority:je.remoteAuthority});this.C.addRecentlyOpened(De)}return this.M(R,X),X}M(R,L){const N=R.waitMarkerFileURI;R.context===0&&N&&L.length===1&&L[0]&&(async()=>{await L[0].whenClosedOrLoaded;try{await this.H.del(N)}catch{}})()}async N(R,L,N,q,se,Y,le){const K=[];let ee;function X(be,Z){K.push(be),Z&&(ee=be,Y=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:me}=this.fb(R);if(!R.initialStartup&&le.length>0){const be=le[0].remoteAuthority,Z=this.kb(be);Z&&X(this.P(Z,le.map(he=>he.workspace.uri)))}const Re=N.length+L.length+q.length;if(Y&&Re===0){const be=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0]||Y.filesToMerge[3],Z=this.getWindows().filter($e=>Y&&(0,l.$bg)($e.remoteAuthority,Y.remoteAuthority));let he;be?.fileUri&&!me&&((R.context===4||R.context===0||R.context===1)&&(he=await(0,re.$44b)(Z,be.fileUri,async $e=>$e.configPath.scheme===u.Schemas.file?this.D.resolveLocalWorkspace($e.configPath):void 0)),he||(he=this.lb(Z))),he?(0,fe.$Eh)(he.openedWorkspace)?L.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):(0,fe.$zh)(he.openedWorkspace)?N.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):X(this.O(R,he,Y),!0):X(await this.gb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const De=(0,D.$of)(L,be=>be.workspace.id);if(De.length>0){const be=(0,D.$jf)(De.map(Z=>(0,re.$54b)(this.getWindows(),Z.workspace.configPath)));if(be.length>0){const Z=be[0],he=(0,l.$bg)(Y?.remoteAuthority,Z.remoteAuthority)?Y:void 0;X(this.O(R,Z,he),!!he),de=!0}for(const Z of De){if(be.some(Ee=>Ee.openedWorkspace&&Ee.openedWorkspace.id===Z.workspace.id))continue;const he=Z.remoteAuthority,$e=(0,l.$bg)(Y?.remoteAuthority,he)?Y:void 0;X(await this.R(R,Z,de,$e),!!$e),de=!0}}const je=(0,D.$of)(N,be=>l.$Zf.getComparisonKey(be.workspace.uri));if(je.length>0){const be=(0,D.$jf)(je.map(Z=>(0,re.$54b)(this.getWindows(),Z.workspace.uri)));if(be.length>0){const Z=be[0],he=(0,l.$bg)(Y?.remoteAuthority,Z.remoteAuthority)?Y:void 0;X(this.O(R,Z,he),!!he),de=!0}for(const Z of je){if(be.some(Ee=>(0,fe.$zh)(Ee.openedWorkspace)&&l.$Zf.isEqual(Ee.openedWorkspace.uri,Z.workspace.uri)))continue;const he=Z.remoteAuthority,$e=(0,l.$bg)(Y?.remoteAuthority,he)?Y:void 0;X(await this.R(R,Z,de,$e),!!$e),de=!0}}const ye=(0,D.$of)(q,be=>be.backupFolder);if(ye.length>0)for(const be of ye){const Z=be.remoteAuthority,he=(0,l.$bg)(Y?.remoteAuthority,Z)?Y:void 0;X(await this.Q(R,!0,Z,he,be),!!he),de=!0}if(K.length===0||Y){Y&&!se&&se++;const be=Y?Y.remoteAuthority:R.remoteAuthority;for(let Z=0;Z<se;Z++)X(await this.Q(R,de,be,Y),!!Y),de=!0}return{windows:(0,D.$of)(K),filesOpenedInWindow:ee}}O(R,L,N){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),L.focus();const q={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return L.sendWhenReady("vscode:openFiles",E.CancellationToken.None,q),L}P(R,L){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:L}),R.focus();const N={foldersToAdd:L};return R.sendWhenReady("vscode:addFolders",E.CancellationToken.None,N),R}Q(R,L,N,q,se){this.m.trace("windowsManager#doOpenEmpty",{restore:!!se,remoteAuthority:N,filesToOpen:q,forceNewWindow:L});let Y;return!L&&typeof R.contextWindowId=="number"&&(Y=this.getWindowById(R.contextWindowId)),this.gb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:N,forceNewWindow:L,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:q,windowToUse:Y,emptyWindowBackupInfo:se,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}R(R,L,N,q,se){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:L,filesToOpen:q}),!N&&!se&&typeof R.contextWindowId=="number"&&(se=this.getWindowById(R.contextWindowId)),this.gb({workspace:L.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:L.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:q,windowToUse:se,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async S(R){let L,N=!1,q=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(L=await this.U(R),N=!0):R.forceEmpty?L=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(L=await this.W(R.cli),L.length===0&&L.push(Object.create(null)),N=!0):(L=await this.Y(),L.length===0&&L.push(Object.create(null)),q=!0),!R.addMode&&N){const se=L.filter(Y=>oe(Y));if(se.length>1){const Y=se[0].remoteAuthority;if(se.every(le=>(0,l.$bg)(le.remoteAuthority,Y))){const le=await this.D.createUntitledWorkspace(se.map(K=>({uri:K.workspace.uri})));L.push({workspace:le,remoteAuthority:Y}),L=L.filter(K=>!oe(K))}}}if(R.initialStartup&&!q&&this.z.getValue("window")?.restoreWindows==="preserve"){const se=await this.Y();L.unshift(...se.filter(Y=>x(Y)||oe(Y)||Y.backupPath))}return L}async U(R){const L={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},N=await Promise.all((0,D.$jf)(R.urisToOpen||[]).map(async q=>{const se=await this.$(q,L);if(se)return se.label=q.label,se;const Y=this.bb(q);this.G.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:Y.scheme===u.Schemas.file?(0,m.localize)(1,null):(0,m.localize)(2,null),detail:Y.scheme===u.Schemas.file?(0,m.localize)(3,null,(0,g.$6z)(Y,{os:c.OS,tildify:this.t})):(0,m.localize)(4,null,Y.toString(!0))},k.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$jf)(N)}async W(R){const L=[],N={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},q=R["folder-uri"];if(q){const le=await Promise.all(q.map(K=>{const ee=this.X(K);if(ee)return this.$({folderUri:ee},N)}));L.push(...(0,D.$jf)(le))}const se=R["file-uri"];if(se){const le=await Promise.all(se.map(K=>{const ee=this.X(K);if(ee)return this.$((0,fe.$Uh)(K)?{workspaceUri:ee}:{fileUri:ee},N)}));L.push(...(0,D.$jf)(le))}const Y=await Promise.all(R._.map(le=>N.remoteAuthority?this.eb(le,N):this.cb(le,N)));return L.push(...(0,D.$jf)(Y)),L}X(R){try{const L=S.URI.parse(R);if(!L.scheme){this.m.error(`Invalid URI input string, scheme missing: ${R}`);return}return L.path?L:L.with({path:"/"})}catch(L){this.m.error(`Invalid URI input string: ${R}, ${L.message}`)}}async Y(){const R=this.Z();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const L=[];R!=="one"&&L.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&L.push(this.j.state.lastActiveWindow);const N=await Promise.all(L.map(async q=>{if(q.workspace){const se=await this.$({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(x(se))return se}else if(q.folderUri){const se=await this.$({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(oe(se))return se}else if(R!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,D.$jf)(N)}}}Z(){let R;return this.v.wasRestarted?R="all":(R=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async $(R,L=Object.create(null)){const N=this.bb(R);return N.scheme===u.Schemas.file?((0,U.$HD)(R)&&(L={...L,forceOpenWorkspaceAsFile:!0}),this.cb(N.fsPath,L)):this.ab(R,L)}ab(R,L){let N=this.bb(R);const q=(0,C.$Bk)(N)||L.remoteAuthority;if(N=(0,l.$dg)((0,l.$0f)(N)),(0,U.$HD)(R)){if(L.gotoLineMode){const{path:se,line:Y,column:le}=(0,h.$Oe)(N.path);return{fileUri:N.with({path:se}),options:{selection:Y?{startLineNumber:Y,startColumn:le||1}:void 0},remoteAuthority:q}}return{fileUri:N,remoteAuthority:q}}else if((0,U.$FD)(R))return{workspace:(0,ae.$W4b)(N),remoteAuthority:q};return{workspace:(0,ae.$X4b)(N),remoteAuthority:q}}bb(R){return(0,U.$FD)(R)?R.workspaceUri:(0,U.$GD)(R)?R.folderUri:R.fileUri}async cb(R,L,N){let q,se;L.gotoLineMode&&({path:R,line:q,column:se}=(0,h.$Oe)(R)),R=(0,h.$Je)((0,y.$6c)(R),(0,d.cwd)());try{const Y=await O.Promises.stat(R);if(Y.isFile()){if(!L.forceOpenWorkspaceAsFile){const le=await this.D.resolveLocalWorkspace(S.URI.file(R));if(le)return le.transient&&L.rejectTransientWorkspaces?void 0:{workspace:{id:le.id,configPath:le.configPath},type:n.FileType.File,exists:!0,remoteAuthority:le.remoteAuthority,transient:le.transient}}return{fileUri:S.URI.file(R),type:n.FileType.File,exists:!0,options:{selection:q?{startLineNumber:q,startColumn:se||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,ae.$X4b)(S.URI.file(R),Y),type:n.FileType.Directory,exists:!0};if(!c.$i&&R==="/dev/null")return{fileUri:S.URI.file(R),type:n.FileType.File,exists:!0}}}catch(Y){if(Y.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!N)return this.db(R,L);const le=S.URI.file(R);if(this.C.removeRecentlyOpened([le]),L.ignoreFileNotFound)return{fileUri:le,type:n.FileType.File,exists:!1}}}async db(R,L){const N=S.URI.file(R),{response:q,checkboxChecked:se}=await this.G.showMessageBox({type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],message:(0,m.localize)(8,null,N.authority),detail:(0,m.localize)(9,null,(0,g.$6z)(N,{os:c.OS,tildify:this.t})),checkboxLabel:(0,m.localize)(10,null,N.authority),cancelId:1});if(q===0)return(0,s.addUNCHostToAllowlist)(N.authority),se&&this.B(f.Event.once(this.onDidOpenWindow)(Y=>{Y.sendWhenReady("vscode:configureAllowedUNCHost",E.CancellationToken.None,N.authority)})),this.cb(R,L,!0);if(q===2)return k.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.db(R,L)}eb(R,L){const N=R.charCodeAt(0),q=L.remoteAuthority;let se,Y;L.gotoLineMode&&({path:R,line:se,column:Y}=(0,h.$Oe)(R)),N!==47&&((0,h.$Ie)(N)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,h.$Be)(R)),R=`/${R}`);const le=S.URI.from({scheme:u.Schemas.vscodeRemote,authority:q,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,fe.$Uh)(R))return L.forceOpenWorkspaceAsFile?{fileUri:le,options:{selection:se?{startLineNumber:se,startColumn:Y||1}:void 0},remoteAuthority:L.remoteAuthority}:{workspace:(0,ae.$W4b)(le),remoteAuthority:q};if(L.gotoLineMode||y.$5c.basename(R).indexOf(".")!==-1)return{fileUri:le,options:{selection:se?{startLineNumber:se,startColumn:Y||1}:void 0},remoteAuthority:q}}return{workspace:(0,ae.$X4b)(le),remoteAuthority:q}}fb(R){const L=this.z.getValue("window"),N=L?.openFoldersInNewWindow||"default",q=L?.openFilesInNewWindow||"off";let se=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(N==="on"||N==="off")&&(se=N==="on");let Y=!1;return R.forceNewWindow||R.forceReuseWindow?Y=!!R.forceNewWindow&&!R.forceReuseWindow:(c.$j?R.context===1&&(Y=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!R.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(Y=q==="on")),{openFolderInNewWindow:!!se,openFilesInNewWindow:Y}}async openExtensionDevelopmentHostWindow(R,L){const N=(0,re.$64b)(this.getWindows(),R);if(N)return this.v.reload(N,L.cli),N.focus(),[N];let q=L.cli["folder-uri"]||[],se=L.cli["file-uri"]||[],Y=L.cli._;if(!Y.length&&!q.length&&!se.length&&!L.cli.extensionTestsPath){const ee=this.j.state.lastPluginDevelopmentHostWindow,X=ee?.workspace??ee?.folderUri;X&&(S.URI.isUri(X)?X.scheme===u.Schemas.file?Y=[X.fsPath]:q=[X.toString()]:X.configPath.scheme===u.Schemas.file?Y=[(0,l.$Wf)(X.configPath)]:se=[X.configPath.toString()])}let le=L.remoteAuthority;for(const ee of R)if(ee.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const X=S.URI.parse(ee),de=(0,C.$Bk)(X);de&&(le?(0,l.$bg)(de,le)||this.m.error("more than one extension development path authority"):le=de)}Y=Y.filter(ee=>{const X=S.URI.file(ee);return(0,re.$54b)(this.getWindows(),X)?!1:(0,l.$bg)((0,C.$Bk)(X),le)}),q=q.filter(ee=>{const X=this.X(ee);return X&&(0,re.$54b)(this.getWindows(),X)?!1:X?(0,l.$bg)((0,C.$Bk)(X),le):!1}),se=se.filter(ee=>{const X=this.X(ee);return X&&(0,re.$54b)(this.getWindows(),X)?!1:X?(0,l.$bg)((0,C.$Bk)(X),le):!1}),L.cli._=Y,L.cli["folder-uri"]=q,L.cli["file-uri"]=se;const K={context:L.context,cli:L.cli,forceNewWindow:!0,forceEmpty:!Y.length&&!q.length&&!se.length,userEnv:L.userEnv,noRecentEntry:!0,waitMarkerFileURI:L.waitMarkerFileURI,remoteAuthority:le,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile};return this.open(K)}async gb(R){const L=this.z.getValue("window"),N=this.getLastActiveWindow(),q=N?.profile??this.u.defaultProfile;let se;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(se=R.windowToUse||N,se&&se.focus());const Y={...this.t.args,...R.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,y.$8c)(this.t.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:q},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.l,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:A.default,isInitialStartup:R.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof L?.zoomLevel=="number"?L.zoomLevel:void 0,autoDetectHighContrast:L?.autoDetectHighContrast??!0,autoDetectColorScheme:L?.autoDetectColorScheme??!1,accessibilitySupport:k.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(se){const le=se.config;!Y.extensionDevelopmentPath&&le?.extensionDevelopmentPath&&(Y.extensionDevelopmentPath=le.extensionDevelopmentPath,Y.extensionDevelopmentKind=le.extensionDevelopmentKind,Y["enable-proposed-api"]=le["enable-proposed-api"],Y.verbose=le.verbose,Y["inspect-extensions"]=le["inspect-extensions"],Y["inspect-brk-extensions"]=le["inspect-brk-extensions"],Y.debugId=le.debugId,Y.extensionEnvironment=le.extensionEnvironment,Y["extensions-dir"]=le["extensions-dir"],Y["disable-extensions"]=le["disable-extensions"]),Y.loggers={global:Y.loggers.global,window:le?.loggers.window??Y.loggers.window}}else{const le=this.j.getNewWindowState(Y);(0,v.mark)("code/willCreateCodeWindow");const K=se=this.F.createInstance(W.$65b,{state:le,extensionDevelopmentPath:Y.extensionDevelopmentPath,isExtensionTestHost:!!Y.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(K),B.a.push(K),this.b.fire(K),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,$.$cb)(K.onDidSignalReady)(()=>this.c.fire(K)),(0,$.$cb)(K.onDidClose)(()=>this.jb(K)),(0,$.$cb)(K.onDidDestroy)(()=>this.f.fire(K)),K.onDidTriggerSystemContextMenu(({x:X,y:de})=>this.h.fire({window:K,x:X,y:de}));const ee=(0,w.$te)(K.win?.webContents);ee.removeAllListeners("devtools-reload-page"),ee.on("devtools-reload-page",()=>this.v.reload(K)),this.v.registerWindow(K)}return Y.windowId=se.id,se.isReady?this.v.unload(se,4).then(async le=>{le||await this.hb(se,Y,R,q)}):await this.hb(se,Y,R,q),se}async hb(R,L,N,q){if(L.extensionDevelopmentPath||((0,fe.$Eh)(L.workspace)?L.backupPath=this.w.registerWorkspaceBackup({workspace:L.workspace,remoteAuthority:L.remoteAuthority}):(0,fe.$zh)(L.workspace)?L.backupPath=this.w.registerFolderBackup({folderUri:L.workspace.uri,remoteAuthority:L.remoteAuthority}):L.backupPath=this.w.registerEmptyWindowBackup({backupFolder:N.emptyWindowBackupInfo?.backupFolder??(0,ae.$Y4b)().id,remoteAuthority:L.remoteAuthority})),this.u.isEnabled()){const se=L.workspace??(0,fe.$Dh)(L.backupPath,!1),Y=this.ib(N,se,q),le=Y instanceof Promise?await Y:Y;L.profiles.profile=le,L.extensionDevelopmentPath||await this.u.setProfileForWorkspace(se,le)}R.load(L)}ib(R,L,N){return R.forceProfile?this.u.profiles.find(q=>q.name===R.forceProfile)??this.u.createNamedProfile(R.forceProfile):R.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(L)??N}jb(R){const L=B.a.indexOf(R);B.a.splice(L,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=k.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(R){return this.lb(this.getWindows().filter(L=>(0,l.$bg)(L.remoteAuthority,R)))}lb(R){const L=Math.max.apply(Math,R.map(N=>N.lastFocusTime));return R.find(N=>N.lastFocusTime===L)}sendToFocused(R,...L){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,E.CancellationToken.None,...L)}sendToAll(R,L,N){for(const q of this.getWindows())N&&N.indexOf(q.id)>=0||q.sendWhenReady(R,E.CancellationToken.None,L)}getWindows(){return B.a}getWindowCount(){return B.a.length}getWindowById(R){const L=this.getWindows().filter(N=>N.id===R);return(0,D.$sf)(L)}getWindowByWebContents(R){const L=k.BrowserWindow.fromWebContents(R);if(L)return this.getWindowById(L.id)}};e.$05b=ce,e.$05b=ce=B=ke([Q(2,I.$Ri),Q(3,F.$H5b),Q(4,j.$1M),Q(5,z.$Wm),Q(6,i.$B4b),Q(7,T.$J4b),Q(8,b.$D4b),Q(9,t.$U4b),Q(10,a.$Vh),Q(11,ue.$C5b),Q(12,V.$74b),Q(13,o.$oh),Q(14,r.$24b),Q(15,n.$Sj),Q(16,P.$r5b),Q(17,J.$l5b)],ce)}),define(te[306],ie([0,1,64,29,84,54]),function(H,e,k,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=void 0;let D=class{constructor(f,h,$,g){this.a=f,this.b=h,this.c=$,this.d=g,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,h){const $=this.b.getWindowById(f);if($)return this.a.enterWorkspace($,this.b.getWindows(),h)}createUntitledWorkspace(f,h,$){return this.a.createUntitledWorkspace(h,$)}deleteUntitledWorkspace(f,h){return this.a.deleteUntitledWorkspace(h)}getWorkspaceIdentifier(f,h){return this.a.getWorkspaceIdentifier(h)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,h){return this.c.addRecentlyOpened(h)}removeRecentlyOpened(f,h){return this.c.removeRecentlyOpened(h)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$_5b=D,e.$_5b=D=ke([Q(0,M.$74b),Q(1,O.$P4b),Q(2,s.$C5b),Q(3,k.$U4b)],D)}),define(te[307],ie([0,1,14,132,38,27,17,50,13,32,49,44,46,2,15,9,4,12,7,31,146,42,157,111,289,160,64,285,18,76,198,91,133,61,116,218,28,63,95,207,233,208,294,118,209,210,16,222,94,75,6,93,216,299,286,274,20,5,304,67,22,60,295,96,34,277,83,123,25,250,252,52,48,264,291,300,292,301,128,266,267,268,271,275,29,305,276,30,98,84,306,54,273,39,231,53,243,51,82,130,279,293,282,8,254,278,226,66,92,297,270,24,126,296,262,238,85]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m,t,a,r,i,n,o,b,I,A,P,C,j,U,W,re,ne,fe,ae,ue,V,J,z,T,F,B,x,oe,ce,G,R,L,N,q,se,Y,le,K,ee,X,de,me,Re,De,je,ye,be,Z,he,$e,Ee,Ce,Fe,Oe,ze,We,_,ge,we,ve,Ae,Ue,Me,Te,Be,He,qe,xe,Xe,tt,nt,$t,mt,wt,rt,bt,pt,yt,vt,kt,Et,St,ot,Pt,It,Dt,At,Rt,at,Ct,ht,ct,Ot,Mt,lt,Lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=void 0;let ut=class extends u.$lb{constructor(Pe,Se,pe,Le,Ie,Ne,Ye,Qe,Ze,Ge,Ve,Je){super(),this.c=Pe,this.f=Se,this.g=pe,this.h=Le,this.i=Ie,this.j=Ne,this.k=Ye,this.l=Qe,this.m=Ze,this.n=Ge,this.p=Ve,this.s=Je,this.t(),this.u()}t(){const Pe=Ge=>Ge?.startsWith(`${y.Schemas.vscodeWebview}://`),Se=new Set(this.p.quality==="stable"?[]:["media"]),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);k.session.defaultSession.setPermissionRequestHandler((Ge,Ve,Je,Ke)=>Pe(Ke.requestingUrl)?Je(pe.has(Ve)):Ke.isMainFrame&&Ke.securityOrigin==="vscode-file://vscode-app/"?Je(Se.has(Ve)):Je(!1)),k.session.defaultSession.setPermissionCheckHandler((Ge,Ve,Je,Ke)=>Pe(Ke.requestingUrl)?pe.has(Ve):Ke.isMainFrame&&Ke.securityOrigin==="vscode-file://vscode-app/"?Se.has(Ve):!1);const Le=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),Ie=Ge=>{for(let Ve=Ge;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ne=Ge=>Ge.resourceType==="xhr"||Ie(Ge.frame),Ye=Ge=>{const Ve=Ge.frame;if(!Ve||!this.a)return!1;const Je=k.BrowserWindow.getAllWindows();for(const Ke of Je)if(Ve.processId===Ke.webContents.mainFrame.processId)return!0;return!1},Qe=(Ge,Ve)=>{if(Ge.path!=="/index.html")return!0;const Je=Ve.frame;if(!Je||!this.a)return!1;for(const Ke of this.a.getWindows())if(Ke.win&&Je.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};k.session.defaultSession.webRequest.onBeforeRequest((Ge,Ve)=>{const Je=l.URI.parse(Ge.url);return Je.scheme===y.Schemas.vscodeWebview&&!Qe(Je,Ge)?(this.h.error("Blocked vscode-webview request",Ge.url),Ve({cancel:!0})):Je.scheme===y.Schemas.vscodeFileResource&&!Ye(Ge)?(this.h.error("Blocked vscode-file request",Ge.url),Ve({cancel:!0})):Je.path.endsWith(".svg")&&!Le.has(Je.scheme)?Ve({cancel:!Ne(Ge)}):Ve({cancel:!1})}),k.session.defaultSession.webRequest.onHeadersReceived((Ge,Ve)=>{const Je=Ge.responseHeaders,Ke=Je["content-type"]||Je["Content-Type"];if(Ke&&Array.isArray(Ke)){const it=l.URI.parse(Ge.url);if(it.path.endsWith(".svg")&&Le.has(it.scheme))return Je["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Je});if(!it.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ke.some(_e=>_e.toLowerCase().includes("image/svg")))return Ve({cancel:!Ne(Ge)})}return Ve({cancel:!1})});const Ze=k.session.defaultSession;typeof Ze.setCodeCachePath=="function"&&this.j.codeCachePath&&Ze.setCodeCachePath((0,v.$8c)(this.j.codeCachePath,"chrome")),c.$i&&(this.l.getValue("security.restrictUNCAccess")===!1?(0,O.disableUNCAccessRestrictions)():(0,O.addUNCHostToAllowlist)(this.l.getValue("security.allowedUNCHosts")))}u(){(0,f.setUnexpectedErrorHandler)(pe=>this.w(pe)),process.on("uncaughtException",pe=>{(0,f.$X)(pe)||(0,f.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,f.$Y)(pe)),this.k.onWillShutdown(()=>this.dispose()),(0,S.$xS)(),k.app.on("accessibility-support-changed",(pe,Le)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Le)}),k.app.on("activate",async(pe,Le)=>{this.h.trace("app#activate"),Le||await this.a?.openEmptyWindow({context:1})}),k.app.on("web-contents-created",(pe,Le)=>{Le.on("will-navigate",Ie=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),Le.setWindowOpenHandler(({url:Ie})=>(this.b?.openExternal(void 0,Ie),{action:"deny"}))});let Pe=[],Se;k.app.on("open-file",(pe,Le)=>{this.h.trace("app#open-file: ",Le),pe.preventDefault(),Pe.push((0,qe.$Uh)(Le)?{workspaceUri:l.URI.file(Le)}:{fileUri:l.URI.file(Le)}),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(async()=>{await this.a?.open({context:1,cli:this.j.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Se=void 0},100)}),k.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.$wS.handle("vscode:fetchShellEnv",pe=>{const Le=this.a?.getWindowByWebContents(pe.sender);let Ie,Ne;return Le?.config?(Ie=Le.config,Ne={...process.env,...Le.config.userEnv}):(Ie=this.j.args,Ne=process.env),this.O(Ie,Ne,!1)}),s.$wS.handle("vscode:writeNlsFile",(pe,Le,Ie)=>{const Ne=this.v([Le]);if(!Ne||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.n.writeFile(Ne,D.$Ec.fromString(Ie))}),s.$wS.handle("vscode:readNlsFile",async(pe,...Le)=>{const Ie=this.v(Le);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.n.readFile(Ie)).value.toString()}),s.$wS.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),s.$wS.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),s.$wS.on("vscode:reloadWindow",pe=>pe.sender.reload())}v(Pe){let Se;for(const pe of Pe)typeof pe=="string"&&(typeof Se!="string"?Se=pe:Se=(0,v.$8c)(Se,pe));if(!(typeof Se!="string"||!(0,v.$7c)(Se)||!(0,h.$He)(Se,this.j.cachedLanguagesPath,!c.$k)))return l.URI.file(Se)}w(Pe){if(Pe){const Se={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.j.appRoot}`),this.h.debug("args:",this.j.args);const Pe=this.p.win32AppUserModelId;c.$i&&Pe&&k.app.setAppUserModelId(Pe);try{c.$j&&this.l.getValue("window.nativeTabs")===!0&&!k.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&k.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ze){this.h.error(Ze)}const Se=new t.$DS;this.k.onWillShutdown(Ze=>{Ze.reason===2&&Se.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Pt.$h6b)(this.m,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Le,sharedProcessClient:Ie}=this.H(pe),Ne=await this.I(pe,Le);this.B(Ne.createInstance(r.$Q4b)),this.B(Ne.createInstance(Et.$e6b)),Ne.invokeFunction(Ze=>this.J(Ze,Se,Ie));const Ye=Ne.invokeFunction(Ze=>this.y(Ze,Se));this.z(Se),this.k.phase=2,await Ne.invokeFunction(Ze=>this.L(Ze,Ye)),this.k.phase=3,this.M(),this.B(new ot.$Gg(()=>{this.B((0,ot.$Kg)(()=>this.k.phase=4,2500))},2500)).schedule()}y(Pe,Se){const pe=this.a=Pe.get(Te.$P4b),Le=Pe.get(ge.$lT),Ie=this.b=Pe.get(ee.$p5b),Ne=this;Le.registerHandler({async handleURL(Je,Ke){return Ne.G(pe,Le,Je,Ke)}});const Ye=this.B(new He.$$5b({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),Qe=new m.$0g(Je=>Ye.getActiveClientId().then(Ke=>Je===Ke)),Ze=new we.$15b(Qe,this.h),Ge=Se.getChannel("urlHandler",Ze);Le.registerHandler(new we.$Z5b(Ge));const Ve=this.C();return this.B(new Ae.$25b(Ve?.urls,Le,pe,this.j,this.p,this.h)),Ve}z(Pe){const Se=()=>({statusCode:404,data:"Not found"}),pe=new Lt.$T(()=>Pe.getChannel(lt.$o6b,new lt.$p6b));k.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Le,Ie)=>{const Ne=l.URI.parse(Le.url);if(!Ne.authority.startsWith("window:"))return Ie(Se());pe.value.call(lt.$n6b,[Ne]).then(Ye=>Ie({...Ye,data:Buffer.from(Ye.body,"base64")}),Ye=>{this.h.warn("error dispatching remote resource call",Ye),Ie({statusCode:500,data:String(Ye)})})})}C(){const Pe=this.j.args["open-url"]?this.j.args._urls||[]:[];Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Pe.length+Se.length===0)return;const pe=[];return{urls:[...Pe,...Se].map(Ie=>{try{return{uri:l.URI.parse(Ie),originalUrl:Ie}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ie);return}}).filter(Ie=>{if(!Ie)return!1;if(this.D(Ie.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ie.uri.toString(!0)),!1;const Ne=this.F(Ie.uri);return Ne?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ie.uri.toString(!0),Ne),pe.push(Ne),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ie.uri.toString(!0)),!0)}),openables:pe}}D(Pe){if(Pe.authority===y.Schemas.file&&c.$i){const{options:Se,buttonIndeces:pe}=(0,Rt.$hA)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,p.$6z)(Pe,{os:c.OS,tildify:this.j}),this.p.nameShort),detail:(0,i.localize)(3,null)},this.p);if(pe[k.dialog.showMessageBoxSync(Se)]===1)return!0}return!1}F(Pe){if(Pe.path){if(Pe.authority===y.Schemas.file){const Se=l.URI.file(Pe.fsPath);return(0,qe.$Uh)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(Pe.authority===y.Schemas.vscodeRemote){const Se=Pe.path.indexOf(v.$5c.sep,1);if(Se!==-1){const pe=Pe.path.substring(1,Se),Le=Pe.path.substring(Se),Ie=l.URI.from({scheme:y.Schemas.vscodeRemote,authority:pe,path:Le,query:Pe.query,fragment:Pe.fragment});return(0,qe.$Uh)(Le)?{workspaceUri:Ie}:/:[\d]+$/.test(Le)?{fileUri:Ie}:{folderUri:Ie}}}}}async G(Pe,Se,pe,Le){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Le),pe.scheme===this.p.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:l.URI.parse(pe.query).path,query:""})),this.D(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Ie=!1;const Ne=new URLSearchParams(pe.query);Ne.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ne.delete("windowId"),pe=pe.with({query:Ne.toString()}),Ie=!0):c.$j&&Pe.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ie=!0);const Ye=Ne.get("continueOn");Ye!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Ne.delete("continueOn"),pe=pe.with({query:Ne.toString()}),this.j.continueOn=Ye??void 0);const Qe=this.F(pe);return Qe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,pe.toString(!0)),(0,ht.$sf)(await Pe.open({context:5,cli:{...this.j.args},urisToOpen:[Qe],forceNewWindow:Ie,gotoLineMode:!0}))?.focus(),!0):Ie?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ht.$sf)(await Pe.open({context:5,cli:{...this.j.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.$Bk)(pe)}))?.ready(),Se.open(pe,Le)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Le),!1)}H(Pe){const Se=this.B(this.g.createInstance(me.$M5b,Pe)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const Ie=await Se.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new a.$ES(Ie,"main")})();return{sharedProcessReady:(async()=>(await Se.whenReady(),pe))(),sharedProcessClient:pe}}async I(Pe,Se){const pe=new R.$nh;switch(process.platform){case"win32":pe.set(Ce.$xT,new ce.$mh(_.$X5b));break;case"linux":c.$l?pe.set(Ce.$xT,new ce.$mh(We.$W5b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Ce.$xT,new ce.$mh(ze.$V5b));break;case"darwin":pe.set(Ce.$xT,new ce.$mh(Oe.$U5b));break}pe.set(Te.$P4b,new ce.$mh(Be.$05b,[Pe,this.f],!1));const Le=new j.$34b(this.h,this.p);pe.set(j.$24b,Le),pe.set(se.$w5b,new ce.$mh(se.$x5b,void 0,!1)),pe.set(C.$_4b,new ce.$mh(C.$a5b,void 0,!1)),pe.set(P.$6l,m.ProxyChannel.toService((0,m.$8g)(Se.then(Ze=>Ze.getChannel("diagnostics"))))),pe.set(L.$Isb,new ce.$mh(N.$s5b,[this.f])),pe.set(U.$fT,new ce.$mh(W.$b5b)),pe.set(q.$t5b,new ce.$mh(q.$u5b)),pe.set(ee.$p5b,new ce.$mh(ee.$q5b,void 0,!1)),pe.set(I.$on,new ce.$mh($t.$a6b)),pe.set(Ue.$35b,new ce.$mh(Me.$55b)),pe.set(K.$F5b,new ce.$mh(K.$G5b)),pe.set(ae.$kkb,new ce.$mh(ue.$c5b)),pe.set(V.$d5b,new ce.$mh(J.$f5b)),pe.set(ye.$L4b,new ce.$mh(ye.$M4b)),pe.set(ye.$N4b,new ce.$mh(ye.$O4b));const Ie=new Ot.$m6b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.l.getValue("terminal.integrated.persistentSessionScrollback")??100},this.l,this.j,this.k,this.h),Ne=new Mt.$cr(Ie,this.l,this.h,this.i);pe.set(ct.$Pq,Ne),c.$i?pe.set(z.$sWb,new ce.$mh(T.$g5b)):c.$j?pe.set(z.$sWb,new ce.$mh(T.$h5b)):c.$k&&pe.set(z.$sWb,new ce.$mh(T.$i5b));const Ye=new o.$Z4b(this.j,this.l,this.h,this.m);pe.set(n.$U4b,Ye);const Qe=new nt.$84b(this.j,this.h,this.s,Ye,Le);if(pe.set(nt.$74b,Qe),pe.set(xe.$UT,new ce.$mh(tt.$_5b,void 0,!1)),pe.set(Xe.$C5b,new ce.$mh(Xe.$D5b,void 0,!1)),pe.set(ge.$lT,new ce.$mh(ve.$nT,void 0,!1)),(0,Ee.$_n)(this.p,this.j)){const Ze=(0,Ee.$eo)(this.p,this.l),Ge=(0,m.$8g)(Se.then(_e=>_e.getChannel("telemetryAppender"))),Ve=new he.$P5b(Ge),Je=(0,be.$2n)((0,M.release)(),(0,M.hostname)(),process.arch,this.p.commit,this.p.version,Pe,Ze),Ke=(0,Ee.$fo)(this.j),it={appenders:[Ve],commonProperties:Je,piiPaths:Ke,sendErrorTelemetry:!0};pe.set(Z.$Vk,new ce.$mh($e.$Hq,[it],!1))}else pe.set(Z.$Vk,Ee.$6n);return pe.set(yt.$bp,new ce.$mh(It.$8M,void 0,!0)),pe.set(vt.$fp,new ce.$mh(kt.$d6b,void 0,!0)),pe.set(at.$k6b,new ce.$mh(at.$l6b,void 0,!0)),await ot.Promises.settled([Ye.initialize(),Qe.initialize()]),this.g.createChild(pe)}J(Pe,Se,pe){const Le=m.ProxyChannel.fromService(Pe.get(se.$w5b),{disableMarshalling:!0});this.c.registerChannel("launch",Le);const Ie=m.ProxyChannel.fromService(Pe.get(C.$_4b),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Ie);const Ne=new wt.$b6b(Pe.get(mt.$Wm));Se.registerChannel("policy",Ne),pe.then(et=>et.registerChannel("policy",Ne));const Ye=this.n.getProvider(y.Schemas.file);(0,d.$se)(Ye instanceof oe.$Tp);const Qe=new x.$j5b(Ye,this.h,this.j);Se.registerChannel(F.$QM,Qe),pe.then(et=>et.registerChannel(F.$QM,Qe));const Ze=m.ProxyChannel.fromService(Pe.get(rt.$J4b));Se.registerChannel("userDataProfiles",Ze),pe.then(et=>et.registerChannel("userDataProfiles",Ze));const Ge=new bt.$Cq(Pe.get(pt.$Ao));pe.then(et=>et.registerChannel("request",Ge));const Ve=new Fe.$Q5b(Pe.get(Ce.$xT));Se.registerChannel("update",Ve);const Je=m.ProxyChannel.fromService(Pe.get(L.$Isb));Se.registerChannel("issue",Je);const Ke=m.ProxyChannel.fromService(Pe.get(U.$fT));Se.registerChannel("encryption",Ke);const it=m.ProxyChannel.fromService(Pe.get(I.$on));Se.registerChannel("credentials",it);const _e=m.ProxyChannel.fromService(Pe.get(Re.$Jk));Se.registerChannel("sign",_e);const st=m.ProxyChannel.fromService(Pe.get(q.$t5b));Se.registerChannel("keyboardLayout",st),this.b=Pe.get(ee.$p5b);const ft=m.ProxyChannel.fromService(this.b);Se.registerChannel("nativeHost",ft),pe.then(et=>et.registerChannel("nativeHost",ft));const jt=m.ProxyChannel.fromService(Pe.get(xe.$UT));Se.registerChannel("workspaces",jt);const Tt=m.ProxyChannel.fromService(Pe.get(K.$F5b));Se.registerChannel("menubar",Tt);const Ut=m.ProxyChannel.fromService(Pe.get(ge.$lT));Se.registerChannel("url",Ut);const Ft=m.ProxyChannel.fromService(Pe.get(ae.$kkb));Se.registerChannel("extensionUrlTrust",Ft);const Nt=m.ProxyChannel.fromService(Pe.get(Ue.$35b));Se.registerChannel("webview",Nt);const dt=this.B(new je.$N5b(this.h,Pe.get(ye.$L4b)));Se.registerChannel("storage",dt),pe.then(et=>et.registerChannel("storage",dt));const Wt=this.B(new St.$f6b(Pe.get(ye.$L4b),Pe.get(rt.$J4b),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Wt));const zt=m.ProxyChannel.fromService(Pe.get(ct.$Pq));Se.registerChannel(ct.TerminalIpcChannels.LocalPty,zt);const Bt=m.ProxyChannel.fromService(Pe.get(z.$sWb));Se.registerChannel("externalTerminal",Bt);const gt=new Dt.$i6b(Pe.get(At.$H5b));Se.registerChannel("logger",gt),pe.then(et=>et.registerChannel("logger",gt));const qt=new A.$14b(Pe.get(Te.$P4b));Se.registerChannel("extensionhostdebugservice",qt);const Ht=m.ProxyChannel.fromService(Pe.get(V.$d5b));Se.registerChannel(V.$e5b,Ht);const Vt=m.ProxyChannel.fromService(Pe.get(at.$k6b));Se.registerChannel(Ct.$j6b,Vt)}async L(Pe,Se){const pe=this.a=Pe.get(Te.$P4b),Le=(0,ne.$tl)(process.env)?0:4,Ie=this.j.args;if(Se){if(Se.openables.length>0)return pe.open({context:Le,cli:Ie,urisToOpen:Se.openables,gotoLineMode:!0,initialStartup:!0});if(Se.urls.length>0)for(const _e of Se.urls){const st=new URLSearchParams(_e.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:st.toString()}),pe.open({context:Le,cli:Ie,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Ye=Ie._.length,Qe=!!Ie["folder-uri"],Ze=!!Ie["file-uri"],Ge=Ie["skip-add-to-recently-opened"]===!0,Ve=Ie.wait&&Ie.waitMarkerFilePath?l.URI.file(Ie.waitMarkerFilePath):void 0,Je=Ie.remote||void 0,Ke=Ie.profile,it=Ie["profile-temp"];if(!Ye&&!Qe&&!Ze){if(Ie["new-window"]||Ke||it)return pe.open({context:Le,cli:Ie,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:Ke,forceTempProfile:it});if(Ne.length)return pe.open({context:1,cli:Ie,urisToOpen:Ne.map(_e=>(0,qe.$Uh)(_e)?{workspaceUri:l.URI.file(_e)}:{fileUri:l.URI.file(_e)}),noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0})}return pe.open({context:Le,cli:Ie,forceNewWindow:Ie["new-window"]||!Ye&&Ie["unity-launch"],diffMode:Ie.diff,mergeMode:Ie.merge,noRecentEntry:Ge,waitMarkerFileURI:Ve,gotoLineMode:Ie.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:Ke,forceTempProfile:it})}M(){this.N(),k.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Pe,Se)=>{Se({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.O(this.j.args,process.env,!0),this.P(),c.$j&&k.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async N(){const Pe=this.p.win32MutexName;if(c.$i&&Pe)try{const Se=await new Promise((Le,Ie)=>{H(["@vscode/windows-mutex"],Le,Ie)}),pe=new Se.Mutex(Pe);(0,$.$cb)(this.k.onWillShutdown)(()=>pe.release())}catch(Se){this.h.error(Se)}}async O(Pe,Se,pe){try{return await(0,fe.$zl)(this.l,this.h,Pe,Se)}catch(Le){const Ie=(0,E.$ai)(Le);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",Ie):this.h.error(Ie)}return{}}async P(){try{const Se=(await this.n.readFile(this.j.argvResource)).value.toString(),pe=JSON.parse((0,g.$Gm)(Se)),Ie=(0,Ee.$bo)(this.l)>=1;if(pe["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ie},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,w.$3e)()}"`,"}"],Ye=Se.substring(0,Se.length-2).concat(`,
`,Ne.join(`
`));await this.n.writeFile(this.j.argvResource,D.$Ec.fromString(Ye))}else{const Ne=Se.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ie},`);Ne!==Se&&await this.n.writeFile(this.j.argvResource,D.$Ec.fromString(Ne))}}catch(Pe){this.h.error(Pe)}}};e.$q6b=ut,e.$q6b=ut=ke([Q(2,G.$oh),Q(3,le.$Ri),Q(4,le.$Si),Q(5,re.$B4b),Q(6,Y.$D4b),Q(7,b.$Vh),Q(8,De.$1M),Q(9,B.$Sj),Q(10,X.$0i),Q(11,rt.$J4b)],ut)}),define(te[313],ie([0,1,14,45,7,24,8,50,13,32,49,46,15,9,65,4,36,26,21,42,100,307,10,18,237,249,28,63,200,16,220,94,75,215,93,20,223,5,78,22,79,280,127,290,51,288,96,248,34,52,80,53,39,232,230,2,40,265,66,225,92,122,269,263]),function(H,e,k,O,s,M,D,E,f,h,$,g,p,u,y,v,c,d,l,w,S,m,t,a,r,i,n,o,b,I,A,P,C,j,U,W,re,ne,fe,ae,ue,V,J,z,T,F,B,x,oe,ce,G,R,L,N,q,se,Y,le,K,ee,X,de,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Re{main(){try{this.a()}catch(ye){console.error(ye.message),k.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ye,be,Z,he,$e,Ee,Ce,Fe]=this.b();try{try{await this.d(Z,Fe,he,$e,Ce)}catch(Oe){throw this.f(Z,Ce,Oe),Oe}await ye.invokeFunction(async Oe=>{const ze=Oe.get(ne.$Ri),We=Oe.get(W.$D4b),_=Oe.get(I.$Sj),ge=Oe.get(ne.$Si),we=await this.e(ze,Z,We,ye,Ce,!0);return l.Promises.writeFile(Z.mainLockfile,String(process.pid)).catch(ve=>{ze.warn(`app#startup(): Error writing main lockfile: ${ve.stack}`)}),Ee.logger=ge.createLogger("main",{name:(0,t.localize)(0,null)}),(0,$.$cb)(We.onWillShutdown)(ve=>{_.dispose(),he.dispose(),ve.join("instanceLockfile",l.Promises.unlink(Z.mainLockfile).catch(()=>{}))}),ye.createInstance(m.$q6b,we,be).startup()})}catch(Oe){ye.invokeFunction(this.i,Oe)}}b(){const ye=new U.$nh,be=new se.$kb;process.once("exit",()=>be.dispose());const Z={_serviceBrand:void 0,...fe.default};ye.set(ae.$0i,Z);const he=new n.$C4b(this.j(),Z),$e=this.c(he);ye.set(n.$B4b,he);const Ee=new K.$I5b((0,ne.$6i)(he),he.logsHome);ye.set(K.$H5b,Ee);const Ce=new re.$k2b(Ee.getLogLevel()),Fe=be.add(new ee.$9M(Ce,[new ne.$Yi(Ee.getLogLevel())]));ye.set(ne.$Ri,Fe);const Oe=new A.$up(Fe);ye.set(I.$Sj,Oe);const ze=new P.$Tp(Fe);Oe.registerProvider(p.Schemas.file,ze),Oe.registerProvider(p.Schemas.vscodeUserData,new me.$B6b(p.Schemas.file,ze,p.Schemas.vscodeUserData,Fe));const We=new le.$gr(Oe);ye.set(Y.$pk,We);const _=new de.$4M(1,he,Fe,Oe);ye.set(oe.$ZM,_),ye.set(oe.$1M,_);const ge=new R.$K4b(_,We,he,Oe,Fe);ye.set(R.$J4b,ge);const we=v.$i&&Z.win32RegValueName?be.add(new N.$z6b(Fe,Z.win32RegValueName)):he.policyFile?be.add(new q.$A6b(he.policyFile,Oe,Fe)):new L.$Ym;ye.set(L.$Wm,we);const ve=new r.$mn(ge.defaultProfile.settingsResource,Oe,we,Fe);return ye.set(a.$Vh,ve),ye.set(W.$D4b,new C.$mh(W.$E4b,void 0,!1)),ye.set(T.$Ao,new C.$mh(F.$x6b,void 0,!0)),ye.set(G.$l5b,new C.$mh(G.$m5b)),ye.set(B.$Jk,new C.$mh(x.$y6b,void 0,!1)),ye.set(J.$Lz,new C.$mh(z.$v6b)),ye.set(ue.$r5b,new V.$s6b(he,ge,Fe)),[new j.$Wp(ye,!0),$e,he,ve,_,Ce,Z,ge]}c(ye){const be={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Z=>{const he=process.env[Z];typeof he=="string"&&(be[Z]=he)}),Object.assign(process.env,be),be}async d(ye,be,Z,he,$e){await D.Promises.settled([Promise.all([ye.extensionsPath,ye.codeCachePath,ye.logsHome.fsPath,be.defaultProfile.globalStorageHome.fsPath,ye.workspaceStorageHome.fsPath,ye.localHistoryHome.fsPath,ye.backupHome].map(Ee=>Ee?l.Promises.mkdir(Ee,{recursive:!0}):void 0)),he.init(),Z.initialize()]),be.init()}async e(ye,be,Z,he,$e,Ee){let Ce;try{(0,y.mark)("code/willStartMainServer"),Ce=await(0,S.$kh)(be.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,$.$cb)(Z.onWillShutdown)(()=>Ce.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.f(be,$e,Fe),Fe;let Oe;try{Oe=await(0,S.$lh)(be.mainIPCHandle,"main")}catch(ge){if(!Ee||v.$i||ge.code!=="ECONNREFUSED")throw ge.code==="EPERM"&&this.g((0,t.localize)(1,null,$e.nameShort),(0,t.localize)(2,null),$e),ge;try{(0,O.unlinkSync)(be.mainIPCHandle)}catch(we){throw ye.warn("Could not delete obsolete instance handle",we),we}return this.e(ye,be,Z,he,$e,!1)}if(be.extensionTestsLocationURI&&!be.debugExtensionHost.break){const ge=`Running extension tests from the command line is currently only supported if no other instance of ${$e.nameShort} is running.`;throw ye.error(ge),Oe.dispose(),new Error(ge)}let ze;!be.args.wait&&!be.args.status&&(ze=setTimeout(()=>{this.g((0,t.localize)(3,null,$e.nameShort),(0,t.localize)(4,null),$e)},1e4));const We=w.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),_=w.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(be.args.status)return he.invokeFunction(async()=>{const ge=new i.$nr(ce.$6n,$e),we=await _.getMainDiagnostics(),ve=await _.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ae=await ge.getDiagnostics(we,ve);throw console.log(Ae),new f.$_});throw v.$i&&await this.h(We,ye),ye.trace("Sending env to running instance..."),await We.start(be.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new f.$_("Sent env to running instance. Terminating...")}if(be.args.status)throw console.log((0,t.localize)(5,null,$e.nameShort)),new f.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f(ye,be,Z){if(Z.code==="EACCES"||Z.code==="EPERM"){const he=(0,M.$jf)([ye.userDataPath,ye.extensionsPath,S.$gh]).map($e=>(0,g.$6z)(s.URI.file($e),{os:v.OS,tildify:ye}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$ai)(Z),he.join(`
`)),be)}}g(ye,be,Z){k.dialog.showMessageBoxSync((0,X.$hA)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:be},Z).options)}async h(ye,be){if(v.$i){const Z=await ye.getMainProcessId();be.trace("Sending some foreground love to the running instance:",Z);try{(await new Promise((he,$e)=>{H(["windows-foreground-love"],he,$e)})).allowSetForegroundWindow(Z)}catch(he){be.error(he)}}}i(ye,be){const Z=ye.get(ne.$Ri),he=ye.get(W.$D4b);let $e=0;be&&(be.isExpected?be.message&&Z.trace(be.message):($e=1,be.stack?Z.error(be.stack):Z.error(`Startup error: ${be.toString()}`))),he.kill($e)}j(){const ye=this.k((0,o.$ql)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const be=(0,b.$r6b)(ye.verbose);be&&((0,o.$sl)(process.argv,"--waitMarkerFilePath",be),ye.waitMarkerFilePath=be)}return ye}k(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const be=this.l(ye._,ye.goto);ye._=be}return ye}l(ye,be){const Z=(0,c.cwd)(),he=ye.map(Ce=>{let Fe=String(Ce),Oe;be&&(Oe=(0,h.$Oe)(Fe),Fe=Oe.path),Fe&&(Fe=this.m(Z,Fe));const ze=(0,h.$Je)(Fe,Z),We=(0,u.$_c)(ze);return We&&!(0,h.$Fe)(We)?null:be&&Oe?(Oe.path=ze,this.n(Oe)):ze}),$e=v.$i||v.$j,Ee=(0,M.$of)(he,Ce=>Ce&&$e?Ce.toLowerCase():Ce||"");return(0,M.$jf)(Ee)}m(ye,be){return v.$i&&(be=(0,d.$ud)(be,'"')),be=(0,d.$sd)((0,d.$sd)(be," "),"	"),v.$i&&(be=(0,u.$9c)(ye,be),be=(0,d.$ud)(be,".")),be}n(ye){const be=[ye.path];return typeof ye.line=="number"&&be.push(String(ye.line)),typeof ye.column=="number"&&be.push(String(ye.column)),be.join(":")}}new Re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/35be9bf683eace09796e59d54f1f225bbc3a7866/core/vs/code/electron-main/main.js.map
