/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,j=J.length;L<j;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class L{static get(){const R=new Map,A=new Map,N=new Map,y=new Map;function u(d,b){d.has(b.detail)||d.set(b.detail,-b.timestamp)}function l(d,b){const k=d.get(b.detail);k&&(k>=0||d.set(b.detail,k+b.timestamp))}let w=[];typeof J=="function"&&typeof J.getStats=="function"&&(w=J.getStats().slice(0).sort((d,b)=>d.timestamp-b.timestamp));for(const d of w)switch(d.type){case 10:u(R,d);break;case 11:case 12:l(R,d);break;case 21:u(A,d);break;case 22:l(A,d);break;case 33:u(N,d);break;case 34:l(N,d);break;case 31:u(y,d);break;case 32:l(y,d);break}let O=0;N.forEach(d=>O+=d);function m(d){const b=[];return d.forEach((k,$)=>b.push([$,k])),b}return{amdLoad:m(R),amdInvoke:m(A),nodeRequire:m(N),nodeEval:m(y),nodeRequireTotal:O}}static toMarkdownTable(R,A){let N="";const y=[];return R.forEach((u,l)=>{y[l]=u.length}),A.forEach(u=>{u.forEach((l,w)=>{typeof l>"u"&&(l=u[w]="-");const O=l.toString().length;y[w]=Math.max(O,y[w])})}),R.forEach((u,l)=>{N+=`| ${u+" ".repeat(y[l]-u.toString().length)} `}),N+=`|
`,R.forEach((u,l)=>{N+=`| ${"-".repeat(y[l])} `}),N+=`|
`,A.forEach(u=>{u.forEach((l,w)=>{typeof l<"u"&&(N+=`| ${l+" ".repeat(y[w]-l.toString().length)} `)}),N+=`|
`}),N}}e.$S=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function L(N){return(y,u,l)=>{let w=null,O=null;if(typeof l.value=="function"?(w="value",O=l.value):typeof l.get=="function"&&(w="get",O=l.get),!O)throw new Error("not supported");l[w]=N(O,u)}}function j(N,y,u){let l=null,w=null;if(typeof u.value=="function"?(l="value",w=u.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",w=u.get),!w)throw new Error("not supported");const O=`$memoize$${y}`;u[l]=function(...m){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,m)}),this[O]}}e.$Tg=j;function R(N,y,u){return L((l,w)=>{const O=`$debounce$${w}`,m=`$debounce$result$${w}`;return function(...d){this[m]||(this[m]=u?u():void 0),clearTimeout(this[O]),y&&(this[m]=y(this[m],...d),d=[this[m]]),this[O]=setTimeout(()=>{l.apply(this,d),this[m]=u?u():void 0},N)}})}e.$Ug=R;function A(N,y,u){return L((l,w)=>{const O=`$throttle$timer$${w}`,m=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,b=`$throttle$pending$${w}`;return function(...k){if(this[m]||(this[m]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[m]=y(this[m],...k)),this[b])return;const $=this[d]+N;$<=Date.now()?(this[d]=Date.now(),l.apply(this,[this[m]]),this[m]=u?u():void 0):(this[b]=!0,this[O]=setTimeout(()=>{this[b]=!1,this[d]=Date.now(),l.apply(this,[this[m]]),this[m]=u?u():void 0},$-Date.now()))}})}e.$Vg=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zb=e.$yb=e.$xb=e.$wb=e.ok=void 0;function j(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=j;function R(u,l="Unreachable"){throw new Error(l)}e.$wb=R;function A(u){if(!u)throw new L.$bb("Assertion Failed")}e.$xb=A;function N(u){if(!u()){debugger;u(),(0,L.$Y)(new L.$bb("Assertion Failed"))}}e.$yb=N;function y(u,l){let w=0;for(;w<u.length-1;){const O=u[w],m=u[w+1];if(!l(O,m))return!1;w++}return!0}e.$zb=y}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var j;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(t,o=!1){let i=0;const s=t.length;let n="",r=0,c=16,S=0;function I(te){let ce=0,ue=0;for(;ce<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)ue=ue*16+ie-48;else if(ie>=65&&ie<=70)ue=ue*16+ie-65+10;else if(ie>=97&&ie<=102)ue=ue*16+ie-97+10;else break;i++,ce++}return ce<te&&(ue=-1),ue}function v(te){i=te,n="",r=0,c=16,S=0}function D(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return S=3,t.substring(te,i);let ce=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;ce=i}else S=3;return t.substring(te,ce)}function W(){let te="",ce=i;for(;;){if(i>=s){te+=t.substring(ce,i),S=2;break}const ue=t.charCodeAt(i);if(ue===34){te+=t.substring(ce,i),i++;break}if(ue===92){if(te+=t.substring(ce,i),i++,i>=s){S=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const V=I(4);V>=0?te+=String.fromCharCode(V):S=4;break}default:S=5}ce=i;continue}if(ue>=0&&ue<=31)if(u(ue)){te+=t.substring(ce,i),S=2;break}else S=6;i++}return te}function _(){if(n="",S=0,r=i,i>=s)return r=s,c=17;let te=t.charCodeAt(i);if(y(te)){do i++,n+=String.fromCharCode(te),te=t.charCodeAt(i);while(y(te));return c=15}if(u(te))return i++,n+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),c=14;switch(te){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,n=W(),c=10;case 47:{const ce=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!u(t.charCodeAt(i));)i++;return n=t.substring(ce,i),c=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=s-1;let ie=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,S=1),n=t.substring(ce,i),c=13}return n+=String.fromCharCode(te),i++,c=16}case 45:if(n+=String.fromCharCode(te),i++,i===s||!l(t.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=D(),c=11;default:for(;i<s&&x(te);)i++,te=t.charCodeAt(i);if(r!==i){switch(n=t.substring(r,i),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(te),i++,c=16}}function x(te){if(y(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let te;do te=_();while(te>=12&&te<=15);return te}return{setPosition:v,getPosition:()=>i,scan:o?le:_,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>S}}e.$wm=N;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function O(t,o){const i=[],s=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function S(I,v,D,W){r.value=I,r.offset=v,r.length=D,r.type=W,r.colonOffset=void 0,n=r}try{P(t,{onObjectBegin:(I,v)=>{if(o<=I)throw s;n=void 0,c=o>I,i.push("")},onObjectProperty:(I,v,D)=>{if(o<v||(S(I,v,D,"property"),i[i.length-1]=I,o<=v+D))throw s},onObjectEnd:(I,v)=>{if(o<=I)throw s;n=void 0,i.pop()},onArrayBegin:(I,v)=>{if(o<=I)throw s;n=void 0,i.push(0)},onArrayEnd:(I,v)=>{if(o<=I)throw s;n=void 0,i.pop()},onLiteralValue:(I,v,D)=>{if(o<v||(S(I,v,D,E(I)),o<=v+D))throw s},onSeparator:(I,v,D)=>{if(o<=v)throw s;if(I===":"&&n&&n.type==="property")n.colonOffset=v,c=!1,n=void 0;else if(I===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(c=!0,i[i.length-1]=""),n=void 0}}})}catch(I){if(I!==s)throw I}return{path:i,previousNode:n,isAtPropertyKey:c,matches:I=>{let v=0;for(let D=0;v<I.length&&D<i.length;D++)if(I[v]===i[D]||I[v]==="*")v++;else if(I[v]!=="**")return!1;return v===I.length}}}e.$xm=O;function m(t,o=[],i=A.DEFAULT){let s=null,n=[];const r=[];function c(I){Array.isArray(n)?n.push(I):s!==null&&(n[s]=I)}return P(t,{onObjectBegin:()=>{const I={};c(I),r.push(n),n=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const I=[];c(I),r.push(n),n=I,s=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:c,onError:(I,v,D)=>{o.push({error:I,offset:v,length:D})}},i),n[0]}e.$ym=m;function d(t,o=[],i=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){s.type==="property"&&(s.length=I-s.offset,s=s.parent)}function r(I){return s.children.push(I),I}P(t,{onObjectBegin:I=>{s=r({type:"object",offset:I,length:-1,parent:s,children:[]})},onObjectProperty:(I,v,D)=>{s=r({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:I,offset:v,length:D,parent:s})},onObjectEnd:(I,v)=>{s.length=I+v-s.offset,s=s.parent,n(I+v)},onArrayBegin:(I,v)=>{s=r({type:"array",offset:I,length:-1,parent:s,children:[]})},onArrayEnd:(I,v)=>{s.length=I+v-s.offset,s=s.parent,n(I+v)},onLiteralValue:(I,v,D)=>{r({type:E(I),offset:v,length:D,parent:s,value:I}),n(v+D)},onSeparator:(I,v,D)=>{s.type==="property"&&(I===":"?s.colonOffset=v:I===","&&n(v))},onError:(I,v,D)=>{o.push({error:I,offset:v,length:D})}},i);const S=s.children[0];return S&&delete S.parent,S}e.$zm=d;function b(t,o){if(!t)return;let i=t;for(const s of o)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===s){i=r.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.$Am=b;function k(t){if(!t.parent||!t.parent.children)return[];const o=k(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;o.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&o.push(i)}return o}e.$Bm=k;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const o=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(o[i.children[0].value]=$(s))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Cm=$;function f(t,o,i=!1){return o>=t.offset&&o<t.offset+t.length||i&&o===t.offset+t.length}e.$Dm=f;function h(t,o,i=!1){if(f(t,o,i)){const s=t.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=o;n++){const r=h(s[n],o,i);if(r)return r}return t}}e.$Em=h;function P(t,o,i=A.DEFAULT){const s=N(t,!1);function n(Z){return Z?()=>Z(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(Z){return Z?Q=>Z(Q,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=n(o.onObjectBegin),S=r(o.onObjectProperty),I=n(o.onObjectEnd),v=n(o.onArrayBegin),D=n(o.onArrayEnd),W=r(o.onLiteralValue),_=r(o.onSeparator),x=n(o.onComment),le=r(o.onError),te=i&&i.disallowComments,ce=i&&i.allowTrailingComma;function ue(){for(;;){const Z=s.scan();switch(s.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Z){case 12:case 13:te?ie(10):x();break;case 16:ie(1);break;case 15:case 14:break;default:return Z}}}function ie(Z,Q=[],U=[]){if(le(Z),Q.length+U.length>0){let M=s.getToken();for(;M!==17;){if(Q.indexOf(M)!==-1){ue();break}else if(U.indexOf(M)!==-1)break;M=ue()}}}function V(Z){const Q=s.getTokenValue();return Z?W(Q):S(Q),ue(),!0}function G(){switch(s.getToken()){case 11:{let Z=0;try{Z=JSON.parse(s.getTokenValue()),typeof Z!="number"&&(ie(2),Z=0)}catch{ie(2)}W(Z);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ue(),!0}function F(){return s.getToken()!==10?(ie(3,[],[2,5]),!1):(V(!1),s.getToken()===6?(_(":"),ue(),Y()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function C(){c(),ue();let Z=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Z||ie(4,[],[]),_(","),ue(),s.getToken()===2&&ce)break}else Z&&ie(6,[],[]);F()||ie(4,[],[2,5]),Z=!0}return I(),s.getToken()!==2?ie(7,[2],[]):ue(),!0}function B(){v(),ue();let Z=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Z||ie(4,[],[]),_(","),ue(),s.getToken()===4&&ce)break}else Z&&ie(6,[],[]);Y()||ie(4,[],[4,5]),Z=!0}return D(),s.getToken()!==4?ie(8,[4],[]):ue(),!0}function Y(){switch(s.getToken()){case 3:return B();case 1:return C();case 10:return V(!0);default:return G()}}return ue(),s.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):Y()?(s.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Fm=P;function p(t,o){const i=N(t),s=[];let n,r=0,c;do switch(c=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:r!==c&&s.push(t.substring(r,c)),o!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,o)),r=i.getPosition();break}while(n!==17);return s.join("")}e.$Gm=p;function E(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Hm=E}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.$wl=e.rot=e.$ul=void 0;function L(y,u,l){return Math.min(Math.max(y,u),l)}e.$ul=L;function j(y,u){return(u+y%u)%u}e.rot=j;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$wl=R;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$xl=A;class N{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const l=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$yl=N}),function(){function J(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function N(u){A.push(u,Date.now())}function y(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:N,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(R+N.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=L(j))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var j in L)(typeof exports=="object"?exports:J)[j]=L[j]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(j){if(e[j])return e[j].exports;var R=e[j]={i:j,l:!1,exports:{}};return J[j].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(j,R,A){L.o(j,R)||Object.defineProperty(j,R,{enumerable:!0,get:A})},L.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},L.t=function(j,R){if(1&R&&(j=L(j)),8&R||4&R&&typeof j=="object"&&j&&j.__esModule)return j;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:j}),2&R&&typeof j!="string")for(var N in j)L.d(A,N,function(y){return j[y]}.bind(null,N));return A},L.n=function(j){var R=j&&j.__esModule?function(){return j.default}:function(){return j};return L.d(R,"a",R),R},L.o=function(j,R){return Object.prototype.hasOwnProperty.call(j,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(j){var R;e=J.exports=U,R=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],u=e.src=[],l=0,w=l++;u[w]="0|[1-9]\\d*";var O=l++;u[O]="[0-9]+";var m=l++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=l++;u[d]="("+u[w]+")\\.("+u[w]+")\\.("+u[w]+")";var b=l++;u[b]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var k=l++;u[k]="(?:"+u[w]+"|"+u[m]+")";var $=l++;u[$]="(?:"+u[O]+"|"+u[m]+")";var f=l++;u[f]="(?:-("+u[k]+"(?:\\."+u[k]+")*))";var h=l++;u[h]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var P=l++;u[P]="[0-9A-Za-z-]+";var p=l++;u[p]="(?:\\+("+u[P]+"(?:\\."+u[P]+")*))";var E=l++,t="v?"+u[d]+u[f]+"?"+u[p]+"?";u[E]="^"+t+"$";var o="[v=\\s]*"+u[b]+u[h]+"?"+u[p]+"?",i=l++;u[i]="^"+o+"$";var s=l++;u[s]="((?:<|>)?=?)";var n=l++;u[n]=u[O]+"|x|X|\\*";var r=l++;u[r]=u[w]+"|x|X|\\*";var c=l++;u[c]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var S=l++;u[S]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var I=l++;u[I]="^"+u[s]+"\\s*"+u[c]+"$";var v=l++;u[v]="^"+u[s]+"\\s*"+u[S]+"$";var D=l++;u[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=l++;u[W]="(?:~>?)";var _=l++;u[_]="(\\s*)"+u[W]+"\\s+",y[_]=new RegExp(u[_],"g");var x=l++;u[x]="^"+u[W]+u[c]+"$";var le=l++;u[le]="^"+u[W]+u[S]+"$";var te=l++;u[te]="(?:\\^)";var ce=l++;u[ce]="(\\s*)"+u[te]+"\\s+",y[ce]=new RegExp(u[ce],"g");var ue=l++;u[ue]="^"+u[te]+u[c]+"$";var ie=l++;u[ie]="^"+u[te]+u[S]+"$";var V=l++;u[V]="^"+u[s]+"\\s*("+o+")$|^$";var G=l++;u[G]="^"+u[s]+"\\s*("+t+")$|^$";var F=l++;u[F]="(\\s*)"+u[s]+"\\s*("+o+"|"+u[c]+")",y[F]=new RegExp(u[F],"g");var C=l++;u[C]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var B=l++;u[B]="^\\s*("+u[S]+")\\s+-\\s+("+u[S]+")\\s*$";var Y=l++;u[Y]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)R(Z,u[Z]),y[Z]||(y[Z]=new RegExp(u[Z]));function Q(q,K){if(q instanceof U)return q;if(typeof q!="string"||q.length>A||!(K?y[i]:y[E]).test(q))return null;try{return new U(q,K)}catch{return null}}function U(q,K){if(q instanceof U){if(q.loose===K)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof U))return new U(q,K);R("SemVer",q,K),this.loose=K;var ee=q.trim().match(K?y[i]:y[E]);if(!ee)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ye=+ge;if(ye>=0&&ye<N)return ye}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Q,e.valid=function(q,K){var ee=Q(q,K);return ee?ee.version:null},e.clean=function(q,K){var ee=Q(q.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(q){return R("SemVer.compare",this.version,this.loose,q),q instanceof U||(q=new U(q,this.loose)),this.compareMain(q)||this.comparePre(q)},U.prototype.compareMain=function(q){return q instanceof U||(q=new U(q,this.loose)),a(this.major,q.major)||a(this.minor,q.minor)||a(this.patch,q.patch)},U.prototype.comparePre=function(q){if(q instanceof U||(q=new U(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=q.prerelease[K];if(R("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return a(ee,ge)}while(++K)},U.prototype.inc=function(q,K){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new U(q,ee).inc(K,ge).version}catch{return null}},e.diff=function(q,K){if(X(q,K))return null;var ee=Q(q),ge=Q(K);if(ee.prerelease.length||ge.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return ye},e.compareIdentifiers=a;var M=/^[0-9]+$/;function a(q,K){var ee=M.test(q),ge=M.test(K);return ee&&ge&&(q=+q,K=+K),ee&&!ge?-1:ge&&!ee?1:q<K?-1:q>K?1:0}function g(q,K,ee){return new U(q,ee).compare(new U(K,ee))}function z(q,K,ee){return g(q,K,ee)>0}function T(q,K,ee){return g(q,K,ee)<0}function X(q,K,ee){return g(q,K,ee)===0}function H(q,K,ee){return g(q,K,ee)!==0}function ae(q,K,ee){return g(q,K,ee)>=0}function oe(q,K,ee){return g(q,K,ee)<=0}function pe(q,K,ee,ge){var ye;switch(K){case"===":typeof q=="object"&&(q=q.version),typeof ee=="object"&&(ee=ee.version),ye=q===ee;break;case"!==":typeof q=="object"&&(q=q.version),typeof ee=="object"&&(ee=ee.version),ye=q!==ee;break;case"":case"=":case"==":ye=X(q,ee,ge);break;case"!=":ye=H(q,ee,ge);break;case">":ye=z(q,ee,ge);break;case">=":ye=ae(q,ee,ge);break;case"<":ye=T(q,ee,ge);break;case"<=":ye=oe(q,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ye}function de(q,K){if(q instanceof de){if(q.loose===K)return q;q=q.value}if(!(this instanceof de))return new de(q,K);R("comparator",q,K),this.loose=K,this.parse(q),this.semver===me?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(q,K){return a(K,q)},e.major=function(q,K){return new U(q,K).major},e.minor=function(q,K){return new U(q,K).minor},e.patch=function(q,K){return new U(q,K).patch},e.compare=g,e.compareLoose=function(q,K){return g(q,K,!0)},e.rcompare=function(q,K,ee){return g(K,q,ee)},e.sort=function(q,K){return q.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(q,K){return q.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=z,e.lt=T,e.eq=X,e.neq=H,e.gte=ae,e.lte=oe,e.cmp=pe,e.Comparator=de;var me={};function fe(q,K){if(q instanceof fe)return q.loose===K?q:new fe(q.raw,K);if(q instanceof de)return new fe(q.value,K);if(!(this instanceof fe))return new fe(q,K);if(this.loose=K,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function he(q){return!q||q.toLowerCase()==="x"||q==="*"}function we(q,K,ee,ge,ye,De,ke,Le,Ie,Ae,Ue,Oe,Ne){return((K=he(ee)?"":he(ge)?">="+ee+".0.0":he(ye)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Ue+"-"+Oe:"<="+Le)).trim()}function be(q,K){for(var ee=0;ee<q.length;ee++)if(!q[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<q.length;ee++)if(R(q[ee].semver),q[ee].semver!==me&&q[ee].semver.prerelease.length>0){var ge=q[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Se(q,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(q)}function ze(q,K,ee,ge){var ye,De,ke,Le,Ie;switch(q=new U(q,ge),K=new fe(K,ge),ee){case">":ye=z,De=oe,ke=T,Le=">",Ie=">=";break;case"<":ye=T,De=ae,ke=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(q,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var Ue=K.set[Ae],Oe=null,Ne=null;if(Ue.forEach(function(je){je.semver===me&&(je=new de(">=0.0.0")),Oe=Oe||je,Ne=Ne||je,ye(je.semver,Oe.semver,ge)?Oe=je:ke(je.semver,Ne.semver,ge)&&(Ne=je)}),Oe.operator===Le||Oe.operator===Ie||(!Ne.operator||Ne.operator===Le)&&De(q,Ne.semver)||Ne.operator===Ie&&ke(q,Ne.semver))return!1}return!0}de.prototype.parse=function(q){var K=this.loose?y[V]:y[G],ee=q.match(K);if(!ee)throw new TypeError("Invalid comparator: "+q);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(q){return R("Comparator.test",q,this.loose),this.semver===me||(typeof q=="string"&&(q=new U(q,this.loose)),pe(q,this.operator,this.semver,this.loose))},de.prototype.intersects=function(q,K){if(!(q instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(q.value,K),Se(this.value,ee,K);if(q.operator==="")return ee=new fe(this.value,K),Se(q.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),De=this.semver.version===q.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Le=pe(this.semver,"<",q.semver,K)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ie=pe(this.semver,">",q.semver,K)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return ge||ye||De&&ke||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(q){var K=this.loose;q=q.trim(),R("range",q,K);var ee=K?y[B]:y[C];q=q.replace(ee,we),R("hyphen replace",q),q=q.replace(y[F],"$1$2$3"),R("comparator trim",q,y[F]),q=(q=(q=q.replace(y[_],"$1~")).replace(y[ce],"$1^")).split(/\s+/).join(" ");var ge=K?y[V]:y[G],ye=q.split(" ").map(function(De){return function(ke,Le){return R("comp",ke),ke=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ne){R("caret",Oe,Ne);var je=Ne?y[ie]:y[ue];return Oe.replace(je,function(Ce,ve,Ee,Pe,Re){var Me;return R("caret",Oe,Ce,ve,Ee,Pe,Re),he(ve)?Me="":he(Ee)?Me=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Me=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Me=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),Me=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",Me),Me})}(Ue,Ae)}).join(" ")}(ke,Le),R("caret",ke),ke=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ne){var je=Ne?y[le]:y[x];return Oe.replace(je,function(Ce,ve,Ee,Pe,Re){var Me;return R("tilde",Oe,Ce,ve,Ee,Pe,Re),he(ve)?Me="":he(Ee)?Me=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Me=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Me=">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0"):Me=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",Me),Me})}(Ue,Ae)}).join(" ")}(ke,Le),R("tildes",ke),ke=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Ue){return function(Oe,Ne){Oe=Oe.trim();var je=Ne?y[v]:y[I];return Oe.replace(je,function(Ce,ve,Ee,Pe,Re,Me){R("xRange",Oe,Ce,ve,Ee,Pe,Re,Me);var Ve=he(Ee),Te=Ve||he(Pe),Fe=Te||he(Re);return ve==="="&&Fe&&(ve=""),Ve?Ce=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Fe?(Te&&(Pe=0),Fe&&(Re=0),ve===">"?(ve=">=",Te?(Ee=+Ee+1,Pe=0,Re=0):Fe&&(Pe=+Pe+1,Re=0)):ve==="<="&&(ve="<",Te?Ee=+Ee+1:Pe=+Pe+1),Ce=ve+Ee+"."+Pe+"."+Re):Te?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Fe&&(Ce=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Ce),Ce})}(Ue,Ae)}).join(" ")}(ke,Le),R("xrange",ke),ke=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(y[Y],"")}(ke,Le),R("stars",ke),ke}(De,K)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(ge)})),ye=ye.map(function(De){return new de(De,K)})},fe.prototype.intersects=function(q,K){if(!(q instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return q.set.some(function(ye){return ye.every(function(De){return ge.intersects(De,K)})})})})},e.toComparators=function(q,K){return new fe(q,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new U(q,this.loose));for(var K=0;K<this.set.length;K++)if(be(this.set[K],q))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(q,K,ee){var ge=null,ye=null;try{var De=new fe(K,ee)}catch{return null}return q.forEach(function(ke){De.test(ke)&&(ge&&ye.compare(ke)!==-1||(ye=new U(ge=ke,ee)))}),ge},e.minSatisfying=function(q,K,ee){var ge=null,ye=null;try{var De=new fe(K,ee)}catch{return null}return q.forEach(function(ke){De.test(ke)&&(ge&&ye.compare(ke)!==1||(ye=new U(ge=ke,ee)))}),ge},e.validRange=function(q,K){try{return new fe(q,K).range||"*"}catch{return null}},e.ltr=function(q,K,ee){return ze(q,K,"<",ee)},e.gtr=function(q,K,ee){return ze(q,K,">",ee)},e.outside=ze,e.prerelease=function(q,K){var ee=Q(q,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(q,K,ee){return q=new fe(q,ee),K=new fe(K,ee),q.intersects(K)},e.coerce=function(q){if(q instanceof U)return q;if(typeof q!="string")return null;var K=q.match(y[D]);return K==null?null:Q((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,L(1))},function(J,e){var L,j,R=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function y($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{j=typeof clearTimeout=="function"?clearTimeout:N}catch{j=N}})();var u,l=[],w=!1,O=-1;function m(){w&&u&&(w=!1,u.length?l=u.concat(l):O=-1,l.length&&d())}function d(){if(!w){var $=y(m);w=!0;for(var f=l.length;f;){for(u=l,l=[];++O<f;)u&&u[O].run();O=-1,f=l.length}u=null,w=!1,function(h){if(j===clearTimeout)return clearTimeout(h);if((j===N||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(h);try{j(h)}catch{try{return j.call(null,h)}catch{return j.call(this,h)}}}($)}}function b($,f){this.fun=$,this.array=f}function k(){}R.nextTick=function($){var f=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)f[h-1]=arguments[h];l.push(new b($,f)),l.length!==1||w||y(d)},b.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=k,R.addListener=k,R.once=k,R.off=k,R.removeListener=k,R.removeAllListeners=k,R.emit=k,R.prependListener=k,R.prependOnceListener=k,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class j{constructor(y,u,l){this.level=y,this.key=u,this.value=l,this.forward=[]}}const R=void 0;class A{constructor(y,u=2**16){this.comparator=y,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new j(this.c,R,R)}get size(){return this.f}clear(){this.e=new j(this.c,R,R)}has(y){return!!A.g(this,y,this.comparator)}get(y){return A.g(this,y,this.comparator)?.value}set(y,u){return A.h(this,y,u,this.comparator)&&(this.f+=1),this}delete(y){const u=A.k(this,y,this.comparator);return u&&(this.f-=1),u}forEach(y,u){let l=this.e.forward[0];for(;l;)y.call(u,l.value,l.key,this),l=l.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this.e.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this.e.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this.e.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",u=this.e.forward[0];for(;u;)y+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return y}static g(y,u,l){let w=y.e;for(let O=y.d-1;O>=0;O--)for(;w.forward[O]&&l(w.forward[O].key,u)<0;)w=w.forward[O];if(w=w.forward[0],w&&l(w.key,u)===0)return w}static h(y,u,l,w){const O=[];let m=y.e;for(let d=y.d-1;d>=0;d--){for(;m.forward[d]&&w(m.forward[d].key,u)<0;)m=m.forward[d];O[d]=m}if(m=m.forward[0],m&&w(m.key,u)===0)return m.value=l,!1;{const d=A.j(y);if(d>y.d){for(let b=y.d;b<d;b++)O[b]=y.e;y.d=d}m=new j(d,u,l);for(let b=0;b<d;b++)m.forward[b]=O[b].forward[b],O[b].forward[b]=m;return!0}}static j(y,u=.5){let l=1;for(;Math.random()<u&&l<y.c;)l+=1;return l}static k(y,u,l){const w=[];let O=y.e;for(let m=y.d-1;m>=0;m--){for(;O.forward[m]&&l(O.forward[m].key,u)<0;)O=O.forward[m];w[m]=O}if(O=O.forward[0],!O||l(O.key,u)!==0)return!1;for(let m=0;m<y.d&&w[m].forward[m]===O;m++)w[m].forward[m]=O.forward[m];for(;y.d>0&&y.e.forward[y.d-1]===R;)y.d-=1;return!0}}e.$fr=A}),define(ne[41],re([0,1,9,2]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function R(p){const E=p;return E?typeof E.read=="function":!1}e.$pc=R;function A(p){const E=p;return E?[E.on,E.pause,E.resume,E.destroy].every(t=>typeof t=="function"):!1}e.$qc=A;function N(p){const E=p;return E?A(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$rc=N;function y(p,E){return new u(p,E)}e.$sc=y;class u{constructor(E,t){this.e=E,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(t=>t(E))}h(E){this.c.error.length===0?(0,L.$Y)(E):this.c.error.slice(0).forEach(t=>t(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,t){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(E,t){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const i=o.indexOf(t);i>=0&&o.splice(i,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(p,E){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return E(t)}e.$tc=l;function w(p,E,t){const o=[];let i;for(;(i=p.read())!==null&&o.length<t;)o.push(i);return i===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return p.read()}}}e.$uc=w;function O(p,E){return new Promise((t,o)=>{const i=[];m(p,{onData:s=>{E&&i.push(s)},onError:s=>{E?o(s):t(void 0)},onEnd:()=>{t(E?E(i):void 0)}})})}e.$vc=O;function m(p,E,t){p.on("error",o=>{t?.isCancellationRequested||E.onError(o)}),p.on("end",()=>{t?.isCancellationRequested||E.onEnd()}),p.on("data",o=>{t?.isCancellationRequested||E.onData(o)})}e.$wc=m;function d(p,E){return new Promise((t,o)=>{const i=new j.$kb,s=[],n=S=>{if(s.push(S),s.length>E)return i.dispose(),p.pause(),t({stream:p,buffer:s,ended:!1})},r=S=>o(S),c=()=>t({stream:p,buffer:s,ended:!0});i.add((0,j.$jb)(()=>p.removeListener("error",r))),p.on("error",r),i.add((0,j.$jb)(()=>p.removeListener("end",c))),p.on("end",c),i.add((0,j.$jb)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$xc=d;function b(p,E){const t=y(E);return t.end(p),t}e.$yc=b;function k(){const p=y(()=>{throw new Error("not supported")});return p.end(),p}e.$zc=k;function $(p){let E=!1;return{read:()=>E?null:(E=!0,p)}}e.$Ac=$;function f(p,E,t){const o=y(t);return m(p,{onData:i=>o.write(E.data(i)),onError:i=>o.error(E.error?E.error(i):i),onEnd:()=>o.end()}),o}e.$Bc=f;function h(p,E,t){let o=!1;return{read:()=>{const i=E.read();return o?i:(o=!0,i!==null?t([p,i]):p)}}}e.$Cc=h;function P(p,E,t){let o=!1;const i=y(t);return m(E,{onData:s=>o?i.write(s):(o=!0,i.write(t([p,s]))),onError:s=>i.error(s),onEnd:()=>{o||(o=!0,i.write(p)),i.end()}}),i}e.$Dc=P}),define(ne[14],re([0,1,164,41]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const R=typeof Buffer<"u",A=new L.$T(()=>new Uint8Array(256));let N,y;class u{static alloc(D){return R?new u(Buffer.allocUnsafe(D)):new u(new Uint8Array(D))}static wrap(D){return R&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new u(D)}static fromString(D,W){return!(W?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(D)):(N||(N=new TextEncoder),new u(N.encode(D)))}static fromByteArray(D){const W=u.alloc(D.length);for(let _=0,x=D.length;_<x;_++)W.buffer[_]=D[_];return W}static concat(D,W){if(typeof W>"u"){W=0;for(let le=0,te=D.length;le<te;le++)W+=D[le].byteLength}const _=u.alloc(W);let x=0;for(let le=0,te=D.length;le<te;le++){const ce=D[le];_.set(ce,x),x+=ce.byteLength}return _}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=u.alloc(this.byteLength);return D.set(this),D}toString(){return R?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(D,W){return new u(this.buffer.subarray(D,W))}set(D,W){if(D instanceof u)this.buffer.set(D.buffer,W);else if(D instanceof Uint8Array)this.buffer.set(D,W);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),W);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return m(this.buffer,D)}writeUInt32BE(D,W){d(this.buffer,D,W)}readUInt32LE(D){return b(this.buffer,D)}writeUInt32LE(D,W){k(this.buffer,D,W)}readUInt8(D){return $(this.buffer,D)}writeUInt8(D,W){f(this.buffer,D,W)}indexOf(D,W=0){return l(this.buffer,D instanceof u?D.buffer:D,W)}}e.$Ec=u;function l(v,D,W=0){const _=D.byteLength,x=v.byteLength;if(_===0)return 0;if(_===1)return v.indexOf(D[0]);if(_>x-W)return-1;const le=A.value;le.fill(D.length);for(let ie=0;ie<D.length;ie++)le[D[ie]]=D.length-ie-1;let te=W+D.length-1,ce=te,ue=-1;for(;te<x;)if(v[te]===D[ce]){if(ce===0){ue=te;break}te--,ce--}else te+=Math.max(D.length-ce,le[v[te]]),ce=D.length-1;return ue}e.$Fc=l;function w(v,D){return v[D+0]<<0>>>0|v[D+1]<<8>>>0}e.$Gc=w;function O(v,D,W){v[W+0]=D&255,D=D>>>8,v[W+1]=D&255}e.$Hc=O;function m(v,D){return v[D]*2**24+v[D+1]*2**16+v[D+2]*2**8+v[D+3]}e.$Ic=m;function d(v,D,W){v[W+3]=D,D=D>>>8,v[W+2]=D,D=D>>>8,v[W+1]=D,D=D>>>8,v[W]=D}e.$Jc=d;function b(v,D){return v[D+0]<<0>>>0|v[D+1]<<8>>>0|v[D+2]<<16>>>0|v[D+3]<<24>>>0}e.$Kc=b;function k(v,D,W){v[W+0]=D&255,D=D>>>8,v[W+1]=D&255,D=D>>>8,v[W+2]=D&255,D=D>>>8,v[W+3]=D&255}e.$Lc=k;function $(v,D){return v[D]}e.$Mc=$;function f(v,D,W){v[W]=D}e.$Nc=f;function h(v){return j.$tc(v,D=>u.concat(D))}e.$Oc=h;function P(v){return j.$Ac(v)}e.$Pc=P;function p(v){return j.$vc(v,D=>u.concat(D))}e.$Qc=p;async function E(v){return v.ended?u.concat(v.buffer):u.concat([...v.buffer,await p(v.stream)])}e.$Rc=E;function t(v){return j.$yc(v,D=>u.concat(D))}e.$Sc=t;function o(v){return j.$Bc(v,{data:D=>typeof D=="string"?u.fromString(D):u.wrap(D)},D=>u.concat(D))}e.$Tc=o;function i(v){return j.$sc(D=>u.concat(D),v)}e.$Uc=i;function s(v,D){return j.$Cc(v,D,W=>u.concat(W))}e.$Vc=s;function n(v,D){return j.$Dc(v,D,W=>u.concat(W))}e.$Wc=n;function r(v){let D=0,W=0,_=0;const x=new Uint8Array(Math.floor(v.length/4*3)),le=ce=>{switch(W){case 3:x[_++]=D|ce,W=0;break;case 2:x[_++]=D|ce>>>2,D=ce<<6,W=3;break;case 1:x[_++]=D|ce>>>4,D=ce<<4,W=2;break;default:D=ce<<2,W=1}};for(let ce=0;ce<v.length;ce++){const ue=v.charCodeAt(ce);if(ue>=65&&ue<=90)le(ue-65);else if(ue>=97&&ue<=122)le(ue-97+26);else if(ue>=48&&ue<=57)le(ue-48+52);else if(ue===43||ue===45)le(62);else if(ue===47||ue===95)le(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${v[ce]}`)}}const te=_;for(;W>0;)le(0);return u.wrap(x).slice(0,te)}e.$Xc=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:v},D=!0,W=!1){const _=W?S:c;let x="";const le=v.byteLength%3;let te=0;for(;te<v.byteLength-le;te+=3){const ce=v[te+0],ue=v[te+1],ie=v[te+2];x+=_[ce>>>2],x+=_[(ce<<4|ue>>>4)&63],x+=_[(ue<<2|ie>>>6)&63],x+=_[ie&63]}if(le===1){const ce=v[te+0];x+=_[ce>>>2],x+=_[ce<<4&63],D&&(x+="==")}else if(le===2){const ce=v[te+0],ue=v[te+1];x+=_[ce>>>2],x+=_[(ce<<4|ue>>>4)&63],x+=_[ue<<2&63],D&&(x+="=")}return x}e.$Yc=I}),define(ne[42],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function j(f){return R(f,0)}e.$di=j;function R(f,h){switch(typeof f){case"object":return f===null?A(349,h):Array.isArray(f)?u(f,h):l(f,h);case"string":return y(f,h);case"boolean":return N(f,h);case"number":return A(f,h);case"undefined":return A(937,h);default:return A(617,h)}}e.$ei=R;function A(f,h){return(h<<5)-h+f|0}e.$fi=A;function N(f,h){return A(f?433:863,h)}function y(f,h){h=A(149417,h);for(let P=0,p=f.length;P<p;P++)h=A(f.charCodeAt(P),h);return h}e.$gi=y;function u(f,h){return h=A(104579,h),f.reduce((P,p)=>R(p,P),h)}function l(f,h){return h=A(181387,h),Object.keys(f).sort().reduce((P,p)=>(P=y(p,P),R(f[p],P)),h)}class w{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=R(h,this.g),this.g}}e.$hi=w;var O;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function m(f,h,P=32){const p=P-h,E=~((1<<p)-1);return(f<<h|(E&f)>>>p)>>>0}function d(f,h=0,P=f.byteLength,p=0){for(let E=0;E<P;E++)f[h+E]=p}function b(f,h,P="0"){for(;f.length<h;)f=P+f;return f}function k(f,h=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(P=>P.toString(16).padStart(2,"0")).join(""):b((f>>>0).toString(16),h/4)}e.$ii=k;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const P=h.length;if(P===0)return;const p=this.p;let E=this.r,t=this.u,o,i;for(t!==0?(o=t,i=-1,t=0):(o=h.charCodeAt(0),i=0);;){let s=o;if(L.$Pd(o))if(i+1<P){const n=h.charCodeAt(i+1);L.$Qd(n)?(i++,s=L.$Rd(o,n)):s=65533}else{t=o;break}else L.$Qd(o)&&(s=65533);if(E=this.w(p,E,s),i++,i<P)o=h.charCodeAt(i);else break}this.r=E,this.u=t}w(h,P,p){return p<128?h[P++]=p:p<2048?(h[P++]=192|(p&1984)>>>6,h[P++]=128|(p&63)>>>0):p<65536?(h[P++]=224|(p&61440)>>>12,h[P++]=128|(p&4032)>>>6,h[P++]=128|(p&63)>>>0):(h[P++]=240|(p&1835008)>>>18,h[P++]=128|(p&258048)>>>12,h[P++]=128|(p&4032)>>>6,h[P++]=128|(p&63)>>>0),P>=64&&(this.y(),P-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),k(this.h)+k(this.l)+k(this.m)+k(this.n)+k(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=$.g,P=this.q;for(let c=0;c<64;c+=4)h.setUint32(c,P.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,m(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let p=this.h,E=this.l,t=this.m,o=this.n,i=this.o,s,n,r;for(let c=0;c<80;c++)c<20?(s=E&t|~E&o,n=1518500249):c<40?(s=E^t^o,n=1859775393):c<60?(s=E&t|E&o|t&o,n=2400959708):(s=E^t^o,n=3395469782),r=m(p,5)+s+i+n+h.getUint32(c*4,!1)&4294967295,i=o,o=t,t=m(E,30),E=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+E&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+i&4294967295}}e.$ji=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(j||(j={})),function(R){const A="error",N="warning",y="warn",u="info",l="ignore";function w(m){return m?L.$Ld(A,m)?R.Error:L.$Ld(N,m)||L.$Ld(y,m)?R.Warning:L.$Ld(u,m)?R.Info:R.Ignore:R.Ignore}R.fromValue=w;function O(m){switch(m){case R.Error:return A;case R.Warning:return N;case R.Info:return u;default:return l}}R.toString=O}(j||(j={})),e.default=j}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function j(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const h=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([P,p])=>{h[P]=p&&typeof p=="object"?j(p):p}),h}e.$Im=j;function R(f){if(!f||typeof f!="object")return f;const h=[f];for(;h.length>0;){const P=h.shift();Object.freeze(P);for(const p in P)if(A.call(P,p)){const E=P[p];typeof E=="object"&&!Object.isFrozen(E)&&!(0,L.$le)(E)&&h.push(E)}}return f}e.$Jm=R;const A=Object.prototype.hasOwnProperty;function N(f,h){return y(f,h,new Set)}e.$Km=N;function y(f,h,P){if((0,L.$re)(f))return f;const p=h(f);if(typeof p<"u")return p;if(Array.isArray(f)){const E=[];for(const t of f)E.push(y(t,h,P));return E}if((0,L.$ke)(f)){if(P.has(f))throw new Error("Cannot clone recursive data-structure");P.add(f);const E={};for(const t in f)A.call(f,t)&&(E[t]=y(f[t],h,P));return P.delete(f),E}return f}function u(f,h,P=!0){return(0,L.$ke)(f)?((0,L.$ke)(h)&&Object.keys(h).forEach(p=>{p in f?P&&((0,L.$ke)(f[p])&&(0,L.$ke)(h[p])?u(f[p],h[p],P):f[p]=h[p]):f[p]=h[p]}),f):h}e.$Lm=u;function l(f,h){if(f===h)return!0;if(f==null||h===null||h===void 0||typeof f!=typeof h||typeof f!="object"||Array.isArray(f)!==Array.isArray(h))return!1;let P,p;if(Array.isArray(f)){if(f.length!==h.length)return!1;for(P=0;P<f.length;P++)if(!l(f[P],h[P]))return!1}else{const E=[];for(p in f)E.push(p);E.sort();const t=[];for(p in h)t.push(p);if(t.sort(),!l(E,t))return!1;for(P=0;P<E.length;P++)if(!l(f[E[P]],h[E[P]]))return!1}return!0}e.$Mm=l;function w(f){const h=new Set;return JSON.stringify(f,(P,p)=>{if((0,L.$ke)(p)||Array.isArray(p)){if(h.has(p))return"[Circular]";h.add(p)}return p})}e.$Nm=w;function O(f,h){const P=Object.create(null);return!f||!h||Object.keys(h).forEach(E=>{const t=f[E],o=h[E];l(t,o)||(P[E]=o)}),P}e.$Om=O;function m(f,h){const P=h.toLowerCase(),p=Object.keys(f).find(E=>E.toLowerCase()===P);return p?f[p]:f[h]}e.$Pm=m;function d(f,h){const P=Object.create(null);for(const[p,E]of Object.entries(f))h(p,E)&&(P[p]=E);return P}e.$Qm=d;function b(f){let h=[];for(;Object.prototype!==f;)h=h.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return h}e.$Rm=b;function k(f){const h=[];for(const P of b(f))typeof f[P]=="function"&&h.push(P);return h}e.$Sm=k;function $(f,h){const P=E=>function(){const t=Array.prototype.slice.call(arguments,0);return h(E,t)},p={};for(const E of f)p[E]=P(E);return p}e.$Tm=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(R){return L.test(R)}e.$2e=j,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let u=0;u<y.length;u++)y[u]=Math.floor(Math.random()*256);return y};const A=new Uint8Array(16),N=[];for(let y=0;y<256;y++)N.push(y.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l}}()}),define(ne[74],re([0,1,32]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=void 0;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(N){const y=N.replace(/\-/g,":").toLowerCase();return!j.has(y)}function A(){const N=(0,L.networkInterfaces)();for(const y in N){const u=N[y];if(u){for(const{mac:l}of u)if(R(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$tm=A}),define(ne[75],re([0,1,32,46,28,74]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0,e.$um=new class{c(l){return this.a||(this.a=j.$vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,w=0;const O=(0,L.networkInterfaces)();for(const m in O){const d=O[m];if(d)for(const{mac:b,internal:k}of d)k||(w+=1,this.c(b.toUpperCase())&&(l+=1))}this.b=w>0?l/w:0}return this.b}};let N;async function y(l){return N||(N=(async()=>await u(l)||R.$3e())()),N}e.$vm=y;async function u(l){try{const w=await new Promise((m,d)=>{J(["crypto"],m,d)}),O=(0,A.$tm)();return w.createHash("sha256").update(O,"utf8").digest("hex")}catch(w){l(w);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0;const j=60,R=j*60,A=R*24,N=A*7,y=A*30,u=A*365;function l(O,m,d,b){typeof O!="number"&&(O=O.getTime());const k=Math.round((new Date().getTime()-O)/1e3);if(k<-30)return(0,L.localize)(0,null,l(new Date().getTime()+k*1e3,!1));if(!b&&k<30)return(0,L.localize)(1,null);let $;return k<j?($=k,m?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):k<R?($=Math.floor(k/j),m?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):k<A?($=Math.floor(k/R),m?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):k<N?($=Math.floor(k/A),m?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):k<y?($=Math.floor(k/N),m?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):k<u?($=Math.floor(k/y),m?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(k/u),m?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$Sl=l;function w(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Tl=w}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[33],re([0,1,19,3,78]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function A(O,m){return m&&(O.stack||O.stacktrace)?R.localize(0,null,y(O),N(O.stack)||N(O.stacktrace)):y(O)}function N(O){return Array.isArray(O)?O.join(`
`):O}function y(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?R.localize(1,null,O.message):O.message||R.localize(2,null)}function u(O=null,m=!1){if(!O)return R.localize(3,null);if(Array.isArray(O)){const d=L.$jf(O),b=u(d[0],m);return d.length>1?R.localize(4,null,b,d.length):b}if(j.$ie(O))return O;if(O.detail){const d=O.detail;if(d.error)return A(d.error,m);if(d.exception)return A(d.exception,m)}return O.stack?A(O,m):O.message?O.message:R.localize(5,null)}e.$ai=u;function l(O){const m=O;return m instanceof Error&&Array.isArray(m.actions)}e.$bi=l;function w(O,m){let d;return typeof O=="string"?d=new Error(O):d=O,d.actions=m,d}e.$ci=w}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;function j(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$dp=j}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var j;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(j||(e.Source=j={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(y,...u){const l=u.reduce((m,d)=>(m[d]=!0,m),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(m=>!l[m]).forEach(m=>{for(let d=0;d<w.length;d++)if(m.search(w[d])!==-1){delete y[m];break}})}e.$fl=A;function N(y){y&&(delete y.DEBUG,L.$j&&delete y.DYLD_LIBRARY_PATH,L.$k&&delete y.LD_PRELOAD)}e.$gl=N}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Gp=e.$Fp=e.$Ep=void 0;function j(l){const w=l;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.$Ep=j;function R(l){const w=[];let O;try{const m=JSON.parse(l.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),O=d.__$stack),w.push(...m)}catch{w.push("Unable to log remote console arguments",l.arguments)}return{args:w,stack:O}}e.$Fp=R;function A(l){if(typeof l!="string")return A(R(l).stack);const w=l;if(w){const O=N(w),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Gp=A;function N(l){if(!l)return l;const w=l.indexOf(`
`);return w===-1?l:l.substring(0,w)}function y(l,w){const{args:O,stack:m}=R(l),d=typeof O[0]=="string"&&O.length===1;let b=N(m);b&&(b=`(${b.trim()})`);let k=[];if(typeof O[0]=="string"?b&&d?k=[`%c[${w}] %c${O[0]} %c${b}`,u("blue"),u(""),u("grey")]:k=[`%c[${w}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:k=[`%c[${w}]%`,u("blue"),...O],b&&!d&&k.push(b),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,k)}e.log=y;function u(l){return`color: ${l}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function R(u){return JSON.stringify(u,N)}e.$Wg=R;function A(u){let l=JSON.parse(u);return l=y(l),l}e.$Xg=A;function N(u,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function y(u,l=0){if(!u||l>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return j.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof L.$Ec||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let w=0;w<u.length;++w)u[w]=y(u[w],l+1);else for(const w in u)Object.hasOwnProperty.call(u,w)&&(u[w]=y(u[w],l+1))}return u}e.$Yg=y}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class N{constructor(m,d,b){this.id=m,this.dependencies=d,this.callback=b}}class y{static{this.INSTANCE=new y}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,d,b)=>{typeof m!="string"&&(b=d,d=m,m=null),(typeof d!="object"||!Array.isArray(d))&&(b=d,d=null),this.c.push(new N(m,d,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const d=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!d)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(m){return new Promise((d,b)=>{const k=document.createElement("script");k.setAttribute("async","async"),k.setAttribute("type","text/javascript");const $=()=>{k.removeEventListener("load",f),k.removeEventListener("error",h)},f=P=>{$(),d(this.c.pop())},h=P=>{$(),b(P)};k.addEventListener("load",f),k.addEventListener("error",h),this.f&&(m=this.f.createScriptURL(m)),k.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(k)})}i(m){return new Promise((d,b)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),d(this.c.pop())}catch(k){b(k)}})}async j(m){try{const d=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,k=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(m).fsPath,f=d.readFileSync($).toString(),h=k.wrap(f.replace(/^#!.*/,""));return new b.Script(h).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function w(O,m,d){if(L.$R){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[O]&&(O=l[O]);const b=`${O}/${m}`;if(u.has(b))return u.get(b);let k;if(/^\w[\w\d+.-]*:\/\//.test(b))k=b;else{const P=`${d&&!R.$o?j.$Ye:j.$Xe}/${b}`;k=j.$1e.asBrowserUri(P).toString(!0)}const $=y.INSTANCE.load(k);return u.set(b,$),$}else return await new Promise((b,k)=>{J([O],b,k)})}e.$2C=w}),define(ne[83],re([0,1,32,16,24]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=void 0;const A=/^\d+$/,N=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class O{constructor(E,t,o){this.exePath=E,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:E=!1}={}){const t=m({useAlternateBitness:p});if(!t)return null;const o=j.$8c(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let i=-1,s=null;for(const c of await R.Promises.readdir(o)){let S=-1;if(E){const v=c.indexOf("-");if(v<0)continue;const D=c.substring(0,v);if(!A.test(D)||c.substring(v+1)!=="preview")continue;S=parseInt(D,10)}else{if(!A.test(c))continue;S=parseInt(c,10)}if(S<=i)continue;const I=j.$8c(o,c,"pwsh.exe");await R.SymlinkSupport.existsFile(I)&&(s=I,i=S)}if(!s)return null;const n=t.includes("x86")?" (x86)":"",r=E?" Preview":"";return new O(s,`PowerShell${r}${n}`,!0)}async function b({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const E=j.$8c(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(E))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=p?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(E))if(t.test(i)){const s=j.$8c(E,i,"pwsh.exe");return new O(s,o)}return null}function k(){const p=j.$8c(L.homedir(),".dotnet","tools","pwsh.exe");return new O(p,".NET Core PowerShell Global Tool")}function $(){const p=j.$8c(process.env.windir,l===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(p,"Windows PowerShell",!0)}async function*f(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await b(),p&&(yield p),p=k(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await b({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*h(){for await(const p of f())await p.exists()&&(yield p)}e.$dl=h;async function P(){for await(const p of h())return p;return null}e.$el=P}),define(ne[56],re([0,1,16,13,34,55,3,24]),function(J,e,L,j,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(O=R.env){return O.comspec||"cmd.exe"}e.$hl=u;function l(O){let m=[],d=!1;const b=function(k){if(d){m.push(k);return}(!O.send(k,f=>{if(f&&console.error(f),d=!1,m.length>0){const h=m.slice(0);m=[],h.forEach(P=>b(P))}})||j.$i)&&(d=!0)};return{send:b}}e.$il=l;var w;(function(O){async function m(d,b,k){if(L.$7c(d))return d;if(b===void 0&&(b=R.cwd()),L.$$c(d)!=="."||(k===void 0&&N.$ie(R.env.PATH)&&(k=R.env.PATH.split(L.$fd)),k===void 0||k.length===0))return L.$8c(b,d);async function f(h){if(await y.Promises.exists(h)){let P;try{P=await y.Promises.stat(h)}catch(p){p.message.startsWith("EACCES")&&(P=await y.Promises.lstat(h))}return P?!P.isDirectory():!1}return!1}for(const h of k){let P;if(L.$7c(h)?P=L.$8c(h,d):P=L.$8c(b,h,d),await f(P))return P;let p=P+".com";if(await f(p)||(p=P+".exe",await f(p)))return p}return L.$8c(b,d)}O.findExecutable=m})(w||(e.win32=w={}))}),define(ne[84],re([0,1,32,13,83,56]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=void 0;async function N(O,m){return O===1?j.$i?w():A.$hl(m):u(O,m)}e.$jl=N;let y=null;function u(O,m){if(j.$k&&O===2||j.$j&&O===3)return"/bin/bash";if(!y){let d;if(j.$i)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let l=null;async function w(){return l||(l=(await(0,R.$el)()).exePath),l}});var $e=this&&this.__decorate||function(J,e,L,j){var R=arguments.length,A=R<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,L):j,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,j);else for(var y=J.length-1;y>=0;y--)(N=J[y])&&(A=(R<3?N(A):R>3?N(e,L,A):N(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,j,R,A,N,y,u,l,w,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var d;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(d||(d={}));function b(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var k;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(k||(k={}));function $(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(f||(f={}));function h(F){let C=0;for(let B=0;;B+=7){const Y=F.read(1);if(C|=(Y.buffer[0]&127)<<B,!(Y.buffer[0]&128))return C}}const P=i(0);function p(F,C){if(C===0){F.write(P);return}let B=0;for(let Z=C;Z!==0;Z=Z>>>7)B++;const Y=R.$Ec.alloc(B);for(let Z=0;C!==0;Z++)Y.buffer[Z]=C&127,C=C>>>7,C>0&&(Y.buffer[Z]|=128);F.write(Y)}class E{constructor(C){this.b=C,this.a=0}read(C){const B=this.b.slice(this.a,this.a+C);return this.a+=B.byteLength,B}}e.$Zg=E;class t{constructor(){this.a=[]}get buffer(){return R.$Ec.concat(this.a)}write(C){this.a.push(C)}}e.$1g=t;var o;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(o||(o={}));function i(F){const C=R.$Ec.alloc(1);return C.writeUInt8(F,0),C}const s={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object),Uint:i(o.Int)},n=typeof Buffer<"u";function r(F,C){if(typeof C>"u")F.write(s.Undefined);else if(typeof C=="string"){const B=R.$Ec.fromString(C);F.write(s.String),p(F,B.byteLength),F.write(B)}else if(n&&Buffer.isBuffer(C)){const B=R.$Ec.wrap(C);F.write(s.Buffer),p(F,B.byteLength),F.write(B)}else if(C instanceof R.$Ec)F.write(s.VSBuffer),p(F,C.byteLength),F.write(C);else if(Array.isArray(C)){F.write(s.Array),p(F,C.length);for(const B of C)r(F,B)}else if(typeof C=="number"&&(C|0)===C)F.write(s.Uint),p(F,C);else{const B=R.$Ec.fromString(JSON.stringify(C));F.write(s.Object),p(F,B.byteLength),F.write(B)}}e.$2g=r;function c(F){switch(F.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return F.read(h(F)).toString();case o.Buffer:return F.read(h(F)).buffer;case o.VSBuffer:return F.read(h(F));case o.Array:{const B=h(F),Y=[];for(let Z=0;Z<B;Z++)Y.push(c(F));return Y}case o.Object:return JSON.parse(F.read(h(F)).toString());case o.Int:return h(F)}}e.$3g=c;class S{constructor(C,B,Y=null,Z=1e3){this.h=C,this.j=B,this.k=Y,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(C,B){this.b.set(C,B),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const B=this.o([C.type]);this.k?.logOutgoing(B,0,1,$(C.type));return}case 201:case 202:case 204:case 203:{const B=this.o([C.type,C.id],C.data);this.k?.logOutgoing(B,C.id,1,$(C.type),C.data);return}}}o(C,B=void 0){const Y=new t;return r(Y,C),r(Y,B),this.p(Y.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const B=new E(C),Y=c(B),Z=c(B),Q=Y[0];switch(Q){case 100:return this.k?.logIncoming(C.byteLength,Y[1],1,`${b(Q)}: ${Y[2]}.${Y[3]}`,Z),this.s({type:Q,id:Y[1],channelName:Y[2],name:Y[3],arg:Z});case 102:return this.k?.logIncoming(C.byteLength,Y[1],1,`${b(Q)}: ${Y[2]}.${Y[3]}`,Z),this.t({type:Q,id:Y[1],channelName:Y[2],name:Y[3],arg:Z});case 101:return this.k?.logIncoming(C.byteLength,Y[1],1,`${b(Q)}`),this.u({type:Q,id:Y[1]});case 103:return this.k?.logIncoming(C.byteLength,Y[1],1,`${b(Q)}`),this.u({type:Q,id:Y[1]})}}s(C){const B=this.b.get(C.channelName);if(!B){this.v(C);return}const Y=new A.$oc;let Z;try{Z=B.call(this.j,C.name,C.arg,Y.token)}catch(M){Z=Promise.reject(M)}const Q=C.id;Z.then(M=>{this.m({id:Q,data:M,type:201}),this.d.delete(C.id)},M=>{M instanceof Error?this.m({id:Q,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.m({id:Q,data:M,type:203}),this.d.delete(C.id)});const U=(0,l.$jb)(()=>Y.cancel());this.d.set(C.id,U)}t(C){const B=this.b.get(C.channelName);if(!B){this.v(C);return}const Y=C.id,Q=B.listen(this.j,C.name,C.arg)(U=>this.m({id:Y,data:U,type:204}));this.d.set(C.id,Q)}u(C){const B=this.d.get(C.id);B&&(B.dispose(),this.d.delete(C.id))}v(C){let B=this.g.get(C.channelName);B||(B=[],this.g.set(C.channelName,B));const Y=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:C,timeoutTimer:Y})}w(C){const B=this.g.get(C);if(B){for(const Y of B)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$gb)(this.d.values()),this.d.clear()}}e.$4g=S;var I;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class v{constructor(C,B=null){this.l=C,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$ec,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=B}getChannel(C){const B=this;return{call(Y,Z,Q){return B.a?Promise.reject(new y.$3):B.m(C,Y,Z,Q)},listen(Y,Z){return B.a?u.Event.None:B.o(C,Y,Z)}}}m(C,B,Y,Z=A.CancellationToken.None){const Q=this.g++,M={id:Q,type:100,channelName:C,name:B,arg:Y};if(Z.isCancellationRequested)return Promise.reject(new y.$3);let a;return new Promise((z,T)=>{if(Z.isCancellationRequested)return T(new y.$3);const X=()=>{const pe=de=>{switch(de.type){case 201:this.f.delete(Q),z(de.data);break;case 202:{this.f.delete(Q);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,T(me);break}case 203:this.f.delete(Q),T(de.data);break}};this.f.set(Q,pe),this.p(M)};let H=null;this.b===f.Idle?X():(H=(0,j.$ig)(pe=>this.u()),H.then(()=>{H=null,X()}));const ae=()=>{H?(H.cancel(),H=null):this.p({id:Q,type:101}),T(new y.$3)},oe=Z.onCancellationRequested(ae);a=(0,l.$ib)((0,l.$jb)(ae),oe),this.d.add(a)}).finally(()=>{this.d.delete(a)})}o(C,B,Y){const Z=this.g++,U={id:Z,type:102,channelName:C,name:B,arg:Y};let M=null;const a=new u.$ec({onWillAddFirstListener:()=>{M=(0,j.$ig)(z=>this.u()),M.then(()=>{M=null,this.d.add(a),this.p(U)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.d.delete(a),this.p({id:Z,type:103}))}}),g=z=>a.fire(z.data);return this.f.set(Z,g),a.event}p(C){switch(C.type){case 100:case 102:{const B=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(B,C.id,0,`${b(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const B=this.q([C.type,C.id]);this.j?.logOutgoing(B,C.id,0,b(C.type));return}}}q(C,B=void 0){const Y=new t;return r(Y,C),r(Y,B),this.r(Y.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const B=new E(C),Y=c(B),Z=c(B),Q=Y[0];switch(Q){case 200:return this.j?.logIncoming(C.byteLength,0,0,$(Q)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,Y[1],0,$(Q),Z),this.t({type:Y[0],id:Y[1],data:Z})}}t(C){if(C.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$gb)(this.d.values()),this.d.clear()}}e.$5g=v,$e([N.$Tg],v.prototype,"onDidInitializePromise",null);class D{get connections(){const C=[];return this.f.forEach(B=>C.push(B)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new u.$ec,this.onDidAddConnection=this.g.event,this.h=new u.$ec,this.onDidRemoveConnection=this.h.event,C(({protocol:B,onDidClientDisconnect:Y})=>{u.Event.once(B.onMessage)(Q=>{const U=new E(Q),M=c(U),a=new S(B,M),g=new v(B);this.a.forEach((T,X)=>a.registerChannel(X,T));const z={channelServer:a,channelClient:g,ctx:M};this.f.add(z),this.g.fire(z),Y(()=>{a.dispose(),g.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(C,B){const Y=this;return{call(Z,Q,U){let M;if((0,m.$we)(B)){const g=(0,L.$Hf)(Y.connections.filter(B));M=g?Promise.resolve(g):u.Event.toPromise(u.Event.filter(Y.onDidAddConnection,B))}else M=B.routeCall(Y,Z,Q);const a=M.then(g=>g.channelClient.getChannel(C));return _(a).call(Z,Q,U)},listen(Z,Q){if((0,m.$we)(B))return Y.j(C,B,Z,Q);const U=B.routeEvent(Y,Z,Q).then(M=>M.channelClient.getChannel(C));return _(U).listen(Z,Q)}}}j(C,B,Y,Z){const Q=this;let U=new l.$kb;const M=new u.$ec({onWillAddFirstListener:()=>{U=new l.$kb;const a=new u.$kc,g=new Map,z=X=>{const ae=X.channelClient.getChannel(C).listen(Y,Z),oe=a.add(ae);g.set(X,oe)},T=X=>{const H=g.get(X);H&&(H.dispose(),g.delete(X))};Q.connections.filter(B).forEach(z),u.Event.filter(Q.onDidAddConnection,B)(z,void 0,U),Q.onDidRemoveConnection(T,void 0,U),a.event(M.fire,M,U),U.add(a)},onDidRemoveLastListener:()=>{U.dispose()}});return M.event}registerChannel(C,B){this.a.set(C,B),this.f.forEach(Y=>{Y.channelServer.registerChannel(C,B)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=D;class W{constructor(C,B,Y=null){const Z=new t;r(Z,B),C.send(Z.buffer),this.a=new v(C,Y),this.d=new S(C,B,Y)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,B){this.d.registerChannel(C,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=W;function _(F){return{call(C,B,Y){return F.then(Z=>Z.call(C,B,Y))},listen(C,B){const Y=new u.$nc;return F.then(Z=>Y.input=Z.listen(C,B)),Y.event}}}e.$8g=_;function x(F){let C=!1;return{call(B,Y,Z){return C?F.call(B,Y,Z):(0,j.$vg)(0).then(()=>C=!0).then(()=>F.call(B,Y,Z))},listen(B,Y){if(C)return F.listen(B,Y);const Z=new u.$nc;return(0,j.$vg)(0).then(()=>C=!0).then(()=>Z.input=F.listen(B,Y)),Z.event}}}e.$9g=x;class le{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const B of C.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.$0g=le;var te;(function(F){function C(Q,U){const M=Q,a=U&&U.disableMarshalling,g=new Map;for(const z in M)Y(z)&&g.set(z,u.Event.buffer(M[z],!0));return new class{listen(z,T,X){const H=g.get(T);if(H)return H;if(Z(T)){const ae=M[T];if(typeof ae=="function")return ae.call(M,X)}throw new y.$ab(`Event not found: ${T}`)}call(z,T,X){const H=M[T];if(typeof H=="function"){if(!a&&Array.isArray(X))for(let ae=0;ae<X.length;ae++)X[ae]=(0,w.$Yg)(X[ae]);return H.apply(M,X)}throw new y.$ab(`Method not found: ${T}`)}}}F.fromService=C;function B(Q,U){const M=U&&U.disableMarshalling;return new Proxy({},{get(a,g){if(typeof g=="string")return U?.properties?.has(g)?U.properties.get(g):Z(g)?function(z){return Q.listen(g,z)}:Y(g)?Q.listen(g):async function(...z){let T;U&&!(0,m.$re)(U.context)?T=[U.context,...z]:T=z;const X=await Q.call(g,T);return M?X:(0,w.$Yg)(X)};throw new y.$ab(`Property not found: ${String(g)}`)}})}F.toService=B;function Y(Q){return Q[0]==="o"&&Q[1]==="n"&&O.$Kd(Q.charCodeAt(2))}function Z(Q){return/^onDynamic/.test(Q)&&O.$Kd(Q.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const C=F.toString();if(C!=="[object Object]")return C}return F}function ie(F){return Array.isArray(F)?F.map(ue):ue(F)}function V(F,C,B,Y,Z,Q,U){U=ie(U);const M=ce[Z],a=M[Y%M.length];let g=[`%c[${F}]%c[${String(C).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(Q)?(g=g.concat(U),g.push(")")):g.push(U),console.log.apply(console,g)}class G{constructor(C,B){this.d=C,this.f=B,this.a=0,this.b=0}logOutgoing(C,B,Y,Z,Q){this.b+=C,V(this.d,this.b,C,B,Y,Z,Q)}logIncoming(C,B,Y,Z,Q){this.a+=C,V(this.f,this.a,C,B,Y,Z,Q)}}e.$$g=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=void 0;class b extends d.$4g{constructor(f){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",h=>R.$Ec.wrap(Buffer.from(h,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$Ip=b;class k{constructor(f,h){this.i=f,this.j=h,this.c=new Set,this.g=new Map,this.h=new u.$ec,this.onDidProcessExit=this.h.event;const P=h&&h.timeout?h.timeout:6e4;this.b=new j.$rg(P),this.d=null,this.f=null}getChannel(f){const h=this;return{call(P,p,E){return h.k(f,P,p,E)},listen(P,p){return h.l(f,P,p)}}}k(f,h,P,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(y.$4());this.b.cancel();const E=this.n(f),t=(0,j.$ig)(s=>E.call(h,P,s)),o=p.onCancellationRequested(()=>t.cancel()),i=(0,l.$jb)(()=>t.cancel());return this.c.add(i),t.finally(()=>{o.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,h,P){if(!this.b)return u.Event.None;this.b.cancel();let p;const E=new u.$ec({onWillAddFirstListener:()=>{p=this.n(f).listen(h,P)(E.fire,E),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,w.$Im)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,m.$gl)(h.env),this.d=(0,L.fork)(this.i,f,h);const P=new u.$ec;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,N.$Ep)(n)){(0,N.log)(n,`IPC Library: ${this.j.serverName}`);return}P.fire(R.$Ec.wrap(Buffer.from(n,"base64")))});const E=this.j.useQueue?(0,O.$il)(this.d):this.d,t=n=>this.d&&this.d.connected&&E.send(n.buffer.toString("base64")),o=P.event,i={send:t,onMessage:o};this.f=new d.$5g(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",s),this.c.forEach(c=>(0,l.$gb)(c)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(f){let h=this.g.get(f);return h||(h=this.m.getChannel(f),this.g.set(f,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Jp=k}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,j,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.StorageState=e.$Ho=e.StorageHint=void 0;var y;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(y||(e.StorageHint=y={}));function u(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Ho=u;var l;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(l||(e.StorageState=l={}));class w extends R.$lb{static{this.a=100}constructor(d,b=Object.create(null)){super(),this.m=d,this.n=b,this.b=this.B(new j.$hc),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=new L.$sg(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(d=>this.r(d)))}r(d){this.b.pause();try{d.changed?.forEach((b,k)=>this.s(k,b)),d.deleted?.forEach(b=>this.s(b,void 0))}finally{this.b.resume()}}s(d,b){if(this.c===l.Closed)return;let k=!1;(0,N.$re)(b)?k=this.f.delete(d):this.f.get(d)!==b&&(this.f.set(d,b),k=!0),k&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.n.hint!==y.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(d,b){const k=this.f.get(d);return(0,N.$re)(k)?b:k}getBoolean(d,b){const k=this.get(d);return(0,N.$re)(k)?b:k==="true"}getNumber(d,b){const k=this.get(d);return(0,N.$re)(k)?b:parseInt(k,10)}getObject(d,b){const k=this.get(d);return(0,N.$re)(k)?b:(0,A.$Xg)(k)}async set(d,b,k=!1){if(this.c===l.Closed)return;if((0,N.$re)(b))return this.delete(d,k);const $=(0,N.$ke)(b)||Array.isArray(b)?(0,A.$Wg)(b):String(b);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:k}),this.w()}async delete(d,b=!1){if(!(this.c===l.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:b}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=l.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(d).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(d){if(this.u)return this.w(d)}async w(d){return this.g.trigger(()=>this.v(),d)}async whenFlushed(){if(this.u)return new Promise(d=>this.l.push(d))}isInMemory(){return this.n.hint===y.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Io=w;class O{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((b,k)=>this.a.set(k,b)),d.delete?.forEach(b=>this.a.delete(b))}async close(){}}e.$Jo=O}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var R;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...l){switch(l.length){case 1:return(0,j.localize)(0,null,l[0]);case 2:return(0,j.localize)(1,null,l[0],l[1]);case 3:return(0,j.localize)(2,null,l[0],l[1],l[2]);default:return}}const N=(0,j.localize)(3,null),y=(0,j.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,L.$6)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const O=this.d,m=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:m};this.g.push({offset:O,lexeme:m,additionalInfo:w}),this.f.push(d)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const O=this.c.substring(this.d,this.e),m=u.b.get(O);m?this.k(m):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,O=!1,m=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(y);return}const b=this.c.charCodeAt(w);if(O)O=!1;else if(b===47&&!m){w++;break}else b===91?m=!0:b===92?O=!0:b===93&&(m=!1);w++}for(;w<this.c.length&&u.a.has(this.c.charCodeAt(w));)w++;this.e=w;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=u}),define(ne[109],re([0,1,77,52,15,16,34,17,11]),function(J,e,L,j,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.$Ul=void 0,e.$Ul=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.$$c)(R.$1e.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$8c)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,y.$9f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,y.$9f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$Tl)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$8c)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.$9f)(u.URI.file((0,A.$8c)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.$9f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.$9f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.$9f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=N.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$8c)(d,"argv.json")):(0,y.$9f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$8c)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$9c)(d):(0,A.$6c)((0,A.$8c)(R.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.$9c)(d)):u.URI.file((0,A.$8c)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$9c)(d);const b=N.env.VSCODE_EXTENSIONS;if(b)return b;const k=N.env.VSCODE_PORTABLE;return k?(0,A.$8c)(k,"extensions"):(0,y.$9f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(b=>/^[^:/?#]+?:\/\//.test(b)?u.URI.parse(b):u.URI.file((0,A.$6c)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.$6c)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$Ul.test(d))}get extensionLogLevel(){const d=[];for(const b of this.args.log||[]){const k=e.$Ul.exec(b);k&&k[1]&&k[2]&&d.push([k[1],k[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,y.$9f)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=N.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$8c)(d,"policy.json")):(0,y.$9f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,b,k){this.a=d,this.b=b,this.c=k,this.editSessionId=this.args.editSessionId}}e.$Vl=l,$e([j.$Tg],l.prototype,"appRoot",null),$e([j.$Tg],l.prototype,"userHome",null),$e([j.$Tg],l.prototype,"userDataPath",null),$e([j.$Tg],l.prototype,"appSettingsHome",null),$e([j.$Tg],l.prototype,"tmpDir",null),$e([j.$Tg],l.prototype,"cacheHome",null),$e([j.$Tg],l.prototype,"stateResource",null),$e([j.$Tg],l.prototype,"userRoamingDataHome",null),$e([j.$Tg],l.prototype,"userDataSyncHome",null),$e([j.$Tg],l.prototype,"sync",null),$e([j.$Tg],l.prototype,"machineSettingsResource",null),$e([j.$Tg],l.prototype,"workspaceStorageHome",null),$e([j.$Tg],l.prototype,"localHistoryHome",null),$e([j.$Tg],l.prototype,"keyboardLayoutResource",null),$e([j.$Tg],l.prototype,"argvResource",null),$e([j.$Tg],l.prototype,"isExtensionDevelopment",null),$e([j.$Tg],l.prototype,"untitledWorkspacesHome",null),$e([j.$Tg],l.prototype,"builtinExtensionsPath",null),$e([j.$Tg],l.prototype,"extensionsPath",null),$e([j.$Tg],l.prototype,"extensionDevelopmentLocationURI",null),$e([j.$Tg],l.prototype,"extensionDevelopmentKind",null),$e([j.$Tg],l.prototype,"extensionTestsLocationURI",null),$e([j.$Tg],l.prototype,"debugExtensionHost",null),$e([j.$Tg],l.prototype,"logLevel",null),$e([j.$Tg],l.prototype,"extensionLogLevel",null),$e([j.$Tg],l.prototype,"serviceMachineIdResource",null),$e([j.$Tg],l.prototype,"disableTelemetry",null),$e([j.$Tg],l.prototype,"disableWorkspaceTrust",null),$e([j.$Tg],l.prototype,"disableKeytar",null),$e([j.$Tg],l.prototype,"policyFile",null);function w(m,d){return O(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}e.$Wl=w;function O(m,d,b,k,$,f){const P=Number(d||m)||(k?null:b),p=P?!!d:!1;let E;if(f)try{E=JSON.parse(f)}catch{}return{port:P,break:p,debugId:$,env:E}}e.$Xl=O}),function(){"use strict";function J(e,L,j){function R(N,y){const u=A(N,y),l=[u];return e.isAbsolute(u)||l.unshift(j),e.resolve(...l)}function A(N,y){process.env.VSCODE_DEV&&(y="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,y);const w=N["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(O,"AppData","Roaming")}break;case"darwin":l=e.join(L.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,y)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,32,34]),function(e,L,j){return J(e,L,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,32,109,110]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=void 0;class A extends j.$Vl{constructor(l,w){super(l,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(l,w.nameShort)},w)}}e.$Yl=A;function N(u,l){return(0,j.$Xl)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.$Zl=N;function y(u,l){return(0,j.$Xl)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.$1l=y}),define(ne[112],re([0,1,3,94]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;function R(N,y,u){try{A(N,y,u)}catch(l){console.error(l?.message??l)}return N}e.$ep=R;function A(N,y,u){const l=(w,O,m)=>{const d=w[O];if((0,L.$ie)(d)){const b=d,k=b.length;if(k>1&&b[0]==="%"&&b[k-1]==="%"){const $=b.substr(1,k-2);let f=y[$];f===void 0&&u&&(f=u[$]);const h=typeof f=="string"?f:f?.message,P=u?.[$],p=typeof P=="string"?P:P?.message;if(!h){p||console.warn(`[${N.name}]: ${(0,j.localize)(0,null,$)}`);return}if(m&&(O==="title"||O==="category")&&p&&p!==h){const E={value:h,original:p};w[O]=E}else w[O]=h}}else if((0,L.$ke)(d))for(const b in d)d.hasOwnProperty(b)&&(b==="commands"?l(d,b,!0):l(d,b,m));else if(Array.isArray(d))for(let b=0;b<d.length;b++)l(d,b,m)};for(const w in N)N.hasOwnProperty(w)&&l(N,w)}}),define(ne[48],re([0,1,17,54,98,43]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function u(f){return f=f.trim(),f==="*"||N.test(f)}e.$to=u;function l(f){if(!u(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=f.match(N);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$uo=l;function w(f){if(!f)return null;const h=f.majorBase,P=f.majorMustEqual,p=f.minorBase;let E=f.minorMustEqual;const t=f.patchBase;let o=f.patchMustEqual;f.hasCaret&&(h===0||(E=!1),o=!1);let i=0;if(f.preRelease){const s=y.exec(f.preRelease);if(s){const[,n,r,c]=s;i=Date.UTC(Number(n),Number(r)-1,Number(c))}}return{majorBase:h,majorMustEqual:P,minorBase:p,minorMustEqual:E,patchBase:t,patchMustEqual:o,isMinimum:f.hasGreaterEquals,notBefore:i}}e.$vo=w;function O(f,h,P){let p;typeof f=="string"?p=w(l(f)):p=f;let E;h instanceof Date?E=h.getTime():typeof h=="string"&&(E=new Date(h).getTime());let t;if(typeof P=="string"?t=w(l(P)):t=P,!p||!t)return!1;const o=p.majorBase,i=p.minorBase,s=p.patchBase;let n=t.majorBase,r=t.minorBase,c=t.patchBase;const S=t.notBefore;let I=t.majorMustEqual,v=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:i>r?!0:i<r||E&&E<S?!1:s>=c:(o===1&&n===0&&(!I||!v||!D)&&(n=1,r=0,c=0,I=!0,v=!1,D=!1),o<n?!1:o>n?!I:i<r?!1:i>r?!v:s<c?!1:s>c?!D:!(E&&E<S))}e.$wo=O;function m(f,h,P,p,E){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([j.default.Error,R.localize(0,null)]),t;if(typeof p.name!="string")return t.push([j.default.Error,R.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([j.default.Error,R.localize(2,null,"version")]),t;if(!p.engines)return t.push([j.default.Error,R.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([j.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return t.push([j.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return t.push([j.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([j.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([j.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([j.default.Error,R.localize(9,null,"main")]),t;{const s=(0,L.$9f)(P,p.main);(0,L.$3f)(s,P)||t.push([j.default.Warning,R.localize(10,null,s.path,P.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([j.default.Error,R.localize(11,null,"browser")]),t;{const s=(0,L.$9f)(P,p.browser);(0,L.$3f)(s,P)||t.push([j.default.Warning,R.localize(12,null,s.path,P.path)])}}if(!A.valid(p.version))return t.push([j.default.Error,R.localize(13,null)]),t;const o=[];if(!d(f,h,p,E,o))for(const s of o)t.push([j.default.Error,s]);return t}e.$xo=m;function d(f,h,P,p,E){return p||typeof P.main>"u"&&typeof P.browser>"u"?!0:k(f,h,P.engines.vscode,E)}e.$yo=d;function b(f,h,P){return f==="*"||k(h,P,f)}e.$zo=b;function k(f,h,P,p=[]){const E=w(l(P));if(!E)return p.push(R.localize(14,null,P)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return p.push(R.localize(15,null,P)),!1}else if(!E.majorMustEqual)return p.push(R.localize(16,null,P)),!1;return O(f,h,E)?!0:(p.push(R.localize(17,null,f,P)),!1)}function $(f){if(!Array.isArray(f))return!1;for(let h=0,P=f.length;h<P;h++)if(typeof f[h]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0;async function R(A,N,y){let u=y&&y.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const w=(await N.readFile(A.serviceMachineIdResource)).value.toString();u=(0,j.$2e)(w)?w:null}catch{u=null}if(!u){u=(0,j.$3e)();try{await N.writeFile(A.serviceMachineIdResource,L.$Ec.fromString(u))}catch{}}return y?.store("storage.serviceMachineId",u,-1,1),u}e.$So=R}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class L{constructor(R,A=[],N=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$mh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.InstantiationType=void 0;const j=[];var R;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(y,u,l){u instanceof L.$mh||(u=new L.$mh(u,[],!!l)),j.push([y,u])}e.$dr=A;function N(){return j}e.$er=N}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;class L{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$Up=L;class j{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const y=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(N);y.outgoing.set(u.key,u),u.incoming.set(y.key,y)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const y of this.a.values())y.outgoing.delete(N),y.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let y=this.a.get(N);return y||(y=new L(N,A),this.a.set(N,y)),y}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,y]of this.a)A.push(`${N}
	(-> incoming)[${[...y.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...y.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const y=new Set([A]),u=this.c(N,y);if(u)return u}}c(A,N){for(const[y,u]of A.outgoing){if(N.has(y))return[...N,y].join(" -> ");N.add(y);const l=this.c(u,N);if(l)return l;N.delete(y)}}}e.$Vp=j}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,R.$ph)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof j.URI)}e.$Wh=A;function N(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof j.URI)}e.$Xh=N;var y;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(y||(e.ConfigurationTarget=y={}));function u(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=u;function l(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.$Zh=l;function w(f,h){const P=Object.create(null);for(const p in f)O(P,p,f[p],h);return P}e.$1h=w;function O(f,h,P,p){const E=h.split("."),t=E.pop();let o=f;for(let i=0;i<E.length;i++){const s=E[i];let n=o[s];switch(typeof n){case"undefined":n=o[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${h} as ${E.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=P}catch{p(`Ignoring ${h} as ${E.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${h} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$2h=O;function m(f,h){const P=h.split(".");d(f,P)}e.$3h=m;function d(f,h){const P=h.shift();if(h.length===0){delete f[P];return}if(Object.keys(f).indexOf(P)!==-1){const p=f[P];typeof p=="object"&&!Array.isArray(p)&&(d(p,h),Object.keys(p).length===0&&delete f[P])}}function b(f,h,P){function p(o,i){let s=o;for(const n of i){if(typeof s!="object"||s===null)return;s=s[n]}return s}const E=h.split("."),t=p(f,E);return typeof t>"u"?P:t}e.$4h=b;function k(f,h,P){Object.keys(h).forEach(p=>{p!=="__proto__"&&(p in f?L.$ke(f[p])&&L.$ke(h[p])?k(f[p],h[p],P):P&&(f[p]=h[p]):f[p]=h[p])})}e.$5h=k;function $(f){return f.replace(/[\[\]]/g,"")}e.$6h=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,j,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$j),u.set("isLinux",L.$k),u.set("isWindows",L.$i),u.set("isWeb",L.$o),u.set("isMacNative",L.$j&&!L.$o),u.set("isEdge",L.$G),u.set("isFirefox",L.$E),u.set("isChrome",L.$D),u.set("isSafari",L.$F);function l(M,a){if(u.get(M)!==void 0)throw(0,y.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(M,a)}e.$ti=l;const w=Object.prototype.hasOwnProperty;var O;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const m={regexParsingWithErrorRecovery:!0},d=(0,N.localize)(0,null),b=(0,N.localize)(1,null),k=(0,N.localize)(2,null),$=(0,N.localize)(3,null),f=(0,N.localize)(4,null),h=(0,N.localize)(5,null),P=(0,N.localize)(6,null),p=(0,N.localize)(7,null);class E{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=m){this.k=a,this.d=new R.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const g=this.l();if(!this.E()){const z=this.D(),T=z.type===17?h:void 0;throw this.h.push({message:f,offset:z.offset,lexeme:R.$si.getLexeme(z),additionalInfo:T}),E.c}return g}catch(g){if(g!==E.c)throw g;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const g=this.o();a.push(g)}return a.length===1?a[0]:t.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const g=this.s();a.push(g)}return a.length===1?a[0]:t.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const g=this.l();return this.A(1,$),g?.negate()}case 17:return this.z(),W.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const g=this.l();return this.A(1,$),g}case 17:{const g=a.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const X=T.lexeme,H=X.lastIndexOf("/"),ae=H===X.length-1?void 0:this.w(X.substring(H+1));let oe;try{oe=new RegExp(X.substring(1,H),ae)}catch{throw this.B("REGEX",T)}return ue.create(g,oe)}switch(T.type){case 10:case 19:{const X=[T.lexeme];this.z();let H=this.D(),ae=0;for(let fe=0;fe<T.lexeme.length;fe++)T.lexeme.charCodeAt(fe)===40?ae++:T.lexeme.charCodeAt(fe)===41&&ae--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?ae++:T.lexeme.charCodeAt(fe)===41&&ae--}if(ae<0)break;X.push(R.$si.getLexeme(H)),this.z(),H=this.D()}const oe=X.join(""),pe=oe.lastIndexOf("/"),de=pe===oe.length-1?void 0:this.w(oe.substring(pe+1));let me;try{me=new RegExp(oe.substring(1,pe),de)}catch{throw this.B("REGEX",T)}return t.regex(g,me)}case 18:{const X=T.lexeme;this.z();let H=null;if(!(0,j.$ld)(X)){const ae=X.indexOf("/"),oe=X.lastIndexOf("/");if(ae!==oe&&ae>=0){const pe=X.slice(ae+1,oe),de=X[oe+1]==="i"?"i":"";try{H=new RegExp(pe,de)}catch{throw this.B("REGEX",T)}}}if(H===null)throw this.B("REGEX",T);return ue.create(g,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,k);const T=this.u();return t.notIn(g,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return t.equals(g,T);switch(T){case"true":return t.has(g);case"false":return t.not(g);default:return t.equals(g,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return t.notEquals(g,T);switch(T){case"true":return t.not(g);case"false":return t.has(g);default:return t.notEquals(g,T)}}case 5:return this.z(),te.create(g,this.u());case 6:return this.z(),ce.create(g,this.u());case 7:return this.z(),x.create(g,this.u());case 8:return this.z(),le.create(g,this.u());case 13:return this.z(),t.in(g,this.u());default:return t.has(g)}}case 20:throw this.h.push({message:P,offset:a.offset,lexeme:"",additionalInfo:p}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,g){if(this.C(a))return this.z();throw this.B(g,this.D())}B(a,g,z){const T=(0,N.localize)(8,null,a,R.$si.getLexeme(g)),X=g.offset,H=R.$si.getLexeme(g);return this.h.push({message:T,offset:X,lexeme:H,additionalInfo:z}),E.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=E;class t{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return c.create(a)}static equals(a,g){return S.create(a,g)}static notEquals(a,g){return D.create(a,g)}static regex(a,g){return ue.create(a,g)}static in(a,g){return I.create(a,g)}static notIn(a,g){return v.create(a,g)}static not(a){return W.create(a)}static and(...a){return G.create(a,null,!0)}static or(...a){return F.create(a,null,!0)}static greater(a,g){return x.create(a,g)}static greaterEquals(a,g){return le.create(a,g)}static smaller(a,g){return te.create(a,g)}static smallerEquals(a,g){return ce.create(a,g)}static{this.c=new E({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$vi=t;function o(M){const a=new E({regexParsingWithErrorRecovery:!1});return M.map(g=>(a.parse(g),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,N.localize)(9,null,z.additionalInfo):(0,N.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$wi=o;function i(M,a){const g=M?M.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!g&&!z?!0:!g||!z?!1:g.equals(z)}e.$xi=i;function s(M,a){return M.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$yi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$zi=r;class c{static create(a,g=null){const z=u.get(a);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new c(a,g)}constructor(a,g){this.key=a,this.c=g,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Ai=c;class S{static create(a,g,z=null){if(typeof g=="boolean")return g?c.create(a,z):W.create(a,z);const T=u.get(a);return typeof T=="boolean"?g===(T?"true":"false")?r.INSTANCE:n.INSTANCE:new S(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Bi=S;class I{static create(a,g){return new I(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(g)?g.includes(z):typeof z=="string"&&typeof g=="object"&&g!==null?w.call(g,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Ci=I;class v{static create(a,g){return new v(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=11,this.c=I.create(a,g)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=v;class D{static create(a,g,z=null){if(typeof g=="boolean")return g?W.create(a,z):c.create(a,z);const T=u.get(a);return typeof T=="boolean"?g===(T?"true":"false")?n.INSTANCE:r.INSTANCE:new D(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Ei=D;class W{static create(a,g=null){const z=u.get(a);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new W(a,g)}constructor(a,g){this.c=a,this.d=g,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:B(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=u.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.$Fi=W;function _(M,a){if(typeof M=="string"){const g=parseFloat(M);isNaN(g)||(M=g)}return typeof M=="string"||typeof M=="number"?a(M):n.INSTANCE}class x{static create(a,g,z=null){return _(g,T=>new x(a,T,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Gi=x;class le{static create(a,g,z=null){return _(g,T=>new le(a,T,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Hi=le;class te{static create(a,g,z=null){return _(g,T=>new te(a,T,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Ii=te;class ce{static create(a,g,z=null){return _(g,T=>new ce(a,T,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Ji=ce;class ue{static create(a,g){return new ue(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return g<z?-1:g>z?1:0}equals(a){if(a.type===this.type){const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&g===z}return!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.d);return this.f?this.f.test(g):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Ki=ue;class ie{static create(a){return new ie(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new ie(this.c.map(a))}negate(){return this.c}}e.$Li=ie;function V(M){let a=null;for(let g=0,z=M.length;g<z;g++){const T=M[g].substituteConstants();if(M[g]!==T&&a===null){a=[];for(let X=0;X<g;X++)a[X]=M[X]}a!==null&&(a[g]=T)}return a===null?M:a}class G{static create(a,g,z){return G.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const T=s(this.expr[g],a.expr[g]);if(T!==0)return T}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=V(this.expr);return a===this.expr?this:G.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].evaluate(a))return!1;return!0}static d(a,g,z){const T=[];let X=!1;for(const H of a)if(H){if(H.type===1){X=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){T.push(...H.expr);continue}T.push(H)}if(T.length===0&&X)return r.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(s);for(let H=1;H<T.length;H++)T[H-1].equals(T[H])&&(T.splice(H,1),H--);if(T.length===1)return T[0];for(;T.length>1;){const H=T[T.length-1];if(H.type!==9)break;T.pop();const ae=T.pop(),oe=T.length===0,pe=F.create(H.expr.map(de=>G.create([de,ae],null,z)),null,oe);pe&&(T.push(pe),T.sort(s))}if(T.length===1)return T[0];if(z){for(let H=0;H<T.length;H++)for(let ae=H+1;ae<T.length;ae++)if(T[H].negate().equals(T[ae]))return n.INSTANCE;if(T.length===1)return T[0]}return new G(T,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new G(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());this.c=F.create(a,this,!0)}return this.c}}e.$Mi=G;class F{static create(a,g,z){return F.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const T=s(this.expr[g],a.expr[g]);if(T!==0)return T}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=V(this.expr);return a===this.expr?this:F.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(this.expr[g].evaluate(a))return!0;return!1}static d(a,g,z){let T=[],X=!1;if(a){for(let H=0,ae=a.length;H<ae;H++){const oe=a[H];if(oe){if(oe.type===0){X=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){T=T.concat(oe.expr);continue}T.push(oe)}}if(T.length===0&&X)return n.INSTANCE;T.sort(s)}if(T.length!==0){if(T.length===1)return T[0];for(let H=1;H<T.length;H++)T[H-1].equals(T[H])&&(T.splice(H,1),H--);if(T.length===1)return T[0];if(z){for(let H=0;H<T.length;H++)for(let ae=H+1;ae<T.length;ae++)if(T[H].negate().equals(T[ae]))return r.INSTANCE;if(T.length===1)return T[0]}return new F(T,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new F(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());for(;a.length>1;){const g=a.shift(),z=a.shift(),T=[];for(const X of U(g))for(const H of U(z))T.push(G.create([X,H],null,!1));a.unshift(F.create(T,null,!1))}this.c=F.create(a,this,!0)}return this.c}}e.$Ni=F;class C extends c{static{this.d=[]}static all(){return C.d.values()}constructor(a,g,z){super(a,null),this.f=g,typeof z=="object"?C.d.push({...z,key:a}):z!==!0&&C.d.push({key:a,description:z,type:g!=null?typeof g:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return S.create(this.key,a)}notEqualsTo(a){return D.create(this.key,a)}}e.$Oi=C,e.$Pi=(0,A.$ph)("contextKeyService");function B(M,a){return M<a?-1:M>a?1:0}function Y(M,a,g,z){return M<g?-1:M>g?1:a<z?-1:a>z?1:0}function Z(M,a){if(M.type===0||a.type===1)return!0;if(M.type===9)return a.type===9?Q(M.expr,a.expr):!1;if(a.type===9){for(const g of a.expr)if(Z(M,g))return!0;return!1}if(M.type===6){if(a.type===6)return Q(a.expr,M.expr);for(const g of M.expr)if(Z(g,a))return!0;return!1}return M.equals(a)}e.$Qi=Z;function Q(M,a){let g=0,z=0;for(;g<M.length&&z<a.length;){const T=M[g].cmp(a[z]);if(T<0)return!1;T===0&&g++,z++}return g===M.length}function U(M){return M.type===9?M.expr:[M]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn=(0,L.$ph)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,L.$ph)("environmentService"),e.$xh=(0,L.$qh)(e.$wh)}),define(ne[21],re([0,1,92,10]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Rn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0,e.$En="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fn=new RegExp(e.$En),e.$Gn="__web_extension",e.$Hn="skipWalkthrough",e.$In="extensionsSync",e.$Jn="dependecyOrPackExtensionInstall";function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Kn=R;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Ln=A;function N(h,P){switch(h){case 3:return P==="x64"?"win32-x64":P==="ia32"?"win32-ia32":P==="arm64"?"win32-arm64":"unknown";case 2:return P==="x64"?"linux-x64":P==="arm64"?"linux-arm64":P==="arm"?"linux-armhf":"unknown";case"alpine":return P==="x64"?"alpine-x64":P==="arm64"?"alpine-arm64":"unknown";case 1:return P==="x64"?"darwin-x64":P==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Mn=N;function y(h,P){return P==="web"&&!h.includes("web")}e.$Nn=y;function u(h,P,p){return y(P,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:l(p).includes(h)}e.$On=u;function l(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Pn=l;function w(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$Qn=w;var O;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var m;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var b;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$Rn=(0,j.$ph)("extensionGalleryService");var k;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var $;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class f extends Error{constructor(P,p){super(P),this.code=p,this.name=p}}e.$Sn=f,e.$Tn=(0,j.$ph)("extensionManagementService"),e.$Un="extensionsIdentifiers/disabled",e.$Vn="extensionsIdentifiers/enabled",e.$Wn=(0,j.$ph)("IGlobalExtensionEnablementService"),e.$Xn=(0,j.$ph)("IExtensionTipsService"),e.$Yn=(0,L.localize)(0,null),e.$Zn={value:e.$Yn,original:"Extensions"},e.$1n={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0,e.$Xo=(0,L.$ph)("IExtensionSignatureVerificationService");class j{b(){return this.a||(this.a=new Promise((A,N)=>J(["node-vsce-sign"],async y=>A(y),N))),this.a}async verify(A,N,y){let u;try{u=await this.b()}catch{return!1}return u.verify(A,N,y)}}e.$Yo=j}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;async function N(w,O,m,d,b,k){let $;try{await y(w,O,m,d,b,k)}catch(f){$=f}finally{$&&b.errorTransformer&&($=b.errorTransformer($)),typeof $<"u"&&m.error($),m.end()}}e.$tp=N;async function y(w,O,m,d,b,k){u(k);const $=await w.open(O,{create:!1});try{u(k);let f=0,h=0,P=b&&typeof b.length=="number"?b.length:void 0,p=L.$Ec.alloc(Math.min(b.bufferSize,typeof P=="number"?P:b.bufferSize)),E=b&&typeof b.position=="number"?b.position:0,t=0;do h=await w.read($,E,p.buffer,t,p.byteLength-t),E+=h,t+=h,f+=h,typeof P=="number"&&(P-=h),t===p.byteLength&&(await m.write(d(p)),p=L.$Ec.alloc(Math.min(b.bufferSize,typeof P=="number"?P:b.bufferSize)),t=0);while(h>0&&(typeof P!="number"||P>0)&&u(k)&&l(f,b));if(t>0){let o=t;typeof P=="number"&&(o=Math.min(t,P)),m.write(d(p.slice(0,o)))}}catch(f){throw(0,A.$6j)(f)}finally{await w.close($)}}function u(w){if(w.isCancellationRequested)throw(0,j.$4)();return!0}function l(w,O){if(typeof O?.limits?.size=="number"&&w>O.limits.size)throw(0,A.$5j)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,j,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class y extends R.$lb{constructor(){super(...arguments),this.a=this.B(new L.$ec),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$ec),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(l){const w=this.i(l),O=w.filter(d=>{const b=this.c.get(d.path);return b?!(0,j.$ij)(b.request.excludes,d.excludes)||!(0,j.$ij)(b.request.includes,d.includes):!0}),m=Array.from(this.c.values()).filter(({request:d})=>!w.find(b=>b.path===d.path&&(0,j.$ij)(b.excludes,d.excludes)&&(0,j.$ij)(b.includes,d.includes))).map(({request:d})=>d.path);O.length&&this.j(`Request to start watching: ${O.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const d of m)this.h(d);for(const d of O)this.g(d)}g(l){const w=new N.$Pp(l,m=>this.a.fire(m),m=>this.b.fire(m),this.f),O={request:l,instance:w};this.c.set(l.path,O)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const w=this.c.get(l);w&&(this.c.delete(l),w.instance.dispose())}i(l){const w=new Map;for(const O of l){const m=A.$k?O.path:O.path.toLowerCase();w.set(m,O)}return Array.from(w.values())}async setVerboseLogging(l){this.f=l;for(const[,w]of this.c)w.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,w){return w?`[File Watcher (node.js)] ${l} (path: ${w.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Rp=y}),define(ne[118],re([0,1,62,117]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class R extends L.$xp{constructor(N,y,u){super(N,y,u),this.m()}l(){return new j.$Rp}}e.$Sp=R}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class N extends A.$yp{constructor(u,l,w){super(u,l,w),this.m()}l(u){const l=u.add(new R.$Jp(L.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:w,signal:O})=>this.n(`terminated by itself with code ${w}, signal: ${O}`))),j.ProxyChannel.toService((0,j.$9g)(l.getChannel("watcher")))}}e.$Kp=N}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,N]of R)this.set(A,N)}set(R,A){const N=this.a.get(R);return this.a.set(R,A),N}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$nh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,j,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;const w=!1;class O extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class m{constructor($=new u.$nh,f=!1,h,P=w){this.f=$,this.g=f,this.h=h,this.i=P,this.o=new Set,this.f.set(y.$oh,this),this._globalGraph=P?h?._globalGraph??new N.$Vp(p=>p):void 0}createChild($){return new m($,this.g,this,this.i)}invokeFunction($,...f){const h=b.traceInvocation(this.i,$);let P=!1;try{return $({get:E=>{if(P)throw(0,j.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(E,h);if(!t)throw new Error(`[invokeFunction] unknown service '${E}'`);return t}},...f)}finally{P=!0,h.stop()}}createInstance($,...f){let h,P;return $ instanceof A.$mh?(h=b.traceCreation(this.i,$.ctor),P=this.j($.ctor,$.staticArguments.concat(f),h)):(h=b.traceCreation(this.i,$),P=this.j($,f,h)),h.stop(),P}j($,f=[],h){const P=y._util.getServiceDependencies($).sort((t,o)=>t.index-o.index),p=[];for(const t of P){const o=this.m(t.id,h);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(o)}const E=P.length>0?P[0].index:f.length;if(f.length!==E){console.trace(`[createInstance] First service dependency of ${$.name} at position ${E+1} conflicts with ${f.length} static arguments`);const t=E-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,E)}return Reflect.construct($,f.concat(p))}k($,f){if(this.f.get($)instanceof A.$mh)this.f.set($,f);else if(this.h)this.h.k($,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const f=this.f.get($);return!f&&this.h?this.h.l($):f}m($,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const h=this.l($);return h instanceof A.$mh?this.q($,h,f.branch($,!0)):(f.branch($,!1),h)}q($,f,h){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,f,h)}finally{this.o.delete($)}}r($,f,h){const P=new N.$Vp(t=>t.id.toString());let p=0;const E=[{id:$,desc:f,_trace:h}];for(;E.length;){const t=E.pop();if(P.lookupOrInsertNode(t),p++>1e3)throw new O(P);for(const o of y._util.getServiceDependencies(t.desc.ctor)){const i=this.l(o.id);if(i||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),i instanceof A.$mh){const s={id:o.id,desc:i,_trace:t._trace.branch(o.id,!0)};P.insertEdge(t,s),E.push(s)}}}for(;;){const t=P.roots();if(t.length===0){if(!P.isEmpty())throw new O(P);break}for(const{data:o}of t){if(this.l(o.id)instanceof A.$mh){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}P.removeNode(o)}}return this.l($)}s($,f,h=[],P,p){if(this.f.get($)instanceof A.$mh)return this.t($,f,h,P,p);if(this.h)return this.h.s($,f,h,P,p);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t($,f,h=[],P,p){if(P){const E=new m(void 0,this.g,this,this.i);E.c=String($);const t=new Map,o=new L.$Lg(()=>{const i=E.j(f,h,p);for(const[s,n]of t){const r=i[s];if(typeof r=="function")for(const c of n)r.apply(i,c)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let c=t.get(s);return c||(c=new l.$ub,t.set(s,c)),(I,v,D)=>{const W=c.push([I,v,D]);return(0,R.$jb)(W)}}if(s in i)return i[s];const n=o.value;let r=n[s];return typeof r!="function"||(r=r.bind(n),i[s]=r),r},set(i,s,n){return o.value[s]=n,!0},getPrototypeOf(i){return f.prototype}})}else return this.j(f,h,p)}u($,f){if(f&&console.warn($),this.g)throw new Error($)}}e.$Wp=m;var d;(function(k){k[k.None=0]="None",k[k.Creation=1]="Creation",k[k.Invocation=2]="Invocation",k[k.Branch=3]="Branch"})(d||(d={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,f){return $?new b(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation($,f){return $?new b(1,f.name):b.c}static{this.f=0}constructor($,f){this.type=$,this.name=f,this.g=Date.now(),this.h=[]}branch($,f){const h=new b(3,$.toString());return this.h.push([$,f,h]),h}stop(){const $=Date.now()-this.g;b.f+=$;let f=!1;function h(p,E){const t=[],o=new Array(p+1).join("	");for(const[i,s,n]of E.h)if(s&&n){f=!0,t.push(`${o}CREATES -> ${i}`);const r=h(p+1,n);r&&t.push(r)}else t.push(`${o}uses -> ${i}`);return t.join(`
`)}const P=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];($>2||f)&&b.all.add(P.join(`
`))}}e.$Xp=b});var se=this&&this.__param||function(J,e){return function(L,j){e(L,j,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,j,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=void 0;function u(w){return w.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$yq=u,e.$zq=(0,y.$ph)("languagePackService");let l=class extends j.$lb{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new L.$oc;setTimeout(()=>O.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const b=m.firstPage.filter(k=>k.properties.localizedLanguages?.length&&k.tags.some($=>$.startsWith("lp-"))).map(k=>{const $=k.properties.localizedLanguages?.[0],f=u(k);return{...this.f(f,$,k),extensionId:k.identifier.id,galleryExtension:k}});return b.push(this.f("en","English")),b}f(O,m,d){const b=m??O;let k;if(b!==O&&(k=`(${O})`),O.toLowerCase()===R.$v.toLowerCase()&&(k??="",k+=(0,A.localize)(0,null)),d?.installCount){k??="";const $=d.installCount;let f;$>1e6?f=`${Math.floor($/1e5)/10}M`:$>1e3?f=`${Math.floor($/1e3)}K`:f=String($),k+=` $(cloud-download) ${f}`}return{id:O,label:b,description:k}}};e.$Aq=l,e.$Aq=l=$e([se(0,N.$Rn)],l)}),define(ne[6],re([0,1,33,4,42,2,35,13,17,3,11,116,10]),function(J,e,L,j,R,A,N,y,u,l,w,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,m.$ph)("logService"),e.$Si=(0,m.$ph)("loggerService");function d(){return new Date().toISOString()}function b(I){return(0,l.$me)(I)}e.$Ti=b;var k;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(k||(e.LogLevel=k={})),e.$Ui=k.Info;function $(I,v,D){switch(v){case k.Trace:I.trace(D);break;case k.Debug:I.debug(D);break;case k.Info:I.info(D);break;case k.Warning:I.warn(D);break;case k.Error:I.error(D);break;case k.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=$;function f(I,v=!1){let D="";for(let W=0;W<I.length;W++){let _=I[W];if(_ instanceof Error&&(_=(0,L.$ai)(_,v)),typeof _=="object")try{_=JSON.stringify(_)}catch{}D+=(W>0?" ":"")+_}return D}class h extends A.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new j.$ec),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==k.Off&&this.b<=v}}e.$Wi=h;class P extends h{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...D){this.f(k.Trace)&&this.g(k.Trace,f([v,...D],!0))}debug(v,...D){this.f(k.Debug)&&this.g(k.Debug,f([v,...D]))}info(v,...D){this.f(k.Info)&&this.g(k.Info,f([v,...D]))}warn(v,...D){this.f(k.Warning)&&this.g(k.Warning,f([v,...D]))}error(v,...D){if(this.f(k.Error))if(v instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=v.stack,this.g(k.Error,f(W))}else this.g(k.Error,f([v,...D]))}flush(){}}e.$Xi=P;class p extends h{constructor(v=e.$Ui){super(),this.setLevel(v),this.g=!y.$i}trace(v,...D){this.f(k.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...D):console.log(`[main ${d()}]`,v,...D))}debug(v,...D){this.f(k.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...D):console.log(`[main ${d()}]`,v,...D))}info(v,...D){this.f(k.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...D):console.log(`[main ${d()}]`,v,...D))}warn(v,...D){this.f(k.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,v,...D):console.warn(`[main ${d()}]`,v,...D))}error(v,...D){this.f(k.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,v,...D):console.error(`[main ${d()}]`,v,...D))}dispose(){}flush(){}}e.$Yi=p;class E extends h{constructor(v=e.$Ui,D=!0){super(),this.g=D,this.setLevel(v)}trace(v,...D){this.f(k.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...D):console.log(v,...D))}debug(v,...D){this.f(k.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...D):console.log(v,...D))}info(v,...D){this.f(k.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...D):console.log(v,...D))}warn(v,...D){this.f(k.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...D):console.log(v,...D))}error(v,...D){this.f(k.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...D):console.error(v,...D))}dispose(){}flush(){}}e.$Zi=E;class t extends h{constructor(v,D=e.$Ui){super(),this.g=v,this.setLevel(D)}trace(v,...D){this.f(k.Trace)&&this.g.log(k.Trace,[this.h(v),...D])}debug(v,...D){this.f(k.Debug)&&this.g.log(k.Debug,[this.h(v),...D])}info(v,...D){this.f(k.Info)&&this.g.log(k.Info,[this.h(v),...D])}warn(v,...D){this.f(k.Warning)&&this.g.log(k.Warning,[this.h(v),...D])}error(v,...D){this.f(k.Error)&&this.g.log(k.Error,[this.h(v),...D])}h(v){return typeof v=="string"?v:(0,L.$ai)(v,this.f(k.Trace))}dispose(){}flush(){}}e.$1i=t;class o extends h{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const D of this.g)D.setLevel(v);super.setLevel(v)}trace(v,...D){for(const W of this.g)W.trace(v,...D)}debug(v,...D){for(const W of this.g)W.debug(v,...D)}info(v,...D){for(const W of this.g)W.info(v,...D)}warn(v,...D){for(const W of this.g)W.warn(v,...D)}error(v,...D){for(const W of this.g)W.error(v,...D)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose()}}e.$2i=o;class i extends A.$lb{constructor(v,D,W){if(super(),this.h=v,this.j=D,this.b=new N.$ni,this.c=this.B(new j.$ec),this.onDidChangeLoggers=this.c.event,this.f=this.B(new j.$ec),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new j.$ec),this.onDidChangeVisibility=this.g.event,W)for(const _ of W)this.b.set(_.resource,{logger:void 0,info:_})}k(v){return(0,l.$ie)(v)?[...this.b.values()].find(D=>D.info.id===v):this.b.get(v)}getLogger(v){return this.k(v)?.logger}createLogger(v,D){const W=this.l(v),_=(0,l.$ie)(v)?v:D?.id??(0,R.$di)(W.toString()).toString(16);let x=this.b.get(W)?.logger;const le=D?.logLevel==="always"?k.Trace:D?.logLevel;x||(x=this.m(W,le??this.getLogLevel(W)??this.h,{...D,id:_}));const te={logger:x,info:{resource:W,id:_,logLevel:le,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(te.info),this.b.set(W,te),x}l(v){return(0,l.$ie)(v)?(0,u.$9f)(this.j,`${v}.log`):v}setLogLevel(v,D){if(w.URI.isUri(v)){const W=v,_=D,x=this.b.get(W);x&&_!==x.info.logLevel&&(x.info.logLevel=_===this.h?void 0:_,x.logger?.setLevel(_),this.b.set(x.info.resource,x),this.f.fire([W,_]))}else{this.h=v;for(const[W,_]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,D){const W=this.k(v);W&&D!==!W.info.hidden&&(W.info.hidden=!D,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,D]))}getLogLevel(v){let D;return v&&(D=this.b.get(v)?.info.logLevel),D??this.h}registerLogger(v){const D=this.b.get(v.resource);D?D.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const D=this.b.get(v);D&&(D.logger&&D.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=i;class s{constructor(){this.onDidChangeLogLevel=new j.$ec().event}setLevel(v){}getLevel(){return k.Info}trace(v,...D){}debug(v,...D){}info(v,...D){}warn(v,...D){}error(v,...D){}critical(v,...D){}dispose(){}flush(){}}e.$4i=s;class n extends s{}e.$5i=n;function r(I){if(I.verbose)return k.Trace;if(typeof I.logLevel=="string"){const v=S(I.logLevel.toLowerCase());if(v!==void 0)return v}return e.$Ui}e.$6i=r;function c(I){switch(I){case k.Trace:return"trace";case k.Debug:return"debug";case k.Info:return"info";case k.Warning:return"warn";case k.Error:return"error";case k.Off:return"off"}}e.$7i=c;function S(I){switch(I){case"trace":return k.Trace;case"debug":return k.Debug;case"info":return k.Info;case"warn":return k.Warning;case"error":return k.Error;case"critical":return k.Error;case"off":return k.Off}}e.$8i=S,e.$9i=new O.$Oi("logLevel",c(k.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,j,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class w extends N.$lb{constructor(m,d){super(),this.a=m,this.b=d,this.c=this.B(new A.$ec),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ec),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new j.$sg(0)),this.s=[],this.t=this.B(new j.$sg(0))}watch(m,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(m,d):this.u(m,d)}l(m,d){const b={path:this.C(m),excludes:d.excludes,includes:d.includes,recursive:d.recursive},k=(0,L.$yf)(this.j,b);return this.m(),(0,N.$jb)(()=>{k(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,R.$Y)(m))}n(){this.h||(this.h=this.B(this.p(d=>this.c.fire((0,u.$zp)(d)),d=>this.z(d),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const d of this.j)(0,u.$vp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const d of this.j)(0,u.$vp)(d)&&m.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,d){const b={path:this.C(m),excludes:d.excludes,includes:d.includes,recursive:!1},k=(0,L.$yf)(this.s,b);return this.v(),(0,N.$jb)(()=>{k(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,R.$Y)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,u.$zp)(m)),m=>this.z(m),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,y.$6c)(m.fsPath)}}e.$Dp=w}),define(ne[122],re([0,1,19,8,14,20,4,42,65,2,46,15,123,17,41,99,12,61,6,9]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let p=class extends l.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new N.$ec),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$ec),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$ec),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.$ec),this.onDidRunOperation=this.m.event,this.R=this.B(new N.$ec),this.onDidFilesChange=this.R.event,this.S=this.B(new N.$ec),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new j.$Dg)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const i=new l.$kb;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),i.add(o.onDidChangeFile(s=>this.R.fire(new $.$$j(s,!this.O(o))))),typeof o.onDidWatchError=="function"&&i.add(o.onDidWatchError(s=>this.S.fire(new Error(s)))),i.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,l.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,l.$gb)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(i){o.push(i)}}),!this.h.has(t)&&await j.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&o)}listCapabilities(){return u.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,d.$ag)(t))throw new $.$ak((0,k.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const i=new P.$ab;throw i.message=(0,k.localize)(1,null,t.toString()),i}return o}async k(t){const o=await this.j(t);if((0,$.$Xj)(o)||(0,$.$Uj)(o)||(0,$.$Yj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const o=await this.j(t);if((0,$.$Xj)(o)||(0,$.$Uj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.n(t,o)}catch(i){throw(0,$.$8j)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$ak((0,k.localize)(2,null,this.nb(t)),1):(0,$.$6j)(i)}}async n(t,o){const i=await this.j(t),s=this.O(i),n=o?.resolveTo,r=o?.resolveSingleChildDescendants,c=o?.resolveMetadata,S=await i.stat(t);let I;return this.p(i,t,S,void 0,!!c,(v,D)=>(I||(I=w.$vh.forUris(()=>!s),I.set(t,!0),n&&I.fill(!0,n)),I.get(v.resource)||I.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&r?D===1:!1))}async p(t,o,i,s,n,r){const{providerExtUri:c}=this.N(t),S={resource:o,name:c.basename(o),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$lk)({mtime:i.mtime,size:i.size}),children:void 0};if(S.isDirectory&&r(S,s)){try{const I=await t.readdir(o),v=await j.Promises.settled(I.map(async([D,W])=>{try{const _=c.joinPath(o,D),x=n?await t.stat(_):{type:W};return await this.p(t,_,x,I.length,n,r)}catch(_){return this.b.trace(_),null}}));S.children=(0,L.$jf)(v)}catch(I){this.b.trace(I),S.children=[]}return S}return S}async resolveAll(t){return j.Promises.settled(t.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),i=await o.stat(t);return this.p(o,t,i,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.r(t,o)}catch(i){return i}return!0}async r(t,o){if(!o?.overwrite&&await this.exists(t))throw new $.$ak((0,k.localize)(3,null,this.nb(t)),3,o)}async createFile(t,o=R.$Ec.fromString(""),i){await this.r(t,i);const s=await this.writeFile(t,o);return this.m.fire(new $.$0j(t,0,s)),s}async writeFile(t,o,i){const s=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(s);try{await this.s(s,t,i)||await this.P(s,n.dirname(t));let c;if((0,$.$Uj)(s)&&!(o instanceof R.$Ec))if((0,b.$qc)(o)){const S=await(0,b.$xc)(o,3);S.ended?c=R.$Ec.concat(S.buffer):c=S}else c=(0,b.$uc)(o,S=>R.$Ec.concat(S),3);else c=o;if(!(0,$.$Xj)(s)||(0,$.$Uj)(s)&&c instanceof R.$Ec)await this.cb(s,t,i,c);else{const S=c instanceof R.$Ec?(0,R.$Pc)(c):c;i?.atomic!==!1&&i?.atomic?.postfix?await this.Y(s,t,(0,d.$9f)((0,d.$8f)(t),`${(0,d.$6f)(t)}${i.atomic.postfix}`),i,S):await this.Z(s,t,i,S)}this.m.fire(new $.$0j(t,4))}catch(r){throw new $.$ak((0,k.localize)(4,null,this.nb(t),(0,$.$6j)(r).toString()),(0,$.$9j)(r),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,o,i){const s=!!i?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,k.localize)(5,null,this.nb(o)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,k.localize)(6,null,this.nb(o)));if(s)throw new Error((0,k.localize)(7,null,this.nb(o)))}let r;try{r=await t.stat(o)}catch{return}if(r.type&$.FileType.Directory)throw new $.$ak((0,k.localize)(8,null,this.nb(o)),0,i);if(this.mb(o,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$kk&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,$.$lk)({mtime:i.mtime,size:r.size}))throw new $.$ak((0,k.localize)(9,null),3,i);return r}async readFile(t,o,i){const s=await this.k(t);return o?.atomic?this.t(s,t,o,i):this.u(s,t,o,i)}async t(t,o,i,s){return new Promise((n,r)=>{this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{try{const c=await this.u(t,o,i,s);n(c)}catch(c){r(c)}})})}async u(t,o,i,s){const n=await this.v(t,o,{...i,preferUnbuffered:!0},s);return{...n,value:await(0,R.$Qc)(n.value)}}async readFileStream(t,o,i){const s=await this.k(t);return this.v(s,t,o,i)}async v(t,o,i,s){const n=new A.$oc(s),r=this.F(o,i).then(S=>S,S=>{throw n.cancel(),S});let c;try{return typeof i?.etag=="string"&&i.etag!==$.$kk&&await r,i?.atomic&&(0,$.$Zj)(t)||!((0,$.$Xj)(t)||(0,$.$Yj)(t))||(0,$.$Uj)(t)&&i?.preferUnbuffered?c=this.D(t,o,i):(0,$.$Yj)(t)?c=this.z(t,o,n.token,i):c=this.C(t,o,n.token,i),{...await r,value:c}}catch(S){throw c&&await(0,b.$vc)(c),this.w(S,o,i)}}w(t,o,i){const s=(0,k.localize)(10,null,this.nb(o),(0,$.$6j)(t).toString());return t instanceof $.$ck?new $.$ck(s,t.stat,i):t instanceof $.$bk?new $.$bk(s,t.fileOperationResult,t.size,t.options):new $.$ak(s,(0,$.$9j)(t),i)}z(t,o,i,s=Object.create(null)){const n=t.readFileStream(o,s,i);return(0,b.$Bc)(n,{data:r=>r instanceof R.$Ec?r:R.$Ec.wrap(r),error:r=>this.w(r,o,s)},r=>R.$Ec.concat(r))}C(t,o,i,s=Object.create(null)){const n=(0,R.$Uc)();return(0,f.$tp)(t,o,n,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.w(r,o,s)},i),n}D(t,o,i){const s=(0,b.$sc)(n=>R.$Ec.concat(n));return(async()=>{try{let n;i?.atomic&&(0,$.$Zj)(t)?n=await t.readFile(o,{atomic:!0}):n=await t.readFile(o),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.G(o,n.byteLength,i),s.end(R.$Ec.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async F(t,o){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new $.$ak((0,k.localize)(11,null,this.nb(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==$.$kk&&o.etag===i.etag)throw new $.$ck((0,k.localize)(12,null),i,o);return this.G(t,i.size,o),i}G(t,o,i){if(typeof i?.limits?.size=="number"&&o>i.limits.size)throw new $.$bk((0,k.localize)(13,null,this.nb(t)),7,o,i)}async canMove(t,o,i){return this.H(t,o,"move",i)}async canCopy(t,o,i){return this.H(t,o,"copy",i)}async H(t,o,i,s){if(t.toString()!==o.toString())try{const n=i==="move"?this.lb(await this.l(t),t):await this.k(t),r=this.lb(await this.l(o),o);await this.M(n,t,r,o,i,s)}catch(n){return n}return!0}async move(t,o,i){const s=this.lb(await this.l(t),t),n=this.lb(await this.l(o),o),r=await this.I(s,t,n,o,"move",!!i),c=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new $.$0j(t,r==="move"?2:3,c)),c}async copy(t,o,i){const s=await this.k(t),n=this.lb(await this.l(o),o),r=await this.I(s,t,n,o,"copy",!!i),c=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new $.$0j(t,r==="copy"?3:2,c)),c}async I(t,o,i,s,n,r){if(o.toString()===s.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:S}=await this.M(t,o,i,s,n,r);if(c&&!S&&r&&await this.del(s,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(s)),n==="copy"){if(t===i&&(0,$.$Vj)(t))await t.copy(o,s,{overwrite:r});else{const I=await this.resolve(o);I.isDirectory?await this.L(t,I,i,s):await this.J(t,o,i,s)}return n}else return t===i?(await t.rename(o,s,{overwrite:r}),n):(await this.I(t,o,i,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async J(t,o,i,s){if((0,$.$Xj)(t)&&(0,$.$Xj)(i))return this.eb(t,o,i,s);if((0,$.$Xj)(t)&&(0,$.$Uj)(i))return this.kb(t,o,i,s);if((0,$.$Uj)(t)&&(0,$.$Xj)(i))return this.ib(t,o,i,s);if((0,$.$Uj)(t)&&(0,$.$Uj)(i))return this.gb(t,o,i,s)}async L(t,o,i,s){await i.mkdir(s),Array.isArray(o.children)&&await j.Promises.settled(o.children.map(async n=>{const r=this.N(i).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),i,r):this.J(t,n.resource,i,r)}))}async M(t,o,i,s,n,r){let c=!1;if(t===i){const{providerExtUri:I,isPathCaseSensitive:v}=this.N(t);if(v||(c=I.isEqual(o,s)),c&&n==="copy")throw new Error((0,k.localize)(14,null,this.nb(o),this.nb(s)));if(!c&&I.isEqualOrParent(s,o))throw new Error((0,k.localize)(15,null,this.nb(o),this.nb(s)))}const S=await this.exists(s);if(S&&!c){if(!r)throw new $.$ak((0,k.localize)(16,null,this.nb(o),this.nb(s)),4);if(t===i){const{providerExtUri:I}=this.N(t);if(I.isEqualOrParent(o,s))throw new Error((0,k.localize)(17,null,this.nb(o),this.nb(s)))}}return{exists:S,isSameResourceWithDifferentPathCase:c}}N(t){const o=this.O(t);return{providerExtUri:o?d.$Yf:d.$1f,isPathCaseSensitive:o}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.lb(await this.j(t),t);await this.P(o,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new $.$0j(t,0,i)),i}async P(t,o){const i=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(o,s.dirname(o));)try{if(!((await t.stat(o)).type&$.FileType.Directory))throw new Error((0,k.localize)(18,null,this.nb(o)));break}catch(n){if((0,$.$8j)(n)!==$.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(s.basename(o)),o=s.dirname(o)}for(let n=i.length-1;n>=0;n--){o=s.joinPath(o,i[n]);try{await t.mkdir(o)}catch(r){if((0,$.$8j)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,o){try{await this.Q(t,o)}catch(i){return i}return!0}async Q(t,o){const i=this.lb(await this.j(t),t),s=!!o?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,k.localize)(19,null,this.nb(t)));const n=o?.atomic;if(n&&!(i.capabilities&65536))throw new Error((0,k.localize)(20,null,this.nb(t)));if(s&&n)throw new Error((0,k.localize)(21,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new $.$ak((0,k.localize)(22,null,this.nb(t)),1);if(!!!o?.recursive){const S=await this.resolve(t);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,k.localize)(23,null,this.nb(t)))}return i}async del(t,o){const i=await this.Q(t,o),s=!!o?.useTrash,n=!!o?.recursive,r=o?.atomic??!1;await i.delete(t,{recursive:n,useTrash:s,atomic:r}),this.m.fire(new $.$0j(t,1))}async cloneFile(t,o){const i=await this.j(t),s=this.lb(await this.l(o),o);if(i===s&&this.N(i).providerExtUri.isEqual(t,o))return;if(i===s&&(0,$.$Wj)(i))return i.cloneFile(t,o);await this.P(s,this.N(s).providerExtUri.dirname(o));const n=this.X.queueFor(t,this.N(i).providerExtUri);return i===s&&(0,$.$Vj)(i)?n.queue(()=>i.copy(t,o,{overwrite:!0})):n.queue(()=>this.J(i,t,s,o))}watch(t,o={recursive:!1,excludes:[]}){const i=new l.$kb;let s=!1,n=()=>{s=!0};return i.add((0,l.$jb)(()=>n())),(async()=>{try{const r=await this.W(t,o);s?(0,l.$gb)(r):n=()=>(0,l.$gb)(r)}catch(r){this.b.error(r)}})(),i}async W(t,o){const i=await this.j(t),s=(0,y.$di)([this.N(i).providerExtUri.getComparisonKey(t),o]);let n=this.U.get(s);return n||(n={count:0,disposable:i.watch(t,o)},this.U.set(s,n)),n.count+=1,(0,l.$jb)(()=>{n&&(n.count--,n.count===0&&((0,l.$gb)(n.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.$gb)(t.disposable);this.U.clear()}async Y(t,o,i,s,n){await this.Z(t,i,s,n);try{await t.rename(i,o,{overwrite:!0})}catch(r){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async Z(t,o,i,s){return this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(o,{create:!0,unlock:i?.unlock??!1});try{(0,b.$qc)(s)||(0,b.$rc)(s)?await this.$(t,n,s):await this.ab(t,n,s)}catch(r){throw(0,$.$6j)(r)}finally{await t.close(n)}})}async $(t,o,i){let s=0,n;if((0,b.$rc)(i)){if(i.buffer.length>0){const r=R.$Ec.concat(i.buffer);await this.bb(t,o,r,r.byteLength,s,0),s+=r.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((r,c)=>{(0,b.$wc)(n,{onData:async S=>{n.pause();try{await this.bb(t,o,S,S.byteLength,s,0)}catch(I){return c(I)}s+=S.byteLength,setTimeout(()=>n.resume())},onError:S=>c(S),onEnd:()=>r()})})}async ab(t,o,i){let s=0,n;for(;(n=i.read())!==null;)await this.bb(t,o,n,n.byteLength,s,0),s+=n.byteLength}async bb(t,o,i,s,n,r){let c=0;for(;c<s;){const S=await t.write(o,n+c,i.buffer,r+c,s-c);c+=S}}async cb(t,o,i,s){return this.X.queueFor(o,this.N(t).providerExtUri).queue(()=>this.db(t,o,i,s))}async db(t,o,i,s){let n;s instanceof R.$Ec?n=s:(0,b.$qc)(s)?n=await(0,R.$Qc)(s):(0,b.$rc)(s)?n=await(0,R.$Rc)(s):n=(0,R.$Oc)(s),await t.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async eb(t,o,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.fb(t,o,i,s))}async fb(t,o,i,s){let n,r;try{n=await t.open(o,{create:!1}),r=await i.open(s,{create:!0,unlock:!1});const c=R.$Ec.alloc(this.a);let S=0,I=0,v=0;do v=await t.read(n,S,c.buffer,I,c.byteLength-I),await this.bb(i,r,c,v,S,I),S+=v,I+=v,I===c.byteLength&&(I=0);while(v>0)}catch(c){throw(0,$.$6j)(c)}finally{await j.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async gb(t,o,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.hb(t,o,i,s))}async hb(t,o,i,s){return i.writeFile(s,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,o,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.jb(t,o,i,s))}async jb(t,o,i,s){const n=await i.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(o);await this.bb(i,n,R.$Ec.wrap(r),r.byteLength,0,0)}catch(r){throw(0,$.$6j)(r)}finally{await i.close(n)}}async kb(t,o,i,s){const n=await(0,R.$Qc)(this.C(t,o,A.CancellationToken.None));await this.cb(i,s,void 0,n)}lb(t,o){if(t.capabilities&2048)throw new $.$ak((0,k.localize)(24,null,this.nb(o)),6);return t}mb(t,o){if((o.permissions??0)&$.FilePermission.Readonly)throw new $.$ak((0,k.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===O.Schemas.file?t.fsPath:t.toString(!0)}};e.$up=p,e.$up=p=$e([se(0,h.$Ri)],p)}),define(ne[124],re([0,1,125,169,8,35,14,4,170,2,16,13,17,41,24,101,12,61,121,33,119,118]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0,(()=>{try{(0,j.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,P.$ai)(o)}`)}})();class t extends h.$Dp{static{this.D=!1}constructor(i,s){super(i,s),this.onDidChangeCapabilities=y.Event.None,this.I=new A.$ni(n=>m.$Zf.getComparisonKey(n)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,O.$k&&(this.F|=1024)),this.F}async stat(i){try{const{stat:s,symbolicLink:n}=await b.SymlinkSupport.stat(this.C(i));return{type:this.H(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:$.FilePermission.Locked}}catch(s){throw this.ab(s)}}async G(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const s=await b.Promises.readdir(this.C(i),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async r=>{try{let c;r.isSymbolicLink()?c=(await this.stat((0,m.$9f)(i,r.name))).type:c=this.H(r),n.push([r.name,c])}catch(c){this.a.trace(c)}})),n}catch(s){throw this.ab(s)}}H(i,s){let n;return s?.dangling?n=$.FileType.Unknown:i.isFile()?n=$.FileType.File:i.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,s&&(n|=$.FileType.SymbolicLink),n}async J(i){const s=this.C(i);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let n;for(;n=this.I.get(i);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await n.wait();const r=new R.$tg;return this.I.set(i,r),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,l.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.I.get(i)===r&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.I.delete(i)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(i,s){let n;try{s?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),n=await this.J(i));const r=this.C(i);return await b.Promises.readFile(r)}catch(r){throw this.ab(r)}finally{n?.dispose()}}L(i){t.D&&this.a.trace(i)}readFileStream(i,s,n){const r=(0,d.$sc)(c=>N.$Ec.concat(c.map(S=>N.$Ec.wrap(S))).buffer);return(0,f.$tp)(this,i,r,c=>c.buffer,{...s,bufferSize:256*1024},n),r}async writeFile(i,s,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.M(i,(0,m.$9f)((0,m.$8f)(i),`${(0,m.$6f)(i)}${n.atomic.postfix}`),s,n):this.N(i,s,n)}async M(i,s,n,r){await this.N(s,n,r);try{await this.rename(s,i,{overwrite:!0})}catch(c){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async N(i,s,n){let r;try{const c=this.C(i);if(!n.create||!n.overwrite){if(await b.Promises.exists(c)){if(!n.overwrite)throw(0,$.$5j)((0,k.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$5j)((0,k.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(c){throw await this.bb(i,c)}finally{typeof r=="number"&&await this.close(r)}}static{this.R=!0}static configureFlushOnWrite(i){t.R=i}async open(i,s){const n=this.C(i);let r;(0,$.$Tj)(s)&&(r=await this.J(i));let c;try{if((0,$.$Tj)(s)&&s.unlock)try{const{stat:I}=await b.SymlinkSupport.stat(n);I.mode&128||await b.Promises.chmod(n,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let S;if((0,$.$Tj)(s)){if(O.$i)try{await b.Promises.truncate(n,0),S="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}S||(S="w")}else S="r";c=await b.Promises.open(n,S)}catch(S){throw r?.dispose(),(0,$.$Tj)(s)?await this.bb(i,S):this.ab(S)}if(this.O.set(c,0),(0,$.$Tj)(s)&&this.Q.set(c,i),r){const S=this.P.get(c);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${n})`),this.P.set(c,r),S&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${n})`),S.dispose())}return c}async close(i){const s=this.P.get(i);try{if(this.O.delete(i),this.Q.delete(i)&&t.R)try{await b.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await b.Promises.close(i)}catch(n){throw this.ab(n)}finally{s&&(this.P.get(i)===s&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.P.delete(i)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,n,r,c){const S=this.S(i,s);let I=null;try{I=(await b.Promises.read(i,n,r,c,S)).bytesRead}catch(v){throw this.ab(v)}finally{this.U(i,S,I)}return I}S(i,s){return s===this.O.get(i)?null:s}U(i,s,n){const r=this.O.get(i);typeof r=="number"&&(typeof s=="number"||(typeof n=="number"?this.O.set(i,r+n):this.O.delete(i)))}async write(i,s,n,r,c){return(0,R.$Mg)(()=>this.W(i,s,n,r,c),100,3)}async W(i,s,n,r,c){const S=this.S(i,s);let I=null;try{I=(await b.Promises.write(i,n,r,c,S)).bytesWritten}catch(v){throw await this.bb(this.Q.get(i),v)}finally{this.U(i,S,I)}return I}async mkdir(i){try{await b.Promises.mkdir(this.C(i))}catch(s){throw this.ab(s)}}async delete(i,s){try{const n=this.C(i);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,w.$8c)((0,w.$$c)(n),`${(0,w.$_c)(n)}${s.atomic.postfix}`)),await b.Promises.rm(n,b.RimRafMode.MOVE,r)}else try{await b.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let c=!1;try{const{stat:S,symbolicLink:I}=await b.SymlinkSupport.stat(n);c=S.isDirectory()&&!I}catch{}if(c)await b.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.ab(n)}}async rename(i,s,n){const r=this.C(i),c=this.C(s);if(r!==c)try{await this.X(i,s,"move",n.overwrite),await b.Promises.rename(r,c)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,k.localize)(2,null,(0,w.$_c)(r),(0,w.$_c)((0,w.$$c)(c)),S.toString()))),this.ab(S)}}async copy(i,s,n){const r=this.C(i),c=this.C(s);if(r!==c)try{await this.X(i,s,"copy",n.overwrite),await b.Promises.copy(r,c,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,k.localize)(3,null,(0,w.$_c)(r),(0,w.$_c)((0,w.$$c)(c)),S.toString()))),this.ab(S)}}async X(i,s,n,r){const c=this.C(i),S=this.C(s);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$Ge)(c,S,!0)),I){if(n==="copy")throw(0,$.$5j)((0,k.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const D=await this.G(i);if(!D)throw(0,$.$5j)((0,k.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const W=await this.G(s);if(W){if(!r)throw(0,$.$5j)((0,k.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);D.type&$.FileType.File&&W.type&$.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,s){return this.Y(i,s,!1)}async Y(i,s,n){const r=this.C(i),c=this.C(s),S=!!(this.capabilities&1024);if((0,u.$Ge)(r,c,!S))return;const I=new l.$kb;try{const[v,D]=await Promise.all([this.J(i),this.J(s)]);I.add(v),I.add(D),n&&await b.Promises.mkdir((0,w.$$c)(c),{recursive:!0}),await b.Promises.copyFile(r,c)}catch(v){if(v.code==="ENOENT"&&!n)return this.Y(i,s,!0);throw this.ab(v)}finally{I.dispose()}}p(i,s,n){return new p.$Kp(r=>i(r),r=>s(r),n)}y(i,s,n){return new E.$Sp(r=>i(r),r=>s(r),n)}ab(i){if(i instanceof $.$4j)return i;let s=i,n;switch(i.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$5j)(s,n)}async bb(i,s){let n=this.ab(s);if(i&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await b.SymlinkSupport.stat(this.C(i));r.mode&128||(n=(0,$.$5j)(s,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$Tp=t}),define(ne[126],re([0,1,2,6]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class R extends L.$lb{constructor(N,y=[]){super(),this.a=new j.$2i([N,...y]),this.B(N.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...y){this.a.trace(N,...y)}debug(N,...y){this.a.debug(N,...y)}info(N,...y){this.a.info(N,...y)}warn(N,...y){this.a.warn(N,...y)}error(N,...y){this.a.error(N,...y)}flush(){this.a.flush()}}e.$9M=R}),define(ne[127],re([0,1,12,6]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0;var R;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(R||(R={}));async function A(l,w,O,m,d){try{const b=await new Promise(($,f)=>{J(["@vscode/spdlog"],$,f)});b.setFlushOn(R.Trace);const k=await b.createAsyncRotatingLogger(l,w,O,m);return d?k.clearFormatters():k.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),k}catch(b){console.error(b)}return null}function N(l,w,O){switch(w){case j.LogLevel.Trace:l.trace(O);break;case j.LogLevel.Debug:l.debug(O);break;case j.LogLevel.Info:l.info(O);break;case j.LogLevel.Warning:l.warn(O);break;case j.LogLevel.Error:l.error(O);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function y(l,w){switch(w){case j.LogLevel.Trace:l.setLevel(R.Trace);break;case j.LogLevel.Debug:l.setLevel(R.Debug);break;case j.LogLevel.Info:l.setLevel(R.Info);break;case j.LogLevel.Warning:l.setLevel(R.Warning);break;case j.LogLevel.Error:l.setLevel(R.Error);break;case j.LogLevel.Off:l.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class u extends j.$Xi{constructor(w,O,m,d,b){super(),this.k=[],this.setLevel(b),this.l=this.n(w,O,m,d),this.B(this.onDidChangeLogLevel(k=>{this.m&&y(this.m,k)}))}async n(w,O,m,d){const b=m?6:1,k=30/b*L.$nk.MB,$=await A(w,O,k,b,d);if($){this.m=$,y(this.m,this.getLevel());for(const{level:f,message:h}of this.k)N(this.m,f,h);this.k=[]}}g(w,O){this.m?N(this.m,w,O):this.getLevel()<=w&&this.k.push({level:w,message:O})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$XM=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=void 0;class A extends j.$3i{m(y,u,l){return new R.$XM((0,L.$3e)(),y.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.$YM=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=e.$Wm=void 0,e.$Wm=(0,A.$ph)("policy");class N extends R.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$ec),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const w=Object.keys(this.f).length;return this.f={...l,...this.f},w!==Object.keys(this.f).length&&await this.i(l),j.Iterable.reduce(this.g.entries(),(O,[m,d])=>({...O,[m]:d}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return j.Iterable.reduce(Object.entries(this.f),(l,[w,O])=>({...l,[w]:{definition:O,value:this.g.get(w)}}),{})}}e.$Xm=N;class y{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Ym=y}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,j,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;function l(O,m){const d=[];for(const b of new Set(R.Iterable.concat(O.keys(),m.keys())))O.get(b)!==m.get(b)&&d.push(b);return d}let w=class extends u.$Xm{constructor(m,d,b){super(),this.j=m,this.k=d,this.l=b,this.c=this.B(new L.$sg(500));const k=j.Event.filter(d.onDidFilesChange,$=>$.affects(m));this.B(d.watch(m)),this.B(k(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const m=new Map;try{const d=await this.k.readFile(this.j),b=JSON.parse(d.value.toString());if(!(0,A.$ke)(b))throw new Error("Policy file isn't a JSON object");for(const k of Object.keys(b))this.f[k]&&m.set(k,b[k])}catch(d){d.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",d)}return m}async p(){const m=await this.n(),d=l(this.g,m);this.g=m,d.length>0&&this.h.fire(d)}};e.$A6b=w,e.$A6b=w=$e([se(1,N.$Sj),se(2,y.$Ri)],w)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,j,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=void 0;let y=class extends L.$Xm{constructor(l,w){super(),this.j=l,this.k=w,this.a=new j.$og,this.b=this.B(new A.$mb)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((w,O)=>{try{this.b.value=(0,R.createWatcher)(this.k,l,m=>{this.m(m),w()})}catch(m){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),O(m)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const w in l){const O=l[w];O===void 0?this.g.delete(w):this.g.set(w,O)}this.h.fire(Object.keys(l))}};e.$z6b=y,e.$z6b=y=$e([se(0,N.$Ri)],y)}),define(ne[31],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,L.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0;class R{constructor(){this.a=new Map}add(N,y){L.ok(j.$ie(N)),L.ok(j.$ke(y)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,y)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$Um=new R}),define(ne[131],re([0,1,4,36]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0,e.$Vm={JSONContribution:"base.contributions.json"};function R(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class A{constructor(){this.b=new L.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,l){this.a[R(u)]=l,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const N=new A;j.$Um.add(e.$Vm.JSONContribution,N)}),define(ne[44],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,j,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ConfigurationScope=e.$Zm=e.EditPresentationTypes=void 0;var l;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Zm={Configuration:"base.contributions.configuration"};var w;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w||(e.ConfigurationScope=w={})),e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m={properties:{},patternProperties:{}},e.$7m="vscode://schemas/settings/resourceLanguage",e.$8m="vscode://schemas/settings/configurationDefaults";const O=u.$Um.as(y.$Vm.JSONContribution);class m{constructor(){this.h=new Set,this.i=new j.$ec,this.onDidSchemaChange=this.i.event,this.j=new j.$ec,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$7m,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const i=new Set;this.n(t,o,i),O.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const o=new Set;this.o(t,o),O.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const i=new Set;this.o(o,i),this.n(t,!1,i),O.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const i=[];for(const{overrides:s,source:n}of t)for(const r in s)if(o.add(r),e.$0m.test(r)){const c=this.a.get(r),S=c?.valuesSources??new Map;if(n)for(const W of Object.keys(s[r]))S.set(W,n);const I={...c?.value||{},...s[r]};this.a.set(r,{source:n,value:I,valuesSources:S});const v=(0,N.$6h)(r),D={type:"object",default:I,description:A.localize(1,null,v),$ref:e.$7m,defaultDefaultValue:I,source:R.$ie(n)?void 0:n,defaultValueSource:n};i.push(...k(r)),this.d[r]=D,this.b.properties[r]=D}else{this.a.set(r,{value:s[r],source:n});const c=this.d[r];c&&(this.w(r,c),this.r(r,c))}this.m(i)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:i,source:s}of t)for(const n in i){const r=this.a.get(n),c=R.$ie(s)?s:s?.id,S=R.$ie(r?.source)?r?.source:r?.source?.id;if(c===S)if(o.add(n),this.a.delete(n),e.$0m.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,i){t.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,o){const i=s=>{if(s.properties)for(const n in s.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,s.properties[n])}s.allOf?.forEach(n=>i(n))};for(const s of t){i(s);const n=this.c.indexOf(s);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,i,s,n=3,r){n=R.$re(t.scope)?n:t.scope;const c=t.properties;if(c)for(const I in c){const v=c[I];if(o&&P(I,v)){delete c[I];continue}if(v.source=i,v.defaultDefaultValue=c[I].default,this.w(I,v),e.$0m.test(I)?v.scope=void 0:(v.scope=R.$re(v.scope)?n:v.scope,v.restricted=R.$re(v.restricted)?!!s?.includes(I):v.restricted),c[I].hasOwnProperty("included")&&!c[I].included){this.f[I]=c[I],delete c[I];continue}else this.d[I]=c[I],c[I].policy?.name&&this.e.set(c[I].policy.name,I);!c[I].deprecationMessage&&c[I].markdownDeprecationMessage&&(c[I].deprecationMessage=c[I].markdownDeprecationMessage),r.add(I)}const S=t.allOf;if(S)for(const I of S)this.p(I,o,i,s,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=i=>{const s=i.properties;if(s)for(const r in s)this.r(r,s[r]);i.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$1m.properties[t]=o,o.scope){case 1:e.$2m.properties[t]=o;break;case 2:e.$3m.properties[t]=o;break;case 6:e.$4m.properties[t]=o;break;case 3:e.$5m.properties[t]=o;break;case 4:e.$6m.properties[t]=o;break;case 5:e.$6m.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$1m.properties[t],o.scope){case 1:delete e.$2m.properties[t];break;case 2:delete e.$3m.properties[t];break;case 6:delete e.$4m.properties[t];break;case 3:delete e.$5m.properties[t];break;case 4:case 5:delete e.$6m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$7m};this.w(o,i),e.$1m.properties[o]=i,e.$2m.properties[o]=i,e.$3m.properties[o]=i,e.$4m.properties[o]=i,e.$5m.properties[o]=i,e.$6m.properties[o]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$7m};e.$1m.patternProperties[e.$9m]=t,e.$2m.patternProperties[e.$9m]=t,e.$3m.patternProperties[e.$9m]=t,e.$4m.patternProperties[e.$9m]=t,e.$5m.patternProperties[e.$9m]=t,e.$6m.patternProperties[e.$9m]=t,this.i.fire()}w(t,o){const i=this.a.get(t);let s=i?.value,n=i?.source;R.$pe(s)&&(s=o.defaultDefaultValue,n=void 0),R.$pe(s)&&(s=f(o.type)),o.default=s,o.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",b=new RegExp(d,"g");e.$9m=`^(${d})+$`,e.$0m=new RegExp(e.$9m);function k(E){const t=[];if(e.$0m.test(E)){let o=b.exec(E);for(;o?.length;){const i=o[1].trim();i&&t.push(i),o=b.exec(E)}}return(0,L.$of)(t)}e.$$m=k;function $(E){return E.reduce((t,o)=>`${t}[${o}]`,"")}e.$_m=$;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$an=f;const h=new m;u.$Um.add(e.$Zm.Configuration,h);function P(E,t){return E.trim()?e.$0m.test(E)?A.localize(7,null,E):h.getConfigurationProperties()[E]!==void 0?A.localize(8,null,E):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,E,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$bn=P;function p(){const E=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))E.push([o,t[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$cn=p}),define(ne[66],re([0,1,19,4,53,2,35,30,3,11,25,44,36]),function(J,e,L,j,R,A,N,y,u,l,w,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function d(o){return Object.isFrozen(o)?o:y.$Jm(o)}class b{constructor(i={},s=[],n=[],r){this.b=i,this.c=s,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof b)return s;const n=new k("");return n.parseRaw(s),n.configurationModel});this.f=i.reduce((s,n)=>n===s?n:s.merge(n),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,w.$4h)(this.contents,i):this.contents}inspect(i,s){const n=this.rawConfiguration.getValue(i),r=s?this.rawConfiguration.getOverrideValue(i,s):void 0,c=s?this.rawConfiguration.override(s).getValue(i):n;return{value:n,override:r,merged:c}}getOverrideValue(i,s){const n=this.i(s);return n?i?(0,w.$4h)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const n of this.overrides)n.identifiers.includes(i)&&s.push(...n.keys);return L.$of(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return L.$of(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=y.$Im(this.contents),n=y.$Im(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const S of i)if(c.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(s,S.contents);for(const I of S.overrides){const[v]=n.filter(D=>L.$$e(D.identifiers,I.identifiers));v?(this.h(v.contents,I.contents),v.keys.push(...I.keys),v.keys=L.$of(v.keys)):n.push(y.$Im(I))}for(const I of S.keys)r.indexOf(I)===-1&&r.push(I)}return new b(s,r,n,c.every(S=>S instanceof b)?void 0:c)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const n={};for(const r of L.$of([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[r];const S=s[r];S&&(typeof c=="object"&&typeof S=="object"?(c=y.$Im(c),this.h(c,S)):c=S),n[r]=c}return new b(n,this.keys,this.overrides)}h(i,s){for(const n of Object.keys(s)){if(n in i&&u.$ke(i[n])&&u.$ke(s[n])){this.h(i[n],s[n]);continue}i[n]=y.$Im(s[n])}}i(i){let s=null,n=null;const r=c=>{c&&(n?this.h(n,c):n=y.$Im(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===i?s=c.contents:c.identifiers.includes(i)&&r(c.contents);return r(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,w.$3h)(this.contents,i),O.$0m.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>L.$$e(n.identifiers,(0,O.$$m)(i))),1))}j(i,s,n){(0,w.$2h)(this.contents,i,s,r=>console.error(r)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),O.$0m.test(i)&&this.overrides.push({identifiers:(0,O.$$m)(i),keys:Object.keys(this.contents[i]),contents:(0,w.$1h)(this.contents[i],r=>console.error(r))})}}e.$dn=b;class k{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!u.$re(i)){const n=this.g(i);this.parseRaw(n,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:n,keys:r,overrides:c,restricted:S,hasExcludedProperties:I}=this.h(i,s);this.b=new b(n,r,c,I?[i]:void 0),this.c=S||[]}g(i){let s={},n=null,r=[];const c=[],S=[];function I(D){Array.isArray(r)?r.push(D):n!==null&&(r[n]=D)}const v={onObjectBegin:()=>{const D={};I(D),c.push(r),r=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const D=[];I(D),c.push(r),r=D,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:I,onError:(D,W,_)=>{S.push({error:D,offset:W,length:_})}};if(i)try{R.$Fm(i,v),s=r[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return s}h(i,s){const n=m.$Um.as(O.$Zm.Configuration).getConfigurationProperties(),r=this.i(i,n,!0,s);i=r.raw;const c=(0,w.$1h)(i,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),S=Object.keys(i),I=this.j(i,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:c,keys:S,overrides:I,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(i,s,n,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:c};const S={},I=[];for(const v in i)if(O.$0m.test(v)&&n){const D=this.i(i[v],s,!1,r);S[v]=D.raw,c=c||D.hasExcludedProperties,I.push(...D.restricted)}else{const D=s[v],W=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&I.push(v),!r.exclude?.includes(v)&&(r.include?.includes(v)||(W===void 0||r.scopes===void 0||r.scopes.includes(W))&&!(r.skipRestricted&&D?.restricted))?S[v]=i[v]:c=!0}return{raw:S,restricted:I,hasExcludedProperties:c}}j(i,s){const n=[];for(const r of Object.keys(i))if(O.$0m.test(r)){const c={};for(const S in i[r])c[S]=i[r][S];n.push({identifiers:(0,O.$$m)(r),keys:Object.keys(c),contents:(0,w.$1h)(c,s)})}return n}}e.$en=k;class $ extends A.$lb{constructor(i,s,n,r){super(),this.c=i,this.f=s,this.g=r,this.b=this.B(new j.$ec),this.onDidChange=this.b.event,this.a=new k(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,c=>c.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&n.isEqual(c.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fn=$;class f{constructor(i,s,n,r,c,S,I,v,D,W,_,x,le){this.a=i,this.b=s,this.c=n,this.overrideIdentifiers=r,this.d=c,this.f=S,this.g=I,this.h=v,this.i=D,this.j=W,this.k=_,this.l=x,this.m=le}get value(){return d(this.c)}n(i,s,n){const r=i.inspect(s,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(i,s,n,r,c=new b,S=new b,I=new N.$ni,v=new b,D=new N.$ni){this.c=i,this.d=s,this.f=n,this.g=r,this.h=c,this.i=S,this.j=I,this.l=v,this.m=D,this.a=null,this.b=new N.$ni,this.n=null}getValue(i,s,n){return this.q(i,s,n).getValue(i)}updateValue(i,s,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new b,this.m.set(n.resource,r))):r=this.l,s===void 0?r.removeValue(i):r.setValue(i,s),n.resource||(this.a=null)}inspect(i,s,n){const r=this.q(i,s,n),c=this.u(s.resource,n),S=s.resource?this.m.get(s.resource)||this.l:this.l,I=new Set;for(const v of r.overrides)for(const D of v.identifiers)r.getOverrideValue(i,D)!==void 0&&I.add(D);return new f(i,s,r.getValue(i),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,c||void 0,S)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const n=[];if(!s){const{added:r,updated:c,removed:S}=E(this.c,i);s=[...r,...c,...S]}for(const r of s)for(const c of(0,O.$$m)(r)){const S=this.c.getKeysForOverrideIdentifier(c),I=i.getKeysForOverrideIdentifier(c),v=[...I.filter(D=>S.indexOf(D)===-1),...S.filter(D=>I.indexOf(D)===-1),...S.filter(D=>!y.$Mm(this.c.override(c).getValue(D),i.override(c).getValue(D)))];n.push([c,v])}return this.updateDefaultConfiguration(i),{keys:s,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:n,removed:r}=E(this.d,i),c=[...s,...n,...r];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=E(this.applicationConfiguration,i),S=[...s,...n,...r];return S.length&&this.updateApplicationConfiguration(i),{keys:S,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=E(this.localUserConfiguration,i),S=[...s,...n,...r];return S.length&&this.updateLocalUserConfiguration(i),{keys:S,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=E(this.remoteUserConfiguration,i),S=[...s,...n,...r];return S.length&&this.updateRemoteUserConfiguration(i),{keys:S,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=E(this.workspaceConfiguration,i),S=[...s,...n,...r];return S.length&&this.updateWorkspaceConfiguration(i),{keys:S,overrides:c}}compareAndUpdateFolderConfiguration(i,s){const n=this.p.get(i),{added:r,updated:c,removed:S,overrides:I}=E(n,s),v=[...r,...c,...S];return(v.length||!n)&&this.updateFolderConfiguration(i,s),{keys:v,overrides:I}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:c,overrides:S}=E(s,void 0);return{keys:[...n,...r,...c],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,n){let r=this.r(s,n);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}r({resource:i},s){let n=this.s();if(s&&i){const r=s.getFolder(i);r&&(n=this.t(r.uri)||n);const c=this.m.get(i);c&&(n=n.merge(c))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const n=this.s(),r=this.j.get(i);r?(s=n.merge(r),this.b.set(i,s)):s=n}return s}u(i,s){if(s&&i){const n=s.getFolder(i);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:n,overrides:r,keys:c}=this.j.get(s);return i.push([s,{contents:n,overrides:r,keys:c}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(n=>i.add(n))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.i.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r))),[...s.values()]}static parse(i){const s=this.x(i.defaults),n=this.x(i.policy),r=this.x(i.application),c=this.x(i.user),S=this.x(i.workspace),I=i.folders.reduce((v,D)=>(v.set(l.URI.revive(D[0]),this.x(D[1])),v),new N.$ni);return new h(s,n,r,c,new b,S,I,new b,new N.$ni)}static x(i){return new b(i.contents,i.keys,i.overrides)}}e.$gn=h;function P(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,s=new Map;for(const r of o)r.keys.forEach(c=>i.add(c)),r.overrides.forEach(([c,S])=>{const I=(0,N.$ki)(s,c,new Set);S.forEach(v=>I.add(v))});const n=[];return s.forEach((r,c)=>n.push([c,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.$hn=P;class p{constructor(i,s,n,r){this.change=i,this.f=s,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const S of c)this.affectedKeys.add(S);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(i,s){const n=this.a+i,r=this.d.indexOf(n);if(r<0)return!1;const c=r+n.length;if(c>=this.d.length)return!1;const S=this.d.charCodeAt(c);if(S!==this.b&&S!==this.c)return!1;if(s){const I=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,v=this.g.getValue(i,s,this.h);return!y.$Mm(I,v)}return!0}}e.$in=p;function E(o,i){const{added:s,removed:n,updated:r}=t(i?.rawConfiguration,o?.rawConfiguration),c=[],S=o?.getAllOverrideIdentifiers()||[],I=i?.getAllOverrideIdentifiers()||[];if(i){const v=I.filter(D=>!S.includes(D));for(const D of v)c.push([D,i.getKeysForOverrideIdentifier(D)])}if(o){const v=S.filter(D=>!I.includes(D));for(const D of v)c.push([D,o.getKeysForOverrideIdentifier(D)])}if(i&&o){for(const v of S)if(I.includes(v)){const D=t({contents:o.getOverrideValue(void 0,v)||{},keys:o.getKeysForOverrideIdentifier(v)},{contents:i.getOverrideValue(void 0,v)||{},keys:i.getKeysForOverrideIdentifier(v)});c.push([v,[...D.added,...D.removed,...D.updated]])}}return{added:s,removed:n,updated:r,overrides:c}}function t(o,i){const s=o?i?o.keys.filter(c=>i.keys.indexOf(c)===-1):[...o.keys]:[],n=i?o?i.keys.filter(c=>o.keys.indexOf(c)===-1):[...i.keys]:[],r=[];if(o&&i){for(const c of i.keys)if(o.keys.indexOf(c)!==-1){const S=(0,w.$4h)(i.contents,c),I=(0,w.$4h)(o.contents,c);y.$Mm(S,I)||r.push(c)}}return{added:s,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,44,6,38,36]),function(J,e,L,j,R,A,N,y,u,l,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0;class m extends R.$lb{constructor(){super(...arguments),this.a=this.B(new j.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new y.$dn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$Um.as(u.$Zm.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:f})=>this.c(Array.from($),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,f){this.h($,O.$Um.as(u.$Zm.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new y.$dn;const $=O.$Um.as(u.$Zm.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,f){const h=this.f();for(const P of $){const p=h[P],E=f[P];p!==void 0?this.b.addValue(P,p):E?this.b.addValue(P,E.default):this.b.removeValue(P)}}}e.$jn=m;class d{constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=new y.$dn}async initialize(){return this.configurationModel}}e.$kn=d;let b=class extends R.$lb{get configurationModel(){return this.b}constructor($,f,h){super(),this.c=$,this.f=f,this.g=h,this.a=this.B(new j.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new y.$dn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.i($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.j(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const f={},h=[],P=O.$Um.as(u.$Zm.Configuration).getConfigurationProperties();for(const p of $){const E=P[p];if(!E){h.push(p);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}h.push(p),f[E.policy.name]={type:E.type}}}return(0,N.$ve)(f)||await this.f.updatePolicyDefinitions(f),h}i($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const f=O.$Um.as(u.$Zm.Configuration).getPolicyConfigurations(),h=(0,L.$jf)($.map(P=>f.get(P)));this.j(h,!0)}j($,f){this.g.trace("PolicyConfiguration#update",$);const h=O.$Um.as(u.$Zm.Configuration).getConfigurationProperties(),P=[],p=this.b.isEmpty();for(const E of $){const t=h[E]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(p?o!==void 0:!(0,A.$Mm)(this.b.getValue(E),o))&&P.push([E,o])}else this.b.getValue(E)!==void 0&&P.push([E,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const E=this.b;this.b=new y.$dn;for(const t of E.keys)this.b.setValue(t,E.getValue(t));for(const[t,o]of P)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);f&&this.a.fire(this.b)}}};e.$ln=b,e.$ln=b=$e([se(1,w.$Wm),se(2,l.$Ri)],b)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,j,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class w extends R.$lb{constructor(m,d,b,k){super(),this.i=m,this.h=this.B(new j.$ec),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$jn),this.c=b instanceof l.$Ym?new u.$kn:this.B(new u.$ln(this.b,b,k)),this.f=this.B(new y.$fn(this.i,{},A.$Zf,d)),this.a=new y.$gn(this.b.configurationModel,this.c.configurationModel,new y.$dn,new y.$dn),this.g=this.B(new L.$Gg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:f})=>this.k($,f))),this.B(this.c.onDidChangeConfiguration($=>this.l($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,d,b]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new y.$gn(m,d,new y.$dn,b)}getConfigurationData(){return this.a.toData()}getValue(m,d){const b=typeof m=="string"?m:void 0,k=(0,N.$Wh)(m)?m:(0,N.$Wh)(d)?d:{};return this.a.getValue(b,k,void 0)}updateValue(m,d,b,k){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const d=this.a.toData(),b=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(b,d,2)}k(m,d){const b=this.a.toData(),k=this.a.compareAndUpdateDefaultConfiguration(m,d);this.m(k,b,7)}l(m){const d=this.a.toData(),b=this.a.compareAndUpdatePolicyConfiguration(m);this.m(b,d,7)}m(m,d,b){const k=new y.$in(m,{data:d},this.a);k.source=b,k.sourceConfig=this.n(b),this.h.fire(k)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$mn=w}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function j(l){return l.scheme===L.Schemas.vscodeRemote?l.authority:void 0}e.$Bk=j;function R(l){if(!l)return;const w=l.indexOf("+");return w<0?l:l.substr(0,w)}e.$Ck=R;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$Dk=A;function N(l){const{host:w,port:O}=u(l);if(typeof O>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:O}}e.$Ek=N;function y(l,w){let{host:O,port:m}=u(l);return typeof m>"u"&&(m=w),{host:O,port:m}}e.$Fk=y;function u(l){const w=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const O=l.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const m=l.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:l,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.TargetPlatform=e.ExtensionType=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=void 0,e.$Cl="extensions.user.cache",e.$Dl="extensions.builtin.cache",e.$El="undefined_publisher",e.$Fl=["ui","workspace","web"];function A(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.$Gl=A,e.$Hl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(N||(e.ExtensionType=N={}));var y;(function(k){k.WIN32_X64="win32-x64",k.WIN32_IA32="win32-ia32",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(y||(e.TargetPlatform=y={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,f){if(typeof $>"u"||$===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof $=="string"||typeof f=="string"){const h=typeof $=="string"?$:$.value,P=typeof f=="string"?f:f.value;return L.$Ld(h,P)}return $._lower===f._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Il=u;class l{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const f of $)this.add(f)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$Jl=l;class w{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,f){this.c.set(u.toKey($),f)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Kl=w;function O(k){return m(k)}e.$Ll=O;function m(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.$Ml=m;function d(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.$Nl=d;function b(k,$){if($){const f=`onResolveRemoteAuthority:${(0,R.$Ck)($)}`;return!!k.activationEvents?.includes(f)}return!1}e.$Ol=b,e.$Pl=(0,j.$ph)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;class A extends L.$lb{constructor(y,u,l,w,O){super(),this.a=y,this.b=u,this.c=l,this.f=O,this.B(w.onDidInstallExtensions(m=>this.g(m))),this.B(w.onDidUninstallExtension(m=>this.h(m)))}g(y){for(const u of y)u.local&&this.invalidate(u.profileLocation)}h(y){y.error||this.invalidate(y.profileLocation)}async invalidate(y){if(y)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,y)&&await this.i(u);else await this.i(this.a.defaultProfile)}async i(y){try{await this.b.del(this.c.extUri.joinPath(y.cacheHome,j.$Cl))}catch(u){(0,R.$9j)(u)!==1&&this.f.error(u)}}}e.$np=A}),define(ne[45],re([0,1,14,9,2,103,44,10,6,36]),function(J,e,L,j,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Ao=(0,y.$ph)("requestService");class w{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?E[t]="*****":E[t]=this.b[t];this.a=E}return this.a}}class O extends R.$lb{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,A.localize)(0,null),when:u.$9i.isEqualTo((0,u.$7i)(u.LogLevel.Trace)).serialize()})}async c(E,t,o){const i=`${E} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new w(t.headers??{}));try{const s=await o();return this.a.trace(`${i} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${i} - error`,t.type,(0,j.$9)(s)),s}}}e.$Bo=O;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Co=m;function d(p){return p.res.statusCode===204}async function b(p){return d(p)?null:(await(0,L.$Qc)(p.stream)).toString()}e.$Do=b;async function k(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return b(p)}e.$Eo=k;async function $(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,L.$Qc)(p.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$Fo=$;function f(p){P(p)}e.$Go=f;let h;function P(p){const E=l.$Um.as(N.$Zm.Configuration),t=h;h={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},E.updateConfigurations({add:[h],remove:t?[t]:[]})}P(1)}),define(ne[135],re([0,1,20,15,12,45]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;let N=class{constructor(u,l){this.a=u,this.b=l}async download(u,l,w=L.CancellationToken.None){if(u.scheme===j.Schemas.file||u.scheme===j.Schemas.vscodeRemote){await this.b.copy(u,l);return}const O={type:"GET",url:u.toString(!0)},m=await this.a.request(O,w);if(m.res.statusCode===200)await this.b.writeFile(l,m.stream);else{const d=await(0,A.$Eo)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};e.$lN=N,e.$lN=N=$e([se(0,A.$Ao),se(1,R.$Sj)],N)}),define(ne[136],re([0,1,137,3]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;function R(N,y){return N.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:N.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function A(N,y,u={}){const l=(0,L.parse)(N),w=u.proxyUrl||R(l,y);if(!w)return null;const O=(0,L.parse)(w);if(!/^https?:$/.test(O.protocol||""))return null;const m={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,j.$oe)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((d,b)=>{J(["http-proxy-agent"],d,b)}))(m):new(await new Promise((d,b)=>{J(["https-proxy-agent"],d,b)}))(m)}e.$Eq=A}),define(ne[138],re([0,1,58,16,104,20,33,9,13,28,84,172,8,72]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0;let b;async function k(f,h,P,p){return P["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$tl)(p)&&!P["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$tl)(p)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=m.Promises.withAsyncBody(async(E,t)=>{const o=new A.$oc;let i=1e4;const s=f.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,d.$ul)(s,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{E(await $(h,o.token))}catch(r){!(0,y.$2)(r)&&!o.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,N.$ai)(r)))):E({})}finally{clearTimeout(n),o.dispose()}})),b)}e.$zl=k;async function $(f,h){const P=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",P);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",p);const E=(0,l.$3e)().replace(/-/g,"").substr(0,12),t=new RegExp(E+"({.*})"+E),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",o);const i=await(0,w.$jl)(u.OS,o);return f.trace("getUnixShellEnvironment#shell",i),new Promise((s,n)=>{if(h.isCancellationRequested)return n(new y.$3);const r=(0,j.$_c)(i);let c,S;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(c=`& '${process.execPath}' ${I} -p '''${E}'' + JSON.stringify(process.env) + ''${E}'''`,S=["-Login","-Command"]):r==="nu"?(c=`^'${process.execPath}' ${I} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,S=["-i","-l","-c"]):(c=`'${process.execPath}' ${I} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,r==="tcsh"||r==="csh"?S=["-ic"]:S=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),c);const v=(0,L.spawn)(i,[...S,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(v.kill(),n(new y.$3))),v.on("error",_=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,N.$ai)(_)),n(_)});const D=[];v.stdout.on("data",_=>D.push(_));const W=[];v.stderr.on("data",_=>W.push(_)),v.on("close",(_,x)=>{const le=Buffer.concat(D).toString("utf8");f.trace("getUnixShellEnvironment#raw",le);const te=Buffer.concat(W).toString("utf8");if(te.trim()&&f.trace("getUnixShellEnvironment#stderr",te),_||x)return n(new Error((0,R.localize)(2,null,_,x)));const ce=t.exec(le),ue=ce?ce[1]:"{}";try{const ie=JSON.parse(ue);P?ie.ELECTRON_RUN_AS_NODE=P:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",ie),s(ie)}catch(ie){f.error("getUnixShellEnvironment#errorCaught",(0,N.$ai)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=void 0,e.$ZM=(0,L.$ph)("stateReadService"),e.$1M=(0,L.$ph)("stateService")}),define(ne[68],re([0,1,8,14,3,18,12,6]),function(J,e,L,j,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.SaveStrategy=void 0;var u;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class l{constructor(d,b,k,$){this.f=d,this.g=k,this.h=$,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=b===0?void 0:new L.$sg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.g.error(d)}}getItem(d,b){const k=this.a[d];return(0,R.$re)(k)?b:k}setItem(d,b){this.setItems([{key:d,data:b}])}setItems(d){let b=!1;for(const{key:k,data:$}of d)this.a[k]!==$&&((0,R.$re)($)?(0,R.$pe)(this.a[k])||(this.a[k]=void 0,b=!0):(this.a[k]=$,b=!0));b&&this.j()}removeItem(d){(0,R.$pe)(this.a[d])||(this.a[d]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.h.writeFile(this.f,j.$Ec.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(b){this.g.error(b)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$2M=l;let w=class{constructor(d,b,k,$){this.a=new l(b.stateResource,d,k,$)}async init(){await this.a.init()}getItem(d,b){return this.a.getItem(d,b)}};e.$3M=w,e.$3M=w=$e([se(1,A.$wh),se(2,y.$Ri),se(3,N.$Sj)],w);class O extends w{setItem(d,b){this.a.setItem(d,b)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.$4M=O}),define(ne[69],re([0,1,13,34,28]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=void 0;function A(u){if(L.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function N(u,l,w,O,m,d,b,k){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,R.$3e)()+Date.now(),$.commitHash=O,$.version=m,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$h)(L.$t),$["common.nodePlatform"]=j.$2c,$["common.nodeArch"]=w,$["common.product"]=k||"desktop",b&&($["common.msftInternal"]=b);let f=0;const h=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),L.$l&&($["common.snap"]="true");const P=A(l);return P&&($["common.platformDetail"]=P),$}e.$2n=N;function y(u){const l=j.env.USERDNSDOMAIN;if(!l)return!1;const w=l.toLowerCase();return u.some(O=>w===O)}e.$3n=y}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,L.$ph)("telemetryService"),e.$Wk=(0,L.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var j;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,j,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$4n=l;class w{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5n=w,e.$6n=new w;class O{async publicLog(n,r,c){}async publicLogError(n,r,c){}}e.$7n=O,e.$8n="telemetry",e.$9n="extensionTelemetryLog",e.$0n={log:()=>null,flush:()=>Promise.resolve(null)};function m(s,n){return R.Event.debounce(n.onDidChangeConfiguration,(c,S)=>{const I=c?new Set([...c.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:I}},1e3,!0)(c=>{c.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,A.$Yh)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.$$n=m;function d(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry||n.extensionTestsLocationURI)}e.$_n=d;function b(s,n){return!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$ao=b;function k(s){const n=s.getValue(u.$3k),r=s.getValue(u.$4k);if(s.getValue(u.$5k)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$bo=k;function $(s){const n={},r={},c={};P(s,c);for(let S in c){S=S.length>150?S.substr(S.length-149):S;const I=c[S];typeof I=="number"?r[S]=I:typeof I=="boolean"?r[S]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${I.length}`),n[S]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[S]=I)}return{properties:n,measurements:r}}e.$co=$;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(s){if(!s)return"none";const n=(0,N.$Ck)(s);return f.has(n)?n:"other"}e.$do=h;function P(s,n,r=0,c){if(s)for(const S of Object.getOwnPropertyNames(s)){const I=s[S],v=c?c+S:S;Array.isArray(I)?n[v]=(0,L.$Nm)(I):I instanceof Date?n[v]=I.toISOString():(0,j.$ke)(I)?r<2?P(I,n,r+1,v+"."):n[v]=(0,L.$Nm)(I):n[v]=I}}function p(s,n){const r=s.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,y.$3n)(r)||c}e.$eo=p;function E(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$fo=E;function t(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const c=[];for(const D of n)for(;;){const W=D.exec(s);if(!W)break;c.push([W.index,D.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(r="";;){const D=I.exec(s);if(!D)break;const W=c.some(([_,x])=>D.index<x&&_<I.lastIndex);!S.test(D[0])&&!W&&(r+=s.substring(v,D.index)+"<REDACTED: user-file-path>",v=I.lastIndex)}return v<s.length&&(r+=s.substr(v)),r}function o(s){if(!s)return s;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function i(s,n){return(0,L.$Km)(s,r=>{if(r instanceof l||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=t(c,n);for(const S of n)c=c.replace(S,"");return c=o(c),c}})}e.$go=i}),define(ne[27],re([0,1,29,21,37,13,11,9,34,39]),function(J,e,L,j,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;function w(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,L.$Gd)(i.id,s.id)===0}e.$ho=w;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const n=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,n,r)}static parse(s){const n=O.exec(s);return n&&n[1]&&n[2]?new m({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?w(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$io=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(i){const s=d.exec(i);return s&&s[1]?[$(s[1]),s[2]]:[$(i),void 0]}e.$jo=b;function k(i,s){return`${i}.${s}`}e.$ko=k;function $(i){return i.toLowerCase()}e.$lo=$;function f(i,s){return $(k(i??R.$El,s))}e.$mo=f;function h(i,s){const n=[],r=c=>{for(const S of n)if(S.some(I=>w(s(I),s(c))))return S;return null};for(const c of i){const S=r(c);S?S.push(c):n.push([c])}return n}e.$no=h;function P(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$oo=P;function p(i){return{id:new l.$4n(i.identifier.id),name:new l.$4n(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$po=p,e.$qo=new R.$Il("pprice.better-merge");function E(i,s){const n=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&n.every(S=>!w(S.identifier,{id:c}))){const S=i.filter(I=>w(I.identifier,{id:c}));S.length===1&&(n.push(S[0]),r.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$ro=E;async function t(i,s){if(!A.$k)return!1;let n;try{n=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,y.$9)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(i,s){const n=await t(i,s),r=(0,j.$Mn)(n?"alpine":A.$t,u.$3c);return s.debug("ComputeTargetPlatform:",r),r}e.$so=o}),define(ne[140],re([0,1,20,9,15,17,43,11,93,21,27,37]),function(J,e,L,j,R,A,N,y,u,l,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0;const m=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function b($,f){return f?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let k=class{constructor(f,h,P){this.a=f,this.b=h,this.d=P}get f(){}async listExtensions(f,h,P){let p=await this.b.getInstalled(1,P);const E=O.$Hl.map(o=>o.toLowerCase());if(h&&h!==""){if(E.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(s=>s.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),E.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((o,i)=>o.identifier.id.localeCompare(i.identifier.id));let t;for(const o of p)t!==o.identifier.id&&(t=o.identifier.id,this.a.info(b(o.manifest,f)))}async installExtensions(f,h,P,p){const E=[];try{const t=[];f.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const o=[];let i=[];const s=(r,c,S)=>{i.push({id:r,version:c!=="prerelease"?c:void 0,installOptions:{...P,isBuiltin:S,installPreReleaseVersion:c==="prerelease"||P.installPreReleaseVersion}})};for(const r of f)if(r instanceof y.URI)o.push({vsix:r,installOptions:P});else{const[c,S]=(0,w.$jo)(r);s(c,S,!1)}for(const r of h)if(r instanceof y.URI)o.push({vsix:r,installOptions:{...P,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,S]=(0,w.$jo)(r);s(c,S,!0)}const n=await this.b.getInstalled(1,P.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:c})=>{try{const S=await this.g(r,c,p,n);S&&t.push(S)}catch(S){this.a.error(S),E.push(r.toString())}})),i.length&&(i=i.filter(({id:r,version:c})=>{const S=n.find(I=>(0,w.$ho)(I.identifier,{id:r}));if(S){if(!p&&(!c||c==="prerelease"&&S.preRelease))return this.a.info((0,u.localize)(5,null,r,S.manifest.version,r)),!1;if(c&&S.manifest.version===c)return this.a.info((0,u.localize)(6,null,`${r}@${c}`)),!1}return!0}),i.length)){const r=await this.h(i);await Promise.all(i.map(async c=>{const S=r.get(c.id.toLowerCase());if(S)try{const I=await this.j(c,S,n);I&&t.push(I)}catch(I){this.a.error(I.message||I.stack||I),E.push(c.id)}else this.a.error(`${m(c.version?`${c.id}@${c.version}`:c.id)}
${d}`),E.push(c.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,j.$9)(t))),t}if(E.length)throw new Error((0,u.localize)(8,null,E.join(", ")))}async g(f,h,P,p){const E=await this.b.getManifest(f);if(!E)throw new Error("Invalid vsix");if(await this.l(E,P,h.profileLocation,p))try{return await this.b.install(f,h),this.a.info((0,u.localize)(9,null,(0,A.$6f)(f))),E}catch(o){if((0,j.$2)(o))return this.a.info((0,u.localize)(10,null,(0,A.$6f)(f))),null;throw o}return null}async h(f){const h=new Map,P=f.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),E=[];for(const t of f)l.$Fn.test(t.id)&&E.push({...t,preRelease:P});if(E.length){const t=await this.d.getExtensions(E,{targetPlatform:p},L.CancellationToken.None);for(const o of t)h.set(o.identifier.id.toLowerCase(),o)}return h}async j({id:f,version:h,installOptions:P},p,E){const t=await this.d.getManifest(p,L.CancellationToken.None);if(t&&!this.k(t))return null;const o=E.find(i=>(0,w.$ho)(i.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.a.info((0,u.localize)(11,null,h?`${f}@${h}`:f)),null;this.a.info((0,u.localize)(12,null,f,p.version))}try{P.isBuiltin?this.a.info(h?(0,u.localize)(13,null,f,h):(0,u.localize)(14,null,f)):this.a.info(h?(0,u.localize)(15,null,f,h):(0,u.localize)(16,null,f));const i=await this.b.installFromGallery(p,{...P,installGivenVersion:!!h});return this.a.info((0,u.localize)(17,null,f,i.manifest.version)),t}catch(i){if((0,j.$2)(i))return this.a.info((0,u.localize)(18,null,f)),null;throw i}}k(f){return!0}async l(f,h,P,p){if(!h){const E={id:(0,w.$mo)(f.publisher,f.name)},t=p.find(o=>(0,w.$ho)(E,o.identifier)&&(0,N.gt)(o.manifest.version,f.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,h,P){const p=async t=>{if(t instanceof y.URI){const o=await this.b.getManifest(t);return b(o)}return t},E=[];for(const t of f){const o=await p(t),s=(await this.b.getInstalled(void 0,P)).filter(n=>(0,w.$ho)(n.identifier,{id:o}));if(!s.length)throw new Error(`${this.m(o)}
${d}`);if(s.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,o));return}if(!h&&s.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,o));return}this.a.info((0,u.localize)(22,null,o));for(const n of s)await this.b.uninstall(n,{profileLocation:P}),E.push(n);this.f?this.a.info((0,u.localize)(23,null,o,this.f)):this.a.info((0,u.localize)(24,null,o))}}async locateExtension(f){const h=await this.b.getInstalled();f.forEach(P=>{h.forEach(p=>{if(p.identifier.id===P&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(f){return this.f?(0,u.localize)(25,null,f,this.f):(0,u.localize)(26,null,f)}};e.$Zo=k,e.$Zo=k=$e([se(1,l.$Tn),se(2,l.$Rn)],k)}),define(ne[141],re([0,1,4,2,35,27,37]),function(J,e,L,j,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;class y extends j.$lb{constructor(l,w,O,m,d,b,k){super(),this.f=l,this.g=w,this.h=O,this.i=m,this.j=d,this.k=b,this.l=k,this.a=this.B(new L.$ec),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new j.$tb),this.m().then(null,$=>k.error($))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(l=>this.p(l.added))),this.B(this.i.onAddExtensions(l=>this.r(l))),this.B(this.i.onDidAddExtensions(l=>this.s(l))),this.B(this.i.onRemoveExtensions(l=>this.t(l))),this.B(this.i.onDidRemoveExtensions(l=>this.u(l))),this.B(this.k.onDidFilesChange(l=>this.v(l)))}async p(l){try{l.length&&await Promise.all(l.map(w=>(this.c.set(w.id,(0,j.$ib)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(l){for(const w of l.extensions)this.C(this.F(w.identifier,w.version),l.profileLocation)}async s(l){for(const w of l.extensions){const O=this.F(w.identifier,w.version);l.error?this.D(O,l.profileLocation):this.C(O,l.profileLocation)}}async t(l){for(const w of l.extensions)this.D(this.F(w.identifier,w.version),l.profileLocation)}async u(l){const w=[],O=[];for(const m of l.extensions){const d=this.F(m.identifier,m.version);l.error?this.C(d,l.profileLocation):(this.D(d,l.profileLocation),this.b.has(d)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),O.push(this.f.scanInstalledExtensionAtLocation(m.location).then(b=>{b?w.push(b):this.l.info("Extension not found at the location",m.location.toString())},b=>this.l.error(b)))))}try{await Promise.all(O),w.length&&await this.z(w)}catch(m){this.l.error(m)}}v(l){for(const w of this.h.profiles)l.contains(w.extensionsResource,0,1)&&this.w(w.extensionsResource)}async w(l){const w=[],O=[],m=await this.i.scanProfileExtensions(l),d=new Set,b=new Set;for(const[k,$]of this.b)$.has(l)&&b.add(k);for(const k of m){const $=this.F(k.identifier,k.version);d.add($),b.has($)||(w.push(k.identifier),this.C($,l))}for(const k of b)if(!d.has(k)){const $=this.G(k);$&&(O.push($.identifier),this.D(k,l))}(w.length||O.length)&&this.a.fire({added:w.length?{extensions:w,profileLocation:l}:void 0,removed:O.length?{extensions:O,profileLocation:l}:void 0})}async y(l){const w=await this.i.scanProfileExtensions(l);for(const O of w)this.C(this.F(O.identifier,O.version),l)}async z(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.F(O.identifier,O.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}C(l,w){let O=this.b.get(l);O||this.b.set(l,O=new R.$oi(m=>this.j.extUri.getComparisonKey(m))),O.add(w)}D(l,w){const O=this.b.get(l);O&&O.delete(w),O?.size||this.b.delete(l)}F(l,w){return`${N.$Il.toKey(l.id)}@${w}`}G(l){const[w,O]=(0,A.$jo)(l);return O?{identifier:{id:w},version:O}:void 0}}e.$op=y}),define(ne[142],re([0,1,113,39]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;async function R(A,N,y,u,l,w,O){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${N.nameShort})`};if((0,j.$_n)(N,y)&&(0,j.$bo)(u)===3){const d=await(0,L.$So)(y,l,w);m["X-Market-User-Id"]=d,m["VSCode-SessionId"]=O.machineId||d}return m}e.$To=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;let k=class extends d.$Aq{constructor(P,p,E,t){super(E),this.h=P,this.i=t,this.g=this.B(new $(p,t)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(P,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.i.warn(`No language pack found for ${p}`);return}const o=t.translations[P];return o?b.URI.file(o):void 0}async getInstalledLanguages(){const P=await this.g.getLanguagePacks(),p=Object.keys(P).map(E=>{const t=P[E];return{...this.f(E,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((E,t)=>E.label.localeCompare(t.label)),p}async j(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",P.identifier.id),await this.update())}async k(P){const p=await this.g.getLanguagePacks();Object.keys(p).some(E=>p[E]&&p[E].extensions.some(t=>(0,O.$ho)(t.extensionIdentifier,P.identifier)))&&(this.i.info("Removing language packs from the extension",P.identifier.id),await this.update())}async update(){const[P,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(p);return!(0,j.$$e)(Object.keys(P),Object.keys(E))}};e.$Bq=k,e.$Bq=k=$e([se(0,w.$Tn),se(1,l.$xh),se(2,w.$Rn),se(3,m.$Ri)],k);let $=class extends A.$lb{constructor(P,p){super(),this.i=p,this.c={},this.f=(0,y.$8c)(P.userDataPath,"languagepacks.json"),this.g=new R.$Bg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(P){return this.m(p=>{Object.keys(p).forEach(E=>delete p[E]),this.j(p,...P)}).then(()=>this.c)}j(P,...p){for(const E of p)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.k(P,E);Object.keys(P).forEach(E=>this.l(P[E]))}k(P,p){const E=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of t)if(p.location.scheme===N.Schemas.file&&f(o)){let i=P[o.languageId];i||(i={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},P[o.languageId]=i);const s=i.extensions.filter(n=>(0,O.$ho)(n.extensionIdentifier,E))[0];s?s.version=p.manifest.version:i.extensions.push({extensionIdentifier:E,version:p.manifest.version});for(const n of o.translations)i.translations[n.id]=(0,y.$8c)(p.location.fsPath,n.path)}}l(P){if(P){const p=(0,L.createHash)("md5");for(const E of P.extensions)p.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);P.hash=p.digest("hex")}}m(P=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(p=P(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.c=E,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>p,E=>this.i.error(E))})}};$=$e([se(0,l.$xh),se(1,m.$Ri)],$);function f(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const P of h.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",y="https://mobile.events.data.microsoft.com/ping";async function u(w,O,m){const d=await(0,L.$2C)("@microsoft/1ds-core-js","dist/ms.core.js"),b=await(0,L.$2C)("@microsoft/1ds-post-js","dist/ms.post.js"),k=new d.AppInsightsCore,$=new b.PostChannel,f={instrumentationKey:w,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(m){f.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:m};f.extensionConfig[$.identifier]=h}return k.initialize(f,[]),k.addTelemetryInitializer(h=>{O&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),k}class l{constructor(O,m,d,b,k){this.e=O,this.f=m,this.g=d,this.h=k,this.c=N,this.d=y,this.g||(this.g={}),typeof b=="function"?this.a=b():this.a=b,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(m=>{O(m)},m=>{(0,j.$Y)(m),console.error(m)})}}log(O,m){if(!this.a)return;m=(0,R.$Lm)(m,this.g),m=(0,A.$co)(m);const d=this.f+"/"+O;try{this.i(b=>{b.pluginVersionString=m?.properties.version??"Unknown",b.track({name:d,baseData:{name:d,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$VM=l}),define(ne[145],re([0,1,2,30,13,29,105,25,44,146,31,36,26,39]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let b=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,h,P){this.k=h,this.l=P,this.d={},this.i=new L.$kb,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$pd)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$pd)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.$3k)||p.affectsConfiguration(m.$5k)||p.affectsConfiguration(m.$4k))&&this.m()}))}setExperimentProperty(f,h){this.d[f]=h}m(){let f=(0,d.$bo)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const P=h.usage?3:h.error?2:0;f=Math.min(f,P)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,h,P){this.g<h||(P=(0,j.$Lm)(P,this.d),P=(0,d.$go)(P,this.j),P=(0,j.$Lm)(P,this.c),this.b.forEach(p=>p.log(f,P)))}publicLog(f,h){this.n(f,3,h)}publicLog2(f,h){this.publicLog(f,h)}publicLogError(f,h){this.h&&this.n(f,2,h)}publicLogError2(f,h){this.publicLogError(f,h)}};e.$Hq=b,e.$Hq=b=$e([se(1,y.$Vh),se(2,w.$0i)],b);function k(){const $=(0,N.localize)(0,null,l.default.nameLong),f=l.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=R.$o?"":(0,N.localize)(3,null),P=(0,N.localize)(4,null),p=(0,N.localize)(5,null),E=(0,N.localize)(6,null),t=(0,N.localize)(7,null),o=`
|       | ${P} | ${p} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${$} ${f} ${h}

&nbsp;

${t}
${o}

&nbsp;

${i}
`}O.$Um.as(u.$Zm.Configuration).registerConfiguration({id:m.$2k,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[m.$3k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:k(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$Um.as(u.$Zm.Configuration).registerConfiguration({id:m.$2k,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[m.$5k]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,N.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,N.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${m.$3k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;async function N(w,O){const m=await O.request(w,j.CancellationToken.None),d=(await(0,L.$Qc)(m.stream)).toString(),b=m.res.statusCode??200;return{headers:m.res.headers,statusCode:b,responseData:d}}async function y(w){const O={method:w.type,headers:w.headers};return new Promise((d,b)=>{const k=R.request(w.url??"",O,$=>{$.on("data",function(f){d({headers:$.headers,statusCode:$.statusCode??200,responseData:f.toString()})}),$.on("error",function(f){b(f)})});k.write(w.data,$=>{$&&b($)}),k.end()})}async function u(w,O,m){const d=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),b={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:d};try{const k=w?await N(b,w):await y(b);m(k.statusCode,k.headers,k.responseData)}catch{m(0,{})}}class l extends A.$VM{constructor(O,m,d,b,k){const $={sendPOST:(f,h)=>{u(O,f,h)}};super(m,d,b,k,$)}}e.$WM=l}),define(ne[148],re([0,1,16,24]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0;async function R(A,N){const y=Object.create(null),u=(w,O)=>{const m=JSON.parse(w);y[O]=m};if(N){const w=[],O=await j.Promises.readdir(N);for(const d of O)try{(await j.Promises.stat((0,L.$8c)(N,d))).isDirectory()&&w.push(d)}catch{}const m=[];for(const d of w)(await j.Promises.readdir((0,L.$8c)(N,d))).filter(k=>k==="telemetry.json").length===1&&m.push(d);for(const d of m){const b=(await j.Promises.readFile((0,L.$8c)(N,d,"telemetry.json"))).toString();u(b,d)}}let l=(await j.Promises.readFile((0,L.$8c)(A,"telemetry-core.json"))).toString();return u(l,"vscode-core"),l=(await j.Promises.readFile((0,L.$8c)(A,"telemetry-extensions.json"))).toString(),u(l,"vscode-extensions"),JSON.stringify(y,null,4)}e.$X6b=R}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=void 0;async function A(N,y){let u=N.getItem(R.$1k);return(typeof u!="string"||L.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,j.$vm)(y.error.bind(y))),u}e.$g6b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=void 0,e.$pk=(0,L.$ph)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,j,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class l{static{this._clock=0}constructor(m){this.uri=m,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let w=class{constructor(m){this.g=m,this.c=new u.$kb,this.f=2**16;const d=new Map,b=k=>{let $=d.get(k.scheme);return $===void 0&&($=m.hasProvider(k)&&!this.g.hasCapability(k,1024),d.set(k.scheme,$)),$};this.c.add(y.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(k=>{d.delete(k.scheme)})),this.extUri=new A.$Xf(b),this.d=new N.$fr((k,$)=>this.extUri.compare(k,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.$0f)(m));const d=this.d.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new l(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((b,k)=>b[1].time<k[1].time?1:b[1].time>k[1].time?-1:0);l._clock=0,this.d.clear();const d=this.f*.5;for(let b=0;b<d;b++)this.d.set(m[b][0],m[b][1].touch())}};e.$gr=w,e.$gr=w=$e([se(0,R.$Sj)],w),(0,j.$dr)(L.$pk,w,1)}),define(ne[151],re([0,1,4,2,12,41,46,14]),function(J,e,L,j,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=void 0;class u extends j.$lb{get capabilities(){return this.f.capabilities&-5}constructor(w,O,m,d){super(),this.c=w,this.f=O,this.g=m,this.h=d,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.$ec),this.onDidChangeFile=this.a.event,this.b=N.$vh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(b=>this.i(b)))}watch(w,O){this.b.set(w,w);const m=this.f.watch(this.j(w),O);return(0,j.$jb)(()=>{this.b.delete(w),m.dispose()})}stat(w){return this.f.stat(this.j(w))}mkdir(w){return this.f.mkdir(this.j(w))}rename(w,O,m){return this.f.rename(this.j(w),this.j(O),m)}readFile(w){return this.f.readFile(this.j(w),{atomic:!0})}readFileStream(w,O,m){const d=(0,A.$sc)(b=>y.$Ec.concat(b.map(k=>y.$Ec.wrap(k))).buffer);return(async()=>{try{const b=await this.readFile(w);d.end(b)}catch(b){d.error(b),d.end()}})(),d}readdir(w){return this.f.readdir(this.j(w))}writeFile(w,O,m){return this.f.writeFile(this.j(w),O,m)}delete(w,O){return this.f.delete(this.j(w),O)}copy(w,O,m){if((0,R.$Vj)(this.f))return this.f.copy(this.j(w),this.j(O),m);throw new Error("copy not supported")}i(w){const O=[];for(const m of w){if(m.resource.scheme!==this.c)continue;const d=this.k(m.resource);this.b.findSubstr(d)&&O.push({resource:d,type:m.type})}O.length&&(this.h.debug("User data changed"),this.a.fire(O))}j(w){return w.with({scheme:this.c})}k(w){return w.with({scheme:this.g})}}e.$B6b=u}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,j,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,y.$ph)("contextService");function l(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.$zh=l;function w(s){return typeof s?.id=="string"&&!l(s)&&!m(s)}e.$Ah=w,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function O(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,j.$_c)(s)}:n?e.$Bh:e.$Ch;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Dh=O;function m(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.$Eh=m;function d(s){const n=s;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Fh=d;var b;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function k(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Gh=k;function $(s){const n=s;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Hh=$;class f{constructor(n,r,c,S,I){this.h=n,this.j=c,this.k=S,this.l=I,this.c=R.$vh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=f;class h{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$9f)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=h;function P(s){return new h({uri:s,index:0,name:(0,A.$5f)(s)},{uri:s.toString()})}e.$Kh=P,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,L.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function p(s,n){return A.$Zf.isEqualOrParent(s,n.untitledWorkspacesHome)}e.$Ph=p;function E(s){let n;return N.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===u.Schemas.tmp}e.$Qh=E,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Rh}e.$Sh=t;function o(s,n){return!p(s,n)&&!E(s)}e.$Th=o;function i(s){return(typeof s=="string"?(0,j.$ad)(s):(0,A.$7f)(s))===e.$Mh}e.$Uh=i}),define(ne[23],re([0,1,42,4,2,17,11,106,18,12,10,6,152,35,22,8,28,29,3]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.ProfileResourceType=void 0;var P;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function p(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$qk=p,e.$rk=(0,w.$ph)("IUserDataProfilesService");function E(s,n){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:N.URI.revive(s.location).with({scheme:n}),globalStorageHome:N.URI.revive(s.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(s.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(s.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(s.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(s.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(s.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(s.cacheHome).with({scheme:n}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$sk=E;function t(s,n,r,c,S,I){return{id:s,name:n,location:r,isDefault:!1,shortName:S?.shortName,globalStorageHome:I&&S?.useDefaultFlags?.globalState?I.globalStorageHome:(0,A.$9f)(r,"globalStorage"),settingsResource:I&&S?.useDefaultFlags?.settings?I.settingsResource:(0,A.$9f)(r,"settings.json"),keybindingsResource:I&&S?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,A.$9f)(r,"keybindings.json"),tasksResource:I&&S?.useDefaultFlags?.tasks?I.tasksResource:(0,A.$9f)(r,"tasks.json"),snippetsHome:I&&S?.useDefaultFlags?.snippets?I.snippetsHome:(0,A.$9f)(r,"snippets"),extensionsResource:I&&S?.useDefaultFlags?.extensions?I.extensionsResource:(0,A.$9f)(r,"extensions.json"),cacheHome:(0,A.$9f)(c,s),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$tk=t;let o=class extends R.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,r,c,S){super(),this.n=n,this.r=r,this.s=c,this.t=S,this.f=!0,this.h=this.B(new j.$ec),this.onDidChangeProfiles=this.h.event,this.i=this.B(new j.$ec),this.onWillCreateProfile=this.i.event,this.j=this.B(new j.$ec),this.onWillRemoveProfile=this.j.event,this.k=this.B(new j.$ec),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new d.$ni,emptyWindows:new Map},this.profilesHome=(0,A.$9f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.$9f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=this.w(),r=[n];if(this.f)try{for(const I of this.J()){if(!I.name||!(0,h.$ie)(I.name)||!I.location){this.t.warn("Skipping the invalid stored profile",I.location||I.name);continue}r.push(t((0,A.$6f)(I.location),I.name,I.location,this.g,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.t.error(I)}const c=new d.$ni,S=new Map;if(r.length)try{const I=this.M();if(I.workspaces)for(const[v,D]of Object.entries(I.workspaces)){const W=N.URI.parse(v),_=r.find(x=>x.id===D);_&&c.set(W,_)}if(I.emptyWindows)for(const[v,D]of Object.entries(I.emptyWindows)){const W=r.find(_=>_.id===D);W&&S.set(v,W)}}catch(I){this.t.error(I)}this.u={profiles:r,workspaces:c,emptyWindows:S}}return this.u}w(){const n=t("__default__profile__",(0,y.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...n,extensionsResource:this.O()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",c=new RegExp(`${(0,f.$pd)(r)}\\s(\\d+)`);let S=0;for(const v of this.profiles){const D=c.exec(v.name),W=D?parseInt(D[1]):0;S=W>S?W:S}const I=`${r} ${S+1}`;return this.createProfile((0,L.$di)((0,$.$3e)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,r,c){return this.createProfile((0,L.$di)((0,$.$3e)()).toString(16),n,r,c)}async createProfile(n,r,c,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.y(n,r,c);return S&&await this.setProfileForWorkspace(S,I),I}async y(n,r,c){if(!(0,h.$ie)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.l.get(r);return S||(S=(async()=>{try{const I=this.profiles.find(W=>W.name===r||W.id===n);if(I)return I;const v=t(n,r,(0,A.$9f)(this.profilesHome,n),this.g,c,this.defaultProfile);await this.r.createFolder(v.location);const D=[];return this.i.fire({profile:v,join(W){D.push(W)}}),await k.Promises.settled(D),this.D([v],[],[]),v}finally{this.l.delete(r)}})(),this.l.set(r,S)),S}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(S=>S.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=t(c.id,r.name??c.name,c.location,this.g,{shortName:r.shortName??c.shortName,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.D([],[],[c]),c}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(S=>S.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this.j.fire({profile:r,join(S){c.push(S)}});try{await Promise.allSettled(c)}catch(S){this.t.error(S)}for(const S of[...this.v.emptyWindows.keys()])r.id===this.v.emptyWindows.get(S)?.id&&this.v.emptyWindows.delete(S);for(const S of[...this.v.workspaces.keys()])r.id===this.v.workspaces.get(S)?.id&&this.v.workspaces.delete(S);this.H(),this.D([],[r],[]);try{await this.r.del(r.cacheHome,{recursive:!0})}catch(S){(0,l.$9j)(S)!==1&&this.t.error(S)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(S=>S.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.G(n,c)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,r)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.s.extUri.isEqual(c.location,r.resource))).map(r=>this.r.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(r=>!this.C(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.z(n);return N.URI.isUri(r)?this.m.workspaces.get(r)??this.v.workspaces.get(r):this.m.emptyWindows.get(r)??this.v.emptyWindows.get(r)}z(n){return(0,m.$zh)(n)?n.uri:(0,m.$Eh)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,n.location))||[...this.m.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,n.location))||[...this.v.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,n.location))||[...this.v.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,n.location)))}D(n,r,c){const S=[...this.profiles,...n],I=[];this.m.profiles=[];for(let v of S)v.isDefault||r.some(D=>v.id===D.id)||(v=c.find(D=>v.id===D.id)??v,v.isTransient?this.m.profiles.push(v):I.push({location:v.location,name:v.name,shortName:v.shortName,useDefaultFlags:v.useDefaultFlags}));this.L(I),this.u=void 0,this.F(n,r,c)}F(n,r,c){this.h.fire({added:n,removed:r,updated:c,all:this.profiles})}G(n,r,c){c=r?.isTransient?!0:c,c||this.G(n,void 0,!0);const S=this.z(n),I=c?this.m:this.v;N.URI.isUri(S)?(I.workspaces.delete(S),r&&I.workspaces.set(S,r)):(I.emptyWindows.delete(S),r&&I.emptyWindows.set(S,r)),c||this.H()}H(){const n={};for(const[c,S]of this.v.workspaces.entries())n[c.toString()]=S.id;const r={};for(const[c,S]of this.v.emptyWindows.entries())r[c.toString()]=S.id;this.N({workspaces:n,emptyWindows:r}),this.u=void 0}I(n){const r={},c=this.w();if(n.workspaces)for(const[I,v]of Object.entries(n.workspaces)){const D=N.URI.parse(v);r[I]=this.s.extUri.isEqual(D,c.location)?c.id:this.s.extUri.basename(D)}const S={};if(n.emptyWindows)for(const[I,v]of Object.entries(n.emptyWindows)){const D=N.URI.parse(v);S[I]=this.s.extUri.isEqual(D,c.location)?c.id:this.s.extUri.basename(D)}return{workspaces:r,emptyWindows:S}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};e.$uk=o,e.$uk=o=$e([se(0,u.$wh),se(1,l.$Sj),se(2,b.$pk),se(3,O.$Ri)],o);class i extends o{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.$vk=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,31,26,22,23]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=void 0;let p=class extends y.$lb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(n,r,c,S,I,v){super(),this.u=n,this.v=r,this.w=c,this.y=S,this.z=I,this.C=v,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.$ec),this.m=this.B(new N.$ec),this.n=this.B(new N.$ec),this.p=this.B(new N.$ec),this.s=this.B(new N.$ec),this.t=[],this.B((0,y.$jb)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.k.forEach(D=>D.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(c=>(0,m.$On)(c,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const S=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:I})=>(0,d.$ho)(I,n.identifier));if(S?.local)return S?.local;throw S?.error?S.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(c){throw t(c)}}async installGalleryExtensions(n){if(!this.u.isEnabled())throw new m.$Sn(O.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=[],c=[];await Promise.allSettled(n.map(async({extension:S,options:I})=>{try{const v=await this.J(S,!!I?.installGivenVersion,!!I?.installPreReleaseVersion);c.push({...v,options:I})}catch(v){r.push({identifier:S.identifier,operation:2,source:S,error:v})}})),c.length&&r.push(...await this.D(c));for(const S of r)S.error&&(this.y.error("Failed to install extension.",S.identifier.id),this.y.error(S.error),S.source&&!w.URI.isUri(S.source)&&o(this.v,"extensionGallery:install",{extensionData:(0,d.$po)(S.source),error:S.error}));return r}async uninstall(n,r={}){return this.y.trace("ExtensionManagementService#uninstall",n.identifier.id),this.M(n,r)}async toggleAppliationScope(n,r){if((0,b.$Ll)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let c=await this.updateMetadata(n,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)||(c=await this.X(n,this.C.defaultProfile.extensionsResource,r));for(const S of this.C.profiles){const I=(await this.getInstalled(1,S.extensionsResource)).find(v=>(0,d.$ho)(v.identifier,n.identifier));I?this.s.fire(I):this.p.fire({identifier:n.identifier,profileLocation:S.extensionsResource})}return c}else{const c=this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(n,r,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.R(),this.h=n),this.g}registerParticipant(n){this.t.push(n)}async D(n){const r=[];return await Promise.allSettled(n.map(async c=>{try{const S=await this.F(c);r.push(...S)}catch(S){r.push({identifier:{id:(0,d.$mo)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:S})}})),this.m.fire(r),r}async F({manifest:n,extension:r,options:c}){const S=c.isApplicationScoped||c.isBuiltin||(0,b.$Ll)(n),I={...c,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(r)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:S,profileLocation:S?this.C.defaultProfile.extensionsResource:c.profileLocation??this.S()},v=te=>`${d.$io.create(te).toString()}${I.profileLocation?`-${I.profileLocation.toString()}`:""}`;if(!w.URI.isUri(r)){const te=this.j.get(v(r));if(te)return this.y.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const D=[],W=[],_=[],x=this.U(n,r,I);w.URI.isUri(r)||this.j.set(v(r),{task:x,waitingTasks:[]}),this.l.fire({identifier:x.identifier,source:r,profileLocation:I.profileLocation}),this.y.info("Installing extension:",x.identifier.id),D.push({task:x,manifest:n});let le=!1;try{if(I.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ce=await this.I(x.identifier,n,!!I.installOnlyNewlyAddedFromExtensionPack,!!I.installPreReleaseVersion,I.profileLocation),ue=await this.getInstalled(void 0,I.profileLocation),ie={...I,donotIncludePackAndDependencies:!0,context:{...I.context,[m.$Jn]:!0}};for(const{gallery:V,manifest:G}of(0,L.$of)(ce,({gallery:F})=>F.identifier.id)){le=le||!!G.extensionDependencies?.some(B=>(0,d.$ho)({id:B},x.identifier));const F=v(V),C=this.j.get(F);if(C){if(this.G(x,C.task)){const B=C.task.identifier;this.y.info("Waiting for already requested installing extension",B.id,x.identifier.id),C.waitingTasks.push(x),W.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,Y=>Y.some(Z=>(0,d.$ho)(Z.identifier,B)))).then(Y=>{if(this.y.info("Finished waiting for already requested installing extension",B.id,x.identifier.id),!Y.find(Q=>(0,d.$ho)(Q.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!ue.some(({identifier:B})=>(0,d.$ho)(B,V.identifier))){const B=this.U(G,V,ie);this.j.set(F,{task:B,waitingTasks:[x]}),this.l.fire({identifier:B.identifier,source:V,profileLocation:I.profileLocation}),this.y.info("Installing extension:",B.identifier.id,x.identifier.id),D.push({task:B,manifest:G})}}}catch(ce){if(w.URI.isUri(x.source))(0,L.$nf)(n.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",x.identifier.id,ce.message),(0,L.$nf)(n.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",x.identifier.id,ce.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ce}const te=D.reduce((ce,{task:ue,manifest:ie})=>(ce.set(ue.identifier.id.toLowerCase(),{task:ue,manifest:ie}),ce),new Map);for(;te.size;){let ce;const ue=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(V=>te.has(V.toLowerCase())));ue.length?ce=te.size===1?ue:ue.filter(({task:ie})=>!(ie===x&&!le)):(this.y.info("Found extensions with circular dependencies",ue.map(({task:ie})=>ie.identifier.id)),ce=[...te.values()]),await this.H(ce.map(async({task:ie})=>{const V=new Date().getTime();try{const G=await ie.run();if(await this.H(this.t.map(F=>F.postInstall(G,ie.source,I,R.CancellationToken.None))),!w.URI.isUri(ie.source)){const F=ie.operation===3,C=F?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(o(this.v,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$po)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:C}),u.$o&&ie.operation!==3)try{await this.u.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}_.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw w.URI.isUri(ie.source)||o(this.v,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$po)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-V,error:G}),this.y.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return W.length&&await this.H(W),_.forEach(({identifier:ce})=>this.y.info("Extension installed successfully:",ce.id)),_}catch(te){if(D.forEach(({task:ce})=>ce.cancel()),_.length)try{const ce=await Promise.allSettled(_.map(({local:ue})=>this.W(ue,{versionOnly:!0,profileLocation:I.profileLocation}).run()));for(let ue=0;ue<ce.length;ue++){const ie=ce[ue],{identifier:V}=_[ue];ie.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",V.id):this.y.warn("Rollback: Error while uninstalling extension",V.id,(0,A.$9)(ie.reason))}}catch(ce){this.y.warn("Error while rolling back extensions",(0,A.$9)(ce),_.map(({identifier:ue})=>ue.id))}return D.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:I.context,profileLocation:I.profileLocation,error:te}))}finally{for(const{task:te}of D)te.source&&!w.URI.isUri(te.source)&&this.j.delete(v(te.source))}}G(n,r){for(const[,{task:c,waitingTasks:S}]of this.j.entries())if(c===n&&(S.includes(r)||S.some(I=>this.G(I,r)))||c===r&&S[0]&&!this.G(n,S[0]))return!1;return!0}async H(n){const r=[],c=[],S=await Promise.allSettled(n);for(const I of S)I.status==="fulfilled"?r.push(I.value):c.push(I.reason);if(c.length)throw E(c);return r}async I(n,r,c,S,I){if(!this.u.isEnabled())return[];const v=await this.getInstalled(void 0,I),D=[],W=[],_=async(x,le)=>{D.push(x);const te=le.extensionDependencies||[],ce=[...te];if(le.extensionPack){const ue=c?v.find(ie=>(0,d.$ho)(ie.identifier,x)):void 0;for(const ie of le.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(V=>(0,d.$ho)({id:V},{id:ie}))||ce.every(V=>!(0,d.$ho)({id:V},{id:ie}))&&ce.push(ie)}if(ce.length){const ue=ce.filter(ie=>D.every(V=>!(0,d.$ho)(V,{id:ie})));if(ue.length){const ie=await this.u.getExtensions(ue.map(V=>({id:V,preRelease:S})),R.CancellationToken.None);for(const V of ie){if(D.find(C=>(0,d.$ho)(C,V.identifier)))continue;const G=te.some(C=>(0,d.$ho)({id:C},V.identifier));let F;try{F=await this.J(V,!1,S)}catch(C){if(G)throw C;this.y.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,A.$9)(C));continue}W.push({gallery:F.extension,manifest:F.manifest}),await _(F.extension.identifier,F.manifest)}}}};return await _(n,r),W}async J(n,r,c){let S;const I=await this.getExtensionsControlManifest();if(I.malicious.some(W=>(0,d.$ho)(n.identifier,W)))throw new m.$Sn(O.localize(1,null,n.identifier.id),m.ExtensionManagementErrorCode.Malicious);const v=I.deprecated[n.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.y.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),S=(await this.u.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!S)throw new m.$Sn(O.localize(2,null,n.identifier.id,v.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const W=await this.getTargetPlatform();throw new m.$Sn(O.localize(3,null,n.identifier.id,this.z.nameLong,(0,m.$Kn)(W)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(S=await this.L(n,r,c),!S)throw!c&&n.properties.isPreReleaseVersion&&(await this.u.getExtensions([n.identifier],R.CancellationToken.None))[0]?new m.$Sn(O.localize(4,null,n.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$Sn(O.localize(5,null,n.identifier.id,this.z.nameLong,this.z.version),m.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",S.identifier.id);const D=await this.u.getManifest(S,R.CancellationToken.None);if(D===null)throw new m.$Sn(`Missing manifest for extension ${S.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(D.version!==S.version)throw new m.$Sn(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:D}}async L(n,r,c){const S=await this.getTargetPlatform();let I=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==c&&(I=(await this.u.getExtensions([{...n.identifier,preRelease:c}],{targetPlatform:S,compatible:!0},R.CancellationToken.None))[0]||null),!I&&await this.u.isExtensionCompatible(n,c,S)&&(I=n),I||(r?I=(await this.u.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:S,compatible:!0},R.CancellationToken.None))[0]||null:I=await this.u.getCompatibleExtension(n,c,S)),I}async M(n,r){const c={...r,profileLocation:n.isApplicationScoped?this.C.defaultProfile.extensionsResource:r.profileLocation??this.S()},S=x=>`${x.id.toLowerCase()}${c.versionOnly?`-${n.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,I=this.k.get(S(n.identifier));if(I)return this.y.info("Extensions is already requested to uninstall",n.identifier.id),I.waitUntilTaskIsFinished();const v=x=>{const le=this.W(x,c);return this.k.set(S(le.extension.identifier),le),c.profileLocation?this.y.info("Uninstalling extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString()):this.y.info("Uninstalling extension:",`${x.identifier.id}@${x.manifest.version}`),this.n.fire({identifier:x.identifier,profileLocation:c.profileLocation,applicationScoped:x.isApplicationScoped}),le},D=(x,le)=>{le?c.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString(),le.message):this.y.error("Failed to uninstall extension:",`${x.identifier.id}@${x.manifest.version}`,le.message):c.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${x.identifier.id}@${x.manifest.version}`),o(this.v,"extensionGallery:uninstall",{extensionData:(0,d.$oo)(x),error:le}),this.p.fire({identifier:x.identifier,error:le?.code,profileLocation:c.profileLocation,applicationScoped:x.isApplicationScoped})},W=[],_=[];try{W.push(v(n));const x=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const le=this.P(n,x);for(const te of le)this.k.has(S(te.identifier))?this.y.info("Extensions is already requested to uninstall",te.identifier.id):W.push(v(te))}c.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.N(W.map(le=>le.extension),x,n),await this.H(W.map(async le=>{try{if(await le.run(),await this.H(this.t.map(te=>te.postUninstall(le.extension,c,R.CancellationToken.None))),le.extension.identifier.uuid)try{await this.u.reportStatistic(le.extension.manifest.publisher,le.extension.manifest.name,le.extension.manifest.version,"uninstall")}catch{}D(le.extension)}catch(te){const ce=te instanceof m.$Sn?te:new m.$Sn((0,A.$9)(te),m.ExtensionManagementErrorCode.Internal);throw D(le.extension,ce),ce}finally{_.push(le)}}))}catch(x){const le=x instanceof m.$Sn?x:new m.$Sn((0,A.$9)(x),m.ExtensionManagementErrorCode.Internal);for(const te of W){try{te.cancel()}catch{}_.includes(te)||D(te.extension,le)}throw le}finally{for(const x of W)this.k.delete(S(x.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",x.extension.identifier.id)}}N(n,r,c){for(const S of n){const I=this.Q(S,r);if(I.length){const v=I.filter(D=>!n.some(W=>(0,d.$ho)(W.identifier,D.identifier)));if(v.length)throw new Error(this.O(S,v,c))}}}O(n,r,c){return c===n?r.length===1?O.localize(6,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}P(n,r,c=[]){if(c.indexOf(n)!==-1)return[];c.push(n);const S=n.manifest.extensionPack?n.manifest.extensionPack:[];if(S.length){const I=r.filter(D=>!D.isBuiltin&&S.some(W=>(0,d.$ho)({id:W},D.identifier))),v=[];for(const D of I)v.push(...this.P(D,r,c));return[...I,...v]}return[]}Q(n,r){return r.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(S=>(0,d.$ho)({id:S},n.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const n=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$9o=p,e.$9o=p=$e([se(0,m.$Rn),se(1,f.$Vk),se(2,h.$pk),se(3,k.$Ri),se(4,$.$0i),se(5,P.$rk)],p);function E(s){const n=Array.isArray(s)?s:[s];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,c)=>new Error(`${r.message}${r.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.$0o=E;function t(s){if(s instanceof m.$Sn)return s;const n=new m.$Sn(s.message,m.ExtensionManagementErrorCode.Internal);return n.stack=s.stack,n}e.$$o=t;function o(s,n,{extensionData:r,verificationStatus:c,duration:S,error:I,durationSinceUpdate:v}){let D,W;(0,l.$qe)(c)&&(c===!0?c="Verified":(c===!1||(D=m.ExtensionManagementErrorCode.Signature,W=c),c="Unverified")),I&&(I instanceof m.$Sn?(D=I.code,I.code===m.ExtensionManagementErrorCode.Signature&&(W=I.message)):D=m.ExtensionManagementErrorCode.Internal),s.publicLog(n,{...r,verificationStatus:c,success:!I,duration:S,errorcode:D,errorcodeDetail:W,durationSinceUpdate:v})}class i{constructor(){this.d=new j.$tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,j.$ig)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,j.$ig)(n=>new Promise((r,c)=>{const S=n.onCancellationRequested(()=>{S.dispose(),c(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$_o=i}),define(ne[40],re([0,1,8,14,2,4,35,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class P extends Error{constructor(i,s){super(i),this.code=s}}e.$ap=P,e.$bp=(0,O.$ph)("IExtensionsProfileScannerService");let p=class extends R.$lb{constructor(i,s,n,r,c,S){super(),this.i=i,this.j=s,this.k=n,this.l=r,this.m=c,this.n=S,this.b=this.B(new A.$ec),this.onAddExtensions=this.b.event,this.c=this.B(new A.$ec),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$ec),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$ec),this.onDidRemoveExtensions=this.g.event,this.h=new N.$ni}scanProfileExtensions(i,s){return this.p(i,void 0,s)}async addExtensionsToProfile(i,s){const n=[],r=[];try{return await this.p(s,c=>{const S=[];for(const I of c)i.some(([v])=>(0,l.$ho)(v.identifier,I.identifier)&&v.manifest.version!==I.version)?n.push(I):S.push(I);for(const[I,v]of i){const D=S.findIndex(_=>(0,l.$ho)(_.identifier,I.identifier)&&_.version===I.manifest.version),W={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:v};D===-1?(r.push(W),S.push(W)):S.splice(D,1,W)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),n.length&&this.f.fire({extensions:n,profileLocation:s}),S}),r.length&&this.c.fire({extensions:r,profileLocation:s}),n.length&&this.g.fire({extensions:n,profileLocation:s}),r}catch(c){throw r.length&&this.c.fire({extensions:r,error:c,profileLocation:s}),n.length&&this.g.fire({extensions:n,error:c,profileLocation:s}),c}}async updateMetadata(i,s){const n=[];return await this.p(s,r=>{const c=[];for(const S of r){const I=i.find(([v])=>(0,l.$ho)(v.identifier,S.identifier)&&v.manifest.version===S.version);I&&(S.metadata={...S.metadata,...I[1]},n.push(S)),c.push(S)}return c}),n}async removeExtensionFromProfile(i,s){const n=[];try{await this.p(s,r=>{const c=[];for(const S of r)(0,l.$ho)(S.identifier,i.identifier)?n.push(S):c.push(S);return n.length&&this.f.fire({extensions:n,profileLocation:s}),c}),n.length&&this.g.fire({extensions:n,profileLocation:s})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:s}),r}}async p(i,s,n){return this.w(i).queue(async()=>{let r=[],c;try{const S=await this.j.readFile(i);c=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,w.$9j)(S)!==1)throw S;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(c=await this.v()),!c&&n?.bailOutWhenFileNotFound)throw new P((0,$.$9)(S),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.r(i);let S=!1;for(const I of c){E(I)||this.r(i);let v;if((0,k.$ie)(I.relativeLocation)&&I.relativeLocation)v=this.t(I.relativeLocation);else if((0,k.$ie)(I.location))v=this.t(I.location),S=!0,I.relativeLocation=I.location,I.location=v.toJSON();else{v=y.URI.revive(I.location);const D=this.s(v);D&&(S=!0,I.relativeLocation=D)}r.push({identifier:I.identifier,location:v,version:I.version,metadata:I.metadata})}S&&await this.j.writeFile(i,j.$Ec.fromString(JSON.stringify(c)))}if(s){r=s(r);const S=r.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.s(I.location),metadata:I.metadata}));await this.j.writeFile(i,j.$Ec.fromString(JSON.stringify(S)))}return r})}r(i){const s=new P(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(i)).value.toString()}catch(c){if((0,w.$9j)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",i.toString());let r;try{const c=JSON.parse(n);Array.isArray(c)&&c.every(S=>E(S))?r=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(r)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,j.$Ec.fromString(JSON.stringify(r)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,w.$9j)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(i)}catch(c){(0,w.$9j)(c)!==1&&this.n.error(c)}try{await this.j.del(s)}catch(c){(0,w.$9j)(c)!==1&&this.n.error(c)}return r})()),this.u}w(i){let s=this.h.get(i);return s||(s=new L.$Bg,this.h.set(i,s)),s}};e.$cp=p,e.$cp=p=$e([se(1,w.$Sj),se(2,d.$rk),se(3,b.$pk),se(4,f.$Vk),se(5,m.$Ri)],p);function E(o){return(0,k.$ke)(o)&&(0,u.$Qn)(o.identifier)&&(t(o.location)||(0,k.$ie)(o.location)&&o.location)&&((0,k.$pe)(o.relativeLocation)||(0,k.$ie)(o.relativeLocation))&&o.version&&(0,k.$ie)(o.version)}function t(o){return o?(0,k.$ie)(o.path)&&(0,k.$ie)(o.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,43,54,3,11,95,18,27,37,48,12,10,6,31,4,47,40,23,22,112]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h,P,p,E,t,o,i,s,n,r,c,S,I,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.Translations=void 0;var W;(function(ie){function V(G,F){if(G===F)return!0;const C=Object.keys(G),B=new Set;for(const Y of Object.keys(F))B.add(Y);if(C.length!==B.size)return!1;for(const Y of C){if(G[Y]!==F[Y])return!1;B.delete(Y)}return B.size===0}ie.equals=V})(W||(e.Translations=W={})),e.$fp=(0,i.$ph)("IExtensionsScannerService");let _=class extends l.$lb{constructor(V,G,F,C,B,Y,Z,Q,U,M,a,g){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=G,this.l=F,this.m=C,this.n=B,this.r=Y,this.s=Z,this.t=Q,this.u=U,this.v=M,this.w=a,this.y=g,this.g=this.B(new r.$ec),this.onDidChangeCache=this.g.event,this.h=(0,d.$9f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(te,this.m,this.h)),this.j=this.B(this.y.createInstance(te,this.m,this.h)),this.k=this.B(this.y.createInstance(le,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,p.$so)(this.s,this.t)),this.z}async scanAllExtensions(V,G,F){const[C,B]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(G)]),Y=F?await this.scanExtensionsUnderDevelopment(V,[...C,...B]):[];return this.G(C,B,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const G=[];G.push(this.H(!!V.useCache,V.language)),G.push(this.I(V.language,!!V.checkControlFile));const[F,C]=await Promise.all(G);return this.F([...F,...C],0,V,!1)}async scanUserExtensions(V){const G=V.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",G);const F=this.w.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,C=await this.L(G,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,F),B=V.useCache&&!C.devMode&&C.excludeObsolete?this.j:this.k;let Y;try{Y=await B.scanExtensions(C)}catch(Z){if(Z instanceof S.$ap&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),Y=await B.scanExtensions(C);else throw Z}return Y=await this.F(Y,1,V,!0),this.t.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(V,G){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const F=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(C=>C.scheme===w.Schemas.file).map(async C=>{const B=await this.L(C,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(B)).map(Z=>(Z.type=G.find(Q=>(0,p.$ho)(Q.identifier,Z.identifier))?.type??Z.type,this.k.validate(Z,B)))}))).flat();return this.F(F,"development",V,!0)}return[]}async scanExistingExtension(V,G,F){const C=await this.L(V,!1,G,!0,F.language,!0,void 0),B=await this.k.scanExtension(C);return!B||!F.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(V,G,F){const C=await this.L(V,!1,G,!0,F.language,!0,void 0),B=await this.k.scanOneOrMultipleExtensions(C);return this.F(B,G,F,!0)}async scanMetadata(V){const G=(0,d.$9f)(V,"package.json"),F=(await this.s.readFile(G)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,G){const F=(0,d.$9f)(V,"package.json"),C=(await this.s.readFile(F)).value.toString(),B=JSON.parse(C);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,B.__metadata={...B.__metadata,...G},await this.s.writeFile((0,d.$9f)(V,"package.json"),A.$Ec.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof S.$ap&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw V}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.r.addExtensionsToProfile(V.map(G=>[G,G.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.$Ec.fromString(JSON.stringify([])))}catch(G){(0,o.$9j)(G)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$9)(G))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.t.error(V)}finally{this.C=void 0}})()),this.C}async F(V,G,F,C){return F.includeAllVersions||(V=this.G(G===0?V:void 0,G===1?V:void 0,G==="development"?V:void 0,await this.getTargetPlatform(),C)),F.includeInvalid||(V=V.filter(B=>B.isValid)),V.sort((B,Y)=>{const Z=O.$_c(B.location.fsPath),Q=O.$_c(Y.location.fsPath);return Z<Q?-1:Z>Q?1:0})}G(V,G,F,C,B){const Y=(Q,U,M)=>{if(Q.isValid&&!U.isValid)return!1;if(Q.isValid===U.isValid){if(B&&b.gt(Q.manifest.version,U.manifest.version))return this.t.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(b.eq(Q.manifest.version,U.manifest.version)){if(Q.type===0)return this.t.debug(`Skipping extension ${U.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===C)return this.t.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return M?this.t.warn(`Overwriting user extension ${Q.location.path} with ${U.location.path}.`):this.t.debug(`Overwriting user extension ${Q.location.path} with ${U.location.path}.`),!0},Z=new E.$Kl;return V?.forEach(Q=>{const U=Z.get(Q.identifier.id);(!U||Y(U,Q,!1))&&Z.set(Q.identifier.id,Q)}),G?.forEach(Q=>{const U=Z.get(Q.identifier.id);if(!U&&V&&Q.type===0){this.t.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!U||Y(U,Q,!1))&&Z.set(Q.identifier.id,Q)}),F?.forEach(Q=>{const U=Z.get(Q.identifier.id);(!U||Y(U,Q,!0))&&Z.set(Q.identifier.id,Q),Z.set(Q.identifier.id,Q)}),[...Z.values()]}async H(V,G){this.t.trace("Started scanning system extensions");const F=await this.L(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),B=await(V&&!F.devMode?this.i:this.k).scanExtensions(F);return this.t.trace("Scanned system extensions:",B.length),B}async I(V,G){const F=this.u.isBuilt?[]:this.v.builtInExtensions;if(!F?.length)return[];this.t.trace("Started scanning dev system extensions");const C=G?await this.J():{},B=[],Y=f.URI.file(O.$6c(O.$8c(w.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of F){const U=C[Q.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":B.push((0,d.$9f)(Y,Q.name));break;default:B.push(f.URI.file(U));break}}const Z=await Promise.all(B.map(async Q=>this.k.scanExtension(await this.L(Q,!1,0,!0,V,!0,void 0))));return this.t.trace("Scanned dev system extensions:",Z.length),(0,L.$jf)(Z)}async J(){try{const V=await this.s.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async L(V,G,F,C,B,Y,Z){const Q=await this.f(B??m.$v),U=await this.M(V),M=G&&!this.w.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,a=M?await this.M(M):void 0;return new x(V,U,M,a,G,Z,F,C,Y,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,B,Q)}async M(V){try{const G=await this.s.stat(V);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$gp=_,e.$gp=_=$e([se(4,I.$rk),se(5,S.$bp),se(6,o.$Sj),se(7,s.$Ri),se(8,P.$wh),se(9,n.$0i),se(10,v.$pk),se(11,i.$oh)],_);class x{constructor(V,G,F,C,B,Y,Z,Q,U,M,a,g,z,T,X){this.location=V,this.mtime=G,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=C,this.profile=B,this.profileScanOptions=Y,this.type=Z,this.excludeObsolete=Q,this.validate=U,this.productVersion=M,this.productDate=a,this.productCommit=g,this.devMode=z,this.language=T,this.translations=X}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,G){return(0,d.$2f)(V.location,G.location)&&V.mtime===G.mtime&&(0,d.$2f)(V.applicationExtensionslocation,G.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&V.profile===G.profile&&R.$Mm(V.profileScanOptions,G.profileScanOptions)&&V.type===G.type&&V.excludeObsolete===G.excludeObsolete&&V.validate===G.validate&&V.productVersion===G.productVersion&&V.productDate===G.productDate&&V.productCommit===G.productCommit&&V.devMode===G.devMode&&V.language===G.language&&W.equals(V.translations,G.translations)}}e.$hp=x;let le=class extends l.$lb{constructor(V,G,F,C,B){super(),this.f=V,this.g=G,this.h=F,this.i=C,this.j=B}async scanExtensions(V){const G=V.profile?await this.l(V):await this.k(V);let F={};if(V.excludeObsolete&&V.type===1)try{const C=(await this.i.readFile(this.f)).value.toString();F=JSON.parse(C)}catch{}return(0,$.$ve)(F)?G:G.filter(C=>!F[p.$io.create(C).toString()])}async k(V){const G=await this.i.resolve(V.location);if(!G.children?.length)return[];const F=await Promise.all(G.children.map(async C=>{if(!C.isDirectory||V.type===1&&(0,d.$6f)(C.resource).indexOf(".")===0)return null;const B=new x(C.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(B)}));return(0,L.$jf)(F).sort((C,B)=>C.location.path<B.location.path?-1:1)}async l(V){let G=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){G=G.filter(C=>!C.metadata?.isApplicationScoped);const F=await this.m(V.applicationExtensionslocation,C=>!!C.metadata?.isBuiltin||!!C.metadata?.isApplicationScoped,V);G.push(...F)}return G}async m(V,G,F){const C=await this.g.scanProfileExtensions(V,F.profileScanOptions);if(!C.length)return[];const B=await Promise.all(C.map(async Y=>{if(G(Y)){const Z=new x(Y.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(Z,Y.metadata)}return null}));return(0,L.$jf)(B)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,d.$9f)(V.location,"package.json"))){const G=await this.scanExtension(V);return G?[G]:[]}else return await this.scanExtensions(V)}catch(G){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,N.$9)(G)),[]}}async scanExtension(V,G){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=E.$El),G=G??F.__metadata,delete F.__metadata;const C=(0,p.$mo)(F.publisher,F.name),B=G?.id?{id:C,uuid:G.id}:{id:C},Y=G?.isSystem?0:V.type,Z=Y===0||!!G?.isBuiltin;F=await this.n(V.location,F,x.createNlsConfiguration(V));const Q={type:Y,identifier:B,manifest:F,location:V.location,isBuiltin:Z,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return V.validate?this.validate(Q,V):Q}}catch(F){V.type!==0&&this.j.error(F)}return null}validate(V,G){let F=!0;const C=(0,t.$xo)(G.productVersion,G.productDate,G.location,V.manifest,V.isBuiltin);for(const[B,Y]of C)B===k.default.Error&&(F=!1,this.j.error(this.u(G.location,Y)));return V.isValid=F,V.validations=C,V}async scanExtensionManifest(V){const G=(0,d.$9f)(V,"package.json");let F;try{F=(await this.i.readFile(G)).value.toString()}catch(B){return(0,o.$9j)(B)!==1&&this.j.error(this.u(V,(0,h.localize)(0,null,G.path,B.message))),null}let C;try{C=JSON.parse(F)}catch{const Y=[];(0,y.$ym)(F,Y);for(const Z of Y)this.j.error(this.u(V,(0,h.localize)(1,null,G.path,Z.offset,Z.length,(0,u.$dp)(Z.error))));return null}return(0,y.$Hm)(C)!=="object"?(this.j.error(this.u(V,(0,h.localize)(2,null,G.path))),null):C}async n(V,G,F){const C=await this.r(V,G,F);if(C)try{const B=[],Y=await this.s(C.default,B);if(B.length>0)return B.forEach(Q=>{this.j.error(this.u(V,(0,h.localize)(3,null,C.default?.path,(0,u.$dp)(Q.error))))}),G;if((0,y.$Hm)(C)!=="object")return this.j.error(this.u(V,(0,h.localize)(4,null,C.default?.path))),G;const Z=C.values||Object.create(null);return(0,D.$ep)(G,Z,Y)}catch{}return G}async r(V,G,F){const C=(0,d.$9f)(V,"package.nls.json"),B=(U,M)=>{M.forEach(a=>{this.j.error(this.u(V,(0,h.localize)(5,null,U?.path,(0,u.$dp)(a.error))))})},Y=U=>{this.j.error(this.u(V,(0,h.localize)(6,null,U?.path)))},Z=`${G.publisher}.${G.name}`,Q=F.translations[Z];if(Q)try{const U=f.URI.file(Q),M=(await this.i.readFile(U)).value.toString(),a=[],g=(0,y.$ym)(M,a);return a.length>0?(B(U,a),{values:void 0,default:C}):(0,y.$Hm)(g)!=="object"?(Y(U),{values:void 0,default:C}):{values:g.contents?g.contents.package:void 0,default:C}}catch{return{values:void 0,default:C}}else{if(!await this.i.exists(C))return;let M;try{M=await this.t(V,F)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const a=(await this.i.readFile(M.localized)).value.toString(),g=[],z=(0,y.$ym)(a,g);return g.length>0?(B(M.localized,g),{values:void 0,default:M.original}):(0,y.$Hm)(z)!=="object"?(Y(M.localized),{values:void 0,default:M.original}):{values:z,default:M.original}}catch{return{values:void 0,default:M.original}}}}async s(V,G){if(V)try{const F=(await this.i.readFile(V)).value.toString();return(0,y.$ym)(F,G)}catch{}}t(V,G){return new Promise((F,C)=>{const B=Y=>{const Z=(0,d.$9f)(V,`package.nls.${Y}.json`);this.i.exists(Z).then(Q=>{Q&&F({localized:Z,original:(0,d.$9f)(V,"package.nls.json")});const U=Y.lastIndexOf("-");U===-1?F({localized:(0,d.$9f)(V,"package.nls.json"),original:null}):(Y=Y.substring(0,U),B(Y))})};if(G.devMode||G.pseudo||!G.language)return F({localized:(0,d.$9f)(V,"package.nls.json"),original:null});B(G.language)})}u(V,G){return`[${V.path}]: ${G}`}};le=$e([se(1,S.$bp),se(2,v.$pk),se(3,o.$Sj),se(4,s.$Ri)],le);let te=class extends le{constructor(V,G,F,C,B,Y,Z){super(G,C,B,Y,Z),this.z=V,this.C=F,this.w=this.B(new j.$sg(3e3)),this.y=this.B(new r.$ec),this.onDidChangeCache=this.y.event}async scanExtensions(V){const G=this.H(V),F=await this.D(G);if(this.v=V,F&&F.input&&x.equals(F.input,this.v))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.w.trigger(()=>this.G()),F.result.map(B=>(B.location=f.URI.revive(B.location),B));const C=await super.scanExtensions(V);return await this.F(G,{input:V,result:C}),C}async D(V){try{const G=await this.i.readFile(V),F=JSON.parse(G.value.toString());return{result:F.result,input:(0,c.$Yg)(F.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",V.path,(0,N.$9)(G))}return null}async F(V,G){try{await this.i.writeFile(V,A.$Ec.fromString(JSON.stringify(G)))}catch(F){this.j.debug("Error while writing the extension cache file:",V.path,(0,N.$9)(F))}}async G(){if(!this.v)return;const V=this.H(this.v),G=await this.D(V);if(!G)return;const F=G.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!R.$Mm(C,F))try{this.j.info("Invalidating Cache",F,C),await this.i.del(V),this.y.fire()}catch(B){this.j.error(B)}}H(V){const G=this.I(V);return this.h.extUri.joinPath(G.cacheHome,V.type===0?E.$Dl:E.$Cl)}I(V){return V.type===0?this.C.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.z.extensionsResource)?this.z:this.C.profiles.find(G=>this.h.extUri.isEqual(V.location,G.extensionsResource))??this.z:this.C.defaultProfile}};te=$e([se(2,I.$rk),se(3,S.$bp),se(4,v.$pk),se(5,o.$Sj),se(6,s.$Ri)],te);function ce(ie,V){const G=(0,p.$ko)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new E.$Il(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:V,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$ip=ce;class ue extends _{constructor(V,G,F,C,B,Y,Z,Q,U,M,a,g){super(V,G,(0,d.$9f)(F,".vscode-oss-dev","extensions","control.json"),C,B,Y,Z,Q,U,M,a,g),this.N=(async()=>{if(m.$y)try{const z=await this.s.readFile(f.URI.file(m.$y));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(V){return this.N}}e.$jp=ue}),define(ne[154],re([0,1,58,8,33,4,2,15,16,24,6,23]),function(J,e,L,j,R,A,N,y,u,l,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;let m=class extends N.$lb{constructor(b,k){super(),this.b=b,this.f=k,this.a=new j.$Ag(5)}async postUninstall(b){const k=this.g(b,"uninstall");k&&(this.f.info(b.identifier.id,b.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(k.script,"uninstall",k.args,!0,b),this.f.info("Finished running post uninstall script",b.identifier.id,b.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",b.identifier.id,b.manifest.version),this.f.error($)}}));try{await l.Promises.rm(this.j(b))}catch($){this.f.error("Error while removing extension storage path",b.identifier.id),this.f.error($)}}g(b,k){const $=`vscode:${k}`;if(b.location.scheme===y.Schemas.file&&b.manifest&&b.manifest.scripts&&typeof b.manifest.scripts[$]=="string"){const f=b.manifest.scripts[$].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(b.identifier.id,b.manifest.version,`${$} should be a node script`),null):{script:(0,u.$8c)(b.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(b,k,$,f,h){return new Promise((P,p)=>{const E=this.i(b,k,$,h);let t;const o=i=>{t&&(clearTimeout(t),t=null),i?p(i):P(void 0)};E.on("error",i=>{o((0,R.$ai)(i)||"Unknown")}),E.on("exit",(i,s)=>{o(i?`post-${k} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,E.kill(),p("timed out")},5e3))})}i(b,k,$,f){const h={silent:!0,execArgv:void 0},P=(0,L.fork)(b,[`--type=extension-post-${k}`,...$],h);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(P.stdout,"data"),E=A.Event.fromNodeEventEmitter(P.stderr,"data");p(i=>this.f.info(f.identifier.id,f.manifest.version,`post-${k}`,i)),E(i=>this.f.error(f.identifier.id,f.manifest.version,`post-${k}`,i));const t=A.Event.any(A.Event.map(p,i=>({data:`%c${i}`,format:[""]})),A.Event.map(E,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),P}j(b){return(0,u.$8c)(this.b.defaultProfile.globalStorageHome.fsPath,b.identifier.id.toLowerCase())}};e.$lp=m,e.$lp=m=$e([se(0,O.$rk),se(1,w.$Ri)],m)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,j,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;let w=class extends N.$cp{constructor(m,d,b,k,$,f){super(l.URI.file(m.extensionsPath),d,b,k,$,f)}};e.$8M=w,e.$8M=w=$e([se(0,u.$xh),se(1,y.$Sj),se(2,j.$rk),se(3,R.$pk),se(4,A.$Vk),se(5,L.$Ri)],w)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,31,22,23]),function(J,e,L,j,R,A,N,y,u,l,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d6b=void 0;let m=class extends A.$jp{constructor(b,k,$,f,h,P,p,E){super(L.URI.file(h.builtinExtensionsPath),L.URI.file(h.extensionsPath),h.userHome,b.defaultProfile,b,k,$,f,h,P,p,E)}};e.$d6b=m,e.$d6b=m=$e([se(0,O.$rk),se(1,R.$bp),se(2,N.$Sj),se(3,u.$Ri),se(4,j.$xh),se(5,l.$0i),se(6,w.$pk),se(7,y.$oh)],m)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,j,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Ko="__$__isNewStorageMarker",e.$Lo="__$__targetStorageMarker",e.$Mo=(0,u.$ph)("storageService");var w;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(w||(e.WillSaveStateReason=w={}));var O;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var m;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function d(h){const P=h.get(e.$Lo);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}e.$No=d;class b extends R.$lb{static{this.a=60*1e3}constructor(P={flushInterval:b.a}){super(),this.j=P,this.b=this.B(new j.$hc),this.c=this.B(new j.$hc),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$ec),this.onWillSaveState=this.f.event,this.h=this.B(new L.$Gg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new R.$mb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(P,p,E){return j.Event.filter(this.b.event,t=>t.scope===P&&(p===void 0||t.key===p),E)}k(){this.i.value=(0,L.$Kg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,R.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(P,p){const{key:E,external:t}=p;if(E===e.$Lo){switch(P){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:E,target:this.F(P)[E],external:t})}r(P){this.f.fire({reason:P})}get(P,p,E){return this.L(p)?.get(P,E)}getBoolean(P,p,E){return this.L(p)?.getBoolean(P,E)}getNumber(P,p,E){return this.L(p)?.getNumber(P,E)}getObject(P,p,E){return this.L(p)?.getObject(P,E)}storeAll(P,p){this.t(()=>{for(const E of P)this.store(E.key,E.value,E.scope,E.target,p)})}store(P,p,E,t,o=!1){if((0,N.$re)(p)){this.remove(P,E,o);return}this.t(()=>{this.u(P,E,t),this.L(E)?.set(P,p,o)})}remove(P,p,E=!1){this.t(()=>{this.u(P,p,void 0),this.L(p)?.delete(P,E)})}t(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,p){const E=[],t=this.F(P);for(const o of Object.keys(t))t[o]===p&&E.push(o);return E}u(P,p,E,t=!1){const o=this.F(p);typeof E=="number"?o[P]!==E&&(o[P]=E,this.L(p)?.set(e.$Lo,JSON.stringify(o),t)):typeof o[P]=="number"&&(delete o[P],this.L(p)?.set(e.$Lo,JSON.stringify(o),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(P){switch(P){case-1:return this.D;case 0:return this.z;default:return this.w}}G(P){const p=this.L(P);return p?d(p):Object.create(null)}isNew(P){return this.getBoolean(e.$Ko,P)===!0}async flush(P=w.NONE){this.f.fire({reason:P});const p=this.L(-1),E=this.L(0),t=this.L(1);switch(P){case w.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,E=this.L(1)?.items??new Map;return f(P,p,E,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(P,p){return this.r(w.NONE),(0,l.$qk)(P)?this.N(P,p):this.O(P,p)}H(P,p){return!(P.id===p.id||k(p)&&k(P))}I(P,p,E){this.t(()=>{const t=new Set;for(const[o,i]of P)t.add(o),p.get(o)!==i&&this.n(E,{key:o,external:!0});for(const[o]of p.items)t.has(o)||this.n(E,{key:o,external:!0})})}}e.$Oo=b;function k(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$Po=k;class $ extends b{constructor(){super(),this.p=this.B(new y.$Io(new y.$Jo,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new y.$Io(new y.$Jo,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new y.$Io(new y.$Jo,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(P=>this.n(1,P))),this.B(this.P.onDidChangeStorage(P=>this.n(0,P))),this.B(this.p.onDidChangeStorage(P=>this.n(-1,P)))}L(P){switch(P){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(P){switch(P){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(P){return!1}}e.$Qo=$;async function f(h,P,p,E,t,o){const i=W=>{try{return JSON.parse(W)}catch{return W}},s=new Map,n=new Map;h.forEach((W,_)=>{s.set(_,W),n.set(_,i(W))});const r=new Map,c=new Map;P.forEach((W,_)=>{r.set(_,W),c.set(_,i(W))});const S=new Map,I=new Map;p.forEach((W,_)=>{S.set(_,W),I.set(_,i(W))}),console.group(E!==t?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const v=[];if(s.forEach((W,_)=>{v.push({key:_,value:W})}),console.table(v),console.groupEnd(),console.log(n),E!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];r.forEach((_,x)=>{W.push({key:x,value:_})}),console.table(W),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${o})`);const D=[];S.forEach((W,_)=>{D.push({key:_,value:W})}),console.table(D),console.groupEnd(),console.log(I)}e.$Ro=f}),define(ne[158],re([0,1,19,20,9,13,34,3,11,25,18,21,27,48,12,6,31,45,142,157,26,175]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=void 0;const t=A.$o?"web":(0,O.$Mn)(A.$t,N.$3c),o="X-Market-Search-Activity-Id";var i;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...a){return String(a.reduce((g,z)=>g|z,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class v{constructor(g=I){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,z=this.d.pageSize){return new v({...this.d,pageNumber:g,pageSize:z})}withFilter(g,...z){const T=[...this.d.criteria,...z.length?z.map(X=>({filterType:g,value:X})):[{filterType:g}]];return new v({...this.d,criteria:T})}withSortBy(g){return new v({...this.d,sortBy:g})}withSortOrder(g){return new v({...this.d,sortOrder:g})}withFlags(...g){return new v({...this.d,flags:g.reduce((z,T)=>z|T,0)})}withAssetTypes(...g){return new v({...this.d,assetTypes:g})}withSource(g){return new v({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:z,pageSize:T,sortBy:X,sortOrder:H,flags:ae,assetTypes:oe}=this.d;return{filters:[{criteria:g,pageNumber:z,pageSize:T,sortBy:X,sortOrder:H}],assetTypes:oe,flags:ae}}get searchText(){const g=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(a,g){const z=(a||[]).filter(T=>T.statisticName===g)[0];return z?z.value:0}function W(a){const g="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(T=>T.assetType.indexOf(g)===0).reduce((T,X)=>{const H=le(a,X.assetType);return H&&T.push([X.assetType.substring(g.length),H]),T},[])}function _(a){if(a.properties){const g=a.properties.filter(X=>X.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=g.filter(X=>z.test(X.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return le(a,r.Repository)}function x(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function le(a,g){return a.files.filter(T=>T.assetType===g)[0]?{uri:`${a.assetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function te(a,g){const z=a.properties?a.properties.filter(X=>X.key===g):[],T=z.length>0&&z[0].value;return T?T.split(",").map(X=>(0,m.$lo)(X)):[]}function ce(a){const g=a.properties?a.properties.filter(z=>z.key===c.Engine):[];return g.length>0&&g[0].value||""}function ue(a){const g=a.properties?a.properties.filter(z=>z.key===c.PreRelease):[];return g.length>0&&g[0].value==="true"}function ie(a){const g=a.properties?a.properties.filter(T=>T.key===c.LocalizedLanguages):[],z=g.length>0&&g[0].value||"";return z?z.split(","):[]}function V(a){return a.properties?.find(g=>g.key===c.SponsorLink)?.value}function G(a){return a.indexOf("preview")!==-1}function F(a){return a.targetPlatform?(0,O.$Ln)(a.targetPlatform):"undefined"}function C(a){const g=(0,L.$of)(a.versions.map(F)),z=!!a.tags?.includes(O.$Gn),T=g.indexOf("web");return z?T===-1&&g.push("web"):T!==-1&&g.splice(T,1),g}function B(a,g){const z=(0,O.$Pn)(g);for(let T=0;T<a.length;T++){const X=a[T];if(X.version===a[T-1]?.version){let H=T;const ae=F(X);if(ae===g)for(;H>0&&a[H-1].version===X.version;)H--;else if(z.includes(ae))for(;H>0&&a[H-1].version===X.version&&F(a[H-1])!==g;)H--;H!==T&&(a.splice(T,1),a.splice(H,0,X))}}return a}e.$Uo=B;function Y(a,g,z){a.telemetryData={index:g,querySource:z,queryActivityId:a.queryContext?.[o]}}function Z(a,g,z,T){const X=a.versions[0],H={manifest:le(g,r.Manifest),readme:le(g,r.Details),changelog:le(g,r.Changelog),license:le(g,r.License),repository:_(g),download:x(g),icon:le(g,r.Icon),signature:le(g,r.Signature),coreTranslations:W(g)};return{identifier:{id:(0,m.$mo)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:g.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(X),description:a.shortDescription||"",installCount:D(a.statistics,"install"),rating:D(a.statistics,"averagerating"),ratingCount:D(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:H,properties:{dependencies:te(g,c.Dependency),extensionPack:te(g,c.ExtensionPack),engine:ce(g),localizedLanguages:ie(g),targetPlatform:F(g),isPreReleaseVersion:ue(g)},hasPreReleaseVersion:ue(X),hasReleaseVersion:!0,preview:G(a.flags),isSigned:!!H.signature,queryContext:T}}let Q=class{constructor(g,z,T,X,H,ae,oe,pe){this.k=z,this.l=T,this.n=X,this.o=H,this.q=ae,this.u=oe,this.w=pe;const de=oe.extensionsGallery,me=de?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=me?de.servicePPEUrl:de?.serviceUrl,this.g=me?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,h.$To)(oe.version,oe,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,z,T){const X=j.CancellationToken.isCancellationToken(z)?{}:z,H=j.CancellationToken.isCancellationToken(z)?z:T,ae=[],oe=[],pe=[],de=[];let me=!0;for(const we of g){we.uuid?oe.push(we.uuid):ae.push(we.id);const be=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),me=me&&!!we.hasPreRelease&&!be}if(!oe.length&&!ae.length)return[];let fe=new v().withPage(1,g.length);oe.length&&(fe=fe.withFilter(n.ExtensionId,...oe)),ae.length&&(fe=fe.withFilter(n.ExtensionName,...ae)),(X.queryAllVersions||me)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),X.source&&(fe=fe.withSource(X.source));const{extensions:he}=await this.z(fe,{targetPlatform:X.targetPlatform??t,includePreRelease:pe,versions:de,compatible:!!X.compatible},H);return X.source&&he.forEach((we,be)=>Y(we,be,X.source)),he}async getCompatibleExtension(g,z,T){if((0,O.$Nn)(g.allTargetPlatforms,T))return null;if(await this.isExtensionCompatible(g,z,T))return g;const X=new v().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,g.identifier.uuid),{extensions:H}=await this.z(X,{targetPlatform:T,compatible:!0,includePreRelease:z},j.CancellationToken.None);return H[0]||null}async isExtensionCompatible(g,z,T){if(!(0,O.$On)(g.properties.targetPlatform,g.allTargetPlatforms,T)||!z&&g.properties.isPreReleaseVersion)return!1;let X=g.properties.engine;if(!X){const H=await this.getManifest(g,j.CancellationToken.None);if(!H)throw new Error("Manifest was not found");X=H.engines.vscode}return(0,d.$zo)(X,this.u.version,this.u.date)}async y(g,z,T,X,H){if(!(0,O.$On)(F(g),X,H)||z!=="any"&&ue(g)!==(z==="prerelease"))return!1;if(T)try{const ae=await this.E(g);if(!(0,d.$zo)(ae,this.u.version,this.u.date))return!1}catch(ae){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,R.$9)(ae)),!1}return!0}async query(g,z){let T=g.text||"";const X=g.pageSize??50;let H=new v().withPage(1,X);T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,he)=>(H=H.withFilter(n.Category,he||fe),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,he)=>(H=H.withFilter(n.Tag,he||fe),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),H=H.withFilter(n.SearchText,T)),H=H.withSortBy(0)):g.ids?H=H.withFilter(n.ExtensionId,...g.ids):g.names?H=H.withFilter(n.ExtensionName,...g.names):H=H.withSortBy(4),typeof g.sortBy=="number"&&(H=H.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(H=H.withSortOrder(g.sortOrder)),g.source&&(H=H.withSource(g.source));const ae=async(me,fe)=>{const{extensions:he,total:we}=await this.z(me,{targetPlatform:t,compatible:!1,includePreRelease:!!g.includePreRelease},fe);return he.forEach((be,Se)=>Y(be,(me.pageNumber-1)*me.pageSize+Se,g.source)),{extensions:he,total:we}},{extensions:oe,total:pe}=await ae(H,z),de=async(me,fe)=>{if(fe.isCancellationRequested)throw new R.$3;const{extensions:he}=await ae(H.withPage(me+1),fe);return he};return{firstPage:oe,total:pe,pageSize:H.pageSize,getPage:de}}async z(g,z,T){const X=g.flags;g.flags&i.IncludeLatestVersionOnly&&g.flags&i.IncludeVersions&&(g=g.withFlags(g.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(g.flags&i.IncludeLatestVersionOnly)&&!(g.flags&i.IncludeVersions)&&(g=g.withFlags(g.flags,i.IncludeLatestVersionOnly)),z.versions?.length&&(g=g.withFlags(g.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),g=g.withFlags(g.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:H,total:ae,context:oe}=await this.B(g,T);if(!(g.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const he of H){const we=await this.A(he,z,oe);we&&fe.push(we)}return{extensions:fe,total:ae}}const de=[],me=new Map;for(let fe=0;fe<H.length;fe++){const he=H[fe],we={id:(0,m.$mo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,y.$oe)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(ze=>(0,m.$ho)(ze,we))?.includePreRelease;if(z.compatible&&(0,O.$Nn)(C(he),z.targetPlatform))continue;const Se=await this.A(he,z,oe);!Se||Se.properties.isPreReleaseVersion&&(!be||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==z.targetPlatform&&Se.hasPreReleaseVersion?me.set(he.extensionId,fe):de.push([fe,Se])}if(me.size){const fe=new E.$ac,he=new v().withFlags(X&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,me.size).withFilter(n.ExtensionId,...me.keys()),{extensions:we}=await this.z(he,z,T);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:me.size});for(const be of we){const Se=me.get(be.identifier.uuid);de.push([Se,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ae}}async A(g,z,T){const X={id:(0,m.$mo)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},H=z.versions?.find(de=>(0,m.$ho)(de,X))?.version,ae=(0,y.$oe)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,m.$ho)(de,X))?.includePreRelease,oe=C(g),pe=B(g.versions,z.targetPlatform);if(z.compatible&&(0,O.$Nn)(oe,z.targetPlatform))return null;for(let de=0;de<pe.length;de++){const me=pe[de];if(!(H&&me.version!==H)){if(await this.y(me,ae?"any":"release",z.compatible,oe,z.targetPlatform))return Z(g,me,oe,T);if(H&&me.version===H)return null}}return H||z.compatible?null:Z(g,g.versions[0],oe)}async B(g,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,s(i.Unpublished));const T=await this.j,X=JSON.stringify(g.raw),H={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},ae=new E.$ac;let oe,pe,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&g.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:H},z),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const me=await(0,f.$Fo)(oe);if(me){const fe=me.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(me){throw pe=me,me}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(X.length),duration:ae.elapsed(),success:!!oe&&(0,f.$Co)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:pe?(0,R.$2)(pe)?"canceled":(0,R.$9)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,z,T,X){if(!this.isEnabled())return;const H=A.$o?this.x(`/itemName/${g}.${z}/version/${T}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${z}/${T}/stats?statType=${X}`),ae=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:H,headers:pe},j.CancellationToken.None)}catch{}}async download(g,z,T){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const X=(0,m.$po)(g),H=new Date().getTime(),ae=fe=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),oe=T===2?"install":T===3?"update":"",pe=oe?{uri:`${g.assets.download.uri}${u.URI.parse(g.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${g.assets.download.fallbackUri}${u.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:g.assets.download,de=g.queryContext?.[o]?{[o]:g.queryContext[o]}:void 0,me=await this.D(pe,de?{headers:de}:void 0);await this.q.writeFile(z,me.stream),ae(new Date().getTime()-H)}async downloadSignatureArchive(g,z){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const T=await this.D(g.assets.signature);await this.q.writeFile(z,T.stream)}async getReadme(g,z){if(g.assets.readme){const T=await this.D(g.assets.readme,{},z);return await(0,f.$Eo)(T)||""}return""}async getManifest(g,z){if(g.assets.manifest){const T=await this.D(g.assets.manifest,{},z),X=await(0,f.$Eo)(T);return X?JSON.parse(X):null}return null}async C(g,z){const T=le(g,r.Manifest);if(!T)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},H=await this.D(T,{headers:X});return await(0,f.$Fo)(H)}async getCoreTranslation(g,z){const T=g.assets.coreTranslations.filter(X=>X[0]===z.toUpperCase())[0];if(T){const X=await this.D(T[1]),H=await(0,f.$Eo)(X);return H?JSON.parse(H):null}return null}async getChangelog(g,z){if(g.assets.changelog){const T=await this.D(g.assets.changelog,{},z);return await(0,f.$Eo)(T)||""}return""}async getAllCompatibleVersions(g,z,T){let X=new v().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?X=X.withFilter(n.ExtensionId,g.identifier.uuid):X=X.withFilter(n.ExtensionName,g.identifier.id);const{galleryExtensions:H}=await this.B(X,j.CancellationToken.None);if(!H.length)return[];const ae=C(H[0]);if((0,O.$Nn)(ae,T))return[];const oe=[];await Promise.all(H[0].versions.map(async me=>{try{await this.y(me,z?"any":"release",!0,ae,T)&&oe.push(me)}catch{}}));const pe=[],de=new Set;for(const me of B(oe,T))de.has(me.version)||(de.add(me.version),pe.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:ue(me)}));return pe}async D(g,z={},T=j.CancellationToken.None){const X=await this.j,H={type:"GET"},ae={...X,...z.headers||{}};z={...z,...H,headers:ae};const oe=g.uri,pe=g.fallbackUri,de={...z,url:oe};try{const me=await this.k.request(de,T);if(me.res.statusCode===200)return me;const fe=await(0,f.$Eo)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${fe}`)}catch(me){if((0,R.$2)(me))throw me;const fe=(0,R.$9)(me);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...z,url:pe};return this.k.request(he,T)}}async E(g){let z=ce(g);if(!z){const T=await this.C(g,j.CancellationToken.None);if(!T)throw new Error("Manifest was not found");z=T.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},j.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,f.$Fo)(g),T=[],X={},H=[];if(z){for(const ae of z.malicious)T.push({id:ae});if(z.migrateToPreRelease)for(const[ae,oe]of Object.entries(z.migrateToPreRelease))(!oe.engine||(0,d.$zo)(oe.engine,this.u.version,this.u.date))&&(X[ae.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[ae,oe]of Object.entries(z.deprecated))oe&&(X[ae.toLowerCase()]=(0,y.$oe)(oe)?{}:oe);if(z.search)for(const ae of z.search)H.push(ae)}return{malicious:T,deprecated:X,search:H}}};Q=$e([se(1,f.$Ao),se(2,k.$Ri),se(3,w.$wh),se(4,p.$Vk),se(5,b.$Sj),se(6,$.$0i),se(7,l.$Vh)],Q);let U=class extends Q{constructor(g,z,T,X,H,ae,oe,pe){super(g,z,T,X,H,ae,oe,pe)}};e.$Vo=U,e.$Vo=U=$e([se(0,P.$Mo),se(1,f.$Ao),se(2,k.$Ri),se(3,w.$wh),se(4,p.$Vk),se(5,b.$Sj),se(6,$.$0i),se(7,l.$Vh)],U);let M=class extends Q{constructor(g,z,T,X,H,ae,oe){super(void 0,g,z,T,X,H,ae,oe)}};e.$Wo=M,e.$Wo=M=$e([se(0,f.$Ao),se(1,k.$Ri),se(2,w.$wh),se(3,p.$Vk),se(4,b.$Sj),se(5,$.$0i),se(6,l.$Vh)],M)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,j,R,A,N,y,u,l,w){"use strict";var O,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.$5M=void 0;let d=class extends u.$uk{static{O=this}static{this.a="profileAssociationsMigration"}constructor(f,h,P,p,E){super(P,p,h,E),this.P=f,this.Q=P}J(){return this.P.getItem(O.b,[]).map(h=>({...h,location:(0,l.$ie)(h.location)?this.s.extUri.joinPath(this.profilesHome,h.location):L.URI.revive(h.location)}))}M(){const f=this.P.getItem(O.c,{});return this.P.getItem(O.a,!1)?f:this.I(f)}O(){return this.s.extUri.joinPath(L.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$5M=d,e.$5M=d=O=$e([se(0,N.$ZM),se(1,y.$pk),se(2,j.$xh),se(3,R.$Sj),se(4,A.$Ri)],d);let b=m=class extends d{constructor(f,h,P,p,E){super(f,h,P,p,E),this.W=f}L(f){f.length?this.W.setItem(m.b,f.map(h=>({...h,location:this.s.extUri.basename(h.location)}))):this.W.removeItem(m.b)}J(){const f=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(f),this.W.setItem("userDataProfilesMigration",!0)),f}N(f){f.emptyWindows||f.workspaces?this.W.setItem(m.c,f):this.W.removeItem(m.c)}M(){const f="workspaceAndProfileInfo",h=this.W.getItem(f,void 0);if(h){this.W.removeItem(f);const p=h.reduce((E,{workspace:t,profile:o})=>(E[L.URI.revive(t).toString()]=L.URI.revive(o).toString(),E),{});this.W.setItem(m.c,{workspaces:p})}const P=super.M();return this.W.getItem(m.a,!1)||(this.N(P),this.W.setItem(m.a,!0)),P}};e.$6M=b,e.$6M=b=m=$e([se(0,N.$1M),se(1,y.$pk),se(2,j.$xh),se(3,R.$Sj),se(4,A.$Ri)],b);let k=class extends b{constructor(f,h,P,p){super(new w.$4M(0,h,p,P),f,h,P,p)}async init(){return await this.W.init(),super.init()}};e.$7M=k,e.$7M=k=$e([se(0,y.$pk),se(1,j.$xh),se(2,R.$Sj),se(3,A.$Ri)],k)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,j,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.zip=e.$5o=e.$4o=void 0,e.$4o="end of central directory record signature not found";const w=new RegExp(e.$4o);class O extends Error{constructor(o,i){let s=i.message;switch(o){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=o,this.cause=i}}e.$5o=O;function m(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>o&i).reduce((i,s)=>i+s,o&61440)}function d(t){if(t instanceof O)return t;let o;return w.test(t.message)&&(o="CorruptZip"),new O(o,t)}function b(t,o,i,s,n,r){const c=R.$$c(o),S=R.$8c(s,c);if(!S.startsWith(s))return Promise.reject(new Error(y.localize(0,null,o)));const I=R.$8c(s,o);let v;return r.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(N.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((D,W)=>{if(!r.isCancellationRequested)try{v=(0,L.createWriteStream)(I,{mode:i}),v.once("close",()=>D()),v.once("error",W),t.once("error",W),t.pipe(v)}catch(_){W(_)}}))}function k(t,o,i,s){let n=(0,j.$ig)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{n.cancel(),t.close()}),new Promise((c,S)=>{const I=new j.$pg,v=D=>{D.isCancellationRequested||(r++,t.readEntry())};t.once("error",S),t.once("close",()=>n.then(()=>{s.isCancellationRequested||t.entryCount===r?c():S(new O("Incomplete",new Error(y.localize(1,null,r,t.entryCount))))},S)),t.readEntry(),t.on("entry",D=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(D.fileName)){v(s);return}const W=D.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(W)){const le=R.$8c(o,W);n=(0,j.$ig)(te=>N.Promises.mkdir(le,{recursive:!0}).then(()=>v(te)).then(void 0,S));return}const _=f(t,D),x=m(D);n=(0,j.$ig)(le=>I.queue(()=>_.then(te=>b(te,W,x,o,i,le).then(()=>v(le)))).then(null,S))})})}function $(t,o=!1){return new Promise((i,s)=>{(0,u.open)(t,o?{lazyEntries:!0}:void 0,(n,r)=>{n?s(d(n)):i((0,A.$te)(r))})})}function f(t,o){return new Promise((i,s)=>{t.openReadStream(o,(n,r)=>{n?s(d(n)):i((0,A.$te)(r))})})}function h(t,o){return new Promise((i,s)=>{const n=new l.ZipFile;o.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const r=(0,L.createWriteStream)(t);n.outputStream.pipe(r),n.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>i(t))})}e.zip=h;function P(t,o,i={},s){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=$(t,!0);return i.overwrite&&(r=r.then(c=>N.Promises.rm(o).then(()=>c))),r.then(c=>k(c,o,{sourcePathRegex:n},s))}e.$7o=P;function p(t,o){return $(t).then(i=>new Promise((s,n)=>{i.on("entry",r=>{r.fileName===o&&f(i,r).then(c=>s(c),c=>n(c))}),i.once("close",()=>n(new Error(y.localize(2,null,o))))}))}function E(t,o){return p(t,o).then(i=>new Promise((s,n)=>{const r=[];i.once("error",n),i.on("data",c=>r.push(c)),i.on("end",()=>s(Buffer.concat(r)))}))}e.$8o=E}),define(ne[160],re([0,1,8,9,2,15,17,43,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;let p=class extends R.$lb{static{P=this}static{this.c=".sigzip"}constructor(t,o,i,s,n,r){super(),this.h=o,this.i=i,this.j=s,this.k=n,this.l=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(t,o,i){await this.g;const s=(0,N.$9f)(this.extensionsDownloadDir,this.u(t));try{await this.r(t,s,r=>this.i.download(t,r,o))}catch(r){throw new b.$Sn(r.message,b.ExtensionManagementErrorCode.Download)}let n=!1;if(i&&this.m(t)){const r=await this.n(t);try{n=await this.k.verify(s.fsPath,r.fsPath,this.l.getLevel()===h.LogLevel.Trace)}catch(c){const S=c;if(n=S.code,S.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${S.output}`),n===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new b.$Sn(O.$4o,b.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(c){this.l.error(c)}}}return n===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:s,verificationStatus:n}}m(t){if(!t.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,u.$oe)(o)?o:!0}async n(t){await this.g;const o=(0,N.$9f)(this.extensionsDownloadDir,`${this.u(t)}${P.c}`);return await this.r(t,o,i=>this.i.downloadSignatureArchive(t,i)),o}async r(t,o,i){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await i(o);return}const s=(0,N.$9f)(this.extensionsDownloadDir,`.${(0,l.$3e)()}`);await this.h.exists(s)||await i(s);try{await w.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(s)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.l.info(`Rename failed because of ${(0,j.$9)(n)}. Deleted the file from downloaded location`,s.path),n}}async delete(t){await this.g,await this.h.del(t)}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],i=[],s=[];for(const c of t.children)if(c.name.endsWith(P.c))s.push(c.resource);else{const S=k.$io.parse(c.name);S&&i.push([S,c])}const n=(0,k.$no)(i,([c])=>c),r=[];for(const c of n)c.sort((S,I)=>y.rcompare(S[0].version,I[0].version)),o.push(...c.slice(1).map(S=>S[1].resource)),r.push(c[0][1]);r.sort((c,S)=>c.mtime-S.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(c=>c.resource)),o.push(...s),await L.Promises.settled(o.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(t){this.l.error(t)}}u(t){return this.f?k.$io.create(t).toString().toLowerCase():(0,l.$3e)()}};e.$kp=p,e.$kp=p=P=$e([se(0,d.$xh),se(1,f.$Sj),se(2,b.$Rn),se(3,m.$Vh),se(4,$.$Xo),se(5,h.$Ri)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function R(A){return(0,L.$8o)(A,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,j.localize)(0,null))}})}e.$mp=R}),define(ne[162],re([0,1,8,14,20,33,9,4,42,2,35,15,16,17,43,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,31,26,22,23]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h,P,p,E,t,o,i,s,n,r,c,S,I,v,D,W,_,x,le,te,ce,ue,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=void 0,e.$pp=(0,x.$qh)(i.$Tn);const V=".vsctmp";let G=class extends o.$9o{constructor(U,M,a,g,z,T,X,H,ae,oe,pe,de){super(U,M,pe,a,oe,de),this.bb=z,this.cb=T,this.db=X,this.eb=ae,this.ab=new Map,this.nb=new w.$oi;const me=this.B(H.createInstance(S.$lp));this.Y=this.B(H.createInstance(F,he=>me.postUninstall(he))),this.Z=this.B(new v.$np(de,ae,pe,this,this.y)),this.$=this.B(H.createInstance(c.$kp));const fe=this.B(new D.$op(this,this.bb,de,T,pe,ae,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.mb(he))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,s.$so)(this.eb,this.y)),this.fb}async zip(U){this.y.trace("ExtensionManagementService#zip",U.identifier.id);const M=await this.lb(U),a=await(0,P.zip)((0,d.$9f)(this.$.extensionsDownloadDir,(0,f.$3e)()).fsPath,M);return $.URI.file(a)}async unzip(U){return this.y.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:M,cleanup:a}=await this.hb(U),g=m.$9c(M.fsPath);try{return await(0,I.$mp)(g)}finally{await a()}}getInstalled(U,M=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(U??null,M)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.Y.scanUserExtensionAtLocation(U)}async install(U,M={}){this.y.trace("ExtensionManagementService#install",U.toString());const{location:a,cleanup:g}=await this.hb(U);try{const z=await(0,I.$mp)(m.$9c(a.fsPath)),T=(0,s.$mo)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,W.$zo)(z.engines.vscode,this.z.version,this.z.date))throw new Error(p.localize(0,null,T,this.z.version));const X=await this.D([{manifest:z,extension:a,options:M}]);if(X[0]?.local)return X[0]?.local;throw X[0]?.error?X[0].error:(0,o.$$o)(new Error(`Unknown error while installing extension ${T}`))}finally{await g()}}async installFromLocation(U,M){this.y.trace("ExtensionManagementService#installFromLocation",U.toString());const a=await this.Y.scanUserExtensionAtLocation(U);if(!a)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.qb([[a,void 0]],M),this.y.info("Successfully installed extension",a.identifier.id,M.toString()),a}async installExtensionsFromProfile(U,M,a){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",U,M.toString(),a.toString());const g=(await this.Y.scanExtensions(1,M)).filter(z=>U.some(T=>(0,s.$ho)(T,z.identifier)));if(g.length){const z=await Promise.all(g.map(T=>this.Y.scanMetadata(T,M)));await this.qb(g.map((T,X)=>[T,z[X]]),a),this.y.info("Successfully installed extensions",g.map(T=>T.identifier.id),a.toString())}return g}async updateMetadata(U,M,a=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",U.identifier.id),M.isPreReleaseVersion&&(M.preRelease=!0),M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.pinned=M.pinned||void 0,U=await this.Y.updateMetadata(U,M,a),this.Z.invalidate(a),this.s.fire(U),U}async reinstallFromGallery(U){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.u.isEnabled())throw new Error(p.localize(1,null));const M=await this.getTargetPlatform(),[a]=await this.u.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:M,compatible:!0},R.CancellationToken.None);if(!a)throw new Error(p.localize(2,null));await this.Y.setUninstalled(U);try{await this.Y.removeUninstalledExtension(U)}catch(g){throw new Error(p.localize(3,null,(0,A.$ai)(g)))}return this.installFromGallery(a)}X(U,M,a,g){return this.Y.copyExtension(U,M,a,g)}copyExtensions(U,M){return this.Y.copyExtensions(U,M)}markAsUninstalled(...U){return this.Y.setUninstalled(...U)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(U){this.y.error(U)}}async download(U,M,a){const{location:g}=await this.$.download(U,M,!a);return g}async hb(U){if(U.scheme===O.Schemas.file)return{location:U,async cleanup(){}};this.y.trace("Downloading extension from",U.toString());const M=(0,d.$9f)(this.$.extensionsDownloadDir,(0,f.$3e)());return await this.db.download(U,M),this.y.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.eb.del(M)}catch(g){this.y.error(g)}}}}S(){return this.C.defaultProfile.extensionsResource}U(U,M,a){if($.URI.isUri(M))return new Y(U,M,a,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const g=s.$io.create(M).toString();let z=this.ab.get(g);return z||(this.ab.set(g,z=new B(U,M,a,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),z.waitUntilTaskIsFinished().finally(()=>this.ab.delete(g))),z}W(U,M){return new Z(U,M.profileLocation,this.cb)}async lb(U){const M=async g=>{let z=await h.Promises.readdir(g);z=z.map(H=>m.$8c(g,H));const T=await Promise.all(z.map(H=>h.Promises.stat(H)));let X=Promise.resolve([]);return T.forEach((H,ae)=>{const oe=z[ae];H.isFile()&&(X=X.then(pe=>[...pe,oe])),H.isDirectory()&&(X=X.then(pe=>M(oe).then(de=>[...pe,...de])))}),X};return(await M(U.location.fsPath)).map(g=>({path:`extension/${m.$0c(U.location.fsPath,g)}`,localPath:g}))}async mb({added:U,removed:M}){if(M)for(const a of M.extensions)this.y.info("Extensions removed from another source",a.id,M.profileLocation.toString()),this.p.fire({identifier:a,profileLocation:M.profileLocation});if(U){const g=(await this.Y.scanExtensions(1,U.profileLocation)).filter(z=>U.extensions.some(T=>(0,s.$ho)(T,z.identifier)));this.m.fire(g.map(z=>(this.y.info("Extensions added from another source",z.identifier.id,U.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:U.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(M=>this.nb.add(M)));const U=await this.eb.resolve(this.bb.userExtensionsLocation);for(const M of U.children??[])M.isDirectory&&this.nb.add(M.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(M=>this.pb(M)))}async pb(U){if(!U.affects(this.bb.userExtensionsLocation,1))return;const M=[];for(const a of U.rawAdded){if(this.nb.has(a)||!this.w.extUri.isEqual(this.w.extUri.dirname(a),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(a,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(a).startsWith(".")||!(await this.eb.stat(a)).isDirectory)continue;const g=await this.Y.scanUserExtensionAtLocation(a);g&&g.installedTimestamp===void 0&&(this.nb.add(a),M.push(g))}M.length&&(await this.qb(M.map(a=>[a,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",M.map(a=>a.identifier.id)))}async qb(U,M){const a=U.map(g=>g[0]);await this.rb(a),await this.cb.addExtensionsToProfile(U,M),this.m.fire(a.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:M})))}async rb(U){const M=await this.Y.getUninstalledExtensions();for(const a of U){const g=s.$io.create(a);M[g.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",g.id),await this.Y.setInstalled(g),this.y.info("Removed the extension from uninstalled list:",g.id))}}};e.$qp=G,e.$qp=G=$e([se(0,i.$Rn),se(1,ce.$Vk),se(2,le.$Ri),se(3,t.$xh),se(4,r.$fp),se(5,n.$bp),se(6,E.$vn),se(7,x.$oh),se(8,_.$Sj),se(9,te.$0i),se(10,ue.$pk),se(11,ie.$rk)],G);let F=class extends l.$lb{constructor(U,M,a,g,z,T){super(),this.j=U,this.k=M,this.l=a,this.m=g,this.n=z,this.p=T,this.h=this.B(new y.$ec),this.onExtract=this.h.event,this.c=(0,d.$9f)(this.l.userExtensionsLocation,".obsolete"),this.g=new L.$Bg}async cleanUp(){await this.C(),await this.z()}async scanExtensions(U,M){const a={includeInvalid:!0,profileLocation:M};let g=[];return U===null||U===0?g.push(...await this.l.scanAllExtensions({includeInvalid:!0},a,!1)):U===1&&g.push(...await this.l.scanUserExtensions(a)),g=U!==null?g.filter(z=>z.type===U):g,Promise.all(g.map(z=>this.y(z)))}async scanAllUserExtensions(U){const M=await this.l.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(M.map(a=>this.y(a)))}async scanUserExtensionAtLocation(U){try{const M=await this.l.scanExistingExtension(U,1,{includeInvalid:!0});if(M)return await this.y(M)}catch(M){this.p.error(M)}return null}async extractUserExtension(U,M,a,g,z){const T=U.toString(),X=$.URI.file(m.$8c(this.l.userExtensionsLocation.fsPath,`.${(0,f.$3e)()}`)),H=$.URI.file(m.$8c(this.l.userExtensionsLocation.fsPath,T));let ae=await this.k.exists(H);if(ae&&g){try{await this.t(U.id,H,"removeExisting")}catch{throw new i.$Sn(p.localize(4,null,H.fsPath,U.id),i.ExtensionManagementErrorCode.Delete)}ae=!1}if(!ae)try{try{this.p.trace(`Started extracting the extension from ${M} to ${H.fsPath}`),await(0,P.$7o)(M,X.fsPath,{sourcePath:"extension",overwrite:!0},z),this.p.info(`Extracted extension to ${H}:`,U.id)}catch(oe){let pe=i.ExtensionManagementErrorCode.Extract;throw oe instanceof P.$5o&&(oe.type==="CorruptZip"?pe=i.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(pe=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$Sn(oe.message,pe)}await this.l.updateMetadata(X,a);try{this.p.trace(`Started renaming the extension from ${X.fsPath} to ${H.fsPath}`),await this.v(X.fsPath,H.fsPath),this.p.info("Renamed to",H.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.p.info(`Rename failed because of ${(0,N.$9)(oe)}. Deleted from extracted location`,X),oe}this.h.fire(H)}catch(oe){try{await this.k.del(X,{recursive:!0})}catch{}throw oe}return this.w(H,1)}async scanMetadata(U,M){return M?(await this.s(U,M))?.metadata:this.l.scanMetadata(U.location)}async s(U,M){return(await this.m.scanProfileExtensions(M)).find(g=>(0,s.$ho)(g.identifier,U.identifier))}async updateMetadata(U,M,a){return a?await this.m.updateMetadata([[U,M]],a):await this.l.updateMetadata(U.location,M),this.w(U.location,U.type,a)}getUninstalledExtensions(){return this.u()}async setUninstalled(...U){const M=U.map(a=>s.$io.create(a));await this.u(a=>M.forEach(g=>{a[g.toString()]=!0,this.p.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(U){await this.u(M=>delete M[U.toString()])}async removeExtension(U,M){if(this.n.extUri.isEqualOrParent(U.location,this.l.userExtensionsLocation))return this.t(U.identifier.id,U.location,M)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.u(M=>delete M[s.$io.create(U).toString()])}async copyExtension(U,M,a,g){const z=await this.s(U,M),T=await this.s(U,a);return g={...z?.metadata,...g},T?await this.m.updateMetadata([[U,{...T.metadata,...g}]],a):await this.m.addExtensionsToProfile([[U,g]],a),this.w(U.location,U.type,a)}async copyExtensions(U,M){const a=await this.scanExtensions(1,U),g=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,U)]));await this.m.addExtensionsToProfile(g,M)}async t(U,M,a){this.p.trace(`Deleting ${a} extension from disk`,U,M.fsPath);const g=this.n.extUri.joinPath(this.n.extUri.dirname(M),`${this.n.extUri.basename(M)}.${(0,u.$di)((0,f.$3e)()).toString(16)}${V}`);await this.v(M.fsPath,g.fsPath),await this.k.del(g,{recursive:!0}),this.p.info(`Deleted ${a} extension from disk`,U,M.fsPath)}async u(U){return this.g.queue(async()=>{let M;try{M=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,_.$9j)(g)!==1)throw g}let a={};if(M)try{a=JSON.parse(M)}catch{}return U&&(U(a),Object.keys(a).length?await this.k.writeFile(this.c,j.$Ec.fromString(JSON.stringify(a))):await this.k.del(this.c)),a})}async v(U,M){try{await h.Promises.rename(U,M,2*60*1e3)}catch(a){throw new i.$Sn(a.message||p.localize(5,null,U,M),a.code||i.ExtensionManagementErrorCode.Rename)}}async w(U,M,a){if(a){const z=(await this.l.scanUserExtensions({profileLocation:a})).find(T=>this.n.extUri.isEqual(T.location,U));if(z)return this.y(z)}else{const g=await this.l.scanExistingExtension(U,M,{includeInvalid:!0});if(g)return this.y(g)}throw new Error(p.localize(6,null,U.path))}async y(U){const M=await this.k.resolve(U.location);let a,g;return M.children&&(a=M.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,g=M.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:a,changelogUrl:g,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async z(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(U));const M=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of M)U[s.$io.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,s.$no)(M,T=>T.identifier);await L.Promises.settled(z.map(async T=>{const X=T.sort((H,ae)=>b.rcompare(H.manifest.version,ae.manifest.version))[0];a.has(X.identifier.id.toLowerCase())||await this.j(await this.y(X))}))}catch(z){this.p.error(z)}const g=M.filter(z=>z.metadata&&U[s.$io.create(z).toString()]);await Promise.allSettled(g.map(z=>this.removeUninstalledExtension(z)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.k.resolve(this.l.userExtensionsLocation)}catch(M){(0,_.$9j)(M)!==1&&this.p.error(M);return}if(U?.children)try{await Promise.allSettled(U.children.map(async M=>{if(!(!M.isDirectory||!M.name.endsWith(V))){this.p.trace("Deleting the temporarily deleted folder",M.resource.toString());try{await this.k.del(M.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",M.resource.toString())}catch(a){(0,_.$9j)(a)!==1&&this.p.error(a)}}}))}catch{}}};e.$rp=F,e.$rp=F=$e([se(1,_.$Sj),se(2,r.$fp),se(3,n.$bp),se(4,ue.$pk),se(5,le.$Ri)],F);class C extends o.$_o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,k.$pe)(this.options.operation)?this.l:this.options.operation}constructor(U,M,a,g,z,T,X,H,ae){super(),this.identifier=U,this.source=M,this.options=a,this.m=g,this.n=z,this.o=T,this.p=X,this.q=H,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[M,a]=await this.x(U);return this.j=M.isBuiltin||M.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[M,a]],this.j),M}async u({zipPath:U,key:M,metadata:a},g,z){let T=await this.v(M);return T||(this.s.trace("Extracting extension...",M.id),T=await this.m.extractUserExtension(M,U,a,g,z),this.s.info("Extracting extension completed.",M.id)),T}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(g=>s.$io.create(g).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class B extends C{constructor(U,M,a,g,z,T,X,H,ae,oe){super(M.identifier,M,a,z,T,X,H,ae,oe),this.y=M,this.z=g}async x(U){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(X=>(0,s.$ho)(X.identifier,this.y.identifier));a&&(this.l=3);const g={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,k.$oe)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,g),g];const{location:z,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:s.$io.create(this.y),metadata:g},!1,U),g]}catch(X){try{await this.z.delete(z)}catch(H){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,N.$9)(H))}throw X}}async B(U){try{await(0,I.$mp)(U)}catch(M){throw new i.$Sn((0,o.$0o)(M).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$sp=B;class Y extends C{constructor(U,M,a,g,z,T,X,H,ae,oe){super({id:(0,s.$mo)(U.publisher,U.name)},M,a,z,T,X,H,ae,oe),this.y=U,this.z=M,this.A=g}async h(U){const M=await super.h(U);return this.D(M,U),M}async x(U){const M=new s.$io(this.identifier,this.y.version),g=(await this.m.scanExtensions(1,this.options.profileLocation)).find(X=>(0,s.$ho)(this.identifier,X.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this.l=3,M.equals(new s.$io(g.identifier,g.manifest.version)))try{await this.m.removeExtension(g,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&b.gt(g.manifest.version,this.y.version)&&await this.m.setUninstalled(g);else{const X=await this.v(M);if(X)try{await this.m.removeExtension(X,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$9c(this.z.fsPath),key:M,metadata:z},!0,U),z]}async D(U,M){try{let[a]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],M);if(a||([a]=await this.A.getExtensions([{id:U.identifier.id}],M)),a){const g={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,g,this.options.profileLocation)}}catch{}}}class Z extends o.$_o{constructor(U,M,a){super(),this.extension=U,this.j=M,this.k=a}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,45,136,178]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;let b=class extends O.$Bo{constructor(h,P,p,E){super(E),this.j=h,this.k=P,this.l=p,this.m(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const h=this.j.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,P){const{f:p,g:E}=this;let t;try{t=await(0,l.$zl)(this.j,this.l,this.k.args,process.env)}catch(s){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.$9)(s)))}const o={...process.env,...t},i=h.agent?h.agent:await(0,m.$Eq)(h.url||"",o,{proxyUrl:p,strictSSL:E});return h.agent=i,h.strictSSL=E,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>$(h,P))}async resolveProxy(h){}};e.$Fq=b,e.$Fq=b=$e([se(0,y.$Vh),se(1,u.$xh),se(2,w.$Ri),se(3,w.$Si)],b);async function k(f){return((0,L.parse)(f.url).protocol==="https:"?await new Promise((p,E)=>{J(["https"],p,E)}):await new Promise((p,E)=>{J(["http"],p,E)})).request}async function $(f,h){return j.Promises.withAsyncBody(async(P,p)=>{const E=(0,L.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await k(f),o={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,N.$oe)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(o.auth=f.user+":"+f.password);const i=t(o,s=>{const n=(0,N.$me)(f.followRedirects)?f.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)$({...f,url:s.headers.location,followRedirects:n-1},h).then(P,p);else{let r=s;!f.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,d.createGunzip)())),P({res:s,stream:(0,R.$Tc)(r)})}});i.on("error",p),f.timeout&&i.setTimeout(f.timeout),f.isChromiumNetwork&&i.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&i.write(f.data),i.end(),h.onCancellationRequested(()=>{i.abort(),p(new A.$3)})})}e.$Gq=$}),define(ne[179],re([0,1,32,8,33,9,2,15,16,13,34,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,31,45,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,j,R,A,N,y,u,l,w,O,m,d,b,k,$,f,h,P,p,E,t,o,i,s,n,r,c,S,I,v,D,W,_,x,le,te,ce,ue,ie,V,G,F,C,B,Y,Z,Q,U,M,a,g,z,T,X,H,ae,oe,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends N.$lb{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(x.$Ri),ze=be.get(r.$Sj),q=be.get(f.$xh),K=be.get(g.$rk);Se.info("CLI main",this.b),this.g(Se),await this.h(q,ze,K,he),await Promise.all(we.map(ee=>{(0,j.$mg)(ee.flush(),1e3)}))})}async f(){const he=new D.$nh,we={_serviceBrand:void 0,...ue.default};he.set(ie.$0i,we);const be=new h.$Yl(this.b,we);he.set(f.$xh,be),await Promise.all([be.appSettingsHome.fsPath,be.extensionsPath].map(je=>je?m.Promises.mkdir(je,{recursive:!0}):void 0));const Se=new ae.$YM((0,x.$6i)(be),be.logsHome);he.set(x.$Si,Se);const ze=this.B(Se.createLogger("cli",{name:(0,oe.localize)(0,null)})),q=[];Se.getLogLevel()===x.LogLevel.Trace&&q.push(new x.$Zi(Se.getLogLevel()));const K=this.B(new H.$9M(ze,q));he.set(x.$Ri,K);const ee=this.B(new c.$up(K));he.set(r.$Sj,ee);const ge=this.B(new S.$Tp(K));ee.registerProvider(y.Schemas.file,ge),ee.registerProvider(y.Schemas.vscodeUserData,new pe.$B6b(y.Schemas.file,ge,y.Schemas.vscodeUserData,K));const ye=new a.$gr(ee);he.set(M.$pk,ye);const De=new F.$3M(1,be,K,ee),ke=new z.$5M(De,ye,be,ee,K);he.set(g.$rk,ke);const Le=l.$i&&we.win32RegValueName?this.B(new ce.$z6b(K,we.win32RegValueName)):be.policyFile?this.B(new le.$A6b(be.policyFile,ee,K)):new te.$Ym;he.set(te.$Wm,Le);const Ie=this.B(new b.$mn(ke.defaultProfile.settingsResource,ee,Le,K));he.set(d.$Vh,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ae;try{Ae=await(0,T.$g6b)(De,K)}catch(je){je.code!=="ENOENT"&&K.error(je)}ke.init(),he.set(M.$pk,new a.$gr(ee));const Ue=new G.$Fq(Ie,be,K,Se);he.set(V.$Ao,Ue),he.set(k.$vn,new I.$mh($.$lN,void 0,!0)),he.set(o.$bp,new I.$mh(X.$8M,void 0,!0)),he.set(i.$fp,new I.$mh(n.$d6b,void 0,!0)),he.set(E.$Xo,new I.$mh(E.$Yo,void 0,!0)),he.set(s.$pp,new I.$mh(s.$qp,void 0,!0)),he.set(p.$Rn,new I.$mh(P.$Wo,void 0,!0)),he.set(W.$zq,new I.$mh(_.$Bq,void 0,!1));const Oe=[],Ne=(0,Z.$eo)(we,Ie);if((0,Z.$_n)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new Q.$WM(Ue,Ne,"monacoworkbench",null,we.aiConfig.ariaKey));const je={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,C.$2n)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,Ne),piiPaths:(0,Z.$fo)(be)};he.set(B.$Vk,new I.$mh(Y.$Hq,[je],!1))}else he.set(B.$Vk,Z.$6n);return[new v.$Wp(he),Oe]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$ai)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$X)(we)||(0,A.$Y)(we)}),process.on("unhandledRejection",we=>(0,A.$Y)(we))}async h(he,we,be,Se){let ze;if(he.args.profile&&(ze=be.profiles.find(K=>K.name===he.args.profile),!ze))throw new Error(`Profile '${he.args.profile}' not found.`);const q=(ze??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(t.$Zo,new x.$Zi(x.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,q);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const K={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:q};return Se.createInstance(t.$Zo,new x.$Zi(x.LogLevel.Info,!1)).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),K,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(t.$Zo,new x.$Zi(x.LogLevel.Info,!1)).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,q);if(this.b["locate-extension"])return Se.createInstance(t.$Zo,new x.$Zi(x.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$X6b)(he.appRoot,he.extensionsPath))}}i(he){return he.map(we=>/\.vsix$/i.test(we)?O.URI.file((0,u.$7c)(we)?we:(0,u.$8c)((0,w.cwd)(),we)):we)}}async function me(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=me})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/35be9bf683eace09796e59d54f1f225bbc3a7866/core/vs/code/node/cliProcessMain.js.map
