/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],W=function(D){for(var e=[],T=0,S=D.length;T<S;T++)e[T]=q[D[T]];return e};define(q[21],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class T{static get(){const v=new Map,O=new Map,r=new Map,u=new Map;function t(l,n){l.has(n.detail)||l.set(n.detail,-n.timestamp)}function a(l,n){const i=l.get(n.detail);i&&(i>=0||l.set(n.detail,i+n.timestamp))}let c=[];typeof D=="function"&&typeof D.getStats=="function"&&(c=D.getStats().slice(0).sort((l,n)=>l.timestamp-n.timestamp));for(const l of c)switch(l.type){case 10:t(v,l);break;case 11:case 12:a(v,l);break;case 21:t(O,l);break;case 22:a(O,l);break;case 33:t(r,l);break;case 34:a(r,l);break;case 31:t(u,l);break;case 32:a(u,l);break}let o=0;r.forEach(l=>o+=l);function f(l){const n=[];return l.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:f(v),amdInvoke:f(O),nodeRequire:f(r),nodeEval:f(u),nodeRequireTotal:o}}static toMarkdownTable(v,O){let r="";const u=[];return v.forEach((t,a)=>{u[a]=t.length}),O.forEach(t=>{t.forEach((a,c)=>{typeof a>"u"&&(a=t[c]="-");const o=a.toString().length;u[c]=Math.max(o,u[c])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(u[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(u[a])} `}),r+=`|
`,O.forEach(t=>{t.forEach((a,c)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(u[c]-a.toString().length)} `)}),r+=`|
`}),r}}e.$S=T}),define(q[4],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vb=e.$Ub=e.$Tb=void 0;let T;function S(i){T=i}e.$Tb=S;function v(){return T}e.$Ub=v;class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([u(l("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[u(" "),a(c(s.oldValue,70),{color:"red",strikeThrough:!0}),u(" "),a(c(s.newValue,60),{color:"green"})]:[u(" (unchanged)")]:[u(" "),a(c(s.newValue,60),{color:"green"}),u(" (initial)")]}handleObservableChanged(s,$){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const $=s.handleChange;this.d.set(s,new Set),s.handleChange=(k,L)=>(this.d.get(s).add(k),$.apply(s,[k,L]))}handleDerivedRecomputed(s,$){const k=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(k),{data:[{fn:s._computeFn}]}])),k.clear()}handleFromEventObservableTriggered(s,$){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const $=s.handleChange;this.d.set(s,new Set),s.handleChange=(k,L)=>(this.d.get(s).add(k),$.apply(s,[k,L]))}handleAutorunTriggered(s){const $=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:s._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let $=s.getDebugName();$===void 0&&($=""),console.log(...this.b([t("transaction"),a($,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Vb=O;function r(i){const s=new Array,$=[];let k="";function L(E){if("length"in E)for(const d of E)d&&L(d);else"text"in E?(k+=`%c${E.text}`,s.push(E.style),E.data&&$.push(...E.data)):"data"in E&&$.push(...E.data)}L(i);const R=[k,...s];return R.push(...$),R}function u(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function $(L){return Object.entries(L).reduce((R,[E,d])=>`${R}${E}:${d};`,"")}const k={color:s.color};return s.strikeThrough&&(k["text-decoration"]="line-through"),s.bold&&(k["font-weight"]="bold"),{text:i,style:$(k)}}function c(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?o(i,s):f(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function o(i,s){let $="[ ",k=!0;for(const L of i){if(k||($+=", "),$.length-5>s){$+="...";break}k=!1,$+=`${c(L,s-$.length)}`}return $+=" ]",$}function f(i,s){let $="{ ",k=!0;for(const[L,R]of Object.entries(i)){if(k||($+=", "),$.length-5>s){$+="...";break}k=!1,$+=`${L}: ${c(R,s-$.length)}`}return $+=" }",$}function l(i,s){let $="";for(let k=1;k<=s;k++)$+=i;return $}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(q[5],W([0,1,4]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=void 0;let S;function v(i){S=i}e.$2b=v;class O{get TChange(){return null}reportChanges(){this.get()}read(s){return s?s.readObservable(this):this.get()}map(s){return S($=>s(this.read($),$),()=>{const $=c(s);if($!==void 0)return $;const L=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(s.toString());return L?`${this.debugName}.${L[2]}`:`${this.debugName} (mapped)`})}}e.$3b=O;class r extends O{constructor(){super(...arguments),this.c=new Set}addObserver(s){const $=this.c.size;this.c.add(s),$===0&&this.f()}removeObserver(s){this.c.delete(s)&&this.c.size===0&&this.g()}f(){}g(){}}e.$4b=r;function u(i,s){const $=new a(i,s);try{i($)}finally{$.finish()}}e.$5b=u;function t(i,s,$){i?s(i):u(s,$)}e.$6b=t;class a{constructor(s,$){this._fn=s,this.b=$,this.a=[],(0,T.$Ub)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():c(this._fn)}updateObserver(s,$){this.a.push({observer:s,observable:$}),s.beginUpdate($)}finish(){const s=this.a;this.a=null;for(const{observer:$,observable:k}of s)$.endUpdate(k);(0,T.$Ub)()?.handleEndTransaction()}}e.$7b=a;function c(i){const s=i.toString(),k=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(s);return(k?k[1]:void 0)?.trim()}e.$8b=c;function o(i,s){return new f(i,s)}e.$9b=o;class f extends r{constructor(s,$){super(),this.debugName=s,this.a=$}get(){return this.a}set(s,$,k){if(this.a===s)return;let L;$||($=L=new a(()=>{},()=>`Setting ${this.debugName}`));try{const R=this.a;this.b(s),(0,T.$Ub)()?.handleObservableChanged(this,{oldValue:R,newValue:s,change:k,didChange:!0,hadValue:!0});for(const E of this.c)$.updateObserver(E,this),E.handleChange(this,k)}finally{L&&L.finish()}}toString(){return`${this.debugName}: ${this.a}`}b(s){this.a=s}}e.$0b=f;function l(i,s){return new n(i,s)}e.$$b=l;class n extends f{b(s){this.a!==s&&(this.a&&this.a.dispose(),this.a=s)}dispose(){this.a?.dispose()}}e.$_b=n}),define(q[9],W([0,1,42,2,5,4]),function(D,e,T,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=void 0;function r(n,i){return new f(n.debugName,i,void 0,void 0)}e.$Ab=r;function u(n){return new f(void 0,n,void 0,void 0)}e.$Bb=u;function t(n,i){return new f(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$Cb=t;function a(n,i){const s=new S.$kb,$=t({debugName:n.debugName??(()=>(0,v.$8b)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(k,L)=>{s.clear(),i(k,L,s)});return(0,S.$jb)(()=>{$.dispose(),s.dispose()})}e.$Db=a;function c(n){const i=new S.$kb,s=r({debugName:()=>(0,v.$8b)(n)||"(anonymous)"},$=>{i.clear(),n($,i)});return(0,S.$jb)(()=>{s.dispose(),i.dispose()})}e.$Eb=c;var o;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(o||(o={}));class f{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$8b)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,$,k){this.h=i,this._runFn=s,this.i=$,this.j=k,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$Ub)()?.handleAutorunCreated(this),this.k()}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear()}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,O.$Ub)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,O.$Ub)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,T.$yb)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:k=>k===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$Fb=f,function(n){n.Observer=f}(u||(e.$Bb=u={}));function l(n,i){let s;return r({debugName:()=>(0,v.$8b)(i)},$=>{const k=n.read($),L=s;s=k,i({lastValue:L,newValue:k})})}e.$Gb=l}),define(q[10],W([0,1,6,2,5,4]),function(D,e,T,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=void 0;const r=(l,n)=>l===n;function u(l,n){return new f(n,l,void 0,void 0,void 0,r)}e.$Wb=u;function t(l,n){return new f(l.debugName,n,void 0,void 0,void 0,l.equalityComparer??r)}e.$Xb=t;function a(l,n,i){return new f(l,i,n.createEmptyChangeSummary,n.handleChange,void 0,r)}e.$Yb=a;function c(l,n){const i=new S.$kb;return new f(l,s=>(i.clear(),n(s,i)),void 0,void 0,()=>i.dispose(),r)}e.$Zb=c,(0,v.$2b)(u);var o;(function(l){l[l.initial=0]="initial",l[l.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",l[l.stale=2]="stale",l[l.upToDate=3]="upToDate"})(o||(o={}));class f extends v.$4b{get debugName(){return this.m?typeof this.m=="function"?this.m():this.m:(0,v.$8b)(this._computeFn)||"(anonymous)"}constructor(n,i,s,$,k=void 0,L){super(),this.m=n,this._computeFn=i,this.n=s,this.p=$,this.q=k,this.s=L,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,O.$Ub)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.n?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.h}}u(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const $=this.l;this.l=this.n?.();try{this.h=this._computeFn(this,$)}finally{for(const L of this.k)L.removeObserver(this);this.k.clear()}const k=i&&!this.s(s,this.h);if((0,O.$Ub)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:k,hadValue:i}),k)for(const L of this.c)L.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new T.$bb}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.p?this.p({changedObservable:n,change:i,didChange:k=>k===n},this.l):!0,$=this.e===3;if(s&&(this.e===1||$)&&(this.e=2,$))for(const k of this.c)k.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$1b=f}),define(q[22],W([0,1,2,9,5,10,4]),function(D,e,T,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=void 0;function u(m){return new t(m)}e.$Hb=u;class t extends v.$3b{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function a(m){const w=(0,v.$9b)("promiseValue",{});return m.then(P=>{w.set({value:P},void 0)}),w}e.$Ib=a;function c(m,w){return new Promise(P=>{let F=!1,g=!1;const A=(0,S.$Bb)(U=>{const z=m.read(U);w(z)&&(F?A.dispose():g=!0,P(z))});F=!0,g&&A.dispose()})}e.$Jb=c;function o(m,w){return new f(m,w)}e.$Kb=o;class f extends v.$4b{constructor(w,P){super(),this.h=w,this._getValue=P,this.b=!1,this.k=F=>{const g=this._getValue(F),A=!this.b||this.a!==g;(0,r.$Ub)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:g,change:void 0,didChange:A,hadValue:this.b}),A&&(this.a=g,this.b&&(0,v.$5b)(U=>{for(const z of this.c)U.updateObserver(z,this),z.handleChange(this,void 0)},()=>{const U=this.i();return"Event fired"+(U?`: ${U}`:"")}),this.b=!0)}}i(){return(0,v.$8b)(this._getValue)}get debugName(){const w=this.i();return"From Event"+(w?`: ${w}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$Lb=f,function(m){m.Observer=f}(o||(e.$Kb=o={}));function l(m,w){return new n(m,w)}e.$Mb=l;class n extends v.$4b{constructor(w,P){super(),this.debugName=w,this.b=P,this.h=()=>{(0,v.$5b)(F=>{for(const g of this.c)F.updateObserver(g,this),g.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return new s(m)}e.$Nb=i;class s extends v.$4b{constructor(w){super(),this.debugName=w}trigger(w,P){if(!w){(0,v.$5b)(F=>{this.trigger(F,P)},()=>`Trigger signal ${this.debugName}`);return}for(const F of this.c)w.updateObserver(F,this),F.handleChange(this,P)}get(){}}function $(m,w,P){const F=(0,v.$9b)("debounced",void 0);let g;return P.add((0,S.$Bb)(A=>{const U=m.read(A);g&&clearTimeout(g),g=setTimeout(()=>{(0,v.$5b)(z=>{F.set(U,z)})},w)})),F}e.$Ob=$;function k(m,w,P){const F=(0,v.$9b)("triggeredRecently",!1);let g;return P.add(m(()=>{F.set(!0,void 0),g&&clearTimeout(g),g=setTimeout(()=>{F.set(!1,void 0)},w)})),F}e.$Pb=k;function L(m,w){const P=new R(w??!1);return m.addObserver(P),w&&m.reportChanges(),(0,T.$jb)(()=>{m.removeObserver(P)})}e.$Qb=L;class R{constructor(w){this.b=w,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&w.reportChanges()}handlePossibleChange(w){}handleChange(w,P){}}function E(m,w){let P;return(0,O.$Wb)(g=>(P=w(g,P),P),m)}e.$Rb=E;function d(m,w){let P;const F=(0,v.$9b)("derivedObservableWithWritableCache.counter",0),g=(0,O.$Wb)(A=>(F.read(A),P=w(A,P),P),m);return Object.assign(g,{clearCache:A=>{P=void 0,F.set(F.get()+1,A)}})}e.$Sb=d}),define(q[11],W([0,1,5,10,9,22,4]),function(D,e,T,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.keepAlive=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return T.$9b}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return T.$$b}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return T.$5b}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return T.$6b}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$Wb}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$Xb}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$Yb}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$Zb}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$Bb}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$Gb}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$Cb}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$Eb}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$Ab}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$Db}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$Hb}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$Ob}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$Rb}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$Sb}}),Object.defineProperty(e,"keepAlive",{enumerable:!0,get:function(){return O.$Qb}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$Kb}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$Ib}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$Nb}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$Mb}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return O.$Jb}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$Pb}}),!1&&(0,r.$Tb)(new r.$Vb)}),define(q[23],W([0,1,6,2]),function(D,e,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function v(R){const E=R;return E?typeof E.read=="function":!1}e.$pc=v;function O(R){const E=R;return E?[E.on,E.pause,E.resume,E.destroy].every(d=>typeof d=="function"):!1}e.$qc=O;function r(R){const E=R;return E?O(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$rc=r;function u(R,E){return new t(R,E)}e.$sc=u;class t{constructor(E,d){this.e=E,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(d=>d(E))}h(E){this.c.error.length===0?(0,T.$Y)(E):this.c.error.slice(0).forEach(d=>d(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,d){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(E,d){if(this.a.destroyed)return;let m;switch(E){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const w=m.indexOf(d);w>=0&&m.splice(w,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(R,E){const d=[];let m;for(;(m=R.read())!==null;)d.push(m);return E(d)}e.$tc=a;function c(R,E,d){const m=[];let w;for(;(w=R.read())!==null&&m.length<d;)m.push(w);return w===null&&m.length>0?E(m):{read:()=>{if(m.length>0)return m.shift();if(typeof w<"u"){const P=w;return w=void 0,P}return R.read()}}}e.$uc=c;function o(R,E){return new Promise((d,m)=>{const w=[];f(R,{onData:P=>{E&&w.push(P)},onError:P=>{E?m(P):d(void 0)},onEnd:()=>{d(E?E(w):void 0)}})})}e.$vc=o;function f(R,E,d){R.on("error",m=>{d?.isCancellationRequested||E.onError(m)}),R.on("end",()=>{d?.isCancellationRequested||E.onEnd()}),R.on("data",m=>{d?.isCancellationRequested||E.onData(m)})}e.$wc=f;function l(R,E){return new Promise((d,m)=>{const w=new S.$kb,P=[],F=U=>{if(P.push(U),P.length>E)return w.dispose(),R.pause(),d({stream:R,buffer:P,ended:!1})},g=U=>m(U),A=()=>d({stream:R,buffer:P,ended:!0});w.add((0,S.$jb)(()=>R.removeListener("error",g))),R.on("error",g),w.add((0,S.$jb)(()=>R.removeListener("end",A))),R.on("end",A),w.add((0,S.$jb)(()=>R.removeListener("data",F))),R.on("data",F)})}e.$xc=l;function n(R,E){const d=u(E);return d.end(R),d}e.$yc=n;function i(){const R=u(()=>{throw new Error("not supported")});return R.end(),R}e.$zc=i;function s(R){let E=!1;return{read:()=>E?null:(E=!0,R)}}e.$Ac=s;function $(R,E,d){const m=u(d);return f(R,{onData:w=>m.write(E.data(w)),onError:w=>m.error(E.error?E.error(w):w),onEnd:()=>m.end()}),m}e.$Bc=$;function k(R,E,d){let m=!1;return{read:()=>{const w=E.read();return m?w:(m=!0,w!==null?d([R,w]):R)}}}e.$Cc=k;function L(R,E,d){let m=!1;const w=u(d);return f(E,{onData:P=>m?w.write(P):(m=!0,w.write(d([R,P]))),onError:P=>w.error(P),onEnd:()=>{m||(m=!0,w.write(R)),w.end()}}),w}e.$Dc=L}),define(q[12],W([0,1,43,23]),function(D,e,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const v=typeof Buffer<"u",O=new T.$T(()=>new Uint8Array(256));let r,u;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,j){return!(j?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const j=t.alloc(b.length);for(let V=0,Y=b.length;V<Y;V++)j.buffer[V]=b[V];return j}static concat(b,j){if(typeof j>"u"){j=0;for(let G=0,H=b.length;G<H;G++)j+=b[G].byteLength}const V=t.alloc(j);let Y=0;for(let G=0,H=b.length;G<H;G++){const K=b[G];V.set(K,Y),Y+=K.byteLength}return V}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice(b,j){return new t(this.buffer.subarray(b,j))}set(b,j){if(b instanceof t)this.buffer.set(b.buffer,j);else if(b instanceof Uint8Array)this.buffer.set(b,j);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),j);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return f(this.buffer,b)}writeUInt32BE(b,j){l(this.buffer,b,j)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,j){i(this.buffer,b,j)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,j){$(this.buffer,b,j)}indexOf(b,j=0){return a(this.buffer,b instanceof t?b.buffer:b,j)}}e.$Ec=t;function a(I,b,j=0){const V=b.byteLength,Y=I.byteLength;if(V===0)return 0;if(V===1)return I.indexOf(b[0]);if(V>Y-j)return-1;const G=O.value;G.fill(b.length);for(let X=0;X<b.length;X++)G[b[X]]=b.length-X-1;let H=j+b.length-1,K=H,p=-1;for(;H<Y;)if(I[H]===b[K]){if(K===0){p=H;break}H--,K--}else H+=Math.max(b.length-K,G[I[H]]),K=b.length-1;return p}e.$Fc=a;function c(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$Gc=c;function o(I,b,j){I[j+0]=b&255,b=b>>>8,I[j+1]=b&255}e.$Hc=o;function f(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$Ic=f;function l(I,b,j){I[j+3]=b,b=b>>>8,I[j+2]=b,b=b>>>8,I[j+1]=b,b=b>>>8,I[j]=b}e.$Jc=l;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$Kc=n;function i(I,b,j){I[j+0]=b&255,b=b>>>8,I[j+1]=b&255,b=b>>>8,I[j+2]=b&255,b=b>>>8,I[j+3]=b&255}e.$Lc=i;function s(I,b){return I[b]}e.$Mc=s;function $(I,b,j){I[j]=b}e.$Nc=$;function k(I){return S.$tc(I,b=>t.concat(b))}e.$Oc=k;function L(I){return S.$Ac(I)}e.$Pc=L;function R(I){return S.$vc(I,b=>t.concat(b))}e.$Qc=R;async function E(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await R(I.stream)])}e.$Rc=E;function d(I){return S.$yc(I,b=>t.concat(b))}e.$Sc=d;function m(I){return S.$Bc(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$Tc=m;function w(I){return S.$sc(b=>t.concat(b),I)}e.$Uc=w;function P(I,b){return S.$Cc(I,b,j=>t.concat(j))}e.$Vc=P;function F(I,b){return S.$Dc(I,b,j=>t.concat(j))}e.$Wc=F;function g(I){let b=0,j=0,V=0;const Y=new Uint8Array(Math.floor(I.length/4*3)),G=K=>{switch(j){case 3:Y[V++]=b|K,j=0;break;case 2:Y[V++]=b|K>>>2,b=K<<6,j=3;break;case 1:Y[V++]=b|K>>>4,b=K<<4,j=2;break;default:b=K<<2,j=1}};for(let K=0;K<I.length;K++){const p=I.charCodeAt(K);if(p>=65&&p<=90)G(p-65);else if(p>=97&&p<=122)G(p-97+26);else if(p>=48&&p<=57)G(p-48+52);else if(p===43||p===45)G(62);else if(p===47||p===95)G(63);else{if(p===61)break;throw new SyntaxError(`Unexpected base64 character ${I[K]}`)}}const H=V;for(;j>0;)G(0);return t.wrap(Y).slice(0,H)}e.$Xc=g;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:I},b=!0,j=!1){const V=j?U:A;let Y="";const G=I.byteLength%3;let H=0;for(;H<I.byteLength-G;H+=3){const K=I[H+0],p=I[H+1],X=I[H+2];Y+=V[K>>>2],Y+=V[(K<<4|p>>>4)&63],Y+=V[(p<<2|X>>>6)&63],Y+=V[X&63]}if(G===1){const K=I[H+0];Y+=V[K>>>2],Y+=V[K<<4&63],b&&(Y+="==")}else if(G===2){const K=I[H+0],p=I[H+1];Y+=V[K>>>2],Y+=V[(K<<4|p>>>4)&63],Y+=V[p<<2&63],b&&(Y+="=")}return Y}e.$Yc=z}),define(q[24],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(q[13],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.StringEOL=void 0;var T;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(T||(e.StringEOL=T={}));function S(v){let O=0,r=0,u=0,t=0;for(let a=0,c=v.length;a<c;a++){const o=v.charCodeAt(a);o===13?(O===0&&(r=a),O++,a+1<c&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,u=a+1):o===10&&(t|=1,O===0&&(r=a),O++,u=a+1)}return O===0&&(r=v.length),[O,r,v.length-u,t]}e.$ls=S}),define(q[14],W([0,1]),function(D,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(T||(e.LanguageId=T={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class u{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let o="mtk"+this.getForeground(a);const f=this.getFontStyle(a);return f&1&&(o+=" mtki"),f&2&&(o+=" mtkb"),f&4&&(o+=" mtku"),f&8&&(o+=" mtks"),o}static getInlineStyleFromMetadata(a,c){const o=this.getForeground(a),f=this.getFontStyle(a);let l=`color: ${c[o]};`;f&1&&(l+="font-style: italic;"),f&2&&(l+="font-weight: bold;");let n="";return f&4&&(n+=" underline"),f&8&&(n+=" line-through"),n&&(l+=`text-decoration:${n};`),l}static getPresentationFromMetadata(a){const c=this.getForeground(a),o=this.getFontStyle(a);return{foreground:c,italic:!!(o&1),bold:!!(o&2),underline:!!(o&4),strikethrough:!!(o&8)}}}e.$js=u}),define(q[25],W([0,1,26]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=void 0;class S{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,u){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=u}replace(r,u,t){if(r>=this.a.length)return;if(u===0){this.insert(r,t);return}else if(t===0){this.delete(r,u);return}const a=this.a.slice(0,r),c=this.a.slice(r+u),o=v(t,this.b);this.a=a.concat(o,c)}delete(r,u){u===0||r>=this.a.length||this.a.splice(r,u)}insert(r,u){if(u===0||r>=this.a.length)return;const t=[];for(let a=0;a<u;a++)t[a]=this.b;this.a=(0,T.$Af)(this.a,r,t)}}e.$mC=S;function v(O,r){const u=[];for(let t=0;t<O;t++)u[t]=r;return u}}),define(q[7],W([0,1,14]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0;class S{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,u){const t=S.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new S(a,r,u)}constructor(r,u,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=u,this.d=t}equals(r){return r instanceof S?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,u,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=u<<1,c=a+(t<<1);for(let o=a;o<c;o++)if(this.a[o]!==r.a[o])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const u=this.a[(r<<1)+1],t=T.$js.getLanguageId(u);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const u=this.a[(r<<1)+1];return T.$js.getTokenType(u)}getForeground(r){const u=this.a[(r<<1)+1];return T.$js.getForeground(u)}getClassName(r){const u=this.a[(r<<1)+1];return T.$js.getClassNameFromMetadata(u)}getInlineStyle(r,u){const t=this.a[(r<<1)+1];return T.$js.getInlineStyleFromMetadata(t,u)}getPresentation(r){const u=this.a[(r<<1)+1];return T.$js.getPresentationFromMetadata(u)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,u,t){return new v(this,r,u,t)}static convertToEndOffset(r,u){const a=(r.length>>>1)-1;for(let c=0;c<a;c++)r[c<<1]=r[c+1<<1];r[a<<1]=u}static findIndexInTokensArray(r,u){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const c=t+Math.floor((a-t)/2),o=r[c<<1];if(o===u)return c+1;o<u?t=c+1:o>u&&(a=c)}return t}withInserted(r){if(r.length===0)return this;let u=0,t=0,a="";const c=new Array;let o=0;for(;;){const f=u<this.b?this.a[u<<1]:-1,l=t<r.length?r[t]:null;if(f!==-1&&(l===null||f<=l.offset)){a+=this.c.substring(o,f);const n=this.a[(u<<1)+1];c.push(a.length,n),u++,o=f}else if(l){if(l.offset>o){a+=this.c.substring(o,l.offset);const n=this.a[(u<<1)+1];c.push(a.length,n),o=l.offset}a+=l.text,c.push(a.length,l.tokenMetadata),t++}else break}return new S(new Uint32Array(c),a,this.d)}}e.$ms=S;class v{constructor(r,u,t,a){this.a=r,this.b=u,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(u),this.f=0;for(let c=this.e,o=r.getCount();c<o&&!(r.getStartOffset(c)>=t);c++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const u=this.a.getEndOffset(this.e+r);return Math.min(this.c,u)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,u){return this.a.getInlineStyle(this.e+r,u)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[27],W([0,1,7]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=void 0,e.$ns=new Uint32Array(0).buffer;class S{static deleteBeginning(r,u){return r===null||r===e.$ns?r:S.delete(r,0,u)}static deleteEnding(r,u){if(r===null||r===e.$ns)return r;const t=v(r),a=t[t.length-2];return S.delete(r,u,a)}static delete(r,u,t){if(r===null||r===e.$ns||u===t)return r;const a=v(r),c=a.length>>>1;if(u===0&&a[a.length-2]===t)return e.$ns;const o=T.$ms.findIndexInTokensArray(a,u),f=o>0?a[o-1<<1]:0,l=a[o<<1];if(t<l){const k=t-u;for(let L=o;L<c;L++)a[L<<1]-=k;return r}let n,i;f!==u?(a[o<<1]=u,n=o+1<<1,i=u):(n=o<<1,i=f);const s=t-u;for(let k=o+1;k<c;k++){const L=a[k<<1]-s;L>i&&(a[n++]=L,a[n++]=a[(k<<1)+1],i=L)}if(n===a.length)return r;const $=new Uint32Array(n);return $.set(a.subarray(0,n),0),$.buffer}static append(r,u){if(u===e.$ns)return r;if(r===e.$ns)return u;if(r===null)return r;if(u===null)return null;const t=v(r),a=v(u),c=a.length>>>1,o=new Uint32Array(t.length+a.length);o.set(t,0);let f=t.length;const l=t[t.length-2];for(let n=0;n<c;n++)o[f++]=a[n<<1]+l,o[f++]=a[(n<<1)+1];return o.buffer}static insert(r,u,t){if(r===null||r===e.$ns)return r;const a=v(r),c=a.length>>>1;let o=T.$ms.findIndexInTokensArray(a,u);o>0&&a[o-1<<1]===u&&o--;for(let f=o;f<c;f++)a[f<<1]+=t;return r}}e.$os=S;function v(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$ps=v}),define(q[28],W([0,1,26,12,44,13,27,15]),function(D,e,T,S,v,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;class t{static deserialize(c,o,f){const l=new Uint32Array(c.buffer),n=(0,S.$Ic)(c,o);o+=4;const i=(0,S.$Ic)(c,o);o+=4;const s=[];for(let $=0;$<i;$++){const k=(0,S.$Ic)(c,o);o+=4,s.push(l.subarray(o/4,o/4+k/4)),o+=k}return f.push(new t(n,s)),o}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(c,o){this.a=c,this.b=o}getLineRange(){return new u.$Vr(this.a,this.a+this.b.length)}getLineTokens(c){return this.b[c-this.a]}appendLineTokens(c){this.b.push(c)}serializeSize(){let c=0;c+=4,c+=4;for(let o=0;o<this.b.length;o++){const f=this.b[o];if(!(f instanceof Uint32Array))throw new Error("Not supported!");c+=4,c+=f.byteLength}return c}serialize(c,o){(0,S.$Jc)(c,this.a,o),o+=4,(0,S.$Jc)(c,this.b.length,o),o+=4;for(let f=0;f<this.b.length;f++){const l=this.b[f];if(!(l instanceof Uint32Array))throw new Error("Not supported!");(0,S.$Jc)(c,l.byteLength,o),o+=4,c.set(new Uint8Array(l.buffer),o),o+=l.byteLength}return o}applyEdit(c,o){const[f,l]=(0,O.$ls)(o);this.c(c),this.d(new v.$Tr(c.startLineNumber,c.startColumn),f,l)}c(c){if(c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn)return;const o=c.startLineNumber-this.a,f=c.endLineNumber-this.a;if(f<0){const l=f-o;this.a-=l;return}if(!(o>=this.b.length)){if(o<0&&f>=this.b.length){this.a=0,this.b=[];return}if(o===f){this.b[o]=r.$os.delete(this.b[o],c.startColumn-1,c.endColumn-1);return}if(o>=0)if(this.b[o]=r.$os.deleteEnding(this.b[o],c.startColumn-1),f<this.b.length){const l=r.$os.deleteBeginning(this.b[f],c.endColumn-1);this.b[o]=r.$os.append(this.b[o],l),this.b.splice(o+1,f-o)}else this.b[o]=r.$os.append(this.b[o],null),this.b=this.b.slice(0,o+1);else{const l=-o;this.a-=l,this.b[f]=r.$os.deleteBeginning(this.b[f],c.endColumn-1),this.b=this.b.slice(f)}}}d(c,o,f){if(o===0&&f===0)return;const l=c.lineNumber-this.a;if(l<0){this.a+=o;return}if(!(l>=this.b.length)){if(o===0){this.b[l]=r.$os.insert(this.b[l],c.column-1,f);return}this.b[l]=r.$os.deleteEnding(this.b[l],c.column-1),this.b[l]=r.$os.insert(this.b[l],c.column-1,f),this.e(c.lineNumber,o)}}e(c,o){if(o===0)return;const f=[];for(let l=0;l<o;l++)f[l]=null;this.b=T.$Af(this.b,c,f)}}e.$qs=t}),define(q[16],W([0,1,12,28]),function(D,e,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nC=void 0;class v{static deserialize(r){let u=0;const t=(0,T.$Ic)(r,u);u+=4;const a=[];for(let c=0;c<t;c++)u=S.$qs.deserialize(r,u,a);return a}constructor(){this.a=[]}add(r,u){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(u);return}}this.a.push(new S.$qs(r,[u]))}finalize(){return this.a}serialize(){const r=this.b(),u=new Uint8Array(r);return this.c(u),u}b(){let r=0;r+=4;for(let u=0;u<this.a.length;u++)r+=this.a[u].serializeSize();return r}c(r){let u=0;(0,T.$Jc)(r,this.a.length,u),u+=4;for(let t=0;t<this.a.length;t++)u=this.a[t].serialize(r,u)}}e.$nC=v}),define(q[29],W([0,1,30,3,31,45]),function(D,e,T,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function r(g){return g===47||g===92}e.$Ae=r;function u(g){return g.replace(/[\\/]/g,T.$5c.sep)}e.$Be=u;function t(g){return g.indexOf("/")===-1&&(g=u(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Ce=t;function a(g,A=T.$5c.sep){if(!g)return"";const U=g.length,z=g.charCodeAt(0);if(r(z)){if(r(g.charCodeAt(1))&&!r(g.charCodeAt(2))){let b=3;const j=b;for(;b<U&&!r(g.charCodeAt(b));b++);if(j!==b&&!r(g.charCodeAt(b+1))){for(b+=1;b<U;b++)if(r(g.charCodeAt(b)))return g.slice(0,b+1).replace(/[\\/]/g,A)}}return A}else if($(z)&&g.charCodeAt(1)===58)return r(g.charCodeAt(2))?g.slice(0,2)+A:g.slice(0,2);let I=g.indexOf("://");if(I!==-1){for(I+=3;I<U;I++)if(r(g.charCodeAt(I)))return g.slice(0,I+1)}return""}e.$De=a;function c(g){if(!S.$i||!g||g.length<5)return!1;let A=g.charCodeAt(0);if(A!==92||(A=g.charCodeAt(1),A!==92))return!1;let U=2;const z=U;for(;U<g.length&&(A=g.charCodeAt(U),A!==92);U++);return!(z===U||(A=g.charCodeAt(U+1),isNaN(A)||A===92))}e.$Ee=c;const o=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(g,A=S.$i){const U=A?o:f;return!(!g||g.length===0||/^\s+$/.test(g)||(U.lastIndex=0,U.test(g))||A&&l.test(g)||g==="."||g===".."||A&&g[g.length-1]==="."||A&&g.length!==g.trim().length||g.length>255)}e.$Fe=n;function i(g,A,U){const z=g===A;return!U||z?z:!g||!A?!1:(0,v.$Ld)(g,A)}e.$Ge=i;function s(g,A,U,z=T.sep){if(g===A)return!0;if(!g||!A||A.length>g.length)return!1;if(U){if(!(0,v.$Md)(g,A))return!1;if(A.length===g.length)return!0;let b=A.length;return A.charAt(A.length-1)===z&&b--,g.charAt(b)===z}return A.charAt(A.length-1)!==z&&(A+=z),g.indexOf(A)===0}e.$He=s;function $(g){return g>=65&&g<=90||g>=97&&g<=122}e.$Ie=$;function k(g,A){return S.$i&&g.endsWith(":")&&(g+=T.sep),(0,T.$7c)(g)||(g=(0,T.$8c)(A,g)),g=(0,T.$6c)(g),S.$i?(g=(0,v.$ud)(g,T.sep),g.endsWith(":")&&(g+=T.sep)):(g=(0,v.$ud)(g,T.sep),g||(g=T.sep)),g}e.$Je=k;function L(g){const A=(0,T.$6c)(g);return S.$i?g.length>3?!1:R(A)&&(g.length===2||A.charCodeAt(2)===92):A===T.$5c.sep}e.$Ke=L;function R(g,A=S.$i){return A?$(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$Le=R;function E(g,A=S.$i){return R(g,A)?g[0]:void 0}e.$Me=E;function d(g,A,U){return A.length>g.length?-1:g===A?0:(U&&(g=g.toLowerCase(),A=A.toLowerCase()),g.indexOf(A))}e.$Ne=d;function m(g){const A=g.split(":");let U,z,I;for(const b of A){const j=Number(b);(0,O.$me)(j)?z===void 0?z=j:I===void 0&&(I=j):U=U?[U,b].join(":"):b}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:z!==void 0?z:void 0,column:I!==void 0?I:z!==void 0?1:void 0}}e.$Oe=m;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",P="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function F(g,A,U=8){let z="";for(let b=0;b<U;b++){let j;b===0&&S.$i&&!A&&(U===3||U===4)?j=P:j=w,z+=j.charAt(Math.floor(Math.random()*j.length))}let I;return A?I=`${A}-${z}`:I=z,g?(0,T.$8c)(g,I):I}e.$Pe=F}),define(q[17],W([0,1,6,3,8]),function(D,e,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var O;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$Te="vscode-tkn",e.$Ue="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${O.vscodeRemoteResource}`}set(c,o,f){this.a[c]=o,this.b[c]=f}setConnectionToken(c,o){this.c[c]=o}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(s){return T.$Y(s),c}const o=c.authority;let f=this.a[o];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const l=this.b[o],n=this.c[o];let i=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(i+=`&${e.$Ue}=${encodeURIComponent(n)}`),v.URI.from({scheme:S.$o?this.d:O.vscodeRemoteResource,authority:`${f}:${l}`,path:this.f,query:i})}}e.$Ve=new r,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class u{static{this.a="vscode-app"}asBrowserUri(c){const o=this.b(c,D);return this.uriToBrowserUri(o)}uriToBrowserUri(c){return c.scheme===O.vscodeRemote?e.$Ve.rewrite(c):c.scheme===O.file&&(S.$m||S.$p&&S.$g.origin===`${O.vscodeFileResource}://${u.a}`)?c.with({scheme:O.vscodeFileResource,authority:c.authority||u.a,query:null,fragment:null}):c}asFileUri(c){const o=this.b(c,D);return this.uriToFileUri(o)}uriToFileUri(c){return c.scheme===O.vscodeFileResource?c.with({scheme:O.file,authority:c.authority!==u.a?c.authority:null,query:null,fragment:null}):c}b(c,o){return v.URI.isUri(c)?c:v.URI.parse(o.toUrl(c))}}e.$1e=new u;var t;(function(a){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(c.get("3"));const o="vscode-coi";function f(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(o);if(s)return c.get(s)}a.getHeadersFromQuery=f;function l(n,i,s){if(!globalThis.crossOriginIsolated)return;const $=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(o,$):n[o]=$}a.addSearchParam=l})(t||(e.COI=t={}))}),define(q[32],W([0,1,21,17,3,8]),function(D,e,T,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class r{constructor(f,l,n){this.id=f,this.dependencies=l,this.callback=n}}class u{static{this.INSTANCE=new u}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,l,n)=>{typeof f!="string"&&(n=l,l=f,f=null),(typeof l!="object"||!Array.isArray(l))&&(n=l,l=null),this.c.push(new r(f,l,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const l=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!l)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(f){return new Promise((l,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",$),i.removeEventListener("error",k)},$=L=>{s(),l(this.c.pop())},k=L=>{s(),n(L)};i.addEventListener("load",$),i.addEventListener("error",k),this.f&&(f=this.f.createScriptURL(f)),i.setAttribute("src",f),document.getElementsByTagName("head")[0].appendChild(i)})}i(f){return new Promise((l,n)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),l(this.c.pop())}catch(i){n(i)}})}async j(f){try{const l=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=O.URI.parse(f).fsPath,$=l.readFileSync(s).toString(),k=i.wrap($.replace(/^#!.*/,""));return new n.Script(k).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function c(o,f,l){if(T.$R){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[o]&&(o=a[o]);const n=`${o}/${f}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const L=`${l&&!v.$o?S.$Ye:S.$Xe}/${n}`;i=S.$1e.asBrowserUri(L).toString(!0)}const s=u.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{D([o],n,i)})}e.$2C=c}),define(q[18],W([0,1,29,17,30,3,31,8]),function(D,e,T,S,v,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function t(l){return(0,u.$Se)(l,!0)}e.$Wf=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Ed)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===S.Schemas.file)return T.$He(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$bg)(n.authority,i.authority))return T.$He(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return u.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$6f)(n)||n.authority}basename(n){return v.$5c.basename(n.path)}extname(n){return v.$5c.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===S.Schemas.file?i=u.URI.file(v.$$c(t(n))).path:(i=v.$5c.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===S.Schemas.file?i=u.URI.file(v.$6c(t(n))).path:i=v.$5c.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$bg)(n.authority,i.authority))return;if(n.scheme===S.Schemas.file){const k=v.$0c(t(n),t(i));return O.$i?T.$Be(k):k}let s=n.path||"/";const $=i.path||"/";if(this.a(n)){let k=0;for(const L=Math.min(s.length,$.length);k<L&&!(s.charCodeAt(k)!==$.charCodeAt(k)&&s.charAt(k).toLowerCase()!==$.charAt(k).toLowerCase());k++);s=$.substr(0,k)+s.substr(k)}return v.$5c.relative(s,$)}resolvePath(n,i){if(n.scheme===S.Schemas.file){const s=u.URI.file(v.$9c(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=T.$Ce(i),n.with({path:v.$5c.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$Ld)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===S.Schemas.file){const s=t(n);return s.length>T.$De(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$cg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===S.Schemas.file){const $=t(n);s=$!==void 0&&$.length===T.$De($).length&&$[$.length-1]===i}else{i="/";const $=n.path;s=$.length===1&&$.charCodeAt($.length-1)===47}return!s&&!(0,e.$cg)(n,i)?n.with({path:n.path+"/"}):n}}e.$Xf=a,e.$Yf=new a(()=>!1),e.$Zf=new a(l=>l.scheme===S.Schemas.file?!O.$k:!0),e.$1f=new a(l=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function c(l,n){const i=[];for(let s=0;s<l.length;s++){const $=n(l[s]);l.some((k,L)=>L===s?!1:(0,e.$3f)($,n(k)))||i.push(l[s])}return i}e.$fg=c;var o;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(L=>{const[R,E]=L.split(":");R&&E&&s.set(R,E)});const k=i.path.substring(0,i.path.indexOf(";"));return k&&s.set(l.META_DATA_MIME,k),s}l.parseMetaData=n})(o||(e.DataUri=o={}));function f(l,n,i){if(n){let s=l.path;return s&&s[0]!==v.$5c.sep&&(s=v.$5c.sep+s),l.with({scheme:i,authority:n,path:s})}return l.with({scheme:i})}e.$gg=f}),define(q[19],W([0,1,46,6,33,2,18,3,24]),function(D,e,T,S,v,O,r,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function a(N){return!!N&&typeof N.then=="function"}e.$hg=a;function c(N){const h=new T.$oc,y=N(h.token),C=new Promise((M,B)=>{const _=h.token.onCancellationRequested(()=>{_.dispose(),h.dispose(),B(new S.$3)});Promise.resolve(y).then(Z=>{_.dispose(),h.dispose(),M(Z)},Z=>{_.dispose(),h.dispose(),B(Z)})});return new class{cancel(){h.cancel()}then(M,B){return C.then(M,B)}catch(M){return this.then(void 0,M)}finally(M){return C.finally(M)}}}e.$ig=c;function o(N,h,y){return new Promise((C,M)=>{const B=h.onCancellationRequested(()=>{B.dispose(),C(y)});N.then(C,M).finally(()=>B.dispose())})}e.$jg=o;function f(N,h){return new Promise((y,C)=>{const M=h.onCancellationRequested(()=>{M.dispose(),C(new S.$3)});N.then(y,C).finally(()=>M.dispose())})}e.$kg=f;async function l(N){let h=-1;const y=N.map((C,M)=>C.then(B=>(h=M,B)));try{return await Promise.race(y)}finally{N.forEach((C,M)=>{M!==h&&C.cancel()})}}e.$lg=l;function n(N,h,y){let C;const M=setTimeout(()=>{C?.(void 0),y?.()},h);return Promise.race([N.finally(()=>clearTimeout(M)),new Promise(B=>C=B)])}e.$mg=n;function i(N){return new Promise((h,y)=>{const C=N();a(C)?C.then(h,y):h(C)})}e.$ng=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=h,!this.b){const y=()=>{if(this.b=null,this.f)return;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(y,y).then(C)})}return new Promise((y,C)=>{this.b.then(y,C)})}return this.a=h(),new Promise((y,C)=>{this.a.then(M=>{this.a=null,y(M)},M=>{this.a=null,C(M)})})}dispose(){this.f=!0}}e.$og=s;class ${constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$pg=$;class k{constructor(){this.a=new Map}queue(h,y){const M=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(h)===M&&this.a.delete(h)});return this.a.set(h,M),M}}e.$qg=k;const L=(N,h)=>{let y=!0;const C=setTimeout(()=>{y=!1,h()},N);return{isTriggered:()=>y,dispose:()=>{clearTimeout(C),y=!1}}},R=N=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,N())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class E{constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,y=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((M,B)=>{this.d=M,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=y===t.$bc?R(C):L(y,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=E;class d{constructor(h){this.a=new E(h),this.b=new s}trigger(h,y){return this.a.trigger(()=>this.b.queue(h),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=d;class m{constructor(){this.a=!1,this.b=new Promise((h,y)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=m;class w extends m{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$ug=w;function P(N,h){return h?new Promise((y,C)=>{const M=setTimeout(()=>{B.dispose(),y()},N),B=h.onCancellationRequested(()=>{clearTimeout(M),B.dispose(),C(new S.$3)})}):c(y=>P(N,y))}e.$vg=P;function F(N,h=0){const y=setTimeout(N,h);return(0,O.$jb)(()=>clearTimeout(y))}e.$wg=F;function g(N){const h=[];let y=0;const C=N.length;function M(){return y<C?N[y++]():null}function B(_){_!=null&&h.push(_);const Z=M();return Z?Z.then(B):Promise.resolve(h)}return Promise.resolve(null).then(B)}e.$xg=g;function A(N,h=C=>!!C,y=null){let C=0;const M=N.length,B=()=>{if(C>=M)return Promise.resolve(y);const _=N[C++];return Promise.resolve(_()).then(Q=>h(Q)?Promise.resolve(Q):B())};return B()}e.$yg=A;function U(N,h=C=>!!C,y=null){if(N.length===0)return Promise.resolve(y);let C=N.length;const M=()=>{C=-1;for(const B of N)B.cancel?.()};return new Promise((B,_)=>{for(const Z of N)Z.then(Q=>{--C>=0&&h(Q)?(M(),B(Q)):C===0&&B(y)}).catch(Q=>{--C>=0&&(M(),_(Q))})})}e.$zg=U;class z{constructor(h){this.a=0,this.d=h,this.f=[],this.b=0,this.g=new v.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(h){return this.a++,new Promise((y,C)=>{this.f.push({factory:h,c:y,e:C}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const h=this.f.shift();this.b++;const y=h.factory();y.then(h.c,h.e),y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=z;class I extends z{constructor(){super(1)}}e.$Bg=I;class b{constructor(){this.a=new x,this.b=0}queue(h){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,h())):this.a.run(this.b++,h())}}e.$Cg=b;class j{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const h=new te;return this.b.add(h),h.p}d(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueFor(h,y=r.$Yf){const C=y.getComparisonKey(h);let M=this.a.get(C);return M||(M=new I,v.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(C),this.f()}),this.a.set(C,M)),M}f(){this.d()&&this.g()}g(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.g()}}e.$Dg=j;class V{constructor(h,y){this.a=-1,typeof h=="function"&&typeof y=="number"&&this.setIfNotSet(h,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},y)}setIfNotSet(h,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},y))}}e.$Eg=V;class Y{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setInterval(()=>{h()},y)}}e.$Fg=Y;class G{constructor(h,y){this.b=-1,this.a=h,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=G;class H{constructor(h,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=h,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=H;class K extends G{constructor(h,y){super(h,y),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$Ig=K;class p extends O.$lb{constructor(h,y){super(),this.g=h,this.h=y,this.a=[],this.b=this.B(new O.$mb),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of h)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=p,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=N=>{(0,u.$A)(()=>{if(h)return;const y=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,y-Date.now())}}))});let h=!1;return{dispose(){h||(h=!0)}}}:e.$Kg=(N,h)=>{const y=requestIdleCallback(N,typeof h=="number"?{timeout:h}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(y))}}}}();class X{constructor(h){this.d=!1,this.a=()=>{try{this.f=h()}catch(y){this.g=y}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=X;async function re(N,h,y){let C;for(let M=0;M<y;M++)try{return await N()}catch(B){C=B,await P(h)}throw C}e.$Mg=re;class x{isRunning(h){return typeof h=="number"?this.a?.taskId===h:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(h,y,C){return this.a={taskId:h,cancel:()=>C?.(),promise:y},y.then(()=>this.d(h),()=>this.d(h)),y}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this.b)this.b.run=h;else{let y,C;const M=new Promise((B,_)=>{y=B,C=_});this.b={run:h,promise:M,promiseResolve:y,promiseReject:C}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=x;class ae{constructor(h,y=()=>Date.now()){this.d=h,this.f=y,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$Og=ae;var ee;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,y)=>{this.a=h,this.b=y})}complete(h){return new Promise(y=>{this.a(h),this.d={outcome:0,value:h},y()})}error(h){return new Promise(y=>{this.b(h),this.d={outcome:1,value:h},y()})}cancel(){return this.error(new S.$3)}}e.$Pg=te;var ne;(function(N){async function h(C){let M;const B=await Promise.all(C.map(_=>_.then(Z=>Z,Z=>{M||(M=Z)})));if(typeof M<"u")throw M;return B}N.settled=h;function y(C){return new Promise(async(M,B)=>{try{await C(M,B)}catch(_){B(_)}})}N.withAsyncBody=y})(ne||(e.Promises=ne={}));var ie;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(ie||(ie={}));class J{static fromArray(h){return new J(y=>{y.emitMany(h)})}static fromPromise(h){return new J(async y=>{y.emitMany(await h)})}static fromPromises(h){return new J(async y=>{await Promise.all(h.map(async C=>y.emitOne(await C)))})}static merge(h){return new J(async y=>{await Promise.all(h.map(async C=>{for await(const M of C)y.emitOne(M)}))})}static{this.EMPTY=J.fromArray([])}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new v.$ec,queueMicrotask(async()=>{const y={emitOne:C=>this.g(C),emitMany:C=>this.h(C),reject:C=>this.k(C)};try{await Promise.resolve(h(y)),this.j()}catch(C){this.k(C)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(h,y){return new J(async C=>{for await(const M of h)C.emitOne(y(M))})}map(h){return J.map(this,h)}static filter(h,y){return new J(async C=>{for await(const M of h)y(M)&&C.emitOne(M)})}filter(h){return J.filter(this,h)}static coalesce(h){return J.filter(h,y=>!!y)}coalesce(){return J.coalesce(this)}static async toPromise(h){const y=[];for await(const C of h)y.push(C);return y}toPromise(){return J.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$Qg=J;class se extends J{constructor(h,y){super(y),this.l=h}cancel(){this.l.cancel()}}e.$Rg=se;function ce(N){const h=new T.$oc,y=N(h.token);return new se(h,async C=>{const M=h.token.onCancellationRequested(()=>{M.dispose(),h.dispose(),C.reject(new S.$3)});try{for await(const B of y){if(h.token.isCancellationRequested)return;C.emitOne(B)}M.dispose(),h.dispose()}catch(B){M.dispose(),h.dispose(),C.reject(B)}})}e.$Sg=ce}),define(q[20],W([0,1,34]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lC=e.$kC=e.$jC=void 0,e.$jC=new class{clone(){return this}equals(O){return this===O}};function S(O,r){return new T.$ts([new T.$ss(0,"",O)],r)}e.$kC=S;function v(O,r){const u=new Uint32Array(2);return u[0]=0,u[1]=(O<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new T.$us(u,r===null?e.$jC:r)}e.$lC=v}),define(q[35],W([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(D,e,T,S,v,O,r,u,t,a,c,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=void 0;var l;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(l||(l={}));class n{constructor(d,m){this.tokenizationSupport=m,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(d)}getStartState(d){return this.store.getStartState(d,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$oC=n;class i extends n{constructor(d,m,w,P){super(d,m),this._textModel=w,this._languageIdCodec=P}updateTokensUntilLine(d,m){const w=this._textModel.getLanguageId();for(;;){const P=this.getFirstInvalidLine();if(!P||P.lineNumber>m)break;const F=this._textModel.getLineContent(P.lineNumber),g=L(this._languageIdCodec,w,this.tokenizationSupport,F,!0,P.startState);d.add(P.lineNumber,g.tokens),this.store.setEndState(P.lineNumber,g.endState)}}getTokenTypeIfInsertingCharacter(d,m){const w=this.getStartState(d.lineNumber);if(!w)return 0;const P=this._textModel.getLanguageId(),F=this._textModel.getLineContent(d.lineNumber),g=F.substring(0,d.column-1)+m+F.substring(d.column-1),A=L(this._languageIdCodec,P,this.tokenizationSupport,g,!0,w),U=new f.$ms(A.tokens,g,this._languageIdCodec);if(U.getCount()===0)return 0;const z=U.findTokenIndexAtOffset(d.column-1);return U.getStandardTokenType(z)}tokenizeLineWithEdit(d,m,w){const P=d.lineNumber,F=d.column,g=this.getStartState(P);if(!g)return null;const A=this._textModel.getLineContent(P),U=A.substring(0,F-1)+w+A.substring(F-1+m),z=this._textModel.getLanguageIdAtPosition(P,0),I=L(this._languageIdCodec,z,this.tokenizationSupport,U,!0,g);return new f.$ms(I.tokens,U,this._languageIdCodec)}isCheapToTokenize(d){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return d<m||d===m&&this._textModel.getLineLength(d)<2048}tokenizeHeuristically(d,m,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(d,w),{heuristicTokens:!1};let P=this.b(m);const F=this._textModel.getLanguageId();for(let g=m;g<=w;g++){const A=this._textModel.getLineContent(g),U=L(this._languageIdCodec,F,this.tokenizationSupport,A,!0,P);d.add(g,U.tokens),P=U.endState}return{heuristicTokens:!0}}b(d){let m=this._textModel.getLineFirstNonWhitespaceColumn(d);const w=[];let P=null;for(let A=d-1;m>1&&A>=1;A--){const U=this._textModel.getLineFirstNonWhitespaceColumn(A);if(U!==0&&U<m&&(w.push(this._textModel.getLineContent(A)),m=U,P=this.getStartState(A),P))break}P||(P=this.tokenizationSupport.getInitialState()),w.reverse();const F=this._textModel.getLanguageId();let g=P;for(const A of w)g=L(this._languageIdCodec,F,this.tokenizationSupport,A,!1,g).endState;return g}}e.$pC=i;class s{constructor(d){this.d=d,this.a=new $,this.b=new k,this.b.addRange(new t.$Rr(1,d+1))}getEndState(d){return this.a.getEndState(d)}setEndState(d,m){if(!m)throw new S.$bb("Cannot set null/undefined state");this.b.delete(d);const w=this.a.setEndState(d,m);return w&&d<this.d&&this.b.addRange(new t.$Rr(d+1,d+2)),w}acceptChange(d,m){this.d+=m-d.length,this.a.acceptChange(d,m),this.b.addRangeAndResize(new t.$Rr(d.startLineNumber,d.endLineNumberExclusive),m)}acceptChanges(d){for(const m of d){const[w]=(0,r.$ls)(m.text);this.acceptChange(new u.$Vr(m.range.startLineNumber,m.range.endLineNumber+1),w+1)}}invalidateEndStateRange(d){this.b.addRange(new t.$Rr(d.startLineNumber,d.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(d,m){return d===1?m:this.getEndState(d-1)}getFirstInvalidLine(d){const m=this.getFirstInvalidEndStateLineNumber();if(m===null)return null;const w=this.getStartState(m,d);if(!w)throw new S.$bb("Start state must be defined");return{lineNumber:m,startState:w}}}e.$qC=s;class ${constructor(){this.a=new c.$mC(null)}getEndState(d){return this.a.get(d)}setEndState(d,m){const w=this.a.get(d);return w&&w.equals(m)?!1:(this.a.set(d,m),!0)}acceptChange(d,m){let w=d.length;m>0&&w>0&&(w--,m--),this.a.replace(d.startLineNumber,w,m)}acceptChanges(d){for(const m of d){const[w]=(0,r.$ls)(m.text);this.acceptChange(new u.$Vr(m.range.startLineNumber,m.range.endLineNumber+1),w+1)}}}e.$rC=$;class k{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const d=this.a[0];return d.start+1===d.endExclusive?this.a.shift():this.a[0]=new t.$Rr(d.start+1,d.endExclusive),d.start}delete(d){const m=this.a.findIndex(w=>w.contains(d));if(m!==-1){const w=this.a[m];w.start===d?w.endExclusive===d+1?this.a.splice(m,1):this.a[m]=new t.$Rr(d+1,w.endExclusive):w.endExclusive===d+1?this.a[m]=new t.$Rr(w.start,d):this.a.splice(m,1,new t.$Rr(w.start,d),new t.$Rr(d+1,w.endExclusive))}}addRange(d){t.$Rr.addRange(d,this.a)}addRangeAndResize(d,m){let w=0;for(;!(w>=this.a.length||d.start<=this.a[w].endExclusive);)w++;let P=w;for(;!(P>=this.a.length||d.endExclusive<this.a[P].start);)P++;const F=m-d.length;for(let g=P;g<this.a.length;g++)this.a[g]=this.a[g].delta(F);if(w===P){const g=new t.$Rr(d.start,d.start+m);g.isEmpty||this.a.splice(w,0,g)}else{const g=Math.min(d.start,this.a[w].start),A=Math.max(d.endExclusive,this.a[P-1].endExclusive),U=new t.$Rr(g,A+F);U.isEmpty?this.a.splice(w,P-w):this.a.splice(w,P-w,U)}}toString(){return this.a.map(d=>d.toString()).join(" + ")}}e.$sC=k;function L(E,d,m,w,P,F){let g=null;if(m)try{g=m.tokenizeEncoded(w,P,F.clone())}catch(A){(0,S.$Y)(A)}return g||(g=(0,a.$lC)(E.encodeLanguageId(d),F)),f.$ms.convertToEndOffset(g.tokens,w.length),g}class R{constructor(d,m){this.b=d,this.d=m,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,T.$Kg)(d=>{this.f=!1,this.h(d)}))}h(d){const m=Date.now()+d.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<m?(0,v.$A)(w):this.g())};w()}j(){const d=this.b._textModel.getLineCount(),m=new o.$nC,w=O.$ac.create(!1);do if(w.elapsed()>1||this.l(m)>=d)break;while(this.k());this.d.setTokens(m.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(d){const m=this.b?.getFirstInvalidLine();return m?(this.b.updateTokensUntilLine(d,m.lineNumber),m.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(d,m){this.b.store.invalidateEndStateRange(new u.$Vr(d,m))}}e.$tC=R}),define(q[37],W([0,1,33,2,36,14,34]),function(D,e,T,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OAb=void 0;class u extends S.$lb{constructor(a,c,o,f,l,n,i){super(),this.c=a,this.f=c,this.g=o,this.h=f,this.j=l,this.k=n,this.l=i,this.a=[],this.b=this.B(new T.$ec),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,c,o){throw new Error("Not supported!")}createBackgroundTokenizer(a,c){if(this.h)return this.h(a,c)}tokenizeEncoded(a,c,o){const f=Math.random()*1e4<1,l=this.l||f,n=l?new v.$ac(!0):void 0,i=this.c.tokenizeLine2(a,o,500);if(l){const $=n.elapsed();(f||$>32)&&this.k($,a.length,f)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$us(i.tokens,o);if(this.g){const $=this.a,k=i.tokens;for(let L=0,R=k.length>>>1;L<R;L++){const E=k[(L<<1)+1],d=O.$js.getLanguageId(E);$[d]||($[d]=!0,this.b.fire(d))}}let s;return o.equals(i.ruleStack)?s=o:s=i.ruleStack,new r.$us(i.tokens,s)}}e.$OAb=u}),define(q[38],W([0,1,20,2,11]),function(D,e,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PAb=void 0;class O extends S.$lb{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(u,t,a){super(),this.a=u,this.b=t,this.c=a,this.B((0,v.keepAlive)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(u,t,a){throw new Error("Not supported!")}tokenizeEncoded(u,t,a){return u.length>=this.c.get()?(0,T.$lC)(this.a,a):this.b.tokenizeEncoded(u,t,a)}createBackgroundTokenizer(u,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(u,t)}}e.$PAb=O}),define(q[39],W([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(D,e,T,S,v,O,r,u,t,a,c,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UAb=void 0;class l extends u.$Cu{constructor(s,$,k,L,R,E,d,m){super(s,$,k,L),this.s=R,this.t=E,this.u=d,this.a=null,this.b=!1,this.c=(0,v.observableValue)("_maxTokenizationLineLength",-1),this.q=new S.$Gg(()=>this.w(),10),this.c.set(m,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,$){this.t=s,this.u=$,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,$){this.a&&(this.a.store.invalidateEndStateRange(new r.$Vr(s,$)),this.q.schedule())}async v(){this.a=null;const s=this.t,$=this.u,k=await this.s.getOrCreateGrammar(s,$);if(!(this.b||s!==this.t||$!==this.u||!k)){if(k.grammar){const L=new f.$PAb(this.u,new o.$OAb(k.grammar,k.initialState,!1,void 0,()=>!1,(R,E,d)=>{this.s.reportTokenizationTime(R,s,k.sourceExtensionId,E,d)},!1),this.c);this.a=new t.$oC(this.f.length,L)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:$}=await(0,T.$2C)("vscode-textmate","release/main.js");this.m=$}const s=new Date().getTime();for(;;){let $=0;const k=new a.$nC,L=new n;for(;;){const d=this.a.getFirstInvalidLine();if(d===null||$>200)break;$++;const m=this.f[d.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(m,!0,d.startState);if(this.a.store.setEndState(d.lineNumber,w.endState)){const F=this.m(d.startState,w.endState);L.setState(d.lineNumber,F)}else L.setState(d.lineNumber,null);if(c.$ms.convertToEndOffset(w.tokens,m.length),k.add(d.lineNumber,w.tokens),new Date().getTime()-s>20)break}if($===0)break;const R=L.getStateDeltas();if(this.s.setTokensAndStates(this.h,k.serialize(),R),new Date().getTime()-s>20){(0,O.$A)(()=>this.w());return}}}}e.$UAb=l;class n{constructor(){this.a=-1,this.b=[]}setState(s,$){s===this.a+1?this.b[this.b.length-1].stateDeltas.push($):this.b.push({startLineNumber:s,stateDeltas:[$]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[40],W([0,1,18]),function(D,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RAb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const r=this.a[O.scopeName];T.$2f(r.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$RAb=S}),define(q[41],W([0,1,2,40]),function(D,e,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TAb=e.$SAb=void 0,e.$SAb="No TM Grammar registered for this language.";class v extends T.$lb{constructor(r,u,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new S.$RAb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async c=>{const o=this.c.getGrammarDefinition(c);if(!o)return this.a.logTrace(`No grammar found for scope ${c}`),null;const f=o.location;try{const l=await this.a.readFile(f);return t.parseRawGrammar(l,f.path)}catch(l){return this.a.logError(`Unable to load and parse grammar for scope ${c} from ${f}`,l),null}},getInjections:c=>{const o=c.split(".");let f=[];for(let l=1;l<=o.length;l++){const n=o.slice(0,l).join(".");f=[...f,...this.f[n]||[]]}return f}}));for(const c of u){if(this.c.register(c),c.injectTo){for(const o of c.injectTo){let f=this.f[o];f||(this.f[o]=f=[]),f.push(c.scopeName)}if(c.embeddedLanguages)for(const o of c.injectTo){let f=this.g[o];f||(this.g[o]=f=[]),f.push(c.embeddedLanguages)}}c.language&&this.h.set(c.language,c.scopeName)}}has(r){return this.h.has(r)}setTheme(r,u){this.j.setTheme(r,u)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,u){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$SAb);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$SAb);const c=a.embeddedLanguages;if(this.g[t]){const l=this.g[t];for(const n of l)for(const i of Object.keys(n))c[i]=n[i]}const o=Object.keys(c).length>0;let f;try{f=await this.j.loadGrammarWithConfiguration(t,u,{embeddedLanguages:c,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(l){throw l.message&&l.message.startsWith("No grammar provided for")?new Error(e.$SAb):l}return{languageId:r,grammar:f,initialState:this.b,containsEmbeddedLanguages:o,sourceExtensionId:a.sourceExtensionId}}}e.$TAb=v}),define(q[49],W([0,1,8,41,39]),function(D,e,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(u,t){return new r(u,t)}e.create=O;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const c=a.grammarDefinitions.map(o=>({location:T.URI.revive(o.location),language:o.language,scopeName:o.scopeName,embeddedLanguages:o.embeddedLanguages,tokenTypes:o.tokenTypes,injectTo:o.injectTo,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors,sourceExtensionId:o.sourceExtensionId}));this.d=this.g(c)}async g(t){const a=this.f.textmateMainUri,c=await new Promise((i,s)=>{D([a],i,s)}),o=await new Promise((i,s)=>{D([this.f.onigurumaMainUri],i,s)}),l=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await o.loadWASM(l);const n=Promise.resolve({createOnigScanner:i=>o.createOnigScanner(i),createOnigString:i=>o.createOnigString(i)});return new S.$TAb({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,c,n)}acceptNewModel(t){const a=T.URI.revive(t.uri),c=this;this.b.set(t.controllerId,new v.$UAb(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(o,f){const l=await c.d;return l?(c.c[f]||(c.c[f]=l.createGrammar(o,f)),c.c[f]):Promise.resolve(null)},setTokensAndStates(o,f,l){c.a.setTokensAndStates(t.controllerId,o,f,l)},reportTokenizationTime(o,f,l,n,i){c.a.reportTokenizationTime(o,f,l,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,c){this.b.get(t).retokenize(a,c)}acceptModelLanguageChanged(t,a,c){this.b.get(t).onLanguageId(a,c)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/35be9bf683eace09796e59d54f1f225bbc3a7866/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
